Welcome to dbForge Studio for Oracle

oracle-doc-header

Thank you for choosing dbForge Studio for Oracle!

ExpandedToggleIcon(9x12) dbForge Studio for Oracle Overview

dbForge Studio is a powerful and comprehensive Oracle GUI tool that provides a complete set of instruments for server management and administration. It offers tools for database development, administration tools, and SQL query tools. Combination of the very best features of existing Oracle front ends and Oracle GUI tools makes dbForge Studio the perfect choice for a database developer and administrator as well as for a novice user.

ExpandedToggleIcon(9x12) Where to Start

To start using dbForge Studio for Oracle, see Getting Started section. The guide helps you get started quickly by describing how to setup a new database connection, and provides an explanation of the key steps for basic database operations.

ExpandedToggleIcon(9x12) See Also

Getting Started

© 2004-2016 Devart


What's New in dbForge Studio for Oracle, v.3.9
· Totally redesigned Database Search (objects and data)
· Redesigned Visual Object Editors
· Data Editor and Viewer Window:
o XML View improved
o JSON View added
· Styled icons are used by default

ExpandedToggleIcon(9x12) See Also

Welcome to dbForge Studio for Oracle

Editions


Editions

dbForge Studio for Oracle has three editions: Express, Standard, and Professional.

Express is a free software that provides basic functionality for working with schema objects, user accounts, SQL scripts, and queries.

Standard includes all must-have tools for database developers, such as PL/SQL debugger, query builder, code snippets, PL/SQL code formatter, object search, export wizard.

Professional is a fully-featured software that facilitates your database management with the following functionality: database projects, database diagram, accurate comparison and synchronization of database structures (schema comparison) or database content (data comparison), complex queries creating, master-detail data browser, data analysis and report, etc.

The matrix below compares features of dbForge Studio for Oracle editions.

Features | Professional | Standard | Express
SQL Development
PL/SQL editor with syntax highlight, bookmarks, and text search | yes | yes | yes
PL/SQL debugger | yes | yes | none
PL/SQL formatter | yes | yes | none
Formatting code through the command line | yes | none | none
Context-sensitive code completion | yes | yes | partial-support
Phrase completion | yes | none | none
Quick information about schema objects | yes | yes | partial-support
Parameter information for stored routines | yes | yes | partial-support
Visual Query Builder | yes | yes | partial-support1
Alias refactoring | yes | yes | none
Object refactoring | yes | yes | none
Navigation to a schema object editor from code | yes | yes | none
Code snippets | yes | yes | none
Customizable DDL generation wizard | yes | yes | none
Query Profiler | yes | yes | none
Highlight Occurrences | yes | yes | none
Database Design
Visual editors for schema objects | yes | yes | yes
Database projects | yes | none | none
Schema comparison and synchronization tool | yes | none | none
Command-line interface for schema comparison and synchronization | yes | none | none
Database Diagrams | yes | yes | partial-support2
Find object in a database | yes | yes | none
Object Viewer window | yes | yes | yes
Dependencies lister | yes | yes | none
Find and Recompile Invalid Objects | yes | yes | none
Database Administration
Security Manager | yes | yes | yes
Session Manager | yes | yes | yes
Event Monitor | yes | yes | yes
Data Pump
Data comparison and synchronization tool | yes | none | none
Command-line interface for data comparison and synchronization | yes | none | none
Data import and data export | yes | yes | partial-support3
Command-line interface for data import and data export | yes | none | none
Schema export and import (dump) | yes | yes | partial-support4
Command-line interface for schema export and import | yes | none | none
Schema snapshot generation | yes | yes | yes
Schema snapshot generation through the command line | yes | none | none
Integration with version control systems** | yes | none | none
Data Analysis
Pivot tables | yes | none | none
Data reports | yes | none | none
Creating data reports through the command line | yes | none | none
Automated data report delivery | yes | none | none
Master-Detail Browser | yes | none | none
Find data record in a database | yes | yes | none
Data editor with in-place filtering, grouping, and sorting | yes | yes | yes
General
Oracle 12c, 11g, 10g, 9i, 8i* Oracle Express Edition (Oracle XE) 11 R2, 10 databases support | yes | yes | yes
OS authentication | yes | none | none
Restore last opened tabbed document | yes | yes | yes
Connection coloring and Documents categories | yes | yes | none
Amazon RDS support | yes | none | none
Direct Oracle database connection (without client) | yes | yes | none
Multiple database connections in Database Explorer window | yes | yes | yes
Full shortcut customization | yes | yes | yes

1 The number of tables is limited to 3, sub-queries are not supported.

2 The number of schema objects on a diagram in the Express edition is limited to 10, in the Standard edition is limited to 20.

3 CSV format has no restrictions for data export and import, for other formats only first 50 rows are processed. User templates are not supported.

4 It does not support schema export projects, auto-deletion of old schema export files, compression, and schema export files larger than 1MB.

* These Oracle versions are not supported in data and schema compare tools.

** TFS and SVN only.

ExpandedToggleIcon(9x12) See Also

Welcome to dbForge Studio for Oracle

Requirements


Requirements

dbForge Studio for Oracle requires the following:

· .NET Framework 4.0* or higher installed
You can download .NET Framework here.

note Note

Note, .NET Framework is pre-installed in Microsoft Windows 7, 8, 8.1 and Windows 10.
· 2 GHz or higher processor
· 1024 MB RAM
· 150 MB of free hard disk space
· Microsoft Windows XP/7/8/8.1/10, and Windows Server 2008/2012

ExpandedToggleIcon(9x12) See Also

Welcome to dbForge Studio for Oracle

Copyright Information


Copyright Information

Information in this document, including URL and other Internet Web site references, is subject to change without notice. Unless otherwise noted, the example companies, organizations, products, domain names, e-mail addresses, logos, people, places and events depicted herein are fictitious, and no association with any real company, organization, product, domain name, e-mail address, logo, person, place or event is intended or should be inferred. Complying with all applicable copyright laws is the responsibility of the user.

Devart may have patents, patent applications, trademarks, copyrights, or other intellectual property rights covering subject matter in this document. Except as expressly provided in any written license agreement from Devart, the furnishing of this document does not give you any license to these patents, trademarks, copyrights, or other intellectual property.

Copyright 2004-2016 Devart. All rights reserved.

Microsoft, Visual Studio, and Windows are either registered trademarks or trademarks of Microsoft Corporation in the United States and/or other countries.

The names of actual companies and products mentioned herein may be the trademarks of their respective owners.

ExpandedToggleIcon(9x12) See Also

Welcome to dbForge Studio for Oracle

Previous Releases


Previous Releases

ExpandedToggleIcon(9x12) In This Section

What's New in dbForge Studio for Oracle, v3.8

What's New in dbForge Studio for Oracle, v3.7

What's New in dbForge Studio for Oracle, v3.6

What's New in dbForge Studio for Oracle, v 3.5

What's New in dbForge Studio for Oracle, v 3.1

What's New in dbForge Studio for Oracle, v 3.0

What's New in dbForge Studio for Oracle, v 2.55

What's New in dbForge Studio for Oracle, v 2.50

What's New in dbForge Studio for Oracle, v 2.0

What's New in dbForge Studio for Oracle, v 1.51

What's New in dbForge Studio for Oracle, v 1.50

ExpandedToggleIcon(9x12) See Also

Welcome to dbForge Studio for Oracle

Getting Started


What's New in dbForge Studio for Oracle, v3.8
· Find and Recompile Invalid Objects functionality
· Object refactoring
· Redesigned UI for schema compare and data compare functionality
· Support for TFS 2015 in schema comparison
· Support for server connection via IPv6
· Shortcut table added
· User reported bugs fixed

ExpandedToggleIcon(9x12) See Also

Previous Releases

What's New in dbForge Studio for Oracle, v3.7


What's New in dbForge Studio for Oracle, v3.7

SQL Editing and Execution

· Suggestion and formatting of MERGE statements
· Command-line interface for SQL formatting
· Query execution pane
· Option to change a snippets folder location
· Phrase completion
· Option to set files encoding within the /execute and /schemaimport command-line operation
· Updated Find&Replace feature in documents and files

Data Comparison and Sync

· Ignore difference in end of line option
· Show white spaces option

Data Export and Import

· Export to the Excel 2007 (XLSX) format
· Retaining records filtering when the Export Selected Rows Only option is selected
· Export of BLOB fields as TEXT to Excel, TXT, HTML, PDF, RTF, and CSV formats
· Export to Excel, RTF, PDF with/without a header
· Force quotes option when exporting data to a CSV file
· Option to select encoding when exporting to DBF
· Import of dynamic values from Excel and Excel 2007
· Detecting column types when importing data from the CSV format

Data Report

· Support of report parameters in the command-line interface

Database Explorer

· Sending objects to a database diagram
· Generate Script As shortcut menu item for check constraints
· Renaming columns, indexes, default and check constraints
· Updated unique key and primary key editors

Data Editor

· Easy way to hide data results
· Data Viewer and LOB Editor are combined into a single control
· Redirect Data to Output is transformed into additional data editor

Other Features and Improvements

· Support of multiple monitors
· Create Schema Snapshot and Data Report wizard windows are modeless

ExpandedToggleIcon(9x12) See Also

Previous Releases

What's New in dbForge Studio for Oracle, v3.6


What's New in dbForge Studio for Oracle, v3.6

Database Connectivity

Connection via Windows authentication is added

Database Explorer

· Ability to compile objects from object category node is added
· Ability to enable/disable triggers is added
· Ability to enable/disable indexes is added
· Icons for user types and triggers are updated

Schema Compare and Synchronization

· Ignore Schema Name During Comparison option is added
· Ignore Compression Differences option is added
· Ignore LOGGING/NOLOGGING option is added
· Ignore Column Order in Indexes option is added
· Exclude Comments option is added
· Use SQL *Plus Commands option is added

Data Compare and Synchronization

· Include Print Comments option is added
· Use SQL *Plus Commands option is added

Data Editor and Viewer

Ability to view results as a structured XML file is added

Object Editors

Viewing script while editing columns, indexes etc. is possible now

Code Debugger

Current variable value output in tooltip while debugging procedures and functions is added

Alias Refactoring

Built-in Rename dialog box to rename aliases in your code

User Interface

· Switching tabs by the CTRL+ALT+PAGE UP and CTRL+ALT+PAGE DOWN key combinations
· Windows connection coloring is added
· Restoring document tabs from the last session is possible now
· Switching between wizard window and primary window is possible now

ExpandedToggleIcon(9x12) See Also

Previous Releases

What's New in dbForge Studio for Oracle, v 3.5


What's New in dbForge Studio for Oracle, v 3.5

Oracle 12c is supported

· Full connectivity and syntax support
· Full support for data comparison
· Full support for schema sync

Improved database object editors

· Editable column grid in the table editor now allows adding and editing columns without opening the pop-up dialog
· Full-text search in the column grid in the table editor is added
· Schema changes can now be viewed before updating database
· Editor layout was revised, and now it allows viewing designer and table SQL simultaneously
· F7 shortcut can now be used to toggle all editor views
· Heuristics is supported: data type of the new column is suggested basing on the column name. For example, for CUSTOMER_ID column NUMBER data type will be suggested, and for CHANGE_DATE column DATE data type will be suggested.

Optimized application work with Oracle server

· Database Explorer works faster now
· Database object editors work faster now
· Metadata for code completion is described faster now

New code formatter

· Format profiles are supported
· Extended options for formatting different clauses are added
· Preview window for viewing formatted code with support of code highlighting and editing is added

Extended code completion capabilities

· Suggestion of JOIN statements is added
· Extended Oracle grammar support is added
· Context-specific suggestions are improved
· Full support of suggestions and PL/SQL grammar with context consideration is added

Minor features

· New window docking system is introduced. Switching between tool windows on CTRL+TAB is supported
· Working with Oracle on Amazon RDS is possible now
· New skins are added (Metropolis and VS2010)
· Snapshot creation functionality is added to all product editions
· Connection export to Import and Export settings wizard is added

ExpandedToggleIcon(9x12) See Also

Welcome to dbForge Studio for Oracle

Editions


What's New in dbForge Studio for Oracle, v 3.1

150 improvements in the code autocompletion system

Nearly 150 changes and improvements are made in the dbForge Studio for Oracle component that helps users edit PL/SQL code. Among them:

· Oracle SQL and PL/SQL syntax support is expanded
· Work of quick info hints for schema objects is improved
· Keywords case is changed automatically on typing (if the corresponding options are set)
· Usability shortcomings and errors are fixed

SQL document works with additional PL/SQL file types:

· Support for editing .pls, .plb, .pks, .pkb, .pck Oracle PL/SQL files is added
· Support for editing files with PL/SQL code created in some competitors' products is added

Data export to SQL statements

· Possibility to export data to INSERT, UPDATE, DELETE, and MERGE statements is added
· Data can be exported from a table or data grid using a wizard
· Quick export from data grid without opening wizard

Convenient work with result sets of several SELECT queries

If there is more than one SELECT statement in a document, after execution query results will be displayed on separate tabs in the Data window.

Such approach allows working with each data set independently.

Editing data of object fields

The new product version provides possibility to edit data in object fields in tables using a pop-up editor.

Support for editing temporary tables

There is a capability to create and edit temporary tables in Table Editor.

Document Outline window for code navigation is improved

· Grouping nodes by IF, FOR, etc. flow-control statements blocks is added
· Displaying labels and navigation among them is added

More convenient working with query execution plan

· Quick query plan obtaining (without turning the Profiling mode on) is added
· Displaying of the EXPLAIN PLAN results without creating an additional table in the user's scheme is added

Performance improvements

· Time required on application startup and connection opening is reduced
· Building of the Database Explorer tree, refreshing it, and receiving table list is quicker now
· Getting metadata for code completion becomes faster
· Work of Schema Export with large amount of objects and data is improved
· Data Editor working speed is increased
· Object Viewer and Property Browser windows working speed is increased
· Navigation to schema object editors from code is improved

Win-x64 Native Support

Now the application does not require 32-bit Oracle client software installed when working with 64-bit Windows operating system - the application works with 64-bit Oracle client software.

ExpandedToggleIcon(9x12) See Also

Previous Releases

What's New in dbForge Studio for Oracle, v 3.0


What's New in dbForge Studio for Oracle, v 3.0

Schema Comparison Tool

Being first released as a separate tool, dbForge Schema Compare for Oracle was integrated into dbForge Studio to provide even greater schema change management capabilities. It is a comprehensive tool for database schema comparison and synchronization that can be used both by application developers and database administrators (DBAs). This tool can become a great assistant when you need to identify the impact of changes made to your database schema, as it easily points out all differences and allows generating customized Oracle schema synchronization script.

Data Comparison Tool

Being first released as a separate tool, dbForge Data Compare for Oracle was integrated into dbForge Studio to provide smooth integration with the rest of functionality. It is a powerful, fast, and easy-to-use tool for Oracle table data comparison and synchronization. It helps you quickly compare data in tables, find the differences at a glance, and generate a script to effortlessly synchronize data.

New Query Builder

Query Builder was completely re-designed to meet user needs. Now it allows you to build any complex queries visually. You can create sub-queries, add tables, create joins, or edit conditions with several clicks of the mouse. Following are the new features:

· The state-of-art diagram with zooming and keyboard support
· Preview and printing of the diagram
· Visual addition of sub-queries to any part of the main query
· Query outline (Document Outline window)
· Visual editing of sub-queries
· Expression builder for creating complex conditions
· Copy/Paste for tables on the diagram
· Undo/Redo support

Greatly Enhanced Data Editor

Over 50 new features and usability improvements were made to Data Editor to provide maximum freedom when working with data. Here are some of them:

· Quick filtering feature is added
· Foreign Key lookup editor is added
· Server-side sorting and filtering is implemented to avoid retrieving all data from the table and enhance work in Paginal Mode
· Few indications are added to inform user about Data Editor's state
· Editing of tables in join statements is enabled now
· Option for numbering records is added
· Copying data to clipboard with header is added
· Integration with charts, data reports, and pivot table component

Data Export to SQL

You can now export data to SQL format.

Powerful Data Export and Import

With Data Export and Import tools, you can export data from tables or views of your Oracle database, and after that you will be able to insert the exported data into the table you need. Data Export and Data Import provide the following features:

· Easy-to use Data Export Wizard for exporting data to HTML, MS Excel, RTF, XML, ODBC, Text, MS Access, PDF, CSV, and DBF formats.
· Highly customizable Data Import Wizard for importing data from CVS, DBF, HTML, MS Access, MS Excel, ODBC, PDF, RTF, Text, and XML formats.
· Ability to export data from several tables at once
· Possibility to export and import data from command line

Master-Detail browser

Explore and analyze master-detail data in a convenient browser with the following features:

· Design view allows building relations between tables with setting where condition and fetch limit, choosing fields for output, and sorting them by default
· Data of the parent table/view is shown in the upper part of the Data view to allow analyzing data of child tables/views without extra navigation.
· The document allows saving and loading data and diagram for future use
· Sorting and filtering data in the Data view
· Ability to analyze self-referencing tables

Data Reports

Every user can benefit from a modern way of generating reports. Less time and manual work is required to get required data from a database, analyze, and print it as a smart, clear, and stylish report tuned for each particular case.

Pivot Table

Users can convert large amounts of data into compact and informative summaries - pivot tables. They can rearrange any obscure data by a simple drag of the mouse to get the layout that is best for understanding data relations and dependencies.

Redesigned Schema Export Wizard

Schema Export wizard has been totally redesigned to provide more freedom for exporting schemas. It features the following:

· Capability to save export options for future use
· Support of command line interface
· Automatic archiving of schema backup scripts
· Writing a report about export process into a log file
· Automatic removing of old backup files based on date or quantity

Object Viewer - a simple way to view object's details

Object Viewer provides an easy way for analyzing objects and their structure right from Database Explorer. It offers:

· Three views to display properties, DDL (text), and data of the selected object
· Inner navigation through object hierarchy
· History with previously viewed objects
· Extended information about each object in the Properties view

Quick generation of template SQL scripts for database objects

Thanks to this new functionality, you can save your time while working with database objects. For example, you can quickly generate template CREATE, DROP, DROP and CREATE, SELECT, INSERT, UPDATE, or DELETE scripts for tables. This option is available in the shortcut menu and called 'Generate Script As'.

Reworked Query Profiler

Query Profiler tool was reworked for more convenient usage and extended with session statistics:

· Query plan is displayed in tree-list control in order to show execution step properties
· Session statistics changes are captured to reflect query impact
· Profiling history that can be saved for further analysis
· Compare statistics results with differences highlight
· Profiling results printing

Wizard for execution of large SQL scripts

The new version provides a special Execute Script Wizard to enable quick and convenient execution of large SQL scripts without waiting for their opening in the editor. It takes only to select a script and enjoy the executed result.

Code Snippets Manager

Code Templates feature is now renamed to Code Snippets and extended with the manager window for adding and editing SQL templates.

Import and Export Settings Wizard

Import and Export Settings Wizard allows you to export and import all your settings, layout, toolbars, keyboard shortcuts. Wizard also allows you to reset settings to their default values. You may export, import, and reset settings completely or partially.

Brand new start page

New functional start page providing the easiest way to learn the product's features and to run the most frequently used ones added.

New state-of-the-art skins

Four new UI skins are added to improve the application appearance.

SQL Intellisense functionality improved

SQL Intellisense functionality is improved to make coding easier. Extended code completion, quick object information, code snippets will simplify your work.

Improved Security Manager

· Ability to edit permissions for several users is added
· Editing users and working with Security Manager window is simplified

Database Projects Improved

· Building project to a single script
· Building project to a collection of scripts
· Multiple build configurations
· Easy object deleting from project

Search and Replace Extended

The following search and replace functionality is added:

· Search in data
· Search in Data Viewer and LOB Editor
· Search and replace in project files
· Search and replace in files on disc

Filter toolbar in the Error List window

Filter toolbar is added to Error List window to show the quantity of errors, warnings, and messages. Also it filters the list of records, so that you can access the records of the selected type in one click.

ExpandedToggleIcon(9x12) See Also

Previous Releases

What's New in dbForge Studio for Oracle, v 2.55


What's New in dbForge Studio for Oracle, v 2.55

Oracle 11g is supported.

ExpandedToggleIcon(9x12) See Also

Previous Releases

What's New in dbForge Studio for Oracle, v 2.50


What's New in dbForge Studio for Oracle, v 2.50

Advanced Context-sensitive Code Completion

· Extended support of SQL and PL/SQL syntax
· Code Completion now contains built-in Oracle functions

SQL*Plus Command Support

dbForge Studio supports:

· @ and @@ commands in debugging.
· Exporting a project to an SQL*Plus run script.

Following SQL*Plus commands are supported:

· @
· @@
· ACCEPT
· CLEAR
· CONNECT
· DEFINE
· DESCRIBE
· EXECUTE
· PROMPT
· REMARK
· VARIABLE

Hot Keys Customizing

Added fully customizable keyboard mapping schemes.

DDL Generation Improved

DDL generation is now highly customizable. You can tune DDL generation with plenty of options.

New Schema Objects Supported

The number of database objects which can be created with visual editors has increased. Here is the list of newly supported schema objects:

· Clusters
· Database links
· Cluster indexes
· Partitioned indexes

Database Object Dependency

Schema objects in the Database Explorer now have folders 'Depends on' and 'Used by'. You can access to object dependants and references through these folders. You can now also easily compile object dependants and references.

User Comments for Schema Objects

dbForge Studio now allows you to view and edit comments for tables, views, materialized views, table and view columns.

Enhanced Code Templates

Code Templates window now allows you to preview code templates. Code templates are now not organized in folders in the completion list and can be inserted with typing template shortcut and pressing the TAB key.

Schema Export to SQL script

Schema Export Wizard provides you flexible export of a database or of some database objects to a script. Schema export can be tuned with a lot of options. You can export objects' structure, tables' data or both of them. Schema Import Wizard can import database from a script in a few clicks.

New Database Project Wizard

New Database Project Wizard allows you to create new Oracle project easily and to import existing database objects to the new project.

Database Object Search Enhancements

Find Object window design enhanced. Added full-text search in the non-source objects and data search in tables and views.

Session Manager Improvements

Session manager was improved. Cursor list now contains first part of SQL for each cursor and allows you to view the entire SQL text. Session statistics can now be filtered.

Database Explorer Enhancements

Database Explorer now stores navigation history. Different icons are available for different types of tables and folders. Column type and size can be displayed in the Database Explorer.

Start Page

Now dbForge Studio loads Start Page on startup, that provides fast access to the recent projects, common tasks, dbForge Studio online resources and help topics.

Other New Features

· PL/SQL compilation warning support added.
· Oracle Instant Client support added.
· Date format can now be set for the Data Editor.
· Same file can be included several times in the deployment order.
· Table columns can now be created using copy/paste operations.

ExpandedToggleIcon(9x12) See Also

Previous Releases

What's New in dbForge Studio for Oracle, v 2.0


What's New in dbForge Studio for Oracle, v 2.0

Database Project Support

Added a project management framework for bookmarking related scripts and organizing database developments. Projects can be deployed in any order and saved to a file.

PL/SQL and Script Debuggers

Added PL/SQL and SQL script debuggers

Security Manager

Added a Security Manager for performing security administration tasks, including manipulating user accounts, granting and revoking roles and privileges, and managing profiles.

Improved SQL Editor

Greatly improved the SQL Editor. The following features were added:

· Enhanced Find and Replace window lets you search and replace text in all opened documents and view search results in a Find Results window.
· Advanced Code completion includes keywords and objects from the parsed script.
· Parameter information.
· Quick information about pointed object in the script.
· Navigation bar for navigating to script objects and subobjects.
· Bookmarks.
· In-place visual select statements editing with Query Builder window.
· Incremental search is now available.
· Code navigation for jumping to the definitions of database objects and PL/SQL variables.

Improved Working with Data

The following features added for working with data:

· You can now print data from data editor directly.
· Sequential fetch feature was added - not all the data can now be fetched at once, cursor can be left opened to fetch data later.
· Data output can now be redirected to the Output window and viewed as text.
· Card View mode gives a visual way to view data rows.

Extended Support of Oracle Schema Objects Editing

The number of database objects which can be created with visual editors has increased. Here is the list of newly supported object types:

· XML Schemas and tables
· Object Tables
· Partitioned, clustered and index-organized tables
· Materialized Views and Materialized View Logs

Session Manager

Added a Session Manager for controlling and analyzing user sessions.

Event Monitor

A new Event Monitor lets you send signals between database connections with Oracle alerts and pipe messages.

Extended Database Object Search

Added search in object data and PL/SQL source code. You can now also perform search on columns, constraints and indexes.

Document Outlining

Added a Document Outline window for viewing the structure of SQL documents. To simplify code navigation, DML commands, DDL statements, PL/SQL blocks and variables are represented as single structural units.

Code Templates

Added an extensive collection of SQL and PL/SQL code templates.

Other new features

· Now you can open several object editors for the same type of object in one document.
· The Output window now has several tabs for viewing different kinds of messages.

ExpandedToggleIcon(9x12) See Also

Previous Releases

What's New in dbForge Studio for Oracle, v 1.51


What's New in dbForge Studio for Oracle, v 1.51

Connection parameters added

DBMS output buffer size can be now configured.

ExpandedToggleIcon(9x12) See Also

Previous Releases

What's New in dbForge Studio for Oracle, v 1.50


What's New in dbForge Studio for Oracle, v 1.50

Database Export/Import

Database Export Wizard provides you flexible export of a database, schema or of some database objects to a dump file. Database export can be tuned with a lot of options. You can export objects' structure, tables' data or both of them. Database Import Wizard can import database from a dump file.

DDL Generation Wizard

This wizard generates DDL script for selected database objects. You can select objects from one or several schemas for DDL script generation.

Script Support

Now you can edit or execute not only single queries but scripts too.

Stop Execution Feature

All queries and scripts are now executed asynchronously. You can continue work on other documents while executing script. At any time you can interrupt its execution clicking Stop execution button.

Execution of Selected SQL Fragment

You can now select and execute any part of script or query.

Data Export

Data Export Wizard provides you capability to export data to external format. Export to HTML, XML, MS Excel and Text format is supported. You can set different export options to change result file appearance.

Dynamic Data Viewing

Use Dynamic Data Viewing to view data of a table or view just by selecting it in Database Explorer.

Paginal Data Access Mode

If there are very many data in a table you can use Paginal Mode to view data in parts. You can set page row count to view as many records on the page as you wish.

LOB Viewer/Editor

LOB Viewer and Editor allow viewing and editing BLOB data in corresponding table fields.

Database Object Search

dbForge Studio allows user to search for database objects by name and type. You can search for an object in specific databases or in the whole server.

Duplicate Object

This feature allows to duplicate any database object into the same or another database.

Data Grid Colors Customizing

You can set background and font colors of Data editor grid rows.

There are also many dbForge Studio improvements.

ExpandedToggleIcon(9x12) See Also

Previous Releases

Getting Started


Getting Started

ExpandedToggleIcon(9x12) In This Section

dbForge Studio for Oracle Start Page
This section describes the basic functionality provided by dbForge Studio for Oracle.

Installation Guide
Describes how to install and uninstall the application.

How To: Connect to a Database
Find out how to create a database using three types of database connections.

How To: Create and Edit a Query
This topic demonstrates how to create a query using the SQL editor and the power of Intellisense features.

How To: Create a Query in Query Builder
This topic shows how to create a query in visual mode.

How To: Edit Data
This topic shows how to edit table data.

How To: Create a Table in Table Editor
This topic explains how to create a new table with help of the Table Editor.

How To: Backup a Database
This topic explains how to backup a database using the Database Backup Wizard and the command line. Also it explains how to schedule backup.

ExpandedToggleIcon(9x12) See Also

Welcome to dbForge Studio for Oracle

Connecting to Databases


dbForge Studio for Oracle Start Page

The goal of the start page is to provide a location, available when the product first started, for the user to find out about dbForge Studio for Oracle functionality. We also added some other features to this start page such as the ability to navigate to the product support page, blog, feedback page, etc. The Start page uses a multi-tab model that provides the relevant features and tools in a specific tab.

To access the Start page, in the View menu click Other Windows, and then click Start Page.

Section | Tool | Description
Quick Links | Help | Opens the built-in help file, where you will find how to perform basic and advanced tasks in dbForge Studio for Oracle. It gives you necessary information to get started with the application and broaden your database administration skills when you are familiar with simple tasks.
 | Product Support Page | On the support page, you can find answers to any questions you may have about using dbForge Studio for Oracle and provide comments and suggestions about the product.
 | Blog | Opens the Devart blog that contains a variety of technical articles on every product and theme.
 | Forum | Participate in the discussion forum of dbForge Studio for Oracle product line. Get answers to your technical questions and find more valuable information about dbForge Studio for Oracle and other products' advantages.
 | Devart website | Opens the Devart company website.
 | Product Feedback Page | We are striving to build a set of tools that simplify Oracle interaction and enhance opportunities for developers, DBAs, and other people dealing with databases. We are interested in how well dbForge Studio for Oracle works for you and what features you want to see added.
 | Recent Files | The section displays recently opened files. Click a required file name link to open the file.
 | Database Connection | Use the suggestion list to quickly switch to the required server connection.
 | New Connection | Click the button to open the Database Connection Properties dialog box and set up another server connection.
SQLDevelopmentIcon | SQLEditorIcon SQL Editor | The SQL editor allows you to write and edit SQL code. It supports auto completion and auto look-up. For example, when typing an SQL SELECT query in the SQL editor, after typing a keyword such as WHERE, the editor will perform an auto column look-up to display the list of available columns pertaining to the current query. After typing a keyword such as FROM, the SQL editor will display a list of available tables to choose from.
 | QueryBuilderIcon Query Builder | The visual Query Builder allows you to construct complex database queries. You do not need to be a developer to build a query. A rich set of visual options allows you to combine SQL clauses like JOINs, GROUP BY with properties like Indexes, Operators, Aliases, Sort Type, Sort Order and Criteria. Based on your selections, the visual Query Builder will generate a complete SQL script that can be executed.
 | ExecuteScriptIcon Execute Script | The Execute Script wizard allows you to execute large scripts without opening them in the editor and loading them to the memory.
 | QueryProfilingIcon Query Profiler | You can use the Query Profiler tool to debug, troubleshoot, monitor, and measure your application's SQL statements and stored procedures. The tool enables you to select precisely which events you want to monitor. For example, you might want to see when stored procedures are called, when they complete, how long it takes to execute them, how many logical reads occur during execution, and so on.
 | DebuggingIcon Debug Stored Procedures | The SQL debugger allows you to interactively debug stored procedures by displaying the SQL call stack, local variables, and parameters for the SQL stored procedure. As with debugging in other programming languages, you can view and modify local variables and parameters, view global variables, as well as control and manage breakpoints while debugging your SQL script.
DatabaseDesignIcon | NewDatabaseDiagramIcon New Database Diagram | A visual tool that allows you to design and visualize a database, to which you are connected. When designing a database, you can use Database Designer to create, edit or delete tables, columns, keys, indexes, relationships, and constraints. To visualize a database, you can create one or more diagrams illustrating some or all of the tables, columns, keys, and relationships in it.
 | NewSchemaComparisonIcon New Schema Comparison | This tool will help you to find differences in objects from two Oracle schemas, view an update script generated by the application, and perform synchronization of changes so that both schemas are identical.
 | NewProjectWizardIcon New Project Wizard | This wizard will assist you while creating a database project. The database project is the offline representation of a database schema with extended opportunities for offline schema development. It is a collection of logically organized SQL scripts and query files, which are used both to create a new database and update the existing one.
 | CreateDatabaseObjectIcon Create Database Object | The visual editor helps you to create a database object. The editor lists available databases on a specific Oracle server instance. You may choose a specific database to place your object there.
 | FindDatabaseObjectIcon Find Database Object | The product provides the database object search functionality and the possibility of data search in tables and views. It is also possible to search for some text block in the database object DDL.
DatabaseAdministrationIcon | ManageServerSecurityIcon Manage Server Security | A professional tool for convenient and easy management of Oracle users and their privileges. It allows you to effortlessly create, edit, or delete user accounts, grant or revoke privileges either at global or object levels, and fully control database security without monotonous code typing into the command line. The graphical user interface provides a clear way to do all these tasks.
 | MonitorSessionsIcon Monitor Sessions | This tool provides a GUI view and Search access for: session details, kill session, session grouping.
 | EventMonitorIcon Event Monitor | Use Event Monitor to monitor Oracle databases, send and receive alerts and pipe messages.
 | Schema-export Schema Export | Using the Schema Export wizard, you can easily copy database objects, export a full schema structure or only selected schema objects. dbForge Studio for Oracle exports a database object into a simple SQL script that can be read and modified before importing.
 | Schema-import Schema Import | Using the Schema Import wizard, you can easily copy database objects, import a full schema structure or only selected schema objects.
 | Export-utility Export Utility | Use the Export Utility wizard to export data from an Oracle database, transfer data objects between Oracle databases, as well as extract object definitions and table data from an Oracle database and store them in an Oracle binary-format export dump file.
 | Import-utility Import Utility | Use the Import Utility wizard to import database objects, transfer data objects between Oracle databases, as well as to insert extracted objects from export dump files to Oracle database.
DataPumpIcon | ExportDataIcon Export Data | This tool allows you to export your Oracle data. Select the database objects to export and configure the related options.
 | ImportDataIcon Import Data | Fill Oracle databases with external data using the import tool. It supports more than 10 popular data formats and allows to customize the whole process. Templates and automating data import tasks through command line are also available.
 | NewDataComparisonIcon New Data Comparison | The tool gives a clear view of differences between data, allows analyzing them, generates synchronization script, and applies changes at a glance. It also allows scheduling regular Oracle data comparisons using the command line.
 | Schema-export Schema Export | With dbForge Studio for Oracle, you can perform database export easily using the Schema Export wizard. dbForge Studio for Oracle exports a schema into a simple SQL script. You can perform full schema export or export only selected schema objects.
 | Schema-import Schema Import | The Schema Import wizard allows you to import your schemas or single tables from a script.
DataAnalysisIcon | MasterDetailBrowserIcon Master-Detail Browser | Use the Master/Detail browser to view or edit data from multiple tables, snapshots, views or queries linked by foreign keys or a user-defined master-detail relationship. This is typical of a database setup from an Entity/Relationship diagram, where some table objects are related to another table objects by a linking field or fields.
 | DesignNewReportIcon Design New Report | Design in minutes any data reports with parameters, customizable formatting, calculated summaries, etc. with the help of the Oracle reporting tool provided by dbForge Studio. Streamline your work with multi-dimensional data, visualize data trends and dependencies, make quick but reasonable business decisions, convert your data in professionally-looking pivot tables.
 | ExportDataIcon Export Data | This tool allows you to export your Oracle data. Select the database objects to export, and configure the related options.
 | NewDataComparisonIcon New Data Comparison | The tool gives a clear view of differences between data, allows analyzing them, generates a synchronization script, and applies changes at a glance. It also allows scheduling regular Oracle data comparisons using a command line.
 | BuildPivotTableIcon Build Pivot Table | Group and summarize your data in pivot tables to make it easier to read and understand.
 | FindDatabaseObjectIcon Find Data | Locate specific data records in a database.
 | NewSchemaComparisonIcon New Schema Comparison | The tool will help you to perform database schemas comparison and synchronize schemas using easy step-by-step wizard instructions.
 | Create Schema Snapshot | Opens the Create Schema Snapshot dialog box to show you the steps you should follow to create a schema snapshot file that is generated by dbForge Studio and contains information on database structure in XML format.
 | NewDataComparisonIcon New Data Comparison | The tool provides a clear view of differences between data, allows analyzing them, generates a synchronization script, and applies changes at a glance. It also allows scheduling regular Oracle data comparisons using a command line.


Installation Guide

ExpandedToggleIcon(9x12) In This Section

How To: Install dbForge Studio for Oracle
Describes how to install the application.

How To: Uninstall dbForge Studio for Oracle
Describes how to uninstall the application.


How To: Install dbForge Studio for Oracle

This topic describes how to install dbForge Studio for Oracle on Windows OS with the help of Devart dbForge Studio for Oracle Setup Wizard.

note Note

To work with 32-bit versions of Oracle under the 64-bit versions of Windows you need to install the 32-bit version of dbForge Studio for Oracle.

To install dbForge Studio for Oracle

1. Run datageneratorsql.exe to begin installation.
2. On the Welcome to dbForge Studio for Oracle page, click Install.
3. On the Select Destination page, select the directory where dbForge Studio for Oracle will be installed. To change the default directory, click Browse. To restore the default directory, click Restore default location. Optionally, click the Licence Agreement link to learn the End-User Agreement for dbForge Studio for Oracle. If you agree to the Devart dbForge Studio for Oracle License Terms, click Next.
4. Optionally, on the Shortcuts page, select the additional shortcuts you would like the Setup Wizard to create while installing dbForge Studio for Oracle. There are two options available: Create a desktop icon and Add a shortcut to the start menu. Click Next.
5. On the File Associations page, select the document types and file extensions that will be associated with this application when it is installed on your computer. Click Next.
6. On the Startup Optimization page, specify whether you want to optimize the application startup time. There are three options available: Generate images for all assemblies during the installation (recommended), Generate images for all assemblies in the background, and Do not generate images. Click Next to start the installation.
7. Optionally, on the Installing page, you can interrupt the installation by clicking the Cancel button.
8. On the final page, click Finish to exit Setup wizard. Optionally, you can select the Launch "dbForge Studio for Oracle" option to start the application immediately after installation.

ExpandedToggleIcon(9x12) See Also

Installation Guide

How To: Uninstall dbForge Studio for Oracle


How To: Uninstall dbForge Studio for Oracle

This topic describes how to uninstall dbForge Studio for Oracle from Windows OS.

To uninstall dbForge Studio for Oracle

1. To begin the uninstall, go to Control Panel and then Programs and Features.
2. Right click dbForge Studio for Oracle and select Uninstall.
3. The Uninstall dialog box appears. Click Yes, if you are sure you want to uninstall the application. This starts the dbForge Studio for Oracle Uninstaller.
4. Optionally, on the Uninstall options page, you can specify the following options for uninstaller and then click Uninstall.
· Settings to remove
o Registry options
o Connection list
o Snippets
o Configuration files
o Format profiles
o Projects, scripts and exported data
5. Go to the product feedback page after uninstall - select this option to leave a feedback about application.
6. Click Uninstall to proceed with the uninstall.
7. If the uninstall is successful, the dialog box confirming that the application was successfully removed appears. Click OK to exit the uninstaller.

ExpandedToggleIcon(9x12) See Also

Installation Guide

How To: Connect to a Database


How To: Connect to a Database

Use the Database Connection Properties dialog box to create or customize a database connection.

ExpandedToggleIcon(9x12) Connection Types

Direct Connection

Direct mode does not require an Oracle Client to be installed on your workstation. dbForge Studio for Oracle talks to the Oracle server directly, no third party libraries are required.

You can connect to a multi-threaded server using Direct mode. The server must be configured to use a specific port and TTC protocol. This can help you avoid firewall conflicts.

Direct mode advantages:

· Installation and administration of an Oracle Client are not required
· System requirements are reduced

Direct mode restrictions:

· Database export and import operations with Export and Import Utility wizards are not supported
· Oracle RAC (Real Application Clusters) is not supported
· OS authentication feature is not available
· TCP/IP protocol connection only

note Note

You can return to a connection via an TNS at any time if restrictions above become critical for you.

Connection via the TNS

The TNS connection type is an appropriate option in any of the following circumstances:

· You have an Oracle client installed on your machine.
· You have access to many Oracle Database instances.
· You do not know the machine details of the system hosting the Oracle Database instance you want to connect to.

A TNS connection uses an alias entry from a tnsnames.ora file. dbForge Studio for Oracle uses only one tnsnames.ora file. You may have more than one on your local machine or want to use the tnsnames.ora file on a remote machine, so note that dbForge Studio for Oracle looks sequentially for the tnsnames.ora file in the following locations:

1. $HOME/.tnsnames.ora
2. $TNS_ADMIN/tnsnames.ora
3. /etc/tnsnames.ora (non-Windows systems)
4. $ORACLE_HOME/network/admin/tnsnames.ora
5. Registry key

You need to create the TNS_ADMIN environment variable in the case when the tnsnames.ora file exists but dbForge Studio for Oracle doesn't use it.

note Note

dbForge Studio for Oracle uses connection via an TNS by default.

Connection via TNS Using OS Authentication

With OS authentication, Oracle Database uses a database user's OS login credentials to authenticate that user. The user doesn't provide a username or password to access the database, and Oracle Database doesn't store and manage the account password. Local OS authentication can be used when the client and the database server are on the same machine. Remote OS authentication is possible but is not considered secure.

ExpandedToggleIcon(9x12) See Also

Getting Started

How To: Create and Edit a Query


Direct Connection

To create a connection:

1. When you start the dbForge Studio for Oracle, the Database Connection Properties dialog box appears. If not, click New Connection on the Database menu.
2. Select Direct in the Connection type box.
3. Enter the host name in the Host box.
4. Enter the port information in the Port box. Default port number is 1521.
5. In the Service Name box enter the database name to which you want to connect to.
6. Enter the login credentials in the User and Password boxes.
7. (optional) You can specify how to connect to the server in the Connect as box. 'Normal' is set by default. Alternatively, you can connect to SYSDBA and SYSOPER administrative privileges selecting 'SYSDBA' or 'SYSOPER' options.
8. Enter a distinctive name for your new connection in the Enter connection name box. Alternatively, the connection name is generated automatically as [user]@[host]:[service name].
9. (optional) You can click Advanced to configure advanced connection properties.w
10. (optional) You can click Test Connection to verify that you can connect to the database by using the specified connection information.
11. Click OK to create the connection.

Alternative ways to access the Database Connection Properties window:

1. In Database Explorer, click [image] New Connection.
2. Right-click anywhere in Database Explorer, and select New Connection from the shortcut menu.

The Database Explorer displays databases list beneath the connections node. You can create more than one connection to suit your own needs.

ExpandedToggleIcon(9x12) See Also

How To: Connect to a Database

Connection via TNS


Connection via TNS

To create a connection:

1. When you start the dbForge Studio for Oracle, the Database Connection Properties dialog box appears. If not, click New Connection on the Database menu.
2. Select TNS (Transparent Network Substracte) in the Connection type box.
3. Enter the database name in the Server box.
4. Enter the login credentials in the User and Password boxes.
5. (optional) You can specify how to connect to the server in the Connect as box. 'Normal' is set by default. Alternatively, you can connect to SYSDBA and SYSOPER administrative privileges selecting 'SYSDBA' or 'SYSOPER' options.
6. If you have several Oracle clients installed, in the Home box select which home you want to work with for the connection. If an Oracle Client is unique, it is selected by default. If you want to connect to the server via an Instant Client, specify the client in the Home box as well.

note Note

If you cannot find the server you want in the server list, your Oracle Client is not properly installed.
7. Enter a distinctive name for your new connection in the Connection name box. Alternatively, the connection name is generated automatically as [user]@[server].
8. (optional) You can assign a category for a new connection in the Document Category box.
9. (optional) You can click Advanced to configure advanced connection properties.
10. (optional) You can click Test Connection to verify that you can connect to the database by using the specified connection information.
11. Click OK to create the connection.

Alternative ways to access the Database Connection Properties window:

1. In Database Explorer, click [image] New Connection.
2. Right-click anywhere in Database Explorer, and select New Connection from the shortcut menu.

The Database Explorer displays databases list beneath the connections node. You can create more than one connection to suit your own needs.

ExpandedToggleIcon(9x12) See Also

How To: Connect to a Database

Connection via TNS Using OS Authentication


Connection via TNS Using OS Authentication

Before you can connect:

1. Create a user on the required server in the following format:

CREATE USER "OPS$DOMAIN_NAME\USER_NAME" IDENTIFIED EXTERNALLY

note Note

All values should be in UPPER CASE. Domain name and user name should coincide with the corresponding values specified under your PC account.
2. In Security Manager, locate the newly selected account and grant CONNECT and DBA roles to it. For more information, see Manipulating Roles.

To create a connection:

1. When you start the dbForge Studio for Oracle, the Database Connection Properties dialog box appears. If not, click New Connection on the Database menu.
2. Select TNS using OS Authentication in the Connection type box.
3. Select the required server in the Server box.
4. (optional) You can specify how to connect to the server in the Connect as box. 'Normal' is set by default. Alternatively, you can connect to SYSDBA and SYSOPER administrative privileges selecting 'SYSDBA' or 'SYSOPER' options.
5. If you have several Oracle clients installed, in the Home box select which home you want to work with for the connection. If an Oracle Client is unique, it is selected by default. If you want to connect to the server via an Instant Client, specify the client in the Home box as well.

note Note

If you cannot find the server you want in the server list, your Oracle Client is not properly installed.
6. Enter a distinctive name for your new connection in the Connection Name box. Alternatively, the connection name is generated automatically as [domain name/user name]@[server].
7. (optional) You can assign a category for a new connection in the Document Category box.
8. (optional) You can click Advanced to configure advanced connection properties.
9. (optional) You can click Test Connection to verify that you can connect to the database by using the specified connection information.
10. Click OK to create the connection.

Alternative ways to access the Database Connection Properties window:

1. In Database Explorer, click [image] New Connection.
2. Right-click anywhere in Database Explorer, and select New Connection from the shortcut menu.

The Database Explorer displays databases list beneath the connections node. You can create more than one connection to suit your own needs.

ExpandedToggleIcon(9x12) See Also

How To: Connect to a Database

How To: Create and Edit a Query


How To: Create and Edit a Query

This topic explains how to create and edit an SQL query in dbForge Studio

To create a query:

1. Create a server connection.
2. On the Start page click SQL Development and then click SQL Editor. Alternatively, click New SQL on the Standard toolbar or press CTRL+N. An empty SQL document opens.
3. Start type a query to a database.
4. Click Execute or press CTRL+F5 to see the query results.

ExpandedToggleIcon(9x12) Coding Techniques Example

The dbForge Studio SQL editor provides many features that make it easier for you to write and manage your code. Let's explore some Intellisense features that assist you while coding.

For an example, let's use the HR database and perform a sample query where we display all the employees working in the Shipping department, department ID is set to 50.

1. Open the SQL Editor.
2. Start typing the SELECT statement. Enter first three letters "sel". dbForge Studio shows you the list of the relevant keywords and snippets. You can select the SELECT keyword from the list and press ENTER. The keyword appears in the SQL editor. You can also select the "sel" snippet from the list and press the TAB button. In this case the SELECT * FROM statement appears in the SQL editor.

If you start type the same letters "sel" a little faster, before the list appears (by default the list has 200 ms delay), a little tool tip appears next to the letters. It signals that you can press the TAB button to complete the statement automatically by inserting a snippet.

Regardless of the method you choose, the SQL editor displays the SELECT * FROM statement.

3. Now, lets type a table name from which we want to retrieve the data. Start type "e". dbForge Studio shows you a list of valid members from the HR database. If you continue typing characters, the list is filtered to include only the members that begin with those characters. After selecting an item, you can insert it into your code by pressing TAB or ENTER. dbForge Studio also shows a quick info for every highlighted item in the list. It allows you to see the object structure immediately.

The EMPLOYEES table comes the third on the list, so choose it and press TAB or ENTER to insert it into the SQL editor. dbForge Studio assigns the alias for the EMPLOYEES table automatically.

4. We need to select employee categories that are stored in separate tables. In a similar way, either type or insert the JOIN keyword and press ENTER. dbForge Studio shows you all available solutions to implement JOIN. Select required statement and press ENTER.

8. The last step in creating a query is to add the condition. Add the AND E. DEPARTMENT_ID = 50 statement at the end of the query.
9. To format the query text, press CTRL + K, D combination or choose the Advanced option, on the Edit menu, and click Format Document. Now we can execute the query to see results. To do so, click the Execute button on the Debug toolbar, or press F5.
10. Place the cursor after the asterisk character and press TAB.

dbForge Studio shows the columns list that are available in the EMPLOYEES table.

11. There is no need to retrieve all the columns from the EMPLOYEES table, so we can leave only required ones.

12. The last step is to press F5 to execute the query.

We got what we wanted.

As you can see, Intellisense feature provided by dbForge Studio allows you to create complex queries in a few keystrokes.

ExpandedToggleIcon(9x12) See Also

Getting Started

How To: Create a Query in Query Builder


How To: Create a Query in Query Builder

This topic explains how to create and edit an SQL query in dbForge Studio using the Query Builder features.

We are going to create a sample query using visual designer. Let's repeat the sample we have created in the How To: Create and Edit a Query topic. We will use the HR database and display all the employees stored in the HR database, that are working in Shipping department with department ID number 50.

To create a query visually:

1. Create a server connection. For more information about how to create a server connection see How To: Connect to a Database.
2. On the Start Page click SQL Development and then click Query Builder. Now, you can drag-and-drop tables from the Database Explorer to the editor. Holding CTRL, select the DEPARTMENTS and EMPLOYEES tables in the Database Explorer, and drag-and-drop them over to the visual editor.

3. Select the DEPARTMENT_ID and DEPARTMENT_NAME checkboxes in the DEPARTMENTS table, and the EMPLOYEE_ID, FIRST_NAME, and LAST_NAME checkboxes in the EMPLOYEES table.

Actually, our query is ready to be executed. However, we need to add a WHERE condition, to display all the employees working in the Shipping department.

4. Go to the Where tab to insert the condition. Click the green plus icon.

5. Click enter a value.

6. Select DEPARTMENT_ID from the list and then press ENTER.

8. Click enter a value, type 50, and then press ENTER.

9. Click Execute. The result set displays the information we have requested.

As you can see the results are the same we have in the How To: Create and Edit a Query topic.

Visual Query Builder is a powerful tool that allows you to build complex queries quickly and with no code typing.

ExpandedToggleIcon(9x12) See Also

Getting Started

How To: Edit Data


How To: Edit Data

When dbForge Studio executes any statement returning a result set, the retrieved data is displayed in Data Editor of the Data view of the same SQL document or the Data window. This topic tells how to edit the data in grid.

ExpandedToggleIcon(9x12) Editing Data

1. In Data Editor available in the Data view of SQL document, Object Viewer, or in the Data window, click a cell you want to edit.
2. After editing, confirm the changes by clicking the EndEdit End Edit button under the grid or selecting the End Edit option from the shortcut menu.

Tip: To discard changes, click the CancelEdit Cancel Edit button or select the Cancel Edit option from the shortcut menu.

In dbForge Studio, you can also edit data right after retrieving it from a table or in the data view after any query was executed.

To retrieve data, select Retrieve Data from the shortcut menu of the table in Database Explorer. After this a window asking if you want to make the received data grid editable or not will appear. If you want to make the grid editable, click the Make Editable button, if you want the grid to be read-only, click Keep Read-Only. You can check the Don't show this message again check box, and the message won't appear when you click Retrieve Data any more.

To make data received after clicking Retrieve Data editable you can also choose the table name from the Table drop-down list on the toolbar , or leave it read-only by selecting (read-only).

If you choose the read-only mode, you will gain in the performance aspect, as the application will work faster in this mode.

To edit data in join query results, you should set the table you want to edit data from to the editable mode, as described above. After you set one table as editable, the data of other tables included into the result will become light-gray.

note Note

When you change the mode of any table from read-only to editable or vice versa, a balloon with the corresponding message is shown on the status bar.

ExpandedToggleIcon(9x12) Inserting, Deleting, and Copying Data

Use the shortcut menu or the corresponding buttons under the grid. For example, you can do the following:

· To insert NULL (instead of empty string), select Set Value To from the shortcut menu, and then click NULL. Alternatively, press CTRL+0.

Tip: Use Set Value To menu to quickly set an empty string, zero, or a current date.

· To add a new record, select the Append option from the shortcut menu or click the Append button under the grid. To delete a record from the grid, select the Delete option from the shortcut menu or click the [image] button under the grid or press the CTRL+DELETE keys.
· To copy and paste cell values, use the corresponding options from the shortcut menu.

ExpandedToggleIcon(9x12) Selecting Data

You can easily select and copy the data just like cells in a spreadsheet. Do either of these actions:

· Move the mouse pointer across the grid holding the left mouse button
· Click the first cell of the data range, press SHIFT, and, holding the SHIFT key, click the last cell. A rectangular range of cells will be selected.

Tip: Using the CTRL key, you may include and exclude cells to selection. Any number of rows may be copied and pasted to some other application, for example, a spreadsheet, but when you paste data in data grid, only the first row will be pasted.

dbForge Studio allows you to control data editing with transactions. When working with grid-based editor, you can access the following buttons on the Connection toolbar: Begin Transaction, Commit, and Rollback.

note Note

Some queries return read only data, for example, queries with aggregate functions (count, avg etc.), or data, retrieved from non-updatable views. Such data can't be edited. It is also impossible to edit the result of executing of the script with several select statements.

ExpandedToggleIcon(9x12) Row and Cell Indicators

When working with grid, you can see special indicators near to the focused cell. These indicators reflect current editing state.

arrow The row is focused.

editedrow The row is being edited.

rowhasbeenedited The row has been edited.

Incorrect Incorrect value was entered into a cell. You must either fix the value or press the ESCAPE key to cancel changes made to the cell.

ExpandedToggleIcon(9x12) See Also

Getting Started

How To: Create a Table in Table Editor


How To: Create a Table in Table Editor

In this example we will create a new table that does not contain any data. Nevertheless, while creating the table you must decide what types of data you want to store in it. The data is held in fields, and each field can be declared as one of the data types that are available.

The HR database contains the EMPLOYEES table. We are going to create a table that will store employees' biographies.

To create a table:

1. You must be connected to a database. For more information about how to create a server connection see How To: Connect to a Database.
2. In the Database Explorer, double-click a required database wherein you need to create a table.
3. Right-click the Tables folder and select the [image] New Table. The Table Editor opens.

4. In the Name text box, enter a table name. You can give it a name such as 'employees_biographies'.
5. In the grid below, click the first empty cell and enter the column name. You can give it a name such as 'id'. Then press ENTER. Notice, that the data type for that column is defined automatically. Select the check box next to id, in order to set this column as the primary key.
6. Click next empty cell and enter the column name. You can give it a name such as 'biography'. Press ENTER. Notice, that the data type for that column is defined automatically.
7. Click Upgrade Update Database.

The new empty table is created. It now appears in the Database Explorer in the Tables folder.

ExpandedToggleIcon(9x12) See Also

Getting Started

How To: Backup a Database


How To: Backup a Database

In this example we will create the HR database backup.

To backup a database:

1. On the Start Page click Data Pump, and then click Schema Export. The Schema Export Wizard opens.
2. Select a connection or click <Manage...> in the Connection list, and then click New, to create a new connection.
3. Once the connection is established, select a database you want to backup in the Schema list.
4. Specify a folder path to store backups in the Path text box.
5. Specify an output file name in the Output file name text box.
6. (Optional) You can setup some optional settings such as: Append timestamp to the file name, Auto delete old files, Use compression (ZIP), etc.

7. Click Next.
8. Select database objects to export. Click Next.
9. Specify detailed options on how schema export should be performed. Click Next.
10. Select the Write a report to a log file check box to save the backup process information to a log file. Enter the path where to store the file, for instance: C:\Users\Documents\Export\SchemaExport.log
11. Click Export.
12. As soon as the export process is finished, click Save Project.

A project file contains all the information that you have entered while walkthrough the wizard pages.

ExpandedToggleIcon(9x12) Running Backup from the Command Line

To run backup from the command line:

1. Click Start.
2. Type cmd in the Search programs and files text box and press the Enter button.

note Note

To run the Command Line in Windows 8:

From the Desktop Mode

· Move the mouse cursor to the exact lower left corner until the desktop shortcuts menu appears.
· Right-click to see the shortcut menu and than click Run

From the Charms Bar

· Move your mouse to the upper right corner until the Charms Bar appears.
· Select Apps from the list and type “run” in the search box.
· Click Run from the search results.

Use Windows+R Shortcut Keys

· In desktop mode, press the Windows+R keys, to show the Run command line.
3. Enter the command line as follows: "c:\Program Files\Devart\dbForge Studio for Oracle\dbforgeoracle.com" /schemaexport /projectfile:"c:\Backup\HR.backup". Press Enter.

After the process ends, a backup file appears in the specified directory.

Here are some additional commands that can help you work within the command line. Type the one you need, and then press ENTER.

· To see available commands, type:

/schemaexport /?

· To specify a connection, type:

/connection:<connection_string>

· To specify a file name for storing the schema, type:

/outputfile

· To specify a server password, type:

/password:<pw>

· To specify a schema export project to use, type:

/projectfile

· To specify a schema to export, type:

/schema

ExpandedToggleIcon(9x12) Scheduling Database Backup

You can use the Windows Task Scheduler to create and manage backup tasks that your computer will carry out automatically at the times you specify.

To create Windows task:

1. Run Windows Task Scheduler.

note Note

To run Windows Task Scheduler:

1. Click Start and then click Control Panel.
2. Click Administrative Tools.

note Note

If your current view is Category, click System and Security, and then click Administrative Tools
3. Click Task Scheduler.
3. Click the Action menu, and then click Create Basic Task.
4. Type a name for the task and an optional description, and then click Next.
5. Do one of the following:
· To select a schedule based on the calendar, click Daily, Weekly, Monthly, or One time, click Next; specify the schedule you want to use, and then click Next.
· To select a schedule based on common recurring events, click When the computer starts or When I log on, and then click Next.
· To select a schedule based on specific events, click When a specific event is logged, click Next; specify the event log and other information using the drop-down lists, and then click Next
6. To schedule a program to start automatically, click Start a program, and then click Next.
7. Click Browse to enter a path to the .bat file that stores the command line string. For instance, a .bat file can contain a command line string as follows: "c:\Program Files\Devart\dbForge Studio for Oracle\dbforgeoracle.com" /schemaexport /projectfile:"c:\Backup\HR.backup".
8. Click Next.
9. Click Finish.

ExpandedToggleIcon(9x12) See Also

Getting Started

Connecting to Databases


Connecting to Databases

ExpandedToggleIcon(9x12) In this Section

How To: Manage Database Connections
Learn how to operate databases via the Database Explorer.

Viewing Database Schema Information
Learn what you can see in the Database Explorer window.


How To: Manage Database Connections

dbForge Studio for Oracle offers you visual, quick, and simple way to manage database connections through the Database Explorer window.

By default, Database Explorer displays recently used database connections. If you open the Database Explorer for the first time, no connections are shown.

Use the Database Explorer to do the following:

ExpandedToggleIcon(9x12) Creating a database connection

1. Open the Database Connection Properties dialog box by either of these ways:
· Click the [image] New Connection button on the Database Explorer toolbar
· Right-click in the Database Explorer window and select New Connection from the shortcut menu
· On the Database menu, click New Connection

2. Set up connection parameters. The newly-created connection marked with the [image] connection icon appears in the Database Explorer.

ExpandedToggleIcon(9x12) Windows connection coloring

Windows connection coloring allows you immediately know which server you are connected to. You can add coloring for each server connection.

ExpandedToggleIcon(9x12) Opening a database connection

Double-click a connection in the Database Explorer. The connection icon is set to [image] and database objects are shown.

ExpandedToggleIcon(9x12) Closing a database connection

Right-click a connection in the Database Explorer and select Close. The connection icon will be changed to CloseConnectionDatabaseExplorer to indicate the close.

ExpandedToggleIcon(9x12) Editing a database connection

Right-click a connection in the Database Explorer and select Modify Connection. The Database Connection Properties dialog box opens enabling you to edit the parameters.

ExpandedToggleIcon(9x12) Duplicating a database connection

Right-click a connection in the Database Explorer and select Duplicate Connection. A copy of the connection will appear in the Database Explorer window.

ExpandedToggleIcon(9x12) Deleting a database connection

Right-click a connection in the Database Explorer and select Delete. The message appears asking "Are you sure you want to remove database connection 'name'?". Click Yes to drop the connection. Click No to cancel dropping.

ExpandedToggleIcon(9x12) Viewing database connection information

Right-click a connection in the Database Explorer and select Properties. The Properties window opens displaying the connection properties.

ExpandedToggleIcon(9x12) See Also

Connecting to Databases

Viewing Database Schema Information


Viewing Database Schema Information

After a database connection is created and opened, you can explore a database schema hierarchy by expanding tree nodes. The Database Explorer allows you to view, edit, create, and drop database objects. To see what actions are available for a specific node, right-click on it to display a shortcut menu.

As other users modify a database, you can refresh the list of the database objects and their properties by clicking the Refresh button.

To rename a database table, focus on it and press F2, or click it again after a short pause.

Node types available for an Oracle server connection:

· Table
· Object Table
· XML Table
· View
· Package
· Procedure
· Function
· Trigger
· Array Type
· Table Type
· Object Type
· Sequence
· Materialized View
· Materialized View Log
· Synonym
· Cluster
· Database Link
· XML Schema

You can view database object properties in the Properties window. Select Properties from the View menu or press CTRL+W, P.

To view additional information about the selected schema, click Object Viewer, on the View menu.

ExpandedToggleIcon(9x12) See Also

Connecting to Databases

Writing and Executing SQL Statements


Writing and Executing SQL Statements

This section provides information on how to create and execute SQL statements.

ExpandedToggleIcon(9x12) In This Section

Writing SQL Statements
Basic tips on writing SQL statements ans working with SQL scripts.

Executing SQL Statements
Explains some special features for executing SQL statements.

Writing SQL Queries with Code Completion
Provides examples of using the Code Completion features.

How To: Work with Code Snippets
Explains how to insert, create, and modify code snippets.

How To: Work with Literals
Explains how to create and modify literals in code snippets.

Viewing Server Messages and Errors
Describes windows designed to display server messages and errors.

Using Parameters
Information on how to use parameters to simplify process of editing the query.

SQL History
Information on how to use SQL statements history to re-execute queries.

Executing Large Scripts
Tells how to execute a large script without opening it in the editor.

Opening Large Scripts in SQL Editor
Contains information about opening large scripts in the editor.

Associating Windows with Connection
Information on how documents and tool windows use connections.

SQL Document Shortcut Keys
Lists shortcut keys designed to facilitate your work with SQL documents and stored procedures.

Executing Scripts through the Command Line
Learn how to automate executing the scripts through the command line.

Formatting Code through the Command Line
Learn how to automate code formatting through the command line.

SQL*Plus Command Support
Learn which SQL*Plus commands are supported in dbForge Studio for Oracle.

Phrase Completion
The topic describes the phrase completion feature provided by dbForge Studio for Oracle.

Code Refactoring
Learn how to rename objects and variables in dbForge Studio for Oracle.

Managing Aliases
The topic describes how to create, rename, and map aliases.


Writing SQL Statements

Every SQL document contains the Text view with SQL editor in it. You switch to this view to edit your SQL queries.

When you type text in SQL editor, it automatically recognizes and highlights SQL syntax.

For ease of SQL writing and reviewing, you can also use such supported shortcut keys as: CTRL+PLUS (+) KEY (to zoom the query in), CTRL+MINUS (-) KEY (to zoom the query out), CTRL+0 (to return an SQL document to the one-to-one scale).

You write and execute SQL queries not only one at a time but you may as well compose SQL scripts. SQL scripts consist of multiple SQL statements separated by the appropriate statement delimiter.

ExpandedToggleIcon(9x12) See Also

Writing and Executing SQL Statements

Executing SQL Statements


Executing SQL Statements

ExpandedToggleIcon(9x12) How to Run Execution

Entire Script

To execute the entire script, click the Execute button on the SQL toolbar.

Alternatively, on the SQL menu, select the Execute command.

Selected Block of Text

To execute an arbitrary text block:

1. Select the text block using the mouse or keyboard.
2. Run the Execute command as when executing the entire script. Alternatively, select Execute Selection from the shortcut menu of SQL Editor

Current Statement

To execute current statement, click the Execute Current Statement button on the SQL toolbar.

Alternatively, right-click a required statement, and select Execute Current Statement command on the shortcut menu.

Execute to Cursor

To execute script to the current position of the cursor:

1. Move cursor to the required position.
2. Click Execute to Cursor on the shortcut menu or press Ctrl+Shift+F10.

ExpandedToggleIcon(9x12) How to Stop Execution

To stop SQL execution, click Stop Execution the SQL toolbar.

ExpandedToggleIcon(9x12) Representing Query Execution Results

The query execution results can be represented in two ways - in text and in grid formats.

To represent results as text, click Results as Text on the SQL toolbar before query execution.

To represent results as grid, click Results as Grid on the SQL toolbar before query execution.

ExpandedToggleIcon(9x12) See Also

Writing and Executing SQL Statements


Writing SQL Queries with Code Completion

dbForge Studio can save your time whether you write an SQL query or format your code. This topic briefly explains how to write SQL queries using dbForge Studio.

expandedtoggleicon(9x12) Writing a Query

For example, you need to write a SQL query like SELECT * FROM SCOTT.EMP.

1. Open a new SQL document and select a connection with the SCOTT database from the Connection list box on the SQL toolbar.
2. Start typing: se (press Enter) * fr (press Enter)

When you are typing, the suggestion box appears with the list of suggestions that are relevant to the typed symbols. The suggestions are filtered to display most relevant ones at the top of the list. To insert a suggestion into your code, navigate to a required one by using Up and Down arrow keys, and then press Enter.

dbForge SQL Complete suggestion box

Note Note

The first suggestion in the list is considered the most relevant, that is why it is highlighted to speed up the insertion.
3. Press the Space key and type em (press Enter).

Inserting a table name

expandedtoggleicon(9x12) Formatting SQL Code

dbForge Studio can quickly format your SQL code depending on selected formatting options. To format your code, click Enable Code Completion for current document on the SQL toolbar.

You can format SQL code even if Code Completion is disabled. Select a statement, and then click Format Current Statement on the shortcut menu if you want to format the whole code, or click Format Selection if you want to format a highlighted code fragment.

To disable code formatting for a specific part of the code, use the -- noformat -- endnoformat tags.

expandedtoggleicon(9x12) Inserting a Snippet

To insert a snippet to your SQL code, type first letter for a required statement in SQL editor. The statements prompt list appears. Select a statement itself, or insert a whole snippet. Snippets follow after the statements in the prompt list. Navigate a required snippet, and press ENTER. Alternatively, click Insert Snippet on the shortcut menu.

dbForge Studio for Oracle allows navigating through the data input fields, where you can specify your own data. Use the TAB key to go forward and the TAB+SHIFT keys to go back.

expandedtoggleicon(9x12) See Also

Writing and Executing SQL Statements

Working with Code Snippets


Working with Code Snippets

This topic explains how to use code snippets in dbForge Studio for Oracle.

Code snippets help to boost SQL code typing. You can use predefined snippets provided in the application and create your own to insert them in SQL scripts and queries.

dbForge Studio code snippets are XML files with the .snippet file name extension.

The Code Snippets window contains a rich collection of templates organized in folders. In this window, you can arrange and preview snippets. To view a snippet, select it in the window. If the preview pane is not visible, right-click a snippet and select toggle-preview Toggle preview from the menu.

ExpandedToggleIcon(9x12) Inserting Code Snippets

1. Click code-snippets Code Snippets on the View menu. The Code Snippets window opens.
2. In the Code Snippets window, choose the required template and drag it to the SQL editor.
3. Specify variable names and parameter values in the lines marked green, and the press ENTER to complete code fragment editing.

Alternatively

1. Click Insert Snippet on the SQL Editor shortcut menu.
2. Select the required template.
3. Use the UP ARROW and DOWN ARROW keys to select the item in the snippets list.
4. Specify variable names and parameter values in the lines marked green and press ENTER to complete code fragment editing.

Code snippets can also be inserted by entering template shortcut word or words and pressing the TAB key.

note Note

If you want some fragment of code to be put inside the inserted template, select it with the mouse before placing snippet to the editor. If the snippet does not provide surrounding, selected text will be deleted.

To move the snippet to the root folder of the Code Snippets window, drag it on the one that already is in the root folder or to the upper border of the Code Snippets window.

ExpandedToggleIcon(9x12) Creating Code Snippets

1. Click code-snippets Snippets Manager on the Tools menu. The Snippets Manager window opens.
2. Click New-snippet New Snippet on the manager toolbar.

note Note

Actual document look may slightly vary from the above image, depending on the product you use.
3. In the Text field, enter the text of the snippet.
4. Specify a shortcut and snippet description in the corresponding Shortcut and Description fields.

note Notes

The Location field is read-only and is filled automatically when you choose the folder available in the list of snippets.

The shortcut (if any) will be taken as snippet name. If there is no shortcut specified, the new snippet will be named Snippet. To change the snippet name, double click it in the list of snippets and enter the needed name.
5. Click Save on the toolbar.

ExpandedToggleIcon(9x12) Editing Code Snippets

1. Click code-snippets Snippets Manager on the Tools menu. The Snippets Manager window opens.
2. Select the required snippet from the list of available snippets.

note Note

Actual document look may slightly vary from the above image, depending on the product you use.
3. Modify the snippet's description, shortcut, and text in the corresponding fields.
4. Click the Save button on the manager toolbar.
5. To change the snippet name, double click it in the list of available snippets.

ExpandedToggleIcon(9x12) Default Snippets Location

By default, all snippets are stored in a folder that is located at C:\ProgramData\Devart\dbForge Studio for Oracle\Snippets.

You can change the default location when editing an existing snippet or creating a new one by setting a new path in the Location field of Snippets Manager.

ExpandedToggleIcon(9x12) See Also

Writing and Executing SQL Statements

Executing Scripts through the Command Line


Working with Literals

This topic explains how to work with literals used in code snippets.

ExpandedToggleIcon(9x12) Creating a New Literal

1. Click code-snippets Snippets Manager on the Tools menu. The Snippets Manager window opens.
2. Select a snippet in the list of available snippets to add a literal to.
3. Under the Literals field, click the Add button. The Edit literal window opens.
4. Specify the literal's name, default value, and description in the corresponding fields.
5. Click OK to add the literal to the list.

ExpandedToggleIcon(9x12) Editing a Literal

1. Click code-snippets Snippets Manager on the Tools menu. The Snippets Manager window opens.
2. Choose the required snippet in the list of snippets and the literal in the Literals field.

note Note

Predefined literals cannot be modified.
3. Click the Edit button below the Literals field. The Edit literal window opens.
4. Modify the literal's name, default value, and description.
5. Click OK to save the changes.

ExpandedToggleIcon(9x12) See Also

Writing and Executing SQL Statements

How To: Work with Code Snippets


Viewing Server Messages and Errors

When you run a query against a database server, it returns a response to the client. There are three types of server responses to an SQL query:

· Tabular data is displayed in the Data Editor.
· Status (info) messages and errors are logged to the Output window.
· Errors are displayed in the Error List window.

ExpandedToggleIcon(9x12) Using Output Window

The Output window includes four tabs showing the complete output information for an executed query.

note Note

Depending on the product the Output window appearance may vary.

· The General tab displays message statuses on general operations.
· The SQL Log tab displays all SQL queries executed by the application during the current session. To see the SQL log information, select the Write queries sent by the program to SQL Log option at Tools, Options, Environment, Output.
· The DBMS Output tab displays the DBMS_OUTPUT package messages. The messages are displayed, if the Enable DBMS output option is selected in Advanced, Database Connection Properties Dialog Box.
· The Debug pane contains messages sent by a stored procedure debugger.

The Output window also shows errors, that occurred during query execution. To navigate to an error location, select Go to Error from the shortcut menu.

Searching Output Messages

The Output window allows to perform the text search. To find a specific text:

1. Navigate to the Output window.
2. Press CTRL+F to Invoke the Find and Replace window.
3. Enter a search string and press ENTER or click Search button.

ExpandedToggleIcon(9x12) Using Error List Window

Error List shows not only errors, but also warnings and informational messages that require user attention.

To filter errors, warnings or messages, use the appropriate toolbar buttons.

To view errors for the current document, click In Active Document.

To navigate to an error, double-click it in the list or select Go to Error from the shortcut menu.

ExpandedToggleIcon(9x12) See Also

Writing and Executing SQL Statements

Using Parameters


Using Parameters

ExpandedToggleIcon(9x12) What is a Parameter?

Parameter is a placeholder for a variable that contains a value of some type that is passed to a database server along with the SQL text at the query execution time. Also parameter can hold values returned by a server after query or stored procedure execution.

You can benefit from using of parameters in the following situations:

· When you execute a query multiple times with different input values
· When you debug a query from your application code

ExpandedToggleIcon(9x12) Adding Parameters to a Query Text

Parameters are declared using ':' prefix followed by name of the parameter.

For example:

SELECT
employee.*
FROM
hr.employee
WHERE
employee.title = :job AND
employee.vacation_hours <= :level

:job and :level are parameters in this query.

ExpandedToggleIcon(9x12) Modifying Parameter Values and Types

When you run a query that contains parameters with empty values, you will be automatically prompted to initialize them.

To set parameter values and types select Edit Parameters command from the SQL toolbar or from the SQL menu. In open Edit Parameters dialog box set parameters' type, value, and other properties.

note Note

When you execute a query with preset parameter values, you will not be automatically prompted to edit them. To edit parameters, press F8 or select Edit Parameters on the SQL toolbar.

ExpandedToggleIcon(9x12) See Also

Writing and Executing SQL Statements

SQL History


SQL History

SQL statement history is designed to ease recalling and re-executing statements you have previously executed. Choose View SQL History from the SQL menu to bring up a dialog where you can choose which SQL statement must be inserted into the editor instead of current one. Point with the mouse on a statement in a history to view its full text in a hint.

For quick navigation through executed statements, you may use PreviousSQL Previous SQL and NextSQL Next SQL buttons. PreviousSQL Previous SQL goes down the stack and NextSQL Next SQL goes up.

note Note

The history clears when application is closed or SQL document is saved or opened, so you have to save your queries for long-term use. SQL history is not available when working with an opened file.

ExpandedToggleIcon(9x12) See Also

Writing and Executing SQL Statements


Executing Large Scripts

dbForge Studio allows you to execute large scripts without opening script in the SQL editor and loading the whole script in memory. When you try to open a large script, you will be prompted to execute it instead with the help of the Execute Script Wizard.

To execute a large script, do the following:

1. To open the Execute Script Wizard, go to the Database, and then select Execute Large Script.
2. Click the Connection field to select a connection to a required database server against which you want to execute your script. In the drop-down lists of the field you can click the <Manage...> link to open the Connection Manager dialog box. It will help you to create a connection if necessary.
3. Click Schema drop-down list to select a required from the list of those schemas that are available on the selected database server.
4. In the File name box specify the path to the script you want to execute.
5. In the SQL file encoding field check that the file encoding is selected correctly. The program automatically selects it basing on the script, if it fails, the default encoding (the current Windows encoding on the machine where the program is running) is selected. You can always select a required encoding from the drop-down list.
6. Click Execute to execute the script.

Tip: See all script execution messages in the Output window.

ExpandedToggleIcon(9x12) See Also

Writing and Executing SQL Statements

Opening Large Scripts in SQL Editor


Opening Large Scripts in SQL Editor

To avoid performance slowdown, some features are disabled when working with large SQL scripts.

If script size exceeds 10 Mb, the SQL syntax highlight is disabled. It is not enabled when you reduce the script in the editor. You should reopen script to re-enable the feature.

note Note

Maximum file size the application can open depends on available memory on your computer.

ExpandedToggleIcon(9x12) See Also

Writing and Executing SQL Statements


Associating Windows with Connection

When several connection are established in the Database Explorer, you can execute queries or perform another actions with either of them. SQL documents are associated with a connection which you can see or set on the Connection toolbar. The drop-down list in the toolbar shows what connection is associated with the active document or tool window. If a tool window, that does not require a connection, is active, connection of the active document (or tool window in the document area) is displayed.

When creating or opening a SQL document, it is assigned a default connection. If you create SQL document with no connection present in Database Explorer, the document will have no connection and you can not execute SQL or retrieve data. You can change connection for SQL document by selecting required connection in the Document Connection box on the Connection toolbar.

ExpandedToggleIcon(9x12) See Also

Writing and Executing SQL Statements

SQL Document Shortcut Keys


SQL Document Shortcut Keys

Use following shortcut keys when working with an SQL document or stored procedure.

Icon | Command Name | Shortcut Keys | Action | Where is used
Execute | Execute | F5 | Execute query associated with current document | SQL Editor, Query Builder
execcurrentstatement | Execute Current Statement | F8 | Execute current statement | SQL Editor
PreviousSQL | Previous SQL | CTRL+SHIFT+ Up Arrow | Previous SQL statement from history | SQL Editor
NextSQL | Next SQL | CTRL+SHIFT+ Down Arrow | Next SQL statement from history | SQL Editor
History | SQL History | CTRL+Alt+H | Open SQL History dialog | SQL Editor
Parameters | Edit Parameters | CTRL+SHIFT+P | Edit parameters | SQL Editor
IListMembers | List Members | CTRL+J | List members | SQL Editor
IListMembers | List Members | CTRL+K, L | List members | SQL Editor
ICompleteWord | Complete Word | CTRL+SPACE | Complete word | SQL Editor
ICompleteWord | Complete Word | CTRL+K, W | Complete word | SQL Editor
ICompleteWord | Complete Word | CTRL+Right Arrow | Complete word | SQL Editor
IParameterInfo | Parameter Info | CTRL+SHIFT+SPACE | Parameter information | SQL Editor
IParameterInfo | Parameter Info | CTRL+K, P | Parameter information | SQL Editor
InsertTemplate | Insert Template | CTRL+K, X | Insert code template | SQL Editor
InsertTemplate | Insert Template | CTRL+K, CTRL+X | Insert code template | SQL Editor
IQuickInfo | Quick Info | CTRL+K, I | Display quick information | SQL Editor
IQuickInfo | Quick Info | CTRL+K, CTRL+I | Display quick information | SQL Editor
Comment | Comment Selection | CTRL+E, C | Comment selection | SQL Editor
Uncomment | Uncomment Selection | CTRL+E, U | Uncomment selection | SQL Editor
 | Toggle Outlining Expansion | CTRL+M, M | Toggle outlining expansion | SQL Editor
 | Toggle All Outlining | CTRL+M, L | Toggle all outlining | SQL Editor
 | Stop Outlining | CTRL+M, P | Stop outlining | SQL Editor
 |  | CTRL+F2 | Switch to Navigation Bar | SQL Editor
GotoDefinition | Go To Definition | F12 | Go to definition | SQL Editor
 |  | CTRL+R | Hide/Show additional document views | SQL Editor
 |  | CTRL+L | Delete current code line and copy it to clipboard | SQL Editor

These shortcuts are default shortcuts. All shortcuts can be customized.

ExpandedToggleIcon(9x12) See Also

Writing and Executing SQL Statements

Executing Scripts through the Command Line


Executing Scripts through the Command Line

You can automate executing the scripts using the command line.

note Note

The command line functionality is available only in certain editions of dbForge Studio. For the detailed information on features availability in the dbForge Studio editions, please refer to the Editions topic.

1. Click Start.
2. Type 'cmd' in the Search programs and files text box and press the ENTER button.

note Note

To run the Command Line in Windows 8:

From the Desktop Mode

· Move the mouse cursor to the exact lower left corner until the desktop shortcuts menu appears.
· Right-click to see the shortcut menu and than click Run.

From the Charms Bar

· Move your mouse to the upper right corner until the Charms Bar appears.
· Select Apps from the list and type “run” in the search box.
· Click Run from the search results.

Use Windows + R Shortcut Keys

· In desktop mode, press the Windows + R keys, to show the Run command line.
3. Type a path to the dbforgeoracle.com file located in the dbForge Studio for Oracle installation folder on your PC, and press the SPACE key.

C:\Program Files\Devart\dbForge Studio for Oracle\dbforgeoracle.com

4. To execute the corresponding script, use the /execute command, and press the SPACE key.

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /execute /?

5. Specify connection details of the server where to execute the script.

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /execute
/connection:"User Id=scott;Server=dboracle;Unicode=True;Connection Timeout=0;Direct=True;Service Name=orcl1120;"

6. Specify the script file.

C:\Program Files\Devart\
dbForge Studio for Oracle>dbforgeoracle.com /execute
/connection:"User Id=scott;Server=dboracle;Unicode=True;Connection Timeout=0;Direct=True;Service Name=orcl1120;"
/inputfile "script.sql"

7. Specify the password.

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /execute
/connection:"User Id=scott;Server=dboracle;Unicode=True;Connection Timeout=0;Direct=True;Service Name=orcl1120;"
/inputfile "script.sql" /Password:mypsw

8. To hide the command line window, use the /quiet command. (Useful for batch files).

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /execute
/connection:"User Id=scott;Server=dboracle;Unicode=True;Connection Timeout=0;Direct=True;Service Name=orcl1120;"
/inputfile "script.sql" /Password:mypsw /quiet

9. Press ENTER to run the process.

If you use the /argfile argument, all the following commands are specified inside an argfile:

/execute

/connection:"User Id=scott;Server=dboracle;Unicode=True;Connection Timeout=0;Direct=True;Service Name=orcl1120;"

/inputfile "script.sql"

In this case, the command line string will be written as follows:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /argfile:myarg.txt

ExpandedToggleIcon(9x12) Arguments Used in Command Line

Select corresponding command line switches to perform the required operations:

Argument | Action and Usage
/connection | This switch is used to specify a connection string. Command usage looks like: /connection:<connection_string>
/encoding | This switch is used to specify the encoding which should be applied to open and execute the script. Command line usage looks like: /encoding:<encoding>
/inputfile | This switch is used to specify an SQL or ZIP file with the script to execute.
/password | This switch is used to specify a server password. It overrides the password specified in the connection string. Command line usage looks like: /password:<pw>
/schema | This switch specifies schema to execute script to. Schemas specified in script will be ignored. Does not affect objects with fully qualified names.

ExpandedToggleIcon(9x12) See Also

Writing and Executing SQL Statements

SQL* Plus Command Support


Formatting Code through the Command Line

You can automate code formatting using the command line.

note Note

The command line functionality is available only in certain editions of dbForge Studio. For the detailed information on features availability in the dbForge Studio editions, please refer to the Editions topic.

1. Click Start.
2. Type 'cmd' in the Search programs and files text box and press the ENTER button.

note Note

To run the Command Line in Windows 8:

From the Desktop Mode

· Move the mouse cursor to the exact lower left corner until the desktop shortcuts menu appears.
· Right-click to see the shortcut menu and than click Run.

From the Charms Bar

· Move your mouse to the upper right corner until the Charms Bar appears.
· Select Apps from the list and type “run” in the search box.
· Click Run from the search results.

Use Windows + R Shortcut Keys

· In desktop mode, press the Windows + R keys, to show the Run command line.
3. Type a path to the dbforgeoracle.com file located in the dbForge Studio for Oracle installation folder on your PC, and press the SPACE key.

C:\Program Files\Devart\dbForge Studio for Oracle\dbforgeoracle.com

4. Specify the operation you want to perform (code formatting) and the required parameters and arguments:

dbforgeoracle.com /formatsql [/switch1[:value | [parameter1:value parameter2:value ..]] /switch2 ..]

Tip: To see a quick help on the arguments available in the command line, type the following:

/formatsql /?

5. Press ENTER to run the process.

note Note

You can set the unlimited quantity of the required extensions:
dbforgeoracle.com /formatsql /sourcefolder:"c:\" /filextention:*.sql /filextention:*.prg /filextention:*.db1

ExpandedToggleIcon(9x12) Arguments Used in Command Line

Select corresponding command line switches to perform the required operations:

Argument | Action and Usage
/connection | This switch is used to specify a connection string. Command usage looks like: /connection:<connection_string>
/filextention | This switch is used to specify the extension of the source folder files that will be formatted. The .sql extension is selected by default. Command usage looks like: /filextention:*.<sql|prc|txt|...>
/log | This switch is used to generate a formatting log file in the specified directory. Command usage looks like: /log:<filepath>
/outputfile | This switch is used to specify the path to an output file where formatting results of the source file will be saved (in this case, the source file is saved without changing). If the parameter is not specified, the formatting results will be saved in the source file. Command usage looks like: /outputfile:<path>
/outputfolder | This switch is used to specify the patch to an output folder where the source folder files with formatting results will be saved (files form the source folder will no be changed). If the parameter is not specified, the formatting results will be saved in the source folder. Command usage looks like: /outputfolder:<path>
/password | This switch is used to specify a server password. It overrides the password specified in the connection string. Command usage looks like: /password:<pw>
/profile | This switch is used to specify the path to a file that contains settings for formatting options. If the parameter is not specified, the default settings will be applied to the formatting options. Command usage looks like: /profile:<path>
/sourcefile | This switch is used to specify the source SQL file to be formatted. Command usage looks like: /sourcefile:<path>
/soucefolder | This switch is used to specify the path to a folder where the files for formatting are located. Command usage looks like: /sourcefolder:<path>
/includesubfolders | This switch is used to include the current directory and all subdirectories in search operation. Command usage looks like: /includesubfolders

ExpandedToggleIcon(9x12) See Also

Writing and Executing SQL Statements


SQL*Plus Command Support

dbForge Studio for Oracle supports some SQL * Plus commands in SQL code. Use these SQL* Plus commands just like usual SQL statements. These commands are supported in both full and short forms.

Supported commands

The list of supported SQL*Plus commands includes:

· @
· @@
· ACCEPT (ACC)
· CLEAR (CL)
· CONNECT (CONN)
· DEFINE (DEF)
· DESCRIBE (DESC)
· EXECUTE (EXEC)
· PROMPT (PRO)
· REMARK (REM)
· VARIABLE (VAR)

If you try to execute script, containing unsupported SQL*Plus commands, warning messages will appear in the Error List and these commands will be ignored.

@, @@
Runs the specified script. When debugging SQL scripts, you can step into scripts, called with @ or @@ commands. The Call Stack window will show stack of the documents. dbForge Studio for Oracle does not support running scripts from URLs. You should use filename or filename with a path.

ACCEPT
Stores the input value in a given substitution variable. When dbForge Studio for Oracle executes the ACCEPT command, it shows a dialog to enter a variable value. If you have specified a prompt, it will be displayed as the title of the dialog. Otherwise, default title "Assign value to variable <variable name> (<datatype>)" will be used. You can not use the NOPROMPT command option.

CLEAR
Clears the Output window.

CONNECT
Connects to the Oracle server. If the connection with entered connection parameters already exists, the existing connection will be opened. Otherwise, a new connection is created. If you have not specified the password, the connection dialog will appear. The CONNECT command in the form CONNECT user/password@host:port/sid creates the Direct connection.

DEFINE
Specifies a user or predefined variable and assigns a CHAR value to it, or lists the value of a single variable or all variables. If you use it to list variable value, it will be displayed in the Data Window. Variables, declared with DEFINE can not be viewed in the Watches window when debugging.

DESCRIBE
Lists the column definitions for the specified table, view or synonym, or the parameter specifications for the specified function or procedure. The result is displayed in the Data window.

EXECUTE
Executes a single PL/SQL statement.

PROMPT
Displays specified text in the General pane of the Output window.

REMARK
Begins a comment.

VARIABLE
Declares a bind variable that can be referenced in PL/SQL or shows variable or all variables with their data types. The result is displayed in the Data window. Bind variables, declared with VARIABLE command, can be viewed in the Watches window when debugging.

ExpandedToggleIcon(9x12) See Also

Writing and Executing SQL Statements


Phrase Completion

Code Completion suggests not only separate keywords and object names, but entire code phrases. The following code phrases are supported:

· ORDER MEMBER
· INNER JOIN
· CROSS JOIN
· COMMENT ON
· GLOBAL TEMPORARY TABLE
· TEMPORARY TABLE
· TEMPORARY TABLESPACE
· CONNECT BY
· FOR UPDATE
· START WITH
· AS RESULT
· AS OF
· PARTITION BY
· REJECT LIMIT
· SEGMENT CREATION
· ROLLBACK SEGMENT
· FLASHBACK ARCHIVE
· DATABASE LINK
· LOCK TABLE
· DEFAULT DIRECTORY
· DEFAULT TABLESPACE
· BULK COLLECT
· PRIMARY KEY
· FOREIGN KEY
· MATERIALIZED VIEW
· NOT NULL
· NOT MATCHED THEN INSERT
· NOT IDENTIFIED

ExpandedToggleIcon(9x12) Example

INNER JOIN is prompted in the SELECT query.

ExpandedToggleIcon(9x12) See Also

Writing and Executing SQL Statements

Building Queries with Query Builder


Code Refactoring

This section describes how to perform code refactoring using dbForge Studio for Oracle.

expandedtoggleicon(9x12) In This Section

Renaming Objects
This topic describes how to rename tables, temporary tables and columns, views, stored procedures, functions.

Renaming Variables
This topic describes how to rename local variables.


Renaming Objects

The Rename functionality provides an easy way to change an object name for a new one that better reveals its purpose and automatically finds and corrects all references to it.

You can rename an object only in a script, and not in a database.

The Rename refactoring is available for:

· Tables
· Views
· Stored procedures
· Packages
· Functions
· Triggers
· Sequences
· User types
· Materialized views
· Synonyms
· Clusters

To rename an object in the SQL editor:

1. Right-click the required object and select the Rename command from the shortcut menu. Alternatively you can select the object and press F2. The object will be highlighted.

2. Type a new name for the object in the SQL editor window. As you type, a tooltip appears instructing to Press F2 to preview changes or Enter/Tab to apply.

3. Press F2 to open the Preview Changes - Rename dialog window and preview code changes, to apply changes press the Apply button;

4. Alternatively, press Enter/Tab to apply changes in the code.

expandedtoggleicon(9x12) See Also

Code Refactoring

Renaming Variables


Renaming Variables

The Rename functionality provides an easy way to change all occurrences of variable names into new ones to improve code readability and automatically finds and corrects all references to them.

You can rename an object only in a script, and not in a database.

The Rename refactoring is available for local variables.

To rename an object in the SQL editor:

1. Right-click the required object and select the Rename command from the shortcut menu. Alternatively you can select the object and press F2. The object will be highlighted.

2. Type a new name for the object in the SQL editor window. As you type, a tooltip appears instructing to Press F2 to preview changes or Enter/Tab to apply.

3. Press F2 to open the Preview Changes - Rename dialog window and preview code changes, to apply changes press the Apply button;

4. Alternatively, press Enter/Tab to apply changes in the code.

expandedtoggleicon(9x12) See Also

Renaming Objects

Code Refactoring


Managing Aliases

dbForge Studio can automatically generate aliases for each table object (table, view, synonym) referenced in the FROM list of your SQL document. To disable automatic alias generation, clear the Generate alias on commit option. If there are prefixes in the names of your table objects, you can setup dbForge Studio so that it ignores those prefixes when assigning aliases.

The following rules are used when creating aliases:

· If possible, dbForge Studio generates aliases using the first letter of a table object name.
· For names with underscores:
for TBL_Address alias ta is assigned
· For names with hyphens:
for Tbl-address alias ta is assigned
· For names with CamelCase:
for TblAddress alias ta is assigned
· For names with numbers:
for 111 alias a is assigned
· If a generated alias name matches a keyword, the alias name is wrapped in square brackets. For example, if the table object name is GeneralObjects, the alias name will be "go".
· If a newly generated alias coincides with an existing one, dbForge Studio adds symbols 1, 2,...n to the newly generated alias to avoid ambiguity.

Alias Refactoring

To rename an alias:

1. Right-click the required alias and select the Rename command from the shortcut menu or select the alias and press F2 - the alias will be highlighted.

2. Type a new name for the alias in the SQL editor window.
As you type, a ToolTip appears instructing to Press F2 to preview changes or Enter/Tab to apply.

3. Press F2 to open the Preview Changes - Rename dialog window and preview code changes; to apply changes press the Apply button.

4. Alternatively, press Enter/Tab to apply changes in the code.

Custom Alias Mapping

dbForge Studio allows users to manually assign aliases to an identifier (table, view, synonym) referenced in an SQL document.

To add a custom alias:

1. In the Tools menu, click Options.

2. In the Options window, navigate to the Text Editor tab, select Code Completion, and then Alias.

3. On the Alias page, in Settings, you can select one or more of the available options.

4. Define an identifier in the Condition column using one of the condition masks, as required.

5. Define an alias name in the Action column using one of the action masks.

6. Click OK.

When a custom alias is created, the dbForge Studio assigns the alias name to an object that is referenced in an SQL statement according to a specified alias mask.

Note Note

Custom aliases have precedence over automatically created ones.

Alias Masks

dbForge Studio offers a number of alias masks for managing custom alias mapping. You can use the alias masks to specify conditions and actions when assigning aliases. For example, you can assign different aliases for same-named objects.

The following list demonstrates examples of the condition masks:

<product> - exact match;

<*product> - matches object names ending with "product"

<product*> - matches object names starting with "product"

<*product*> - matches object names including "product"

<*> - matches any valid object name

<schema>.<product> - exact match with the object name "product" using schema as a prefix

<schema*>.<product*> - matches object names starting with "product" with a prefix starting with "schema"

The following list demonstrates examples of the action masks:

Id<1> - adds prefix Id to a generated alias

<1>.<2> - generates alias with a prefix

<"Dept"1> - excludes "Dept" from a generated alias

No Alias - when "No Alias" is specified in the Action column for a certain condition, no alias will be generated for that condition

Mask Prioritization

User-defined (custom) masks have precedence over the automated alias mapping.

Alias masks specified in the grid have top-down priority. For example, in the following table demonstrating an example custom alias mapping, the <*Person*> mask condition has a higher priority than <Product*>:

Condition | Action
<*Person*> | <alias1>
<Product*> | <alias2>
<Sales>.<Product*> | <alias3>

alias1 will be assigned to all objects including "Person";

alias2 will be assigned to all objects starting with "Product";

alias3 will be assigned to all objects starting with "Product" with parent "Sales".

expandedtoggleicon(9x12) See Also

Phrase Completion

Writing and Executing SQL Statements


Building Queries with Query Builder

ExpandedToggleIcon(9x12) In This Section

Query Builder Overview
Provides basic information about Query Builder.

How To: Add Tables to Query
Describes how to add tables to SELECT list when visually building a query.

How To: Remove Tables from Query
Information on how to remove tables from SELECT statements.

How To: Include Columns in Query
Information on how to setup SELECT clause.

How To: Make Joins Between Tables
Information on how to create relations between tables.

How To: Build WHERE or HAVING Clause
Information on how to set up WHERE and HAVING clauses.

How To: Include Fields in GROUP BY or ORDER BY Clauses
Information on how to setup GROUP BY and ORDER BY clauses.

Building a Query in Visual Mode
Contains a step-by-step procedure to easily create inner and outer joins and customize a query.

Working with Query Diagram
Tells how to manage shapes on the diagram.

Working with Subqueries
Tells how to create and edit subqueries.

Navigating Query with Document Outline
Describes how to navigate queries with the Document Outline window.


Query Builder Overview

Query Builder is designed to enhance productivity and simplify SQL query building tasks. Query Builder provides a graphical user interface for creating SQL queries. You can drag-and-drop multiple tables, views and their columns onto a visual designer to generate SQL statements.

You can use Query Builder to perform the following tasks:

Working with a graphical representation of a query or with SQL code
Query Builder includes a pane that displays your query graphically and a pane that displays the SQL text of your query. You can work in either the graphical pane or the text pane. Query Builder synchronizes the views so that they are always current.

Joining related tables
If you add more than one table to your query, Query Builder automatically determines how the tables are related and constructs the appropriate join command.

Querying or updating databases
You can use Query Builder to return data by using SELECT statements and to create queries that update, add, or delete records in a database.

Viewing and editing results immediately
You can run your query and work with a recordset in a grid that allows you to scroll through and edit records in the database.

ExpandedToggleIcon(9x12) See Also

Building Queries with Query Builder

How To: Add Tables to Query


How To: Add Tables to Query

The first step in building a SELECT query is to decide which tables and views you need to add to SELECT list.

ExpandedToggleIcon(9x12) Adding Tables and Views

To add tables and views to the query, simply drag-and-drop them from the Database Explorer tree to the query diagram.

You can also select required tables in the Database Explorer, right click the selected tables, and then click Send To, and then click Query Builder. Table shapes appear containing the list of table columns which you can mark to include in SELECT list. Check "All Columns" option if you want to select all the fields in a table.

After you have added tables to the query diagram, you can use the Selection tab of the tabbed editor to adjust the query to your needs.

note Note

A connection you are using while dragging a table must be the connection of the query document. You will not be able to perform a drag and drop operation from another connection.

note Note

The appearance may slightly vary depending on the product you use.

Besides tables, you can add the following objects to the diagram:

· Views
· Synonyms
· Functions

They are displayed as shapes with the list of columns which you can mark to include in SELECT list.

ExpandedToggleIcon(9x12) See Also

Building Queries with Query Builder

How To: Remove Tables from Query


How To: Remove Tables from Query

You can remove a table or any table-valued object from the query.

To remove a table or table-structured object

· In the Diagram Pane, select a table, view, user-defined function, synonym, or query, and then press DELETE, or right-click the object and then click Remove from the diagram. You can select and remove multiple objects at one time.

Alternatively

· Remove all references to the object in the SQL editor.

When you remove a table or table-valued object, the Query Builder automatically removes joins that involve that table or table-valued object and removes references to the object's columns in the SQL editor and.

note Note

Removing a table or table-valued object does not delete anything from the database, it only removes it from the current query.

ExpandedToggleIcon(9x12) See Also

Building Queries with Query Builder

How To: Include Columns in Query


How To: Include Columns in Query

To use a column in a query, you must add it to the query. You may add a column to display it in query output, to use it for sorting, to search the contents of the column, or to summarize its contents.

To add an individual column

· In the Diagram Pane, select the check box next to the column that you want to include.

Alternatively

· In the Tabbed Editor, move to the first blank grid row, click the field in the Column column, and select a table and a column name from the drop-down list.

To add all columns for one table or table-valued object

· In the Diagram Pane, select the check box next to *(All Columns).

To add all columns for all tables and table-structured objects

1. In the Design Pane, select all tables.
2. Make sure no join lines in the Design Pane are selected.
3. Right-click any table and select Select all columns from the shortcut menu.

ExpandedToggleIcon(9x12) See Also

Building Queries with Query Builder

How To: Make Joins Between Tables


How To: Make Joins Between Tables

A join between two tables describes how these tables are related. Depending on a join kind you can get different results for the same tables. Refer to SQL manual for information on joins and their effect. dbForge Studio allows you to visually create 5 kinds of joins: inner, left outer, right outer, natural, and cross join. You can also easily set very complex conditions for any kind of joins.

ExpandedToggleIcon(9x12) Creating Joins

To add a join between two tables, do either of these actions:

· Use the diagram - Drag-and-drop a source column from one table to a destination column in the second table.
· Use the Joins tab of the tabbed editor - Click the FilterGreyAdd button of the top tree node. A new empty join with an empty condition will appear. Click the <Enter table name> field and specify the join tables. You may type them or select them from the drop-down list. Then set the join kind by clicking the red-colored join kind and selecting a required item from the shortcut menu. You can remove a join by clicking its FilterGreyDel button.

To edit join properties, use the toolbar, connector shortcut menu, or Joins tab of the tabbed editor.

To change a join kind, use the select-all-tables-left Select all rows from "[table]" and select-all-tables-right Select all rows from "[table]" buttons on the Query toolbar.

To remove a join, select the connector, then either right-click on it and choose Remove from Diagram or hit the DELETE key.

note Note

Joins are automatically created when a table with foreign key and its referenced table is placed on the diagram.

ExpandedToggleIcon(9x12) Working with join conditions and condition groups

The tabbed editor shows joins as a tree with join, condition and group nodes. A join consists of conditions and condition groups. A group consists of several conditions or subgroups, united with a logical operator. You can change a group logical operator by clicking it and selecting another one from the menu. To navigate between conditions and groups, use the UP ARROW and DOWN ARROW keys. Use the LEFT ARROW and RIGHT ARROW keys to navigate between a criteria operator and operands.

To create a new group, click the upper-level group operator or join kind and choose Add Group from the appeared menu.

To create a new condition, do the following:

1. Navigate to the group or the join you want to enhance and click the FilterGreyAdd button or press the INSERT or PLUS SIGN key. Alternatively, click the upper-level group operator and choose Add Condition from the appeared menu.
2. Click the condition column and select a column you need from the appeared menu.
3. Click the condition criteria operator and select a criteria operator you want to apply.
4. If the condition operator requires operand value(s), specify it (them).

To remove a condition, click the FilterGreyDel condition button or navigate to the condition and press the DELETE or MINUS SIGN key. To remove a group, click its logical operator and choose Remove Group from the appeared menu or navigate to the group and press the DELETE or the MINUS SIGN key.

You also can copy, cut, and paste conditions and groups with CTRL+C, CTRL+X, and CTRL+V keys.

ExpandedToggleIcon(9x12) See Also

Building Queries with Query Builder

How To: Build WHERE or HAVING Clause


How To: Build WHERE or HAVING Clause

When retrieving data, you may want to set up a filtering expression or relation between tables. You can do it using WHERE and HAVING clauses. Refer to SQL manual to learn what's different in these sections. In dbForge Studio visual interface for WHERE and HAVING clauses is the same.

In the tabbed editor conditions are displayed as a tree with condition and group nodes. A group consists of several conditions or subgroups, united with a logical operator. You can change a group logical operator by clicking it and selecting another one from the menu. To navigate between conditions and groups, use the UP ARROW and DOWN ARROW keys. Use the LEFT ARROW and RIGHT ARROW keys to navigate between criteria operator and operands.

To create a new group, do one of the following:

· Click the upper-level group operator and choose Add Group from the appeared menu.
· Press CTRL+PLUS SIGN.

ExpandedToggleIcon(9x12) Building WHERE and HAVING Clause

To create a new condition, do the following:

1. Navigate to the group you want to enhance and click the FilterGreyAdd button or press INSERT or PLUS SIGN key. Alternatively, click the upper-level group operator and choose Add Condition from the appeared menu.
2. Click the condition column and select the column you need from the appeared menu.
3. Click the condition criteria operator and select the criteria operator you want from the list.
4. If the condition operator requires operand value(s), specify it (them).

To remove a condition, click the FilterGreyDel condition button or navigate to condition and press DELETE or MINUS SIGN key. To remove a group click its logical operator and choose Remove Group from the appeared menu or navigate to the group and press DELETE or MINUS SIGN key.

You also can copy, cut, and paste conditions and groups with CTRL+C, CTRL+X, and CTRL+V keys.

The following clause is generated according to the sample image:

WHERE
Product.Color = 'silver' AND
ProductCategory.Name >= 'components'

ExpandedToggleIcon(9x12) See Also

Building Queries with Query Builder

How To: Include Fields in GROUP BY or ORDER BY Clauses


How To: Include Fields in GROUP BY or ORDER BY Clauses

When you need to group resulting data, you must specify the field you want to group on in GROUP BY clause. When you want to sort data by a field, you must include the field in ORDER BY list. In dbForge Studio, the interface for this clauses is approximately the same. The only difference is that ORDER BY tab has the Change Order button that you can use to alter sorting direction.

ExpandedToggleIcon(9x12) Including Fields in ORDER BY Clause

To include fields in ORDER BY clause, switch to the corresponding tab of the tabbed editor and perform the following steps:

1. Select the field you want to perform grouping/ordering on and click the right arrow button.
2. Repeat this operation for every field that should be added to the clause.
3. Use the up arrow and down arrow buttons to change the order of columns.
4. If you want to exclude a field from the list, select it and click the left arrow button.
5. For ordering lists, select a field and click the Change Order button to alter the sorting order.

ExpandedToggleIcon(9x12) See Also

Building Queries with Query Builder

Building a Query in Visual Mode


Building a Query in Visual Mode

The topic describes how to use Query Builder for generating SELECT statements.

ExpandedToggleIcon(9x12) Retrieving Data from Tables Using Query Builder

Suppose you need to know what department the employee belongs to. To accomplish the task, we need to get the employee's name and the department internal code from one table (Emp) and the name of the department from another table (Dept).

Creating Inner Join between Two Tables

1. In Database Explorer. make sure that the connection to the server is active.
2. In the SQLDevelopment SQL Development section of the Start Page, click SQL-Query-Builder Query Builder.
3. Drag the Emp and Dept table from Database Explorer to the query diagram.
4. Select EName in the Emp table shape, and Dname in the Dept table shape to include them to the SELECT list. These fields appear in the Selection tab of the tabbed editor below the query diagram.
5. Drag the DeptNo field from the Emp table shape to the same field of the Dept table shape. A connector between two tables appears, what indicates that the relation is established.
6. Switch to the Joins tab of the tabbed editor to make sure the relation has been established properly. The string should like "Emp.DeptNo=Dept.DeptNo".
7. To perform the query, click [image] on the Query toolbar
EName | Dname
Smith | Sales
Allen | Sales2
Ward | Sales2
Jones | Sales
Martin | Sales2
Blake | Sales2
King | Accounting

Creating an Outer Join Between Two Tables

Now when data from several tables can be retrieved at the same query, let's have a closer look at the SQL statement that was just composed. A distinctive feature of the INNER JOIN is that if an employee has DeptNo, which is never encountered in the Dept table, then this employee will not be listed in the query result. You can set value of DeptNo to other than 10, 20 or 30 to make sure that after performing the same query the corresponding entry disappears from the returned data. An OUTER JOIN should be used to save the situation.

To create an OUTER JOIN:

1. Right-click the connector between two tables. The shortcut menu appears.
2. Estimate the position of table shapes on the query diagram. If the table shape representing the Emp table is at the left of the connector, click Select all rows from "Emp" at the shortcut menu. Notice, that the middle of the connection has changed its form.
3. Switch to the Joins tab of the tabbed editor to see the changes. Alternatively, click the red-colored join kind and select Left Outer Join from the shortcut menu.
4. To execute the query, click [image] on the Query toolbar .

The result of this query should be exactly the same as the previous. To see how the outer join works, change a value of DeptNo in any of the tables to a unique value and re-execute the query.

Customizing a Query Using Query Builder

There are six clauses in the SELECT statement and there is a separate tab for every clause in the tabbed editor. The tabbed editor is the easiest way to adjust a query to your needs. Now, the previous query should become a bit more complex. Suppose we need to find out, how much money employees earn in each department. Let's exclude the president from the list and sort it by money amount in descending order.

1. Switch to the Design view of the query that was built in the previous section of the walkthrough.
2. In the Emp table shape, clear the EName field to exclude it from SELECT list.
3. Switch to the Selection tab of the tabbed editor. Click the first empty cell and select Emp.Sal (SAL (emp)) field from the drop-down list.
4. In the same row, click the Alias column and enter a alias for the field, for example "Money".
5. In the same row, click the Function column and select Sum from the drop-down list. Pay attention to the changes that occurred in the table shape related to the Emp table.
6. On the Where tab of the tabbed editor, click the FilterGreyAdd button.
7. Click the left <enter a value> field, then select Emp.Job from the drop-down list.
8. Click the condition operator ('=') and select Does not equal from the drop-down list.
9. Click the right <enter a value> field and type 'President'.
10. On the Group By tab, select theDept.DName field and click RightArrowButton . Use up and down arrow buttons to change the columns order. If you mistakenly added a wrong field to the Group By list, exclude it by selecting it and clicking the left arrow button. Keep the Having tab intact. It is absolutely similar to the Where tab.
11. On the Order By tab, click Money, and then click RightArrowButton .
12. Select this field in the Ordered By list and click ChangeOrder. Notice, what happened to table shapes after all these manipulations.
13. At any moment you can switch to the Text view of a document to examine a query you built with Query Builder. To click the Text button at the bottom part of a document. If the Text button is not visible, use a corresponding item in the shortcut menu. Another way to change document's view is to use commands from the View menu.
14. In either Design or Text view, click the [image] Execute button.

If you follow the instructions correctly and use the source data provided in the previous topic, the following table should appear:

Dname | Money
Sales2 | 6950
Sales | 3775

If you modify the tables involved in the query, your results may differ.

note Note

Depend on the product you use the retrieval data may differ from this example.

ExpandedToggleIcon(9x12) See Also

Building Queries with Query Builder

Working with Query Diagram


Working with Query Diagram

This section provides information about managing shapes on the query diagram.

ExpandedToggleIcon(9x12) In This Section

Diagram Overview
Provides basic information about the diagram.

Diagram Layout
Describes how to layout the diagram automatically and change shape order.

Aligning Shapes
Describes how to align shapes on the diagram.

Changing Shape Size
Describes shape size changing.

Controlling Spacing between Shapes
Describes how to change spacing between shapes.

Diagram Shortcuts
This section describes shortcuts for query builder diagram.

ExpandedToggleIcon(9x12) See Also

Building Queries with Query Builder

Working with Subqueries


Diagram Overview

Query Builder diagram allows you to view and edit visual query representation. Table shapes on the diagram represent tables, views and subqueries. Joins are represented as connections between table shape fields.

Table controls can be moved (by dragging them with mouse or by keyboard), resized, aligned to the diagram grid. You also can zoom in and out of the diagram using either CTRL+Mouse Wheel or Zoom In and Zoom Out buttons on the Query toolbar. Use the Actual Zoom button to return to actual zoom.

The order of overlapping shapes can be controlled using the Bring to Front and Send to Back buttons of the Layout toolbar or use corresponding items of the Order submenu of the Layout menu.

You may control diagram layout both with mouse and keyboard. All operations can be executed with keyboard.

Diagram can be customized on theGeneral, Query Builder Options dialog box. You can enable or disable diagram grid and grid snapping, set grid step, enable or disable table shape shadow, and set diagram background color.

ExpandedToggleIcon(9x12) See Also

Building Queries with Query Builder

Diagram Layout


Diagram Layout

Diagram layout can be controlled in a number of ways. Diagram shapes can be moved (by dragging them with mouse or by keyboard), resized, aligned to the diagram grid. Read Aligning Shapes and Changing Shape Size topics for more information.

dbForge Studio allows you to layout a diagram automatically or manually. To resize the diagram automatically, just click the Layout Diagram button on the Diagram toolbar.

You may change shape order either by right-clicking them and choosing Bring to Front or Send to Back from the Shape sub menu of the shortcut menu, or by using the corresponding buttons on the Layout toolbar.

ExpandedToggleIcon(9x12) See Also

Working with Query Diagram

Aligning Shapes


Aligning Shapes

Each shape may be aligned to the grid. To align a shape to the grid, select it and click the Align to Grid button on the Layout toolbar.

Several shapes can be aligned in a column or in a row.

· To align in a row, select shapes and click the Align Tops, Align Middles, or Align Bottoms button on the Layout toolbar to align the shapes by their top, center, or bottom of the primary selection respectively. Their horizontal position remains unchanged.
· To align in a column, select shapes and click the Align Rights, Align Lefts, or Align Centers button to align the shapes by their right side, left side, or center of the primary selection respectively. Their vertical position remains unchanged.

You may also use corresponding commands of the Align sub menu of the Layout menu.

ExpandedToggleIcon(9x12) See Also

Working with Query Diagram

Changing Shape Size


Changing Shape Size

To change shape size, select it and drag the square resize markers at the shape sides and corners. To fit shape size to grid, select it and click the Size to Grid button on the Layout toolbar or select Size to Grid from the Make Same Size submenu of the Layout menu. Shapes have minimal and maximal height and width. Minimal width and height are constant. Maximal width depends on the length of the name of the longest column in a table shape. Maximal height depends on the table shape column count.

You can also fit the same size for multiple shapes. To do this, select the shapes and click the Make Same Width or Make Same Height buttons on the Layout toolbar. You may also use corresponding items of the Make Same Size submenu of the Layout menu. When using this feature, the size of the selected shapes will be aligned with the size of primary selection.

note Note

A primary selection is one of the selected shapes. Its resize markers are blue, while resize markers of other selected shapes are black. If a selected shape cannot have the same size as the primary selection, its size will be changed to become as close to the primary selection size as possible.

ExpandedToggleIcon(9x12) See Also

Controlling Spacing between Shapes

Controlling Spacing between Shapes


Controlling Spacing between Shapes

Diagram provides flexible control over spacing between shapes on the diagram. You can proportionally increase and decrease horizontal and vertical spacing between the shapes, make it equal or remove it.

· To increase spacing between shapes, select shapes, which will be moved, and click Increase Horizontal Spacing or Increase Vertical Spacing on the Layout toolbar or choose Increase from the Horizontal Spacing or Vertical Spacing submenu of the Layout menu.
· To decrease spacing between shapes, select shapes, which will be moved, and click Decrease Horizontal Spacing or Decrease Vertical Spacing on the Layout toolbar or choose Decrease from the Horizontal Spacing or Vertical Spacing submenu of the Layout menu.
· To make spacing between shapes equal, select shapes, which will be moved, and click Make Horizontal Spacing Equal or Make Vertical Spacing Equal on the Layout toolbar or choose Make Equal from the Horizontal Spacing or Vertical Spacing submenu of the Layout menu.
· To remove spacing between shapes, select shapes, which will be moved, and click Remove Horizontal Spacing or Remove Vertical Spacing on the Layout toolbar or choose Make Equal from the Horizontal Spacing or Vertical Spacing submenu of the Layout menu.

note Note

When increasing or decreasing spacing or making it equal, spacing is considered as distance between centers of shapes. But when removing spacing it is considered as distance between shape borders. When you remove, for example, vertical spacing, shapes will be located in the following way: the top of the second shape will be located at the same height as the bottom of the highest shape, the top of the third one will be located at the same height as the bottom of the second shape and so on.

ExpandedToggleIcon(9x12) See Also

Working with Query Diagram

Diagram Shortcuts


Diagram Shortcuts

This section contains shortcuts for query builder diagram.

ExpandedToggleIcon(9x12) In This Section

Diagram Shortcuts Overview
This topic explains how to use shortcut keys to perform certain operations using keyboard.

Focus and Selection Shortcuts
Contains shortcuts for moving focus and selecting shapes or columns.

Zoom and Scroll Shortcuts
Contains shortcuts for moving and zooming the diagram sheet.

Shape and Column Managing Shortcuts
Contains shortcuts for manipulating shapes and columns.

ExpandedToggleIcon(9x12) See Also

Working with Query Diagram

Working with Subqueries


Diagram Shortcuts Overview

Diagram allows you to speed up your work with keyboard shortcuts. This topic explains how to use them to perform certain operations using keyboard.

Some diagram shortcuts can be customized.

ExpandedToggleIcon(9x12) Moving Focus and Selecting Shapes

To switch between shapes, use TAB (SHIFT+TAB) keys. TAB key moves focus and selection forward, SHIFT+TAB moves it backward. To select multiple shapes, move focus with CTRL+ALT+TAB or SHIFT+CTRL+ALT+TAB shortcut and add required shapes to selection with the SPACE key (these shortcuts are not available in Windows 7).

ExpandedToggleIcon(9x12) Moving and Resizing Shapes

To move selected shapes with snapping to the grid, use arrow keys. To move the shapes one pixel, press CTRL+arrow keys. To resize the shapes, press SHIFT+arrow keys or CTRL+SHIFT+arrow keys. To collapse/expand a table control, use ALT+RIGHT ARROW/ALT+LEFT ARROW keys.

ExpandedToggleIcon(9x12) Bookmarking a Viewing Area of the Diagram

You can bookmark the current viewing area of the diagram by pressing CTRL+SHIFT+{0-9}. Then you can scroll the sheet or change the zoom, but quickly come back to the saved viewing area by pressing CTRL+{0-9}.

ExpandedToggleIcon(9x12) Working with Columns

To add columns to the query:

1. Navigate to a table.
2. Switch to its columns with SHIFT+PERIOD keys.
3. Use arrow keys to navigate to the column to add to query.
4. Press ENTER to add column
5. Repeat steps 3-4 for all columns you want to add
6. Press the ESC key to move focus from the columns to the table.

ExpandedToggleIcon(9x12) Viewing Diagram

To scroll the diagram, switch focus to it with the ESC or SHIFT+COMMA keys and use arrow keys. You may also use PAGE UP and PAGE DOWN keys. To zoom in and out use CTRL+PLUS SIGN and CTRL+MINUS SIGN keys.

ExpandedToggleIcon(9x12) Other Shortcuts

You can assign shortcuts for all commands from the layout menu. These commands don't have shortcuts by default. Use the Keyboard page of the environment options to assign shortcuts. Type Diagram in the Show Commands Containing field to filter commands.

ExpandedToggleIcon(9x12) See Also

Diagram Shortcuts

Focus and Selection Shortcuts


Focus and Selection Shortcuts

Use following shortcut keys for changing focus and selection on the diagram.

Shortcut Keys | Action | Where is used
Ctrl+A | Selects all | Diagram
TAB | Moves focus and selection forward | Diagram
SHIFT+TAB | Moves focus and selection backward | Diagram
CTRL+ALT+TAB | Moves focus forward without moving selection (this shortcut is not available in Windows 7) | Diagram
CTRL+SHIFT+ALT+TAB | Move focus backward without moving selection (this shortcut is not available in Windows 7) | Diagram
HOME | Moves focus and selection to the first item (shape or column) | Diagram
END | Moves focus and selection to the last item (shape or column) | Diagram
SPACE | Toggle selection of the focused item | Diagram
UP ARROW | Moves focus and selection to the previous column or stored routine parameter | Diagram
DOWN ARROW | Moves focus and selection to the next column or stored routine parameter | Diagram
CTRL+UP ARROW | Moves focus without selection to the previous column or stored routine parameter | Diagram
CTRL+DOWN ARROW | Moves focus without selection to the next column or stored routine parameter | Diagram
SHIFT+UP ARROW | Moves focus to the previous column or stored routine parameter. Adds it to selection if the first selection column or stored routine parameter is below, otherwise, removes selection from the current column or stored routine parameter. | Diagram
SHIFT+DOWN ARROW | Moves focus to the next column or stored routine parameter. Adds it to selection if the first selection column or stored routine parameter is above, otherwise, removes selection from the current column or stored routine parameter. | Diagram
CTRL+SHIFT+UP ARROW | Moves focus to the previous column or stored routine parameter and extends the selection on it | Diagram
CTRL+SHIFT+DOWN ARROW | Moves focus to the next column or stored routine parameter and extends the selection on it | Diagram
SHIFT+PERIOD | Moves focus to the lower level | Diagram
SHIFT+COMMA | Moves focus to the upper level | Diagram
ESC | Moves focus to the upper level | Diagram
ALT+DOWN ARROW | Moves focus to the table shape name if the focus was on the table shape. Table shape expands if it was previously collapsed. | Diagram

ExpandedToggleIcon(9x12) See Also

Diagram Shortcuts

Zoom and Scroll Shortcuts


Zoom and Scroll Shortcuts

Use following shortcut keys for working with the diagram sheet.

Icon | Command Name | Shortcut Keys | Action | Where is used
 | Zoom In | CTRL+PLUS SIGN | Zoom in | Diagram
 | Zoom In | CTRL+MouseWheel forward | Zoom in | Diagram
 | Zoom Out | CTRL+MINUS SIGN | Zoom out | Diagram
 | Zoom Out | CTRL+MouseWheel backward | Zoom out | Diagram
 |  | UP ARROW | Scroll the sheet up when the sheet is focused | Diagram
 |  | DOWN ARROW | Scroll the sheet down when the sheet is focused | Diagram
 |  | LEFT ARROW | Scroll the sheet left when the sheet is focused | Diagram
 |  | RIGHT ARROW | Scroll the sheet right when the sheet is focused | Diagram
 |  | PAGE UP | Scroll the sheet one page up | Diagram
 |  | PAGE DOWN | Scroll the sheet one page down | Diagram
 |  | CTRL+SHIFT+{0-9} | Bookmark a current viewport (a visible region of the diagram) | Diagram
 |  | Ctrl+{0-9} | Return to a bookmarked viewport | Diagram

ExpandedToggleIcon(9x12) See Also

Diagram Shortcuts

Shape and Column Managing Shortcuts


Shape and Column Managing Shortcuts

Use following shortcut keys to manipulate shapes and columns on the diagram.

Shortcut Keys | Action | Where is used
UP ARROW | Moves the selected shapes one grid step up if some shapes are selected | Diagram
DOWN ARROW | Moves the selected shapes one grid step down if some shapes are selected | Diagram
LEFT ARROW | Moves the selected shapes one grid step left if some shapes are selected | Diagram
RIGHT ARROW | Moves the selected shapes one grid step right if some shapes are selected | Diagram
CTRL+UP ARROW | Moves the selected shapes one pixel up if some shapes are selected | Diagram
CTRL+DOWN ARROW | Moves the selected shapes one pixel down if some shapes are selected | Diagram
CTRL+LEFT ARROW | Moves the selected shapes one pixel left if some shapes are selected | Diagram
CTRL+RIGHT ARROW | Moves the selected shapes one pixel right if some shapes are selected | Diagram
SHIFT+UP ARROW | Decreases the height of the selected shapes one grid step if some shapes are selected | Diagram
SHIFT+DOWN ARROW | Increases the height of the selected shapes one grid step if some shapes are selected | Diagram
SHIFT+LEFT ARROW | Decreases the width of the selected shapes one grid step if some shapes are selected | Diagram
SHIFT+RIGHT ARROW | Increases the width of the selected shapes one grid step if some shapes are selected | Diagram
CTRL+SHIFT+UP ARROW | Decreases the height of the selected shapes one pixel if some shapes are selected | Diagram
CTRL+SHIFT+DOWN ARROW | Increases the height of the selected shapes one pixel if some shapes are selected | Diagram
CTRL+SHIFT+LEFT ARROW | Decreases the height of the selected shapes one pixel if some shapes are selected | Diagram
CTRL+SHIFT+RIGHT ARROW | Increases the height of the selected shapes one pixel if some shapes are selected | Diagram
ALT+LEFT ARROW | Expands the shape or table compartment | Diagram
ALT+LEFT ARROW | Collapses the shape or table compartment | Diagram
ENTER | Opens editor for the selected objects | Database Diagram
ENTER | Includes selected columns to the query if some columns are selected | Query Builder Diagram
DELETE | Excludes the selected shapes from the diagram when shapes are selected | Diagram
DELETE | Drops the selected columns, constraints, or triggers from database when table columns, constraints, or triggers are selected. | Database Diagram
CTRL+DELETE | Drops the selected database objects from the database | Database Diagram

ExpandedToggleIcon(9x12) See Also

Diagram Shortcuts

Working with Subqueries


Working with Subqueries

This section describes how to visually create subqueries in dbForge Studio.

ExpandedToggleIcon(9x12) In This Section

Subqueries Overview
Contains basic information on working with subqueries.

Subqueries in From Clause
Describes how to add subqueries to FROM clause.

Subqueries in Other Clauses
Describes how to add subqueries in SELECT, WHERE, and HAVING clauses.

ExpandedToggleIcon(9x12) See Also

Building Queries with Query Builder

Navigating Query with Document Outline


Subqueries Overview

dbForge Studio offers full support for subqueries in all SELECT statement clauses. Each subquery can have its own subqueries.

When you create a subquery or open it for visual editing, a subquery tab of the query document appears. This offers you simple navigating subqueries using these tabs. You can navigate to the upper-level query from the subquery with the ParentQuery Parent Query button on the Query toolbar. You can also use the Document Outline window to navigate the complex queries.

note Note

If you want to include a table along with joins, conditions, and subqueries into a subquery, you have to set focus on the whole diagram area instead of the particular table and perform the Wrap to Subquery operation for your diagram.

ExpandedToggleIcon(9x12) See Also

Working with Subqueries

Subqueries in From Clause


Subqueries in From Clause

Subqueries in the FROM clause are represented as table controls on the diagram. They can be treated exactly as tables.

ExpandedToggleIcon(9x12) Creating Subqueries

To create a new subquery:

In the query document, do either of these actions to open the SubQuery tab:

· Right-click the diagram and choose Create Subquery from the shortcut menu
· Click the Create Subquery button on the Query toolbar
· Select Create Subquery from the Query menu

The SubQuery tab appears where you can create the subquery - add a table, select required columns, specify conditions, etc.

You can include a table into a subquery in two clicks. Just right-click a table on the diagram, and select Wrap to Subquery item from the menu. The table shape will change its color and the subquery will be added to the query. You can add an alias to your subquery by typing it into the caption of subquery table shape. When the subquery is created, you can switch to the Text view to check the code.

To quickly navigate to your main query and subquery, use the tabs of the query document or open the Document Outline window.

To edit a subquery, click the Query3PButton button on the subquery title bar or right-click the subquery and select Edit Subquery from the shortcut menu.

To rename a subquery, double-click its title and enter a required alias.

ExpandedToggleIcon(9x12) See Also

Working with Subqueries

Subqueries in Other Clauses


Subqueries in Other Clauses

ExpandedToggleIcon(9x12) Subqueries in SELECT, WHERE, and HAVING Clauses

Subqueries in these clauses are highlighted like hyperlinks. You can add subqueries to these clauses by typing them instead of columns. To open such subquery for visual editing, click them holding the CTRL key. Subqueries in the SELECT clause may be renamed by entering name into the Alias column.

ExpandedToggleIcon(9x12) Subqueries in GROUP BY and ORDER BY Clauses

Subqueries in these clauses should always return only one value (i.e. one row having one column). To add such subquery, type it into the expression box and press ENTER. You can open them for visual editing only by navigating to them with Document Outline.

ExpandedToggleIcon(9x12) Subquery in SELECT clause

To add a subquery to SELECT clause:

1. In the query document go to the Selection tab of the tabbed editor (it is placed under the diagram) and click the field in the Column field. The operand editor opens.
2. Click the CreateSubQuery Create Subquery button. The program inserts a subquery template into the condition and automatically moves you to the subquery tab of the query document.

ExpandedToggleIcon(9x12) Subquery in WHERE and HAVING Clauses

To add a subquery to WHERE and HAVING clauses:

1. In the query document create a condition on the WHERE or HAVING tab of the tabbed editor and click the CreateSubQuery Create Subquery button in the Operand editor.

The program inserts a subquery template into the condition and automatically moves you to the subquery tab of the query document.

2. Drag-and-drop a table to the subquery and add the subquery conditions. The subquery template will be populated with the added parameters.

ExpandedToggleIcon(9x12) See Also

Working with Subqueries

Navigating Query with Document Outline


Navigating Query with Document Outline

Use the Document Outline window to quickly navigate to the root query and clauses containing subqueries. If the Document Outline window is not visible, click the View menu, and then click Document Outline. The Document Outline window contains nodes, representing all the query clauses, selected columns, tables and views in the From clause, and all the subqueries on any nesting level. Double-click on the clause node activates the corresponding Query Builder tab for the corresponding subquery or the root query. Double-click on the subquery node opens the corresponding subquery for editing. Double-click on the table column or table node selects the corresponding column or table.

The Working with Subqueries window represents the root query and clauses (SELECTION, FROM, WHERE, and HAVING) containing subqueries as nodes in the tree. Double-click the nodes to go to the corresponding query tabs.

ExpandedToggleIcon(9x12) See Also

Working with Subqueries

Building Queries with Query Builder


Working with Data in Data Editor

This section describes some things you should know about manipulating data in dbForge Studio for Oracle.

ExpandedToggleIcon(9x12) In This Section

Viewing Data in Grid
Describes how to use multiple grid editor's features to customize the data display and get more insight.

Editing Data in Grid
Describes how to quickly edit data using various grid editor's features.

Data Shortcut Keys
Lists useful shortcut keys for working with data.


Viewing Data in Grid

This section describes features for viewing data in dbForge Studio for Oracle.

ExpandedToggleIcon(9x12) In This Section

Viewing Data in Grid Overview
Tells how to efficiently view data in dbForge Studio.

Sorting Data in Grid
Tells how to sort data in the grid.

Grouping Data in Grid
Tells how to use data grouping.

Filtering Data in Grid
Tells how to apply various filter conditions to filter data in the grid.

Server-side and Client-side Sorting and Filtering Data in Grid
Explains how sorting and filtering are processed on the client side and on the server side. Gives a list of problems that may be encountered.

Paginal Mode
Teaches how to use paginal mode to limit row count in the grid.

Auto-search Mode
Teaches how to use auto-search mode to quickly locate data.

Card View
Describes how to use card mode for graphical data representation.

ExpandedToggleIcon(9x12) See Also

Working with Data in Data Editor

Editing Data in Grid


Viewing Data in Grid Overview

The Data Editor allows you to view and quickly edit data right in the grid.

ExpandedToggleIcon(9x12) To Access Data

· Execute a query that returns data.
· Open the table or view editor and switch to the data view.
· Right-click on the table or view in the Database Explorer and choose Retrieve Data from the shortcut menu.
· Double-click a table or view in Database Explorer and switch to the Data view of the Object Viewer.
*In Query Builder: right-click the table or view in the Data Editor and select Data View from the shortcut menu.
· Drag the table or view from the database explorer to the Data Window.

Use the rich set of data management options in the shortcut menu.

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

note Note

If you want to retrieve all data from a table with a large number of records, a message warning you about the possibility of the "Out of memory" exception is shown, and you can choose either of the following actions - continue retrieving data, cancel retrieving data, or turn on the Paginal Mode.

To simplify data analysis, you can use the following features:

· Grouping Data in Grid
· Sorting Data in Grid
· Filtering Data in Grid
· Paginal Mode
· Card View
· Auto-search Mode
· Data Viewer and Editor

note Note

By default, Paginal Mode is enabled in data view with 1000 records per page, so only 1000 records are displayed at once.

You can change columns order and width, group by order via dragging column headers into required place. You can fit the column's width to the column content by right-clicking on an appropriate header and choosing Best Fit from shortcut menu. To adjust widths of all columns at once, choose Best Fit (all columns) instead. Note that this operation can take some time when there are many records in the grid.

To refresh data, click the Refresh command in the Data menu (for Data view), the shortcut menu, or on the toolbar. To abort too long refresh operation, click the Stop Refresh command in the Data menu (for Data view) or on the toolbar.

Grid rows' background and foreground colors can be set. You can set them separately for odd and even rows, focused row, selected rows, focused cell, group rows.

Data row can be viewed, edited and printed as cards.

You can also export data from the grid, using the Export Data button on the toolbar or selecting a corresponding option from the shortcut menu.

Tip: you can use down arrow to add an empty row to the table displayed in the grid. If you've added an empty row accidentally, you can easily delete it using the up arrow.

note Note

Null values 0000-00-00 in fields of DATE data type are displayed as 01.01.0001. Null values of TIMESTAMP fields are displayed as 01.01.0001 0:00:00.

ExpandedToggleIcon(9x12) See Also

Viewing Data in Grid

Sorting Data in Grid


Sorting Data in Grid

By default, dbForge Studio retrieves unsorted data from tables if the Retrieve Data option was used. If data was retrieved after executing an SQL statement, it will be sorted according to the operators used in this statement (in case operators are sorting-related, e. g. ORDER BY).

To sort data

To sort data in grid or to change the sort order, click the header of a column. Alternatively, right-click a column header, and then click Sort Ascending or Sort Descending on the shortcut menu.

To assign a secondary sorting, click another column header, while holding down the SHIFT key. You can set as many sorting columns as you need. To stop sorting on a certain column, click it while holding the CTRL key.

To clear column sorting, click the Clear Sorting option on the table shortcut menu.

The current sort order of a column is indicated by the sort glyph (a small arrow displayed at the column header's right edge). If data is sorted in ascending order, the sort glyph represents an up-arrow. When sorting in descending order, the sort glyph is displayed as a down-arrow. If the column isn't sorted, the sort glyph is hidden.

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

ExpandedToggleIcon(9x12) See Also

Viewing Data in Grid

Grouping Data in Grid


Grouping Data in Grid

To group data by column, click ShowGroupByBox Show Group by Box on the document toolbar. The Group by Box pane will appear above the grid. Drag a column header you want the data to be grouped by to the pane.

Alternatively, right-click the required column header and click Group By This Column on the shortcut menu. The data is automatically displayed in groups marked with collapsed nodes. The column header is moved to the Group By Box pane.

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

Group By Box is the area above the data grid where you can see the grouping order and perform further grouping-related operations. Drag a column header to Group By Box to group the data by that column. You can group the data by multiple columns. In this case the grid will display a tree of nested groups that you can expand by clicking '+' buttons. To collapse the groups, click '-' buttons.

To expand or collapse all groups at once, right-click the Group By Box pane, and then click Full Expand or Full Collapse on the shortcut menu.

To cancel grouping by column, drag-and-drop the column header from the Group By Box pane to the grid or right-click the column header, and then click Ungroup from the shortcut menu.

To remove all groupings, right-click Group By Box, and then click Clear Grouping on the shortcut menu.

ExpandedToggleIcon(9x12) See Also

Viewing Data in Grid

Filtering Data in Grid


Filtering Data in Grid

ExpandedToggleIcon(9x12) Hiding Data of a Column

1. Right-click the required column, and then click Visible Columns on the shortcut menu. The Visible Columns dialog box opens.
2. Clear the check box next to the column you want to hide in the grid.
3. Click OK to close the dialog box and apply the filter condition.

ExpandedToggleIcon(9x12) Filtering Data by Column

· On a column header, click the filer-button Filter button. Select the filter value from the drop-down list box. The box includes a set of values encountered in the column and the universal items such as All, Custom, Blanks, and Non Blanks.
· Right-click a column, and point to Quick Filter on the shortcut menu, and then click the required filtering condition.

quickfilter

When the data is filtered, the column Filter button will be changed to active-filter to indicate the applied filter. The filter condition appears at the bottom of the grid providing you a one-click quick access to the filter condition parameters. You can manage them in the following ways:

· To remove all filter conditions, click cancel-filter at the bottom of the grid. To remove the filter condition of a column, right-click this column and click Clear Filter on the shortcut menu.
· To switch from the filtered data to the full data display, clear the [image] check box at the bottom of the grid.
· To edit the filter condition, click edit-filter . The Filter Editor dialog box opens.

ExpandedToggleIcon(9x12) Applying a Custom Filter Condition to Column

1. Right-click the required column, point to Quick Filter on the shortcut menu, and then click [image]. The Filter Editor dialog box opens.
2. Choose a relation type and type values to build a filter.

filtereditor-oracle

Filter conditions in the Filter Editor dialog box are displayed as a tree with condition and group nodes. A group consists of several conditions or subgroups, united with a logical operator. To change a group logical operator, click it and select another one from the menu. To navigate between conditions and groups, use the UP ARROW and DOWN ARROW keys. To navigate between a condition column, a criteria operator and an operand value, use the LEFT ARROW and RIGHT ARROW keys.

To remove a condition, click FilterGreyDel or navigate to the condition and press the DELETE or MINUS SIGN key. To remove a group, click its logical operator and select the Remove Group from the appeared menu. You can copy, cut, and paste conditions and groups with CTRL+C, CTRL+X, and CTRL+V keys.

3. Click OK to apply the filter condition to the data in the grid.

ExpandedToggleIcon(9x12) Creating a New Filter Condition

1. Create a new group:
· Click the upper-level group operator and select Add Group from the menu.
· Press CTRL+PLUS SIGN.
2. Create a new filter condition by doing one of the following:
· Click the upper-level group operator and select Add Condition from the menu.
· Navigate to a group you want to enhance, and press INSERT or PLUS SIGN key.
· Click FilterGreyAdd of the group you want to enhance.
3. Click the condition column, and then and select the column you need from the menu.
4. Click the condition criteria operator and select the criteria operator you want to apply.
5. If the condition operator requires operand values, specify them.

ExpandedToggleIcon(9x12) See Also

Viewing Data in Grid

Server-Side and Client-Side Sorting and Filtering


Server-Side and Client-Side Sorting and Filtering

In dbForge Studio, sorting and filtering of data can be performed on the client or on the server side.

If there are not many records in a table, they are all shown in the result grid after retrieving data from a table or after executing a SELECT statement. If you want to sort these records or use a filter, the filtering and sorting procedures are performed on the client side and all available records are processed.

But if there are many records in a table, they are not displayed after executing a SELECT statement or retrieving data at once, because such action can cause hanging of the client machine or some other problems associated with too much data to operate.

The other case when not all records are displayed in the grid, is when Paginal Mode is on and there are more records then the number of records displayed on one page. In these cases, if you perform client-side sorting or filtering, only records available on the client machine are processed. That means you will not get a complete result of filtering or sorting. That's why dbForge Studio performs server-side filtering or sorting when not all records can be displayed in the grid.

When server-side filtering or sorting is performed, the application sends a query that is a modification of the starting query to the server. The shortcoming of this way is that server resources are taken, but the benefit is that a user will get a complete result of sorting or filtering.

But once all records are received, for example, after pressing CTRL+END or scrolling to the end, server-side filtering and sorting is turned off and client-side filtering and sorting is used.

ExpandedToggleIcon(9x12) See Also

Viewing Data in Grid

Paginal Mode


Paginal Mode

Paginal Mode splits data into pages and is used for displaying data with large number of records.

To enable Paginal Mode, click Paginal Mode.

To configure the number of record per a page, type or select the value from the Page Row Count drop-down list box.

To navigate through pages, use the corresponding buttons on the document toolbar.

Paginal mode toolbar buttons

By default, Paginal Mode is enabled for data views with 1000 records on a page, so only 1000 records are displayed at once. You may change default settings on the Data Editor, General tab of the Options window.

note Note

Paginal Mode can also be enabled by clicking the corresponding button on a message received when retrieving data from a table that has large number of records.

note Note

If not all records are displayed on one page when Paginal mode is on, the warning icon Caution is shown on the status bar. If you move the mouse pointer onto the icon, a notification informing that the data is split into pages will be shown.

ExpandedToggleIcon(9x12) See Also

Viewing Data in Grid

Auto-search Mode


Auto-Search Mode

Auto-search mode allows you to search column data.

To enable or disable the Auto-Search mode, do any of the following:

· Press CTRL+I keys.
· On the Data menu, click Auto-search mode.
· Click Auto-search mode on the Data Editor toolbar.

To search for the data, select a cell in a column, and type first letters of the required data. If you made a mistake when typing, press BACKSPACE and type the string again.

To navigate to the next entry, press CTRL+DOWN keys. To return to the previous entry, press CTRL+UP. The entries will be highlighted.

ExpandedToggleIcon(9x12) See Also

Viewing Data in Grid

Card View


Card View

Data Editor allows you to view, edit, and print data in the Card View mode. In the Card View mode, each data row is represented as a card with caption 'Record N' and number.

To enable the Card View mode, click the Switch to Card View button on the Data Editor toolbar. To return the grid view mode, click the Switch to the Grid View button on the Data Editor toolbar.

You can view or edit data in the same way as in the grid mode. Data cards can be expanded and collapsed with help of corresponding button on a caption.

To sort or filter data in the card mode, click the Customize button, and then click either Sort, or Filter next to a column.

To customize the column display in cards, click the Customize button and select or clear check boxes next to the required columns.

Card View

ExpandedToggleIcon(9x12) See Also

Viewing Data in Grid

Editing Data in Grid


Editing Data in Grid

This section describes how to effortlessly edit data in dbForge Studio for Oracle.

ExpandedToggleIcon(9x12) In This Section

Editing Data in Grid Overview
The topic describes how to quickly edit data using various grid editor's features.

Using Transactions
This topic explains how to use transactions in dbForge Studio for data editing. This functionality is not available in Devart Schema and Data Compare tools.

Cached Updates
This topic explains how to use cached updates mode.

Foreign Key Lookup
The topic describes the Foreign Key Lookup functionality.


Editing Data in Grid Overview

When dbForge Studio for Oracle executes any statement returning a result set, the retrieved data is displayed in the Data Editor of the data view of the same SQL document or the Object Viewer. This topic shows how to edit the data in grid; for information about customizing data grid, as well as sorting, grouping and filtering, visit Viewing Data in Grid topic.

ExpandedToggleIcon(9x12) To edit data:

1. In the Data Editor, available in the data view of an SQL document, click a cell you want to edit.
2. After editing, confirm the changes by clicking the [image] End Edit button under the grid or selecting the End Edit option from the shortcut menu.

Tip: To discard changes, click the [image] Cancel Edit button or select the Cancel Edit option from the shortcut menu.

In dbForge Studio for Oracle, you can also edit data right after retrieving it from a table or in the data view after any query was executed.

To retrieve data, select Retrieve Data from the shortcut menu of the table in the Database Explorer. To make received data editable, you can also choose the table name from the Table drop-down list on the

toolbar - MakeTableEditable, or leave it read-only by selecting (read-only).

If you choose the read-only mode, you will gain in the performance aspect, as the application will work faster in this mode.

To edit data in join query results, you should set the table you want to edit data from to the editable mode, as described above. After you set one table as editable, the data of other tables included into the result will become light-gray.

note Note

When you change the mode of any table from read-only to editable or vice versa, a balloon with the corresponding message is shown on the status bar.

note Note

To view values of CHAR and VARCHAR fields you should take into account the following points:

1. If length >= 200 is stated in the column type, buttons will be shown in the grid. Click these buttons, and the editor will be shown in a separate window.
2. If there are more than 4000 symbols in a cell, data can not be edited directly in the cell. To edit data in such cells, you should click the [...] button.

ExpandedToggleIcon(9x12) To insert, delete, copy and paste data:

Use the shortcut menu or the corresponding buttons under the grid. For example, you can do the following:

· To insert NULL (instead of empty string), select Set Value To, and then click Null from the shortcut menu. You can also use the CTRL+0 key combination.
Tip: Use Set Value To menu to quickly set an empty string, zero, or a current date.

· To add a new record, select the Append option from the shortcut menu or click the Append Append button under the grid. To delete a record from the grid, select the Delete option from the shortcut menu or click the '-' button under the grid or press CTRL+DEL keys.
· To copy and paste cell values, use the corresponding options from the shortcut menu.

ExpandedToggleIcon(9x12) To select data:

You can easily select and copy the data just like cells in a spreadsheet. Do either of these actions:

· Move the mouse pointer across the grid holding the left mouse button
· Click the first cell of the data range, press SHIFT, and, holding the SHIFT key, click the last cell. A rectangular range of cells will be selected.

Tip: Using the CTRL key, you may include and exclude cells to selection. Any number of rows may be copied and pasted to some other application, for example, a spreadsheet, but when you paste data in data grid, only the first row will be pasted.

note Note

Actual document look may slightly vary from the above image depending on the product you use.

dbForge Studio for Oracle allows you to control data editing with transactions. When working with grid-based editor, you can access the following buttons on the Connection toolbar: Begin Transaction, Commit, and Rollback.

note Note

Some queries return read only data, for example, queries with aggregate functions (count, avg etc.), or data, retrieved from non-updatable views. Such data can't be edited. It is also impossible to edit the result of executing of the script with several select statements.

ExpandedToggleIcon(9x12) Row and cell indicators

When working with grid, you can see special indicators near to the focused cell. These indicators reflect current editing state.

The row is focused.

The row is being edited.

The row has been edited.

Incorrect value was entered into a cell. You must either fix the value or press the ESCAPE key to cancel changes made to the cell.

ExpandedToggleIcon(9x12) See Also

Editing Data in Grid

Cached Updates


Using Transactions

dbForge Studio allows to control data editing with transactions. You can access the following buttons on the Connection toolbar: Begin Transaction, Commit, and Rollback.

note Note

The transactions in Oracle are applicable only for DML statements.

Click on Begin Transaction button on the Connection toolbar or select Begin Transaction from the shortcut menu of the connection to start a new transaction. Since now, all changes you make to a database object are not applied until you click Commit button on the Connection toolbar or select Commit from the shortcut menu of the connection. To revert all changes and return to the point where you have been at the moment of clicking Begin Transaction button, click on the Rollback button on the Connection toolbar or select Rollback from the shortcut menu of the connection.

Commit is automatically issued when you save documents that represent database objects.

The transaction applies to the whole connection. Notice that the Output window reports all transaction events.

ExpandedToggleIcon(9x12) See Also

Editing Data in Grid

Cached Updates


Cached Updates

Cached updates mode allows you to control data editing within single database object. For the object you have turned this mode on, updates are stored locally on the client side until you click the Apply Changes button. If you do not need the changes to be applied, click the Cancel Changes button. When you close the document in the cached updates mode, you cancel all changes made since the last Apply command.

ExpandedToggleIcon(9x12) See Also

Editing Data in Grid

Working with Data in Data Editor


Foreign Key Lookup

Foreign key lookup functionality opens table data basing on the link available in the cell. This functionality is based on foreign key relation between tables.

If you retrieve data of a table that has links based on foreign keys, you will be able to see data from the related table directly in Data Editor. The data of the parent table is shown if you click the CBDropDownArrow button of the field you want to edit. The record of the parent table this foreign key corresponds to will be highlighted, as shown on the image below:

note Note

Actual document look may slightly vary from the above image depending on the product you use.

note Note

If you are using Devart Schema Compare or Data Compare tools, this functionality is not available.

ExpandedToggleIcon(9x12) See Also

Editing Data in Grid

Data Shortcut Keys


Data Shortcut Keys

Use following shortcut key combinations when working with data in the Data Editor or data view of an SQL document.

Icon | Command Name | Shortcut Keys | Action | Where is used
AutoSearch | Auto-search mode | CTRL+I | Data auto-search mode | Data Editor
RefreshButton | Refresh | F5 | Refresh Data view | Data Editor
 |  | CTRL+HOME | Focus on first record in data grid | Data Editor
 |  | CTRL+END | Focus on last record in data grid | Data Editor
 |  | CTRL+DELETE | Delete currently selected row in data grid | Data Editor
 |  | INSERT | Insert new record in data grid | Data Editor
 |  | CTRL+0 | Insert NULL value in current cell | Data Editor

These shortcuts are default shortcuts. All shortcuts can be customized.

ExpandedToggleIcon(9x12) See Also

Working with Data in Data Editor


Exporting and Importing Data

This section describes how to use the Import and Export Wizard to import data in dbForge Studio and to export data in other formats.

ExpandedToggleIcon(9x12) In This Section

Data Export
This section describes how to export data using the Data Export wizard.

Data Import
This section describes how to import data using the Data Import wizard.


Data Export

This section describes how to export data using the Data Export wizard.

ExpandedToggleIcon(9x12) In This Section

Data Export Overview
Gives the essential information to start exporting data.

How To: Export Data
Describes how to export data.

Saving and Using Templates
Tells how to save export settings into templates and save time.

Working with Command Line
Explains how to export data using command line.


Data Export Overview

With dbForge Studio you can easily export data from one or several tables to the following file formats:

· HTML (Hyper Text Markup Language)*- a data storage format used for the web pages.
· XLS - Microsoft Excel spreadsheet.
· XLSX - Microsoft Excel 2007 spreadsheet.

note Note

If you do not have Microsoft Office installed, you need to install Open XML SDK 2.5 for Microsoft Office to use the result Microsoft Excel spreadsheet.
· RTF - Rich Text Format from Microsoft.
· JSON - an open-standard format that uses human-readable text to transmit data objects consisting of attribute-value pairs.
· XML (XML Schema Definition) - XML data representation with data contained in attributes. Contains XML schema.
· ODBC (Open Database Connectivity)* - a data storage format used to access any data from any application.
· Text - plain text format.
· MS Access - database of well-known Microsoft DBMS Access (2003, 2007+).

note Note

If you do not have Microsoft Office installed, you need to install Microsoft Access Database Engine to use the result MS Access file.
· PDF (Portable Document Format) - file format, created by Adobe Systems for document exchange. (Only Latin charset data can be exported.)
· CSV (Comma-separated values)* - another name for the comma-delimited format of data storage.
· DBF - a database filename extension (Foxpro, dBase III, dBase IV, dBase 7). Other files can also be connected with DBF files, for example: .DBT (dBase III, IV, Clipper), .FPT (FoxBASE/FoxPro). While exporting data, ANSI charset is used.
· SQL - format of the file that contains a SQL script.

note Note

* Express Edition of dbForge Studio supports export only to HTML, CSV and ODBC formats.

note Note

When using text/csv ODBC provider, on the Export Format page enter a file name with an extension in the Destination table name field, e.g., 'table.csv'.

note Note

When exporting data to MS Excel format through ODBC provider, the following export limits exist:

· for export to MS Excel 2003 format - 65536 records
· for export to MS Excel 2007 format - 1 048 576 records

Data export to MS Excel (not through ODBC provider) is limited only by available system memory.

dbForge Studio gives a simple way to export data both from Database Explorer and the grid. Using Database Explorer, you can select any table for export in seconds. Also you can compose a complex query, execute it, and then select exported data from the grid.

dbForge Studio includes the Data Export Wizard which allows you to select the following:

· columns
· data formats for each column
· rows
· additional options for each exported format

Based on your needs, you can save your selected export options into a template file for the further usage in the wizard.

dbForge Studio also includes the Export Data to SQL wizard that allows you to export data from tables to SQL.

ExpandedToggleIcon(9x12) See Also

Data Export

How To: Export Data


How To: Export Data

ExpandedToggleIcon(9x12) Export data to other formats

1. Open the Data Export wizard by doing either of these actions:
· On the Start page click DataAnalysis Data Analysis, and then click exportdata Export Data.
· In Database Explorer right click the required table or view (or CTRL+click several tables and/or views) you want to export data from and select Export Export Data from the shortcut menu.
· Right-click data grid and choose Export Data from the shortcut menu, or click the DataExport Export Data button on the Data Editor window toolbar.
· Click DataExport Export Data on the Database menu.

note Note

The appearance of the Data Export Wizard can differ depending on a product you use.

2. On the Export format page, select an export format or load export options from a template file if you saved them previously and click Next.
3. On the Source page, select a required Oracle server connection, a database, table(s), view(s), which you want to export, and then click Next.

note Note

If you opened the wizard from the data grid, the Source tab would allow to specify only a name and a path of the destination file (the one where the exported data will be saved.
4. Set additional settings for the selected export format on the Options wizard page and click Next.
5. Select exported columns and click Next. (For CSV, HTML, PDF, RTF, and Text export formats, select formats of data representation, e.g., integer, date, time, etc. For Excel and Excel 2007 formats, the field is editable only for binary columns and includes only two data types (HexString and String) in the drop-down list).
6. Select exported rows. You can export all rows, only selected in the grid ones, or a specified range.
7. Specify how the application should behave when an error is encountered.
8. (Optional) To export options to a template file for future usage, click the Save Template button and specify a path and a name of the template file.
9. Define how dbForge Studio for Oracle should handle errors during export and whether to write a log file. .
10. Click the Export button and see the result of export process.
11. Select whether to open the exported file or result folder, and click the Finish button. Data export is finished.

ExpandedToggleIcon(9x12) Filtered data export

There is a filter in the Data Export wizard window. It is not used to filter exporting tables and views but to ignore them while data exporting.

If you want to filter data, use the required column filter. To do this, firstly write a whole data query using the SELECT * FROM statement. Click the Execute button to implement the query. Then on the required column name, click the filter icon. In the drop-down list, choose the item to filter by. Right click the filtered grid, and select Export Data to call the Data Export wizard.

Another and the most reliable way to export filtered data is to filter it directly in the query. Execute the SELECT * FROM statement with the WHERE condition, where you can specify the required filter. And then implement already filtered data export with the Data Export wizard, calling it from the filtered grid shortcut menu.

Follow the Data Export wizard steps, click the Export button. If the data export is finished successfully, the Data export complete message appears.

ExpandedToggleIcon(9x12) See Also

Data Export

Saving and Using Templates During Data Export


Saving and Using Templates During Data Export

Template is a set of export settings stored in a file.

It's no use wasting your time on selecting the same settings each time you export data. Select once, save multiple settings to a file, and use it to have customized export without efforts.

For example, you need to export data from an existing table to text format once a day. You can set up the export options once, and next time all you need to do is to select the Text export format and a location of the data source and click Export. To illustrate the case, let's export data from the sales database to the sales_export.txt file, create a template, and then use it.

To create a template:

1. Click DataExport Export Data on the Database menu.


Working with Command Line

This section describes how to automate data export using command line.

note Note

The command-line interface is available only in certain editions of dbForge Studio. For detailed information on the features availability in the dbForge Studio editions, please refer to the Editions topic.

ExpandedToggleIcon(9x12) In This Section

How To: Export Data through Command Line
This topic explains how to use the command line interface to export data.

Additional /dataexport Arguments
The topic contains information on command line switches and examples of their usage.


How To: Export Data through Command Line

You can automate data export process using command line. Such possibility can be very useful if you need to export data from the same table or view quite often (for example, such data may be needed for generating a report, etc.). In this case you can create a template file using Data Export Wizard, where all export settings will be saved, and perform export by specifying the name of this file in the command line instead of going through all wizard pages. Note that some parameters like connection, destination file, and some others can be specified directly in the command line. In this case values of these parameters specified in your template file will be overridden.

To create a template file:

1. On the Database menu click DataExport Export Data to open Data Export Wizard.
2. Go through all wizard pages and specify necessary information and settings.
3. When all necessary settings were made, click the Save Template button on any of the wizard's pages.

note Note

The generated file does not contain password information for security purposes. If the Save Password option is checked for the selected connection in dbForge Studio for Oracle, you should not do anything regarding the password. If it is not, then you should define the password with the help of the /password option.

note Note

It is not necessary to click the Export button in the wizard and perform the export process itself to create a template file.

To export data through the command line:

1. Click Start.
2. Type cmd in the Search programs and files text box and press the ENTER button.

note Note

To run the Command Line in Windows 8:

From the Desktop Mode

· Move the mouse cursor to the exact lower left corner until the desktop shortcuts menu appears.
· Right-click to see the shortcut menu and than click Run

From the Charms Bar

· Move your mouse to the upper right corner until the Charms Bar appears.
· Select Apps from the list and type “run” in the search box.
· Click Run from the search results.

Use Windows + R Shortcut Keys

· In desktop mode, press the Windows key and R at the same time, to show the Run command line.
3. Type a path to the dbforgeoracle.com file, located in dbForge Studio for Oracle installation folder on your PC, and press the SPACE key:

C:\Users\user>"C:\Program Files\Devart\dbForge Studio for Oracle\dbforgeoracle.com"

note Note

It is not necessary to specify the extension of the dbforgeoracle.com file.
4. Specify the operation you want to perform (data export) and the template file:

/dataexport /templatefile:<filepath>

5. Type all other arguments you need.
6. Press ENTER to run the process.

ExpandedToggleIcon(9x12) See Also

Working with Command Line

Additional /dataexport Arguments


Additional /dataexport Arguments

This topic gives detailed description of command line switches and examples of their usage.

Arguments

To get more information on switches related to data export through the command-line interface, type:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /dataexport /?

The following table describes all switches for the option.

Parameter

Action

/connection

Use this switch to specify a connection string. Command usage looks like:

/connection:<connection_string>

/errormode

Use this switch to specify the application behavior when an error is encountered. Command usage looks like:

/errormode:<ignore | abort>

Here ignore means that all uncritical errors will be ignored, and abort means that the export process will be canceled if an error occurs.

/outputfile

Use this switch to specify a destination file, or a directory for multiple export. Command usage looks like:

/outputfile:<filepath>

note Note

The option is not available for the ODBC format.

/outputtable

Use this switch to specify a destination table name for SQL, ODBC and Access formats. Command usage looks like:

/outputtable:<tablename>

note Note

You cannot use this option to export multiple tables at once.

During export to the server, the value of the option will be generated as the table's name in INSERT queries.

For example,

INSERT INTO my_table (column1, column2, column3) VALUES (1, 2, 3)

When exporting to the SQL format, inserts will be generated to a file specified by the /singlefile parameter.

/password

Use this switch to specify a server password in order to override the one specified in the connection string or force connecting with the specified password (when the connection string is hidden into the template file). Command usage looks like:

/password:<pw>

/range

Use this switch to specify a range of exported rows. Command usage looks like:

/range all | <start:<startfrom> length:<count>>

The possible values and parameters for the switch are the following:

· all - type to export all rows
· start:<startfrom> - type to specify the number of the row to start export from
· length:<count> - type to specify the quantity of rows to export

/singlefile

Use this switch to specify all data be exported into a single file, even if there are several source tables. Available for SQL export only. Command usage looks like:

/singlefile[:true|:false]

/table

Use this switch to specify one or several source tables. Command usage looks like:

/table <tablename> [<tablename>] /singlefile[:true|:false]

/templatefile

Use this switch to specify a template file. Command usage looks like:

/templatefile:<filepath>

The entire command line used to export data may look as the following:

C:\Users\User>"C:\Program Files\Devart\dbForge Studio for Oracle\dbforgeoracle.com" /dataexport /templatefile:"c:\Users\User\Documents\dbForge Studio for Oracle\Export\sample_template.det"

ExpandedToggleIcon(9x12) See Also

Working with Command Line

How To: Export Data through Command Line


Data Import

This section describes how to import data using the Data Import wizard.

ExpandedToggleIcon(9x12) In This Section

Data Import Overview
Describes a data import process and its steps.

MS Access Import
Describes how to import data from MS Access format.

CSV Import
Describes how to import data from CSV format.

DBF Import
Describes how to import data from DBF format.

MS Excel Import
Describes how to import data from MS Excel format.

Text Import
Describes how to import data from Text format.

JSON_Import
Describes how to import data from JSON format.

XML Import
Describes how to import data from XML format.

Migrating Data from Other Servers
Describes how to migrate data from other servers.

Saving and Using Templates
Describes how to save and use import settings as templates.

Importing Data to a New Table
Describes how to quickly import data to a new table.

Working with Command Line
Describes how to import data using command line.

ExpandedToggleIcon(9x12) See Also

Exporting and Importing Data


Data Import Overview

Data import is a process of converting data stored in one format into another.

dbForge Studio automates this process and offers a wizard to guide you. You will get a correct and painless way to:

· Import data into a table from MS Access (2003, 2007+), CSV, DBF (Foxpro, dBase III, dBase IV, dBase 7), MS Excel, Text, XML formats
· Migrate data from other servers
· Customize the import

One more benefit is that you can optimize your import by saving the import settings as a template for future usage for importing data with the help of the wizard, and get a customized import immediately next time.

To import data using the Data Import wizard, you need to do simple steps:

1. Select an import format and a file with the data that you want to import.
2. Select a destination table.
3. Adjust data formats for the Source data.
4. Set additional options to customize the import.
5. Set a correspondence between the Source file content and columns of the Target table.
6. Select a data processing mode, e.g., whether to add the records to the Target table or update the existing ones, or both.
7. Define how dbForge Studio should handle errors during import and whether to write a log file.

ExpandedToggleIcon(9x12) See Also

Data Import

MS Access Import


MS Access Import

This topic describes how to import data from a MS Access (2003, 2007+) file.

1. Decide what table to import the data to:

For a new table:

· On the Database menu, click Import Data.. The Data Import wizard opens.

For an existing table:

· Right-click a table in the Database Explorer and select Import Data from the shortcut menu. The Data Import wizard opens with predefined parameters: a Oracle connection, a database, and a table to import the data to.
· Alternatively, on the Database menu click Import Data, and select a required table on the Destination table wizard page.
2. Select MS Access import format and specify a location of Source file. Click Next.

If the Source data is protected with a password, the Open MS Access database dialog box appears where you should enter the password.

note Note

Data Import Wizard pages can slightly differ due to the product you have been using.

3. Select a Source table or view. To quickly find them in the list, enter characters of a required name into the Filter field. The list will be filtered to show only those that contain such characters in their names.

You can use a query for partial data import. Click Custom Query and edit the query. Click OK to save the changes.

4. Specify a Target Oracle connection, a database, a schema, and a table to import the data to. If you selected a table in Database Explorer before opening the Data Import wizard, the wizard will open with the predefined connection parameters of the selected table. To create or edit Oracle connections, click the corresponding buttons. Click Next.
5. Specify data formats for the Source data and click Next.
6. Map the Source columns to the Target ones. If you are importing the data into a new table, dbForge Studio will automatically create and map all the columns. If you are importing into an existing table, only columns with the same names will be mapped, the rest should be mapped manually. (If no columns with the same name are found, they are mapped in succession - the 1st column in Source with the 1st column in Target, etc.)

See the Target columns in the top and the Source columns at the bottom of the wizard page. Click Source column fields and select required columns from the drop-down list.

note Note

To cancel mapping of all the columns, click Clear Mappings on the toolbar. To restore it, click Fill Mapping.
7. If you are importing to a new table, you can edit the Target column properties by double-clicking them in the top grid. Select the Key check box for a column with a primary Key and click Next.

note Note

You should select at least one column with a primary key, otherwise some of import modes on the Modes wizard page will be disabled.
8. Select an import mode to define how dbForge Studio should import the data. Click Next.
9. Select how dbForge Studio should handle errors during import and whether you want to get a log file with details about the import session.
10. Click Import and see the import progress. dbForge Studio will notify you whether the import completed successfully or failed. Click the Show log file button to open the log file.
11. Click Finish to finish the import and close the wizard.

note Note

You can save the import settings as a template for future uses. Click the Save Template button on any wizard page to save the selected settings. Next time you should only select a template and specify a location of the Source data - all the settings will be already set. For more information, go to Saving and Using Templates topic.

ExpandedToggleIcon(9x12) See Also

Data Import

CSV Import


CSV Import

This topic describes how to import data from a CSV file.

note Note

Data Import Wizard pages can slightly differ due to the product you have been using.

1. Decide what table to import the data to:

For a new table:

· On the Database menu, click Import Data. The Data Import wizard opens.

For an existing table:

· Right-click a table in the Database Explorer and select Import Data from the shortcut menu. The Data Import wizard opens with predefined parameters: a Oracle connection, a database, and a table to import the data to.
· Alternatively, on the Database menu click Import Data, and select a required table on the Destination table wizard page.
2. Select CSV import format and specify a location of Source data. Click Next.
3. Specify a Oracle connection, a database, a schema and a table to import the data to. If you selected a table in Database Explorer before opening the Data Import wizard, the wizard will open with the predefined connection parameters of the selected table. To create or edit Oracle connections, click the corresponding buttons. Click Next.
4. Preview the Source data and specify additional options to customize the import:
· Set a quantity of lines to skip during the import. Lines are counted from the top.
· Select the line number where the table header is located. It will be highlighted with blue in the Preview section. If you don't specify the header position, the imported columns will get default names - column1, column2, etc.
· Specify a column delimiter. See the result in the Preview section.

Click Next.

5. Specify data formats for the Source data and click Next.
6. Map the Source columns to the Target ones. If you are importing the data into a new table, dbForge Studio will automatically create and map all the columns. If you are importing into an existing table, only columns with the same names will be mapped, the rest should be mapped manually. (If no columns with the same name are found, they are mapped in succession - the 1st column in Source with the 1st column in Target, etc.)

See the Target columns in the top and the Source columns at the bottom of the wizard page. Click Source column fields and select required columns from the drop-down list. (For more information about mapping, go to Mapping, Data Import Wizard topic.)

note Note

To cancel mapping of all the columns, click Clear Mappings on the toolbar. To restore it, click Fill Mapping.

7. If you are importing to a new table, you can edit the Target column properties by double-clicking them in the top grid. Select the Key check box for a column with a primarykKey and click Next.

note Note

You should select at least one column with a primary key, otherwise some of import modes on the Modes wizard page will be disabled.
8. Select an import mode to define how dbForge Studio should import the data. Click Next.
9. Select how dbForge Studio should handle errors during import and whether you want to get a log file with details about the import session.
10. Click Import and see the import progress. dbForge Studio will notify you whether the import completed successfully or failed. Click the Show log file button to open the log file.
11. Click Finish to finish the import and close the wizard.

note Note

You can save the import settings as a template for future uses. Click the Save Template button on any wizard page to save the selected settings. Next time you should only select a template and specify a location of the Source data - all the settings will be already set. For more information, go to Saving and Using Templates topic.

ExpandedToggleIcon(9x12) See Also

Data Import

DBF Import


DBF Import

This topic describes how to import data from a DBF file.

note Note

Data Import Wizard pages can slightly differ due to the product you have been using.

1. Decide what table to import the data to:

For a new table:

· On the Database menu, click Import Data. The Data Import wizard opens.

For an existing table:

· Right-click a table in the Database Explorer and select Import Data from the shortcut menu. The Data Import wizard opens with predefined parameters: a Oracle connection, a database, and a table to import the data to.
· Alternatively, on the Database menu click Import Data, and select a required table on the Destination table wizard page.
2. Select DBF import format and specify a location of Source data. Click Next.
3. Specify a Oracle connection, a database, and a table to import the data to. If you selected a table in Database Explorer before opening the Data Import wizard, the wizard will open with the predefined connection parameters of the selected table. To create or edit Oracle connections, click the corresponding buttons. Click Next.
4. Preview the Source data and specify additional options to customize the import:
· Check that the file encoding is set correctly.
· Check Read deleted records to import rows marked as deleted in Source.

Click Next.

5. Specify data formats for the Source data and click Next.
6. Map the Source columns to the Target ones. If you are importing the data into a new table, dbForge Studio will automatically create and map all the columns. If you are importing into an existing table, only columns with the same names will be mapped, the rest should be mapped manually. (If no columns with the same name are found, they are mapped in succession - the 1st column in Source with the 1st column in Target, etc.)

See the Target columns in the top and the Source columns at the bottom of the wizard page. Click Source column fields and select required columns from the drop-down list.

note Note

To cancel mapping of all the columns, click Clear Mappings on the toolbar. To restore it, click Fill Mapping.
7. If you are importing to a new table, you can edit the Target column properties by double-clicking them in the top grid. Select the Key check box for a column with a primary key and click Next.

note Note

You should select at least one column with a primary key, otherwise some of import modes on the Modes wizard page will be disabled.
8. Select an import mode to define how dbForge Studio should import the data. Click Next.
9. Select how dbForge Studio should handle errors during import and whether you want to get a log file with details about the import session.
10. Click Import and see the import progress. dbForge Studio will notify you whether the import completed successfully or failed. Click the Show log file button to open the log file.
11. Click Finish to finish the import and close the wizard.

note Note

You can save the import settings as a template for future uses. Click the Save Template button on any wizard page to save the selected settings. Next time you should only select a template and specify a location of the Source data - all the settings will be already set. For more information, go to Saving and Using Templates topic.

ExpandedToggleIcon(9x12) See Also

Data Import

MS Excel Import


MS Excel Import

This topic describes how to import data from a MS Excel file.

note Note

Data Import Wizard pages can slightly differ due to the product you have been using.

1. Decide what table to import the data to:

For a new table:

· On the Database menu, click Import Data. The Data Import wizard opens.

For an existing table:

· Right-click a table in Database Explorer and select Import Data from the shortcut menu. The Data Import wizard opens with predefined parameters: a Oracle connection, a database, and a table to import the data to.
· Alternatively, on the Database menu click Import Data, and select a required table on the Destination table wizard page.
2. Select Excel (for Excel 97-2003) or Excel 2007 import format and specify a location of Source data. Click Next.
3. Specify a Oracle connection, a database, a schema and a table to import the data to. If you selected a table in Database Explorer before opening the Data Import wizard, the wizard will open with the predefined connection parameters of the selected table. To create or edit Oracle connections, click the corresponding buttons. Click Next.
4. Preview the Source data and specify additional options to customize the import:
· If the source data is located on several sheets, specify which of them to choose for the import.
· Specify the data range to import. You can see it highlighted with green in the Preview section. If you want to import the data partially, clear the Detect a range automatically check box and enter Start Cell and End Cell values or click the [image] button next to these fields and double-click a cell in the Preview grid. The specified range will be highlighted with green, skipped lines will be highlighted with white.
· Select to import the data either in rows or in columns.
· Specify the header position if required. It will be highlighted with blue in the Preview section. If you don't specify the header position, the imported columns will get default names - column1, column2, etc.

Click Next.

5. Specify data formats for the Source data and click Next.
6. Map the Source columns to the Target ones. If you are importing the data into a new table, dbForge Studio will automatically create and map all the columns. If you are importing into an existing table, only columns with the same names will be mapped, the rest should be mapped manually. (If no columns with the same name are found, they are mapped in succession - the 1st column in Source with the 1st column in Target, etc.)

See the Target columns in the top and the Source columns at the bottom of the wizard page. Click Source column fields and select required columns from the drop-down list.

note Note

To cancel mapping of all the columns, click Clear Mappings on the toolbar. To restore it, click Fill Mapping.
7. If you are importing to a new table, you can edit the Target column properties by double-clicking them in the top grid. Select the Key check box for a column with a primary key and click Next. Note you should select at least one column with a primary key, otherwise some of import modes on the Modes wizard page will be disabled.
8. Select the import mode to define how dbForge Studio should import the data. Click Next.
9. On the Errors handling wizard page, select how dbForge Studio should handle errors during import and whether you want to get a log file with details about the import session.
10. Click Import and see the import progress. dbForge Studio will notify you whether the import completed successfully or failed. Click the Show log file button to open the log file.
11. Click Finish to finish the import and close the wizard.

note Note

You can save the import settings as a template for future uses. Click the Save Template button on any wizard page to save the selected settings. Next time you should only select a template and specify a location of the Source data - all the settings will be already set.

ExpandedToggleIcon(9x12) See Also

Data Import

Text Import


Text Import

This topic describes how to import data from a TXT file.

note Note

Data Import Wizard pages can slightly differ due to the product you have been using.

1. Decide what table to import the data to:

For a new table:

· On the Database menu, click Import Data. The Data Import wizard opens.

For an existing table:

· Right-click a table in the Database Explorer and select Import Data from the shortcut menu. The Data Import wizard opens with predefined parameters: a Oracle connection, a database, and a table to import the data to.
· Alternatively, on the Database menu click Import Data, and select a required table on the Destination table wizard page.
2. Select Text import format and specify a location of Source data. Click Next.
3. Specify a Oracle connection, a database, a schema and a table to import the data to. If you selected a table in Database Explorer before opening the Data Import wizard, the wizard will open with the predefined connection parameters of the selected table. To create or edit Oracleconnections, click the corresponding buttons. Click Next.
4. Select how you want to split the Source data into columns:
· Manual - for manual splitting. In the Preview section double-click desired positions to set column ranges. The markers will appear. You can move them forward or backward to change the columns length. To remove the markers, double-click them.
· Fixed width - to split into columns with fixed width. Specify a width value and see how the Source columns are splitted in the Preview section.
· Delimiter - requires you to specify a column delimiter. See the result in the Preview section.

5. Specify additional options to customize the import. (For more information, refer to the Text Options, Data Import Wizard topic.) Click Next.
6. Specify data formats for the Source data and click Next.
7. Map the Source columns to the Target ones. If you are importing the data into a new table, dbForge Studio will automatically create and map all the columns. If you are importing into an existing table, only columns with the same names will be mapped, the rest should be mapped manually. (If no columns with the same name are found, they are mapped in succession - the 1st column in Source with the 1st column in Target, etc.)

See the Target columns in the top and the Source columns at the bottom of the wizard page. To change automatic mapping, do the following:

· (for columns splitted with a delimiter) Click Source column fields in the top grid and select required columns from the drop-down list.
· (for columns with fixed width or manual splitting) Select a Target column in the top grid and click the Unmap button. To map it to a Source column, click a required one in the bottom grid and click the Map button. The length and starting position values of the Source column will appear in the corresponding fields in the top grid. If required, you can change these values manually. (For more information about mapping, go to Mapping for Text Data, Data Import Wizard topic.)

note Note

To cancel mapping of all the columns, click Clear Mappings on the toolbar. To restore it, click Fill Mapping.
8. If you are importing to a new table, you can edit the Target column properties by double-clicking them in the top grid. Select the Key check box for a column with a primary key and click Next. Note you should select at least one column with a primary key, otherwise some of import modes on the Modes wizard page will be disabled.
9. Select an import mode to define how dbForge Studio should import the data. Click Next.
10. Select how dbForge Studio should handle errors during import and whether you want to get a log file with details about the import session.
11. Click Import and see the import progress. dbForge Studio will notify you whether the import completed successfully or failed. Click the Show log file button to open the log file.
12. Click Finish to finish the import and close the wizard.

note Note

You can save the import settings as a template for future uses. Click the Save Template button on any wizard page to save the selected settings. Next time you should only select a template and specify a location of the Source data - all the settings will be already set. For more information, go to Saving and Using Templates topic.

ExpandedToggleIcon(9x12) See Also

Data Import

JSON Import


XML Import

This topic describes how to import data from an XML file.

note Note

Data Import Wizard pages can slightly differ due to the product you have been using.

1. Decide what table to import the data to:

For a new table:

· On the Database menu, click Import Data. The Data Import wizard opens.

For an existing table:

· Right-click a table in Database Explorer and select Import Data from the shortcut menu. The Data Import wizard opens with predefined parameters: a Oracle connection, a database, and a table to import the data to.
· Alternatively, on the Database menu click Import Data, and select a required table on the Destination table wizard page.
2. Select XML import format and specify a location of Source data. Click Next.
3. Specify a Oracle connection, a database, a schema and a table to import the data to. If you selected a table in Database Explorer before opening the Data Import wizard, the wizard will open with the predefined connection parameters of the selected table. To create or edit Oracleconnections, click the corresponding buttons. Click Next.
4. Preview the Source data and specify additional options to customize the import:
· Check that the Source encoding is set correctly.
· Select from the drop-down list a tag that identifies a table row in the Source data.
· Select Consider tag attributes as table fields, if required.

Click Next.

5. Specify data formats for the Source data and click Next.
6. Map the Source columns to the Target ones. If you are importing the data into a new table, dbForge Studio will automatically create and map all the columns. If you are importing into an existing table, only columns with the same names will be mapped, the rest should be mapped manually. (If no columns with the same name are found, they are mapped in succession - the 1st column in Source with the 1st column in Target, etc.)

See the Target columns in the top and the Source columns at the bottom of the wizard page. Click Source column fields and select required columns from the drop-down list.

note Note

To cancel mapping of all the columns, click Clear Mappings on the toolbar. To restore it, click Fill Mapping.
7. If you are importing to a new table, you can edit the Target column properties by double-clicking them in the top grid. Select the Key check box for a column with a primary key and click Next. Note you should select at least one column with a primary key, otherwise some of import modes on the Modes wizard page will be disabled.
8. Select an import mode to define how dbForge Studio should import the data. Click Next.
9. Select how dbForge Studio should handle errors during import and whether you want to get a log file with details about the import session.
10. Click Import and see the import progress. dbForge Studio will notify you whether the import completed successfully or failed. Click the Show log file button to open the log file.
11. Click Finish to finish the import and close the wizard.

note Note

You can save the import settings as a template for future uses. Click the Save Template button on any wizard page to save the selected settings. Next time you should only select a template and specify a location of the Source data - all the settings will be already set. For more information, go to Saving and Using Templates topic.

ExpandedToggleIcon(9x12) See Also

Data Import

Migrating Data from Other Servers


Migrating Data from Other Servers

note Note

Data Import Wizard pages can slightly differ due to the product you have been using.

1. Decide what table to import the data to:

For a new table:

· On the Database menu, click Import Data. The Data Import wizard opens.

For an existing table:

· Right-click a table in the Database Explorer and select Import Data from the shortcut menu. The Data Import wizard opens with predefined parameters: a Oracle connection, a database, and a table to import the data to.
· Alternatively, on the Database menu, click Import Data., and select a required table on the Destination table wizard page.
2. Select ODBC import format and click Next.
3. Specify ODBC data provider options for import: select a system or a user data source name from the drop-down list or specify a connection string by clicking Build and selecting a required data source. Enter a user name and a password if the selected data source requires them. Click Next.
4. Select a Source table or view. To quickly find them in the list, enter characters of a required name into the Filter field. The list will be filtered to show only those that contain such characters in their names. You can use a query for a partial data import. Click the Custom Query button and edit the query. Click OK to save the changes.
5. Specify a Oracle connection, a database, a schema and a table to import the data to. If you selected a table in Database Explorer before opening the Data Import wizard, the wizard will open with the predefined connection parameters of the selected table. To create or edit Oracle connections, click the corresponding buttons. Click Next.
6. Specify data formats for the Source data and click Next.
7. Map the Source columns to the Target ones. If you are importing the data into a new table, dbForge Studio will automatically create and map all the columns. If you are importing into an existing table, only columns with the same names will be mapped, the rest should be mapped manually. (If no columns with the same name are found, they are mapped in succession - the 1st column in Source with the 1st column in Target, etc.)

See the Target columns in the top and the Source columns at the bottom of the wizard page. Click Source column fields and select required columns from the drop-down list. (For more information about mapping, go to Mapping, Data Import Wizard topic.)

note Note

To cancel mapping of all the columns, click Clear Mappings on the toolbar. To restore it, click Fill Mapping.
8. If you are importing to a new table, you can edit the Target column properties by double-clicking them in the top grid. Select the Key check box for a column with a primary key and click Next. Note you should select at least one column with a primary key, otherwise some of import modes on the Modes wizard page will be disabled.
9. Select an import mode to define how dbForge Studio should import the data. Click Next.
10. Select how dbForge Studio should handle errors during import and whether you want to get a log file with details about the import session.
11. Click Import and see the import progress. dbForge Studio will notify you whether the import completed successfully or failed. Click the Show log file button to open the log file.
12. Click Finish to finish the import and close the wizard.

note Note

You can save the import settings as a template for future uses. Click the Save Template button on any wizard page to save the selected settings. Next time you should only select a template and specify a location of the Source data - all the settings will be already set. For more information, go to Saving and Using Templates topic.

ExpandedToggleIcon(9x12) See Also

Data Import

Saving and Using Templates


Saving and Using Templates During Import

A template is a set of import settings stored in a file.

It's no use wasting your time on selecting the same settings each time you import data. Select once, save multiple settings to a file, and use it to have customized import without efforts.

For example, you need to import data stored in text format into an existing table once a day. You can set up the import options once, and next time all you need to do is to select Text import format and a location of Source data and click Import. To illustrate the case, let's import .txt Source file to an existing table create a template, and then use it.

Creating Template

1. Open the Data Import wizard, and select Text import format and a path to .txt Source file.
2. Move to the Destination table wizard page, and select a Target Oracle connection and a database. Select Existing table and in the drop-down list select the table.
3. On the Options wizard page in the Skip lines field, enter 3 to start importing the Source data from the 4th line. As there is a header in the Source with column names, let's specify its position, otherwise the imported columns will get default names - column1, column2. Enter 2 in the corresponding field. Select to import only even lines and Fixed width type of splitting for the Source data.

4. On the Mapping wizard page, you can see that dbForge Studio has mapped all the Source and Target columns, as all of them have the same names.
6. One more thing is left. Let's set Universal sortable date\time format for the Source data. On the Data formats wizard page, let's clear the Autodetect Date and Time format check box and select the format from the drop-down list.
7. Everything is appropriate, so click Import to start importing the data.
8. Click the Save Template at the bottom and specify a name and a location of a template file in the Save As dialog. Let's call it _txt_template. This template will appear in the User templates section.

Loading Template:

1. Click _txt_template, which was created following the aforementioned steps, in the Templates section on the first page of the Data Import wizard.
2. Select Text import format and a location of Source data.
3. On the Destination table wizard page, select the Target connection and database. Select Existing table and in the drop-down list select the table.
4. Move to the Options wizard page and see the Skip lines and Header position fields and Fixed width splitting type already selected. The same happens with mapping and a date\time format on the other wizard pages.

ExpandedToggleIcon(9x12) See Also

Data Import

Importing Data to a New Table


Importing Data to a New Table
1. On the Database menu, click Import Data. The Data Import wizard opens.
2. Select a required import format and specify a location of Source data. Click Next.
3. Specify a Target Oracle connection and a database, select New table, and enter a name of a table to import the data to. To create or edit Oracle server connections, click the corresponding buttons. Click Next.
4. Specify additional options to customize the import. Click Next.
5. Specify data formats for the Source data and click Next.
6. dbForge Studio will automatically create and map all the columns in a Target database to the Source columns. See the Target columns in the top and the Source columns at the bottom of the wizard page. To remap columns, click Source column fields and select required columns from the drop-down list.

note Note

To cancel mapping of all the columns, click Clear Mappings on the toolbar. To restore it, click Fill Mapping.
7. You can edit the Target column properties by double-clicking them in the top grid. Select the Key check box for a column with a primary key and click Next.
8. Select how dbForge Studio should handle errors during import and whether you want to get a log file with details about the import session.
9. Click Import and see the import progress. dbForge Studio will notify you whether the import completed successfully or failed. Click the Show log file button to open the log file.
10. Click Finish to finish the import and close the wizard.

note Note

You can save the import settings as a template for future uses. Click the Save Template button on any wizard page to save the selected settings. Next time you should only select a template and specify a location of the Source data - all the settings will be already set.

ExpandedToggleIcon(9x12) See Also

Data Import

Migrating Data from Other Servers


Working with Command Line

This section describes how to automate data import using command line.

note Note

The command-line interface is available only in certain editions of dbForge Studio. For detailed information on the features availability in the dbForge Studio editions, please refer to the Editions topic.

ExpandedToggleIcon(9x12) In This Section

How To: Import Data through Command Line
This topic explains how to use the command line interface to import data.

Additional /dataimport Arguments
The topic contains information on command line switches and examples of their usage.


How To: Import Data through Command Line

You can automate data import process using command line. Such possibility can be very useful if you need to import data to the same table or view quite often. In this case you can create a template file using Data Import Wizard, where all import settings will be saved, and perform import by specifying the name of this file in the command line instead of going through all wizard pages. Note that some parameters like connection, input file, and some others can be specified directly in the command line. In this case values of these parameters specified in your template file will be overridden.

note Note

You cannot import data into a new table using command line.

To create a template file:

1. On the Database menu, click DataImportIcon Export Data to open the Data Import Wizard.
2. Go through all wizard pages and specify necessary information and settings.
3. When all necessary settings were made, click the Save Template button on any of the wizard's pages.

note Note

The generated file does not contain password information for security purposes. If the Save Password option is checked for the selected connection in dbForge Studio for Oracle, you should not do anything regarding the password. If it is not, then you should define the password with the help of the /password option.

note Note

It is not necessary to click the Import button in the wizard and perform the import process itself to create a template file.

To import data through command lone:

1. To open Command Prompt, press Win+R and type cmd in the Open line.
2. Type a path to the dbforgeoracle.com file, located in dbForge Studio for Oracle installation folder on your PC, and press the SPACE key:

C:\Users\user>"C:\Program Files\Devart\dbForge Studio for Oracle\dbforgeoracle.com"

note Note

It is not necessary to specify the extension of the dbforgeoracle.com file.
3. Specify the operation you want to perform (data import) and the template file:

/dataimport /templatefile:<filepath>

4. Type all other arguments you need.
5. Press ENTER to run the process.

ExpandedToggleIcon(9x12) See Also

Data Import

Additional /dataimport Arguments


Additonal /dataimport Arguments

Additional /dataimport Arguments

This topic gives detailed description of command line switches and examples of their usage.

Arguments

To get more information on switches related to data import through the command-line interface, type:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /dataimport /?

The following table describes all switches for the option.

Parameter

Action

/connection

Use this switch to specify a connection. Command usage looks like:

/connection:<connection_string>

/errormode

Use this switch to define the application behavior when an error is encountered. Command usage looks like:

/errormode:<ignore|abort>

Here ignore means that all uncritical errors will be ignored, and abort means that the export process will be canceled if an error occurs.

/inputfile

Use this switch to specify a destination file, or a directory for multiple export. Command usage looks like:

/inputfile:<filepath>

note Note

The option is not available for the ODBC format.

/inputtable

Use this switch to specify the table you want to import data from. Command usage looks like:

/inputtable:<tablename>

note Note

The option is only available for ODBC and Access formats,

/password

Use this switch to set a server password in order to override the one specified in the connection string or force connecting with the specified password (when the connection string is hidden into the template file). Command usage looks like:

/password:<pw>

/table

Use this switch to specify a target table (i.e. the table where you want to insert the imported data). Command usage looks like:

/table:<tablename>

/templatefile

Use this switch to specify a template file. Command usage looks like:

/templatefile:<filepath>

The entire command line used to import data may look like as following:

C:\Users\user>"C:\Program Files\Devart\dbForge Studio for Oracle\dbforgeoracle.com" /dataimport /templatefile:"c:\Users\User\Documents\dbForge Studio for Oracle\Import\sample_template.dit"

ExpandedToggleIcon(9x12) See Also

Data Import

Working with Command Line


Data Analysis

ExpandedToggleIcon(9x12) In This Section

Working with Pivot Table
This section describes how to create pivot tables and efficiently analyze data using pivot tables.

Viewing Data in Master-Detail Tables
This topic describes how to view data in Master-Detail tables.


Working with Pivot Table

This section describes how to create pivot tables and efficiently analyze data using pivot tables.

ExpandedToggleIcon(9x12) In This Section

What is Pivot Table?
Explains nuts and bolts of a pivot table and lists the benefits.

How To: Create a Pivot Table
Tells how to transform data into a pivot table and use data analysis features.

How To: Create a Chart in Pivot Table
Tells how to create a chart basing on pivot table data.

Managing a Pivot Table
Explains how you can manage data in a pivot table.

Pivot Table Components
Describes the components of a pivot grid and how to use them.

ExpandedToggleIcon(9x12) See Also

Data Analysis

Viewing Data in Master-Detail Tables


What is Pivot Table?

Data analysis is not always a snap. You can look at the same data from different angles and only some of them can bring valuable information. When dealing with data, one often beats his brains with grouping, sorting, or doing anything else to get required results and grasp the whole picture. Pivot Table is designed exactly to end these miseries and enable you to fisk any obscure data with several mouse clicks. It's possible to be a data-management guru with Pivot Table.

Pivot Table is a tool that converts large amounts of data into compact and informative summaries - pivot tables. You can rearrange (or pivot) your data by a simple drag of a mouse until you get the layout best for understanding the data relations and dependencies.

ExpandedToggleIcon(9x12) Pivot Table in Use

Let's take the Human Resources (HR) schema, retrieve some data for analysis, and create a pivot table to see its benefits.

note Note

As the original HR database contains a huge number of table records, they were cut down to half to illustrate the example.

Suppose we need to find out the salary volume of each employee from all departments sorted by regions. The main data is stored in the Employees table, other tables are required to get full names of film categories and film titles.

To get required data from the tables, you should select the following fields and build a query using Query Builder:

· JOB_TITLE from the JOBS table
· EMPLOYEE_ID, JOB_ID, SALARY, COMMISSION_PCT, MANAGER_ID, DEPARTMENT_ID from the EMPLOYEES table
· DEPARTMENT_NAME and LOCATION_ID from the DEPARTMENTS table
· CITY, STATE_RPOVINCE and COUNTRY_ID from the LOCATIONS table
· COUNTRY_NAME from the COUNTRIES table
· REGION_NAME from the REGIONS table

This is what you should have received after executing the query. The usual grid will display the data the same way.

As you see, the data is large and can hardly be analyzed. Let's see how data can be displayed in a pivot table. To create a pivot table, you need to open the Pivot Table view of the SQL document and drag the required fields from the Data Source window (which opens automatically with the list of fields specified in the query) into required areas in a pivot table. The Pivot Table view contains the pivot table areas, so it's easy to understand how the dragged fields will be displayed.

Now, following the tips, let's drag salary into the Data area, and region, country, city, department, job and employee name name to the Row area.

note Note

Pivot Grid automatically decomposes any fields of date or time type, so you can see payment date field decomposed into year, month, and day fields.

Now you have the following neat summaries:

· Salary for each employee
· Total salary in each department
· Total salary in each region
· Grand Total salary value

ExpandedToggleIcon(9x12) See Also

Working with Pivot Table

How To: Create a Pivot Table


How To: Create a Pivot Table

This topic describes how to create pivot tables and efficiently analyze data using pivot tables.

ExpandedToggleIcon(9x12) Pivot Table

Pivot table is a table that allows you to easily rearrange or pivot your data by a simple drag of a mouse until you get the layout best for understanding the data relations and dependencies. You can create pivot tables using Pivot Table view of the SQL document.

Some facts about a pivot table creation:

· You should connect a pivot table to the data you want to display and rearrange in the pivot table. The data source can be a query in the SQL or query document.
· Not all the data source tables are good for converting into a pivot table. The data source should contain a column with duplicated values, which can be grouped, and a column with numeric data, which can be used to calculate grand totals and custom totals.
· You should place data source fields from the Data Source view into pivot table areas to add the data to the pivot table.

ExpandedToggleIcon(9x12) Creating Pivot Table

Let's take the Order Entry (OE) schema to create a pivot table to analyze yearly and monthly profit gross from online and direct orders.

1. In Database Explorer, right-click the ORDERS table, point to Send To, and then click Pivot Table.

note Note

In this eample, only one table was used. If you need to create a pivot table based on several tables, see What is Pivot Table?

The Pivot Table document with pivot table template, and Data Source view with the table fields (when dealing with pivot tables, data source columns are referred to as fields) open.

note Note

Any field with date or time data format is decomposed in the Data Source view to its components.

In this case, the ORDER_DATE field is decomposed into four fields: year, month, day, and master field. The latter allows you to add the three order date sub-fields to a pivot table at once.

3. Let's think how to efficiently place the selected fields in the pivot table:
· Since we would like to range orders made online from the ones made directly, we put ORDER_MODE to row field.
· The ORDER_TOTAL field has numeric data, so it is reasonable to place it into data area where grand totals and custom totals can be calculated.
· If date fields are displayed as column fields, i.e., horizontally in the pivot table, we will be able to group gross figures by payment day, month, and year.

To add fields to the pivot table, drag-and-drop them from the Data Source view to a required pivot table area or highlight a field in the Data Source view, select a required area from the Destination area drop-down list and click the Add To button or just press ENTER.

To add two or more fields to the same pivot table area, add the first field and then drop the second one before or after the first field in the area.

4. Now our pivot table looks in the following way:
· order mode as row fields (1)
· gross date (Year) and (Month) as column fields (2)
· gross amount as data field (3)
· custom totals and grand totals that are automatically calculated for the added fields

The month details for each year may be hidden by collapsing the category name nodes to define the most profitable year. To sort the values in the fields, click the [image] Sort button. You can also filter data, for example, to display data only for the year 1999, click FilterGridButton in the ORDER_DATE (Year) field and clear all values, except the 1999.

5. If required, you can apply conditional styles to the pivot table to better process the data. For example, you may need to quickly see what months of a year were the most profitable.
· Click the [image] Conditional Styles button on the Pivot Table toolbar or right-click the pivot table header and select Conditional Styles from the menu. In the opened dialog, click the button to add a new condition.
· Select payment amount in the list of fields, Greater or Equal in the Condition field, enter 0 in the Value1 field. In the Apply to section clear all the check boxes except the Cell check box. In the Appearance section click the BackColor field and select the LightCyan color to highlight the cells.

See the result in the pivot table.

ExpandedToggleIcon(9x12) See Also

Working with Pivot Table

How To: Create a Chart in Pivot Table


How To: Create a Chart in Pivot Table

In dbForge Studio, you can view pivot data as a chart. Such an option helps to visualize data dependencies and compare it.

You can view a chart associated with the needed pivot data directly in the pivot table document, in a special view.

Let's build a chart basing on the data of the pivot table created in the How To: Create a Pivot Table topic.

1. Open the Charts view of the pivot table document by clicking the ShowChart-PivotTable Show Chart button on the pivot table document toolbar.
2. Select the data that should be displayed on the chart on the Pivot Table view of the document by pressing Ctrl and clicking the needed cells of the pivot table or by selecting the cells of the table with the left mouse button pressed:

3. Adjust the Chart options using the Chart view toolbar, shortcut menu, or ChartDesigner Chart Designer.

ExpandedToggleIcon(9x12) See Also

Working with Pivot Table

Managing a Pivot Table


Managing a Pivot Table

Learn how to efficiently manage the pivot table data in this section.

ExpandedToggleIcon(9x12) In This Section

Reordering Fields
Tells how to rearrange fields in a pivot table.

Filtering Fields
Tells how to filter fields in a pivot table.

Sorting Fields
Tells how to sort fields in a pivot table.

Grouping Fields
Tells how to group fields in a pivot table.

Using Summary Functions to Calculate Custom Totals
Tells how to apply summary calculation functions.

Applying Conditional Styles
Tells how to change a pivot table appearance using conditional styles.

Printing
Tells how to print a pivot table.

ExpandedToggleIcon(9x12) See Also

Working with Pivot Table

Pivot Table Components


Reordering Fields

Reordering fields is the key point in finding the best table layout to understand data dependencies, make the conclusions, and use them to your benefit.

A pivot table is the very place where you can change the location of any field with a single drag of a mouse. Drag-and-drop a field from one area to another to rearrange their data.

You can easily swap row and column fields to display row field values in columns and column field values in rows. Compare the two screenshots.

If there are two or more fields in one section, you can use Order options from the right-click to reorder the fields within the area.

ExpandedToggleIcon(9x12) See Also

Managing a Pivot Table

Filtering Fields


Filtering Fields

You can use various types of filtering to display only required data in a pivot table.

To filter values of any field, click the [image] Filter button on the field header and in the opened dialog box select only required values that you want to display. The Filter button will be highlighted with purple and the data will be filtered according to the selected criteria.

For example, to filter payment amount values to display only those that were made in 2005, you should click the Filter button on the header of the payment date (Year) field and uncheck 2006 in the dialog box.

You can add a filter field to filter the whole data in the pivot table. Drag-and-drop a required field from the Data Source view to the filter area in the pivot table. In the picture below the film rating film was added to filter the list of films by their rating.

Also you can use the PivotGrid Prefilter dialog box to apply advanced filtering conditions to filter the data. To open the dialog box, click the [image] Prefilter icon on the toolbar or right-clock the pivot table header and select Prefilter from the menu.

To create a filtering condition in the Prefilter dialog box, do the following:

1. Click the FilterGreyAdd button to add a new condition.
2. Click the field name and select a required one from the drop-down list.
3. Click the condition criteria operator (displayed using the green font color) and select a required one from the drop-down list.

4. To add more conditions to this group, click the FilterGreyAdd button again and specify the condition properties. To remove a condition, click the FilterGreyDel condition button or navigate to the condition and press DELETE.
5. To add a new group of conditions, click the upper-level group operator and select Add Group from the menu. Then specify the condition properties. To remove a group, click its logical operator and select Remove Group from the menu.

6. The pivot table will display data matching the created filtering conditions. In the case described here, the list of film titles was filtered to see it starting with CHILL LUCK film title and ending with DANCING FEVER one. To edit the conditions, press the Edit Prefilter button. To see the data unfiltered, clear the check box next to the filtering condition. To cancel filtering, click the [image] button.

ExpandedToggleIcon(9x12) See Also

Managing a Pivot Table

Sorting Fields


Sorting Fields

You can sort data in a pivot table to display it in ascending or descending order.

To sort values of any field, click the [image] Sort button on the field header.

ExpandedToggleIcon(9x12) See Also

Managing a Pivot Table

Grouping Fields


Grouping Fields

To better understand data dependencies, you can group data in a pivot table using various predefined group modes. To group values of some field, right-click the field in the Data Source view and select a required group mode from the menu. It will appear as a new sub-field of the selected field and you will be able to add it to a required area in a pivot table.

Values of date and time type can be grouped by years, months, quarters, days, weeks, days, etc. Numeric data can be grouped into numeric ranges, for example 0-9, 10-19, etc. Text data can be grouped by first letter.

To remove grouping, select a required sub-field and click Delete.

Creating custom groups

Besides predefined group modes you can create your own group criteria using the Collection Editor dialog box.

To create a custom group mode, do the following:

1. In the Data Source view right-click a field you want to apply a custom group mode and select Custom from the menu.
2. When the Collection Editor dialog box opens, enter a value to set a range for grouping. The pivot table will group the field values into the specified range and a custom group mode will appear as a new sub-field of the selected field in the Data Source view. To delete a custom group mode, right-click the sub-field and select Remove Group from the menu.

ExpandedToggleIcon(9x12) See Also

Managing a Pivot Table

Using Summary Functions to Calculate Custom Totals


Using Summary Functions to Calculate Custom Totals

Pivot table offers you a number of summary functions that you can apply to required column or row fields to calculate custom totals for their values. Custom totals are displayed in additional rows or columns highlighted with the grey color.

The summary functions are applied only to those fields that summarize the data of another field, for example, data of the category name field summarizes data of the film title field. The default function calculates the sum of all values, so you can see the Sum values just after adding row and column fields in a pivot table. You can cancel the default function or, quite the contrary, add others.

To apply a summary function to a field, do the following:

1. Select a required field in the Data Source view and go to the Properties window (to open it, right-click the field and select Properties from the menu).
2. Click the Summary field and check a required function or several ones to apply. See the custom totals in a pivot table.

ExpandedToggleIcon(9x12) See Also

Managing a Pivot Table

Applying Conditional Styles


Applying Conditional Styles

Conditional styles give you freedom to change a pivot table appearance to make the data more readable. For example, you can highlight values of some field that are greater than 100 with the red color, and values of another field that meet some other condition with the blue color, the difference between data in a pivot table will be clear at a glance.

Besides setting a background color for some cells, you can select an image as a background, change a font and its color, specify a condition to apply only for some values in a required field, etc.

Let's examine conditional styles benefits by the following example:

There is the list of films and their rental payments grouped by month and year. It is required to quickly identify which films bring the expected revenue, i.e., the sum of their rental payments meet the planned monthly range of $20-40 and which films are in less demand, i.e., the sum of their rental payments are less than $10.

Conditional styles in use:

1. Open the Conditional Styles dialog box by either of these ways:
· Click the [image] Conditional Styles icon on the toolbar
· Right-click the pivot table header and select Conditional Styles from the menu
2. Click the [image] Add Condition icon to create a new condition.
3. Select the payment amount field from the Field drop-down list and go to the Condition field to select Between value.
4. Enter 20 and 40 values into Value1 and Value2 fields to specify the required range of values.
5. Unselect all the check boxes except the Cell one in the Apply To section, as there is no need to apply this condition for all the cell types in the pivot table.
6. In the Appearance section click the BackColor field and select LightBlue. Now the first condition is ready. Click the [image] Add Condition icon to create another condition for the films which have the sum of payment amounts less than $10.

7. Select the payment amount field from the Field drop-down list and go to the Condition field to select Less value.
8. Enter 10 into the Value1 field and leave only the Cell check box selected in the Apply To section.
9. In the Appearance section select the red color from the ForeColor field to change the font color of the payment amount values into red.
10. Click OK to apply the conditional styles to the pivot table. The data will look like the following:

ExpandedToggleIcon(9x12) See Also

Managing a Pivot Table

Printing


Printing

To print a pivot table:

1. Select Print from the File menu. The Preview window opens where you can customize the display of the pivot table.
2. Click the [image] Quick Print button to start printing.

ExpandedToggleIcon(9x12) See Also

Managing a Pivot Table

Pivot Table Components


Pivot Table Components

Find detailed information about the components of the PivotGrid window and how to use them in this section.

ExpandedToggleIcon(9x12) In This Section

Areas
Describes data areas of a pivot table.

Headers
Describes headers of a pivot table.

Filter Field
Describes filter fields of a pivot table.

Column Field
Describes column fields of a pivot table.

Row Field
Describes row fields of a pivot table.

Data Field
Describes data fields of a pivot table.

Totals
Describes custom totals you can get in a pivot table.

Grand Totals
Describes grand totals you can get in a pivot table.

ExpandedToggleIcon(9x12) See Also

Working with Pivot Table

Viewing Data in Master-Detail Tables


Areas

To convert your data into a pivot table, you can drag-and-drop data source fields into four areas in the Pivot Grid view of the SQL document. They are the following:

· Filter area - displays a data source field as a Filter field.
· Row area - displays a data source field as a Row field.
· Column area - displays a data source field as a Column field.
· Data area - displays values of the Data field that you dragged from the Data Source view, Total and Grand Total values that are automatically calculated after adding the fields to this area, and any custom summary calculations you can select for the fields.

ExpandedToggleIcon(9x12) See Also

Pivot Table Components

Headers


Headers

Headers are part of fields added to a pivot table in the Pivot Grid view of the SQL document. They display the fields names and allow you to manage the fields data in different ways. You can sort, filter, move the field headers to any pivot table area to rearrange the data and get the best layout to understand the data relations and dependencies.

You can see the headers for filter, column, row, and data fields.

ExpandedToggleIcon(9x12) See Also

Pivot Table Components

Filter Field


Filter Field

Filter field is a data source field that you place into filter field area in the Pivot Grid view of the SQL document. It allows you to filter all the data in a pivot table by applying custom filtering criteria.

To add a filter field, drag-and-drop a required field from the Data Source view. To set filter criteria, click the [image] Filter button in the filter field and select criteria from the drop-down dialog box.

ExpandedToggleIcon(9x12) See Also

Pivot Table Components

Column Field


Column Field

Column field is a data source field that you place into column field area in the Pivot Grid view of the SQL document. It consists of a column header and values. A column header displays a column name and allows you to sort and filter column data, move the column to any pivot table area to rearrange the data.

To add a column field, drag-and-drop a required field from the Data Source view. You can add more than one column field, in this case the values of the leftmost column field will be displayed only once, as the values of other column fields will be repeated.

ExpandedToggleIcon(9x12) See Also

Pivot Table Components

Row Field


Row Field

Row field is a data source field that you place into row field header area in the Pivot Grid view of the SQL document. It consists of a row header and values. A row header displays a row name and allows you to sort and filter row data, move the column to any pivot table area to rearrange the data.

To add a row field, drag-and-drop a required field from the Data Source view. You can add more than one row field, in this case the values of the leftmost column field will be displayed only once, as the values of other row fields will be repeated.

ExpandedToggleIcon(9x12) See Also

Pivot Table Components

Data Field


Data Field

Data field is a data source field that you place into data area in the Pivot Grid view of an SQL document. To add a data field, drag-and-drop a required field from the Data Source view. Sum of data field values as well as grand total values are automatically calculated and displayed in a pivot table.

You can select the following summary calculation functions to apply for data fields:

· Sum
· Average
· Count
· Min, Max
· Standard deviation based upon the entire data or the subset
· Population Variance based upon the entire data or the subset

Data fields consist of a header and values. The header contains a data field name, which helps you identify the values of the data fields.

ExpandedToggleIcon(9x12) See Also

Pivot Table Components

Totals


Totals

Row Totals are rows containing a calculated sum of row field values. Column totals are columns containing a calculated sum of column field values.

Totals are calculated based on selected summary functions and displayed in the Data area highlighted with the grey color. The default function calculates the sum of all values. You can cancel the default function or, quite the contrary, add others.

ExpandedToggleIcon(9x12) See Also

Pivot Table Components

Grand Totals


Grand Totals

Row Grand Totals are rows containing an automatically calculated sum of row field totals. Column Grand Totals are columns containing an automatically calculated sum of column field totals.

Grand Totals are displayed in the data area highlighted with the light yellow color when you add any data fields to the Row Fields, Column Fields, and Data area in the Pivot Grid view of the SQL document.

Besides automatic grand total values you can get custom totals for a required field. They are calculated based on selected summary functions.

ExpandedToggleIcon(9x12) See Also

Pivot Table Components

Viewing Data in Master-Detail Tables


Viewing Data in Master-Detail Tables

dbForge Studio provides a possibility to view data in parent tables or views as well as in related child tables or views, and also in self-referencing tables with the help of Master-Detail Browser. This feature is useful because it allows users to view and analyze related data all together in a comprehensive and easy way.

There are several ways to open Master-Detail Browser:

· In the Database menu click MasterDetailBrowser Master-Detail Browser
· Click New in the File menu, and then click MasterDetailBrowser Master-Detail Browser
· Right-click on a table(s) or view(s) in the Database Explorer window, click Send to, and then click MasterDetailBrowser New Master-Detail option.

When you open the browser, a master-detail document with the *.mdet extension is created.

ExpandedToggleIcon(9x12) In This Section

How To: View Data in Related Tables
Tells how to easily view data in related tables.

How To: Work with Self-Referencing Tables
Tells how to view data in self-referencing tables.

Working with Master-Detail Browser Document
Explains how to work with Master-Detail Browser documents.

Sorting and Filtering Data in Master-Detail Browser
Explains how sort and filter resulting data.

Tips for Working with Master-Detail Browser
Gives some recommendations that will help to improve working with Master-Detail Browser.

ExpandedToggleIcon(9x12) See Also

Data Analysis


How To: View Data in Related Tables

This topic gives a quick guide on how to view data in related tables with the help of Master-Detail Browser.

For example, you need to view details for each actor for all categories in the Sakila database. To do this, you should perform the following actions:

1. In the Database menu click MasterDetailBrowser Master-Detail Browser.
2. Drag the actor, film_actor_id , and film tables from Database Explorer to the designer area.
3. Select the actor table and click Set Table as Master SetAsMaster on the toolbar pane of the master-detail document.

4. Link columns, if needed.
5. Select checkboxes near the columns you want to be included into the results and deselect the checkboxes near the columns you don't want to be included into the result.
6. Click BrowseData Browse Data (F5) on the toolbar pane.
7. Navigate between the records in the master table and click + to view the detail data.

ExpandedToggleIcon(9x12) See Also

Viewing Data in Master-Detail Tables

How To: Work with Self-Referencing Tables in Master-Detail Browser


How To: Work with Self-Referencing Tables in Master-Detail Browser

This topic explains how to work with self-referencing tables in Master-Detail Browser.

Self-referencing table is a table that is a parent and a dependent in the same referential constraint. I. e. in such tables a foreign key constraint can reference columns within the same table.

The example specified below shows how to view data in a self-referencing table regarding available relations between columns using Master-Detail Browser.

ExpandedToggleIcon(9x12) Prerequisites

To perform the steps described in the Viewing Data in a Self-Referencing Table part of this topic, you will need a self-referencing table itself. Below is an example of such table (the Employees table) and it will be used in the Viewing Data in a Self-Referencing Table section as a sample table:

EmpNo | EName | Job | MGR | HireDate | Sal | Commission | DeptNo
7369 | SMITH | CLERK | 7902 | 12/17/1980 12:00:00 AM | 800 | (null) | 20
7499 | ALLEN | SALESMAN | 7698 | 02/20/1981 12:00:00 AM | 1600 | 300 | 30
7521 | WARD | SALESMAN | 7698 | 02/22/1981 12:00:00 AM | 1250 | 500 | 30
7566 | JONES | MANAGER | 7839 | 04/02/1981 12:00:00 AM | 2975 | (null) | 20
7654 | MARTIN | SALESMAN | 7698 | 09/28/1981 12:00:00 AM | 1250 | 1400 | 30
7698 | BLAKE | MANAGER | 7839 | 05/01/1981 12:00:00 AM | 2850 | (null) | 30
7782 | CLARK | MANAGER | 7839 | 06/09/1981 12:00:00 AM | 2450 | (null) | 10
7788 | SCOTT | ANALYST | 7566 | 07/13/1980 12:00:00 AM | 3000 | (null) | 20
7839 | KING | PRESIDENT | (null) | 11/17/1980 12:00:00 AM | 5000 | (null) | 10
7844 | TURNER | SALESMAN | 7698 | 09/08/1981 12:00:00 AM | 1500 | 0 | 30
7876 | ADAMS | CLERK | 7788 | 07/13/1987 12:00:00 AM | 1100 | (null) | 20
7900 | JAMES | CLERK | 7698 | 12/03/1980 12:00:00 AM | 950 | (null) | 30
7902 | FORD | ANALYST | 7566 | 12/03/1980 12:00:00 AM | 3000 | (null) | 20
7934 | MILLER | CLERK | 7782 | 01/23/1982 12:00:00 AM | 1300 | (null) | 10

ExpandedToggleIcon(9x12) Viewing Data in a Self-Referencing Table

Task: it is required to view all employees regarding the levels of company hierarchy using the data available in the sample Employees table.

Solution: because the manager is also an employee, there is a relationship from the MGR column to the EmpNo column. The EmpNo column contains identification number of all employees, and the MGR column contains the identification number of the manager a person subordinates to (you see, the company president has (null) in the MGR column, as he doesn't subordinate to anyone). Now, as you've understood the relationship between these columns, you can perform the following steps to solve the task specified above using dbForge Studio Master-Detail Browser:

1. Click MasterDetailBrowser Master-Detail Browser on the Database Tools toolbar. An empty Master-Detail Browser document will open.
2. Drag'n'drop the Employees table you've created onto the designer surface.
3. Create a relationship between the MGR and EmpNo columns by selecting the MGR column and dragging it to the EmpNo column. An arrow indicating the relationship will be displayed on the diagram:

note Note

There is no foreign key in this table, but if there is one and a relation between columns was established earlier, it's displayed on the diagram after dropping the table onto it.
4. Click the BrowseData Browse Data button.
5. In the Data view that opened, select the row with PRESIDENT specified in the Job column in the upper part of the view, and click + near each detail record in the lower part of the view to see the next level of company hierarchy and the employees belonging there:

ExpandedToggleIcon(9x12) See Also

Viewing Data in Master-Detail Tables

Working with Master-Detail Browser Document


Working with Master-Detail Browser Document

This topic explains how to work with the Master-Detail Browser document. The document is divided into two views - Design and Data. It is described how to work with each of these views below.

ExpandedToggleIcon(9x12) Working with Design View

To add one or more tables/views to the diagram drag them from the Database Explorer window onto the designer surface.

note Note

The first table/view that you drag will be automatically set as master table/view and marked with a peach color. To set another table/view as master, you can select this table/view and click Set Table as Master on the document toolbar or right-click it and select the same command from the shortcut menu.

note Note

Arrows between tables/views indicate any existing relationships between these tables/views.

note Note

At least one parent table/view (without any arrows pointing to it) must be added to the document, or an error message will be displayed if you try to view results.

When dragging tables onto the designer surface, relationship lines are automatically created if a relationship exists in the database for the added tables.

A line with an arrow pointing in the direction of the link indicates a one to one relationship. But you can also create links between different columns yourself. To create a link, simply drag a column from one object to a column in the second object that you want to link. You can change the direction of a created or an existing link by right-clicking on it and selecting Change Link Direction from the shortcut menu.

note Note

You can not make links between columns of different types.

Now you can select columns you want to include into or exclude from your result by checking or unchecking checkboxes near the columns. You can also select all columns by clicking the Select All Columns SelectAllColumns option on the document toolbar or selecting this option in the table/view shortcut menu. To clear all columns, click the Unselect All Columns UnselectAllColumns option on the document toolbar or select this option in the table/view shortcut menu.

You can also sort columns in tables/views in ascending or descending order using the Sort Ascending SortAscending or Sort Descending SortDescending options from the document toolbar or the shortcut menu correspondingly.

Under the designer area you can specify a fetch limit for the result set, and a field to specify a WHERE condition. Also you can view the name of the currently selected table/view or link here.

To view results, click the BrowseData Browse Data button on the document toolbar or press F5. After this the Data view with result set will be opened.

To send the available relation to Query Builder, click the Send to Query option in the menu.

ExpandedToggleIcon(9x12) Working with Data View

In the upper part of the Data view the data of the parent table/view is shown. The lower part of the document is occupied by data available in the child tables/views. You can navigate through the records of the parent table/view, and the corresponding data of the child tables/views will be shown in the lower part of the view. If there is more than one child table/view, click + to view data of these child tables/views.

For the parent table/view, you can change the order of the available records. For the child tables/views, you can also change the records order and also apply filtering. To learn more about sorting and filtering data in parent and child tables/views, refer to the Sorting and Filtering Data in Master-Detail Browser topic.

In this view, you can click the Refresh button to refresh data, Stop Refresh to stop refreshing.

Click MasterDetailBrowser Show Design to return to the design view.

note Note

In the split document view document is divided in two parts - Design and Data. If you've designed the required relationship and you are ready to work with data, you can hide the Design view by clicking the MasterDetailBrowser Hide Design button in the Data view. After this the Data view will occupy all document area. To return to the Design view, click the MasterDetailBrowser Show Design button on the document toolbar.

ExpandedToggleIcon(9x12) See Also

Viewing Data in Master-Detail Tables

Sorting and Filtering Data in Master-Detail Browser


Sorting and Filtering Data in Master-Detail Browser

In dbForge Studio Master-Detail Browser resulting data displayed in the documnet Data view can be sorted and filtered. This topic explains how to perform each of these actions.

ExpandedToggleIcon(9x12) Sorting Data

Data can be sorted in both master and detail tables. To sort data by some particular column, click the column header. Clicking on the cell removes sorting from all other columns, sets sorting order to ascending if it has not been set before, or changes the sorting direction.

To assign secondary sorting, click on another column header, while holding down the Shift key. You can set any number of sorting columns. To stop sorting on a certain column, click it holding CTRL key.

The Up arrow indicates ascending sorting.

The Down arrow indicates descending sorting.

No arrow indicates that no sorting is applied to the column.

ExpandedToggleIcon(9x12) Filtering Data

Data can be filtered only in detail tables. To apply filtering to some column, click the FilterFunnel funnel button on the header of a column you want to apply filtering to. The drop-down list opens with a set of values encountered in this column and the universal items such as All, Custom, Blanks, and Non Blanks. To view only rows containing Blanks (NULLs), Non Blanks (not NULLs), or a certain value, select the corresponding item in the list. To set a custom filter, select (Custom), and create a filter in the opened Custom AutoFilter window.

To remove all filter conditions, click the [image] button in the bottom of the grid.

ExpandedToggleIcon(9x12) See Also

Viewing Data in Master-Detail Tables

Tips for Working with Master-Detail Browser


Tips for Working with Master-Detail Browser

This topic gives you some pieces of advice for working with Master-Detail Browser and describe the problems you may encounter when using this functionality.

Working with tables containing large amounts of data.

If you have a large table, but you don't need to view all data from this table, you can set a fetch limit in the corresponding field under the diagram. In this case the application will not require as much memory as it would have required for fetching all data.

In case you want to view only data that answers some certain criteria, you can write a WHERE condition in the corresponding field under the diagram. In this case only data that satisfies this criteria will be displayed.

Problems that may occur when viewing data of related tables:

· If a cycle in some table is found, then the "Cannot retrieve master-detail data. The cycle in table TableName was found." error message is shown. In this case you won't be able to view table data.
· If there are tables not connected with any tables on the diagram, data of such tables won't be displayed in the Data view.
· Only relation of the Master-Detail-Detail-Detail-... kind can be processed in Master-Detail Browser. If the relation has a different scheme, data from the tables that escape the specified relation scheme will not be available in the Data view.

ExpandedToggleIcon(9x12) See Also

Viewing Data in Master-Detail Tables

Data Analysis


Working with Schema Objects

In this section you can learn how to perform certain operations on schema objects.

ExpandedToggleIcon(9x12) In This Section

Working with Tables
This topic provides information about table editing.

Views
Overview on working with views in Oracle.

PL/SQL Objects
This section describes how to work with PL\SQL objects.

Other Schema Objects
This section describes how to work with different database objects.

Walkthrough
Walkthrough on creating database objects.


Working with Tables

In this section you can learn how to perform certain operations on tables.

ExpandedToggleIcon(9x12) In This Section

How To: Create, Drop, and Edit Tables
Describes adding, removing, and editing tables from a database.

Defining Table Structure
Describes defining columns and indexes in a table and setting up table options.

Working with Constraints
Describes how to work with unique, primary, foreign keys and check constraints in Oracle.

Object Tables
Describes how to add and remove object tables from a database.

Clustered Tables
Describes how to add and remove clustered tables from a database.

Index-Organized Tables
Describes how to add and remove clustered tables from a database.

Partitioned Tables
Describes working with partitioned tables.

ExpandedToggleIcon(9x12) See Also

Working with Database Objects

Views


How To: Create, Drop, and Edit Tables

This topic describes ways to create, drop, and edit a table in a database with the help of dbForge Studio.

ExpandedToggleIcon(9x12) Creating a Table

1. Click the New Database Object button on the Standard toolbar, and specify an object type.
2. Select the Table type in the dialog.

NewObjectSS
3. Enter the table name.
4. Click Create. If the specified table name is unique, the table editor appears.
5. Add at least one column to the table.
6. Optionally, you can alter the table name, change the database (owner), or set a comment for the table.
7. Save the document.

-or-

1. In the Database Explorer window, right-click the Tables folder, and select New Table.
2. Input the table name.
3. Add at least one column to the table.
4. Optionally, alter the name, change the database (owner), or set a comment for the table.
5. Save the document.

note Note

To learn about adding columns, constraints, indexes to the table and defining other table parameters, see Defining Table Structure

ExpandedToggleIcon(9x12) Dropping a Table

1. In the Database Explorer window, expand the Tables folder.
2. Right-click a required table, and then click Delete in the shortcut menu.

note Note

While dropping a table, all its data will be lost.

ExpandedToggleIcon(9x12) Editing a Table

Editing a table implies editing its structure: changing, removing, or adding columns, indexes, modifying table options. Table editor allows performing all these actions and viewing changes in the script of the table.

To edit a table and view changes:

1. In the Database Explorer window, expand the Tables folder.
2. Right-click a required table, and then click Edit Table.
3. Select Edit Table from the shortcut menu.
4. Make necessary changes in the table structure.
5. Click the Script Changes button to view changes.
6. To apply changes, click Update Database. If you want to undo all actions made since table document (or any another object editor) was opened or saved, click the Undo button, on the Standard toolbar. However, you cannot issue the Redo command for database objects, because when you click Undo, a database object is reloaded from server, and all unsaved changes are lost.

ExpandedToggleIcon(9x12) See Also

Working with Tables

Defining Table Structure


Defining Table Structure

A table contains columns, constraints, and indexes. Besides, a table has options such as owner, tablespace and so on. Defining a table structure means setting up all these elements.

To define table structure, create the table or open existing one from the Database Explorer.

ExpandedToggleIcon(9x12) Defining Columns

To define columns or rename a table, go to the General tab of the table editor. To add a new column to a table:

1. Right-click the grid, and then click New Column in the shortcut menu. Alternatively, you can press the INSERT button on the keyboard. The Column Properties dialog box appears.
2. Enter the column name, its data type, and other parameters if needed.
3. Click OK. The column appears in the grid.

To edit an existing column:

1. Right-click a required column, and then click Edit Column in the shortcut menu. The Column Properties dialog box appears.
2. Change the column's parameters.
3. Click OK. The updated column appears in the grid.

To remove a column, right-click a required column, and then click Delete Column in the shortcut menu.

ExpandedToggleIcon(9x12) Defining Constraints

To add or alter foreign and primaries keys, go to the Constraints tab.

To add a key to a table:

1. Right-click the table editor window, and then click either New Foreign Key or New Primary Key in the shortcut menu. The Primary Key Properties (or Foreign Key Properties) windows opens.
2. Enter the key name.
3. Select required table columns.
4. Enter other parameters if needed.
5. Click OK.

To edit a key, right click a required one, and then select Edit Constraint in the shortcut menu.

To remove a key, right click a required one, and then select Delete Constraint in the shortcut menu.

ExpandedToggleIcon(9x12) Defining Indexes

To define indexes, go to the Indexes tab. To add an index to a table:

1. Right-click the table editor window, and then select New Index in the shortcut menu. Alternatively, press the INSERT button on the keyboard. The Index Properties dialog box opens.
2. Enter the index name.
3. Select index column.
4. On the Storage tab, enter other parameters if needed.
5. Click OK.

ExpandedToggleIcon(9x12) Defining Table Storage

Tune up specific options according to your plans for the table in the Storage tab of Table editor. For example, you can set extents and transactions options in this tab. For more information, see Storage, Table Editor.

ExpandedToggleIcon(9x12) See Also

Working with Tables

Working with Constraints


Working with Constraints

In this section you can learn how to perform certain operations on tables.

ExpandedToggleIcon(9x12) In This Section

Unique and Primary Keys
Overview on working with unique and primary keys.

Check Constraints
Overview on working with check constraints.

Foreign Keys
Overview on working with foreign keys.

ExpandedToggleIcon(9x12) See Also

Working with Tables

Object Tables


Unique and Primary Keys

The UNIQUE constraint uniquely identifies each record in a database table. The UNIQUE and PRIMARY KEY constraints both provide a guarantee for uniqueness for a column or set of columns. A PRIMARY KEY constraint automatically has a UNIQUE constraint defined on it. Note that you can have many UNIQUE constraints per table, but only one PRIMARY KEY constraint per table.

Certain restrictions must be obeyed when working with unique and primary keys:

· A table or view can have only one primary key.
· A composite key cannot have more than 32 columns.
· You cannot designate the same column or combination of columns as both a primary key and a unique key.
· Some column types such as LOB, LONG, VARRAY, NESTED TABLE, REF are not supported for unique or primary keys.

ExpandedToggleIcon(9x12) Creating and Editing a Key

1. In the Database Explorer window, right click a required table.
2. Click Edit Table in the shortcut menu.
3. In the Table menu, click either New Primary Key or New Unique Key.
4. Add required columns to the key and click OK.

When the Table Editor is open, you can switch to the Constraints tab, and create (or edit) a key using the shortcut menu.

To delete a key, select a required key, and click Delete Constraint in the shortcut menu.

ExpandedToggleIcon(9x12) See Also

Working with Constraints

Check Constraints


Check Constraints

You can create a check constraint as part of the table definition when you create a table. If a table already exists, you can add a CHECK constraint. Tables and columns can contain multiple check constraints. If a check constraint already exists, you can modify or delete it. For example, you may want to modify the expression that is used by the check constraint on a column in the table.

The following restrictions are actual for check constraints:

· The condition of a check constraint can refer to any column in the table, but it cannot refer to columns of other tables.
· Conditions of check constraints cannot contain the following constructs:
· Subqueries and scalar subquery expressions
· Calls to the functions that are not deterministic
· Calls to user-defined functions
· Dereferencing of REF columns
· Nested table columns or attributes
· The pseudocolumns CURRVAL, NEXTVAL, LEVEL, or ROWNUM
· Date constants that are not fully specified

ExpandedToggleIcon(9x12) Creating a Check Constraint

1. In the Database Explorer window, right click a required table.
2. Click Edit Table in the shortcut menu.
3. Select the Constraints tab.
4. Click New Check Constraint form the shortcut menu. The Check Constraint Properties dialog box will open.
5. Enter a condition and click OK.

When the Table Editor is open, you can switch to the Constraints tab, and edit a constraint using the shortcut menu.

To delete a constraint, select a required one, and click Delete Constraint in the shortcut menu.
ExpandedToggleIcon(9x12) Example

Consider you need to ensure that all employees in table Emp have and will have salary that is more than 500. This can be implemented best with check constraint. Open the table and create the constraint as described above. In the Condition type field - "Sal>500", and save the document. At this moment all data in the table is checked for validity and, if it satisfies the condition, new constraint is applied to the table.

This example assumes you do not change some of constraint's options which are located at the bottom of constraint editor. These options add some flexibility to constraints both in the moments of creation and altering. For example, you can:

· Uncheck the Enabled option to prevent constraint from activating. You can enable it later.
· Uncheck the Validate option to avoid verification of data that table already contains. Newly added or modified data still will be checked for validity.
· Check the Deferrable option to preserve opportunity of deferring check operation until after a transaction is committed.

ExpandedToggleIcon(9x12) See Also

Working with Constraints

Foreign Keys


Foreign Keys

A foreign key constraint (also called a referential integrity constraint) designates a column as the foreign key and establishes a relationship between that foreign key and a specified primary or unique key, called the referenced key. The same table or view can contain a foreign key and a referenced key.

You can define multiple foreign keys in a table or view. Also, a single column can be part of more than one foreign key.

The following restrictions are actual for foreign constraints:

· None of the columns in the foreign key can be of LOB, LONG, LONG RAW, VARRAY, NESTED TABLE, BFILE, REF, TIMESTAMP WITH TIME ZONE, or user-defined type. However, the primary key can contain a column of TIMESTAMP WITH LOCAL TIME ZONE.
· The referenced unique or primary key constraint on the parent table or view must already be defined.
· A composite foreign key cannot have more than 32 columns.
· The child and parent tables must be on the same database. To enable referential integrity constraints across nodes of a distributed database, you must use database triggers.

ExpandedToggleIcon(9x12) Creating and Editing a Foreign Key

1. In the Database Explorer window, right click a required table.
2. Click Edit Table in the shortcut menu.
3. In the Table menu, click New Foreign Key.
4. Add required columns, select referenced table, and referenced constraint.
5. Click OK.

-or-

1. In the Database Explorer window, right click a required table.
2. Click Edit Table in the shortcut menu.
3. Switch to the Constraints tab.
4. Create a constraint using the shortcut menu.

note Note

Note, to create a foreign key, the referenced table should have a unique index, otherwise dbForge Studio will prompt you to create it. Click Yes in the dialog and the unique index will be added.

When the Table Editor is open, you can switch to the Constraints tab, and edit a foreign key using the shortcut menu.

To delete a foreign key, select a required one, and click Delete Constraint in the shortcut menu.

ExpandedToggleIcon(9x12) Example of Creating a Foreign Key

Assume you need to ensure that each employee in the Emp table has and will have a valid reference to a manager. That is, for each employee value of field MGR there always will be one of the EMPNO values in the same table. This is best implemented with a foreign key.

1. Open the table and create a primary or unique key for field EMPNO as described in topic Unique and Primary Keys.
2. Create the foreign key as described above. Select MGR as constraint column, then select EMP as referenced table, and select the unique or primary key you have created in step 1 as the referenced constraint.

That's all you need to do to establish a referential integrity constraint. For a more flexible control over the constraint you may use the following options of the Advanced tab of foreign key editor:

· Clear the Enabled option to prevent constraint from activating. You can enable it later.
· Clear the Validate option to avoid verification of data that the table already contains. Newly added or modified data still will be checked for validity.
· Select the Deferrable option to preserve possibility of deferring check operation until after the transaction is committed.

ExpandedToggleIcon(9x12) See Also

Working with Constraints

Object Tables


Object Tables

Object table is a table having rows of objects. Each column in a row corresponds to an attribute of the object type. Object table structure is defined with object type and cannot be modified. You can only add, modify or remove constraints and indexes to it and change its storage options.

dbForge Studio allows you to create, modify, and drop object tables, retrieve their data.

ExpandedToggleIcon(9x12) Creating an Object Table

1. Click the New Database Object button on the Standard toolbar.
2. Select the Object Table type in the dialog.
3. Input a table name.
4. Click Create and, if specified name is unique, the table editor will appear.
5. Select an initial object name, and a schema.
6. Add required columns.
7. Save the document.

To drop a table, select a required one, and then select Delete, from the shortcut menu.

note Note

While dropping a table, all its data will be lost.

ExpandedToggleIcon(9x12) See Also

Working with Tables

Clustered Tables


Clustered Tables

Clustered tables which belong to the same cluster store their data rows, having the same cluster key values together. Storage options of clustered table are defined by cluster, so you cannot modify them. Disc I/O is reduced and access time is improved for joins of clustered tables.

ExpandedToggleIcon(9x12) Creating a Clustered Table

1. Click the New Database Object button on the Standard toolbar, and specify an object.
2. Select the Table type in the dialog.
3. Input the table name.
4. Click Create. If specified table name is unique, the table editor appears.
5. Add columns to the table.
6. Optionally, you can alter the table name, change the database (owner), or set comment for the table.
7. Click Clustered.
8. Go to the Cluster tab.
9. Select a schema and a cluster name that will contain the table.
10. Select table columns that correspond to the cluster columns. You can select Create new column, and the required column will be created automatically.
11. Save the document.

To drop a clustered table, select a required table, and then select Delete, from the shortcut menu.

note Note

While dropping a table, all its data will be lost.

ExpandedToggleIcon(9x12) See Also

Clusters

Working with Tables


Index-Organized Tables

An index-organized table (IOT) is a type of table that stores data in a B*Tree index structure.

ExpandedToggleIcon(9x12) Creating an Index-Organized Table

1. Click the New Database Object button on the Standard toolbar.
2. Select the Table type in the dialog.
3. Input the table name.
4. Add columns to the table.
5. Click Index Organized.
6. Go to the IOT tab.
7. Set required index-organized parameters.
8. Save the document.

To drop an index-organized table, select a required table, and then select Delete, from the shortcut menu.

note Note

While dropping a table, all its data will be lost.

ExpandedToggleIcon(9x12) See Also

Creating and Dropping Tables

Working with Tables


Partitioned Tables

This section describes working with partitioned tables using different partitioning methods.

ExpandedToggleIcon(9x12) In This Section

Partitioning Basics
This topic contains basic information about table partitioning.

How To: Create Partitioned Tables with Range, Hash or List Partition Methods
This topic tells how to create partitioned table with using range, hash or list partition method.

How To: Create Partitioned Tables with Composite Partition Methods
This topic tells how to create partitioned table with using composite partition method.

Adding and Removing Partitions and Subpartitions
This topic tells how to add or remove partitions and subpartitions.

Using Subpartition Template
This topic tells about using subpartition template for setting subpartitions for table partitions.

ExpandedToggleIcon(9x12) See Also

Working with Tables

Views


Partitioning Basics

Oracle allows to divide table and index data into a smaller parts - partitions and sub-partitions that can be stored and managed individually. dbForge Studio provides you handy interface for creating partitioned tables, and manipulating partitions and sub-partitions.

note Note

Clustered tables and tables containing any LONG or LONG RAW columns cannot be partitioned.

Oracle provides you several partitioning methods. They are range, hash and list partitioning and composite partitioning. Range partitioning provides mapping rows to partitions based on ranges of column values. Hash partitioning provides mapping rows to partitions based on a hash value of partitioning key. List partitioning provides mapping rows to partitions based on lists of discrete values set for each partitions. When using composite partitioning method table is divided into partitions using range partitioning method and partitions can be further divided into sub-partitions with hash or list subpartitioning method.

The partitioning key is a set of one or more table columns that determines the partition. It can contain from one to 16 columns. When using list partitioning method, partitioning key can contain only one column.

note Note

Index-organized tables cannot be partitioned with composite partitioning method. Index-organized tables can be partitioned with list partitioning method only on Oracle 10g and higher. Partitioning key of index-organized table must be a subset of table's primary key columns.

ExpandedToggleIcon(9x12) See Also

Partitioned Tables

How To: Create Partitioned Tables with Range, Hash or List Partition Methods


How To: Create Partitioned Tables with Range, Hash or List Partition Methods

ExpandedToggleIcon(9x12) Creating a Range-Partitioned Table

1. Click the New Database Object button on the Standard toolbar.
2. Select the Table type in the dialog.
3. Input the table name.
4. Click Create. If specified table name is unique, the table editor appears
5. Add columns to the table.
6. Optionally, you can alter the table name, change the database (owner), or set comment for the table.
7. Go to the Partitioning tab.
8. In the Partitioning Type drop down list, click Range.
9. Select Partition columns.
10. Add required partitions and set values for partitions' bounds for all partition columns.
11. Set tablespace names for partitions if required.
12. Save the document.

ExpandedToggleIcon(9x12) Creating a List-Partitioned Table

1. Click the New Database Object button on the Standard toolbar.
2. Select the Table type in the dialog.
3. Input the table name.
4. Click Create. If specified table name is unique, the table editor appears
5. Add columns to the table.
6. Optionally, you can alter the table name, change the database (owner), or set comment for the table.
7. Go to the Partitioning tab.
8. In the Partitioning Type drop down list, click List.
9. Select Partition columns.
10. Add required partitions and set values for partitions' bounds for all partition columns.
11. Set tablespace names for partitions if required.
12. Save the document.

ExpandedToggleIcon(9x12) Creating a Hash-Partitioned Table

1. Click the New Database Object button on the Standard toolbar.
2. Select the Table type in the dialog.
3. Input the table name.
4. Click Create. If specified table name is unique, the table editor appears
5. Add columns to the table.
6. Optionally, you can alter the table name, change the database (owner), or set comment for the table.
7. Go to the Partitioning tab.
8. In the Partitioning Type drop down list, click Hash.
9. Select Partition columns.
10. Add required partitions and set values for partitions' bounds for all partition columns.
11. Set tablespace names for partitions if required.
12. Save the document.

ExpandedToggleIcon(9x12) See Also

Partitioned Tables

How To: Create Partitioned Tables with Composite Partition Methods


How To: Create Partitioned Tables with Composite Partition Methods

In composite partitioned table partitions are divided into subpartitions. Subpartitions can be set individually for each partition. You can set subpartition template that can be used for setting subpartitions for new partitions without manually set subpartitions.

ExpandedToggleIcon(9x12) Creating a Composite Range-Hash Partitioned Table

1. Click the New Database Object button on the Standard toolbar and specify an object.
2. Select the Table type in the dialog.
3. Input the table name.
4. Click Create. If specified table name is unique, the table editor appears.
5. Add columns to the table.
6. Optionally, you can alter the table name, change the database (owner), or set comment for the table.
7. Go to the Partitioning tab.
8. In the Partitioning Type drop down list, click Range.
9. Select Partition columns, and Sub-partition columns.
10. Add required partitions and set values for partitions' bounds for all partition columns.
11. Set sub-partitions template if required.
12. Add sub-partitions manually if required, or set their quantity for partitions.
13. Set tablespace names for partitions and sub-partitions if required.
14. Save the document.

ExpandedToggleIcon(9x12) Creating a Composite Range-List Partitioned Table

1. Click the New Database Object button on the Standard toolbar, and specify an object.
2. Select the Table type in the dialog.
3. Input the table name.
4. Click Create. If specified table name is unique, the table editor appears.
5. Add columns to the table.
6. Optionally, you can alter the table name, change the database (owner), or set comment for the table.
7. Go to the Partitioning tab.
8. In the Partitioning Type drop down list, click List.
9. Select Partition columns, and Sub-partition columns.
10. Add required partitions and set values for partitions' bounds for all partition columns.
11. Set sub-partitions template if required.
12. Add sub-partitions manually if required, or set their quantity for partitions.
13. Set tablespace names for partitions and sub-partitions if required.
14. Save the document.

ExpandedToggleIcon(9x12) See Also

Partitioned Tables

Adding and Removing Partitions and Subpartitions


Adding and Removing Partitions and Subpartitions

On the Partitioning tab of Table Editor you can manipulate table partitions and subpartitions.

Current table partitions and subpartitions are shown in the Partitions tree. To remove a partition or a subpartition just select its node in the tree and click the Remove button, or click Remove from its shortcut menu. To change a partition name, select a partition in the tree and edit its name in the Name text box.

For hash partitioning you can add each partition manually or set their count. To add a partition, click the Add button.

For range partitioning you can add partition by clicking the Add button too. Range boundaries values must be set for partitions. To edit values for the partition, select it in the tree and click [image] button in the Value box. The Values Editor dialog box will appear.

To add an item to the list, type the value in the box and click Add. To delete an item, select it in the list and click Delete. To finish editing click OK to apply changes. Values count must be equal to partitioning key columns count. When using range partitioning, records, having partitioning key values up to the first partition's values inclusive maps to the first partition. Record maps to n-th partition if record has partitioning key value more than (n-1)-th partition border value and less or equal than n-th partition border value. If partitioning key consists of several columns, database uses the next value only when previous values cannot uniquely identify the partition to store record in.

Each value must correspond to the partitioning key column and they must have the same type. First value must be greater or equal than the first value of previous partition. If the first values are equal than the second value must be greater or equal than the second value of previous partition and so on. All values of different partitions cannot be equal, so if partitioning key contains only one column, the value of current must be greater than the value of previous partition. When adding new partition to existing partitioned table this rule must be kept too. The MAXVALUE keyword can be used for the partitions to set its boundaries to the maximum possible value of the corresponding partitioning key column type.

For list partitioning new partitions can be added in the same way as in other partitioning methods. Values list should be set for each partition. Values can be edited just like when using range partitioning. Values list must contain values for the column of partitioning key. Record will be stored in the partition, having the value of the partitioning key in the list. You can use DEFAULT keyword to identify the partition that accomodates rows that do not map into any other partitions.

For a composite partitioning you can add partition by clicking the Add button and choosing the Add partition from the shortcut menu or right-click in the Partitions tree choose Add partition from the shortcut menu. Range boundaries for partitions should be set just like when using range partitioning.

To add a subpartition to the partition, right-click on the partition in the Partitions tree and choose Add subpartition from the shortcut menu or do following:

1. Select the partition in the Partitions tree.
2. Click the Add button.
3. Click Add subpartition in the shortcut menu.

To remove subpartition select it in the tree, and click the Remove button or right-click the subpartition and choose Remove from the shortcut menu.

You can use subpartition template to set subpartitions. Working with subpartition template is described in topic. Subpartitions can be added to or removed from the template just like described above for adding them to and removing from partitions.

When using composite range-list partitioning you should set list values for subpartitions. You can set them just like list values for partitions when using list partitioning.

ExpandedToggleIcon(9x12) See Also

Partitioned Tables

Using Subpartition Template


Using Subpartition Template

In a composite-partitioned table a subpartition template can be used to simplify setting subpartitions for partitions. You can specify subpartition settings once for a template. These settings will be used when creating a partition without manually set subpartitions.

To create subpartition template right-click in the Partitions tree or click the Add button, and then select Add template from the shortcut menu. To remove the template, select it in the Partitions tree, and click the Remove button or right-click it in the Partitions tree, and select Remove from the shortcut menu.

To add subpartition to template or to remove it from template perform the same actions for adding or removing subpartitions from partitions, that are described in Adding and Removing Partitions and Subpartitions topic.

When using composite range-hash partitioning you can set only subpartitions count for template without adding each subpartition to template manually. To do it select template in the Partitions tree (it must have no manually set subpartitions) and type required value into Quantity of subpartitions box.

ExpandedToggleIcon(9x12) See Also

Partitioned Tables

Working with Schema Objects


Views

View is a logical table based on one or more tables or views. A view contains no data itself, but retrieves it from underlying tables and views when requested.

dbForge Studio allows you to create, modify, and drop views, retrieve and alter data in underlying tables.

ExpandedToggleIcon(9x12) Creating a View

To create a view:

1. On the Standard toolbar, click the New Database Object button.
2. In the New Object dialog window, select View.
3. Give a unique name to a view
4. Click the Create button. If specified name is unique, the view editor will appear. Note that views share same namespace with tables.
5. Type a query that will represent the view. You do not have to type "CREATE OR REPLACE VIEW ... AS" because dbForge Studio adds this clause for you.
6. Optionally, you can alter the name, change owner in which the new view will be created, or set view comment.
7. Optionally you can switch to the Columns tab, and set column aliases and comments.
8. Save the document. If there are any errors in the SQL syntax, you will be notified about it.

ExpandedToggleIcon(9x12) Editing a View

To edit a view:

1. In the Database Explorer window select a required view.
2. Select the Edit View option from the shortcut menu.

In the opened document you can alter a query text. Note that after a view had been created, you can not modify its name and owner. Save the document to apply changes you made to the query text.

ExpandedToggleIcon(9x12) Dropping a View

To drop a view:

1. In the Database Explorer select a required view.
2. Select the Delete option from the shortcut menu.

ExpandedToggleIcon(9x12) Retrieving and modifying view data

To retrieve view data:

1. Right-click on a required view in the Database Explorer, and click Retrieve Data from the shortcut menu.

The data is rendered in grid-based editor. You can browse and edit view data in the same way as you browse and edit table data.

Example

Let's create a view that represents a join between DEPT and EMP tables. The view must return columns "Department Name", "Employee Name", and "Job"; the data must be ordered in certain order. Let's make the view not updatable. It may also be a good idea to force view creation so that it will not fail if some referenced objects are wrong. To construct this view you have to perform the following steps:

1. In the Database Explorer window, right-click the Views node, and select New View.
2. Give a name to a view. Let it be TestView.
3. Type the following SQL in the Query Text field:

SELECT dname, ename, job FROM emp, dept WHERE emp.deptno = dept.deptno

4. Switch to the Columns tab. In the Alias column, change default column names to the custom ones; that is, DNAME to Department Name, ENAME to Employee Name, and JOB to Job.
5. Now switch to the Advanced tab, to tune up some view settings.
6. Check the Force view creation option. This allows to create or modify a view even if some objects referenced by the view are missing or have NOT VALID status.
7. Check the Restrictions check box to enable additional options for the view.
8. Choose the Read Only option.
9. Save the document.

You can invoke the text view of the document to inspect the query generated by dbForge Studio.

ExpandedToggleIcon(9x12) See Also

Working with Database Objects

PL/SQL Objects


PL/SQL Objects

This section provides information about working with stored procedures and functions, packages and objects.

ExpandedToggleIcon(9x12) In This Section

Procedures and Functions
Describes stored procedures and functions creating, editing, executing and deleting.

Packages
Describes working with packages.

Packages and Programs Compilation
Provides information about packages and programs compilation.

Object Types
Provides information about specific features for working with object types.

ExpandedToggleIcon(9x12) See Also

Working with Database Objects

Other Database Objects


Procedures and Functions

Stored procedure (function) is a set of statements that resides on server side and can be executed. Using dbForge Studio you can create, edit, execute and delete stored procedures.

ExpandedToggleIcon(9x12) Creating a Stored Procedure

1. In the Database Explorer window, right click the Procedures folder, and than click New Procedure. A new template document appears.
2. Fill a template with statements. dbForge Studio adds the CREATE/REPLACE words for you.
3. Save the document.

ExpandedToggleIcon(9x12) Editing a Stored Procedure

1. In the Database Explorer window, expand the Procedures folder.
2. Right click a required procedure, and then click Edit.

note Note

Once you have saved a procedure, its name can not be changed.

To delete a stored procedure, right click a required procedure, and then click Delete.

ExpandedToggleIcon(9x12) Executing a Stored Procedure

1. In the Database Explorer window, expand the Procedures folder.
2. Right click a required procedure, and then click Execute.

If a procedure accepts parameters you will see the Parameters dialog where you can set initial values for the procedure arguments. Once the routine is executed, you will see appropriate record in the Output window.

Stored procedures, as well as many other Oracle objects, have status. It means that procedures may be valid or invalid. An invalid procedure probably references invalid objects, or has errors in its text, or has some other problems. For example, a stored procedure may suddenly go invalid if it was working with some tables and those tables were recreated. To fix the problem you have to compile the stored procedure or function.For this, click Compile in procedure's shortcut menu. Note that if the procedure is a part of a package, you have to recompile the whole package.

To use default values of stored routine parameters delete the parameters with default values in the Edit Parameters dialog.

ExpandedToggleIcon(9x12) Expanding Stored Procedures

This feature allows to simplify debugging by replacing a call to a stored procedure with the stored procedure body - it takes the content of the stored procedure and substitutes the call in your query to it. To apply this feature to the needed code, select the Convert CALL to Script option from the shortcut menu.

ExpandedToggleIcon(9x12) See Also

Packages

PL/SQL Objects


Packages

A package is an encapsulated collection of related procedures, functions, and other program objects stored together in the database. The package consists of two parts: specification declares these objects, and package body, specified subsequently, defines these objects.

ExpandedToggleIcon(9x12) In This Section

Package Specification
Contains information on working with package specification.

Package Body
Contains information on working with package body.

ExpandedToggleIcon(9x12) See Also

Procedures and Functions

PL/SQL Objects


Package Specification

The specification is the package interface. It consists of declarations of types, variables, constants, exceptions, cursors, and subprograms that can be referenced from outside the package. The specification holds public declarations, which are visible outside the package. You must declare subprograms at the end of the specification after all other items (except pragmas that name a specific function; such pragmas must follow the function specification). If specification declares only types, constants, variables and exceptions the package body is unnecessary. Only subprograms and cursors have an underlying implementation.

ExpandedToggleIcon(9x12) Creating a Package Specification

1. In the Database Explorer window, right click the Packages folder, and than click New Package. A new template document appears.
2. Fill a template with statements. dbForge Studio adds the CREATE/REPLACE words for you.
3. Save the document.

ExpandedToggleIcon(9x12) Editing a Package Specification

1. In the Database Explorer window, expand the Packages folder.
2. Right click a required package, and then click Open Package, to open its specification.

ExpandedToggleIcon(9x12) Executing a Stored Procedure within a Package

1. In the Database Explorer window, expand the Packages folder.
2. Expand a required package.
3. Select a required procedure, and then click Execute.

If a procedure accepts parameters you will see the Parameters dialog where you can assign initial values for procedure arguments. Once the routine is executed you will see appropriate record in the Output window.

If a package is invalid you have to compile it to make it work. To do it, choose Compile from package's shortcut menu. The whole package is considered invalid if at least one procedure or function that make up its body is invalid. Read more about the matter in topic Working with Procedures and Functions.

ExpandedToggleIcon(9x12) See Also

Packages

Package Body


Package Body

Package body is the initialization part of the package. It defines the queries for cursors and the code for subprograms included into the package. Procedure implementation details and private declarations are encapsulated in the package body and they are hidden from code outside the package.

note Note

Sometimes package body is unnecessary.

note Note

Subprograms defined in a package body are accessible outside the package only if their declarations are also present in the package specification. If a subprogram declaration is not included into the package specification, that subprogram can be called only by other subprograms in the same package.

PL/SQL allows two or more packaged subprograms to have the same name. This option is useful when you want a subprogram to accept similar sets of parameters that have different data types.

ExpandedToggleIcon(9x12) Creating a Package Body

1. In the Database Explorer window, expand the Packages folder.
2. Right click a required package, and then click Create Package Body.
3. Fill a template with statements. dbForge Studio adds the CREATE/REPLACE words for you.
4. Save the document.

ExpandedToggleIcon(9x12) Editing a Package Body

1. In the Database Explorer window, expand the Packages folder.
2. Right click a required package, and then click Open Package Body, to open its realization.

ExpandedToggleIcon(9x12) See Also

Packages

Package Specification


Packages and Programs Compilation

If a package, an object or a stored procedure is invalid you have to compile one to make it work.

The whole package is considered invalid if its specification contains errors. An object status is also determined by the validity of its specification. Project body or object body becomes invalid if at least one procedure or function that makes up the body is invalid. Stored procedure or function is invalid when its code contains errors.

PL/SQL programs can be compiled by right-clicking the node in the Database Explorer window, and choosing corresponding command from the Compile submenu of the shortcut menu. You can compile PL/SQL programs with or without debug information.

ExpandedToggleIcon(9x12) Compilation Warnings

When working with Oracle server 10.1 or higher, you can enable compilation warnings. By default compilation warnings are ignored. To enable them, perform the following steps:

1. In the Database Explorer window, right click a connection, and then click Modify Connection from the shortcut menu.
2. Go to the Advanced tab.
3. Select the Show PL/SQL compilation warnings check box.
4. Click OK.

After performing these steps you can work with PL/SQL compilation warnings in the same way as with compilation errors.

ExpandedToggleIcon(9x12) See Also

Compiling Database Objects

Packages

PL/SQL Objects


Object Types

An object type is a user-defined composite datatype representing a data structure and functions and procedures to manipulate the data. The variables declared in the object specification are called object attributes. The functions and procedures of the object type are object methods.

Like a package, an object type has a specification and a body. The specification defines the programming interface; it declares a set of attributes and the specifications of methods to manipulate the data. The body defines the code for the methods.

ExpandedToggleIcon(9x12) In This Section

Object Type Specification
Contains information on working with object type specification.

Object Type Body
Contains information on working with object type body.

ExpandedToggleIcon(9x12) See Also

PL/SQL Objects


Object Type Specification

The specification is the interface of the object type. It contains declarations of attributes and methods. The specification contains public declarations, which are accessible outside the object type. You can call object methods and attributes using dot notation. In the interface part of object type, you are to declare all attributes before the methods, otherwise PL/SQL compilation error will occur.

If the object type specification has only attributes, it is not necessary to create type body. You can't declare constants, exceptions, cursors, or types in the object specification. You must declare at least one attribute but less than 1000 ones in the specification.

Attribute name attribute must be unique within the object type.

PL\SQL does not allow creating attributes of such data types:

· LONG and LONG RAW
· ROWID and UROWID
· The PL/SQL-specific types BINARY_INTEGER (and its subtypes), BOOLEAN, PLS_INTEGER, RECORD, REF CURSOR, %TYPE, and %ROWTYPE
· Types defined inside a PL/SQL package

Generally object method is declared using the keyword MEMBER or STATIC. To call MEMBER methods the instance of this type is to be created. STATIC methods can be invoked on object types when no object of such type exists. Like other subprograms, methods have two parts: a declarative one and a subprogram body. The declarative part consists of the method name, parameter list, and return type(for functions). The body is the code that is executed to perform a specific task.

Specify MAP or ORDER methods to provide the possibility of comparison and sorting of objects.

ExpandedToggleIcon(9x12) Creating an Object Type Specification

1. In the Database Explorer window, expand the User Types folder.
2. Right click the Object Types folder, and then click New Object Type in the shortcut menu.
3. Fill a template with statements. dbForge Studio adds the CREATE/REPLACE words for you.
4. Save the document.

ExpandedToggleIcon(9x12) Editing an Object Type Specification

1. In the Database Explorer window, expand the User Types folder.
2. Expand the Object Types folder.
3. Right click a required object, and then click Open Type in the shortcut menu.

To delete an object type, right click a required object, and then click Delete in the shortcut menu.

ExpandedToggleIcon(9x12) See Also

Object Type Body

Object Types


Object Type Body

Object type body defines code for object methods. Procedures and functions implementation details are encapsulated in the object body and they are hidden from code outside the object.

note Note

Sometimes object body is unnecessary.

note Note

You are not allowed to declare attributes in the body, so all items in the object type specification are public (visible outside the object type).

Like package procedures and functions, object type methods can be overloaded. You can create several methods with the same name but with the different parameter set within the object. When calling object subprogram, PL/SQL distinguishes the correct method by comparing actual parameters with the formal ones.

ExpandedToggleIcon(9x12) Creating an Object type Body

1. In the Database Explorer window, expand the User Types folder.
2. Expand the Object Types folder.
3. Select a required object, and then click Create Type Body in the shortcut menu.
4. Fill a template with statements.
5. Save the object body.

ExpandedToggleIcon(9x12) Editing an Object type Body

1. In the Database Explorer window, expand the User Types folder.
2. Expand the Object Types folder.
3. Right click a required type, and then click Open Type in the shortcut menu.

ExpandedToggleIcon(9x12) See Also

Object Type Specification

Object Types


Other Schema Objects

ExpandedToggleIcon(9x12) In This Section

Database Links
The topic describes how to create, edit, and use database links.

Materialized Views
The topic describes how to create a materialized view.

Materialized View Logs
The topic describes materialized view logs.

Collection Types
The topic describes how to work with user array and table types.

Clusters
The topic describes how to work with clusters.

Sequences
The topic describes how to create, edit, and use sequences.

Synonyms
The topic describes how to create, edit, and use synonyms.

Triggers
The topic describes how to create, edit, and use triggers.

XML Objects
The topic describes how to create, edit, and use XML objects.

ExpandedToggleIcon(9x12) See Also

Working with Database Objects

Walkthrough


Database Links

Database links are pointers that define a one-way communication path from an Oracle Database server to another database server.

ExpandedToggleIcon(9x12) Creating a Database Link

To create a database link, you must have the CREATE SESSION privilege on the remote database. You must also have CREATE DATABASE LINK privilege to create a database link and CREATE PUBLIC DATABASE LINK to create a public database link.

1. On the Standard toolbar, click New Database Object.
2. Select the Database Link type in the dialog.
3. Input a database link name. If specified name is unique, the DbLink editor document will appear.
4. Set connection details (service name and type of the link). For more information about database link types refer to Oracle documentation.
5. Optionally select Public or Shared check boxes to create public or shared database link. For shared database link specify user name and password to use when connecting to the remote database. On the text view the password can be seen unencrypted. Note that only DBA can see whether the database link is shared after creation.
6. Save the document

To delete a database link, right click a required link, and then click Delete in the shortcut menu.

ExpandedToggleIcon(9x12) See Also

Synonyms

Working with Database Objects


Materialized Views

Materialized view is a database object, that contains the results of a query.

Using dbForge Studio you can create, edit and delete materialized views.

ExpandedToggleIcon(9x12) Creating a Materialized View

1. On the Standard toolbar, click New Database Object.
2. Select the Materialized View type in the dialog.
3. Input a materialized view name.
4. Click Create. If specified name is unique, the materialized view editor appears.
5. Type a query that will represent the materialized view.
6. Optionally you can alter the name or change owner in which the new materialized view will be created.
7. Optionally switch to the Options tab and set materialized view creation and refresh parameters.
8. You can set materialized view storage options, indexes, constraints and partitioning settings in the same way that you do for tables. For more information read Defining Table Structure and Partitioned Tables.
9. Save the document.

note Note

Materialized views can be index-organized and clustered. To create index-organized or clustered materialized view select corresponding option on General tab. You can set additional parameters for clustered or index-organized materialized views just like setting these parameters for clustered or index-organized tables.

ExpandedToggleIcon(9x12) Editing a Materialized View

1. In the Database Explorer, expand the Materialize View folder.
2. Select a required materialized view, and click Edit Materialized View in the shortcut menu.

To delete a materialized view, select a required materialized view, and click Delete in the shortcut menu.

ExpandedToggleIcon(9x12) See Also

Materialized View Logs

Views

Working with Database Objects


Materialized View Logs

Materialized view log is a table associated with the master table of a materialized view. When changes are made to master table data, Oracle Database stores those changes description in the materialized view log and then uses the materialized view log to refresh materialized views based on the master table.

ExpandedToggleIcon(9x12) Setting materialized view log parameters

You cannot set materialized view log name and owner. Materialized view log name is always autogenerated by Oracle. It is 'MLOG$_' + name of the table, on which it is being created. It also has the same owner as the table, on which it is being created.

Materialized view log options determine what materialized view log should record when data in the master table is changed. One of the following options should be set when creating materialized view log.

· Primary Key
· Row ID
· Object ID

Primary key option is automatically set by default when no other option is set. So to clear this option, select another one at first. Materialized view log can have Object ID option selected only when it is created for object table. Sequence option is vailable only when creating materialized view log on Oracle 10g and higher.

You can select additional table columns to record them in materialized view log for all changed rows of master table in the Columns grid. Note, that if primary key option is set, you can not select primary key columns. In that case they are automatically implicitly included.

Partitioning and storage parameters can be set just like corresponding parameters for the table.

ExpandedToggleIcon(9x12) Creating a Materialized View Log

1. On the Standard toolbar, click New Database Object.
2. Select the Materialized View Log type in the dialog.
3. Specify a table name and schema, on which materialized view log will be created.
4. Set materialized view log options.
5. Optionally select columns to record them in materialized view log for all changed rows of master table in the Columns grid.
6. Optionally set storage and partitioning parameters on the corresponding tabs.
7. Save the document.

ExpandedToggleIcon(9x12) Editing a Materialized View Log

You can edit materialized view by selecting Edit Materialized View Log from the shortcut menu. In the opened document you alter materialized view parameters. Save the document to apply changes you made. When editing materialized view log you can only select additional options, you can not deselect already selected options.

ExpandedToggleIcon(9x12) See Also

Materialized Views

Working with Database Schema Objects


Collection Types

User-defined array type is an ordered set of elements, each of same datatype.

Using dbForge Studio for Oracle you can create, edit and delete varray and table types.

ExpandedToggleIcon(9x12) Creating a Varray or Table Type

1. In the Database Explorer window, expand the User Types folder.
2. Right click the Array Types folder, and then click New Array Type in the shortcut menu.
3. Provide type name in dialog box opened. Optionally you can change schema in which the type should be created.
4. Click the Create button.

A new document appears with template in the Design view. Choose type parameters and save the document to have the type created. You can switch to the Text view to inspect generated SQL query.

ExpandedToggleIcon(9x12) Editing a Varray or Table Type

1. In the Database Explorer window, expand the User Types folder.
2. Expand the Array Types or the Table Types folder.
3. Right click a required type, and then click Edit Type in the shortcut menu.

To compile a varray type or a table type, right click a required type, and then click Compile in the shortcut menu. If operation succeeds a type changes its status from invalid to valid.

To delete a type, click Delete in the shortcut menu.

ExpandedToggleIcon(9x12) See Also

Working with Schema Objects


Clusters

Clusters are the schema objects that contain data of one or more tables, that are physically stored together, when tables share common columns and are often used together.

Oracle have two types of clusters - index and hash clusters. In index clusters table rows, that have the same values of the cluster key columns, are stored together. Cluster index must be created for index cluster. It always contains all the cluster columns. In hash clusters table rows, that have the same result of applying hash function to the cluster key value, are stored together.

dbForge Studio allows you to create and edit both types of clusters.

ExpandedToggleIcon(9x12) Creating and Editing a Cluster

To create a cluster

1. Click NewDatabaseObjectButton the New Database Object button on the Standard toolbar.
1. Select the Cluster type in the dialog.
2. Input the cluster name. It is not recommended that a table and a cluster have the same name.
3. Click the Create button. If specified name is unique, the cluster editor document will appear.
4. Add required cluster key columns to the cluster.
5. Optionally you can alter the name or change schema (owner).
6. Switch to the Advanced tab, and set cluster type, size, and other parameters.
7. For index clusters you can optionally click the Edit button, and edit a cluster index name, and storage parameters. It includes all the cluster column, and its column list can not be changed.
8. Optionally you can switch to the Storage tab and set cluster storage parameters.
9. Save the document.

To edit a cluster

1. In the Database Explorer window, expand the Clusters folder.
2. Right click a required cluster, and then click Edit Cluster in the shortcut menu.

To delete a cluster

3. In the Database Explorer window, expand the Clusters folder.
4. Right click a required cluster, and then click Delete in the shortcut menu.

ExpandedToggleIcon(9x12) See Also

Other Schema Objects

Sequences


Sequences

Sequence is a database object from which multiple users may generate unique integers.

Using dbForge Studio you can create, edit and delete sequences.

ExpandedToggleIcon(9x12) Creating a Sequence

1. In the Database Explorer window, right click the Sequences folder, and then click New Sequence in the shortcut menu.
2. A new template document appears.
3. Choose sequence parameters and save the document to have the sequence created. You can switch to the Text view to inspect generated SQL query.

ExpandedToggleIcon(9x12) Editing a Sequence

1. In the Database Explorer window, expand the Sequences folder.
2. Right click a required sequence, and then click Edit Sequence in the shortcut menu.

By default, dbForge Studio creates ascending sequence that starts with 1, increments by 1, has 20 values cached (Oracle default), and is not limited.

ExpandedToggleIcon(9x12) Deleting a Sequence

1. In the Database Explorer window, expand the Sequences folder.
2. Right click a required sequence, and then click Delete in the shortcut menu.

ExpandedToggleIcon(9x12) See Also

Working with Schema Objects

Synonyms

Triggers


Synonyms

Synonym is an alternative name for a table, view, sequence, procedure, stored function, package, materialized view, Java class schema object, user-defined object type, or another synonym. Synonyms provide both data independence and location transparency. Synonyms permit applications to function without modification regardless of which user owns the table or view and regardless of which database holds the table or view. Using dbForge Studio you can create, edit and delete synonyms.

ExpandedToggleIcon(9x12) Creating a Synonym
1. In the Database Explorer window, right click the Synonyms folder, and then click New Synonym in the shortcut menu.
2. Provide a synonym name in the opened dialog box. Optionally, you can change schema for the object.
3. Click Create.

A new document appears with template in Design view. Choose synonym parameters and save the document to have the synonym created. You can switch to Text view to inspect generated SQL query.

ExpandedToggleIcon(9x12) Editing a Sequence

1. In the Database Explorer window, expand the Synonym folder.
2. Right click a required sequence, and then click Edit Synonym in the shortcut menu.

Editing a synonym is as easy as the following 4 steps:

1. Choose whether the object is located in the same database or remote one.
2. For local database choose object type, for the remote one choose database link.
3. Choose an object schema.
4. Choose an object name.

For local database the available names are automatically suggested in drop-down lists. In case of remote database you have to input object's schema and name yourself.

ExpandedToggleIcon(9x12) Deleting a Synonym

1. In the Database Explorer window, expand the Synonym folder.
2. Right click a required synonym, and then click Delete in the shortcut menu.

ExpandedToggleIcon(9x12) See Also

Database Links

Working with Schema Objects


Triggers

ExpandedToggleIcon(9x12) Triggers Overview

A trigger is a named PL/SQL unit that is stored in the database and fired in response to a specified event that occurs in the database.

The specified event is associated with either a table, a view, a schema, or the database, and it is one of the following:

· A database manipulation (DML) statement (DELETE, INSERT, or UPDATE)
· A database definition (DDL) statement (CREATE, ALTER, or DROP)
· A database operation (SERVERERROR, LOGON, LOGOFF, STARTUP, or SHUTDOWN)

The trigger is said to be defined on the table, view, schema, or database.

ExpandedToggleIcon(9x12) Trigger Types

A DML trigger is fired by a DML statement, a DDL trigger is fired by a DDL statement, a DELETE trigger is fired by a DELETE statement, and so on.

A system trigger is defined on a schema or the database. A trigger defined on a schema fires for each event associated with the owner of the schema (the current user). A trigger defined on a database fires for each event associated with all users.

A simple trigger can fire at exactly one of the following timing points:

· Before the triggering statement executes
· After the triggering statement executes
· Before each row that the triggering statement affects
· After each row that the triggering statement affects

An INSTEAD OF trigger is a DML trigger that is defined on a view (not a table). The database fires the INSTEAD OF trigger instead of executing the triggering DML statement.

ExpandedToggleIcon(9x12) Creating a Trigger

1. In the Database Explorer window, right click the Triggers folder, and then click New Trigger.
2. Select a database object to assign a trigger on it. You can select either Table, View, Schema, Database.
3. Enter a trigger body.
4. Go to the Event tab, and set Timing and Event.
5. Save the document.

ExpandedToggleIcon(9x12) Editing a Trigger

Edit a trigger by selecting Edit Trigger from the Database Explorer node shortcut menu. In the opened document, you can alter the query text. Save the document to apply changes you've made to the query text.

ExpandedToggleIcon(9x12) Dropping a Trigger

Drop a Trigger by selecting Delete from the Database Explorer node shortcut menu.

ExpandedToggleIcon(9x12) Enabling and Disabling Triggers

Enable or disable a trigger by selecting Enable or Disable from the Database Explorer node shortcut menu.

To enable or disable all triggers at once, select Enable All or Disable ALL from the Database Explorer node shortcut menu.

ExpandedToggleIcon(9x12) See Also

Other Schema Objects

XML Objects


XML Objects

dbForge Studio allows you to create XML schemas and XML tables. These features are available for 10g (and higher) Oracle Servers with XML schema support. If you don't see XML schemas node in the Database Explorer, your Oracle server instance does not support XML schemas.

This section provides information about working with XML schemas and creating XML Tables in dbForge Studio.

ExpandedToggleIcon(9x12) In This Section

How To: Create XML Schema
Provides information about how to create XML Schema.

How To: Drop XML Schemas
Provides information about dropping XML Schemas.

Creating and Dropping XML Tables
Provides information about how to create XML table.

ExpandedToggleIcon(9x12) See Also

Working with Schema Objects


How To: Create XML Schema

ExpandedToggleIcon(9x12) Creating an XML Schema

1. In the Database Explorer window, right click the XML Schemas folder, and then click New XML Schema in the shortcut menu.

note Note

If there is no such menu command, this instance of the Oracle server does not support XML objects, and you can not create XML schema on it.
2. Specify the owner of the XML schema.
3. Specify if the schema should be loaded from the file or from the URL and provide the source name. You can choose the Specify Text option to put XML text manually without loading it from any source. If option Public is selected the object will be available out of the other schemas.
4. Go to the Advanced tab, and set the options for the schema generation.
5. Save the document to have the XML Schema created. You can switch to the Text view to inspect generated SQL query.

To view XML schema properties, in the Database Explorer window, expand the XML Schemas folder, right click a required object, and then click View properties in the shortcut menu.

note Note

It is not allowable to edit stored XML schemas.

ExpandedToggleIcon(9x12) See Also

How To: Drop XML Schemas

Creating and Dropping XML Tables

XML Objects


How To: Drop XML Schemas

Dropping XML Schemas provides some peculiarities. There can be objects depending on the given XML schema, so be careful while deleting XML schema, for these objects will become inaccessible for editing and deleting operations if the source XML schema is dropped but the dependent objects are not.

Four options for XML schema deleting exist:

· DELETE_RESTRICT: Schema deletion fails if there are any tables or schemas that depend on this schema.
· DELETE_INVALIDATE:Schema deletion does not fail if there are any dependencies. Instead, it simply invalidates all dependent objects.
· DELETE_CASCADE: Schema deletion will also drop all default SQL types and default tables. However the deletion fails if there are any stored instances conforming to this schema.
· DELETE_CASCADE_FORCE: Similar to CASCADE except that it does not check for any stored instances conforming to this schema. Also it ignores any errors.

To drop an XML Schema, expand the XML Schemas folder in the Database Explorer. Right-click a required object, and click Delete in the shortcut menu. The dialogue asking if the object has to be dropped appears. Select Yes to delete an XML Schema.

ExpandedToggleIcon(9x12) See Also

How To: Create XML Schema

Creating and Dropping XML Tables

XML Objects


Creating and Dropping XML Tables

ExpandedToggleIcon(9x12) Creating an XML Table

1. Click the New Database Object button on the Standard toolbar and specify an object type.
2. Select the XML Table type in the dialog.

note Note

If there is no such menu command, this instance of the Oracle server does not support XML objects, and you can not create XML table on it.
3. Input the table name.
4. Specify the owner of the XML schema, choose the schema to contain the object being created, the source XML schema and the element to be stored in the table.
5. You can also specify storing options of the table.
6. Click the Create button. If specified name is unique the table will appear in the Database Explorer.

ExpandedToggleIcon(9x12) Deleting an XML Schema

1. In the Database Explorer window, expand the XML Schemas folder.
2. Right click a required schema, and then click Delete in the shortcut menu.
3. Click Yes in the appeared dialog.

note Note

When you drop a table all data containing in it is lost.

ExpandedToggleIcon(9x12) See Also

Working with Tables

XML Objects


Walkthrough

ExpandedToggleIcon(9x12) In This Section

How To: Create a Copy of Schema Object
The topic describes the duplicate object feature.

How To: Dispaly the Number of Schema Objects
This topic describes how to display the number of database objects.

How To: Generate DDL Statements for Schema Objects
The topic describes how to generate a DDL script.

How To: Filter Schema Objects
The topic describes how to filer schema objects.

How To: Delete Schema Objects
The topic describes how to delete schema objects.

How To: View Object Dependencies
The topic describes the Object Dependencies tree.

Compiling Schema Objects
The topic explains how to compile schema objects.

ExpandedToggleIcon(9x12) See Also

Working with Schema Objects


How To: Create a Copy of Schema Object

dbForge Studio for Oracle gives you the duplicate object feature. You can make an exact copy of a database object in the same or different database of the same server. It can be very useful for database designers.

To copy an object, right-click its node and select Duplicate Object in the shortcut menu. Then select destination database and type a new object name. If the selected object is a table, you can copy data from it or create an empty table copy.

Note that if you copy a table with foreign key constraints, these constraints will not be copied because there may be no referenced tables in the target database.

You can copy objects of following types:

· Tables
· Views
· Sequences
· Array and table types

ExpandedToggleIcon(9x12) See Also

Working with Schema Objects

How To: Generate DDL Statements for Schema Objects


How To: Dispaly the Number of Schema Objects

How To: Display the Number of Database Objects

dbForge Studio enables to display the number of existing schema objects.

To display the number of schema objects, in Database Explorer, right-click a schema object node. The number of schema objects is displayed in parentheses to the right of the node name.

note Note

If a schema object node includes sub-nodes (for example, Functions), the object number is not displayed. Instead, the object number for each sub-node is displayed separately.

ExpandedToggleIcon(9x12) See Also

Walkthrough

Working with Schema Objects


How To: Generate DDL Statements for Schema Objects

dbForge Studio for Oracle allows you to generate DDL statements for schema objects, such as: tables, views, synonyms, sequences, packages, materialized views and materialized view logs, stored procedures and functions, triggers and user types. Using this feature you can make scripts for recreating schema objects or object groups.

Generating DDL Script

1. On the Database menu, and then click Generate Schema Script.
2. Check schema objects for DDL script generation. (If you run the wizard from the shortcut menu of the single object node, this step will be skipped. You can return to it by clicking the Back button on the Script Generation Options page).
3. Click Next if the Script Generation Options page was not turned off and go to step 4, otherwise, go to step 5.
4. Select DDL generation options you want to tweak. You can set default values of these options in the Options dialog.
5. Click Generate.

You can turn off Generate Schema Script Wizard appearing when generating the DDL statement for the single object.

ExpandedToggleIcon(9x12) See Also

Working with Schema Objects

How To: Filter Schema Objects


How To: Filter Schema Objects

With dbForge Studio for Oracle you can create a filter for schema objects in accordance with a certain criteria.

Creating a Filter

1. To create a filter for a schema category (for example, Tables), right-click on its node and select Filter from the shortcut menu. Alternatively, select an object category node and click Filter on the Database Explorer toolbar.

fileter-shortcut
2. In the Filter Settings dialog box, specify parameters for a filter in Criteria:
· In the Property column, select the required property (Name, Schema or Owner).
· In the Operator column, select the matching type of the filter syntax (Equals, Not Equals, Contains, Starts With, Ends With).
· In the Pattern column, enter the full or partial syntax of the property or properties you want to apply to a filter.
3. Check All or Any to make a filtered object comply with all or any criteria.
4. Click OK.

When a filter is applied to a certain database object category, it is labeled as (filtered).

Deleting a Filter

To delete a filter, right-click an object category node and select Clear Filter from the shortcut menu.

ExpandedToggleIcon(9x12) See Also

Walkthrough

How To: Delete Schema Objects


How To: Delete Schema Objects

With dbForge Studio for Oracle you can delete any schema object immediately from the Database Explorer window.

Deleting a Schema Object

1. Right-click a schema object in Database Explorer and select Delete from the shortcut menu.
2. In the new dialog box, click OK if you confirm the object's deletion, or No to terminate it.

ExpandedToggleIcon(9x12) See Also

Walkthrough

How To: View Object Dependencies


How To: View Object Dependencies

The Objects Dependencies tree, introduced in dbForge Studio for Oracle, offers a fast a simple way to view and navigate trough schema object dependencies, that belong to each schema object.

Each of available schema objects within Database Explorer has Depends On and Used By collections.

The Depends On collection includes schema objects that must be present for the object to function properly.

The Used By collection includes schema objects that depend upon the selected object.

In its turn, you can expand any object within Used By or Depends On to analyze its own dependencies.

Right-click any database element to learn more abut it, find it in Database Explorer etc. (the list of available options depends on an object's type).

ExpandedToggleIcon(9x12) See Also

Walkthrough

Compiling Schema Objects


Compiling Schema Objects

If a view, package, object, or stored procedure is invalid you have to compile it to make it work. Schema objects can be compiled by right-clicking the node in the Database Explorer window, and choosing corresponding command from the Compile shortcut menu.

ExpandedToggleIcon(9x12) Compiling Dependants and References

When you change an object, its descendants can become invalid. In such cases you may need to recompile them. dbForge Studio allows you to compile object's dependants and references. To do this, right-click the node in the Database Explorer and choose corresponding command from the Compile shortcut menu.

ExpandedToggleIcon(9x12) See Also

Packages and Programs Compilation

Working with Schema Objects


Searching for Objects and Data

This section describes how to perform object and data search with dbForge Studio.

ExpandedToggleIcon(9x12) In This Section

How To: Search Database Objects
Describes how to quickly find a schema objects

How to: Search Table ad View Data
Describes how to find data.

How To: Manage Search Results
Describes how to review, sort, and filter search results.


How to: Search Schema Objects

This topics discusses how to search for objects in a database using dbForge Studio.

Search

1. Click Find Object on the Database menu toolbar or press Ctrl+F, D.
2. Click object-search to switch to the Search objects by name and DDL mode.
3. In the Search text box, enter the search string.
4. Optionally, click find-options to select an additional find option from the drop-down list box. The available options are Match Case, Match Whole Word and Use WildCards. By default, the Use WildCards option is selected.
5. Optionally, click group-results to group results by the object type.
6. You can change the scope of search results by specifying the search parameters, such as an object type, database, and connection to search in.
· Object types. Select object types, in which the search will be performed. By default, all object types are selected.
· Schema. Select a schema to search in from a drop-down list. The schema you are currently connected to is selected by default.
· Connection. Select a connection for search from a drop-down list. The connection you are currently using is selected by default.
7. To start the search, Click Start Search in the Search text box. During the search, you will see the button with a binocular and a progress spinner indicating that the search is in progress. You can stop the search at any point by clicking the binocular button.

8. When the search is completed, the details of search results will be displayed in the Search Results grid.
9. Optionally, you can set a filter for each column in the Search Results grid.
10. When you select a result in the grid, the Preview window below the grid displays the DDL statements associated with the selected result.

ExpandedToggleIcon(9x12) See Also

How to: Search Table ad View Data

Working with Search for SQL Server


How to: Search Table ad View Data

How to: Search Table and View Data

This topics discusses how to search for data in database tables and views using dbForge Studio.

Data Search

1. Click Find Object on the Database menu toolbar or press Ctrl+F, D.
2. Click search-data to switch to the Search Table and View Data mode.
3. In the Search text box, enter the search string.
4. Optionally, click find-options to select an additional find option from the drop-down list box. The available options are Match Case, Match Whole Word and Use WildCards. By default, the Use WildCards option is selected.
5. Optionally, click group-results to group results by the object type.
6. You can change the scope of search results by specifying the search parameters, such as objects, a database, and a connection to search in.
· Objects. Select objects, in which the search will be performed. By default, all objects are selected.
· Database. Select a database to search in from a drop-down list. The database you are currently connected to is selected by default.
· Connection. Select a connection for search from a drop-down list. The connection you are currently using is selected by default.
7. To start the search, Click start-search-button in the Search text box. During the search, you will see the button with a binocular and a progress spinner indicating that the search is in progress. You can stop the search at any point by clicking the binocular button.

8. When the search is completed, the details of search results will be displayed in the Search Results grid.
9. Optionally, you can set a filter for each column in the Search Results grid.
10. When you select a result in the grid, the Preview window below the grid displays the records that match the search criteria.

ExpandedToggleIcon(9x12) See Also

How to: Manage Search Results

Working with Search for SQL Server


How to: Manage Search Results

This topic discusses how you can manage search results.

Sort and Filter Search Results

dbForge Studio allows you to quickly sort search results. You can sort records in each column by ascending or descending alphabetic order by clicking a column heading.

To apply filter to a column:

1. Hover a cursor over a column heading. The Filter button filer-button will appear its upper right corner.

2. Click the Filter button and select an item from the drop-down list. All the records corresponding to this item will be displayed in the grid.
3. Optionally, select the "Custom" option from the drop-down list. The Custom AutoFilter window will appear, where you can fine tune the filter.

4. The filters currently applied to the search results may be edited in the Filter Editor. To evoke the editor, click the Edit Filter button in the lower right corner of the Search Results grid.

Find Object in Object Explorer

dbForge Studio can navigate you to an object in the Object Explorer directly from the dbForge Studio window.

1. Double-click the object in the Test Results grid; or
2. Right-click the object in the Test Results grid and select Find in Object Explorer from the context menu;
3. Select the object in the Test Results grid and click the Find in Object Explorer button [image] below the grid.

Word Wrap

Click the Word Wrap button word-wrap to set and clear the Word Wrap option for source code displayed in the Preview window. When the option is enabled, all the text shall fit the current width of the Preview window.

Line Numbers

Click the Show line numbers button line-numbers to set or clear numbers for lines of the source code displayed in the Preview window.

ExpandedToggleIcon(9x12) See Also

How to: Search Database Objects

Working with Search for SQL Server


Designing Databases with Database Designer

Database Designer allows you to view and edit a database in a convenient visual way. You can observe all database objects, see foreign key relations between tables, view database objects information, easily access database objects for editing, retrieving data, executing stored routines. Database object shortcut menu on the diagram provides access to the same actions as the shortcut menu of the database object in the Database Explorer. Shapes representing a database object can be moved (by dragging them with mouse or keyboard), resized, aligned to the diagram grid. Diagram can be saved for future use.

With Database Designer, you can also perform reverse engineering of databases to IDEF1X or IE diagrams, that can be easily printed.

ExpandedToggleIcon(9x12) In This Section

How To: Create a Database Diagram
The topic explains how to create a database diagram.

How To: Add Database Objects to a Diagram
Describes how to add existing database objects to the diagram, or create new ones, how to quickly add multiple existing objects, etc.

How To: Delete or Edit Database Object on a Diagram
Describes how to delete database objects from the diagram or edit them.

How To: Create a Many-to-Many Relationship Between Tables
The topic explains how to create many-to-many relationship between tables.

How To: Save and Restore a Diagram
The topic explains how to save and restore a diagram.

How To: Export a Diagram
This topic describes how to export database diagram to an image file.

How To: Quickly Print a Diagram
The topic describes how to print a diagram.

Searching Text on a Database Diagram
This topic contains information about searching database objects by text on the diagram.

Setting Diagram Options
This topic describes how to customize the diagram with the diagram options.

Additional Elements on a Diagram
The topic describes supplementary elements that can be displayed on a diagram.

Working with Database Objects on the Diagram
This section contains information about working with the database objects on the diagram.


How To: Create a Database Diagram

To create a database diagram, perform the following steps:

1. On the File menu select New, and then click Database Diagram.
2. Drag database objects from Database Explorer to the diagram. Alternately, right-click a database object, point to Send to, and that click Database Diagram. You can also create new database objects on the diagram using the Diagram toolbar.
3. You may click the Layout Diagram button on the Layout toolbar to layout diagram for a more convenient view. (Or set the diagram layout manually by dragging shapes and moving the relations. You can also use containers to organize the diagram.)
4. Add a stamp to the diagram to display company and project names, diagram author, version, date, and copyright. To add a stamp, click the New Stamp button on the Diagram toolbar. To edit stamp fields, double-click them and enter values. You can also add notes to the diagram to describe its objects.
5. Save the diagram for future use.

ExpandedToggleIcon(9x12) Navigating the Diagram

To navigate the diagram:

· Use the scrollbars.
· Move the mouse while holding the middle mouse button.
· Use the Diagram Overview window. Drag square visible area on the Diagram Overview window with the mouse.

To display the Diagram Overview window, on the View menu, click Other Windows, and then click Diagram Overview, or press CTRL+V, W.

· Search diagram shapes.
· Use the Document Outline window. It contains nodes, representing all shapes on the diagram. They are grouped by containers and by object kinds. Stamps and notes are placed to the Notes kind. Table nodes contains their relations.

You can zoom in and out the diagram to simplify the navigating. To quickly move to the area you need, click the Fit button on the Diagram toolbar, then hold CTRL+SHIFT and select the area you need with mouse pointer.

ExpandedToggleIcon(9x12) See Also

Designing Databases with Database Designer

How To: Add Database Objects to a Diagram


How To: Add Database Objects to a Diagram

To add existing database objects to a diagram:

· Drag a database object from Database Explorer and drop it to the diagram document.

OR

· In Database Explorer, right-click a database object, point to Send to, and then click Database Diagram.

To create new database objects, use Diagram toolbar buttons.

ExpandedToggleIcon(9x12) Adding Existing Database Objects

To add an existing database object, drag it from the Database Explorer. Select multiple database objects in the Database Explorer with SHIFT or CTRL key to drag them to the diagram.

This way, you can add tables, views, stored procedures, and functions to the diagram. Triggers are added to the diagram automatically with their tables.

If you drag a database to the diagram, all its objects will be added to the diagram.

note Note

You cannot add database objects from a different connection to the same diagram.

Foreign key relations are displayed on the diagram automatically when both of the connected tables are displayed on the diagram.

ExpandedToggleIcon(9x12) Creating New Database Objects

To create a new database object on the diagram, perform the following steps:

1. Click the corresponding button on the Diagram toolbar to create a corresponding database object, and then on the diagram sheet. A dialog box with the corresponding database object editor will appear.
2. Set all required database object settings in the editor and click OK to create the database object.

You can also open the database object editor dialog by right-clicking a diagram and choosing items from the New submenu of the shortcut menu.

To create a new foreign key relation between two diagram tables, you may perform the following steps:

1. Click the New Relation button on the Diagram toolbar.
2. Click the child table and move the mouse pointer, holding the mouse button pressed, to the parent table. Then release the mouse button. A partially initialized New Foreign Key Dialog Box will appear.
3. Specify the missing parameters in the dialog box and click OK.

ExpandedToggleIcon(9x12) See Also

Designing Databases with Database Designer

How To: Delete or Edit Database Object on the Diagram


How To: Delete or Edit Database Object on a Diagram

ExpandedToggleIcon(9x12) How to Delete Database Object from Diagram

To delete a shape from the diagram but keep a database object in the database, click the object and hit the DELETE key or right-click the object and select Remove from Diagram from the shortcut menu.

To remove database object from the database, click the object and press CTRL+DELETE or right-click the object and select Remove from Diagram from the shortcut menu.

Table columns, indexes, constraints, triggers, relations (foreign keys) can only be dropped from a database. Both DELETE and CTRL+DELETE keys invoke dropping. View columns and stored routine parameters cannot be deleted.

ExpandedToggleIcon(9x12) How to Edit Database Object on Diagram

To edit a database object, double-click it on the diagram. An object editor dialog will appear. The object editor dialog is the same as object editor document except for the bottom buttons. Reset discards all changes to the database object on any tab of the editor (but not the changes to the table or view data on the data view), OK button closes the dialog and saves all changes, Cancel button closes the dialog and discards all changes. You can edit database object in this dialog just like in the object editor document.

EditorDialog

ExpandedToggleIcon(9x12) See Also

Designing Databases with Database Designer

How To: Create a Many-to-Many Relationship Between Tables


How To: Create a Many-to-Many Relationship Between Tables

Many-to-many relationships between tables are accommodated in databases by means of junction tables. A junction table contains primary key columns of the two tables you want to relate.

To create a many-to-many relationship between tables in dbForge Studio for Oracle you need to:

1. Create/Open a database diagram.
2. Add the tables that you want to create a many-to-many relationship between.
3. Create a third table by right-clicking within the database diagram, and then clicking New Table.

This will become a junction table.

4. In the table editor's dialog box, enter a name for the table.

For example, the junction table between the Customer table and the Supplier table is named CustomerSupplier.

5. Copy the primary key columns from each of the other two tables to the junction table.

You can add other columns to this table, just as you can to any other table.

6. In the junction table, set the primary key to include all primary key columns from the other two tables.
7. Define a one-to-many relationship between each of the two primary tables and the junction table.

note Note

The creation of a junction table in a database diagram does not insert data from the related tables into the junction table. You can copy rows from one table to another or within a table using an Insert From query.

ExpandedToggleIcon(9x12) See Also

Designing Databases with Database Designer

How To: Save and Restore a Diagram


How To: Save and Restore a Diagram

Diagrams can be saved and restored just like any other document by using Save and Open buttons on the Standard toolbar.

Diagram does not store information about database object details offline. So, when you open the diagram, dbForge Studio will try to establish connection with Oracle database containing objects of the diagram. If the connection cannot be established, the diagram will not be opened.

Diagram stores the following information when saved to a file:

· layout information
· information about containers, notes, stamps
· connection information
· diagram database object names and owners
· names of the foreign keys, displayed on the diagram as relations
· diagram options

If the diagram database was modified after saving the diagram, diagram updates information about all database objects displayed on it, when opening. But the newly created objects in the database do not appear on the diagram. If the diagram object was deleted from the database, it is deleted from the diagram.

ExpandedToggleIcon(9x12) See Also

Designing Databases with Database Designer

How To: Export a Diagram


How To: Export a Diagram

Diagrams can be exported to various image formats. dbForge Studio supports the following formats for diagram export: bmp, jpg, gif, png, tif, emf.

To export a diagram to an image, perform the following steps:

1. Right-click the diagram and select Export to Image from the shortcut menu.
2. Specify the target file's name and image format.
3. Click the Save button.

ExpandedToggleIcon(9x12) Exporting Large Diagrams

Bitmap generating engine needs contiguous memory area for the bitmap. If the diagram is large, it is not always possible even if you have enough memory because of memory fragmentation. When such a problem occurs, you will get the following error: "The error occurred while diagram exporting. Probably the image is oversized. Try export to another format". This error occurs when exporting diagrams of about 10 000 x 10 000 pixels size and sometimes even with a smaller diagram.

What can be done:

1. Export the diagram to the vector format (emf).
2. Use third-party RAM defragmentation and applications optimization.
3. You may want to try to restart the application and export the diagram again.

ExpandedToggleIcon(9x12) See Also

Designing Databases with Database Designer

How To: Quickly Print a Diagram


How To: Quickly Print a Diagram

To print the diagram, perform the following steps:

1. Click the Display Print Markup button on the Diagram toolbar. The print markup grid will be displayed. Gray stripes show the page overlapping.
2. Layout a diagram for convenient view considering the print markup.
3. Select Print from the File menu.
4. After you have printed the diagram, you may turn off the print markup by choosing Print Markup from the diagram shortcut menu.

PageOptions

ExpandedToggleIcon(9x12) See Also

Designing Databases with Database Designer

Searching Text on the Database Diagram


Searching Text on the Database Diagram

dbForge Studio allows searching shapes by text. Database object shapes can be searched by their names and names of their members (columns, constraints, stored routine parameters). Search is also performed in stamp company name and project name fields, in notes, relation comments, container names.

To search for a database object, perform the following steps:

1. On the Edit menu, select Find and Replace, and then click Find in Files, or press CTRL+SHIFT+F.
2. Enter the text you search into the Find what field, and click the Find All button.
3. Double-click lines in the Find Results window to navigate to the found shapes.

ExpandedToggleIcon(9x12) See Also

Designing Databases with Database Designer

Setting Diagram Options


Setting Diagram Options

A database diagram can be tuned with a rich set of options. Options can be set either globally for all the diagram documents or separately for a particular one.

To set options for the current diagram, right-click it and choose Options from the shortcut menu to open the Diagram Options dialog box. You can reset options for the current diagram to default values (set globally) by using the Default button.

ExpandedToggleIcon(9x12) Changing Diagram Appearance

Database diagram supports three predefined skins which change its appearance. They are the Default skin, the Simple skin, and the IDEF1X skin. The Default skin uses the richest color palette. The Simple skin is optimized for printing and does not use gradients. The IDEF1X skin is mostly black-and-white to look like IDEF1X diagrams. To choose the skin, use the Skin Type drop-down list in the notations options.

You can use either IDEF1X or IE notation for relations. They can be switched by using the Relation Notation drop-down list.

With the notations options you can greatly customize the table shape look. You may hide its constraints, indexes, and triggers compartments, change its field detail level to display only column names, names with types or names with full types. Note that field detail level does not affect stored routines. Primary key columns may either be separated with horizontal line or placed with other columns.

On the General page of the Database Diagram section of Options Dialog Box you can customize diagram background color, shape shadows, and diagram grid.

ExpandedToggleIcon(9x12) Setting Diagram Printing Options

Page options allow you to set such page settings as orientation (portrait or landscape), paper size and source, printing margins and overlapping, header and footer text.

PageOptions

Print options allow setting parameters for positioning printed image in the center, diagram scale, and whether to print diagram grid. Diagram scale may be set either manually, using Scale field, or automatically to fit the desired number of pages. They also allow you to set up printing of the page markup that helps you to glue diagram pages together.

ExpandedToggleIcon(9x12) See Also

Designing Databases with Database Designer

Additional Elements on a Diagram


Additional Elements on a Diagram

ExpandedToggleIcon(9x12) Notes

Notes are yellow boxes with text you can add to the diagram to explain some diagram parts. Notes can be moved, brought to front or sent to back, or resized like any other shapes on the diagram.

To add a note to a diagram, click the New Note button on the Database Diagram toolbar and click the diagram. After that you may type the note text.

To change a note text, click it and hit F2 key or right-click it and choose Edit text from the shortcut menu.

To remove a note from the diagram, click it and hit the DELETE key or right-click it and choose Remove from Diagram from the shortcut menu.
NoteDi

The note allows you to add a hyperlink to a file.

To add a hyperlink, right-click a note and select Hyperlink from the menu. The Hyperlink Properties dialog box opens where you can specify a file path or URL and a file description. The latter will be displayed under the note text and you can click on it to open the file in dbForge Studio. To open the file with a default program, use CTRL+click.

To edit a hyperlink, right-click it and select Hyperlink from the menu. The Hyperlink Properties dialog box opens where you can change the hyperlink properties.

To delete a hyperlink, clear the File path or URL field in the Hyperlink Properties dialog box.

To change a note color, right-click the note and select a required color from the Color menu.

ExpandedToggleIcon(9x12) Stamp

Diagram stamp enables you to specify the following information about diagram: diagram author, company, version, copyrights, project name, date. You can add an unlimited number of stamps to your diagram.

To add a stamp to diagram, click the New Stamp button on the Database Diagram toolbar and click the diagram.

To edit stamp fields, double-click them and enter values.

To remove a stamp from the diagram, click it and hit the DELETE key or right-click it and select Remove from Diagram from the shortcut menu.

ExpandedToggleIcon(9x12) Images

dbForge Studio allows adding images to diagram. Images can be moved, brought to front, sent to back, or resized like any other shapes on the diagram. You may use the following image formats:

· BMP
· JPEG
· TIFF
· PNG
· ICO
· EMF
· WMF

To add an image to the diagram, click the New Image button on the Database Diagram toolbar and click the diagram, then select an image file to add image from and click Open.

To remove an image from the diagram, click it and hit the DELETE key or right-click it and select Remove from Diagram from the shortcut menu.

ExpandedToggleIcon(9x12) See Also

Designing Databases with Database Designer

Working with Database Objects on a Diagram


Working with Database Objects on a Diagram

This section contains information about working with the database objects on the diagram.

ExpandedToggleIcon(9x12) In This Section

Editing Tables
Describes some aspects of editing tables on the diagram.

Displaying Database Objects on a Diagram
Describes how to work with other database objects on the diagram.

Working with Relations
Describes how to manage the relations on the diagram.

Relation Notations
Describes how relations are displayed in different notations.

Diagram Shapes and Layout
The topic describes how to manage a diagram shape and layout.

ExpandedToggleIcon(9x12) See Also

Designing Databases with Database Designer


Editing Tables

By default, tables on the diagram are presented as shapes. Their captions display the table icon, name and button for minimizing table. Then there is a list of columns and a collapsed lists of constraints, indexes, and triggers, if the table has ones.

Edit tables on a diagram either way:

· Open the Table Editor Dialog Box by double-clicking the table or choosing Edit Table from its shortcut menu. The Table Editor Dialog Box is the same as the Table Editor document with its views, except for the bottom buttons. Reset button discards all changes, OK button closes the dialog and saves all changes, Cancel button closes the dialog and discards all changes. You can edit table in this dialog just like in the table editor document.
· Edit, delete, and create table columns, indexes, and constraints in the diagram shape. You can open them for editing by double-clicking them, or delete them by right-clicking and choosing Drop from Database from the shortcut menu. To create a new column, right-click an existing one and choose New Column from the shortcut menu. To create a new index or constraint, right-click the Indexes or Constraints line and choose the corresponding item from the shortcut menu. If the corresponding compartment is not available, right-click the table caption and choose the corresponding item from the New sub-menu of the shortcut menu. Note that you can create, edit, and delete triggers the same way.

ObjectWithPopupMenu

note Note

Constraints, Indexes, and Triggers compartments are not displayed in two cases:

1. They are not displayed when there are no constraints, indexes, or triggers in the table.
2. They may be disabled in the diagram options.

ExpandedToggleIcon(9x12) See Also

Working with Database Objects on a Diagram

Displaying Database Objects on a Diagram


Displaying Database Objects on a Diagram

ExpandedToggleIcon(9x12) Diagram Objects Colors

Views and stored routines are presented as differently colored shapes on the diagram. You can manage these like table shapes, except for some differences. Unlike table shapes, these shapes have only two size handles, which allows you to resize the shape width. View shapes contain view columns, and stored routine shapes contain their parameters. They don't have any additional compartments.

Triggers are displayed on the diagram just like constraints and indexes - in their own compartments on the table shapes. You can work with them in the same way as with constraints and indexes.

ExpandedToggleIcon(9x12) Organizing Diagram Shapes with Containers

If you want to build a complex diagram with many shapes or make a diagram with tables from different schemas, you may use containers to group the shapes. Or you may use containers for storing only specific kinds of database objects.

Containers are resizable colored boxes with a caption, which you can use to place other diagram shapes into. Any diagram object can be placed into container, even another container. Relation between table shapes are kept when the shapes are in different containers. Container color can be customized and you can specify container caption, so you can group diagram shapes into several containers, each with its own name and color. So, when building diagram with objects of several schemas, you may create a container for each schema and name them after schemas, then place objects from each schema into the corresponding container.

Containers have their own grid inside of them for positioning shapes. If there are not enough place in the container, scroll bars appear, allowing you to scroll the container and to view all shapes in the container. Containers can be collapsed like any other shape by clicking the Collapse button.

ExpandedToggleIcon(9x12) Working with Containers

To create a container:

· Right-click a diagram and select New, and then click Container from the shortcut menu.

or
· Click the New Container button on the Database Diagram toolbar and click the diagram.

When the container is added to the diagram, you may drag shapes to it. Note that when you are dragging the shape, if the mouse pointer was over the container, the dragged shapes will be dropped to the container, even if the most part of the dragged selection was not over the container. The same is about dragging shapes out of the containers.

To change the container color, right-click the container and choose a required color from the Color menu.

To rename the container, click it and hit F2 key or right-click it and choose Rename from the shortcut menu.

To drop the container from the diagram, click it and hit the DELETE key or right-click it and choose Remove from Diagram from the shortcut menu. Note that all shapes inside the container will be dropped from the diagram too, but the corresponding database objects will not be dropped from database.

ExpandedToggleIcon(9x12) See Also

Working with Database Objects on a Diagram

Working with Relations


Working with Relations

dbForge Studio allows creating two types of relations: physically existing foreign key relations and virtual relations.

ExpandedToggleIcon(9x12) Physical relations

They represent physically existing foreign key relations between tables. On the diagram, these relations are displayed as connecting lines. Their appearance depends on the selected notation.

Options available for managing physical relations are as follows:

· Move - click the relation and drag its bend handle.
· Bend - click the relation and drag its bend handle.
· Reroute - right-click the relation and choose Reroute from the shortcut menu. The relation will be rerouted to its default route.
· Drag a relation's parent end to another table - you may attach the parent edge to any edge of the table shape.

ExpandedToggleIcon(9x12) How to Delete a Relation

Click a relation and press the DELETE key, then click Yes in the appeared dialog.

note Note

When you delete a relation from the diagram, the corresponding foreign key is deleted from the database.

ExpandedToggleIcon(9x12) How to Edit a Relation

1. Double-click a relation to invoke the Foreign Key Properties dialog box.
2. Make changes and click OK.

To change the relation's parent table, drag the parent end of the relation to another table. You cannot change the relation's child table.

note Note

The relation's cardinality is determined automatically from the child table constraints and cannot be changed by a user except for editing child table constraints.

ExpandedToggleIcon(9x12) How to Create a Relation

1. Click the New Relation icon on the Database Diagram toolbar.
2. Click the child table and move the mouse pointer to the parent table while holding the mouse button, then release the mouse button. A partially initialized New Foreign Key dialog box will appear with a referenced table, a database, a constraint, and columns already set.
3. Specify the Constraint Columns in the dialog box and click OK.

note Note

Relations on the diagram correspond to existing foreign keys in a database. When you create a relation on the diagram, a foreign key constraint is created in the database. If the foreign key cannot be created in the database, the relation cannot be created on the diagram.

ExpandedToggleIcon(9x12) Virtual relations

They allow you to create relations between tables if their storage engine does not support foreign keys. Virtual relations do not exist physically, but only stored on the diagram, however they can be converted to physical foreign keys. On the diagram they are displayed as thin dotted lines connecting tables.

You can move, bend, reroute virtual relations, drag a relation's parent end to another table the same way as you do with physical relations.

ExpandedToggleIcon(9x12) How to Create a Virtual Relation

1. Click the New Virtual Relation icon on the Database Diagram toolbar.
2. Click the child table and move the mouse pointer to the parent table. Click a required column in the child table and, holding the mouse button pressed, select a required column in the parent table, then release the mouse button. The virtual relation will appear on the diagram.

You can also select entire tables to create a virtual relation between them. In this case the Virtual Relation Properties dialog box will appear where you should select constraints and referenced columns.

ExpandedToggleIcon(9x12) How to Edit a Virtual Relation

1. Double-click it to invoke the Virtual Relation Properties dialog box.
2. Make changes and click OK.

ExpandedToggleIcon(9x12) How to Delete a Virtual Relation

Do either of these actions:

· Click it on the diagram and press the DELETE key.
· Select it in the Virtual Relation Manager window and press the DELETE key.

ExpandedToggleIcon(9x12) How to Manage Virtual Relations

Use the Virtual Relation Manager window to view, edit, remove virtual relations, generate their DDL, convert to Foreign keys, etc.

To open it, click the Virtual Relation Manager icon on the toolbar or, on the View menu, point to Other Windows, and click Virtual Relation Manager. Right-click a required relation in the grid and select a required command from the menu.

ExpandedToggleIcon(9x12) Relation Comments

Each relation has a comment - a yellow rectangle with a relation foreign key name. Select the Show Relation Comment check box in the diagram options or click Show Comments on the Diagram toolbar to display comments. By default, they are displayed near the child end of relations. You can drag them to any other place, and they will move with the relation. To hide a comment for a specific relation, click it and hit the DELETE key. To display it again, right-click the relation and select Show Comment from the shortcut menu.

ExpandedToggleIcon(9x12) See Also

Working with Database Objects on a Diagram

Relation Notations


Relation Notations

Foreign key relations are displayed as lines connecting tables. Appearance of the relation depends on the selected notation. dbForge Studio supports IE and IDEF1X notations for the diagrams.

ExpandedToggleIcon(9x12) IDEF1X Notation

IDEF1X (Integration Definition for Information Modeling) is a modeling language for developing a logical model of data. For detailed description of IDEF1X notation refer to FIPS Publication 184 Announcing the IDEF1X Standard December 1993 by the Computer Systems Laboratory of the National Institute of Standards and Technology (NIST).

Identifying relations are displayed as continuous lines with black circle on the child end. (Identifying relation means when all foreign key columns are included to the primary key of the child table). See example below.

Non-identifying relations are displayed as dotted lines with black circle on the child end. If this relation is an Optional Non-Identifying Relationship (child foreign key columns are nullable), white diamond is displayed on the parent end of the relation. See examples below.

Z letter at the child end of the relationship appears if there can be only zero or one child record. It depends on whether the foreign key columns in the child table are unique (belong to the primary key or unique index). Thus, identifying relations are always displayed with letter Z. Non-identifying relations can be displayed both with or without Z letter.

ExpandedToggleIcon(9x12) IE Notation

IE Notation is used by default. Relations are displayed as continuous lines. Ends of the lines depend on relation cardinality. Relation cardinality is determined automatically from the foreign key constraint, it cannot be specified by user (except for editing child table constraints).

In Oracle one record of the child table corresponds to 0..1 (zero or one) or 1 (exactly one) record from the parent table. It depends on the presence of the NOT NULL constraints on the foreign key columns in the child table.

One record of the parent table corresponds to 0..1 (zero or one) or 0..N (zero, one, or more) records from the child table. It depends on whether the foreign key columns in the child table are unique (belong to the primary key or unique index).

Parent record | Child record | Example
1 (exactly one) | 0..N (zero, one, or more) | IE1to0N
1 (exactly one) | 0..1 (zero or one) | IE1to01
0..1 (zero or one) | 0..N (zero, one, or more) | IE01to0N
0..1 (zero or one) | 0..1 (zero or one) | IE01to01

ExpandedToggleIcon(9x12) See Also

Working with Database Objects on a Diagram

Diagram Shapes and Layout


Diagram Shapes and Layout

ExpandedToggleIcon(9x12) Diagram Layout

Diagram layout can be controlled in a number of ways. Diagram shapes can be moved (by dragging them with mouse or by keyboard), resized, and aligned to the diagram grid.

dbForge Studio allows you to layout diagram automatically or manually. To resize diagram automatically just click the Layout Diagram button on the Diagram toolbar.

To change the shape order, right-click required shapes, point to Shape, and then click Bring to Front or Send to Back. Alternatively, use the corresponding buttons on the Layout toolbar.

ExpandedToggleIcon(9x12) Aligning Shapes

Each shape may be aligned to grid. To align shape to grid, select it and click the Align to Grid button on the Layout toolbar.

Several shapes can be aligned in a column or in a row.

· To align shapes in a row, click the Align Tops, Align Middles, or Align Bottoms button on the Layout toolbar to align the shapes by their top, center, or bottom of the primary selection respectively. Their horizontal position remains unchanged.
· To align shapes in a column, click the Align Rights, Align Lefts, or Align Centers button to align the shapes by their right side, left side, or center of the primary selection respectively. Their vertical position remains unchanged.

You can also use corresponding commands of the Align sub-menu of the Layout menu.

ExpandedToggleIcon(9x12) Changing Shape Size

To change shape size, select it and drag the size handles at the shape sides and corners. To fit shape size to grid, select it and click Size to Grid on the Layout toolbar or select Size to Grid from the Make Same Size sub-menu of the Layout menu. Shapes have minimal and maximal height and width. Minimal width and height and maximal height are constant. Maximal height depends on the table shape column count.

You can also fit the same size for multiple shapes. To do this, select the shapes and click Make Same Width or Make Same Height on the Layout toolbar. You may also use corresponding items of the Make Same Size sub-menu of the Layout menu. When using this feature, the size of the selected shapes will be aligned with the size of primary selection.

To improve the shape size in terms of the content representation, right-click the shape, point to Shape and click Best Fit.

note Note

A primary selection is one of the selected shapes. Its size handles are blue, while size handles of other selected shapes are black. If a selected shape cannot have the same size as the primary selection, its size will be changed to become as close to the primary selection size as possible.

ExpandedToggleIcon(9x12) Controlling Spacing between Shapes

Diagram provides you flexible control over spacing between shapes on the diagram. You can proportionally increase and decrease horizontal and vertical spacing between the shapes, make it equal or remove it.

· To increase spacing between shapes, select shapes, which will be moved, and click Increase Horizontal Spacing or Increase Vertical Spacing on the Layout toolbar or select Increase from the Horizontal Spacing or Vertical Spacing sub-menus of the Layout menu.
· To decrease spacing between shapes, select shapes, which will be moved, and click Decrease Horizontal Spacing or Decrease Vertical Spacing on the Layout toolbar or select Decrease from the Horizontal Spacing or Vertical Spacing sub-menus of the Layout menu.
· To make spacing between shapes equal, select shapes, which will be moved, and click Make Horizontal Spacing Equal or Make Vertical Spacing Equal on the Layout toolbar or select Make Equal from the Horizontal Spacing or Vertical Spacing sub-menus of the Layout menu.
· To remove spacing between shapes, select shapes that will be moved, and click Remove Horizontal Spacing or Remove Vertical Spacing on the Layout toolbar or select Make Equal from the Horizontal Spacing or Vertical Spacing sub-menus of the Layout menu.

note Note

Spacing is considered as distance between shape borders. When you remove, for example, vertical spacing, shapes will be arranged as follows: the top of the second shape will be located at the same height as the bottom of the highest shape, the top of the third one will be located at the same height as the bottom of the second shape and so on.

ExpandedToggleIcon(9x12) See Also

Working with Database Objects on a Diagram


Export and Import of Oracle Schemas

dbForge Studio for Oracle provides you administrative tools, that allow to export and import schema, monitor sessions and manage schema security.

ExpandedToggleIcon(9x12) In This Section

How To: Copy Oracle Schema
Describes how to copy an Oracle schema to another server or schema.

Schema Export and Import
Describes how to perform database export using the Schema Export Wizard.

Oracle Administrative Privileges for connection to the server
The topic contains information on what Administrative Privileges you can use when connecting to the Oracle server.

How To: Export Schema through Command Line
Describes how to perform schema export using command line.

How To: Import Schema through Command Line
Describes how to perform schema import using command line.

Additional /schemaexport and /schemaimport Arguments
This topic gives detailed description of command line switches and examples of their usage.

How To: Use Command Line To Create Database Snapshots
Describes how to automate creation of target database snapshots using the command line


How To: Copy Oracle Schema

The topic describes how to copy an Oracle schema to another server or schema.

To copy an Oracle schema, you need to export it with help of the Schema Export Wizard. Once the schema is exported, you can start importing it to another server or schema using the Schema Import Wizard.

ExpandedToggleIcon(9x12) Exporting Oracle schema

To export an Oracle schema:

1. In the Database menu, point to Export & Import, and then click Schema Export on the shortcut menu.
2. On the General page, select a connection, a schema to export, and a filename for the export script. Click Next.
3. On the Export Content page, select data to export. Click Next.
4. On the Options page, set options for exporting a schema. Click Next.

note Note

If you export a schema with the Include SET CURRENT SCHEMA option, then, in case you are importing it afterwards with the Schema field being set to other than <As in script>, the previously set Include SET CURRENT SCHEMA option will be ignored

If you enable Prefix object names with a schema name option, you will not be able to import the script to another schema.
5. On the Errors Handling page, specify errors processing behavior and logging options. Click Export.

ExpandedToggleIcon(9x12) Importing Oracle schema

To import an Oracle schema:

1. In the Database menu, point to Export & Import, and then click Schema Import on the shortcut menu.
2. On the Schema Script File page, choose a connection, a schema to export, a filename for the export script, and an SQL file encoding.

note Note

If you import a schema to the same server as it was exported from and the Schema field is set to <As in script> in the Schema Import Wizard, make sure the empty schema with the same name exists on the sever. Otherwise, you can execute the following script to create it:

CREATE USER schema_name IDENTIFIED BY pass;
GRANT CONNECT TO schema_name;
GRANT RESOURCE TO schema_name;
3. Click Import.

ExpandedToggleIcon(9x12) See Also

Export and Import of Oracle Schemas

Schema Export and Import


Schema Export and Import

With dbForge Studio for Oracle, you can perform a full schema export or export only selected schema objects. To call Schema Export Wizard, in the Database menu, point to Export & Import, and then click Schema Export.

ExpandedToggleIcon(9x12) To export the whole schema with Schema Export Wizard

1. Select a connection, a schema to export, export script file name and location. Click Next.
2. Select Structure and Data, check Include all objects. Click Next.
3. Set the export options. Click Next.
4. Specify the errors processing behavior and logging options. Click Export.
5. Select whether to open the export script file in SQL Editor. Click Finish.

ExpandedToggleIcon(9x12) To export some schema objects with the Schema Export Wizard

1. Select a connection, a schema to export, script file name and location, click Next.
2. Select a required data, object types and proper schema objects to export. Click Next.
3. Set the export options, click Next.
4. Specify errors processing behavior and logging options, click Export.
5. Select whether to open export script file in SQL Editor. Click Finish.

ExpandedToggleIcon(9x12) To import schema from the export script, use the Schema Import Wizard.

To call the Schema Import Wizard and import the schema from the export script:

1. In the Database menu, point to Export & Import , and then click Schema Import.
2. Select an export script file to import and a target schema. If an export script file contains the CREATE DATABASE statement, the data will be imported to the created schema, not to the selected one.
3. Ensure that the encoding for the imported file is selected correctly. The application selects it automatically based on the imported file; if it fails, the default encoding (the current Windows encoding on the machine where dbForge Studio for Oracle is running) is selected. You can always select a required encoding from the drop-down list box.
4. Click Import.

note Note

If you export and import schema in different Oracle versions, you may encounter errors.

ExpandedToggleIcon(9x12) See Also

Export and Import of Oracle Schemas

Oracle Administrative Privileges for connection to the server


Oracle Administrative Privileges for connection to the server

This topic contains information on what Administrative Privileges you can use when connecting to the Oracle server.

Some administrative actions may require connecting as SYSDBA or SYSOPER. SYS or SYSTEM users can connect only as SYSDBA or SYSOPER.

note Note

To connect as SYSDBA or SYSOPER you must have SYSDBA or SYSOPER system privilege. These privileges are not included in the DBA role.

To connect as SYSDBA or SYSOPER, you should select 'SYSDBA' or 'SYSOPER' in the Connect as box of the general tab of the Connection Properties dialog box when adding or modifying a connection.

Connecting as SYSDBA or SYSOPER enables you to perform certain database operations for which privileges cannot be granted in any other fashion.

SYSDBA

Connecting as SYSDBA allows you to perform the following operations:

· STARTUP and SHUTDOWN
· ALTER DATABASE: open, mount, back up, or change character set
· CREATE DATABASE
· DROP DATABASE
· CREATE SPFILE
· ALTER DATABASE ARCHIVELOG
· ALTER DATABASE RECOVER

When you connect as SYSDBA you also have RESTRICTED SESSION privilege.

SYSOPER

Connecting as SYSOPER allows you to perform the following operations:

· STARTUP and SHUTDOWN
· CREATE SPFILE
· ALTER DATABASE OPEN/MOUNT/BACKUP
· ALTER DATABASE ARCHIVELOG
· ALTER DATABASE RECOVER (Complete recovery only).

When you connect as SYSOPER you also have RESTRICTED SESSION privilege. Connecting as SYSOPER allows a user to perform basic operational tasks, but without the ability to look at user data.

SYSBACKUP

This privilege allows a user to perform backup and recovery operations either from Oracle Recovery Manager (RMAN) or SQL*Plus.

The privilege enables you to perform the following operations:

· STARTUP
· SHUTDOWN
· ALTER DATABASE
· ALTER SYSTEM
· ALTER SESSION
· ALTER TABLESPACE
· CREATE CONTROLFILE
· CREATE ANY DIRECTORY
· CREATE ANY TABLE
· CREATE ANY CLUSTER
· CREATE PFILE
· CREATE RESTORE POINT (including GUARANTEED restore points)
· CREATE SESSION
· CREATE SPFILE
· DROP DATABASE
· DROP TABLESPACE
· DROP RESTORE POINT (including GUARANTEED restore points)
· FLASHBACK DATABASE
· RESUMABLE
· UNLIMITED TABLESPACE
· SELECT ANY DICTIONARY
· SELECT ANY TRANSACTION
· SELECT
o X$ tables (that is, the fixed tables)
o V$ and GV$ views (that is, the dynamic performance views)
o APPQOSSYS.WLM_CLASSIFIER_PLAN
o SYSTEM.LOGSTDBY$PARAMETERS
· DELETE/INSERT
o SYS.APPLY$_SOURCE_SCHEMA
o SYSTEM.LOGSTDBY$PARAMETERS
· EXECUTE
o SYS.DBMS_BACKUP_RESTORE
o SYS.DBMS_RCVMAN
o SYS.DBMS_DATAPUMP
o SYS.DBMS_IR
o SYS.DBMS_PIPE
o SYS.SYS_ERROR
o SYS.DBMS_TTS
o SYS.DBMS_TDB
o SYS.DBMS_PLUGTS
o SYS.DBMS_PLUGTSP
· SELECT_CATALOG_ROLE

In addition, the SYSBACKUP privilege enables you to connect to the database even if the database is not open.

SYSDG

Connect with the SYSDG administrative privilege to perform Data Guard operations.

The SYSDG privilege enables the following operations:

· STARTUP
· SHUTDOWN
· ALTER DATABASE
· ALTER SESSION
· ALTER SYSTEM
· CREATE RESTORE POINT (including GUARANTEED restore points)
· CREATE SESSION
· DROP RESTORE POINT (including GUARANTEED restore points)
· FLASHBACK DATABASE
· SELECT ANY DICTIONARY
· SELECT
o X$ tables (that is, the fixed tables)
o V$ and GV$ views (that is, the dynamic performance views)
o APPQOSSYS.WLM_CLASSIFIER_PLAN
· DELETE
o APPQOSSYS.WLM_CLASSIFIER_PLAN
· EXECUTE
o SYS.DBMS_DRS

In addition, the SYSDG privilege enables you to connect to the database even if it is not open.

SYSKM

The SYSKM administrative privilege enables the SYSKM user to manage Transparent Data Encryption wallet operations.

The SYSKM administrative privilege enables the following operations:

· ADMINISTER KEY MANAGEMENT
· CREATE SESSION
· SELECT (only when a database is open)
o SYS.V$ENCRYPTED_TABLESPACES
o SYS.V$ENCRYPTION_WALLET
o SYS.V$WALLET
o SYS.V$ENCRYPTION_KEYS
o SYS.V$CLIENT_SECRETS
o SYS.DBA_ENCRYPTION_KEY_USAGE

In addition, the SYSKM privilege enables you to connect to the database even if it is not open.

ExpandedToggleIcon(9x12) See Also

Export and Import of Oracle Schemas


How To: Export Schema through Command Line

You can automate schema export process using command line.

note Note

The command line functionality is available only in certain editions of dbForge Studio. For the detailed information on features availability in the dbForge Studio editions, please refer to the Editions topic.

To perform schema export from command line:

1. To open Command Prompt, press Win+R and type cmd in the Open line.

note Note

To run the Command Line in Windows 8:

From the Desktop Mode

· Move the mouse cursor to the exact lower left corner until the desktop shortcuts menu appears.
· Right-click to see the shortcut menu and than click Run.

From the Charms Bar

· Move your mouse to the upper right corner until the Charms Bar appears.
· Select Apps from the list and type “run” in the search box.
· Click Run from the search results.

Use Windows + R Shortcut Keys

· In desktop mode, press the Windows + R keys, to show the Run command line.
2. Type a path to the dbforgeoracle.com file, located in dbForge Studio for Oracle installation folder on your PC, and press the SPACE bar:

C:\Users\user>"C:\Program Files\Devart\dbForge Studio for Oracle\dbforgeoracle.com"

3. Specify the operation you want to perform (execute a script):

/schemaexport /projectfile:"D:\sample.backup"

4. Type all other arguments you need.

Tip: To see a quick help on the arguments available in the command line, type the following:

/schemaexport /?

5. Press ENTER to run the process.

ExpandedToggleIcon(9x12) See Also

Export and Import of Oracle Schemas

How To: Import Schema through Command Line


How To: Import Schema through Command Line

You can automate schema import process using command line.

note Note

The command line functionality is available only in certain editions of dbForge Studio. For the detailed information on features availability in the dbForge Studio editions, please refer to the Editions topic.

To perform schema export from command line:

1. To open Command Prompt, press Win+R and type cmd in the Open line.

note Note

To run the Command Line in Windows 8:

From the Desktop Mode

· Move the mouse cursor to the exact lower left corner until the desktop shortcuts menu appears.
· Right-click to see the shortcut menu and than click Run.

From the Charms Bar

· Move your mouse to the upper right corner until the Charms Bar appears.
· Select Apps from the list and type “run” in the search box.
· Click Run from the search results.

Use Windows + R Shortcut Keys

· In desktop mode, press the Windows + R keys, to show the Run command line.
2. Type a path to the dbforgeoracle.com file, located in dbForge Studio for Oracle installation folder on your PC, and press the SPACE bar:

C:\Users\user>"C:\Program Files\Devart\dbForge Studio for Oracle\dbforgeoracle.com"

3. Specify the operation you want to perform (execute a script):

/schemaimport /inputfile:"D:\sample.backup"

4. Type all other arguments you need.

Tip: To see a quick help on the arguments available in the command line, type the following:

/schemaimport /?

5. Press ENTER to run the process.

ExpandedToggleIcon(9x12) See Also

Export and Import of Oracle Schemas

Additional /schemaexport and /schemaimport Arguments


Additional /schemaexport and /schemaimport Arguments

This topic gives detailed description of command line switches and examples of their usage.

ExpandedToggleIcon(9x12) /schemaexport Arguments

To get more information on switches related to schema export in the command line interface, type:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /schemaexport /?

Below all switches of this option are described, together with usage examples.

Argument | Action and Usage
/connection | This switch is used to specify a connection string with additional parameters. Command usage is as follows: /connection:<connection_string> Example of using the /connection argument: /connection:"User Id=some_user_id;Password=password;Server=ORCL;Unicode=True;Pooling=False"
/outputfile | Use this switch to specify file name for storing the schema. This switch overrides file name specified in schema export project. Command usage is as follows: /outputfile:<file_name> Example of using the /outputfile argument: /outputfile:"D:\sample.sql"
/password | Use this switch to specify server password. This switch overrides password specified in schema export project or in connection string. Command usage is as follows: /password:<pw> Example of using the /password argument: /password:"tiger"
/projectfile | Use this switch to specify a schema export project to be used. Some project options can be overridden by switches. Command usage is as follows: /projectfile:<file_name> Example of using the /password argument: /projectfile:"D:\sample.backup"
/schema | Use this switch to specify a schema to be exported. This switch overrides a schema specified in a schema export project or in a connection string. Command usage is as follows: /schema:<schema_name> Example of using the /schema argument: /schema:"scott"

Below is the example of the /shcemaexport arguments usage:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /schemaexport /connection:"User Id=SCOTT;Server=ORCL1020" /outputfile:"D:\sample.sql" /password:"tiger" /projectfile:"D:\sample.backup" /schema:SCOTT /encoding:"UTF-8"

ExpandedToggleIcon(9x12) /schemaimport Arguments

To get more information on switches related to schema import in the command line interface, type:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /schemaimport /?

Below all switches of this option are described, together with usage examples.

Argument | Action and Usage
/connection | This switch is used to specify a connection string with additional parameters. Command usage is as follows: /connection:<connection_string> Example of using the /connection argument: /connection:"User Id=some_user_id;Password=password;Server=ORCL;Unicode=True;Pooling=False"
/encoding | Use this switch to specifies the encoding which should be applied to open and execute the script. Command usage is as follows: /encoding:<codepage|encoding name> Example of using the /encoding argument: /encoding:"UTF-8"
/inputfile | Use this switch to specify a SQL or ZIP file with schema script. Command usage is as follows: /inputfile:<file_name> Example of using the /inputfile argument: /inputfile:"D:\sample.zip"
/password | Use this switch to specify server password. This switch overrides password specified in connection string. Command usage is as follows: /password:<pw> Example of using the /password argument: /password:"tiger"
/schema | Use this switch to specify a schema to be exported. This switch overrides schema specified in connection string. The ALTER SESSION SET CURRENT_SCHEMA statements will be ignored. Does not affect objects with fully qualified names. Command usage is as follows: /schema:<schema_name> Example of using the /schema argument: /schema:"scott"

Below is the example of the /shcemaimport arguments usage:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /schemaimport /connection:"User Id=SCOTT;Server=ORCL1020" /password:"tiger" /schema:SCOTT /inputfile:"D:\HR.sql" /encoding:"UTF-8"

ExpandedToggleIcon(9x12) See Also

Export and Import of Oracle Schemas

How To: Use Command Line To Create Database Snapshots


How To: Use Command Line To Create Database Snapshots

You can automate creation of target database snapshots using the command line.

note Note

The command line functionality is available only in certain editions of dbForge Studio. For the detailed information on features availability in the dbForge Studio editions, please refer to the Editions topic.

To create a snapshot of target database through the command line, do the following:

1. Open Command Prompt by pressing Win+R, and typing 'cmd' in the Open line.

note Note

To run the Command Line in Windows 8:

From the Desktop Mode

· Move the mouse cursor to the exact lower left corner until the desktop shortcuts menu appears.
· Right-click to see the shortcut menu and than click Run.

From the Charms Bar

· Move your mouse to the upper right corner until the Charms Bar appears.
· Select Apps from the list and type “run” in the search box.
· Click Run from the search results.

Use Windows + R Shortcut Keys

· In desktop mode, press the Windows + R keys, to show the Run command line.
2. Type a path to the dbforgeoracle.com file, located in dbForge Studio for Oracle installation folder on your PC, and press the SPACE bar.

"C:\Program Files\Devart\dbForge Studio for Oracle\dbforgeoracle.com"

3. Specify the action you want to perform:

"C:\Program Files\Devart\dbForge Studio for Oracle\dbforgeoracle.com" /snapshot

4. Specify the connection string and schemas:

"C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /snapshot /connection:"User Id=hr;Server=ORCL;Unicode=True" /s:"SH,SH"

5. Press ENTER to run the process.

Tip: To see a quick help on the switches available for the /snapshot operation, type the following:

"C:\Program Files\Devart\dbForge Studio for Oracle\dbforgeoracle.com" /snapshot /?

Additional arguments:

You can edit the generated file to add some additional parameters, for example:

· To write a comment, type:

/comment:<value>

· To apply compression to your snapshot file, type:

/compress:[value]

To turn this option on, type Yes, Y, On, True, T.

To turn this option off, type No, N, Off, False, F.

· To specify full connection string with additional parameters, type:

connection:<connection_string>

This argument is required.

· To specify a file name and its path to save the created snapshot file, type:

/file:<file_path>

If the path is not specified, the snapshot will be saved to the current directory.

· To specify server password, type:

/password:<pw>

Define this argument to override the password specified in the connection string.

Command line used to make a snapshot of a schema may look like:

"C:\Program Files\Devart\dbForge Studio for Oracle\dbforgeoracle.com" /snapshot /connection:"User Id=hr;Server=ORCL;Unicode=True;" /password:my_pass /schema:"HR" /file:"result.snap"

If you connect to the server in the Direct mode, the connection parameters will differ and the command line used to make a snapshot of a schema will look like:

"C:\Program Files\Devart\dbForge Studio for Oracle\dbforgeoracle.com" /snapshot /connection:"User Id=hr;Server=dbOracle;Connect Mode=SysDba;Unicode=True;Direct=True;Service Name=ORCL" /password:my_pass /schema:"HR" /file:"result.snap"

ExpandedToggleIcon(9x12) See Also

Export and Import of Oracle Schemas

How To: Export Schema through Command Line

How To: Import Schema through Command Line


Managing Users and Privileges

This section provides information on managing database security with dbForge Studio for Oracle Security Manager.

ExpandedToggleIcon(9x12) In This Section

User Management Concepts
This topic tells you some basic information about Oracle user accounts.

Setting Up a New User Account
Describes how to create new user account and grant required privileges and roles to it.

Manipulating User Accounts
This topic tells how to create, edit or delete user accounts.

Working with Privileges
This topics tells how to grant and revoke system privileges and privileges on database objects.

Manipulating Roles
This topic tells how to create, edit or delete roles.

Granting and Revoking Roles
This topics tells how to grant and revoke roles.

Manipulating Profiles
This topic tells how to create, edit or delete profiles.

How To: Work with Multiple Users
This topic tells how to work with several users in Security Manager.

Generating DDL
This topic tells how to view DDL statements of users, profiles and roles.

Duplicating Security Objects
This topic tells how to create a new security object (user, role or profile), based on the existing one.

Watermarks in Security Manager
Describes cases when Security Manager editor cannot be displayed.


User Management Concepts

This topic tells you some basic information about Oracle user accounts. To learn how to add user account using dbForge Studio for Oracle Security Manager, see Setting Up New User Account.

There are some basic account concepts in Oracle.

ExpandedToggleIcon(9x12) User Privileges

A user privilege is a right to execute a particular type of SQL statement, or a right to access another user's object. There are two types of privileges: system privileges and object privileges. System privileges allow to perform a particular database operation or class of database operations. For example, CREATE PROCEDURE privilege allows user to create stored procedures, functions, and packages in his schema. Object privileges are privileges that can be granted on database objects. Each type of object has different privileges associated with it. To learn more about user privileges, refer to Oracle documentation.

ExpandedToggleIcon(9x12) Roles

A role groups several privileges and roles, so that they can be granted to and revoked from users simultaneously. Roles can be enabled and disabled per user. Default role is the role that is automatically enabled for a user when the user connects to Oracle server.

ExpandedToggleIcon(9x12) Profiles

Profiles are the named sets of resource limits. Oracle limits database usage and instance resources to whatever is defined in the user's profile. To use resource profiles resource limits must be turned on for the database as a whole. Profile can be assigned to each user.

ExpandedToggleIcon(9x12) See Also

Managing Users and Privileges

Setting Up a New User Account


Setting Up a New User Account

The following walkthrough describes how to connect to an Oracle server, create a new user account with the Security Manager tool and how to grant required privileges and roles to this account. You can skip this walkthrough if you don't need to know how to set up user accounts.

To get acquainted with dbForge Studio for Oracle, let us perform some common operations and see how a database and data within it can be managed. In order to interact with Oracle, a client must first establish a connection with an Oracle server, so first of all you have to connect to a server.

note Note

In this topic as well as in the other topics, clicking with the right mouse button is referred as "right-click". Clicking with the left mouse button is referred as "click". "Double-click" means that you should click with the left mouse button twice quickly.

After establishing connection to server, you can start working with security objects.

ExpandedToggleIcon(9x12) Creating a Profile

Let us create a new user profile to specify a password policy, for example, a profile in which user passwords will expire after 30 day. To do this, perform the following steps.

1. Select Security Manager from the Database menu. The Security Manager window opens.
2. Right-click the Profiles node in the object tree in the right part of the Security Manager.
3. Select New Profile from the shortcut menu.
4. Enter a unique profile name (for example, 'Expired30').
5. Switch to the Password tab.
6. Enter '30' into the Life Time box.
7. Enter '3' into the Grace Time box.
8. Click the Save Save button on the Security Manager toolbar.

Now our profile is created. Password life time set to 30 means that after 30 days user should change password. Grace time set to 3 means that user will get warning messages when connects to database for three days after first connect after password lifetime is over. After that user should change his password to work with database.

ExpandedToggleIcon(9x12) Creating a New User Account

To create new user account perform following steps.

1. Open the Security Manager by selecting Security Manager from the Database menu.
2. Select the Users node in the object tree in the right part of the Security Manager.
3. Click the Create User button on the Security Manager toolbar.
4. Enter a unique user name. In this and following walkthroughs the name HR will be used.
5. Select Database in the Authentication box.
6. Enter the user's password in the Password field and re-enter it in the Confirm Password field. In this and the following walkthroughs the password 'test' will be used.
7. Click the Save Save button on the Security Manager toolbar to save this user account.

ExpandedToggleIcon(9x12) Granting Required Roles and Privileges

By now as you have set up a connection, set up a profile, and created a user account. Let's grant required roles and privileges to this account. To grant required roles and privileges, perform the following steps:

1. In the Security Manager, expand the Users node.
2. Select the user HR.
3. Switch to the Role tab.
4. Select check boxes in the Default column for CONNECT and RESOURCE roles.

note Note

Two roles were granted as default roles.

5. Switch to the System tab.
6. Select the check box in the Granted column for the UNLIMITED TABLESPACE privilege.
7. Click the Save Save button on the Security Manager toolbar to save changes.

Now the account is ready for work. You can create a connection for it just like the previous connection for the administrator account. In future this user schema and therefore these login parameters will be used.

ExpandedToggleIcon(9x12) See Also

Managing Users and Privileges

Manipulating User Accounts


Manipulating User Accounts

This topic tells you how to manipulate user accounts with dbForge Studio for Oracle Security Manager.

Security Manager provides an easy way to add, alter or remove users visually without typing SQL code. To open Security Manager, select Security Manager from the Database menu.

ExpandedToggleIcon(9x12) Creating User Account

1. Open Security Manager.
2. Select the Users node.
3. Right-click the Users node and select New User from the shortcut menu.
4. Fill the Name, Password and Confirm Password fields.
5. Select authentication method, default and temporary tablespace and user profile in the corresponding boxes.
6. Grant necessary roles and privileges to user.
7. You can optionally set tablespaces quotas for user.
8. Click the Save Save button on the Security Manager toolbar.

ExpandedToggleIcon(9x12) Editing User Account

You can edit user account by opening Security Manager, expanding the Users node and selecting the required user in the tree. After editing you should click the Save Save button on the Security Manager toolbar to apply changes. If you want to discard changes, click the Undo button on the Security Manager toolbar.

ExpandedToggleIcon(9x12) Deleting User Account

Open Security Manager, expand 'Users' node and select Delete from shortcut menu of required user or select required user in the tree and click the Delete button on the Security Manager toolbar or press the DELETE key.

ExpandedToggleIcon(9x12) Assigning Tablespace Quota for User Account

1. Open Security Manager.
2. Expand the Users node and select a required user.
3. Switch to the Quota tab.
4. Select the required tablespace.
5. Select quota from the corresponding box - None, Unlimited or Value; if you have selected Value, enter the required value and select Unit of the entered value.
6. Repeat steps 4 and 5 for all required tablespaces.
7. Click the Save Save button on the Security Manager toolbar.

ExpandedToggleIcon(9x12) See Also

Managing Users and Privileges

Working with Privileges


Working with Privileges

Security Manager allows granting and revoking system and object privileges easily. This topic describes how to work with system privileges and privileges on database objects.

ExpandedToggleIcon(9x12) Granting and Revoking System Privileges

1. Open Security Manager.
2. Select a user account or role in the left part of the Security Manager.
3. Switch to the System tab.
4. Select check boxes opposite to the required privileges to grant them, and clear the check boxes to revoke already granted privileges.
5. Click the Save Save button on the Security Manager toolbar to apply changes.

ExpandedToggleIcon(9x12) Granting and Revoking Privileges on Database Objects

Privileges on database objects can be granted on the Object tab of the Security Manager.

Granting privileges

To give a user or role some privileges on a database object, perform the following actions.

1. Open the Security Manager by selecting security-manager Security Manager from the Database menu or selecting Edit Privileges from the shortcut menu of database object node in the Database Explorer.
2. Select a user account or role in the left part of the Security Manager and switch to the Object tab.
3. Select a database object to grant privileges on in the Objects tree. After selecting an object you will see the list of available privileges.
4. Assign privileges to a user (account) or role by checking them in the available privileges list.
5. Click the Save Save button on the Security Manager toolbar.

Revoking privileges

The grid at the bottom of the Security Manager Object tab contains the current privileges of the user (account) or role.

You can revoke selected privilege by:

1. Double-clicking it
2. Clicking the [image] Revoke Selected Privilege from their shortcut menu
3. Pressing CTRL+DELETE keys
4. Clicking the [image] button near the list

To revoke all assigned privileges, select Revoke All Privileges from their shortcut menu or click the clearresults button near the list.

Available privileges

Available privileges for different database objects are listed at the table below:

Database objects | Privileges
Databases | Select, Insert, Update, Delete, Alter, Alter Routine, Create, Create Routine, Create Temporary Tables, Create View, Drop, Event, Execute, Grant Option, Index, Lock Tables, References, Show View, Trigger
Tables | Select, Insert, Update, Delete, Create, Drop, Grant Option, References, Index, Alter, Create View, Show View, Trigger
Columns | Select, Insert, Update, References
Stored procedures and functions | Alter Routine, Execute, Grant Option

ExpandedToggleIcon(9x12) See Also

Managing Users and Privileges

Manipulating Roles


Manipulating Roles

This topic tells you how to manipulate roles with dbForge Studio for Oracle Security Manager.

Security Manager provides an easy way to add, alter or remove roles visually without typing SQL code. To open Security Manager, select Security Manager from the Database menu.

ExpandedToggleIcon(9x12) Creating a Role

1. Open the Security Manager.
2. Select the Roles node.
3. Right-click the Roles node and select New Role from the shortcut menu.
4. Fill the Name field.
5. Select authentication method. If you have selected the Database method, fill the Password and Confirm Password fields.
6. Grant necessary roles and privileges to role.
7. Click the Save Save button on the Security Manager toolbar.

ExpandedToggleIcon(9x12) Editing a Role

You can edit role account by opening Security Manager, expanding 'Roles' node and selecting required role in the tree. After editing you should click the Save button on Security Manager toolbar to apply changes. If you want to discard changes, click the Undo button on the Security Manager toolbar.

ExpandedToggleIcon(9x12) Deleting a Role

Open the Security Manager, expand the Roles node and select Delete from the shortcut menu of the required role, or select a required role in the tree and press DELETE.

ExpandedToggleIcon(9x12) See Also

Managing Users and Privileges

Granting and Revoking Roles


Granting and Revoking Roles

Security Manager allows granting and revoking roles. To do this, you should:

1. Open the Security Manager.
2. Expand the Users node for granting privileges to a user or the Roles node for granting privileges to a role.
3. Select the required user or role.
4. Switch to the Role tab.
5. Select check boxes in the Granted column for required roles' rows in the grid to grant required roles. Clear the check boxes in the Granted column for required roles' rows to revoke required roles.
6. You can optionally select or clear the check boxes in the Admin Option column for granted roles' rows to grant or revoke role admin option.
7. Click the Save Save button on the Security Manager toolbar to apply changes.

ExpandedToggleIcon(9x12) See Also

Managing Users and Privileges

Manipulating Profiles


Manipulating Profiles

This topic tells you how to manipulate profiles with dbForge Studio for Oracle Security Manager.

Security Manager provides an easy way to add, alter or remove profiles visually without typing SQL code. To open Security Manager select Security Manager from Database menu.

ExpandedToggleIcon(9x12) Creating a Profile

1. Open the Security Manager.
2. Select the Profiles node.
3. Click the Create Profile button on the Security Manager toolbar

OR

1. Right-click the Profiles node and select New Profile from the shortcut menu.
2. Fill the Name field.
3. Set required general and password parameters.
4. Click the Save Save button on the Security Manager toolbar.

ExpandedToggleIcon(9x12) Editing a Profile

To edit a profile, you should:

1. Open the Security Manager.
2. Expand the Profiles node.
3. Select the required profile in the tree.
4. Edit the profile.
5. Click the Save Save button on the Security Manager toolbar to apply changes. If you want to discard changes, click the Undo button.

ExpandedToggleIcon(9x12) Deleting a Profile

To delete a profile, you should:

1. Open the Security Manager.
2. Expand the Profiles node.
3. Select Delete from the shortcut menu of the required profile
- or -
select the required profile in the tree and press DELETE.

ExpandedToggleIcon(9x12) See Also

Managing Users and Privileges

Generating DDL


How To: Work with Multiple Users

dbForge Studio for Oracle provides possibility to work with multiple users or roles in Security Manager. This feature is useful if you need to add the same privileges or roles for several users or roles.

To select multiple users or roles:

· Press Ctrl and select users/roles
- or -
Select the first user/role, press Shift, and click the last user or role (if users or roles are located one by one).

For several users or roles, you can edit roles, system and object privileges on the corresponding Security Manager tabs. Note that the General and Quota tabs are unavailable in this case.

The following identifications define the state of privileges:

· for global privileges:

- the privilege is assigned to all selected users;

security-manager-halfchecked-oracle - the privilege is assigned not to all selected users;

- the privilege is not assigned to any of the selected users;

· for object privileges:

security-manager-belongstoall - the privilege is assigned to all selected users;

security-manager-belongsnottoall - the privilege is assigned not to all selected users.

ExpandedToggleIcon(9x12) See Also

Managing Users and Privileges

Watermarks in Security Manager


Generating DDL

dbForge Studio for Oracle allows you to view DDL statements for users, roles and profiles. To view DDL statements, you should:

1. Open the Security Manager.
2. Expand the required node (Users, Roles or Profiles).
3. Right-click the required user, role or profile.
4. Select Generate Schema Script from the shortcut menu.

ExpandedToggleIcon(9x12) See Also

Managing Users and Privileges

Duplicating Security Objects


Duplicating Security Objects

dbForge Studio for Oracle allows you to create a new security object (user, role or the profile), based on the existing one. To do it:

1. Right-click the required security object in the Security Manager.
2. Select Duplicate Object in the shortcut menu. Right part of the editor will contain a new security object, that is an exact copy of the existing one except for its name.
3. Make changes to the object if you need and save it. Note that no object will be created until you save it.

ExpandedToggleIcon(9x12) See Also

Managing Users and Privileges

Watermarks in Security Manager


Watermarks in Security Manager

There are several situations in Security Manager when editor for managing users accounts is not available. In these cases a message explaining why the editor cannot be displayed is shown on its place. Here are the messages:

· To view the list of users select a connection from the drop-down list on the window toolbar or click Refresh

No connection is selected, and there are no objects in the user, role, or profile list (i.e. there is no user, role, or profile to select).

· You do not have enough privileges to view users. Select another connection or change connection settings and click Refresh

User has no rights to read security metadata.

· Cannot show editor because no users are selected or objects of different types are selected

If different types of objects are selected in the tree.

ExpandedToggleIcon(9x12) See Also

Managing Users and Privileges

Security Manager


Debugging PL/SQL Units

PL/SQL UnitsThis section provides information on debugging PL/SQL program and scripts.

ExpandedToggleIcon(9x12) In This Section

Debugger Overview
Provides an overview of the dbForge Studio debugger.

How To: Debug a Stored Procedure
This example demonstrates how to debug a Oracle stored procedure.

How To: Debug a Stored Function
This example demonstrates how to debug a Oracle stored function.

How To: Debug a Trigger
This example demonstrates how to debug a Oracle trigger.

How To: Debug Object Method
Describes the process of debugging an object method.

How To: Debug a Package
Describes the process of debugging a package.

How To: Debug an SQL Script
Describes how to debug a Oracle stored procedure.

Execution Control
Describes different navigation techniques while debugging stored database objects.

How To: Work with Breakpoints
Describes what breakpoints is and how to use them.

Debug Shortcut Keys
Lists shortcut key combinations that may be used while debugging stored database objects.

How To: Find and Recompile Invalid Objects
Describes the process of finding and recompiling invalid objects.


Debugger Overview

The dbForge Studio debugger is a powerful tool that allows you to observe the run-time behavior of your database object and locate logic errors. With the debugger, you can break, or suspend, execution of your program to examine your database object, evaluate and edit variables in your script.

The dbForge Studio debugger provides the Debug menu with access to debugger tools. Debugger windows and dialog boxes display information about your database object and enable you to enter additional information. You can call Help on any window or a dialog box by pressing F1.

The dbForge Studio debugger provides powerful commands for controlling the execution of your code. Here is the list of the tasks you can perform to control execution using debugger commands:

· Starting (or continuing) execution of procedures, functions, triggers, and SQL scripts
· Breaking execution of procedures, functions, triggers, and SQL scripts
· Stopping execution of procedures, functions, triggers, and SQL scripts
· Stepping through the procedures, functions, triggers, and SQL scripts
· Running to a specified location
· Setting the execution point

Debug Layout

dbForge Studio has two window layouts - default layout and debug layout. Debug layout is applied when you start debugging, the rest of the time you work in the default layout. Both layouts preserve their state when starting/stopping debugging or exiting from dbForge Studio. Watches and Call Stack windows are available only in debug layout.

ExpandedToggleIcon(9x12) See Also

Debugging SQL Database Objects

How To: Debug a Stored Procedure


How To: Debug a Stored Procedure

This example demonstrates how to debug Oracle stored procedure by stepping into the stored procedure. It also illustrates different debugging techniques such as setting breakpoints, viewing data items, and so on.

ExpandedToggleIcon(9x12) Creating a Sample Procedure

In this topic, some sample database objects are used for demonstrating how to work with the dbForge Studio Debugger. Use scripts specified in this topic to create necessary objects in your test database.

Database Procedure

Use the script below to create the procedure that takes two input parameters: DateFrom and DateTo. Based on these input parameters the table fills up with data.

ExpandedToggleIcon(9x12) Debugging the Stored Procedure

Assume that you need to get Time Sheet for a specific time period. To do this, execute the FillSchedule procedure:

1. In Database Explorer, choose your test database.
2. Click Procedures and then right-click the FillSchedule procedure, and click Execute from the shortcut menu.
3. Enter input parameters.

4. Click OK.

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

A quick look through the code gives you nothing and you have no other choice but to start the debugger.

Debugging Procedure

To start debugging the stored procedure:

1. To compile the stored procedure for debugging, navigate to the required procedure in the Database Explorer, select Compile, and then click Compile Dependants for Debugging from the shortcut menu.
2. Click the Run Start Debugging button on the Debug toolbar.
3. If you have not compiled the procedure, the dbForge Studio prompts you to compile it. Click Yes.
4. Enter the stored procedure input parameters once again and click OK.

You can see that the yellow arrow identifies the stack frame where the execution pointer is currently located.

5. To stop the debugging process, click the Stop button.
6. Click Execute to run the stored procedure.
7. You can see the message telling us that the stored procedure executed successfully. To verify this, you can retrieve the data from the table.
8. In the Database Explorer choose the required database.
9. Click Tables and then right-click the required table.
10. Click Retrieve Data from the shortcut menu.

11. dbForge Studio displays the result table.

result

note Tip

Place the mouse pointer over a variable to see its value.

As you see, the Debugger for Oracle is a very simple and powerful tool to use. You can use different debugging techniques to achieve successful results.

ExpandedToggleIcon(9x12) See Also

How To: Debug a Stored Function

Debugging PL/SQL Units


How To: Debug a Stored Function

This example shows how to debug a stored function in dbForge Studio for Oracle. Use provided scripts to create sample objects in your test database.

ExpandedToggleIcon(9x12) Creating a Sample Function

Procedure

Use the script available in How To: Debug a Stored Procedure to the procedure used in the sample below.

Function

Use the script below to create the GetFirstDayOfMonth function that returns the first day of a calendar month.

CREATE OR REPLACE FUNCTION GetFirstDayOfMonth(DT DATE)
RETURN DATE
AS
BEGIN
RETURN TRUNC(DT, 'MONTH');
END;

ExpandedToggleIcon(9x12) Debugging Function

To debug the Oracle function:

1. In Database Explorer, choose a test database.
2. Click Procedures and then double-click the FILLSCHEDULE procedure to open it.
3. Left-click in the gray margin next to the SELECT statement to insert a breakpoint in the place where we call the GetFirstDayOfMonth stored function.

4. Click Run Start Debugging, and enter the input parameters values for the procedure.
5. Add the DATE_TO variable to the Watches window. This option allows you to track the value of the variable while stepping through the code. To add the variable to the Watches window, right-click the DT variable, and then select Watches Add Watch from the shortcut menu. The variable will appear in the Watches window.
6. Step through the code using the F11 key or the StepInto Step Into button, or press CTRL+F5 to move directly to the breakpoint.

7. Press F11 or click StepInto Step Into to get inside the GetFirstDayOfMonth stored function.

note Note

You may ignore stepping through the function by clicking the StepOver Step Over button. In this case you will continue stepping through the stored procedure.
8. Step through the GetFirstDayOfMonth function until you exit back to the stored procedure, and continue to the end.

note Note

You may get back to the stored procedure code by clicking the StepOut Step Out button. In this case you will continue stepping through the stored procedure.

You may click the FILLSCHEDULE procedure in the Call Stack window to get back to the parent code.

note Tip

Place the mouse pointer over a variable to see its value.

ExpandedToggleIcon(9x12) See Also

Debugging PL/SQL Units

How To: Debug a Trigger


How To: Debug a Trigger

-This example shows how to debug a trigger in dbForge Studio for Oracle. Use provided scripts to create sample objects in your test database.

ExpandedToggleIcon(9x12) Creating a Sample Trigger

Procedure

Use the script available in How To: Debug a Stored Procedure to the procedure used in the sample below.

Trigger

Use the script below to create the IU_SCHEDULE_DETAIL trigger that generates an error message in case when Timesheetdate is not equal to the first date of a month.

CREATE OR REPLACE TRIGGER IU_SCHEDULE_DETAIL
BEFORE INSERT
ON SCHEDULE_DETAIL
FOR EACH ROW
BEGIN

IF (GETFIRSTDAYOFMONTH(:NEW.DATEOUT) <> :NEW.TIMESHEETDATE)
THEN
RAISE_APPLICATION_ERROR(-20000, '');
END IF;

END;

ExpandedToggleIcon(9x12) Debugging a Trigger

To debug the Oracle trigger:

1. In Database Explorer, choose your test database.
2. Expand the Triggers folder, and then double click the IU_SCHEDULE_DETAIL trigger to open it.
3. Change the current view from Main to SQL.

note Note

While opening a trigger the Main view is set as default. You are not able to insert a breakpoint in this view.
4. Set a breakpoint for the trigger. Left-click in the gray margin next to the SET statement to set a breakpoint in the trigger. This step is obligatory: if you do not set a breakpoint in the trigger, you will skip over its code when you try to step into it.
5. Expand the Procedures folder, and then double click the FILLSCHEDULE procedure to open it.
6. Set a breakpoint for the stored procedure that will fire the trigger. Left-click in the gray margin next to the INSERT INTO SCHEDULE.SCHEDULE_DETAIL statement.

7. Click Run Start Debugging, and enter input parameters for the procedure.
8. Step through the code using the F11 key or the StepInto Step Into button, or press CTRL+F5 to move directly to the breakpoint. At the INSERT INTO SCHEDULE.SCHEDULE_DETAIL statement, when you press F11 again, you will step into the trigger.

9. Step through the trigger until you exit back to the stored procedure, and continue to the end.

Call Stack Window

There are two database objects in the Call Stack window: the IU_SCHEDULE_DETAIL trigger and the FILLSCHEDULE procedure. You may notice the yellow arrow next to the IU_SCHEDULE_DETAIL trigger which identifies the stack frame where the execution pointer is currently located.

You can get back to the procedure source code by double-clicking the procedure in the Call Stack window.

A [image] green arrow indicates that you have stepped back to the parent code that has called the trigger.

ExpandedToggleIcon(9x12) See Also

Debugging PL/SQL Units

How To: Start Debugging Object Method


How To: Start Debugging Object Method

How To: Debug Object Method

dbForge Studio PL/SQL Debugger allows debugging object static and member procedures and functions. The process of object method debugging can be initiated by calling this method in the PL/SQL program. Put the breakpoint on the line where the object method is called. On the Debug menu, click Step Into. Alternatively, press F11 to step into the body of an object method.

ExpandedToggleIcon(9x12) Creating a Sample Object Type

Procedure

Use the script available in How To: Debug a Stored Procedure to the procedure used in the sample below.

Object Type

Execute the following script to create an object type:

CREATE OR REPLACE TYPE SCHEDULE.REC_TYPE1
AS
OBJECT (DATE_OUT DATE,
DAY_ORDER SMALLINT,
TIME_SHEET_DATE DATE,
MEMBER PROCEDURE ADMIT(DAYOPER SMALLINT));
/

CREATE OR REPLACE TYPE BODY SCHEDULE.REC_TYPE1 AS
MEMBER PROCEDURE ADMIT
( DAYOPER SMALLINT) AS
BEGIN
DAY_ORDER := DAYOPER;
END;
END;
/

ExpandedToggleIcon(9x12) Debugging an Object Method

To debug the method of a created object, call it in the PL/SQL block and run the debugging process of this block. Select Step Into command when the debugger reaches the line where an object procedure call is fulfilled to step inside the method definition.

TYPE ENUM_TYPE IS TABLE OF REC_TYPE;
DAY_ENUM ENUM_TYPE;
DAY_ENUM2 REC_TYPE1;

BEGIN
DAY_ENUM2 := REC_TYPE1(DATE_FROM, NULL, SYSDATE);
DAY_ENUM2.ADMIT(1);
...
END;

ExpandedToggleIcon(9x12) See Also

Debugging PL/SQL Units

How To: Start Debugging Package


How To: Start Debugging Package

How To: Debug a Package

This example shows how to debug a package in dbForge Studio for Oracle. Use provided scripts to create sample objects in your test database.

ExpandedToggleIcon(9x12) Creating a Sample Package

Procedure

Use the script available in How To: Debug a Stored Procedure to the procedure used in the sample below.

Package

Use the script below to create the IU_Schedule_Detail package:

-- PACKAGE_SCHEDULE specification
CREATE OR REPLACE PACKAGE SCHEDULE.Package_Schedule AS
PROCEDURE FILLSCHEDULE(DATE_FROM IN DATE, DATE_TO IN DATE,SCHEDULE_ID IN INT);
FUNCTION GetFirstDayOfMonth(DT DATE) RETURN DATE;
END Package_Schedule;
/

ExpandedToggleIcon(9x12) Debugging a Package

To debug a package:

1. In Database Explorer, expand the Packages node.
2. Choose the name of the required package and expand the node.
3. Choose the FILLSCHEDULE procedure.
4. Right-click the procedure name, select Compile, and then click Compile Dependants For Debugging from the shortcut menu.
5. After the procedure is compiled, right-click it once more and click Step Into to start debugging.
6. Follow the instructions specified in the How To: Debug a Stored Procedure topic regarding the process of debugging the procedure.

note Note

You can also debug a package from other PL/SQL programs, which call package procedures or functions using the same way for schema procedures and functions debugging.

ExpandedToggleIcon(9x12) See Also

Debugging PL/SQL Units

How To: Debug an SQL Script


How To: Debug an SQL Script

This topic explains how to debug SQL scripts using debugger integrated into dbForge Studio for Oracle.

To debug an SQL script:

1. Open the required script in the SQL editor.
2. On the Debug menu, click Run Start.
3. Set a breakpoint for your statement by clicking in the gray margin next to the SET statement.

If a statement is invalid, an error message appears in the error list, though debugging process continues. The debugging of an SQL script can be suspended by clicking the Pause Pause command. You can also use different step commands of the Debug menu to trace an SQL script.

To debug an SQL script, you don't need any special privileges, except for the privileges, required for execution of the script statements.

If an SQL script contains call of another script with SOURCE command, you can use the StepInto Step Into command to step into the called script. If this script contains breakpoints, execution stops on these breakpoints. The Call Stack window shows stack of the script calls.

You can use the Watches window to view server and session variables during SQL script debugging.

ExpandedToggleIcon(9x12) See Also

Debugging PL/SQL Units

Execution Control


Execution Control

This topic describes different navigation techniques while debugging stored database objects.

ExpandedToggleIcon(9x12) Stepping Through Code

One of the most common debugging procedures is stepping. Stepping is executing one line of a code at a time.

The Debug menu provides three commands for stepping through code:

· StepInto Step Into
· StepOver Step Over
· StepOut Step Out

Step Into

Step Into and Step Over differ in only one aspect, the way they handle function calls. Either command instructs the debugger to execute the next line of the code. If the line contains a function call, Step Into executes only the call itself, then halts at the first line of the code inside the function.

Step Over

Step Over executes the entire function, then halts at the first line outside the function. Use Step Into if you want to look inside the function call. Use Step Over if you want to avoid stepping into functions.

On a nested function call, Step Into steps into the most deeply nested function. If you use Step Into on a call like Func1(Func2()), the debugger steps into the function Func2.

Step Out

Use Step Out when you are inside a function call and want to return to the calling function. Step Out resumes execution of your code until the function returns, then breaks at the return point in the calling function.

Continue

The debugger breaks execution of the code when execution reaches a breakpoint. You can select Run Continue, StepInto Step Into, StepOver Step Over, StepOut Step Out on the Debug menu to continue the execution.

Stop Debugging

Stop debugging means terminating the debugging session. It should not be confused with breaking execution, which temporarily halts execution of the process you are debugging but leaves the debugging session active.

To stop debugging process, click StopExecution Stop Debugging on the Debug menu.

note Note

If the module is compiled for debugging, the debug execution is paused at the last line of the code allowing you to investigate the state of the program variables in the Watches window. If the module was not complied for debugging, PL/SQL Units execution is not broken at the last line.

Restart

If you want to stop the run you are currently debugging and immediately begin a new run, you can use the Restart Restart command. Current debug session will be terminated and a new one will start.

ExpandedToggleIcon(9x12) Breaking Non-Responding Program

Stopping execution means terminating the program you are debugging and completing the debugging process. It differs from breaking execution, which temporarily halts debugging session but leaves it active.

note Note

Stop Debugging does not always terminate the program. It stops the process, being in the break mode. Otherwise, it fulfills finalizing the program in the background mode, so that you can begin a new debugging session. Only two instances of the program can be started for debug and terminated in the background mode. The next debugging process will be available only after one of the programs, being terminated, stops running.

ExpandedToggleIcon(9x12) See Also

Debugging PL/SQL Units

How To: Work with Breakpoints


How To: Work with Breakpoints

A breakpoint tells the debugger that an application should break, or pause execution at a certain point. When a break occurs, you can use available tools to evaluate your variables. A breakpoint will stop your code on the line of the source code which will be executed next. When the debugger breaks program execution, the program is broken and it remains in the break mode until you click Step Into, Step Over, Step Out or Run to continue the execution.

ExpandedToggleIcon(9x12) Using Breakpoints

The Breakpoints window lists all breakpoints currently set in your program and displays their properties. Using the Breakpoints window, you can delete, enable or disable breakpoints, or go to the source code corresponding to a breakpoint. The debugger can't operate a breakpoint in the run mode. You can place a breakpoint in the run mode but it will be bound when the debugger enters the break mode.

ExpandedToggleIcon(9x12) Breakpoint Status

Breakpoint status is indicated by symbols that appear in the gray margin, at the left, in the source window. They are:

· Enabled: Execution will be suspended at this breakpoint.
· Disabled: The debugger ignores this breakpoint.
· Error: No breakpoint can be set at this location; the location is illegal and breakpoint cannot be bound. The debugger ignores this breakpoint.

ExpandedToggleIcon(9x12) Inserting Breakpoints

The dbForge Studio debugger provides many ways to set breakpoints:

Using the shortcut menu

1. In a source window, right-click a line of executable code where you want to set a breakpoint.
2. On the shortcut menu, click InsertBreakpoint Insert Breakpoint.

Using the Debug menu

1. In a source window, right-click a line of executable code where you want to set a breakpoint.
2. On the Debug menu, click Toggle Breakpoint.

Here are also two commonly used techniques to set a breakpoint in a source window:

1. Click in the gutter of the window at the line that you want to break at.
2. Select the line and press F9.

The breakpoint icon appears in the gutter.

ExpandedToggleIcon(9x12) Deleting Breakpoints

To delete a breakpoint, perform either of the following:

· Click the breakpoint in the Breakpoints window and then click the Delete button on the Breakpoints window toolbar.
· Right-click the breakpoint in the Breakpoints window and select Delete from the menu.
· Click the breakpoint on the indicator margin.
· Move the insertion point to the breakpoint and select Toggle Breakpoint from the Debug menu.
· Right-click the line of code with the breakpoint and choose Delete from the shortcut menu.

You can delete all breakpoints by choosing Delete All Breakpoints from the Debug menu or by clicking the corresponding button on the Breakpoints window toolbar.

ExpandedToggleIcon(9x12) Enabling or Disabling Breakpoint

You can enable or disable a breakpoint by selecting the check box at the appropriate line in the Breakpoints window. You can also click the Disable/Enable All Breakpoints button in the Breakpoints window to disable all breakpoints, if at least one breakpoint is enabled. Otherwise, it enables all breakpoints.

ExpandedToggleIcon(9x12) See Also

Debugging PL/SQL Units

Execution Control


Debug Shortcut Keys

The following shortcut key combinations can be used while debugging PL/SQL Unitss and SQL scripts.

Icon | Command Name | Shortcut Keys | Action | Where is used
Breakpoints | Breakpoints | CTRL+D, B | Reveal Breakpoints window | Global
CallStack | Call Stack | CTRL+D, C | Reveal Call Stack window | Global (when debug session is started)
Watches | Watches | CTRL+D, W | Reveal Watches window | Global (when debug session is started)
DeleteAllBreakpoints | Delete All Breakpoints | CTRL+SHIFT+F9 | Delete all breakpoints | Global (when debug session is started)
 | Toggle Breakpoint | F9 | Toggle breakpoint | SQL document or PL/SQL Units
Compile | Compile | CTRL+F7 | Compile PL/SQL Units or view | PL/SQL Units or view
CompileDebug | Compile for Debugging | CTRL+ALT+F7 | Compile PL/SQL Units for Debugging | PL/SQL Units
Run | Start/Continue | CTRL+F5 | Start/continue debugging | SQL document or PL/SQL Units
StopExecution | Stop | SHIFT+F5 | Stop debugging | Global (when debug session is started)
Restart | Restart | CTRL+SHIFT+F5 | Restart debugging | Global (when debug session is started)
Pause | Pause | CTRL+ALT+PAUSE | Pause | Global (when debug session is started)
StepInto | Step Into | F11 | Step into | SQL document or stored procedure or function or Global when debug session is started
StepOver | Step Over | F10 | Step over | SQL document or stored procedure or function or Global when debug session is started
RunToCursor | Run To Cursor | CTRL+F10 | Run to cursor | SQL document or stored procedure or function
StepOut | Step Out | SHIFT+F11 | Step out | Global (when debug session is started)

These shortcuts are default shortcuts. All shortcuts can be customized.

ExpandedToggleIcon(9x12) See Also

Debugging PL/SQL Units


How To: Find and Recompile Invalid Objects

The Find Invalid Objects functionality allows to search your database schema for invalid objects that require recompilation.

To identify invalid objects:

1. In Database Explorer, right-click a required connection node or a database node and select Find Invalid Objects in the shortcut menu. Alternatively, go to Database menu and select Find Invalid Objects. The Invalid Object Manager document will open.

The Invalid Object Manager document contains two sections. The Action required section lists invalid objects that require recompilation, and the No action required section lists valid objects.

In the Invalid Object Manager, you can:

· compile the selected invalid objects using the Compile button;
· generate a compile script for the selected objects via the Script changes button;
· export the compilation results to a CSV file via the Export to CSV button;
· search for a specific object in the list using the Search field;
· rerun the search using the Reanalyze button;
· select the type of object to search for from the Type drop-down list;
· select databases and connections from the corresponding Database and Connection drop-down-lists;
· filter and sort data in the grids using the filter glyph and error icon on a column header.

To recompile invalid objects:

1. In the list of invalid objects, select the objects you wish to recompile. You can use the search field to find specific objects.

2. Click the Compile button. The results of recompilation will be shown in the Result column. The errors, if any, will be described in the Error List section below.

ExpandedToggleIcon(9x12) See Also

Debugging PL/SQL Units

Debug Shortcut Keys


Optimizing SQL Queries

dbForge Studio for Oracle offers you a way of obtaining query execution plan and getting session statistics with the help of the Query Profiler tool. To switch to the profiling mode, you can either turn it on by clicking the Query-Profiler-Mode Query Profiling Mode button or Generate Execution Plan Generate Execution Plan button on the SQL toolbar.

ExpandedToggleIcon(9x12) In This Section

How To: Get Query Profiling Results
Describes how to get query profiling results.

How To: Compare Query Profiling Results
Tells how to easily compare profiling results.


How To: Get Query Profiling Results

This topic explains how to obtain query profiling results using Query Profiler.

1. Open a query file and click the Query-Profiler-Mode Query Profiling Mode button on the SQL toolbar to activate the Query Profiler tool.
2. Execute the query by clicking the Execute Execute button or press F5. The Profiler document view opens. See the query profiling results displayed on three tabs - Plan, Session Statistics.

query-plan-oracle
3. After you have made changes in the query, click the Get-New-Results Get New Results button in the Profiler document view. New profiling results appear in the tree view as a new node with time and date of query execution. You can easily distinguish and navigate to them.

note Note

When you save the query file after getting the query profiling results, the latter will be automatically stored in the .Design file.

ExpandedToggleIcon(9x12) See Also

Optimizing SQL Queries

How To: Compare Query Profiling Results


How To: Compare Query Profiling Results

Each time you get profiling results for the executed query, they appear in the tree view as a new node with time and date of query execution. When editing your query, you want to know whether your changes reduce query execution time or not. Query Profiler can quickly compare the profiling results. Do the following:

1. Select the nodes of the required query profiling results in the tree view by holding the CTRL key.
2. Click the Compare-Selected-Results Compare Selected Results button on the toolbar or select the corresponding option from the shortcut menu. The compared results appear in the grid where differences are highlighted.

compare-qp-results-oracle

ExpandedToggleIcon(9x12) See Also

Optimizing SQL Queries


Schema Comparison and Synchronization

This section helps you quickly get started with comparing data in dbForge Studio for Oracle.

ExpandedToggleIcon(9x12) In This Section

Walkthrough
Describes main procedures you can meet while comparing the schemas.

Managing Comparison Results
Learn how to view and manage schema differences the best way.

How To: Synchronize Schemas
Explains how to synchronize two database schemas.

Working with Command Line
Learn how to automate data comparison and synchronization using the command line.

Advanced Topics
Contains advanced information on the schema comparison process.


How To: Quickly Synchronize Two Schemas

This topic explains how to perform simple database schema comparison and synchronization.

ExpandedToggleIcon(9x12) Comparing Schemas

1. Click New Schema Comparison in the Database Design section of the Start Page. The Schema Comparison wizard opens.
New Schema Comparison Wizard

New Schema Comparison Wizard

2. Select the Source and Target connections. (You can edit selected connections or create a new one by either clicking the Edit button or the New button.) To quickly compare schemas, you can click the Compare button immediately after setting databases and skip step 3.
3. To adjust comparison process, set the comparison options.
4. Use the Search field to select the objects you want to compare.

ExpandedToggleIcon(9x12) Synchronizing Schemas

1. Analyze comparison results, select the database objects you want to synchronize by checking the corresponding check boxes.
2. Select the data to synchronize in the grid with comparison results. (To do this, select check boxes next to tables (or views) in the top grid. You may also select check boxes next to individual records on the Only in Source, Only in Target, and Different Records tabs of the bottom grid).
3. Click the Synch-btn Synchronize button on the Comparison toolbar to open the Schema Synchronization wizard.
4. Select where to output the synchronization script in the wizard and then click the Synchronize button.

ExpandedToggleIcon(9x12) See Also

Walkthrough

How To: Save and Load Schema Comparison


How To: Save and Load Schema Comparison

You can save the Schema Comparison document (the one that opens after comparison to show comparison results) for the future usage. The saved file has the '*.scomp' extension and stores schema comparison information, including:

· Source and target settings
· Selected values for comparison options
· Object filters
· Selected values for synchronization options
· Schema mapping settings

It does not contain schema comparison results or object DDL. When the file is opened, schemas are recompared. If target or source can not be found, the New Schema Comparison dialog appears, where you should set source or target options.

ExpandedToggleIcon(9x12) Saving Schema Comparison Document

To save:

· In the File menu, click Save (or Save As).
· Right-click the title of the document and select Save from the menu.
· Click the Save Save button on the toolbar.

ExpandedToggleIcon(9x12) Opening Schema Comparison Document

· Drag it to the dbForge Studio for Oracle UI.
· Use the Open File button on the Standard toolbar.

note Note

When opening the document where a schema and a project are compared, the project should be opened.

ExpandedToggleIcon(9x12) See Also

Managing Comparison Results


How To: Set up Schema Comparison

ExpandedToggleIcon(9x12) Comparing Two Schemas

1. Open the New Schema Comparison wizard by doing any of these actions:
· Highlight two schemas in the Database Explorer window, holding the CTRL key, and select the New Schema Comparison option from the shortcut menu.
· On the Comparison menu, click New Schema Comparison.

2. Click the Type fields and select what you are going to compare (two databases, or a database and a snapshot, or two versioned snapshots in your version control system) from the drop-down lists. There are three options: Database, Snapshot, Versioned Snapshot.

Database

When you select Database in the Type field, the following dialog box appears:

1. In the Connection field, type or select the name of Oracle Server connection required for comparison.
2. If no connection is found, click the New button to create new one.
3. You can edit the selected connection by clicking the Edit button.
4. In the drop-down list of the Connection field, you can click the <Manage...> link to open the Connection Manager dialog box. It will help you to create, edit, and delete database connections.

Snapshot

When you select Snapshot in the Type field, the following dialog box appears:

1. In the Snapshot field, either select a snapshot from a drop-down list or click the Browse button to add another snapshot.
2. The New button opens the Create Scripts Folder or Snapshot window, where you can create a new snapshot. For more information on creating a snapshot, see How To: Create a New Snapshot in Schema Compare.

Versioned Snapshot

note Note

The Versioned Snapshot functionality is now available only for TFS and SVN. Though other version control systems are available for selection, you will be notified that the "Specified Version Control System is not supported".

When you select Versioned Snapshot in the Type field, the following dialog box appears:

1. In the Repository field you have three options:
· Click the arrow icon [image] to select a source control repository from the drop-down list.
· Click the plus icon [image] to create a new source control repository in the Source Control Repository Properties dialog box.
· Click the more option icon more-options-icon to specify source control settings in the Source Control Repository Properties dialog box.
2. In the drop-down list of the Repository field, you can click <Manage...> to open the Repository Manager dialog box. It will help you to create, edit, and delete repositories.
3. In the Snapshot field, select a snapshot for comparing.
4. In the Revision field, select a revision for comparing. To select the latest (head) revision, click the cross icon cross-icon.

Schema Mapping

1. In the Schema Mapping grid, specify the required objects mapping.
2. (Optional) If you want to ignore some schema options during comparison, go to the Options wizard page.
3. (Optional) Go to Object Filter wizard page and select the types of objects you want to compare.
4. (Optional) Use the Search field to find a specific object.
5. Click the Compare button to close the wizard and start the comparison.

Tips:

· To save your time while selecting Source and Target databases, you can copy the details from one side of the wizard to the other by clicking the Copy buttons: - to copy Source database details, [image] - to copy Target database details.
· To swap the Source and Target databases, click the Swap button [image].
· To close the wizard and cancel the comparison, click the Cancel button.

ExpandedToggleIcon(9x12) See Also

Walkthrough

Managing Comparison Results


Managing Comparison Results

This section tells how to view and manage schema differences the best way.

ExpandedToggleIcon(9x12) In This Section

How To: Group and Filter Comparison Results
Describes how to group and filter comparison results by various criteria.

How To: Compare Objects' DDL
Tells how to compare DDL of two corresponding database objects.

How To: Preview Schema Synchronization Script
Teaches how to preview the synchronization script for any compared object.

How To: Generate Comparison Report
Tells how to generate a report after schema comparison is completed.


How To: Group and Filter Comparison Results

This topic explains how to group and filter comparison results in the result grid.

ExpandedToggleIcon(9x12) Grouping

Schema comparison results can be grouped either by schema object type or by operation (as shown in the screenshot). To change grouping, right-click in the document grid and select Object Type or Operation in the Group By submenu of the shortcut menu. By default, comparison results are always grouped by one of these items.

How To: Group and Filter Comparison Results

How To: Group and Filter Comparison Results

note Note

Appearance of this window may vary depending on the product.

ExpandedToggleIcon(9x12) Filtering

Database objects can be filtered by status. You can select what objects to show: Different, Equal, Only in Source, Only in Target, Inconsistent, or Unknown. You can also filter objects by action to view excluded or included objects.

To filter objects, on the Compare toolbar click the down arrow near the Filter button and select the corresponding option in the appeared menu. Any select filter criterion becomes framed in the menu to help you quickly identify what criterion is applied. You can select one and then another criterion to apply together, so several criteria can be applied at the same time.

To discard filtering, select All from the menu.

note Note

Appearance of this window may vary depending on the product.

ExpandedToggleIcon(9x12) See Also

Managing Comparison Results

How To: Compare Objects' DDL


How To: Compare Objects' DDL

dbForge Studio for Oracle allows you to compare DDL of the corresponding objects in the compared schemas.

1. In the Tools menu, click Options.
2. Click Schema Comparison and select General.

You can select one of the following text comparers:

· Internal - it is selected by default.
· Araxis Merge - before selecting this option, check that Araxis Merge 2001 or higher is installed on your PC.
· Custom - you can set and use any other text comparer, which can be used through the command line.

ExpandedToggleIcon(9x12) Using Internal Comparer

If this comparer is selected, under the grid, in the Schema Comparison window, two SQL editors show string and symbol differences of the selected Source and Target schema objects. It is a convenient option, as you can see the object and SQL differences at once without distraction and any inconvenience.

}

To see SQL differences of compared objects, select required objects in the grid and see the differences in two SQL editors under the grid. The corresponding blocks of text, but with any differences, are connected with lines. Differences in strings are marked with three colors:

· light green is for lines existing in the Source schema but missing in the Target one or for symbols that are different in the Source and Target schemas.
· light red - is for lines existing in the Target schema but missing in the Source one
· light blue - lines existing in the Source and Target schemas, but containing differences in some symbols. These symbols are displayed in the red font and highlighted with the light green color.

Corresponding blocks of text, but with any differences, are connected with lines. If required, you will copy text from the SQL editors and then edit or save it in a new SQL document.

ExpandedToggleIcon(9x12) See Also

Managing Comparison Results

How To: Preview Schema Synchronization Script


How To: Preview Schema Synchronization Script

When analyzing the comparison results, you can select any object and preview the synchronization script for it, which will be generated by dbForge Studio for Oracle. This option is very convenient as you can check the script and be sure that you will get the correct synchronization and the desired result after it.

To preview the synchronization script:

Select the required object (or several ones) in the grid and do either of these actions:

1. Click the [image] View Schema Update Script button on the Comparison toolbar.
2. Right-click the grid and select the View Schema Update Script option.

By default, the window with the script snippet opens under the SchemaComparison window with the comparison results. You can move the opened window to any place in the dbForge Studio for Oracle UI.

ExpandedToggleIcon(9x12) See Also

Managing Comparison Results

How To: Generate Comparison Report


How To: Generate Comparison Report

When schema comparison is completed, you can generate a comparison report to keep records of schema changes.

1. In the Comparison menu, click Generate Comparison Report. The Generate Comparison Report dialog opens.
2. Select the report format (either HTML or Excel), its location and objects you want to report.
3. Click Generate.

Tip: If you want to open the comparison report after generation, select View a report on completion.

ExpandedToggleIcon(9x12) See Also

Managing Comparison Results

How To: Synchronize Schemas


How To: Synchronize Schemas

This topic explains how to synchronize two database schemas.

note Note

Schema synchronization can not be rolled back! It may alter or drop schema objects in your Target schema. It is highly recommended to backup the Target database before synchronization.
1. Review the comparison results and select required objects for synchronization. Clear the checkboxes next to the objects you do not want to be synchronized. You can also select an object and then click Exclude Selection in the shortcut menu to exclude one from the synchronization process.
2. Click the [image] View Schema Update Script button on the Comparison toolbar.
3. Click the Synch-btn Synchronize button to open the synchronization wizard. You can select what do you want to do with the synchronization script (either open or save).
4. Click the Synchronize button to close the wizard and complete the synchronization process.
5. Review the sync script, and then execute it by clicking the Execute button on the SQL toolbar.

ExpandedToggleIcon(9x12) See Also

Managing Comparison Results


Working with Command Line

This section describes how to automate data comparison and synchronization using the command line.

note Note

The command line functionality is available only in certain editions of dbForge Studio. For the detailed information on features availability in the dbForge Studio editions, please refer to the Editions topic.

ExpandedToggleIcon(9x12) In This Section

How To: Compare and Synchronize Schemas through Command Line
This chapter explains how to use the command line interface to run comparisons.

How To: Compare Database Snapshots through Command Line
The topic explains how to compare two database snapshots, or a snapshot with a database through command line.

Additional /schemacompare Arguments
The topic contains information on command line switches and examples of their usage.

Command Line Options for /schemacompare Operation
Lists the comparison options to use in the command line.


How To: Compare and Synchronize Schemas through Command Line

You can automate schema comparison and synchronization using the command line.

1. Click Start, and type cmd in the Run line. Press ENTER. The Command Prompt opens.
2. Type a path to the dbforgeoracle.com file, located in dbForge Studio for Oracle installation folder on your PC, and press the SPACE bar.
3. Type all the arguments (actions you want to run) in the Command Prompt. You can do this in three ways:
1) Type all the arguments directly in the Command Prompt, for example:

C:\Program Files\Devart\dbForge Studio for Oracle\dbforgeoracle.com" /schemacompare /source connection:"User Id=scott;Password=tiger;Server=dbOracle;Direct=True;Service Name=orcl1120"
/target connection:"User Id=scott;Password=tiger;Server=dbOracle;Direct=True;Service Name=orcl1120" /schemas:SCHEMA3,SCHEMA;SCHEMA1,SCHEMA2
pause

2) Specify a path to a previously saved comparison document to use the connection settings along with the comparison settings specified in the document.

/schemacompare /compfile:"D:\file_name.scomp"

3) Type the path to a previously generated file with required command line arguments (see below how to prepare the file), for example:

/argfile:"D:\file_name.txt"

Type additional parameters that are not specified in the file into the Command Prompt, for example:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /argfile:file_name.txt /schemacompare /sync

Tip: To see a quick help on the arguments available in the command line, type the following:

dbforgeoracle.com /?

4. Press ENTER to run the process.

Preparing a file with command line arguments

1. Define what action you want to run, for example:

/schemacompare

2. Define Source and Target connection strings:

/schemacompare /source connection:"User Id=scott;Password=tiger;Server=dbOracle;Direct=True;Service Name=orcl1120"
/target connection:"User Id=scott;Password=tiger;Server=dbOracle;Direct=True;Service Name=orcl1120"

You can also use the schema comparison document that already contains Source and Target connection strings.

/schemacompare /compfile:"C:\MyComparison.scomp"

3. To generate and save a log file, specify the file name and location. For example:

/log:"C:\Log.log"

4. To generate and save a comparison report file, specify the file name and location. For example:

/report:"C:\Report.html"

5. To synchronize the schemas, i.e., update the Target schema, type the following:

/sync

6. To generate and save a synchronization script, specify the file location and name. For example:

/sync:"C:\sync_script_name.sql"

ExpandedToggleIcon(9x12) See Also

Working with Command Line

How To: Compare Database Snapshots through Command Line


How To: Compare Database Snapshots through Command Line

This topic describes how to compare two snapshots, and a snapshot with a database using the command line.

note Note

Synchronization to a database snapshot is impossible. You can generate a synchronization script only by specifying the output file path in the '/sync' switch.

ExpandedToggleIcon(9x12) Comparing two snapshots through the command line

To compare two database snapshots through the command line, do the following:

1. Open Command Prompt by pressing Win+R, and typing 'cmd' in the Open line.

note Note

To run Command Line in Windows 8:

From the Desktop Mode

· Move the mouse cursor to the exact lower left corner until the desktop shortcuts menu appears
· Right-click to see the shortcut menu and than click Run

From the Charms Bar

· Move your mouse to the upper right corner until the Charms Bar appears
· Select Apps from the list and type “run” in the search box
· Click Run from the search results

Use Windows + R Shortcut Keys

· In the desktop mode, press Windows key + R to show the Run command line.
2. Type a path to the dbforgeoracle.com file (note that the .com extension can be omitted in the command line), located in dbForge Studio for Oracle installation folder on your PC, and press the SPACE bar.

"C:\Program Files\Devart\dbForge Studio for Oracle\dbforgeoracle.com"

3. Specify the snapshots you want to compare:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /schemacompare /source snapshot:"d:\test\source.snap" /target snapshot:"d:\test\target.snap"

4. Press ENTER to run the process.

Tip: To obtain information on switches, type the following in the command line:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com

More examples can be obtained by typing the following:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /schemacompare /?

ExpandedToggleIcon(9x12) Comparing a snapshot with a database through the command line

To compare a snapshot with a database through the command line, do the following:

1. Open Command Prompt by pressing Win+R, and typing 'cmd' in the Open line.
2. Type a path to the dbforgeoracle.com file (note that the .com extension can be omitted in the command line), located in dbForge Studio for Oracle installation folder on your PC, and press the SPACE bar.

"C:\Program Files\Devart\dbForge Studio for Oracle\dbforgeoracle.com"

3. Specify the snapshot and the database you want to compare:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /schemacompare /source snapshot:"D:\snapshot\SCOTT.snap" /target connection:"User Id=scott;Server=dboracle;Unicode=True;Connection Timeout=0;Direct=True;Service Name=orcl1120;" /schemas:SCOTT,SCOTT

4. Press ENTER to run the process.

ExpandedToggleIcon(9x12) See Also

Working with Command Line

Additional /schemacompare Arguments


Additional /schemacompare Arguments

This topic gives detailed description of command line switches and examples of their usage.

ExpandedToggleIcon(9x12) Arguments

To get more information on switches related to schema comparison in the command line interface, you can type:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /schemacompare /?

Below all switches of this option are described, together with usage examples.

Argument

Action and Usage

/compfile

This switch is used to load command line settings from the comparison project file, *.scomp. Command usage looks like:

/compfile:<path>

Example of using a file with comparison settings, saved earlier:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /schemacompare /compfile:"D:\workDir\OSC1vsOSC2.scomp"

/groupby

This switch is used when generating comparison reports. use it to group objects in such report. Command usage looks like:

/groupby:<none/status/objecttype>

The following example shows how to compare schemas using settings from the file, generate comparison report, and group objects in the report by type:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /schemacompare /compfile:"OSC1vsOSC2.scomp" /report:"report.txt" /reportformat:HTML /groupby:objecttype

/log

Use this switch if you want to generate comparison log file in a specified directory. Command usage looks like:

/log:<filepath>

The following example shows how to compare schemas using settings from the file and write log to the specified file:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /schemacompare /compfile:"OSC1vsOSC2.scomp" /log:"D:\sync.log

options

You can specify some comparison and synchronization options directly in the command line interface. See the list of available options and learn how to use them in the Command Line Options for /schemacompare Operation topic.

/report and /reportformat

You can generate schema comparison report in .html or .xls format. If you specify file format in the output file name in the /report switch, it is not necessary to use the /reportformat switch. Commands usage looks like:

/report:<filepath>

/reportformat:<HTML|XLS>

The following example shows how to compare schemas using settings from a file, generate report to the specified file in the HTML format:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /schemacompare /compfile:"OSC1vsOSC2.scomp" /report:"report.txt" /reportformat:HTML

/source

You can specify source database schema for comparison and synchronization in the command line. It is possible to use several options for defining the schema.

To connect to a server via Oracle client, type:

server:<server_alias> [home:<oracle_home_name>] user:<user_name> password:<pw> mode:[normal/sysdba/sysoper]

To connect to a server without using Oracle client (direct connection), type:

host:<machine_name> [port:<port_number>] SID:<oracle_service_ID> user:<user_name> password:<password> mode:[normal/sysdba/sysoper]

To specify full connection string with additional parameters, type:

connection:<connection_string>

To specify a snapshot file path, type:

snapshot:<filepath>

/target

You can specify target database schema for comparison and synchronization in the command line. It is possible to use several options for defining the schema.

To connect to a server via Oracle client, type:

server:<server_alias> [home:<oracle_home_name>] user:<user_name> password:<pw> mode:[normal/sysdba/sysoper]

To connect to a server without using Oracle client (direct connection), type:

host:<machine_name> [port:<port_number>] SID:<oracle_service_ID> user:<user_name> password:<password> mode:[normal/sysdba/sysoper]

To specify full connection string with additional parameters, type:

connection:<connection_string>

To specify a snapshot file path, type:

snapshot:<filepath>

/schemas

You can specify schemas to compare. If you don't, schemas specified in /source and /target will be used. Command usage looks like:

/schemas:<source_1>,<target_1>[;<source_2>,<target_2>;...]

The following example shows how to compare schemas using connection through client.

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /schemacompare /source server:OraServer user:system password:pswd /target server:OraServer2 user:system password:pswd /schemas:OSC1,OSC2"

/sync

You can perform schema synchronization from the command line interface. If you specify output file for synchronization, only synchronization script will be generated. Command usage looks like:

/sync[:path]

The following example shows how to compare schemas using settings from the file saved before, and save synchronization script:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /schemacompare /compfile:"OSC1vsOSC2.scomp" /sync:"D:\compare_result.sql"

ExpandedToggleIcon(9x12) Usage Examples

· Compare schemas using settings from a file saved earlier:

/schemacompare /compfile:"D:\workDir\OSC1vsOSC2.scomp"

· Compare and synchronize schemas using connection through the client. Log will be written to the specified file:

/schemacompare /source server:OraServer user:system password:pswd /target server:OraServer2 user:system password:pswd /schemas:OSC1,OSC2 /sync /log:"D:\sync.log"

· Compare specified schemas and save the synchronization script to the D:\compare_result.sql file; the first connection is created using direct mode, the second connection is established through the client:

/schemacompare /source host:oraHost port:1521 SID:orcl user:sys password:manager mode:sysdba /target server:OraServer user:system password:pswd /schemas:SC1,SC2;OSC1,OSC2 /sync:"D:\compare_result.sql"

· Compare and synchronize schemas using settings from the file, ignore case and foreign keys during comparison; generate a report to the specified file in the html format:

/schemacompare /compfile:"OSC1vsOSC2.scomp" /icase:yes /IgnoreForeignKeys:yes /report:"report.txt" /reportformat:HTML /groupby:objecttype /incsettings:T /sync

ExpandedToggleIcon(9x12) See Also

Working with Command Line

Command Line Options for /schemacompare Operation


Command Line Options for /schemacompare Operation

By default, dbForge Studio for Oracle generates a file with command line arguments and writes all the comparison and synchronization options into it. Each option is written like the following:

/option_name: [Y/N]

You can edit the file to turn on/off required options. To turn on comparison and synchronization options, edit their values to "Yes", "Y", "True", "T", or "On". To turn off the options, change their values to "No", "N", "False", "F", or "Off".

Each option has a full and short name. You can type either name of a required option into Command Prompt instead of editing the file.

See the list of the options with their full and short command line names below.

Command line option name | Short name | Option
AddRecompileDependantsScript | addnocheck | Add a script for recompiling invalid dependent objects to the end of the synchronization script
EnableNoValidate | ennovalid | Set ENABLE NOVALIDATE for constraints
EnableTableLock | tablelock | Enable table locks during synchronization
ForceColumnOrder | force | Force column order
IgnoreCase | icase | Ignore case
IgnoreColumnDefaultValues | icoldef | Preserve the column order
IgnoreColumnOrderInIndexes | mindcolorder | Ignore the column order for the included columns in indexes.
IgnoreCommentObjects | iobjcomment | Ignore COMMENT objects during comparison
IgnoreComments | icomment | Ignore comments
IgnoreConstraintClauseEnableDisable | iconstdisable | Ignore ENABLE and DISABLE clause of constraints in tables.
IgnoreConstraintClauseValidateNovalidate | iconstnovalidate | Ignore VALIDATE and NOVALIDATE clause of constraints in tables.
IgnoreConstraintsNames | iconnames | Ignore constraints' names
IgnoreForeignKeys | ifk | Ignore foreign keys
IgnoreInvalidObjectsFromSource | iinvsobj | The 'None' operation will be set for all objects from the source schema of INVALID status in the comparison results grid
IgnoreLoggingNologgingClause | ilnl | Ignore LOGGING AND NOLOGGING clause.
IgnoreNotNullConstraints | inotnull | Ignore Not Null constraints
IgnorePartitions | ipart | Ignore partitions while comparing
IgnorePermissions | iperm | Ignore permissions
IgnorePhysicalAttributes | iphysattr | Ignore physical storage settings for tables when comparing and synchronizing databases
IgnoreSchemaName | ischemaname | Ignore schema name.
IgnoreStorageClause | istorage | Ignore STORAGE settings for tables when comparing and synchronizing databases
IgnoreTablespaces | itspace | Ignore tablespaces during comparison
IgnoreTablesCompressions | itcompr | Ignore difference in the compressions for the tables.
IgnoreWhiteSpace | ispace | Ignore white spaces
IsCompareWrappedVsUnwrapped | cwrapped | Compare wrapped and unwrapped PL/SQL objects
IsForceCreateObjects | forceviews | Force the creation of objects even if they are invalid
QuoteObjectNames | quoteobj | Always quote object names with double quotes.
RebuildSequences | rebuildseq | Forcedly rebuild sequences
ExcludeComments | nocomments | Prevent comments generation in a synchronization script.
ExcludeDependencies | edep | If the option is turned on, all the dependencies shown on the Dependencies page of the synchronization wizard will be excluded from synchronization
IncludePrintComments | iprint | Include comments to a synchronization script.
PurgeRecycleBin | purgerebin | Purge the recycle bin when objects are being dropped
RestoreSessionParameters | restoresession | Restore session parameters (NLS_DATE_FORMAT, NLS_TIMESTAMP_TZ_FORMAT, NLS_TIMESTAMP_FORMAT, NLS_NUMERIC_CHARACTERS, NLS_NCHAR_CONV_EXCP, TIME_ZONE) after the script is done
UseSchemaNamePrefix | fullnames | Generate fully qualified object names in the synchronization script
UseSqlExtensionCommands | sqlplus | Use SQL *Plus commands SET SQLBLANKLINES and SET DEFINE in synchronization script.
IncludeComparisonSettings | incsettings | Includes identical objects into your report
IncludeIdenticalObjects | incident | Includes comparison options into your report. This option is available only for HTML reports.
SelectedObjectsOnly | selobjonly | Includes objects selected for synchronization into your report

ExpandedToggleIcon(9x12) See Also

Working with Command Line

Advanced Topics


Advanced Topics

This section gives advanced information on the schema comparison process and issues that you may encounter.

ExpandedToggleIcon(9x12) In This Section

Schema Comparison Overview
Provides general information on schema comparison and synchronization.

Viewing Schema Differences Overview
Explains how comparison results are presented and how to organize them for better understanding.

Comparing Schemas on Different Oracle Server Versions
Describes peculiarities of schema comparison on servers with different versions.

Known Schema Comparison Problems
Lists known schema comparison problems.

How To: Create a New Snapshot in Schema Compare
Describes the process of creation of a schema snapshot.


Schema Comparison and Synchronization Overview

dbForge Studio gives you a perfect opportunity to compare and synchronize schemas with many useful features. They include the following:

· Comparing and synchronizing of two schemas or a schema and a database project.
· Schema comparison separates objects existing only in the Target or Source database, identical objects, and ones having the same name, but with different structure.
· Schema comparison results are displayed in a convenient document, easy for analysis and synchronization.
· Schema comparison is asynchronous. Based on your needs, you can stop it in any moment.
· Schema comparison includes object description. When any errors occur during description, error notifications are shown. You can either stop or retry comparison, or ignore the errors. In case of fatal errors, schema comparison is automatically stopped.
· You can quickly synchronize the Target schema with the Source one or export a schema synchronization script.

ExpandedToggleIcon(9x12) See Also

Advanced Topics

Viewing Schema Differences Overview


Viewing Schema Differences Overview

After comparing schemas or a schema and a project, the differences are shown in the schema comparison document. In the upper part you will see the names of compared databases and their connections. Source schema objects are displayed in the left part and Target schema objects are in the right one.

ExpandedToggleIcon(9x12) Object status

dbForge Studio for Oracle automatically sets different statuses for compared objects to help you quickly analyze the differences. Compared objects can have the following statuses:

· Only in Source - schema object exists in source schema and does not exist in target schema.
· Only in Target - schema object exists in target schema and does not exist in source schema.
· Different - schema objects with the same names exist in both schemas, but they have different DDL.
· Equal - identical objects exist in both schemas.
· Inconsistent - objects are different, but target object can not be created or updated due to incompatibility between the source and target Oracle servers. For example, if source table contains a BIT column and target Oracle server does not support BIT columns. Table status will be inconsistent.
· Unknown - object metadata cannot be retrieved, so its status is unknown.

note Note

If a Source table has partitioning and a Target Oracle server does not support partitioning, table comparison status depends on the table structure differences. If the table exists only in Source or has other differences than partitioning, it has Only in Source or Different status and it can be synchronized with Source except for partitioning. If the tables in Source and Target have the same structure except for partitioning, the partitioning is ignored and the table comparison status is Equal.

ExpandedToggleIcon(9x12) Update operation

For each compared object dbForge Studio automatically sets the operation in the Operation field to apply after synchronization. Based on your needs, you can change it and select the required one from the drop-down list in the field. The following operations are available:

· None - by default, it is set for identical objects, you can change it to Drop.
· Update - by default, it is set for objects with Different status and means the object will be moved to the Target schema. You can change it to Drop or None.
· Drop - by default, it is set for objects with Only in Target status and means the object will be dropped in the Target schema. You can change it to None.
· Create - by default, it is set for objects with Only in Source status and means the object will be created in the Target schema. You can change it to None.

ExpandedToggleIcon(9x12) Excluding objects from synchronization

If you don't want to synchronize some objects, clear check boxes for them in the grid.

To exclude several objects from synchronization or include them, highlight these objects in the grid and select the Exclude Selection or Include Selection options from the right-click the menu or press the SPACE key to include/exclude selected objects.

By default all compared objects are included into synchronization.

ExpandedToggleIcon(9x12) Managing comparison results

To refresh schema comparison results, click the Refresh button on the Comparison toolbar.

To better understand comparison results, you can do the following:

· Filter them by comparison status
· Group by comparison status and object type

ExpandedToggleIcon(9x12) See Also

Advanced Topics

Comparing and Synchronizing Schemas on Different Oracle Server Versions


Comparing and Synchronizing Schemas on Different Server Versions

Comparing and Synchronizing Schemas on Different Oracle Server Versions

When comparing schemas on different Oracle servers, some incompatibilities can occur in schema objects. For example, when comparing schemas on Oracle 3.23 and 5.x. Schema on Oracle 5.x can have such objects as views, triggers, stored routines that are not supported on 3.23 server. This topic describes how dbForge Studio for Oracle treats such incompatibilities.

ExpandedToggleIcon(9x12) Not Supported Objects

If source schema contains objects that are not supported on the target Oracle server, they are not displayed in the Schema Comparison document and are not affected by synchronization.

If target schema contains objects that are not supported on the source Oracle server, they are displayed in the document. Their default operation is None and they will not be affected by synchronization. You may change their operation to Drop, so the object will be dropped from the target schema.

ExpandedToggleIcon(9x12) Partially Supported Objects

Sometimes there are some incompatibilities even if the type of the database object is supported on both source and target database. For example, tables are supported by both Oracle 3.23 and Oracle 5.x, but a table on one server may have a column of a type that is not supported on the other one.

When an object is supported on the source server but is not supported on the target server, it will have Inconsistent status and cannot participate in synchronization. When there is an object in the target that is not supported in the source, but source objects are supported on the target server, target schema can be synchronized and incompatible database objects have Different status.

Here are some examples of such incompatibilities:

· Unsupported column type (for example, Oracle 3.23 does not support BIT column type).
· Unsupported table engine.
· Unsupported ROW_FORMAT
· Usage of unsupported built-in functions in the DDL.

ExpandedToggleIcon(9x12) Partitioning

Partitioning is treated in another way than other incompatibilities. Let us examine several situations:

· The source and target tables have the same structure except for partitioning. In that case, the target table can be updated. If the target schema supports partitioning, the status is Different, otherwise it is Equal.
· Source partitioned table has another structure than corresponding target table or there are no corresponding target table (having the same name). In that case the table has Different status.

If target schema supports partitioning, partitioned tables are included into schema comparison results, otherwise they are ignored.

ExpandedToggleIcon(9x12) Syntax Incompatibility

In cases when equal schema objects have syntax differences, because they are placed on different server versions, the object DDL is generated according to target object DDL.

ExpandedToggleIcon(9x12) See Also

Advanced Topics

Known Schema Comparison Problems


Known Schema Comparison Problems

When comparing Oracle schemas you may face some problems caused by Oracle limitations. Here is the list of widely-known problems:

· If you compare schema on Oracle 6.0 with another schema on Oracle 4 or 5.0, and there are tables with TIMESTAMP column, status of such tables will always be different even if they have the same structure or they were synchronized.
· Oracle does not allow editing tables with EXAMPLE table engine, so synchronization of such tables will fail.
· On the Oracle 6.0 table, containing VARCHAR column can have ROW_FORMAT = FIXED. On the earlier Oracle version you may execute ALTER TABLE ... ROW_FORMAT = FIXED but it does not do anything. So, such tables will have Different comparison status even if after their synchronization.

ExpandedToggleIcon(9x12) See Also

Advanced Topics


How To: Create a New Snapshot in Schema Compare

This topic describes the steps you should follow to create a schema snapshot file.

Snapshot is a file generated by dbForge Studio that contains information about a database structure in XML format.

To create a new snapshot:

1. On the Database menu, click Create Schema Snapshot. The Create Snapshot dialog box opens.

Snapshot-create

2. The Type box in the Source section displays a source type, for which a snapshot is created.

3. In the Connection box, select an Oracle connection from the drop-down list. Click <Manage...> in the top of the list to open the Connection Manager dialog box. It will help you to create, edit, and delete database connections. To edit the current connection parameters, click the Edit button. To create a new connection, click the New button.

4. In the Schema box, select a required schema from the drop-down list. Click <Refresh...> in the top of the list to refresh the list of available schemas, if any changes were made.

5. The Type box in the Destination section displays the destination type (snapshot) that is created.

6. In the Path box, click the [...] button, then select the folder to save the snapshot to and specify the name of the snapshot file.

7. (Optional), select the Compress check box to compress the created snapshot file. It is recommended if you have selected a large schema.

8. Click the Create button to finish the snapshot file creation.

ExpandedToggleIcon(9x12) See Also

Advanced Topics


Data Comparison and Synchronization

This section helps you quickly get started with comparing data in dbForge Studio for Oracle.

ExpandedToggleIcon(9x12) In This Section

Comparing Data
The section describes how to setup the data comparison process.

Analyzing Comparison Results
Learn the section to perform data comparison analysis.

Synchronizing Data
Describes how to synchronize data.

Working with Command Line
Learn how to automate data comparison and synchronization through the command line.

Advanced Data Comparison Topics
The section contains advanced topics describing data comparison and synchronization process.


Comparing Data

This section describes how to setup the data comparison process, how to compare data, and analyze comparison results.

ExpandedToggleIcon(9x12) In This Section

How To: Set up Data Comparison
The topic describes all steps that can be taken during data comparison process and alternative ways for accomplishing routine comparison tasks.

Mapping
This section describes automatic and manual object mapping.

Data Comparison Options
The topic describes options of comparison process.

ExpandedToggleIcon(9x12) See Also

Analyzing Comparison Results


How To: Set Up Data Comparison

From this topic you will learn all steps that can be taken during data comparison process and alternative ways for accomplishing routine comparison tasks.

1. In the Data Comparison Wizard window, select source and target connection from the drop-down list. Also you can create new connection by clicking New or modify existing ones by clicking Edit.
2. Select source and target databases in the grid to compare. To quickly find a required one, use the Filter field. To hide system schemas in the grid, select the corresponding check box. You can easily swap source and target databases by clicking the Swap Swap button. (To immediately compare the data, click the Compare button. To tune the comparison, click the Next button to move to other wizard pages.).

NewDataComparisonOracle

note Note

This is available only in the Standard edition.
3. Click Next.
4. On the Options page, you can customize your comparison by checking required options. Here you can generate a file with command line arguments. Click Next.

Data Comparison Options

note Note

The whole list of options is available only in the Standard edition.
5. On the Mapping page, you can customize mapping. Use this page if you want to change the default mapping or map tables with different names or columns with different names and structure. Read more about mapping in the Object Mapping section. Click Compare.

Mapping Oracle schemas
6. After comparison process is completed, you can view results in the Data Comparison document.

Comparison results Oracle

ExpandedToggleIcon(9x12) See Also

Comparing Data

Mapping


Mapping

This section describes dbForge Studio automatic and manual object mapping.

By default dbForge Studio maps tables that have the same name and owner and columns with the same names for comparison. Column order may be different. Unique or primary constrains with the same set of columns can be used as comparison keys.

ExpandedToggleIcon(9x12) In This Section

How To: Map Tables and Views
Describes how to map tables and views manually.

How To: Map Columns
Describes how to map columns manually.

How To: Set Comparison Key
Describes how to select constraints for the comparison key or create custom comparison key.

How To: Filter Rows Included into Comparison
Describes how to filter rows to compare specific ranges.

Mapping Warnings
Describes warnings you may encounter when mapping database objects.

ExpandedToggleIcon(9x12) See Also

Comparing Data

Data Comparison Options


How To: Map Tables and Views

dbForge Studio allows you to map tables or views with non-equal names. This topic contains instructions on custom table and view mapping.

By default, when you move to the Mapping tab of the Data Comparison wizard, dbForge Studio automatically maps all available objects of the selected databases.

note Note

To remap already mapped objects, unmap them first. See the "How to unmap an object" section below.

note Note

After objects are mapped for comparison and synchronization, you may encounter mapping warnings, displayed as Caution icons.

ExpandedToggleIcon(9x12) How to unmap an object:

1. Switch to the Mapping page of the Data Comparison wizard.

Mapping objects in Oracle schemas
2. In the grid, select database objects to unmap. (To find a mapped database object quickly, use the Filter box. Type the string in this box to view only the objects, containing this string in their names. Click the arrow button to select a recent search. To clear the Filter box, click the x button.)
3. Click the unmap Unmap button on the toolbar. The unmapped objects disappear from the grid, but will be listed in the Object Mapping dialog.

ExpandedToggleIcon(9x12) How to map an object:

1. Switch to the Mapping page of the Data Comparison wizard.
2. Click the change-mapping Map Objects button on the toolbar. The Objects Mapping dialog will appear.

Object Mapping in Oracle
3. Select source and target objects in the corresponding boxes.
4. Click the Map button and the mapped objects disappear from the Objects Mapping dialog and will be shown in the Mapping tab's grid.
5. Repeat steps 3-4 until you map all the objects you need. Click OK to close the dialog.

CollapsedToggleIcon(9x12) How to map an object using custom queries

You can use this option to compare custom results received after query execution instead of comparing whole tables or views. For this, you should:

1. Click the custom-query-mapping Custom Query button on the Mapping page of the wizard. The Custom Queries Mapping dialog box opens.

custom-query-sqlserver

note Note

Actual document look may slightly vary from the above image depending on the product you use.
2. Select Query or Table radio buttons for Source and Target.
3. If you selected Table for both, refer to the How to map an object section of this topic. If you selected Query for Source, Target or both, write query name in the field (if the name assigned by default is not appropriate).
4. Type the needed query in the SQL field.
5. Click Validate to validate your queries, if necessary.
6. Click Map.
7. Click OK to close the dialog box.

Tips:

Click the Cancel button to close the dialog and discard mapping.

Click the Reset Reset button to restore the automatic mapping of objects.

ExpandedToggleIcon(9x12) See Also

Mapping

How To: Map Columns


How To: Map Columns

dbForge Studio allows you to map columns with non-equal names. You may map columns with different types, however this may result in data truncation, rounding, and errors during synchronization for certain types. If such a situation is possible, a warning icon Caution appears in the Target Column column of the Select columns for comparison grid. If the columns are not compatible and cannot be compared, the ErrorIcon icon appears near this column.

For customizing column mapping the Column Mapping dialog box is used. To open it, click the [image] button in the Columns in Comparison column on the Mapping page of the Data Comparison wizard.

ColumnMapping

note Note

Actual document look may slightly vary from the above image depending on the product you use.

note Note

If you want to remap already mapped columns, you should unmap them first.

How to unmap columns

Click the corresponding cell in the Target Column column and choose <None>.

How to map columns

Click the corresponding cell in the Target Column column and choose the column you need.

ExpandedToggleIcon(9x12) See Also

Mapping

How To: Set Comparison Key


How To: Set Comparison Key

Comparison key is used to determine which rows correspond to each other. You can choose suitable constraints for comparison or specify custom comparison keys. dbForge Studio can select comparison key automatically if tables have matching primary key or unique constraint.

To choose a constraint pair, click the CBDropDownArrow button in the Comparison Key column on the Mapping page of the Data Comparison wizard and select the constraint pair you need.

To set a custom comparison key, click the CBDropDownArrow button in the Comparison Key column on the Mapping page of the Data Comparison wizard and select <Custom>. Then in the appeared Column Mapping dialog box select check boxes in the Key column to add columns to the comparison key.

Note that you can set custom comparison key or choose the needed constraint pair directly in the Comparison Key drop-down list of the Column Mapping dialog box.

ColumnMapping

note Note

Actual document look may slightly vary from the above image depending on the product you use.

ExpandedToggleIcon(9x12) See Also

Mapping

How To: Filter Rows Included into Comparison


How To: Filter Rows Included into Comparison

By default, dbForge Studio compares all the rows in the selected tables or views. If they contain a large amount of data, the comparison can take a lot of time and even result in running out of disk space. You can simply avoid such things by filtering the rows to compare specific ranges.

1. Open the Data Comparison Wizard and specify source and target schemas. Click Next.
2. On the Mapping wizard page, select a required object in the grid, and then click the Filter button. The WHERE Filter dialog opens. It is divided into Source section (on the left) and Target one (on the right). If you want to filter Source rows, use the left section. To filter Target rows, use the right section.
3. Right-click either Source or Target section, then select Insert Column and a required column from the shortcut menu. Type a filter expression.

4. If you want to apply the expression to both Source and Target rows, type the expression and select Use the same expression for source and target.
5. To apply the filtering expression, click OK. The filtered object will be marked with the ? icon on the Mapping wizard page grid.

ExpandedToggleIcon(9x12) See Also

Mapping

Mapping Warnings


Mapping Warnings

After objects are mapped for comparison and synchronization, you may encounter warnings on the Mapping page of the Data Comparison wizard. The warnings may be divided into two groups. They are table-level warnings and column level warnings.

Table-level warnings are displayed as Caution icon in the column with check boxes on the Mapping page of the Data Comparison wizard. Object pairs with table-level warnings are not compared. They are displayed with Caution icon instead of check box in the Data Comparison document.

MappingPageOracle

Column-level warnings are displayed as Caution icon in the Columns in Comparison column on the Mapping page of the Data Comparison wizard. They also appear in the Target column in the Column Mapping dialog box. Such warnings mean that some columns of a compared object pair cannot be compared because of type incompatibility or that you may encounter data loss when synchronizing data.

To read the warning messages, point to the warning icon. All warnings for this object will appear in the hint.

The following table contains information about table-level warnings and ways to remove them.

Warning | Description
No columns to compare. | It means, there are no columns with the same name in this pair of tables (views). To compare them you should map the columns manually. For more information about the column mapping, see How to: Map Columns.
Objects to compare have no key column. | It means that custom comparison key is used but is not set. You should mark at least one column pair as comparison key. For more information visit How to: Set Comparison Key.

The following table contains information about column-level warnings.

Warning | Description
Conversion is possible, but may fail in case of incompatible data. | Conversion between columns "ColumnName1" and "ColumnName2" is possible, but may fail in case of incompatible data.
Columns have different precisions. | Columns "ColumnName1" and "ColumnName2" have different precisions, data migration may cause overflows.
Date or time columns have different data format. | Date and time columns "ColumnName1" and "ColumnName2" have different data format, migrating the data may cause truncation.
Numeric columns have different precisions. | Numeric columns "ColumnName1" and "ColumnName2" have different precisions, migrating the data may cause rounding.
Columns have different sizes. | Columns "ColumnName1" and "ColumnName2" have different sizes, migrating the data may cause truncation.
Source column allows Nulls which can not be stored in target. | Source column "ColumnName1" allows Nulls which can not be stored in target column "ColumnName2", data migration may cause error.
RowID columns have different formats. | RowID columns "ColumnName1" and "ColumnName2" have different formats.
Data type is not supported. | Data type "ColumnName1" of the "ColumnName2" column is not supported. For the Direct mode: Data type "ColumnName1" of the "ColumnName2" column is not supported in the direct mode.
CLOB data could be spoiled. | Columns "ColumnName1" and "ColumnName2" have CLOB or NCLOB data types. Oracle 8 does not support textual encoding for loading CLOBs and NCLOBs from files, hence if you have non-latin characters data of these data types, you may lose it. Please turn off the 'Synchronize LOBs via files' option, or use it at your own risk.
Types are incompatible. | These columns cannot be compared. This warning appears when data of the source column cannot be converted to the data type of the target column, for example, RAW and NUMBER.

note Note

You may exclude columns from comparison and synchronization either by unmapping them or by clearing the check boxes in the first column of the Select columns for comparison grid on the Column Mapping dialog box.

ExpandedToggleIcon(9x12) See Also

Mapping

Data Comparison Options


Data Comparison Options

Data comparison and synchronization options are set in the Data Comparison Wizard. You can include views and tables to data comparison and set options for automatic object mapping on the Source and Target wizard page.

Other comparison options can be found at the Options page. Select Ignore Case for case insensitive data comparison, and set the Paginal mode options for displaying data of compared tables or views. Records for comparison and synchronization can be selected on this page. You can select whether to view identical records, different records, records only in source, and only in target.

DataComparisonOptionsOracle

ExpandedToggleIcon(9x12) See Also

Mapping

Comparing Data


Analyzing Comparison Results

This section tells how to perform data comparison analysis.

ExpandedToggleIcon(9x12) In This Section

How To: View Data Comparison Results
The topic describes a data comparison document interface and explains how to view comparison results.

How To: Generate Data Comparison Report
The topic explains how to view results of data comparison in the form of a report.

ExpandedToggleIcon(9x12) See Also

Synchronizing Data


How To: View Data Comparison Results

After you have compared data, a Data Comparison document will appear with Source and Target connections displayed in the upper part of the window and data comparison results displayed in two grids. The top grid lists all the compared tables and views with values indication the quantity of rows that are different, identical, existing only in Target or only in Source. The bottom grid contains the corresponding data records of the selected database object in the top grid. The records are grouped by their status and displayed on separate tabs. They are Different Records, Only in Source, Only in Target, Identical Records, and Conflict Records (it appears only in case any conflict records exist). The shortcut menu of the Data Comparison document and its top menu provide a number of options to manage the comparison results. The status bar in the bottom of the grid shows the number of differences per a column.

Database objects can be filtered by differences. You can select what objects to show: objects with different, identical records, only in source or only in target records.

To view the specific kind of tables:

1. Click the down arrow near the Filter button on the Comparison toolbar.
2. Select the corresponding option in the appeared menu. Several options can be selected at the same time.

note Note

In case a table has both different and identical records, it will be visible, independently of the selected options (Different or Identical).

You can also filter Incorrectly mapped objects and Correctly mapped objects.

To clear filtering:

1. Click the down arrow near the Filter button on theComparison toolbar.
2. Select All from the appeared menu.

The bottom grid allows you to view data differences between the corresponding tables or views. Select a table in the compared database object grid, and the data of these tables appears in the tabs below.

The Identical Records tab contains a grid with data rows that are identical and there is no need to update such records in target. Other tabs contain an additional column with check boxes in the grid. This column is named as action, that will be executed when synchronizing data - Update, Delete, or Insert. By selecting or clearing these check boxes you can control which rows will be affected with data synchronization. This column will not hide when scrolling grid.

note Note

Incorrectly mapped objects are displayed with Caution icon instead of check box in the Data Comparison document. The data of such database objects are not compared. Zero count will be displayed for all kinds of records. Objects with no data to synchronize (with only identical records or with no records at all) are displayed without check boxes.

Only in Source and Only in Target tabs contain grid with Insert and Delete columns respectively and data rows, that are stored only in the table of the source and of the target database respectively. Different Records tab contains grid with the following columns.

· Column with check boxes.
· Comparison key columns. Their value is the same for the compared tables.
· Other table columns. Source columns and target columns are grouped in pairs and marked as (Source) and (Target). When the values of the corresponding columns are different, this pair is highlighted with bold.

If a non-unique custom comparison key was chosen for any table or view, the fifth column in main grid and the fifth tab, Conflict Records appear. The tab consists of two grids containing all records with non-unique values of the comparison key from the corresponding database. These records cannot be synchronized.

If you cleared Update, Delete, or Insert column check boxes in some tables, you may view only tables with selected records or only tables without selected records. To filter tables, click the down arrow near the Filter button on the Comparison toolbar and select the corresponding option in the appeared menu.

To refresh data comparison results, click the Refresh button on the Comparison toolbar. To view long text or binary fields, use the Data Viewer and Editor window.

ExpandedToggleIcon(9x12) See Also

Analyzing Comparison Results

How To: Generate Data Comparison Report


How To: Generate Data Comparison Report

dbForge Studio provides a possibility to view results of data comparison in the form of a report.

ExpandedToggleIcon(9x12) Generating Report

To generate a comparison report after comparison, perform the following steps:

1. In the Comparison menu, select comparison-report-icon Generate Comparison Report. The Comparison Report Wizard will be opened.

note Note

Actual document look may slightly vary from the above image, depending on the product you use.
2. On the Format page select the required report format (HTML or Excel).
3. Specify the name of the report file.
4. Specify the location of the report file.
5. Check the View the report on completion check box to view the report upon creation.
6. On the Options page select required options.

7. Click Generate.

ExpandedToggleIcon(9x12) See Also

Analyzing Comparison Results

Synchronizing Data


Synchronizing Data

This section describes how to synchronize data.

ExpandedToggleIcon(9x12) In This Section

How To: Synchronize Data
The topic guides you through the process of establishing consistency among data from a source and a target data storage.

Synchronization Warnings
The topic describes warnings that may occur during the data synchronization process.


How To: Synchronize Data

note Note

Data synchronization can not be rolled back! It may change or delete data in your target database. It is highly recommended to backup target database before synchronizing data.

ExpandedToggleIcon(9x12) Synchronizing databases

To start synchronizing data of two databases:

1. Select data to synchronize. For this, select check boxes in the column with check boxes for the tables (or views) you want to synchronize. You may also click a separate table and select check boxes in the column with check boxes on the Only in Source, Only in Target, and Different Records tabs for individual records to determine which records to synchronize. Use the check box in the header of the grid to apply settings to all the grid rows.

data-comp-oracle

note Note

Incorrectly mapped objects are displayed with Caution icon instead of check box in the Data Comparison document. Objects with no data to synchronize (with only identical records or with no records at all) are displayed without check boxes. You cannot select them for synchronization.
2. On the Comparison toolbar, click [image] Synchronize. Data Synchronization Wizard opens.
3. Select whether to backup target database and backup files location. Then select whether to execute a script as a single transaction. You may click the Synchronize button and skip next steps to open the synchronization script in the editor, but this is not recommended if the script is too large.
4. Select action for the synchronization script - open in the editor, save for the future execution, or immediately execute it.
5. You may either click the Synchronize button to generate the update script or click the Next button to set synchronization options and view the synchronization action plan and synchronization warnings if any exist, and then click the Synchronize button.

ExpandedToggleIcon(9x12) See Also

Synchronizing Data

Synchronization Warnings


Synchronization Warnings

Synchronization warnings are displayed at the Summary Page of the Data Synchronization wizard. These warnings are the same as column level Mapping Warnings. But mapping warnings appear regardless of real data differences, they are generated if there are column datatype differences, which may cause errors or data loss in the tables to compare. Synchronization warnings appear only if there are data to be updated or inserted to the target table.

If you encountered synchronization warnings, than synchronization may fail or data loss may occur because of truncation or rounding. If the warning has the ErrorIcon icon, then the error will certainly occur when executing synchronization script. To avoid this error, exclude this table or corresponding records from synchronization by clearing the corresponding check boxes in the Data Comparison document.

ExpandedToggleIcon(9x12) See Also

Synchronizing Data

How To: Synchronize Data


Working with Command Line

This section describes how to automate data comparison and synchronization using the command line.

note Note

The command line functionality is available only in certain editions of dbForge Studio. For the detailed information on features availability in the dbForge Studio editions, please refer to the Editions topic.

ExpandedToggleIcon(9x12) In This Section

How To: Compare and Synchronize Data through Command Line
This chapter explains how to use the command line interface to run comparisons.

How To: Schedule Database Synchronization
The topic explains how to use the Windows Task Scheduler to run database synchronization automatically.

Additional /datacompare Arguments
This topic contains all additional command line arguments for /datacompare switch and shows how to use them.

Options Used in Command Line for /datacompare
Lists the comparison options to use in the command line.

Parameters Used in Command Line
This topic describes command line parameters.

ExpandedToggleIcon(9x12) See Also

Advanced Data Comparison Topics


How To: Compare and Synchronize Data through the Command Line

You can automate data comparison and synchronization using the command line.

ExpandedToggleIcon(9x12) Running Comparisons from the Command Line

1. Click Start.
2. Type cmd in the Search programs and files text box and press the ENTER button.

note Note

To run the Command Line in Windows 8:

From the Desktop Mode

· Move the mouse cursor to the exact lower left corner until the desktop shortcuts menu appears.
· Right-click to see the shortcut menu and than click Run.

From the Charms Bar

· Move your mouse to the upper right corner until the Charms Bar appears.
· Select Apps from the list and type “run” in the search box.
· Click Run from the search results.

Use Windows + R Shortcut Keys

· In desktop mode, press the Windows + R keys, to show the Run command line.
3. Type a path to the dbforgeoracle.com file located in the dbForge Studio for Oracle installation folder on your PC, and press the SPACE.

C:\Program Files\Devart\dbForge Studio for Oracle\dbforgeoracle.com

4. Specify command line arguments (connection strings and actions you want to run).

For example, specify the type of the operation.

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /datacompare /?

5. Specify the objects that will be compared and synchronized.

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /datacompare /compfile:"D:\mycompdoc.dcomp"

6. Synchronize data directly into the database and generate a synchronization script file.

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /datacompare /compfile:"D:\mycompdoc.dcomp" /sync:"D:\mysync.sql"

note Note

To synchronize data automatically, use /sync without file name specification:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /datacompare /compfile:"D:\mycompdoc.dcomp" /sync
7. Generate a comparison and synchronization protocol into a file.

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /datacompare /compfile:"D:\mycompdoc.dcomp" /sync:"D:\mysync.sql" /log:"D:\mylog.log"

8. Compose a comparison report.

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /datacompare /compfile:"D:\mycompdoc.dcomp" /sync:"D:\mysync.sql" /log:"D:\mylog.log" /report:"D:\myreport.html"

9. Specify the report format. HTML and EXCEL formats are available.

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /datacompare /compfile:"D:\mycompdoc.dcomp" /sync:"D:\mysync.sql" /log:"D:\mylog.log" /report:"D:\myreport.html" /reportformat:HTML

10. Press ENTER to run the process.

Tip: To execute the synchronization script, use the /execute switch:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /execute /connection:"User Id=scott;Server=dboracle;Unicode=True;Connection Timeout=0;Direct=True;Service Name=orcl1120;" /inputfile:"D:\mysync.sql"

ExpandedToggleIcon(9x12) Generate File With Command Line Arguments

To generate a file with command line arguments, open the Data Comparison wizard.

To access the Data Comparison Wizard, on the Comparison menu, click NewDataComparisonButton

Select Source and Target for comparison. Go through other wizard pages to tune the data comparison.

On the Options tab, click Save settings to a command line arguments file and specify the file name and location to save the file. The selected Source and Target connection strings along with comparison options will be saved as command line arguments in the file. You can edit the values of comparison options in the file.

Note that the generated file does not contain password information for security purposes. You should edit the file and enter the passwords manually.

You can see available additional arguments and learn how to use them in the Additional /datacompare Arguments topic.

The command line string with /argfile parameter will be written as follows:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /argfile:file_name.txt

ExpandedToggleIcon(9x12) See Also

How To: Schedule Database Synchronization


How To: Schedule Database Synchronization

You can use Windows Task Scheduler to create and manage synchronization tasks that your computer will carry out automatically at the times you specify.

ExpandedToggleIcon(9x12) Create Synchronization Task

To create Windows task:

1. Run the Windows Task Scheduler.

note Note

To run the Windows Task Scheduler:

1. Click Start and then click Control Panel.
2. Click Administrative Tools.

note Note

If your current view is Category, click System and Security, and then click Administrative Tools
3. Click Task Scheduler.
3. Click the Action menu, and then click Create Basic Task.
4. Type a name for the task and an optional description, and then click Next.
5. Do one of the following:
· To select a schedule based on the calendar, click Daily, Weekly, Monthly, or One time, click Next; specify the schedule you want to use, and then click Next.
· To select a schedule based on common recurring events, click When the computer starts or When I log on, and then click Next.
· To select a schedule based on specific events, click When a specific event is logged, click Next; specify the event log and other information using the drop-down lists, and then click Next
6. To schedule a program to start automatically, click Start a program, and then click Next.
7. Click Browse to enter a path to the datacompare.com file in Program/script. (The default path is C:\Program Files\Devart\dbForge Studio for Oracle.)
8. Also, make sure to specify arguments in the Add arguments field.
9. Click Next.
10. Click Finish.

ExpandedToggleIcon(9x12) See Also

Additional /datacompare Arguments


Additional /datacompare Arguments

This topic gives detailed description of command line switches and examples of their usage.

You can select the required options while setting the comparison in the Data Comparison wizard and generate a file with command line arguments by clicking Save settings to a command line arguments file.

ExpandedToggleIcon(9x12) Arguments

To get more information on switches related to data comparison in the command line interface, you can type:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /datacompare /?

Below all switches of this option are described, together with usage examples.

Argument

Action and usage

/compfile

This switch is used to load command line settings from the comparison project file, *.dcomp. Command usage looks like:

/compfile:<path>

Example of using a file with comparison settings, saved earlier:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /datacompare /compfile:"D:\workDir\ODC1vsODC2.dcomp"

/log

Use this switch if you want to generate comparison log file in a specified directory. Command usage looks like:

/log:<filepath>

The following example shows how to compare schemas using settings from the file and write log to the specified file:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /datacompare /compfile:"ODC1vsODC2.scomp" /log:"D:\sync.log

options

You can specify some comparison and synchronization options directly in the command line interface. See the list of available options and learn how to use them in the Options Used in Command Line for /datacompare topic.

/report

/reportformat

You can generate schema comparison report in .html or .xls format. If you specify file format in the output file name in the /report switch, it is not necessary to use the /reportformat switch. Commands usage looks like:

/report:<filepath>

/reportformat:<HTML|XLS>

The following example shows how to compare data using settings from a file, generate report to the specified file in the HTML format:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /datacompare /compfile:"ODC1vsODC2.scomp" /report:"D:\workDir\report.txt" /reportformat:HTML

/source

You can specify source database schema for comparison and synchronization in the command line. It is possible to use several options for defining the schema.

To connect to a server via Oracle client, type:

server:<server_alias> [home:<oracle_home_name>] user:<user_name> password:<pw> mode:[normal/sysdba/sysoper]

To connect to a server without using Oracle client (direct connection), type:

host:<machine_name> [port:<port_number>] SID:<oracle_service_ID> user:<user_name> password:<password> mode:[normal/sysdba/sysoper]

To specify full connection string with additional parameters, type:

connection:<connection_string>

/target

You can specify target database schema for comparison and synchronization in the command line. It is possible to use several options for defining the schema.

To connect to a server via Oracle client, type:

server:<server_alias> [home:<oracle_home_name>] user:<user_name> password:<pw> mode:[normal/sysdba/sysoper]

To connect to a server without using Oracle client (direct connection), type:

host:<machine_name> [port:<port_number>] SID:<oracle_service_ID> user:<user_name> password:<password> mode:[normal/sysdba/sysoper]

To specify full connection string with additional parameters, type:

connection:<connection_string>

/schemas

You can specify schemas to compare. If you don't, schemas specified in /source and /target will be used. Command usage looks like:

/schemas:<source_1>,<target_1>[;<source_2>,<target_2>;...]

The following example shows how to compare schemas using connection through client.

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /datacompare /source server:OraServer user:system password:pswd /target server:OraServer2 user:system password:pswd /schemas:OSC1,OSC2

/sync

You can perform schema synchronization from the command line interface. If you specify output file for synchronization, only synchronization script will be generated. Command usage looks like:

/sync[:path]

The following example shows how to compare schemas using settings from the file saved before, and save synchronization script:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /datacompare /compfile:"OSC1vsOSC2.scomp" /sync:"D:\compare_result.sql"

note Note

If the /sync argument is used without parameters, synchronization with the database is performed at once and changes cannot be reversed.

/copybfiles

Use this switch to specify parameters for the 'Physically copy BFILEs' option. Command line usage looks like:

/copybfiles dir:<directory_alias> path:<path>

/lobsviafiles

Use this switch to specify parameters for the 'Synchronize LOBs data via files' option. Command line usage looks like:

/lobsviafiles dir:<directory_alias> path:<path>

ExpandedToggleIcon(9x12) Usage Examples

· Compare data using settings from a file saved earlier:

/datacompare /compfile:"D:\workDir\ODC1vsODC2.dcomp"

· Compare and synchronize data using connection through the client. Log will be written to the specified file:

/datacompare /source server:OraServer user:system password:manager /target server:OraServer2 user:system password:pswd /schemas:ODC1,ODC2 /sync /log:"D:\sync.log"

· Compare data of the specified schemas and save the synchronization script to the D:\compare_result.sql file; the first connection is created using direct mode, the second connection is established through the client:

/datacompare /source host:oraHost port:1521 SID:orcl user:sys password:manager mode:sysdba /target server:OraServer user:system password:pswd /schemas:DC1,DC2;ODC1,ODC2 /sync:"D:\compare_result.sql"

· Compare and synchronize data using settings from the file, do not generate comments in the synchronization script, turn off triggers during synchronization; generate a report to the specified file in the .html format:

/datacompare /compfile:"ODC1vsODC2.dcomp" /nocomments:yes /distrig:yes /report:"report.txt" /reportformat:HTML /sync

· Compare and synchronize data using settings from a file. Synchronize Lob columns using files:

/datacompare /compfile:"ODC1vsODC2.dcomp" /LobsViaFiles dir:DC2_DIR path:\\oracleHost\TEMP_FOLDER\DB_TARGET\ /sync

· Compare data and generate data report using settings from a file. Comparison and data writing settings of the different objects will be included into the report.

/datacompare /compfile:"ODC1vsODC2.dcomp" /report:"report.html" /incdata:Yes /incsettings:Yes

ExpandedToggleIcon(9x12) See Also

Working with Command Line

Options Used in Command Line for /datacompare


Command Line Options for /datacompare Operation

You can select the required options while setting the comparison in the Data Comparison wizard and generate a file with command line arguments by clicking Save settings to a command line arguments file on the Options wizard page. Also you can set comparison options by using the /option_name:[Y/N] switch in the Command Prompt. Specify either full or short names of the options. Here is the list of their names.

By default, dbForge Studio for Oracle generates a file with command line arguments and writes all comparison and synchronization options into it. Each option is written like the following: /option_name: [Y/N]

You can edit the file to turn on/off required options. To turn on comparison and synchronization options, edit their values to "Yes", "Y", "True", "T", or "On". To turn off the options, change their values to "No", "N", "False", "F", or "Off".

Each option has a full and short name. You can type either name of a required option into the Command Prompt instead of editing the file.

See below the list of options with their full and short command line names.

ExpandedToggleIcon(9x12) Options List

Command line option name | Short Name | Option
CheckDifferent | chkdiff | Include different records into comparison results.
CheckIdentical | chkequal | Include identical records into comparison results.
CheckOnlyInSource | chksource | Include records that are available only in source into comparison results.
CheckOnlyInTarget | chktarget | Include records that are available only in target into comparison results.
CompareMViews | mviews | Include materialized views into comparison.
CompareNamesOnlyForBFiles | bfnames | Only file (and directory) names are compared regardless their content. Otherwise, the file content is compared and differences in file names are ignored. Allows to copy BFILEs to a target database.
CompareTables | tables | Include tables into comparison.
CompareViews | views | Include views into comparison.
ExcludeObjectsByMask | meobjmask | Allows specifying a custom wildcard expression for tables (or views) to exclude them from comparison.
IgnoreCase | icase | Ignore case in symbols for non-key columns of the following data types: CHARACTER, CHARACTER VARYING, TEXT.
IgnoreColumnsByMask | micolmask | Ignore columns by mask: *ModifiedDate*, *CreatedOn*, *UpdatedBy*.
IgnoreEndOfLine | ieol | Ignore end of line characters during comparison and synchronization
IgnoreLobColumns | milob | Allows ignoring LOB columns during comparison. The option can be applied to the following column types: (N)CLOUB, BLOB, BFILE, LONG, LONG RAW and XML.
IgnoreTrailingSpaces | ispaces | Ignore whitespaces in the end of strings during comparison and synchronization. This option can be applied to CHARACTER, CHARACTER VARYING, TEXT columns.
IncludeObjectsByMask | miobjmask | Allows specifying a custom wildcard expression for tables (or views) to include them to comparison.
IsIgnoreTime | itime | Ignores time for fields of the DATETIME types and compares only dates.
MappingIgnoreCase | micase | Ignore case in object names when mapping them.
MappingIgnoreSpaces | mispace | Ignore spaces in object names when mapping them.
MappingIgnoreUnderscores | miunder | Ignore underscore in object names when mapping them.
RoundFloatTypes | round | Specify the count of digits after the decimal point. Option rounds data types.
CompileMViews | compmviews | Compile materialized views.
DisableForeignKeys | nofk | Disable foreign keys before synchronizing tables and to enable them after it.
DisableTriggers | distrig | Disable triggers in the beginning of the synchronization. After the synchronization, it will be enabled. This option applied to tables and views.
DropKeys | dropkeys | Disable non-unique indexes and check constraints in the beginning of the synchronization.
ExcludeComments | nocomments | Prevent comments generation in a synchronization script.
IncludePrintComments | iprint | Print comments into output while executing the script. If print comments are included in the deployment script, it is easier to locate items in output, including the backup file path.
RestoreSessionParameters | restoresession | Restore session parameters (NLS_DATE_FORMAT, NLS_TIMESTAMP_TZ_FORMAT, NLS_TIMESTAMP_FORMAT, NLS_NUMERIC_CHARACTERS, NLS_NCHAR_CONV_EXCP, TIME_ZONE) after script done.
RollbackOnError | rollback | In case of error, automatically restores database to the state preceding the synchronization.
UseSchemaNamePrefix | fullnames | Generate fully qualified object names in the synchronization script.
UseSqlExtensionCommands | sqlplus | Use *SQL Plus commands SET SQLBLANKLINE AND SET DEFINE in synchronization script.
IncludeComparisonSettings | incsettings | Include comparison options into your report. This option is available only for HTML reports.
IncludeDifferencesPerColumns | incdiffcols | Include the list with the number of differences in each column to your report. For each database table, a table with the list of columns and the number of differences in them will be created.
IncludeIdenticalObjects | incident | Includes comparison options into your report. This option is available only for HTML reports.
IncludeObjectsData | incdata | Include data records available in your database tables into your report.
IncludeOnlyColumnsWithChanges | inccolswchanges | Only data that contains differences will be added to the report.

ExpandedToggleIcon(9x12) See Also

Working with Command Line

Parameters Used in Command Line


Parameters Used in Command Line

Host
The name or IP address of the Oracle Server host to which to connect. Direct mode only.

Port
Specify Oracle Server connection port; default value is 1521. Direct mode only.

Server
Set the name of the Oracle database to which to connect. Not available in the direct mode.

Service Name
Specify an alias to an Oracle database instance (or many instances). Direct mode only.

SID
Specify a unique name for an Oracle database instance. Direct mode only.

note Note

The Service Name parameter can be used instead of SID.

User Id
The name of the user account on the Oracle server. The default Oracle user is 'scott'.

Password
The password of the user account on the Oracle Server.

Connect Mode
Specify how you want to connect to the Oracle server. This parameter is set to 'Normal' by default. dbForge Studio for Oracle allows you to connect to SYSDBA and SYSOPER administrative privileges selecting 'SYSDBA' or 'SYSOPER' options.

Home
Select an Oracle client to be used. Not available in the direct mode.

Direct
Select to connect to the Oracle server by the direct mode.

Unicode
Gets or sets a value indicating whether the UTF8 character set will be used.

Pooling
Gets or sets pooling mode.

Transaction Scope Local
Enables support for non-distributed transactions in the Transaction Scope implementation.

Enlist
Gets or sets a Boolean value that indicates whether the connection is automatically enlisted in the current transaction context.

ExpandedToggleIcon(9x12) See Also

Working with Command Line

Advanced Data Comparison Topics


Advanced Data Comparison Topics

This section contains advanced topics that describes data comparison and synchronization process.

ExpandedToggleIcon(9x12) In This Section

Type Compatibility Table
The topic describes which data types can be compared.

Data Comparison Process Overview
The topic gives basic information on data comparison and synchronization.

Data Synchronization Process Overview
The topic contains basic information on data comparison and synchronization.

ExpandedToggleIcon(9x12) See Also

Comparing Data


Type Compatibility Table

These tables demonstrate which data types can be compared by dbForge Studio when you connect to the Oracle server in direct mode or with a client.

ExpandedToggleIcon(9x12) Connection mode: Direct

Data types conversion in direct connection

ExpandedToggleIcon(9x12) Connection mode: Client

Data types conversion in client connection

- can be compared

Empty cells - explicit conversion is performed when comparing. A synchronization script will contain already converted data. On the Different, Equal, and Only in Target tabs in the Data Comparison document, you will see data in Target data type, Only in source will display data in the Source data type.

Table! - possible data loss

ExpandedToggleIcon(9x12) See Also

Advanced Data Comparison Topics

Data Comparison Process Overview


Data Comparison Process Overview

dbForge Studio for Oracle gives you a perfect opportunity to compare data between different databases with many useful features. They include the following:

· Comparison of data between different databases
· Displaying of data comparison results in a convenient UI, easy for analysis and synchronization
· Quick data synchronization of target and source databases
· Asynchronous comparison and synchronization

By default data comparison is performed only for the objects with the same names and owners. Process of choosing corresponding database objects in source and target for comparison is called object mapping. You can use dbForge Studio automatic mapping or map database objects manually. dbForge Studio allows you to customize mapping of tables (views) and columns, so you can compare data of objects with non-equal names, owners, and structure.

The following tables and views cannot be compared:

· Invalid tables or views.
· Tables or views, meta data of which can not be retrieved.

By default, data is compared by a primary or unique key, but other key or custom column set can be defined. A comparison key is used to determine which rows correspond to each other. It is not recommended to use a non-unique comparison key. If the table does not have a suitable key, you should manually select a custom key for this table when comparing.

Data comparison can be saved to the file and opened later.

ExpandedToggleIcon(9x12) See Also

Advanced Data Comparison Topics

Data Synchronization Process Overview


Data Synchronization Process Overview

After you have compared data, dbForge Studio gives you an easy and convenient way to synchronize data.

You may manually specify which tables and even which records to synchronize. Use the check boxes in the first column of the data comparison document grid to include or exclude objects to synchronization.

Note that it is highly recommended to backup target database before data synchronization.

If you synchronize data with different data type, you may encounter synchronization warnings. They are displayed at the Summary page of the Data Synchronization Wizard. If you have any synchronization warnings, that means that during synchronizing data you may encounter errors or data loss because of rounding, truncation, etc.

The Data Synchronization Wizard allows you to either apply updates immediately or create an update script for the Target database and save it to a file.

Before launching the synchronization, you may view Action Plan that contains all the actions that will be performed during synchronization. The action plan represents the synchronization script structure, so it is good to analyze it before this script will be generated or executed if you have chosen to execute the script immediately. The action Plan is displayed on the Summary page of the Data Synchronization Wizard.

ExpandedToggleIcon(9x12) See Also

Advanced Data Comparison Topics


Performing Administration Tasks

This section tells you how to perform some database administration tasks, such as server variables control, service management, etc.

ExpandedToggleIcon(9x12) In This Section

Using Export and Import Utility Wizards
Explains how to export and import databases using Oracle Export and Import Utilities with dbForge Studio wizards.

Monitoring Sessions
Explains how to retrieve information on current sessions and terminate them.

Walkthrough: Controlling Sessions
Describes how to view session information and control user sessions.

Monitoring Events
Explains how to monitor and send alerts and pipe messages.


Using Export and Import Utility Wizards

dbForge Studio for Oracle has Export Utility and Import Utility wizards for exporting and importing database objects. It allows to transfer data objects between Oracle databases, even if they reside on the platforms with different hardware and software configurations. dbForge Studio Export Utility Wizard allows to extract the object definitions and table data from an Oracle database and stores them in an Oracle binary-format export dump file. Import Utility Wizard allows to insert extracted objects from export dump files to Oracle database.

dbForge Studio uses Oracle export and import utilities for export and import. So these utilities are required for export and import operations. These utilities are installed with Oracle Client software.

note Note

It is recommended to use Oracle Client with version less or equal to the lowest version between source and target Oracle servers.

ExpandedToggleIcon(9x12) Export

To call the Export Utility Wizard, on the Database menu, select Export & Import, and then click Export Utility.

note Note

To export tables owned by another user, you must have enough privileges.

There are four modes of export: Table, User, Full and Tablespace. You must connect as SYSDBA to use the Full and Tablespace modes.

Table mode

The Table mode allows to export particular tables. In the Table mode you can select tables and set additional queries to select a subset of rows from a set of tables for export.

To export particular tables:

1. Call the Export Utility Wizard.
2. Click the Next button if the Export Mode page is active.
3. Select tables to export.
4. Click the Additional query button and enter a condition to select a subset of rows from a set of tables if necessary. Condition must be the WHERE clause for the SELECT statement applicable for all selected tables.
5. Click the Next button.
6. Select additional objects and settings to export and click the Next button.
7. Enter or select export dump and configuration files location and names. Click the Export button.
8. Wait for export finish, select the check box if you want to view the export log, and click the Finish button.

User mode

The User mode allows extracting data objects of one ore more (for SYSDBA) users. It can be useful for users who want to back up their data or who want to move objects from one owner to another.

To export all data of one or more users:

1. Call the Export Utility Wizard.
2. Click the Back button if the Export Tables page is active.
3. Select the User mode and click the Next button.
4. Select the users whose data you want to export, and click Next. Only SYSDBA can export another user data.
5. Select additional objects and settings to export. Click Next.
6. Enter or select export dump and configuration files location and names. Click Export.
7. Wait for export finish, select the check box if you want to view the export log. Click Finish.

Full mode

In the Full mode an entire database can be exported to the file with all GRANTS and all data.

To export a whole database:

1. Call the Export Utility Wizard.
2. Click Back if the Export Tables page is active.
3. Select the Full mode. Click Next. If the Full option is not available, you have not enough privileges to use the Full mode. You must connect as SYSDBA to use this mode.
4. Select additional objects and settings to export. Click Next.
5. Enter or select export dump and configuration file locations and names. Click Export.
6. Wait for the export finish, select the check box if you want to view the export log. Click Finish.

Tablespace mode

To move or copy a set of tablespaces you must copy the datafiles of these tablespaces, and export their metadata using Export Wizard in the Tablespace mode. The Tablespace mode allows to move a set of tablespaces from one Oracle database to another. Tablespaces to export must be ONLINE and READONLY. dbForge Studio can temporarily make exporting tablespaces ONLINE and READONLY and restore their state after export.

To export tablespaces metadata:

1. Call the Export Utility Wizard.
2. Click Back if Export Tables page is active.
3. Select the Tablespace mode and click Next. If the Tablespace option is not available, you have not enough privileges to use the Tablespace mode. You must connect as SYSDBA to use this mode.
4. Select tablespaces to export. Click Next.
5. Select additional objects and settings to export. Click Export.
6. Enter or select export dump and configuration files location and names. Click Next.
7. Wait for export finish, select the check box if you want to view the export log. Click Finish.

ExpandedToggleIcon(9x12) Import

There are four modes of import: Table, User, Full and Tablespace. You must connect as SYSDBA to use the Tablespace mode. To call Import Utility Wizard, choose Export & Import, and then click Import Utility from the Database menu .

Table mode

This mode allows you to import specific tables. You can import either all tables from dump file or select particular tables.

To import specific tables:

1. Call the Import Utility Wizard.
2. Select the export dump file and the configuration file location. Click Next. You can optionally select the index file for indexes import.
3. Select the Table mode. Click Next.
4. Select what tables to import, source and target schemas. You can import all tables from the file, enter table names manually or select table names from existing tables. Click Next.
5. If you have chosen the Select from existing option, select tables from the existing tables list. Only table names but not owners will be selected. Table owners have been selected at the previous step.
6. Select additional objects to import and import settings on this page. Click Import.
7. Wait for import finish, select the check box if you want to view the import log. Click Finish.

User mode

This mode allows you to import all objects that belong to you (such as tables, grants, indexes, and procedures). If you are connected as SYSDBA, you can import all the objects in the schemas of a specified set of users to the specified schemas.

To import data in the User mode:

1. Call Import Utility Wizard.
2. Select export dump file and configuration file location. Click Next. You can optionally select index file for indexes import.
3. Select the User mode. Click Next.
4. Select source and destination schemas. Click Next.
5. Select additional objects to import and import settings on this page. Click Import.
6. Wait for import finish, select the check box if you want to view the import log. Click Finish.

Full mode

This mode allows you to import all data objects from the dump file. It also allows to use incremental import. Incremental import can be used for database restore.

To import the whole dump file:

1. Call the Import Utility Wizard.
2. Select the export dump file and the configuration file location. Click Next. You can optionally select the index file for indexes import.
3. Select the Full mode. Click Next.
4. Select the destination schema and incremental import type. Click Next.
5. Select additional objects to import and import settings on this page. Click Import.
6. Wait for import finish, select the check box if you want to view the import log. Click Finish.

Tablespace mode

This mode allows to move a set of tablespaces from one Oracle database to another.

To import tablespaces:

1. Call the Import Utility Wizard.
2. Select the export dump file and configuration file location. Click Next. You can optionally select the index file for indexes import.
3. Select the Tablespace mode. Click Next. If the Tablespace option is not available, you have not enough privileges to use the Tablespace mode. You must connect as SYSDBA to use this mode.
4. Select tablespaces' datafiles, owners and tablespaces' names to import. Click Next. You can select tablespaces' owners from existing ones.
5. If you have selected the Select from existing option, select tablespaces' source and target owners from existing users. Click Import.
6. Wait for import finish, select the check box if you want to view the import log. Click Finish.

ExpandedToggleIcon(9x12) See Also

Performing Administration Tasks

Monitoring Sessions


Monitoring Sessions

dbForge Studio provides you with the Session Manager tool that allows to obtain information about sessions and manipulate them. To open the Session Manager dialog box, on the Database menu, click Session Manager.

ExpandedToggleIcon(9x12) In This Section

Retrieving Information about Current Sessions
Describes how to get information about current sessions.

Using Cursor List
Describes how to use cursor list.

Terminating and Disconnecting Session
Describes how to terminate or disconnect sessions.

Enabling and Disabling SQL Trace
Describes how to enable or disable SQL trace.

ExpandedToggleIcon(9x12) See Also

Performing Administration Tasks

Controlling Sessions


Retrieving Information about Current Sessions

To retrieve the information about current sessions simply select Session Manager from the Database menu. All database sessions will be displayed in the grid, containing following fields:

User Name
Name of the user associated with the session.

Sid
Session identifier.

Serial
Session serial number, used to unambiguously determine a session. In combination with the Sessions ID, it is used to specify the correct session to manipulate with.

Status
Shows whether a user session is active, inactive or killed.

OS User
Operating system username.

Machine
Operating system machine through which the user is connected.

Program
Program you are currently running.

Schema Name
Schema name associated with the user.

SQL Address, SQL Hash Value
Used to identify the SQL statement that is currently being executed.

Logon Time
Shows the start date and time of the session.

Clicking Refresh button refreshes the information in grid.

Columns order can be specified by user. To call Customize Columns window click the Customize session columns button on the toolbar. To show/hide the column select/deselect the corresponding check box left of the column name in the window. To change columns order drag the required column to the desired location. Click OK to apply changes.

dbForge Studio gets information about sessions in the grid from the SYS.V$SESSION view. To get all SYS.V$SESSION columns, click the Full Session Information button on the Session Manager toolbar. Visit Oracle Database Reference for an information about fields of this view.

At any time you can use filtering, sorting and grouping session data in the grid and resize grid columns.

Detailed statistics is available for each session. It is contained on the Statistics tab below sessions list.

ExpandedToggleIcon(9x12) See Also

Monitoring Sessions

Using Cursor List


Using Cursor List

Open cursors associated with the selected session are displayed in the cursor list. An arrow in the first column indicates the current statement. The second column displays a part of the cursor SQL code.

SQL editor is located to the left of the cursor list. It displays the cursor SQL statement.

ExpandedToggleIcon(9x12) See Also

Monitoring Sessions

Terminating and Disconnecting Session


Terminating and Disconnecting Session

To terminate or disconnect a user's session:

1. Navigate to the session to kill in the sessions list.
2. Choose Kill Session or Disconnect Session from the shortcut menu or corresponding toolbar.
3. The dialog asking if the session with the specified SID has to be terminated will appear. Click Yes to kill the session.

The difference between terminating and disconnecting a session is following. When disconnecting a session, the session is not actually terminated until the user tries to execute a database operation, ongoing transactions are allowed to complete before the session is disconnected. When killing a session currently running operation will be aborted.

ExpandedToggleIcon(9x12) See Also

Enabling and Disabling SQL Trace

Monitoring Sessions


Enabling and Disabling SQL Trace

To enable or disable trace logging for the selected session:

1. Navigate to the required session in the sessions list.
2. Choose Enable Sql Trace/Disable Sql Trace from the shortcut menu or click the corresponding toolbar button.
3. The dialog asking if the SQL trace has to be enabled/disabled for the session with the specified Sid will appear. Click Yes to enable/disable SQL trace.

note Note

Enabling and disabling SQL trace is allowed for the users connected as SYSDBA only.

ExpandedToggleIcon(9x12) See Also

Monitoring Sessions

Controlling Sessions


Controlling Sessions

The following walkthrough describes how to control user sessions. You will learn how to view session information, stop query execution and disconnect sessions.

ExpandedToggleIcon(9x12) Starting Session

Execute the following query.

SELECT * FROM
SCOTT.EMP

To do it, perform the following steps:

1. Open an SQL editor by clicking the New SQL button on the Standard toolbar.
2. Type or paste this code to the document.
3. Execute the document by clicking the Run! button on the SQL toolbar.

ExpandedToggleIcon(9x12) Managing Sessions

Viewing Session Information

Launch another instance of the dbForge Studio for Oracle (don't close the previous one) and open the Session Manager window in it. To call Session Manager, select Session Manager from the Database menu.

If you have the global PROCESS privilege, you will see all user sessions for the current connection. Otherwise, you will see only your own sessions.

Click on the OS User column caption to order all data by host. Find your connections (from your host). Then click on the connection. In the bottom part of the Session Manager you can see the text of the executing queries. Find your connection executing the query above.

Killing and Disconnecting Session

Right-click the session with our query and choose Kill Session from the shortcut menu. Click Yes in the appeared dialog. Then switch back to the previous instance of dbForge Studio for Oracle and scroll down the data grid. You will get a message that the current user is not logged on.

Switch to the dbForge Studio for Oracle with Session Manager open. Again right-click the session and choose Disconnect Session from the shortcut menu. Switch back to the previous instance of dbForge Studio for Oracle and click the Refresh button on the Database Explorer toolbar. You will get a message that you are not connected to the Oracle server.

ExpandedToggleIcon(9x12) See Also

Performing Administration Tasks

Monitoring Events


Monitoring Events

dbForge Studio provides you Event Monitor tool that allows to send and receive alerts and pipe messages. To open Event Monitor select Event Monitor from the Database menu.

ExpandedToggleIcon(9x12) In This Section

Alerts and Pipe Messages
Basic information on alerts and pipe messages.

Receiving and Sending Alerts and Pipe Messages
Tells how to receive and send alerts and pipe messages using Event Monitor.

ExpandedToggleIcon(9x12) See Also

Performing Administration Tasks


Alerts and Pipe Messages

Alerts and pipe messages are sent and received using the DBMS_ALERT and DBMS_PIPE packages. They serve for the same purpose - communicating between different sessions, but they have following differences:

· Alerts are sent only after the transaction, in which it was sent, is committed. If the transaction was rolled back alerts will not be sent. Pipe messages are asynchronous, they are sent independently of transactions.
· Alert can be received by several sessions, that registered for this alert. Pipe message can be received only by one session.
· Pipe messages with the same name do not overwrite each other, you can receive all pipe messages sent (if they were not received by someone else). Alerts with the same name overwrite each other. When you try to receive alert after several alerts have been sent, you will receive only the last sent alert.
· You can start asynchronous listening by clicking the Start/Stop listening to alerts button to the alerts with specified name and all coming alerts with specified name will be displayed at the moment it was received. This feature is not available to the pipe messages. You can only use the Refresh button to get one pipe message.

ExpandedToggleIcon(9x12) See Also

Monitoring Events

Receiving and Sending Alerts and Pipe Messages


Receiving and Sending Alerts and Pipe Messages

How to start listening to alerts

1. Open Event Monitor.
2. Select Alert in the Event type box.
3. Enter name of the required alert.
4. Click the Run button on the Event Monitor toolbar.

To stop listening to the alerts, click this button again.

How to get one alert or pipe message

1. Open Event Monitor.
2. Select the required event type.
3. Enter the name of the required alert or pipe.
4. Click the RefreshButton button on the Event Monitor toolbar.

How to send alert or pipe message

1. Open Event Monitor.
2. Select the required event type.
3. Enter the name of the required alert or pipe.
4. Enter the message text.
5. Click the SendMessage button on the Event Monitor toolbar.

ExpandedToggleIcon(9x12) See Also

Monitoring Events

Performing Administration Tasks


Developing Database Projects

dbForge Studio for Oracle provides you projects feature. Database projects have significantly improved database development, giving developers a number of great opportunities.

A database project is an offline representation of a database schema with extended opportunities for offline schema development. It is a collection of logically organized SQL scripts and query files, which are used both to create a new database and update the existing one.

Projects greatly facilitate database development. They organize your scripts in one logical structure, good for navigation and management, offers offline database development with a set of useful features, such as syntax check and code completion in SQL code, refactoring, etc. You can generate either a single SQL script file or a set of files (a batch script file) for deploying to the server. Deployment of only required project changes is one more benefit. Empower yourself with database projects, while developing databases, and feel difference.

ExpandedToggleIcon(9x12) In This Section

How To: Create and Open Projects
This topic describes how to create, save, open database projects, and import database objects into them.

How To: Manage Files in Projects
This topic describes how to work with files and folders in your projects.

How To: Work with Database Objects in Project
This topic will explain how to rename and delete database objects.

How To: Use Project Build Configurations
This topic describes how to use project build configuration.

How To: Build and Deploy Project
This topic describes how to build and deploy a project.

Working with Project
This walkthrough describes how to create a sample project.

Advanced Topics
This section contains advanced information on working with projects.


How To: Create and Open Projects

This topic explains how to create, save, open database projects, and import database objects into them.

ExpandedToggleIcon(9x12) Creating a Project

To create a project:

1. In the File menu, point to New, and then click Project. The New Database Project Wizard opens.

note Note

Actual document look may slightly vary from the above image, depending on the product you use.
2. Enter a name and a location of the project.
3. You can also select a connection to use for the project deployment. (By default, the current connection is selected.)Optionally clear Create a folder for the project to store the project in the chosen path without creating a folder for a project.

note Note

Actual document look may slightly vary from the above image, depending on the product you use.
4. Click the Create button to close the wizard and see the created project in the Project Explorer window. To save the project, click the Save button on the toolbar.

ExpandedToggleIcon(9x12) Creating an Empty Project

To create a new blank project point to New, and select Blank Project from the File menu.

ExpandedToggleIcon(9x12) Importing Database Objects into Project

To import database objects into a project:

1. Select the Import schema objects from the existing database check box in the wizard and click the Next button to specify a connection and a database where the imported database objects are located.

note Note

Actual document look may slightly vary from the above image, depending on the product you use.
2. If you clear Include all objects, you can select only required database objects from the list of database objects on the next wizard's page.

note Note

Actual document look may slightly vary from the above image, depending on the product you use.
3. (optional) You may specify detailed options for schema export on the next page of the wizard.

4. You can also select a connection to use for the project deployment. (By default, the current connection is selected.)Optionally clear Create a folder for the project to store the project in the chosen path without creating a folder for a project.
5. Click the Create button to close the wizard and see the created project with imported objects in the Project Explorer window. To save the project, click the Save button on the toolbar.

CollapsedToggleIcon(9x12) Saving a Database Project

To save project right-click on the project in Project Explorer and select Save Project from the shortcut menu or activate Project Explorer and press the Save button or select Save <project name> from the File menu.

CollapsedToggleIcon(9x12) Opening a Database Project

To open existing project, in the File menu, select Open, and then click Project.

note Note

When creating new project from existing database, object DDL is formatted according to formatting options.

note Note

When you create a new project, opened project will be closed, and all opened documents will be closed too.

ExpandedToggleIcon(9x12) See Also

Developing Database Projects

How To: Manage Files in Projects


How To: Manage Files in Projects

This topic explains how to work with files and folders in your projects.

ExpandedToggleIcon(9x12) Working with Folders

If you are working with the project that contains many different queries and scripts, you can use folders to organize the related scripts and queries into groups. dbForge Studio for Oracle allows you to create folders and move or add items to them, to create nested folders for complex project organization, delete or rename folders.

To create a folder right-click the project or folder in Project Explorer and select Add Folder from the shortcut menu.

To delete a folder right-click on it in Project Explorer and select Delete from the shortcut menu. All the file shortcuts and subfolders of this folder will be removed from the project, but physical files will not be deleted.

You can move SQL scripts and queries to and from folders by dragging them from and dropping to the folders.

note Note

Project folders are not real Windows folders, information about these folders is stored in the project file (.oradev). When you create or delete folders, corresponding Windows folders are not created or deleted and when you move file shortcuts and folders in Project Explorer from one folder to another, physical files stay at the same locations they were before.

ExpandedToggleIcon(9x12) Adding File to Project

To add a new file to the project right-click on the project or its folder node in Project Explorer and select Add New File from the shortcut menu

-or-

select Add New File from the Project menu.

Add New File window will appear. Choose the desired template of the file to create. Input the name of the file. Click Add to create the file with code template.

note Note

Though the created file is automatically included into the project it is not saved anywhere on the disk. You are to save it by selecting the Save command from the File menu or the Standard toolbar.

To add an existing file to project right-click on the project or its folder node in Project Explorer and select Add Existing File from the shortcut menu.

ExpandedToggleIcon(9x12) Removing File from Project

To remove a file from the project right-click on it in Project Explorer, select Delete from the shortcut menu and click Remove in the appeared dialog. The physical file will not be deleted, these actions only remove the file link from project.

To delete a physical file from disc right-click on it in Project Explorer, select Delete from the shortcut menu and click Delete in the appeared dialog. The file link in project and the physical file itself will be deleted.

ExpandedToggleIcon(9x12) Editing files in Project

You can edit project's files in a convenient SQL editor, which provides a wide range of options for quick and efficient SQL code editing.

ExpandedToggleIcon(9x12) See Also

Developing Database Projects

How To: Work with Database Objects in Project


How To: Work with Database Objects in Project

This topic will explain how to rename and delete database objects.

ExpandedToggleIcon(9x12) Renaming Database Objects

To rename an object from a project perform the following steps:

1. Right-click the object in the Schema View window.
2. Choose Rename from the shortcut menu.
3. Enter a new name.
4. View and adjust changes, and click Apply.

ExpandedToggleIcon(9x12) Deleting Database Objects

To delete an object from a project perform the following steps:

1. Right-click the object in the Schema View window.
2. Choose Delete from the shortcut menu.
3. Click Yes in the appeared dialog.

note Note

If the script file, containing the object, has the same name as the object, the whole file will be physically deleted. If the object is a table, and it has triggers, the triggers will also be deleted.

ExpandedToggleIcon(9x12) See Also

Developing Database Projects

How To: Use Project Build Configurations


How To: Use Project Build Configurations

Build configurations can be used for storing multiple versions of the project properties and multiple project connections. You can have several configurations - each one with its own options. For example, you can use one configuration for deploying database to the test sever and another one for deploying to the production server.

You can choose active configuration from the Configuration drop-down list on the Project toolbar. Each new project has one configuration named Default.

Configurations can be created, renamed, and deleted using the Configuration Manager.

ExpandedToggleIcon(9x12) Adding a Configuration

1. Open Configuration Manager by selecting Configuration Manager from the Configuration drop-down list on the Project toolbar.
2. Click the Add button. A New Project Configuration dialog will appear.
3. Enter the Name of the configuration and select a configuration to copy settings from if you need it.
4. Click OK.

ExpandedToggleIcon(9x12) Removing a Configuration

1. Open Configuration Manager by selecting Configuration Manager from the Configuration drop-down list on the Project toolbar.
2. Select the configuration you want to remove and click Remove.

ExpandedToggleIcon(9x12) Renaming a Configuration

1. Open Configuration Manager by selecting Configuration Manager from the Configuration drop-down list on the Project toolbar.
2. Select the required configuration in Configuration Manager and click the Rename button or press the F2 key.
3. Type the new name.
4. Press ENTER.

ExpandedToggleIcon(9x12) Changing Options for a Configuration

1. Open project options.
2. Select the configuration from the Configuration drop-down list in the upper part of the document.
3. Edit options. They will be applied for the selected configuration only. The same is about the project connection.

note Note

To edit project options for the specific configuration, you should select it in the Configuration drop-down list on the project properties document, not on the Project toolbar.

ExpandedToggleIcon(9x12) See Also

Developing Database Projects

How To: Build and Deploy Project


How To: Build and Deploy Project

This topic explains how to build and deploy a project.

ExpandedToggleIcon(9x12) Building Project

After you have edited your database project, you should build it to create a script that will deploy all the project changes to the database on the server. A project can be built to a single ready-to-deploy script or a set of scripts with a batch to run it in the Oracle Command-Line Tool.

To build a project:

1. Choose a project configuration to build on the Build tab of the Project Properties window. (To open the window, click Properties on the Project menu).
2. Right-click in the Project Explorer window and select Build the Project from the shortcut menu.

Project building is enhanced with the following features:

· Syntax check in project scripts. (If any errors are found, the build is stopped.)
· Check of references to schema objects in all statements.
· Check of any object duplicates.

Project options to customize build results

Before building the project, you can set project options to customize build results.

1. Right-click in the Project Explorer window and select the Properties option, or on the Project menu, click Properties. The Project Properties window opens. It contains three tabs: Build, Build Order, and Database.
2. Use the Build tab to define the settings for the generated SQL file with project changes. For example, you can select whether to generate a single SQL script file or a batch script file, etc.
3. The Build Order tab lets you manage the order of files in the build script and deploy execution. You can manage dependencies between objects in different files using build order.

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

ExpandedToggleIcon(9x12) Deploying Project to Server

You can deploy either the entire project or only the changes in the project to the database on your server.

note Note

Project files can be deployed only if a connection was assigned to the project.

Deploying an entire project

To deploy an entire project, click Deploy the Project on the Build menu.

Use Always re-create a database option to guarantee database integrity.

Deploying changes from your project

When you want to deploy only the changes from your project to the server, you should compare your project with the database on the server and create a special schema synchronization script. The script will deploy only required changes to the server.

ExpandedToggleIcon(9x12) See Also

Developing Database Projects

Working with Project


Working with Project

The following walkthrough describes how to create a sample project, add folders and files into it, deploy the project, compile it and export it to a single script. A sample project will contain scripts, that create database objects, that were have created manually in previous walkthroughs.

To create a new project select New, Blank Project from the File menu. A project will appear in the Project Explorer.

ExpandedToggleIcon(9x12) Creating Project

Creating Folder Structure

Folders help to organize related scripts and queries into groups, so, first of all, let's create a folder structure for the new project. There will be three folders in the root folder: Security, Database Objects, Data. Folders for every database object type that is created in the project will be in the Database Objects folder. To create such folder structure perform the following steps.

1. Right-click the project node in the Project Explorer and choose Add Folder from the shortcut menu

- or -

Select the project node in the Project Explorer and choose Add Folder from the Project menu.

2. Enter the new folder name ('Security').
3. Repeat steps 1 - 3 for creating Database Objects and Data folders.
4. Right-click the Database Objects folder node in the Project Explorer.
5. Select Add Folder from the shortcut menu.
6. Enter the new folder name ('Tables').
7. Repeat steps 5 - 7 for creating Views, Procedures, Sequences and Triggers folders.

Now you have a folder structure for our project created. Note that project folders are not real Windows folders, information about these folders is stored in a project file. When you create or delete folders, corresponding Windows folders are not created or deleted.

Adding Scripts to the Project

Now let's create required SQL script files and add them to the project. Let's learn how to add existing files to the project first. Existing files can be added to a project in two ways. Perform following actions to create files and add them to a project.

1. Click the New SQL button on the Standard toolbar.
2. Type or paste following code into the SQL document:

CREATE TABLE DEMOBASE.DEPT (
DEPTNO NUMBER(38),
DNAME VARCHAR2(14),
LOC VARCHAR2(13),
CONSTRAINT PK_DEPT PRIMARY KEY (DEPTNO))

3. Click the Save Save button on the Standard toolbar.
4. Choose file location and enter file name (for example, 'Table Dept') in the appeared Save File As dialog.
5. Save the file and close the document.
6. Right-click on the Tables folder in the Project Explorer and choose Add Existing File from the shortcut menu

- or -

Click on the Tables folder in the Project Explorer and choose Add Existing File from the Project menu.

7. Choose the created file in the Open File dialog.

Now the file is added to the project. Perform following actions, that demonstrate it.

1. Click the New SQL button on the Standard toolbar.
2. Type or paste following code into the SQL document:

CREATE TABLE DEMOBASE.EMP (
EMPNO NUMBER(38) NOT NULL,
ENAME VARCHAR2(10),
JOB VARCHAR2(9),
MGR NUMBER(38),
HIREDATE DATE,
SAL FLOAT(126),
COMM FLOAT(126),
DEPTNO NUMBER(38))

3. Click the Save Save button on the Standard toolbar.
4. Choose file location and enter file name (for example, 'Table Emp') in the appeared Save File As dialog.
5. Save the file.
6. Right-click on the Tables folder in the Project Explorer and choose Add Existing File from the shortcut menu

- or -

Click on the Tables folder in the Project Explorer and choose Add Existing File from the Project menu.

7. Choose the created file in the Open File dialog.

You can add not only existing files to the project, but to create new files, that will belong to the project too. You can use file templates when adding a new file to project. Perform following actions to create an SQL file for creating the view STAFF.

1. Right-click the Views folder node in the Project Explorer and choose Add New File from the shortcut menu

- or -

Click the Views folder node in the Project Explorer and choose Add New File from the shortcut menu.

2. Select View Script item in the Templates box and click OK.
3. Replace the view name 'VIEW1' with 'STAFF' in the appeared SQL document
4. Type or paste following query text after AS keyword.

SELECT
emp.ename AS name,
emp.job,
emp.sal AS salary,
dept.dname AS department
FROM emp, dept
WHERE emp.deptno = dept.deptno
(+)

5. Save the document with the name 'View Staff'.

To complete the project you should add some more scripts to it. Create and add to the project the following scripts in the same way as previous ones.

· 'Emp data' to the Data folder

INSERT INTO demobase.emp VALUES (7839, 'KING', 'PRESIDENT', NULL, '17/11/1981', 5000, 0, 10);
INSERT INTO demobase.emp VALUES (7566, 'JONES', 'MANAGER', 7839, '15/04/1981', 2975, 0, 20);
INSERT INTO demobase.emp VALUES (7698, 'BLAKE', 'MANAGER', 7839, '01/05/1981', 2850, 0, 30);
INSERT INTO demobase.emp VALUES (7782, 'CLARK', 'MANAGER', 7839, '09/06/1981', 2450, 0, 10);
INSERT INTO demobase.emp VALUES (7788, 'SCOTT', 'ANALYST', 7566, '19/08/1987', 3000, 0, 20);
INSERT INTO demobase.emp VALUES (7844, 'TURNER', 'SALESMAN', 7698, '08/09/1981', 1500, 0, 30);
INSERT INTO demobase.emp VALUES (7654, 'MARTIN', 'SALESMAN', 7698, '28/09/1981', 1250, 1400, 30);
INSERT INTO demobase.emp VALUES (7876, 'ADAMS', 'CLERK', 7788, '13/07/1987', 1100, 0, 20);
INSERT INTO demobase.emp VALUES (7900, 'JAMES', 'CLERK', 7698, '03/12/1981', 950, 0, 30);
INSERT INTO demobase.emp VALUES (7902, 'FORD', 'ANALYST', 7566, '03/12/1981', 3000, 0, 20);
INSERT INTO demobase.emp VALUES (7369, 'SMITH', 'CLERK', 7902, '17/12/1980', 800, 0, 20);
INSERT INTO demobase.emp VALUES (7499, 'ALLEN', 'SALESMAN', 7698, '20/02/1981', 1600, 300, 30);
INSERT INTO demobase.emp VALUES (7521, 'WARD', 'SALESMAN', 7698, '22/02/1981', 1250, 500, 30);
INSERT INTO demobase.emp VALUES (7934, 'MILLER', 'CLERK', 7782, '23/01/1982', 1300, 0, 10);

· 'Dept data' to the Data folder

INSERT INTO demobase.dept(deptno, dname, loc) VALUES (10, 'ACCOUNTING', 'NEW YORK');
INSERT INTO demobase.dept(deptno, dname, loc) VALUES (20, 'RESEARCH', 'DALLAS');
INSERT INTO demobase.dept(deptno, dname, loc) VALUES (30, 'SALES', 'CHICAGO');

· 'Sequence Seq_Empno' to the Sequences folder

CREATE SEQUENCE DEMOBASE.SEQ_EMPNO START WITH 8000

· 'Trigger Trig_Empinsert' to the Triggers folder

CREATE OR REPLACE TRIGGER DEMOBASE.TRIG_EMPINSERT

BEFORE INSERT ON DEMOBASE.EMP

REFERENCING NEW AS NEWVALUES OLD AS OLD FOR EACH ROW

BEGIN

SELECT SEQ_EMPNO.NEXTVAL INTO :NewValues.EMPNO FROM DUAL;

SELECT EmpNo INTO :NewValues.MGR FROM Demobase.Emp WHERE EName='Jones';

END;

· 'User Demobase' to the Security folder

GRANT CONNECT, RESOURCE, UNLIMITED TABLESPACE TO DEMOBASE IDENTIFIED BY TEST;

· 'Function RaiseSalary' to the Procedures folder

CREATE FUNCTION DEMOBASE.RAISESALARY (
Department IN VARCHAR, Rate IN NUMBER

)
RETURN NUMBER
AS
d_No NUMBER;
e_Affected NUMBER;
BEGIN
SELECT DeptNo INTO d_No FROM Dept WHERE Dname=Department;
UPDATE Emp SET Sal=Sal*Rate WHERE DeptNo=d_No;
SELECT Count(*) INTO e_Affected FROM Emp WHERE DeptNo=d_No;

RETURN e_Affected;
END;

After you added these scripts to project, save the project and all unsaved files for future use. To do it perform the following actions.

1. Right-click the project node in the Project Explorer and choose 'Save NewProject1' from the shortcut menu

- or -

Select the project node in the Project Explorer and choose 'Save NewProject1' or 'Save NewProject1 As' from the File menu.

2. Type the project name 'Demobase' and choose the project location.
3. Click OK to save the project.

ExpandedToggleIcon(9x12) Working with Project

Deploying Project

Project deployment is a very convenient feature for executing project scripts in specific order called the deployment order. With the sample project, that was created in this walkthrough you can create entire Demobase database using project deployment. At first you should set the project deployment order. User Demobase should be created first. Then you should execute scripts, that create tables and fill them with data. Then you can create a sequence and a trigger. After this other scripts can be performed in any order or may be not performed. So, the deployment order must be following.

· User Demobase.sql
· Table Dept.sql
· Table Emp.sql
· Dept data.sql
· Emp data.sql
· Sequence Seq_Empno.sql
· Trigger Trig_Empinsert.sql
· Function RaiseSalary.sql
· View Staff.sql

Perform following actions to set such order.

1. Select Build Order from the Project menu or right-click the project node in the Project Explorer and select Build Order from the Project menu to invoke the Project Deployment Order dialog box.
2. Drag User Demobase.sql to the top of the list.
3. Choose Table Dept.sql and click the Move Up button several times till Table Dept.sql takes the second place in the list.
4. Use Drag-n-drop and Move Up and Move Down buttons to set the deployment order.
5. Clear list item check boxes for scripts, that you don't want to be executed. For example, if you don't want to execute View Staff.sql when performing project deployment, you should clear its check box in the deployment order list.
6. Click OK.
7. You can save the project, to permanently save its deployment order.

All the project scripts will be executed using the project connection. If the project does not have a connection, it can not be deployed. So, you should assign a connection to the project. It must be a connection to account of a user that have administrative rights, because project contains script, that creates a user. So, create such a connection or use the existing one. To assign a connection to a project perform following steps.

1. Right-click on the project in Project Explorer and select Assign Connection from the shortcut menu.
2. Select required connection from the list and click OK.

-or-

Right-click the connection in the Database Explorer and select Assign to Project from the shortcut menu.

Before deploying the project you have to drop old demobase schema, that was created in the previous walkthroughs. You can do it in two ways. The first is using Security Manager and the second is executing the DROP USER statement.

To delete user using Security Manager perform the following steps.

1. Select the project connection in the Database Explorer.
2. Select Security Manager from the Database menu.
3. Expand the Users node in the Security Manager
4. Select the user DEMOBASE and click the Delete button on the Security Manager toolbar

- or -

Right-click the user DEMOBASE and select Delete from the shortcut menu.

5. Click Yes in the appeared dialog box.

To delete user by executing the DROP USER statement perform following actions.

1. Open an SQL editor by clicking the Create New SQL button on Standard toolbar.
2. In the SQL editor type the following:

DROP USER DEMOBASE CASCADE

3. Execute the document by clicking on appropriate button on the SQL toolbar.

After performing all these steps you can deploy project. To deploy the project select Deploy Demobase from the Project menu and click Yes in the appeared dialog. You will see deployment log in the General tab of the Output window. After deployment is finished, you can access Demobase database and its objects.

After deploying the project you can add database object shortcuts to it. To add a database object shortcut drag the database object from the project connection in the Database Explorer to the project explorer or select Add to Project and then select Demobase from the shortcut menu of the object node in the Database Explorer. Database object shortcuts can be used for fast opening of object editors by double-clicking the shortcuts. You can also easily find the object in the Database Explorer by right-clicking its shortcut in Project Explorer and selecting Find in the Database Explorer from the shortcut menu.

Compiling Project

After deploying project, you can compile it. Compiling project means compiling all database source objects and views, that correspond to the project DDL scripts. So, all deployed source objects and views will be compiled during project compilation. Project will be compiled through the project connection. In case of the Demobase project following objects will be compiled if they were deployed: view STAFF, trigger TRIG_EMPINSERT, function RAISESALARY.

To compile project, in the Project menu, select Compile. You can also compile project with debug information for debugging project source objects.

ExpandedToggleIcon(9x12) See Also

Developing Database Projects

Advanced Topics in Developing Projects


Advanced Topics in Developing Projects

This topic contains more detailed information on working with database projects.

ExpandedToggleIcon(9x12) In This Section

Database Project Overview
This topic describes useful opportunities, provided with projects feature.

Project Connection
This topic provides information about project connection.

Manipulating Database Object Shortcuts
This topic describes how to add or remove database object shortcuts from the project.

Project Build Overview
This topic describes project build process.


Database Project Overview

dbForge Studio for Oracle comes with an extensive project management system that allows you to create database projects and integrate related database development files.

dbForge Studio database projects greatly facilitate database development and allow offline database development. Database project can be created from the scratch or imported from an existing database.

Database development is clear and logical within a database project. It allows you to do the following:

1. Create a database project guided by the wizard, either empty or with database objects imported from a required database.
2. Manage SQL scripts and query files in the project and edit their contents.
3. Build ready project to create a script that will deploy all project changes to the database on the server.
4. Deploy either the entire project or only required changes to the server.

Project building allows you to create a single ready-to deploy script for deploying your database to the server. Building project includes the following:

· Checking SQL syntax of all files from the project.
· Checking references.
· Applying project options to the scripts if necessary.
· Combining project scripts to a single script or generating run script that executes project scripts in a certain order.

For more information about project building see How To: Build and Deploy Project.

Checking SQL syntax and checking references ensure that your project is valid without using the server connection.

Project allows you to manage such items as SQL and query files and database objects easily. It allows you to group scripts and queries into folders and provides fast access to selected database objects.

You can also work with schema objects, generated by the project scripts. These objects are displayed in the Schema View window. You can delete such object. For more information see How To: Work with Database Objects in Projects section.

When you work with project and exit dbForge Studio for Oracle, it remembers all opened documents, even files and database objects that do not belong to the project, and opens them next time when you open this project. Project remembers also all document bookmarks, breakpoints and watches that can help you to restore previous debug session. Note that when you close the project, all opened documents are closed too.

Project folder and file structure, connection and database object links, build order is stored in file with extension. Temporary information about opened documents, bookmarks, breakpoints, watches is stored in the file, having the same name and extension 'user'.

Benefits of database projects

It is recommended to use database projects as they fully meet modern database development standards.

As much work in database development accounts for working with SQL scripts, database projects offer a great number of features for quick and convenient SQL editing. You will appreciate automatic syntax check in SQL scripts, check of schema objects references in all statements, check of any object duplicates, etc.

Settings and syntax differences in various versions of servers can put obstacles in the phase of deploying the ready tested database to the server. Projects can have multiple configurations, they allow you to customize the database project for deploying to various versions of server. You should select the required connection and settings in a project configuration once, and next time just use the required configuration.

projects-explorer-orcl

ExpandedToggleIcon(9x12) See Also

Advanced Topics

Project Connection


Project Connection

A connection can be associated with the project to perform project deployment through it. You can not deploy a project without connection. You can also add shortcuts to database objects from the project connection to project.

ExpandedToggleIcon(9x12) Associating a Connection with Project

To associate connection with the project, do the following:

1. Right-click on the project in Project Explorer and select Assign connection from the shortcut menu.
2. Select the required connection from the list and click OK.
-or-
Right-click on the connection in Database Explorer and select Assign to project from the shortcut menu.
-or-
Drag the connection from Database Explorer to the Project Explorer.

ExpandedToggleIcon(9x12) Deleting an Associated Connection

To delete associated connection shortcut from project, right-click on it in Project Explorer and select Delete from the shortcut menu or select connection shortcut in Project Explorer and press the Delete key.

Project connection is specific to project configuration. If you select another project configuration, the connection and database object shortcuts in Project Explorer will be loaded from the configuration data. For more information, read Project Build Configurations.

note Note

When you delete connection shortcut from project, all database object shortcuts of this project will be also deleted.

ExpandedToggleIcon(9x12) See Also

Database Project Overview

Manipulating Database Object Shortcuts


Manipulating Database Object Shortcuts

dbForge Studio allows to add database object shortcuts to project for simplifying access to some database objects.

To add database object shortcut from the associated connection, you can either:

· drag them from the Database Explorer to the Project Explorer
· select Add to Project <project name> from the shortcut menu of the object node in the Database Explorer

If the project has no associated connection, database object connection will be assigned to project. Shortcut of database object can be added to the project only if this database object is from the connection, associated with the project.

Object editor can be opened by double-clicking the shortcut. You can also easily find the object in the Database Explorer by right-clicking its shortcut in Project Explorer and selecting Find in Database Explorer from the shortcut menu.

To delete a shortcut from project, right-click it in the Project Explorer and select Delete from the shortcut menu or select the shortcut in Project Explorer and press DELETE.

ExpandedToggleIcon(9x12) See Also

Advanced Topics

Project Build Overview


Project Build Overview

Building project is a complicated processing of project scripts which results in one ready-to-deploy result script or in several scripts with batch file.

At first, project script syntax is checked. If project scripts have syntax errors, the build is stopped.

If the declaration cannot be found, an error or warning is raised. Warning is raised in the following cases:

· Database object from schema, other than project schema, is referenced, and this object cannot be found in the schema.
· Unresolved reference is in a DROP statement.
· User is referenced.

In all other cases an error is raised and build is stopped. You may enforce build to ignore errors by selecting the Ignore errors check box in the Build options.

After this, project scripts are processed according to build order. You may forbid applying Depending on build options, either single result SQL script is formed or batch script, calling SQL scripts is generated.

note Note

Project build will delete all SQL files having the same names as project files in the build output directory without user confirmation. dbForge Studio asks for confirmation before deleting any other SQL file. Non-SQL files in the build output directory are not affected by build. Build output path can be set in the Build options.

ExpandedToggleIcon(9x12) See Also

Advanced Topics

Developing Database Projects


Writing Data Reports

This section contains detailed description of data reports implementation in dbForge Studio for Oracle. When studying this section, you will learn how to perform the simplest and the most difficult tasks with data reports.

ExpandedToggleIcon(9x12) In This Section

How To: Create a Static Report
The topic explains how to create an unbound data report.

How To: Create a Simple Data-Aware Report
The topic explains how to create a data-aware data report.

How To: Create a Master-Detail Report
The topic explains how to create a master-detail data report.

How To: Save and Load Reports
The topic explains how to save created data reports and load existing ones.

How To: Export Data Reports to Various Formats
The topic explains how to export data from your reports to one of the supported formats.

Working with Command Line
This section contains information on creating reports using command line.

Advanced Topics
This section contains more detailed information on data report kinds and tools used for creating them.


How To: Create a Static Report

This topic will guide you through the process of creating a simple report with dbForge Studio. You will learn how to create an empty report, add static text to the report, and preview it.

1. Open dbForge Studio.
2. On the File menu, point to New, then select Blank Data Report. In the document area designer for the newly created report will be shown:

lesson1-designer

note Note

Actual document look may slightly vary from the above image depending on the product you use.
3. To proceed with report creation, open the Toolbox window by clicking the toolbox-icon icon on the Data Report toolbar.
Toolbox
4. In the Toolbox window, select the Label control and drop it onto the report's Detail Band.
5. Double-click the created label to invoke its in-place editor, which allows you to input text. For example, type the classic "Hello, World!" statement. Then use the Data Report toolbar to adjust the label's color and font options:

lesson1-datareporttoolbox

note Note

Actual document look may slightly vary from the above image depending on the product you use.
6. Now switch to the Preview tab.

lesson1-preview

note Note

Actual document look may slightly vary from the above image depending on the product you use.

The steps above demonstrate the basics of building and previewing reports.

Proceed to the How To: Create a Simple Data-Aware Report topic to learn how to bind a report to data.

ExpandedToggleIcon(9x12) See Also

Writing Data Reports

How To: Create a Simple Data-Aware Report


How To: Create a Simple Data-Aware Report

This topic will guide you through the process of creating a simple data-aware report with dbForge Studio. You will learn how to bind a report to data, edit report bands, use the Data Source window to add report controls to the report and bind them to data, and also how to number pages in the report.

Note that it is recommended that you review the Creating a Static Report topic first. It will help you learn how to create a simple report with dbForge Studio.

1. In this example, a report will be bound to data from the EMPLOYEES table of the HR database. To add the table to the report, simply drag it from Database Explorer to the Data Source window.

Now your report is bound to data. The next steps show how to customize the report's layout, and to specify which data fields should be used to provide data for report controls.

2. Click the top-left corner of the report designer to invoke the report's smart tag. Choose the Edit and Reorder Bands... option in this list to edit the collection of report bands. For example, select the PageHeader band and remove it (it's unnecessary for this report):

Note that you can also use the Report Editor dialog to change any other report band settings (e.g. the height of the PageFooter band).

3. Drop a Label control from the Toolbox window onto the Report Header band (as you did in the Creating a Static Report topic) and set its Text to Employee List.
4. Create two labels and set their Text properties to "First name:" and "Last name:" correspondingly.
5. Create two labels bound to the FIRST_NAME and LAST_NAME data fields. To do this, simply drag the necessary data field items from the Data Source tree and drop them onto the report's Detail band.
6. To add page numbers to the bottom of each page in the report, drag the PageInfo item from Toolbox, and then drop it onto the PageFooter band. To change the format of page numbers shown in the report invoke the control's smart tag by clicking top-right corner of the control. For instance, set this property's value to "Current of Total" Page Numbers.
7. Now you have a data-aware report. Its structure is represented in the Document Outline window. Note that in the Document Outline tree, bound controls are marked with yellow database icons:

8. To use this report for creating a master-detail report by our tutorial, save this report.
9. Now switch to the Preview tab at the bottom of the Document area:

In this topic, you've created a simple report which is bound to data. You can now proceed to the Creating a Master-Detail Report topic to learn how to use Detail Report bands to create master-detail relationship reports.

ExpandedToggleIcon(9x12) See Also

Writing Data Reports

How To: Create a Master-Detail Report


How To: Create a Master-Detail Report

This topic will guide you through the process of creating a master-detail report with dbForge Studio.

Note that it is recommended that you review the Creating a Simple Data-Aware Report topic first. It will help you learn how to bind report to data with dbForge Studio.

1. Open the report definition created in the Create a Simple Data-Aware Report topic. For this, in the File menu, click Open File.
2. To create a master-detail report, it's required to add the DEPARTMENTS table to the report. To add the detail table, drag it from the Database Explorer to the Data Source window.
3. Make the master table active by right-clicking on the table name in the Data Source window and selecting Set Active Item from the shortcut menu:

Note, that in the Data Source tree the FK_EMPLOYEES_DEPARTMENTS node should be available. If it is not, refresh data in the Data Source tree by clicking the Refresh Data Refresh Data button on the Data Source toolbar.

4. Right-click your report in the document area to invoke the shortcut menu. In the menu, point to Insert Detail Report, and then click the FK_EMPLOYEES_DEPARTMENTS option to add a new detail report. A Detail Report band will appear:

5. Right-click the detail report and point to Insert Band, and then click Group Header in the shortcut menu. This will add the GroupHeaderBand to the detail report:

You can add the Label control to the added GroupHeader band and change text in it to "Department details".

6. Add the DEPARTMENT_NAME field from the FK_EMPLOYEES_DEPARTMENTS node of the Data Source tree to the Detail Report band of the report. Near each label with the bound field add labels with the text changed to "Department name:".
7. Now switch to the Preview tab at the bottom of the Document area:

In this topic you've created a master-detail report.

ExpandedToggleIcon(9x12) See Also

Writing Data Reports

How To: Save and Load Reports


How To: Save and Load Reports

Using dbForge Studio for Oracle, you can save a data report definition (its bands, controls and other settings) to an .rdb file, and later re-create a report instance from this file. This topic will describe how to save and load reports in dbForge Studio for Oracle.

ExpandedToggleIcon(9x12) Saving Data Reports

To save a report, click Save [Document Name].rdb on the File menu or press Ctrl+S.

Also you can choose the Save [Document Name].rdb As... option or right-click the needed document tab in the document area and choose Save [Document Name].rdb.

These actions will invoke the Save File As dialog window.

ExpandedToggleIcon(9x12) Loading Data Reports

To load an existing report definition from an .rdb file, click Open File on the File main menu or press Ctrl+O. Each of these actions will invoke the Open File dialog window. You may choose Reports (*.rdb) in the Files of type field to show only files with report definitions.

ExpandedToggleIcon(9x12) Connection Manager Window

If dbForge Studio can not find a connection by the connection string that is available when loading a report, then a message with the following options will be shown:

1. Create New - create a new connection using the available connection string.
2. Choose Existing - choose one of the existing connections.

If you choose this option, the Connection Manager window will be shown. In the Connections: field available connections are displayed, and the Connection string area below shows the connection string for the selected connection.

The image below shows the Connection Manager window:

connection-manager-ora

note Note

Actual document look may slightly vary from the above image, depending on the product you use.
3. Cancel - click this button to cancel loading of the document.

ExpandedToggleIcon(9x12) See Also

Writing Data Reports

How to: Export Data Reports to Various Formats


How To: Export Data Reports to Various Formats

This topic explains how to export available data report to one of the supported formats.

After you created a data report, you can export it to PDF, HTML, MHT, RTF, XLS, XLSX, CSV, text file or image file. To do this, you should:

1. Click the preview-report Preview button below the report. The report preview will be shown.
2. Click the down arrow on the export-report Export Document button on the document toolbar and choose the format you want to export your report to.
3. Define the needed settings in the window that appears (the settings vary depending on the format).
4. Save the file.

ExpandedToggleIcon(9x12) See Also

Writing Data Reports

Advanced Topics


Working with Command Line

This section explains how to work with data reports using command line interface. It provides comprehensive examples of the frequently used tasks that can be performed with data reports through command line.

note Note

The command line functionality is available only in certain editions of dbForge Studio. For the detailed information on features availability in the dbForge Studio editions, please refer to the Editions topic.

ExpandedToggleIcon(9x12) In This Section

How To: Create a Report through Command Line
The topic explains how to create and work with data reports using command line interface, and holds a step-by-step instruction on saving a report to disk in the HTML format, sending it by email and FTP

Additional /datareport Arguments
The topic gives detailed description of command line switches and examples of their usage.

ExpandedToggleIcon(9x12) See Also

Writing Data Reports

How To: Create Data Report through Command Line


How To: Create a Report through Command Line

You can automate report creation process using command line. Such possibility can be very useful if you need to create a report using the same report file. For this, you will need to create a report template to use it afterwards in the command line. Note that some parameters can be specified directly in the command line. In this case values of these parameters specified in your template file will be overridden.

The walkthrough described further in this topic will show you how to use command line in order to automate the following data report routines: saving a report on disk in the HTML format, sending it by email and FTP.

ExpandedToggleIcon(9x12) Creating a Report Template

To create a report template, you should perform the following actions:

1. Click Design New Report on the Data Analysis tab of the product Start page. Data Report Wizard opens.
2. Follow the wizard pages to create a report template file with .rdb extension.
3. Compose the report template.
4. Save the file for future usage.

ExpandedToggleIcon(9x12) Working with Data Reports

Suppose you need to send a data report containing customers' address and phone number list in HTML format to your authorities via e-mail and FTP every day. For this, you have a report template Report1.rdb (the file is located in C:\dbForge Studio\Reports\), the folder on disk to which the report should be saved is C:\dbForge Studio for Oracle\Reports\Output\, the e-mail address of your authorities is my_chief@company.com, the address of your FTP server is ftp://myftphost.net/reports/, login is send-report, and password is report.

To accomplish such task through command line, you need to perform the following steps:

1. Open Command Prompt by pressing Win+R and type cmd in the Open line.

note Note

To run Command Line in Windows 8:

From the Desktop Mode

· Move the mouse cursor to the exact lower left corner until the desktop shortcuts menu appears
· Right-click to see the shortcut menu and than click Run

From the Charms Bar

· Move your mouse to the upper right corner until the Charms Bar appears
· Select Apps from the list and type “run” in the search box
· Click Run from the search results

Use Windows + R Shortcut Keys

· In the desktop mode, press Windows key + R to show the Run command line.
2. Change the path available in your Command Prompt window to the path where the dbforgeoracle.com file is located (by default it's C:\Program Files\Devart\dbForge Studio for Oracle\). For this, use the cd operator:

C:\Users\User>cd C:\Program Files\Devart\dbForge Studio for Oracle\

Press Enter. You can see that the path has changed:

C:\Program Files\Devart\dbForge Studio for Oracle>

3. Now call the dbforgeoracle.com file:

C:\Program Files\Devart\dbForge Studio for Oracle> dbforgeoracle.com

4. Specify the /datareport operation switch:

C:\Program Files\Devart\dbForge Studio for Oracle> dbforgeoracle.com /datareport

5. Specify the path to your Report1.rdb input file and the name of the file itself:

C:\Program Files\Devart\dbForge Studio for Oracle> dbforgeoracle.com /datareport /reportfile:"C:\dbForge Studio for Oracle\Reports\Report1.rdb"

6. Specify the format you want to save your report in. In this case it's HTML:

C:\Program Files\Devart\dbForge Studio for Oracle> dbforgeoracle.com /datareport /reportfile:"C:\dbForge Studio for Oracle\Reports\Report1.rdb" /format:HTML

7. To start working with the result file, type the /result operation.
· To save your report in the specified folder on disk, type the path to this folder:

C:\Program Files\Devart\dbForge Studio for Oracle> dbforgeoracle.com /datareport /reportfile:"C:\dbForge Studio for Oracle\Reports\Report1.rdb" /format:HTML /result folder:"C:\dbForge Studio\Reports\Output\"

· To send your report by email, add the email address:

C:\Program Files\Devart\dbForge Studio for Oracle> dbforgeoracle.com /datareport /reportfile:"C:\dbForge Studio for Oracle\Reports\Report1.rdb" /format:HTML /result email:"address@hostname.net"

· To send your report by FTP, specify the host, login, and password:

C:\Program Files\Devart\dbForge Studio for Oracle> dbforgeoracle.com /datareport /reportfile:"C:\dbForge Studio for Oracle\Reports\Report1.rdb" /format:HTML /result folder:"ftp://myftphost.net/reports/ " ftplogin:send-report ftppassword:report

note Note

If your report is in HTML format and consists of several files or folders, it is not possible to send such report by email or FTP using command line interface.

note Note

You can perform two actions at a time with the result: save it on disk and send by e-mail, or send it by FTP and e-mail.

note Note

If you need to create the same report and perform the same action with the result frequently, you can save the needed command line in a *.bat file and run it each time you need to create a report. In this case you will not have to type all necessary operators manually in Command Prompt any more.

note Note

To see quick help on the arguments available in the command line, you can type /datareport /?

For more information on the command line arguments for /datareport, refer to the Additional /datareport Arguments topic.

ExpandedToggleIcon(9x12) See Also

Working with Command Line

Additional /datareport Arguments


Additional /datareport Arguments

This topic gives detailed description of command line switches and examples of their usage.

ExpandedToggleIcon(9x12) Arguments

To get more information on switches related to data reports in the command line interface, you can type:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /datareport /?

Below all switches of this option are described, together with usage examples.

Argument

Action and Usage

/connection

This switch is used to specify a connection string with additional parameters. Command usage is as follows:

/connection:<connection_string>

Example of using the /connection argument:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /datareport /connection:"User Id=scott;Server=ORCL"

/format

This switch is used to specify report format. Note that the HTML report won't be sent by FTP or email if result contains several files or folders. Command usage is as follows:

/format:<PDF|HTML|MHT|RTF|TEXT|CSV|EXCEL|EXCEL2007|BMP|EMF|GIF|JPEG|PNG|TIFF|WMF>

Example of using the /format argument:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /datareport /format:"PDF"

/parameters

The switch is used to specify values for parameters declared in a query script. Command usage is as follows:

<param_name1>:<param_value1>
<param_name2>:<param_value2>

Example of using the /parameters argument:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /datareport /parameters param1:value1 param2:value2

/password

Use this switch if you want to specify a server password. This argument overrides the password specified in the connection string. Command usage is as follows:

/password:<pw>

Example of using the /password argument:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /datareport /password:"tiger"

/reportfile

Use this switch to specify the input report file. Command usage is as follows:

/reportfile:<file name>

The following example shows how to specify the input report file:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /datareport /reportfile:"sample_report.rdb"

/result

Use this switch to specify what should be done with the result: save the report to disk, or send it by email or FTP.

You can specify SMTP settings on the corresponding options page.

Command usage is as follows:

/result folder:<file path> | email:<email address> | ftplogin:<login> ftppassword:<password>

Usage examples:

1. Report is saved to the specified folder on disk in the CSV format:

/datareport /reportfile:"D:\workDir\dept.rdb" /format:CSV /result folder:"D:/output/"

2. Report is sent by email:

/datareport /reportfile:"D:\workDir\dept.rdb" /format:CSV /result email:"address@hostname.net"

3. Report is sent by FTP:

/datareport /reportfile:"D:\workDir\dept.rdb" /format:CSV /result folder:"ftp://hostname.net/output/" ftplogin:user_name ftppassword:user_password

4. Report is sent by email and FTP:

/datareport /reportfile:"D:\workDir\dept.rdb" /format

/resultfilename

The switch is used to specify a report name. Command usage is as follows:

/resultfilename:<document name>

Example of using the /resultfilename argument:

C:\Program Files\Devart\dbForge Studio for Oracle>dbforgeoracle.com /datareport /reportfile:"sample_report.rdb" /resultfilename:report1

ExpandedToggleIcon(9x12) See Also

Working with Command Line

Advanced Topics


Advanced Topics in Writing Reports

Advanced Topics

This section describes the fundamental concepts of working with reports in dbForge Studio for Oracle.

ExpandedToggleIcon(9x12) In This Section

Data Reports Overview
This topic describes what is data report and which types of data reports exist.

Report Building Basics
This topic describes basic concepts of the report building process.

Designer Elements
This topic describes the list of tool windows and tools that can be used when creating a report.

Measure Units
This topic describes the measure units used in dbForge Studio.

Report Bands
This topic gives the definition of report bands and describes the bands types available in dbForge Studio.

Report Controls
This topic gives the definition of report controls and describes their types available in dbForge Studio.

Smart Tags
This topic describes smart tags and how to use them when working with reports.

Context Links
This topics describes context links and how to use them when working with data reports.

ExpandedToggleIcon(9x12) See Also

Writing Data Reports


Data Reports Overview

dbForge Studio for Oracle offers the possibility of creating reports implemented in the well-known and user-friendly interface. With dbForge Studio, the routine of report creating is simplified to several clicks - that means you won't have to spend a lot of time and efforts for report producing any more.

ExpandedToggleIcon(9x12) What is Data Report?

Data report is a formatted representation of data that can be displayed on a screen, printed or saved to a file. Reports allow getting the needed data from a database and representing it in a human-readable form, and also providing a lot of capabilities for data generalization and analyzing.

When printing tables and query results data is presented in nearly the same form as it is stored. So, it is often necessary to present it in the form of a report that has traditional appearance and is easy to read. Such reports include all information from a table or returned by a query, but also contain headers, are repaginated etc.

ExpandedToggleIcon(9x12) Data Report Creation in dbForge Studio for Oracle

Of course, reports are used in bookkeeping. In fact, one can not imagine bookkeeping without reports. So, accountants usually need a report generator to automate the process of report creation and avoid any mistakes.

dbForge Studio provides easy-to-use and fast solution for this goal which includes fully-functional report designer, Data Report Wizard for creating different types of reports, and a lot of report examples.

Below is a list of the main features for report creation in dbForge Studio:

Binding Report to Data - it is possible to create a data source, fill it with data and supply it to a report.

Custom Query - you can upload an existing query or create a new one to use it in a report.

Relations Editor - a comprehensive relations editor allows you to create, change, and remove relations between tables and/or views, and queries.

Parametrized Queries - support for parametrized queries with the possibility to edit parameters in Parameter Editor. This editor allows you to add and remove parameters and edit their properties.

Easy Data Source List Population - data source list can be populated in many ways. To add a data source you can drag'n'drop tables or views from the Database Explorer, use the dialog window for adding tables and/or views, or create a custom query.

Mail Merge - it is possible to insert a data field name in brackets right into controls' text, and these fields will be populated from the specified data source when a document is created.

Data Filtering - data can be filtered at several levels data adapter, data set or data view levels.

Data Grouping - report bands serve for implementing grouping, making the process easier and faster.

Set of Controls - a wide range of available controls allows to display various kinds of information in a report.

Chart Control - a special control for adding charts to your report.

Enhanced RichText Control - it's possible to load data from *.txt and *.rtf files.

Large Number of Band Types - 10 different band types to display controls on any part of any page.

Master-Detail Reports - master-detail reports can be created quickly and easily by editing relations between data tables.

Data Source - drag fields from the Data Source window and drop them onto the designer area to create controls which will be automatically bound to an appropriate field. Drop necessary fields onto already created controls to bind them to the fields.

Document Outline - shows the report structure and is used to navigate within a report.

Data Report Toolbar - a toolbar with a set of buttons to operate text options and to call report designer windows, also contains a button to call Data Report Wizard.

Toolbox - the window holding controls available in dbForge Studio data reports.

Event Support - allows to create event handlers at the Report, Band and even Control levels.

Advanced Styles - styles provide the possibility to control the look of your report. Styles can be applied conditionally to reflect certain states. dbForge Studio provides a convenient Style Editor.

Summary Support - to create a summary for textbox or table cell set only two properties - Summary position and Summary type.

In-Place Editing - possibility to change the text properties of controls (label, RichText,TableCell) using in-place editing. To use in-place editing, just double-click the needed control.

Wide Range of Exporting Formats - possibility to export report documents to different formats like PDF, HTML, MHT, RTF, TXT, CSV, and MS Excel. Also a report can be exported to an image file types, like BMP, EMF, GIF, JPEG, PNG, TIFF, WMF.

Save and Load Report Definitions - possibility to save and load report definitions.

Scripting - possibility to use C#, Visual Basic .NET and JScript .NET scripts in reports.

Watermarks - a report can contain a collection of watermarks for all or specified report pages.

Search in Preview - the possibility to call a search dialog in the preview mode to search a report for specific text.

Bookmarks - support for bookmarks makes your report easier to navigate. This structure can also be exported along with the report to PDF, HTML and MHT file formats.

Report Wizard - easy to use, convenient, yet powerful wizard to reduce the time you spend on customizing report.

Measurement - support for imperial (inches) and metric (centimeters) units of measurement. Use the ReportUnit property to set the measuring system for your report.

ExpandedToggleIcon(9x12) See Also

Advanced Topics

Report Building Basics


Report Building Basics

This topic describes the main concepts of reports construction in dbForge Studio. It explains the basics of report creation, describe the structure of a simple report. To learn more on the report elements, see the Report Bands and Report Controls topics.

The following diagram illustrates the report's life cycle in dbForge Studio:

Every report in dbForge Studio consists of bands, and every band contains report controls inside it. Reports can be either bound to data, or unbound. Unbound reports may contain text, images etc. provided manually without using any data source.

Bound to data reports are used to present required information in an easy to read form, so this is the most important feature of all report generators. To create a data bound report, bind the report to a data source and then specify data binding options for report controls.

A report can be created using Data Report Wizard or Blank Data Report option. It is possible to save the created report to an RDB file (for more information refer to the Saving and Loading Reports topic). If a report uses stylesheets, they can be saved to an REPSS file. Also you can load styles from a created earlier REPSS file.

After a report was created you can preview, save, and print it.

ExpandedToggleIcon(9x12) See Also

Advanced Topics

Designer Elements


Designer Elements

This topic gives a brief overview of the main report designer elements.

The following image shows how typical Report Designer and its elements look like:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

The table below gives a brief description of each element marked on the image:

ID | Name | Description
1 | Document Outline Window | Provides quick and easy navigation through the report elements.
2 | Data Report Toolbar | Contains buttons to change font properties of the selected control, buttons to access the Toolbox, Data Source, and Group and Sort windows, and also provides capability to zoom in or out the Report Designer surface.
3 | Toolbox Window | Contains controls available in dbForge Studio for Oracle data reports.
4 | Smart Tag | With smart tags, report controls and bands are enabled to display context-sensitive information and commands.
5 | Band Strips | A strip with band name, band icon, and the Expand/Collapse button displayed on the top of every report band. Strips are not taken in account when generating a report document.
6 | In-Place Editor | To invoke this editor, double-click any text-aware control in Designer. To adjust font and color options use Data Report Toolbar (1).
7 | Shortcut Menu | Right-click any element when designing a report to invoke shortcut menu. It provides access to the most popular options depending on the context.
8 | Data Source Window | Displays the schema of the data source currently bound to a report.
9 | Group and Sort Window | Serves for applying grouping and sorting to a report.

ExpandedToggleIcon(9x12) See Also

Advanced Topics

Measure Units


Measure Units

This topic describes the measure units supported by dbForge Studio, and how to change the currently used system of measurement for a particular report.

ExpandedToggleIcon(9x12) Supported Measure Units

All sizes and locations of report controls, bands, and the report itself are measured in the same units of measurement within a report. This unit of measurement is specified by a report's ReportUnit property, and can be set to one of the following types:

· Hundredths of an Inch.

Used when the ReportUnit property is set to ReportUnit.HundredthsOfAnInch.

· Tenth of a Millimeter.

Used when the ReportUnit property is set to ReportUnit.TenthsOfAMillimeter.

The table below lists all properties that are measured in units, specified by the report's ReportUnit property.

Property | Description
Control.Height | Represents the control height.
Control.Width | Represents the control width.
Control.X | Represents the X coordinate of the control.
Control.Y | Represents the Y coordinate of the control.
Band.Height | Represents the band height.
Line.LineWidth | Represents the line width.
Shape.LineWidth | Represents the width of the line used to create a shape image.
BarCode.Module | Represents the width of the narrowest bar or space in the current BarCode instance.
CrossBandControl.StartPoint | Represents the X and Y coordinates of the starting point where the cross-band control starts drawing.
CrossBandControl.EndPoint | Represents the X and Y coordinates of the end point where the cross-band control ends drawing.
Report.PageHeight | Represents the height of the report pages.
Report.PageWidth | Represents the width of the report pages.
Report.Margins | Represents the margins of the report pages.
Report.Padding | Represents the padding of the report pages.
MultiColumn.ColumnWidth | Represents the widths of the columns when printing multi-column reports.
MultiColumn.ColumnSpacing | Represents the space between the columns when multi-column reports are printed.

ExpandedToggleIcon(9x12) Changing Current Measure Unit

By default the ReportUnit property of a new report is set to Hundredths of an Inch. The current unit of measurement may be easily changed in the Properties window by locating the ReportUnit property and changing it to Tenth of a Millimeter. Also you can change the value of the ReportUnit property in the report's smart tag (to invoke report's smart tag click in the top left corner of the report designer).

How to change the current measure unit using the Properties window is shown on the image below:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

ExpandedToggleIcon(9x12) See Also

Advanced Topics

Report Bands


Report Bands

Every report created in dbForge Studio for Oracle is a banded report. This means that every report consists of a number of bands, each one of which has a different type. Every band may contain report controls.

This topic describes the band types available in dbForge Studio, what they can be used for, and how to add, edit, and delete bands in a particular report. To learn more about basic principles of report creation, see the Report Building Basics topic.

ExpandedToggleIcon(9x12) What is Report Band?

Report band represents a specific area on a report page used to define the way report controls that belong to it should be rendered. Every band has a set of specific properties that define its behavior.

In the report designer report bands are represented by the parts of the design surface divided with band strips.

ExpandedToggleIcon(9x12) Band Types

When you create a new report, it is divided into three basic bands, as shown in the image below. PageHeader, Detail, and PageFooter bands provide space for placing different report controls on them:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

Each band type defines how the controls located on this band will be rendered, their rendering order, and how many times they will be rendered (in case of data-bound report). Note that in the report designer, on some bands may be provided tips with information on bands rendering. For example, on the PageHeader and PageFooter bands the "[one band per page]" tip is displayed.

In the process of creating and working on any report you can add or remove these or any other bands. The band types available in dbForge Studio are listed in the table below.

Band Name | Description
TopMargin | Located at the top of every page above the ReportHeader band or PageHeader band.
ReportHeader | Located at the beginning of a report. This band usually displays introductory information, e.g. a report cover page.
PageHeader | Located at the top of every page of a report, below the TopMargin and/or ReportHeader band. This band can display page numbers or a table header, continued from the previous page.
GroupHeader | Located at the beginning of every group or at the top of the group if it is split across pages. It specifies grouping criteria and is used to display information at the beginning of a group of records.
Detail | Located on a page between all other bands. This band displays a single record from the bound data source at a time, or simply holds unbound controls if there is no a data source assigned to a report.
DetailReport | Located below the Detail band. It holds the detail report when creating a master-detail report.
GroupFooter | Located at the end of every group or on the bottom of the group if it is split across pages. This band is usually used to display summary information for a group.
ReportFooter | Located at the end of a report. This band is usually used to display final information, e.g. report totals.
PageFooter | Located at the bottom of every page below the BottomMargin or ReportFooter band. This band is usually used to display page numbers or a table footer, which has been continued on the following page.
BottomMargin | Located at the bottom of every page below the page footer band.

The following image illustrates the relative positions of different band types, and how many times they are rendered in a report.

The Page Header, Page Footer, Top Margin, and Bottom Margin bands are rendered in the report preview on every page.

The Report Header and Report Footer bands are rendered in the report preview only once.

The Group Header and Group Footer bands are rendered for every group of records in a report.

The number of times the Detail band is rendered in a report depends on the number of records returned from the bound data source - one band per record.

ExpandedToggleIcon(9x12) Editing Bands

A collection of bands of every particular report can be accessed by the report's Bands property. The collection of bands and its items can be modified in different ways:

· In the Properties window, select a report, and click the ellipsis button for the Bands property. This will invoke the Report Editor dialog, in which a hierarchical tree of report bands is be displayed. In this window, you can add or remove bands, and also edit their properties.

The Report Editor dialog window is shown on the image below:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.
· Another way to invoke the Report Editor dialog is to choose the Edit and Reorder Bands... option in a report's smart tag, as shown on the image below. Note that this smart tag is shown in the top left corner of the report designer.

note Note

Actual document look may slightly vary from the above image, depending on the product you use.
· If you want to simply add a new band of a particular type, you may use the report's shortcut menu. Right-click a report's area at design time, as shown in the image below, and select the Insert Band option in the shortcut menu:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

ExpandedToggleIcon(9x12) See Also

Advanced Topics

Report Controls


Report Controls

This topic describes report controls, which are used to display various information in a report. There is the list of controls available in dbForge Studio for Oracle and some basic recommendations on their usage.

ExpandedToggleIcon(9x12) What is a Report Control?

A Report Control represents a specific report element (like text, picture, check box, etc.) which can be inserted into a report. Report controls can reside either inside report bands, or inside other report controls which may serve as control containers (like panel).

The appearance and behavior of a report control is defined by its type. See the section below to learn more about different report control types available in the current version of dbForge Studio.

ExpandedToggleIcon(9x12) Control Types

The table below represents report controls available in dbForge Studio:

Report Control

Description

Label Label

A label control, which allows inserting single-line or multi-line text into a report. This text may be either static, or dynamically populated from a report's data source.

CheckBox Check Box

A check box control, which is intended to display a True/False or Checked/Unchecked/Indeterminate state in a report.

RichText Rich Text

A rich text control, which is intended to display, enter and manipulate formatted text. You can enter and format its text at design time, load it from an external file, or bind this control to a data field.

PictureBox Picture Box

A picture box control, which is intended to display an image in a report. Use this control to insert images of different types into your reports.

Panel Panel

A panel control, which can contain other report controls. It is used for grouping controls together to make their manipulation easier.

Table Table

A table control, which inserts a table (containing rows and cells) in a report.

Note: to create a table that is identical to some table from data source, simply drag the needed table from the Data Source window onto Designer. Each cell of the table will be bound to a field of the source table.

Line Line

A line control, which draws vertical, horizontal or diagonal lines in a report.

Shape

A shape control, which allows to insert any simple graphics into a report.

BarCode Bar Code

A barcode control, which allows to insert many different barcode types into a report.

ZipCode Zip Code

A zipcode control, which allows the insertion of numbers representing a zipcode into a report.

Chart Chart

A chart control is used to represent data in a graphical view.

Note: if the Chart control is bound to data, set the Data Source option in the report smart tag to (none) to display it correctly.

PivotGrid Pivot Grid

A pivot grid control (also called as pivot table) represents data from an underlying data source in a cross-tabulated form to create cross-tab reports.

Note: if the PivotGrid control is bound to data, set the Data Source option in the report smart tag to (none) to display it correctly.

Page Info Page Info

A control, which displays some auxiliary information in a report. Used to display page numbers, the current date or user information in your reports.

Page Break Page Break

A page break control, which serves to mark the place where a report should start a new page.

CrossbandLine Cross-band Line

A line control, which draws itself through the bands, from the CrossBandControl.StartPoint to the CrossBandControl.EndPoint.

CrossBandBox Cross-band Box

A box control, which draws itself through the bands, from the CrossBandControl.StartPoint to the CrossBandControl.EndPoint.

ExpandedToggleIcon(9x12) Editing Report Controls

Report controls can be added to a report in different ways. For example, you may use one of the methods listed below:

· Drag an appropriate item from the Toolbox window, and drop it onto a report.
· Another way of adding report controls to a report is to use the Data Source window. When any data field is dragged and dropped onto a report, a new appropriate report control is added and automatically bound to the specified data field.

ExpandedToggleIcon(9x12) See Also

Advanced Topics

Smart Tags


Smart Tags

This topic gives a brief description of smart tags available in dbForge Studio for Oracle and the basic principles of working with them.

With the smart tag feature, report controls and bands are enabled to display context-sensitive information and commands.

To invoke a smart tag, select any report element and click on its smart tag icon ( Smart Tag). After that the smart tag panel is invoked, allowing you to adjust the properties of the selected report element or of the whole report if the report smart tag (top left corner of the report in the Designer) was invoked.

The smart tag feature is available for the report elements listed below.

Report

A report's smart tag icon is located at the top left corner of a report designer:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

note Note

Keep in mind, that in order to display the Chart and Pivot Grid controls correctly, you should set the Data Source option of the report smart tag to (none).

Report Bands

A band's smart tag icon is located on the band strip right next to the caption. For instance, the smart tag for the Detail band is shown in the image below:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

Here is the smart tag for the Group Header band:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

On the following image the smart tag for the Report Header band is shown:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

Report Controls

A control's smart tag icon is located at the top right corner of the control. For instance, the smart tag for the label is shown in the image below:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

note Note

The smart tag feature is available for all report controls. To learn more about report controls, refer to the Report Controls topic.

ExpandedToggleIcon(9x12) See Also

Advanced Topics

Context Links


Context Links

This topic gives a description of context links and their usage in dbForge Studio for Oracle.

The context links (the so-called "verbs") in dbForge Studio are shown in a smart tag of the currently selected control. For instance, the Edit text context link appears as shown in the image below:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

Context links allow performing multistep tasks more quickly and easily. For example, with the Load File... context link you can load data from external RTF or TXT file to the RichText control with just several clicks. There are other context links that allow you to perform different tasks in dbForge Studio.

· Context links for the RichText control:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.
· Context links for a report object:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

Also context links are available in the Properties window:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

ExpandedToggleIcon(9x12) See Also

Advanced Topics

Writing Data Reports


User Interface Concepts

expandedtoggleicon(9x12) In This Section

Using Documentation
The topic explains how to use the current manual.

User Interface Elements
This topic provides you with basic information about managing your environment workspace.

Working with Text Editor
This topic explains how to work with the Text Editor.

Customizing Window Layout
This section provides information about window layouts and their customization.

Manipulating Documents
The topic describes how to manipulate documents in dbForge Studio.

Customizing Environment
This topic contains information on customizing environment to simplify your work and save time.

Find and Replace Text and Code
This section describes how to use Find and Replace utility.


Using Documentation

The application documentation is available from the official Devart website in the following formats:

· Online
· Offline CHM file (you can download it on the Download section of the product)

There are several ways to navigate through documentation:

· F1 Search
· Search
· Contents

expandedtoggleicon(9x12) F1 Search

F1 provides context help for the active window, dialog box. It always returns no more than one page.

expandedtoggleicon(9x12) Search

Use Search to return all documents that match any specified term or a set of terms.

expandedtoggleicon(9x12) Contents

The table of contents shows all documentation topics in a hierarchical tree view structure and provides a convenient way to browse help. If you opened topic from index or search or from the link and you want to know where this topic is located, use the Locate button or switch to the Contents tab.

expandedtoggleicon(9x12) See Also

Customizing Environments

User Interface Elements


User Interface Elements

This topic provides you basic information about managing your environment workspace. Environment workspace consists of toolbars, tool windows, menus and document area. To personalize menus and toolbars and to adjust their behavior to your needs, point to Toolbars in the View menu, and click Customize.

expandedtoggleicon(9x12) Toolbars

A toolbar is a container for a group of commands or controls that are typically related in their function.

dbForge Studio supports dockable toolbars. A dockable toolbar can be attached, or docked, to any side of its parent window, or it can be detached, or floated, in its own mini-frame window. This article explains how to use dockable toolbars in your applications.

Note Note

If you drag a toolbar to the right or left side of the window, toolbar drop-down lists or combo boxes will not be available. For example, if you drag the Connection toolbar to the right or left side of the window, the Connection box will not be available.

expandedtoggleicon(9x12) Menus

The environment has a set of toolbars where reside buttons, using which you can accomplish most frequent tasks. The toolbar you can access depends on kind of document currently active. If it is not visible, right-click on toolbars area and choose one from the shortcut menu.

You can control which toolbars are allowed to appear, and which must be always visible. By default, when you switch between views or documents, corresponding toolbars appear and disappear. When a toolbar is visible, right-click on toolbar area and deselect its item in the shortcut menu to prevent it from showing even if corresponding view is active. If you want to make a toolbar always visible, select it in the shortcut menu, when corresponding document or view is not active. To return a toolbar to its default state select it in the shortcut menu when corresponding document or view is active. You can edit any toolbar, delete, or add your own in Customization dialog box. To open it choose Customize from a toolbar shortcut menu.

expandedtoggleicon(9x12) Tool Windows

dbForge Studio tool windows are, in general, read-only windows that are not file-based. In this they differ from document windows, which display files in read-write mode. The Toolbox, Database Explorer, and Properties window are examples of tool windows. Tool windows can be docked, floating, or tabbed in the document frame. The tool windows are used to display information. The default size and location apply only when the tool window is first opened; after that the tool window state is persisted.

Placing Tool Windows to the Document Area

To place a tool window to the document area, activate it and choose Tabbed Document from the Window menu, or right-click its title and choose Tabbed Document from the shortcut menu. To make it dockable again, activate it and choose Dockable from the Window menu, or right-click its title and choose Dockable from the shortcut menu.

expandedtoggleicon(9x12) Document Area

Document area typically displays SQL code or diagrams. Document area size can be manipulated by resizing docked tool windows. To free more space for documents, you can put docked tool windows to auto-hide mode by clicking the pushpin icon on the title bar of the window.

You can arrange documents in tab groups in document area. To create a tab group or move document to another tab group just drag a document to a drop point. Dragging a document to an arrow drop point will create new tab group; dragging it to the tab group central drop point will move the document to this tab group.

Multiple documents can be organized into horizontal or vertical tab groups for organizing a workspace for working with several documents at the same time. New document tab group can be created either by dragging document to the required place or by selecting New Horizontal Tab Group or New Vertical Tab Group from the document header shortcut menu.

Documents can be moved between tab groups by dragging-n-dropping or by selecting required command from the shortcut menu. You can expand a tab group to the whole document area and restore document tab groups' sizes by selecting Prominent from the document header shortcut menu.

expandedtoggleicon(9x12) Switching Between Windows

This section contains information about how to switch between documents and tool windows.

To cycle through open documents, use CTRL+TAB or CTRL+SHIFT+TAB key combinations. Press CTRL+TAB to switch to previously used document. Pressing CTRL+TAB again will return you to current document. Hit TAB key while holding CTRL key to cycle through recent documents stack. You can also use CTRL+SHIFT+TAB combination to browse documents in another direction.

To navigate from the current document tab to the next tab, use CTRL+ALT+PGDOWN key combination. To navigate from the current document tab to the previous tab, use CTRL+ALT+PGUP key combination.

You can also switch between documents in the following ways.

· By clicking document titles.
· By clicking the down arrow near the right upper corner of the document area and selecting document name from the appeared menu.
· By selecting document from the Window menu.
· By selecting document in the Windows dialog and clicking the Activate button.

To activate a tool window, use its shortcut key.

expandedtoggleicon(9x12) Switching to another skin

dbForge Studio for Oracle provides you several types of a skin. To switch to another skin, on the Tools menu, choose Skin, and then click the skin name you like.

The following skins are available in dbForge Studio for Oracle:

· Visual Studio 2013 Blue
· Visual Studio 2013 Light
· Visual Studio 2013 Dark
· Visual Studio 2010
· Metropolis
· Metropolis Dark
· Office 2010 Silver
· Office 2010 Blue
· Office 2010 Black
· Office 2013
· Office 2013 Dark Gray
· Office 2013 Light Gray
· Windows 7

expandedtoggleicon(9x12) See Also

Using Documentation

Working with Text Editor


Working with Text Editor

The text editor is the word processor of the dbForge Studio. When the text editor is used to edit text, it is referred to as the text editor. When it is used to edit SQL source code, which is its more common use, it is referred to as the code editor. You can open multiple code editors to view or/and edit code. A list of all documents open for editing in instances of the code editor is available on the Windows menu.

To open the Text editor:

1. On the File menu, click New, and then click File. (Alternatively, on the Standard toolbar, click the New File button.)

2. The New File dialog box opens.

3. Select either the Text file or the XML file form the General Files section.

The only difference between XML and text editors is that XML editor provides syntax highlighting for XML code. You can customize XML highlighting and coloring in Fonts and Colors, Text Editor, Options Dialog Box.

expandedtoggleicon(9x12) User Interface

Code pane
The area where code or text is displayed for editing. It provides SQL statement completion.

Indicator margin
A gray column on the left side of the code editor where indicators for breakpoints and bookmarks are displayed. Clicking this area sets a breakpoint on the adjacent line of code.

Selection margin
A column between the indicator margin and the editing window where you can click to select lines of code.

Horizontal and vertical scroll bars
Lets you scroll the code pane horizontally and vertically so that you can view the code that extends beyond the viewable edges of the pane.
expandedtoggleicon(9x12) Text Editor Toolbar

The Text Editor toolbar contains tools related to the code completion features, commenting and uncommenting of code, bookmarks, etc.

Display an Object Member List
Displays a list of valid databases, tables, columns, and other database objects. When a member from the list is selected, you can insert that member into your code by pressing TAB, or by typing a space or period.

Display Parameter Info
This feature opens the Parameters list to give you information about the number, names, and types of parameters required by a function or attribute. The Parameters list also displays parameter information for nested functions. If you type a function as a parameter to another function, the Parameters list displays the parameters for the inner function. Then, when the inner function Parameters list is complete, the Parameters list reverts to displaying the outer function parameters.

To view Parameter Info for functions:

1. After the name of a function, type an open parenthesis as you normally would to open the Parameters list.
2. dbForge Studio displays the complete declaration for the function in a pop-up window just under the insertion point. The first parameter in the list appears in bold.
3. As you type the function parameters, the bold changes to reflect the next parameter that you need to enter.
4. Press ESC at any time to close the list, or continue typing until you have completed the function.
5. Typing the closing parenthesis also closes the Parameters list.

Display Quick Info
This option displays the complete declaration for any identifier in your code.

You can manually invoke Quick Info feature as follows:

1. On the Edit menu, click Code Completion, and then click Quick Info.
2. Use the keyboard shortcut CTRL+K, CTRL+I.
3. Select the Quick Info toolbar button from the Text Editor toolbar.

Display Word Completion
Complete word types the rest of a variable, command, or function name once you have entered enough characters to disambiguate the term. Type the first few letters of the name, and then press ALT+RIGHT ARROW or CTRL+SPACEBAR.

Refresh Local Cache
If you are writing a query on a database while someone else is making changes to the structure of that database, the suggestions offered by dbForge Studio may become out of date. For instance, if someone has added several tables to a database while you have been connected to that database, these tables will not appear in the suggestions box. To reload the database objects, click Refresh Suggestions. Refreshing suggestions applies only to the database to which you are currently connected.

Reset Suggestions Cache
If you connect to a number of different databases during the same session, dbForge Studio will load all the objects for each database as required, without unloading any of the previously stored objects. This means that you can go back to previous queries and continue to see suggestions for any database to which you have previously connected.
dbForge Studio loads database objects into its memory whenever you connect to a database, in order to display suggestions from that database. If you connect to several databases with a large number of objects, this may eventually result in running out of memory. To reset the memory at any time, click Reset Suggestion Cache.

Decrease Line Indent
Removes a tab (or the equivalent spaces) from the selected lines or the current line.

Increase Line Indent
Adds a tab (or the equivalent spaces) to the selected lines or the current line.

Comment out the selected lines
Adds comment characters to the selection or the current line.

Uncomment the selected lines
Removes comment characters from the selection or the current line.

Toggle a bookmark on the current line
Adds or removes a bookmark on the selected line of the document in the active Editor. Does not alter the line of code bookmarked.

Move the caret to the previous bookmark
Selects the previous bookmark. When the first bookmark is reached, jumps ahead to the last one.

Move the caret to the next bookmark
Selects the next bookmark. When the last bookmark is reached, jumps back to the first one.

Clear all bookmarks in current document
Removes all the bookmarks in the current document.

Format Document
Automatically formats SQL code in the currently opened document.

expandedtoggleicon(9x12) Selecting text and code

You can quickly select a single word, line of text, or multiple paragraphs while you work with code in the editor. Keyboard shortcuts also let you select text starting from the cursor to any other point in your document.

To select text:

· To select any amount of text, just drag the mouse over the text.
· To select a word, either double-click a word or put your cursor next to word and press CTRL+SHIFT+ either RIGHT ARROW or LEFT ARROW.
· To select a line of text, drag the mouse over a line.
· To select text from the cursor to the start or end of the line, press SHIFT+ either HOME or END.

expandedtoggleicon(9x12) Editing text and code

The Editor allows you to manipulate text in the same ways as most word processing applications or text editors. For example, you can:

· Copy and Paste text or code inside the editor and between several Editors or between the Editor and other text editing applications.
· Put the Code Editor into the overstrike mode using the INSERT key
· Use the DELETE and BACKSPACE keys to remove text or code

expandedtoggleicon(9x12) Navigating text and code

There are various ways to move through text or code in the Code Editor using the mouse and navigation keys:

· Use the arrow keys to move one character at a time, or the arrow keys in combination with the CTRL key to move one word at a time. Arrow keys move one line at a time also.
· Click a location with the mouse.
· Use the scroll bars or scroll wheel on the mouse to move through the code.
· Use the HOME, END, PAGEUP, and PAGEDOWN keys.
· Use CTRL+PAGE UP and CTRL+PAGE DOWN to move the insertion point to the top or bottom of the window, respectively.
· Use CTRL+UP ARROW and CTRL+DOWN ARROW to scroll the view without moving the insertion point.

Go to Line command

Use the Go to Line command to a specific line number:

1. In the General, Text Editor, Options Dialog Box, select the Line Numbers option.
2. With a document open in the Editor, select Go to Line from the Edit menu.
3. Enter the line number you want to move to.

expandedtoggleicon(9x12) Change Text Case in the Editor

You can use menu commands or keyboard shortcuts to convert the case of selected text to all upper case or to all lower case.

To switch text to upper case:

1. Select the text you want to convert.
2. On the Edit menu, select Advanced.
3. To convert text to all upper case, choose Make Uppercase, or press CTRL+SHIFT+U.

To convert text to all lower case, choose Make Lowercase, or press CTRL+U.

expandedtoggleicon(9x12) Setting Bookmarks

As the name suggests, bookmarking accelerate your code navigation in the text editor.

There may be some piece of code where you need to move to very frequently. Generally, you scroll the page and move to that section, but dbForge Studio provides great features by which you can move to a particular section very quickly using some shortcut keys. This is called Bookmarking of Code.

You can place a bookmark by clicking on the bookmark icon or use CTRL + B, CTRL + T.

To create or remove a bookmark using the Text Editor toolbar:

1. Open a file in the Editor.
2. Place the insertion point on the line you want to bookmark.
3. Click the Toggle a bookmark on the current line button on the Text toolbar.

To move to a bookmarked line:

1. Scroll to the bookmarked line.
2. On the Text toolbar, the Move the caret to the previous bookmark and Move the caret to the next bookmark buttons are enabled.
3. Click these buttons to navigate to bookmarks in files within the current solution or project.

expandedtoggleicon(9x12) View White Space and Word Wrap

You can turn View White Space and Word Wrap modes on or off by selecting corresponding commands from the Advanced submenu of the Edit menu.

View White Space mode displays spaces and tab characters.

Word Wrap automatically displays any portion of a line that extends horizontally beyond the viewable editor area on the next line.

expandedtoggleicon(9x12) Text Indenting

The Editor provides text indenting functionality. You can set the indent at some line, thus when you press ENTER, this indent is set at the next line. To change line indenting use Increase Line Indent and Decrease Line Indent options.

To increase or decrease indenting perform the following actions:

1. Select the text you want to indent.
2. On the Edit menu, select Advanced.
3. Select Increase Line Indent or Decrease Line Indent to manage the indentation.

collapsedtoggleicon(9x12) Code Outlining

SQL Editor allows you to hide parts of code. Outlining marks are shown left of the code editor window. Code blocks which belong to the same structural item can be collapsed by using the minus (-) symbol. Outlined code is not deleted, it is merely hidden from view.

You can then expand the outlined statement or user-defined region by clicking the plus sign (+) next to the symbol.

Outlining SQL Statements

The statement is outlined in the following cases:

· it spans over two or more lines
· it is a create statement

Nested SQL statement (for example, SELECT in CREATE VIEW) is outlined only if it starts from the new line.

Statement is not outlined if it is very short and takes only one line of code. Stored code condition and cycle operators are not outlined; the same is about nested BEGIN ... END blocks.

User-defined Outlining Regions

You can outline code block using Regions.

To create the region, type #region command at the start line of the region. No symbols except spaces are allowed at the same line before #region command. Region may have the name, so simply specify it after space at the same line. Each region statement has to be closed by the #endregion command. Type #endregion at the beginning of the line determining the region end.

You can create named regions using the #region <region name> and #endregion <region name> commands.

SQL code block, grouped by the specified region can be collapsed/expanded by user. You can create nested regions to operate several SQL code blocks.

expandedtoggleicon(9x12) See Also

User Interface Elements

Find and Replace Text and Code


Customizing Window Layout

This section provides information about window layouts and their customization.

expandedtoggleicon(9x12) Closing and Displaying Tool Windows

When a tool window is closed, it becomes invisible but preserves its content, that will be available when the window is opened again. Most tool windows are listed in the View menu and can be opened by selecting corresponding View menu command. Other tool windows are listed in Database menu. You can also use shortcut keys to display certain tool windows.

All layout changes are saved when you close the application and restored when you open it again.

expandedtoggleicon(9x12) Auto-hide Mode

Tool window auto-hide mode allows you to minimize tool windows along the edges of the application window, freeing more space for the document area.

To turn on auto-hide mode, perform one of the following.

· Activate the window and select Auto Hide from the Window menu
· Right-click the window title and select Auto Hide from the shortcut menu
· Click on the pushpin icon on the title bar of the window

When tool window is in auto-hide mode, it shows when you point on it and hides when you click somewhere out of the window. You can turn auto-hide mode on for all docked tool windows to free all the workspace for document area. To do it, select AutoHide All from the Window menu.

expandedtoggleicon(9x12) Layout Saving and Restoring

All layout changes are saved when you close the application and restored when you open it again. To restore layout to its default state select Reset Window Layout from the Windows menu.

expandedtoggleicon(9x12) See Also

User Interface Concepts

Manipulating Documents


Manipulating Documents

The topic describes how to manipulate documents in dbForge Studio.

expandedtoggleicon(9x12) Managing Documents

The Windows Dialog Box allows you to switch between documents and manage them. To open it, select Windows from the Window menu. This dialog allows you to save and close multiple documents at once, and activate required document.

To save document(s) select required document(s) and click the Save button.

To close document(s) select required document(s) and click the Close Window(s) button.

note Note

To close an opened document, click the document title with middle mouse button (mouse wheel).

To activate required document, select the document and click the Activate button.

expandedtoggleicon(9x12) Navigating through the Document Views

Each SQL document includes different representations of the content - document views.

To switch to a specific view, click a button with the view name on the bottom pane of the document. Alternatively, select the required view from the shortcut menu of the document bottom pane.

You can also cycle through available views with the F7 key.

expandedtoggleicon(9x12) Working with Document Tab Groups

Multiple documents can be organized into horizontal or vertical tab groups for organizing a workspace for working with several documents at the same time. New document tab group can be created either by dragging document to the required place or by selecting New Horizontal Tab Group or New Vertical Tab Group from the document header shortcut menu.

Documents can be moved between tab groups by dragging-n-dropping or by selecting required command from the shortcut menu.

expandedtoggleicon(9x12) Restoring Tabs

Document tabs can be saved to cash and eventually be restored after the application crush or accidental closing. To customize the tab restore options, on the Tools menu, select Options. In the Options dialog box, expand Environment, then expand Documents and select Restore. Set the time after which the data will be saved automatically and select restartable file types.

Document tabs will be restored automatically at the run of the application.

expandedtoggleicon(9x12) Document Header Shortcut Menu

The document header shortcut menu includes the following options:

Save <Name>.sql
Saves a current SQL document.

Close
Closes a current document.

Close All But This
Closes all documents excepting the selected one.

Copy Full Path
Copies the full path for the document.

Open Containing Folder
Opens the folder containing the document.

Float
Detaches the window.

New Horizontal Tab Group
Creates new horizontal tab group.

New Vertical Tab Group
Creates new vertical tab group.

expandedtoggleicon(9x12) See Also

Customizing Window Layout

Customizing Environment


Customizing Environment

The environment provides many useful shortcut key combinations to speed up your work. Default shortcut settings are similar to shortcuts in Visual Studio. Default keyboard mapping schema can be changed to the one similar to Visual C++ 6.0 or to Delphi. There are some more keyboard mapping schemas. Moreover, you can assign your own shortcut keys to every action.

Shortcuts can be changed on the Keyboard, Environment, Options dialog box.

To access this dialog box:

1. In the Tools menu, click Options. The dialog box appears.
2. Expand the Environment section, and click Keyboard.

expandedtoggleicon(9x12) Choosing a keyboard mapping schema

You can select a keyboard mapping schema from the Apply the following additional keyboard mapping scheme drop-down list on the Keyboard page of the Environment section in the Options dialog box.

expandedtoggleicon(9x12) Determining and removing the shortcut key combination for a command

To determine or remove the shortcut key combination for a command perform the following actions.

1. On the Keyboard, Environment, Options dialog box, enter the command name without spaces or a part of it in the Show commands containing box.
2. In the list, select the correct command.
3. Shortcuts for selected command drop-down list now contains the assigned key combination for the command if any combinations exist. You can view them in the list.
4. If you want to remove the combination, select a command in the list, and click the Remove button.

expandedtoggleicon(9x12) Assigning custom shortcut key combination for a command

To assign a shortcut key combination for a command:

1. On the Keyboard, Environment, Options dialog box, enter the command name without spaces or a part of it, in the Show commands containing text box.
2. In the list, select the correct command.
3. On the Use new shortcut in drop-down list, select the feature area where you want to use the shortcut.
4. Place the cursor in the Press shortcut keys box, and press the key combination to set for the selected command. The combination will be displayed in the box.
5. Click Assign.

expandedtoggleicon(9x12) See Also

Customizing Environment

© 2004-2016 Devart


Import and Export Settings

expandedtoggleicon(9x12) In This Section

Import and Export Settings Overview
Contains basic information on import and export of settings.

How To: Import, Export, or Reset Settings
Describes how to import, export, or reset settings.


Import and Export Settings Overview

Settings are customizations of the integrated development environment (IDE). They include windows' visibility and layouts, shortcut key combinations, code templates, code formatting etc. Using the convenient wizard, you can save, export, and then import settings. If required, you can reset all your current settings to default ones.

The ability to export and import settings gives you several benefits - you can:

· quickly copy your settings and use them on another computer
· have the same settings within your development team
· migrate the settings to further versions of dbForge Studio

expandedtoggleicon(9x12) See Also

Import and Export Settings

How To: Import, Export, or Reset Settings


How To: Import, Export, or Reset Settings

Using the convenient Import and Export Settings Wizard, you can select specific categories of settings in dbForge Studio and export or import them, or reset all your settings to default ones.

To open the wizard, in the Tools menu, click Import and Export Settings.

ExportimportsettingsDEV

To export dbForge Studio settings:

1. Open the Import and Export Settings Wizard.
2. Select the Export selected environment settings option and click Next.
3. Expand the Devart Tools node and select the check boxes next to the settings you want to export. To export all settings, select All Settings check box. (Clear the settings which should not be exported.)
4. Enter the name of the file that will contain the exported settings. Click the Browse button to select the file location.
5. Click Finish and see the result message.
6. Click Close to close the wizard.

To import dbForge Studio settings:

1. Open the Import and Export Settings Wizard.
2. Select the Import selected environment settings option and click Next.
3. Select whether to create a backup of your current settings before importing the new ones or not:
· To save your current settings before importing the new ones, select Yes, save my current settings and enter the name of the file that will contain the exported settings. Click the Browse button to select the file location. Then click Next.
· To import the new settings without saving the current ones, select No, just import new settings... Then click Next.
4. Click the Browse button to select the file with the imported settings.
5. Select the check boxes next to the settings you want to import. To import all settings, select All Settings check box. (Clear the settings which should not be imported.)
6. Click Finish and see the result message.
7. Click Close to close the wizard.

To reset dbForge Studio settings to default ones:

1. Open the Import and Export Settings Wizard.
2. Select the Reset all settings option and click Next.
3. Select whether to create a backup of your current settings before replacing them with the default settings or not:
· To save your current settings before replacing them, select the Yes, save my current settings option and enter the name of the file that will contain the exported settings. Click the Browse button to select the file location. Then click Finish and see the result message.
· To restore the default settings without saving the current ones, select the No, just reset all settings... option. Then click Finish and see the result message.
4. Click Close to close the wizard.

expandedtoggleicon(9x12) See Also

Import and Export Settings

Find and replace text and code


Find and Replace Text and Code

This section describes how to use Find and Replace utility.

expandedtoggleicon(9x12) In This Section

Finding and Replacing Text
The topic explains how to finding and replacing text in a file.

Searching and Replacing Text in Files
The topic describes searching and replacing text in files techniques.

Using Incremental Search
The topic explains how to use incremental search to find required text in a file.

Regular Expressions for Find and Replace
The topic explains how to use regular expressions while searching.

Wildcards for Find and Replace
The topic explains how to use wildcards while searching.


Finding and Replacing Text

You can find and replace text using Find and Replace window. To open this window press CTRL+F or CTRL+H. These techniques allow you to control the scope of find and replace and choose the method of reviewing search matches and replacements.

You should consider the following information when you search and replace text:

· Options set in the Find and Replace window are global; certain options selected in one dialog box are selected for all the dialogs. These options are Match case, Match whole word, Search all open documents, Search hidden text, Search up, Wildcards, and Regular Expressions.
· Undo is available only for documents left open after a replace operation.
· Undo for a Replace All operation rolls back all replacement changes in the current document.

You can search one or more open files or windows and move through the search matches one by one using the Find and Replace window. This technique allows you to review each individual search match in the context of the text around the match.

To search current document, current project, or all open documents:

1. Open the items you wish to search.
2. Press CTRL+F and switch to Find mode if necessary.
3. In the Look in box, select 'Current Document', 'Current Project' or 'All Open Documents'.
4. In the Find what text box, enter the text you intend to search for.
5. Select additional search options to increase the accuracy of the search.
6. Click Find Next to start the search and continue choosing Find Next until the last file has been searched.

note Note

You may search in the Output or Data Viewer and Editor windows in the same way. Just select Current Window on the step 3. In the Data Viewer and Editor window you may search both hex code and text. Hex code can be searched only when no wildcards or regular expressions are used.

When the search passes the beginning or end of the document, a message is displayed in the status bar. A message box appears when the search reaches the starting point of the search.

To replace in the current document or in all open documents:

1. Open the items you wish to search.
2. Press CTRL+H and switch to Replace mode if necessary.
3. In the Look in box, select 'Current Document', 'Current Project' or 'All Open Documents'.
4. In the Find what text box, enter the text you intend to search for.
5. In the Replace with text box, enter the text with which you intend to replace the search text.
6. Click Replace and continue clicking Replace until the last match in the last file has been replaced. Use Find Next to skip a match you do not want to replace.

You may click Replace All to replace all matches. A message box appears, listing the total number of replacements. The Replace All command replaces all search matches, including those you have skipped with the Find Next button. To reverse Replace All, choose Undo from the Edit menu in each changed file before closing any of the files.

expandedtoggleicon(9x12) See Also

Find and replace text and code

Searching and Replacing Text in Files


Searching and Replacing Text in Files

You can use the Find and Replace in Files window to perform search and replace operations. To open this window press CTRL+F or CTRL+H, then switch to Find in Files or Replace in Files mode.

Searching and replacing text in files has following peculiarities:

· You can enter disc folder as search location or even create and use named folder sets.
· You can only find all occurrences, you cannot use Find Next.

To create a named folder set:

1. In the Find and Replace in Files window, click the button button next to the Look In box.
2. Enter the folder set name.
3. Edit the folder list with LeftArrow and RightArrow buttons. To browse folders
4. Click the Apply button. Now you may use this folder set in the Look In box.

To delete named folder set, click the button button next to the Look In box, enter the folder set name, and click Delete button.

To search in files:

1. Press CTRL+F and switch to Find in Files mode if necessary.
2. In the Look in box, select needed location or enter folder path or name of the named folder set.
3. In the Find what text box, enter the text you intend to search for.
4. Select additional search options to increase the accuracy of the search.
5. You may specify the file mask for searching in the Look at these file types box.
6. If needed, customize the Result options.
7. Click the Find All button.

After search is finished, all results are displayed in the Find Results window. You may double-click on matches to navigate to them.

To replace in files

1. Press CTRL+H and switch to Replace in Files mode if necessary.
2. In the Look in box, select needed location or enter folder path or name of the named folder set.
3. In the Find what text box, enter the text you intend to search for.
4. Select additional search options to increase the accuracy of the search.
5. If needed, customize the Result options. Select the Keep modified files open after Replace All check box if you want to be able to undo changes.
6. You may specify the file mask for replacing in the Look at these file types box.
7. In the Replace with text box, enter the text with which you intend to replace the search text.
8. Click Replace and continue clicking Replace until the last match in the last file has been replaced. Use Find Next to skip a match you do not want to replace.

You may click Replace All to replace all matches. A message box appears, listing the total number of replacements. The Replace All command replaces all search matches, including those you have skipped with the Find Next button. To reverse Replace All, choose Undo from the Edit menu in each changed file before closing any of the files.

expandedtoggleicon(9x12) See Also

Find and replace text and code

Using Incremental Search


Using Incremental Search

You can search an individual document or window incrementally by entering a search string character by character, then observing the matches found as the search string lengthens. To activate an incremental search, choose Advanced from the Edit menu and choose Incremental Search.

An incremental search automatically searches the entire document or all text within a window, with the exception of text that has been collapsed or concealed. The editor highlights the first set of characters found in the document or window that match the search string entered.

Incremental searches are performed by default from the current location in the document downward, and from left to right. To move to the next match, press CTRL+I. To reverse the direction of the search, press CTRL+SHIFT+I.

To search incrementally:

1. Place the cursor in a blank section of the file or window you want to search.
2. From the Edit menu, choose Advanced, and then select Incremental Search.
3. The cursor icon changes to binoculars with an arrow indicating the search direction, and the status bar displays the text Incremental Search.
4. Begin typing the search string.
5. The status bar displays the search string you are entering, and the editor highlights the first match found for what you have typed so far.
6. Continue to add characters to the search string.

The editor searches again for a match of the augmented search string, and again highlights the first match found.

If no match is found, the status bar displays the following message: Incremental Search: <text> not found.

expandedtoggleicon(9x12) See Also

Find and replace text and code

Regular Expressions for Find and Replace


Regular Expressions for Find and Replace

The Find and Replace window contains a list of symbols and signs which you can use to quickly find and replace required patterns of text. They are called regular expressions.

To select a regular expression, do the following:

1. In the Find and Replace window, select the Use check box and choose Regular Expressions from the drop-down list. The [image] arrow button next to the Find what field becomes active.
2. Click the [image] arrow button and select a regular expression from the drop-down list. It is inserted into the Find what field.

The drop-down list contains the following regular expressions:

Syntax | Expression | Description
. | Any single character | Matches any single character except a line break.
* | Zero or more | Matches zero or more occurrences of the preceding expression, finding all possible matches.
+ | One or more | Matches at least one occurrence of the preceding expression.
^ | Beginning of line | Anchors the match string to the beginning of a line.
$ | End of line | Anchors the match string to the end of a line.
< | Beginning of word | Matches only when a word begins at this point in the text.
> | End of word | Matches only when a word ends at this point in the text.
\n | Line break | Matches a platform-independent line break. In a Replace expression, inserts a line break.
[] | Any one character in the set | Matches any one of the characters within the []. To specify a range of characters, list the starting and ending character separated by a dash (-), as in [a-z].
[^] | Any one character not in the set | Matches any character not in the set of characters following the ^.
| | Or | Matches either the expression before or the one after the OR symbol (|). Mostly used within a group. For example, (database|management)system matches "database system" and "management system".
\ | Escape Special Character | Matches the character that follows the backslash (\) as a literal. This allows you to find the characters used in regular expression notation, such as { and ^. For example, \^ Searches for the ^ character.
{} | Tagged Expression | Matches text tagged with the enclosed expression.
:i | SQL identifier | Matches the expression ([a-zA-Z_$][a-zA-Z0-9_$]*).
:q | Quoted string | Matches the expression (("[^"]*")|('[^']*')).
:b | Space or Tab | Matches either space or tab characters.
:z | Integer | Matches the expression ([0-9]+).

expandedtoggleicon(9x12) See Also

Find and replace text and code

Wildcards for Find and Replace


Wildcards for Find and Replace

The Find and Replace window contains a list of expressions to replace characters or digits in the Find what field. They are called Wildcards.

To select a required wildcard, do the following:

1. In the Find and Replace window, select the Use check box and choose Wildcards from the drop-down list. The [image] arrow button next to the Find what field becomes active.
2. Click the [image] arrow button and select a wildcard from the drop-down list. It is inserted into the Find what field.

The drop-down list contains the following wildcards:

Syntax | Expression | Description
? | Any single character | Matches any single character.
# | Any single digit | Matches any single digit. For example, 5# matches numbers that include 5 followed by another number, such as 51, but not 15.
[!] | Characters not in set | Matches any one character that is not specified in the set.
\ | Escape | Matches the character that follows the backslash (\) as a literal. This allows you to find the characters used in wildcard notation, such as * and #.
* | One or more characters | Matches any one or more characters. For example, test* matches any text that includes "test", such as testfile.txt.
[] | Set of characters | Matches any one of the characters specified in the set.

expandedtoggleicon(9x12) See Also

Find and Replace Text and Code

User Interface Concepts


Reference

This section contains reference information on user interface. Visit the following topics for detailed information.

ExpandedToggleIcon(9x12) In This Section

Code Refactoring
This section contains information on user interface elements used when performing refactoring.

Code Debugger
Describes wizards, windows, and other UI elements related to debug processes.

Code Snippets
Use this section to specify user interface elements for code snippets.

Create Schema Snapshot Dialog Box
Describes the Create Schema Snapshot dialog box.

Data Compare
Describes user interface elements of the windows concerned with data comparison.

Data Editor
Provides information on data managing windows and dialogs.

Data Export Wizard
Learn how to make data export quick and convenient using the Data Export wizard.

Data Import Wizard
Learn how to import data quickly and conveniently using the Data Import wizard.

Data Report
Learn how to perform the simplest and the most difficult tasks with data reports.

Database Administration Tools
Provides you with administrative tools that allows to perform different database administration tasks.

Database Connection
Use the section to set up database connection parameters.

Database Designer
Contains information on Database Designer user interface elements.

Database Explorer
Describes Database Explorer user interface elements.

Database Projects
Use the section to arrange a project management.

Execute Script Wizard
Use the section to execute large scripts without opening them in the editor.

Find and Replace Window
Use the window to search for text, expressions, or entity names within the code of the documents.

Invalid Object Manager Document
Use the document to search and recompile invalid objects.

Import and Export Settings Wizard
Use the wizard to export, import, or restore the dbForge Studio settings.

Master-Detail Browser
Learn Master-Detail Browser user interface elements to customize the data view in parent and related child tables or views.

Pivot Table
Get the information on all the windows and dialog boxes related to PivotGrid functionality.

Object Editors
Contains reference information on user interface.

Options
The section provides you with the information on user adjustable parameters.

Query Builder
Use the section to get information about main components of the query document - the diagram and the tabbed editor.

Query Profiling
Describes Query Profiling interface elements.

Schema Compare
Describes wizards, documents, windows and other UI elements related to schema comparison and synchronization processes.

Schema Export Wizard
Use the section to export schemas or single tables.

Schema Import Wizard
Use the section to import schemas or single tables from a script.

Object and Data Search
Use the section to search for objects and data.

Security Manager
Use the section to add, edit or delete user accounts, roles and profiles, grant and revoke roles and privileges.

Service Windows
Describes user interface elements of service windows and dialogs.

Shortcut Keys
Describes some default shortcut keys that are used by dbForge Studio for Oracle.

SQL Document
Learn how to specify user interface elements for an SQL Document.

SQL Formatter Wizard
Learn how to format an SQL code in multiple files or folders.


Code Refactoring UI

This section contains information on user interface elements used when performing code refactoring.

ExpandedToggleIcon(9x12) In This Section

Preview Changes Dialog Box
Describes the Preview Changes window.


Preview Changes Dialog Box

Use this dialog box to preview refactoring changes to project and to control these changes. Preview Changes dialog box displays all project changes in the Rename <OldName> to <NewName> tree. If the change check box is cleared, this change will not be applied. To open this dialog box, select the object you would like to rename and press F2, make the required changes, and then press F2 again.

Rename <OldName> to <NewName>
This tree represents project script changes.

Preview code changes
This box displays changes in the code. Changes selected in the tree is highlighted with green. Other changes in this file have dotted frame.

Apply
Click to apply changes.

Cancel
Click to cancel changes.

ExpandedToggleIcon(9x12) See Also

Alias Refactoring

Reference


Code Debugger

This section describes the wizards, windows, and other UI elements related to debug processes.

ExpandedToggleIcon(9x12) In This Section

Debug Windows
This section describes user interface elements of the debug windows.

Debug Wizard
This section describes the debug wizard interface for debugging stored procedures and functions.


Debug Windows

This section describes user interface elements of the debug windows.

ExpandedToggleIcon(9x12) In This Section

Breakpoints Window
This window allows to control breakpoints.

Call Stack Window
This window displays call stack of function calls.

Watches Window
This window allows to watch and edit stored procedure variables.

Unable to Apply Code Changes Dialog Box
This dialog box appears if you edit a stored procedure or SQL script while debugging it and then try to step or continue execution.

ExpandedToggleIcon(9x12) See Also

Code Debugger

Debug Wizard


Breakpoints Window

The Breakpoints window contains a toolbar and a list of breakpoints currently set in your program. To open the Breakpoints window, on the Debug menu, point to Windows, and then click Breakpoints.

The window toolbar contains the following tools:

Delete
Removes the breakpoint that is currently selected. You cannot undo this operation.

Delete All Breakpoints
Removes all breakpoints that are currently set. You cannot undo this operation.

Disable/Enable All Breakpoints
Disables all breakpoints that are currently set. You can enable the breakpoints (undo the operation) by clicking the button again.

Go To Source Code
Opens a source window, if necessary, and shows you the location where the breakpoint is set.

The breakpoint list contains three columns with the following information:

Name
A descriptive name of the breakpoint created by the debugger based on the breakpoint's location. The Name allows you to distinguish breakpoints and select the one you are interested in.

A check box appears before the name. You can use this check box to enable or disable the breakpoint.

Line
Contains the line where the breakpoint is situated.

Character
Contains the position of the breakpoint in a line.

ExpandedToggleIcon(9x12) See Also

Debug Windows

Call Stack Window


Call Stack Window

The Call Stack window enables you to view the names of functions on the call stack. To open the Call Stack window, the debugging process must be running. On the Debug menu, point to Windows and click Call Stack. Call stack information is shown only when the program being debugged is in a break state.

The Call Stack window contains the following information:

Name
Shows the name of each function or procedure on the call stack. An indicator appears before the name. The yellow arrow identifies the stack frame where the execution pointer is currently located. green arrow indicates that you have stepped back to the parent code.

Line
Contains the line number that is being executed.

ExpandedToggleIcon(9x12) See Also

Debug Windows

Watches Window


Watches Window

You can use the Watches window to evaluate variables and keep the results. To open the Watches window, the debugger must be running or in break mode. On the Debug menu, point to Windows, then click Watches.

The Watches window contains the following information:

Name
Shows the name of each added variable. An indicator appears before the name. red circle indicates that a variable is not declared in the current context, therefore cannot be traced. Another indicator, Watch , tells that a variable exists in the current context and is traced.

Value
Shows the value of each added variable.

Type
Shows the type of each added variable.

ExpandedToggleIcon(9x12) See Also

Debug Windows

Unable to Apply Code Changes Dialog Box


Unable to Apply Code Changes Dialog Box

This dialog box appears if you edit a stored procedure or SQL script, while debugging, and then try to step or continue execution. Changes cannot be applied to the object that is being debugged. If you continue execution, the debugger will continue to execute the original SQL or stored procedure code (without the changes you have just made).

Always restart without prompting
When selected, disables this dialog box in the future. Instead, the debugger will automatically restart stored procedure or SQL script. If you want to show this dialog box again, select the Warn me if I make changes option on the General tab of the Debugging Options dialog box.

Always continue without prompting
When selected, disables this dialog box in the future. Instead, the debugger will automatically continue, without applying the changes, when you try to step or continue. If you want to show this dialog box again, select the Warn me if I make changes option on the General tab of the Debugging Options dialog box.

Restart
Stops execution of the stored procedure or SQL script, saves changes, and restarts it.

Continue
Continues or steps, depending on the last command you have chosen.

Cancel
Cancels the Continue or Step command you have chosen.

ExpandedToggleIcon(9x12) See Also

Debug Windows

Debug Wizard


Debug Wizard

Use this wizard for debugging stored procedures and functions. To access the wizard, click Debug Stored Procedure on the product Start page. The wizard pages are listed below.

ExpandedToggleIcon(9x12) In This Section

Procedures and Functions, Debug Wizard
Choose script location and connection parameters on this page.

Compilation Process, Debug Wizard
See script compilation process on this page.

ExpandedToggleIcon(9x12) See Also

Code Debugger


Procedures and Functions, Debug Wizard

Use this page to choose a location and connection parameters of a stored procedure or function to debug it.

You can set the following options on this page:

Connection
Click the field to select a connection to the required Oracle server where the stored procedure is placed. In the drop-down list, you can click the <Manage...> link to open the Connection Manager dialog box. It will help you to create, edit, and delete existing connections.

Edit
Click to open the Database Connection Properties dialog box and edit the existing connection.

New
Click to open the Database Connection Properties dialog box and create a new connection.

Schema
Click the field to select the required schema from the list of all schemas available on the selected Oracle server.

Procedures and Functions
Select the procedure/function to debug.

Filter
Use the field to quickly find the needed procedure/function.

Debug
Click to start debugging the selected procedure/function.

Cancel
Click to close the wizard and discard debugging the procedure/function.

ExpandedToggleIcon(9x12) See Also

Debug Wizard

Compilation Process, Debug Wizard


Compilation Process, Debug Wizard

To debug stored procedure, function, or trigger, it must be compiled with debug information. To access compile options, right-click the procedure, function or trigger in Database Explorer and select the required one:

Compiling for Debugging
Compile a stored procedure, function, or a trigger with debug information.

Compile
Delete debug information from specified stored procedure, function, or trigger.

Compile References for Debugging
Compile a stored procedure, function, or a trigger and all its references with debug information.

Compile References
Delete debug information from the specified stored procedure, function, or trigger, and also from all its references.

Compile Dependants for Debugging
Compile a stored procedure, function, or a trigger and all its dependants with debug information.

Compile Dependants
Delete debug information from the specified stored procedure, function, or trigger, and also from all its dependants.

ExpandedToggleIcon(9x12) See Also

Debug Wizard

Code Debugger


Code Snippets

This section describes Code Snippets user interface elements.

ExpandedToggleIcon(9x12) In This Section

Code Snippets Window
This topic describes the Code Snippets window.

Snippets Manager
This topic describes the Snippets Manager window.

Edit Literal Window
This topic describes the Edit Literal window.


Code Snippets Window

In the Code Snippets window, you can find different code samples, organized in folders. You can drag samples from the window to SQL document to inset them to the text. To open the Code Snippets window, click code-snippets Code Snippets on the View menu. To get more information about using the Code Snippets window, read the Using Code Snippets topic.

The Code Snippets window has a preview pane at the bottom of the window. It displays the selected snippet. You can toggle it on or off using the corresponding toolbar button.

The Code Snippets window has the following toolbar buttons:

RefreshButton Refresh
Reloads snippets from the disk.

delete Delete
Deletes selected snippet or folder. Snippet file or all files in folder will be deleted!

new-folder New Folder
Creates new empty folder.

toggle-preview Toggle Preview
Toggles preview panel on or off.

code-snippets Open Snippet Manager
Opens the Snippets Manager window.

ExpandedToggleIcon(9x12) See Also

Code Snippets

Snippets Manager


Snippets Manager

Use Snippets Manager to add, remove or edit snippets. To open Snippets Manager, click code-snippets Snippets Manager on the Tools menu.

ExpandedToggleIcon(9x12) Toolbar

New-snippet New Snippet
Click it to create a new snippet.

new-folder New Folder
Click it to create a new empty folder.

delete Delete
Click it to remove existing snippets.

Save Save
Click it to save changes in existing snippets.

Undo Cancel
Click it to cancel changes in existing snippets.

share-with-devart Share with Devart
Click it to send the new predefined snippet suggestion to Devart.

RefreshButton Reload Snippets
Click it to reload snippets.

ExpandedToggleIcon(9x12) Snippets

Snippets List
The list of existing snippets

Title
Use the field to sent a name for the snippet.

Shortcut
Use the field to set a shortcut for the snippet.

Description
Use the field to describe the snippet.

Text
Displays the snippet's body.

ExpandedToggleIcon(9x12) Literals

Predefined
Predefined literals that can not be removed or modified.

User
Literals created by a user.

Add
Click it to add a new literal using Edit Literal Window.

Edit
Click it to edit existing literals.

Remove
Click it to remove existing literals.

Location
A path to the snippet.

Browse
Click the button to browse for a snippet file location using the Browse For Folder dialog box.

ExpandedToggleIcon(9x12) See Also

Code Snippets

Edit Literal Window


Edit Literal Window

Use the Edit Literal window to create and modify literals. To open this window, you should perform the following steps:

1. Open Snippets Manager.
2. In Snippets Manager, choose one of the available snippets.
3. Click Add.

-or-

Select one of the user defined literals in the Literals field and click Edit.

Name
Specify the name of the literal in this field.

Default value
Specify the default value of the literal in this field.

Description
Specify the description of the literal in this field.

ExpandedToggleIcon(9x12) See Also

Code Snippets

Reference


Create Schema Snapshot Dialog Box

Use this dialog box to generate a snapshot file of your schema structure. To open the dialog box, in the Database menu, click Create Schema Snapshot.

Source

Type
Displays the source type, for which a snapshot is created.

Connection
Select an Oracle connection you want to connect to from the drop-down list. Click <Manage...> in the top of the list to open the Connection Manager dialog box. It will help you to create, edit, and delete database connections.

Edit
Click to edit the current connection. The Database Connection Properties dialog box opens.

New
Click to create a new Oracle connection. The Database Connection Properties dialog box opens.

Server Version
Displays the server version.

Schema
Select a required schema from the drop-down list. Click <Refresh...> in the top of the list to refresh the list of available schemas, if any changes were made.

Destination

Type
Displays the object type (snapshot) that is created.

Path
Click the [...] button, select the folder to save the snapshot to and specify the name of the snapshot file.

Compress
Select this check box if you want dbForge Studio for Oracle to archive the snapshot file. This option is useful when you save large snapshots.

Create
Click to finish the snapshot file creation.

Cancel
Click to abort the snapshot file creation.

ExpandedToggleIcon(9x12) See Also

Data Compare


Data Compare

This section describes user interface elements of the windows concerned with data comparison.

ExpandedToggleIcon(9x12) In This Section

Data Comparison Wizard
Describes Data Comparison wizard's fields and options.

Data Synchronization Wizard
The topic describes the Progress window that appears during comparison/synchronization.

Comparison and Synchronization Progress Info
This topic describes progress window for comparison and synchronization process.

Comparison Report
This section describes the Comparison Report wizard.

Data Comparison Document
Describes the details of the Data Comparison document.


Data Comparison Wizard

ExpandedToggleIcon(9x12) Data Comparison Wizard Description

The Data Comparison wizard provides a single access to perform the basic configuration steps to compare data stored in databases.

To access the Data Comparison Wizard, click New Data Comparison on the start page. Alternatively, on the File menu click NewDataComparisonButton.

ExpandedToggleIcon(9x12) The Main Tabs and Dialog Boxes of the Data Comparison Wizard

Source and Target, Data Comparison Wizard
Choose Source and Target connections, Databases, and select comparison options here.

Options, Data Comparison Wizard
Set data comparison options and records to view in comparison results on this page.

Edit Mask Dialog Box
Use this dialog box to specify a custom wildcard expression for tables (or views) to include them into comparison.

Objects Mapping Dialog Box
Use this dialog box to set custom mapping for tables and views.

Mapping, Data Comparison Wizard
Select objects and their columns to compare and set comparison keys for them.

Column Mapping Dialog Box
Use this dialog box to map columns and specify the comparison key.

Custom Queries Mapping Dialog Box
Use this dialog box to set custom query mapping for tables and views.

WHERE Filter Dialog Box
Use this dialog box to filter rows included into comparison.


Source and Target, Data Comparison Wizard

The tab consists of two sections. The first section, Source, is used to set the connection properties for the source database or to choose a backup file for comparison. The second section, Target, is used to set the connection properties for the target database respectively or to choose a backup file for comparison.

ExpandedToggleIcon(9x12) Database Comparison

Type
Select a database or a backup file you want to compare data with.

Connection
Select a connection here. Choose the <Manage...> option to call the Connection Manager window.

Edit...
Click to edit properties of the selected connection.

New...
Click to create a new connection.

Server Version
The version of the database server used in the connection is specified.

Database
Specify a database to compare.

ExpandedToggleIcon(9x12) Backup Comparison

Type
Select a database or a backup file you want to compare data with.

Add...
Click to add a backup file to compare.

Remove
Click to remove the selected backup file.

Clear
Click to remove all backup files from the grid.

Server Version
The version of the database server used in the connection is specified.

Database
A database which the backup was made from.

Date
A backup file creation date.

Server
The server version of a database which the backup was made from.

Type
The backup type.

File Name
A backup file name and its path.

ExpandedToggleIcon(9x12) See Also

Data Comparison Wizard

Options, Data Comparison Wizard


Options, Data Comparison Wizard

This tab allows you to set data comparison options and records to view in comparison results.

ExpandedToggleIcon(9x12) Options Wizard Page Content

Auto Mapping Options

A set of options that are used to adjust objects mapping.

Ignore case in object names
Select it to ignore case in object names when mapping them. For example, will be mapped to when this option is set.

Ignore underscores in object names
Select it to ignore underscore in object names when mapping them. For example, will be mapped to when this option is set.

Ignore spaces in object names
Select it to ignore spaces in object names when mapping them. For example, will be mapped to when this option is set.

Include tables or views by mask: *
Allows specifying a custom wildcard expression for tables (or views) to include them to comparison. For example, tables or views with such names as dept.Jobs, dept.Tmp_Jobs, Tmp_Job_History, sales.Departments, dept.Tmp_Departments, dept.Tmp_Departments2, will be included to mapping if "*jobs*, *Department*" is set for this option.

Exclude tables or views by mask. *Table*
Allows specifying a custom wildcard expression for tables (or views) to exclude them from comparison. For example, tables or views with such names as hr.employees, hr.Temp_Employees, sales.Temp_Employees_Old, sales.REGIONS, customer.Tmp_Regions, sales.Tmp_RegionS_new will be excluded from mapping if "*employees*, *Regions*" is set for this option.

Ignore LOB columns
Allows ignoring LOB columns during comparison. The option can be applied to the following column types: (N)CLOUB, BLOB, BFILE, LONG, LONG RAW and XML.

Ignore columns by mask: *ModifiedDate*, *CreatedOn*, *UpdatedBy*
Allows you to specify a custom wildcard expression for columns names to exclude columns from comparison. For example, columns with such names as UpdateByCustomer, NotUpdateByUser, RecordsCreatedOn, RecordCreatedOnDay, LastModifiedDate, and ProductModifiedDateTime will be excluded from mapping if *MadifiedData*, *CreatedOn*, *UpdatedBy* is set for this option.

To add/edit a wildcard expression, click the OptionButton button next to the option and enter a required expression.

The compare process usually involves some large tables with many fields. Most tables have system fields like date and timestamp or user name that updated a record. Although this information is useful, usually it is not a target of comparison. This option allows you to specify the columns to be ignored during comparison. To do this, a mask by which columns will be ignored should be set. To set such mask wildcards can be used. If this option is checked, column names are compared with the specified mask during comparison (register is not taken into account). If column name corresponds to the mask, the column is ignored. Columns that don't correspond to any masks are ignored during comparison. So if you do not want to compare columns with a specific name, use this option. This way the columns won't be compared and won't participate in comparison.

Comparison Options

A set of options used to determine the objects and records that should be compared.

Compare tables
Includes tables into comparison.

Compare views
Includes views into comparison.

Compare materialized views
Includes materialized views into comparison. Materialized views cannot be synchronized.

Round float types up to 3 digits
Select it to specify the count of digits after the decimal point. Option rounds data types.

Ignore trailing spaces
This option allows you to ignore whitespaces in the end of strings during comparison and synchronization. This option can be applied to CHARACTER, CHARACTER VARYING, TEXT columns.

note Note

This option recognizes only the Unicode code point 0x0020.

Ignore case
Ignores case in symbols for non-key columns of the following data types: CHARACTER, CHARACTER VARYING, TEXT.

Ignore end of line
Ignores end of line characters during comparison and synchronization. The option can be applied only to (n)VARCHAR columns.

Ignore time part in DATETIME data types
Ignores time for fields of the DATETIME types and compares only dates. For example, if you set this option values '1995-09-29 03:14:15.000' and '1995-09-29 22:14:06.540' will be considered equal. This option is supported for the DATETIME, DATETIME2, SMALLDATETIME, and DATETIMEOFFSET data types.

Compare file names only for BFILE
If selected, only file (and directory) names are compared regardless their content. Otherwise, the file content is compared and differences in file names are ignored. Allows to copy BFILEs to a target database.

Display Options

A set of options used to determine the set of results to be seen after comparison.

Different records
Select to include different records into comparison results. These records are displayed in the result grid and are available for synchronization. If this option is not selected, different records will not appear in to comparison results and will not be stored on disk.

Only in source records
Select to include records that are available only in source into comparison results. These records are displayed in the result grid and are available for synchronization. If this option is not selected, only in source records will not be stored on disk and will not appear in the comparison result.

Only in target records
Select to include records that are available only in target into comparison results. These records are displayed in the result grid and are available for synchronization. If this option is not selected, only in target records will not be stored on disk and will not appear in the comparison result.

Identical records
Select to include identical records into comparison results. These records are displayed in the result grid and are available for synchronization. If this option is not selected, identical records will not be stored on disk and will not appear in the comparison result.

Buttons

Save As My Defaults
Click this button to save current settings as your default settings.

Devart Defaults
Click this button to restore the application default comparison settings.

My Defaults
Click this button to restore your default comparison settings, previously saved with the Save As My Defaults button.

Other Elements

Find
Enter the first character of the option's name to show only the options that contain this part in their names.

Save settings to a command line arguments file
Click to save settings of options to use them in an arguments file when comparing databases through the command line or scheduling a task.

ExpandedToggleIcon(9x12) See Also

Data Comparison Wizard

Edit Mask Dialog Box


Edit Mask Dialog Box

This dialog allows you to specify a custom wildcard expression for tables (or views) to include them into comparison. For example, tables or views with such names as dept, Jobs, department.Tmp_Jobs, Tmp_Job_History, sales.Dept, job.Tmp, dept.Tmp_Departments2, will be excluded from mapping if "*job*,*dept*" is set for the Exclude tables or views by mask:* option.

To open this dialog, open the Data Comparison Wizard, navigate to the Include/Exclude tables or views by mask:* option and click the three-dotted button.

The Edit Mask dialog box contains a list of expressions to replace characters or digits in the Include/Exclude tables or views by mask:* field. They are called Wildcards.

To select the required wildcard, do the following:

1. In the Edit Mask dialog box, click the [image] arrow button next to the wildcard expression field.
2. Select a wildcard from the drop-down list. It is inserted into the wildcard expression field.

The drop-down list contains the following wildcards:

Syntax | Expression | Description
, | Next mask | Use comma to specify several masks.
* | Zero or more of any character | Matches any single or more characters. For example, test* matches any text that includes "test".
? | Any single character | Matches any single character.
# | Any single digit | Matches any single digit. For example, 5# matches numbers that include 5 followed by another number, such as 51, but not 15.
[] | Any single character in the set | Matches any of the characters that is specified in the set.
[!] | Any single character not in the set | Matches any of the characters that is not specified in the set.
\ | Escape Special Character | Matches the character that follows the backslash (\) as a literal. This allows you to find the characters used in wildcard notation, such as * and #.

ExpandedToggleIcon(9x12) See Also

Data Comparison Wizard

Objects Mapping Dialog Box


Object Mapping Dialog Box

This dialog allows you to set custom mapping for tables and views.

Source objects

Table
Select this radio button to display the list of tables in the source database. If several schemas are being compared, tables are grouped by these schemas.

Filter
To quickly find a required object, enter characters available in the required object's name. Only objects, names of which contain the required characters, will be shown in the list.

Hide mapped objects
Check this option to show only unmapped objects in the list.

Target objects

Table
Select this radio button to display the list of tables in the target database. If several schemas are being compared, tables are grouped by these schemas.

Filter
To quickly find a required object, enter characters available in the required object's name. Only objects, names of which contain the required characters, will be shown in the list.

Hide mapped objects
Check this option to show only unmapped objects in the list.

OK
Click to map the selected source and target object and close the dialog.

Cancel
Click to close the dialog.

Map
Click to map the selected source and target object without closing the dialog.

ExpandedToggleIcon(9x12) See Also

Data Comparison Wizard

Column Mapping Dialog Box


Mapping, Data Comparison Wizard

Select objects and their columns to compare and set comparison keys for them on this page.

This page displays the grid with compared tables and views, comparison keys and comparison columns. The grid contains the following columns:

Column with check boxes
Select check boxes to include objects to comparison.

Object Name
Displays object names.

Comparison Key
Select comparison key in this column. Use the button to choose another key or to select and edit custom key.

Columns in Comparison
See the quantity of columns (the first number) that are compared and the whole quantity of columns existing in the object (the second number). Click the button to open the Column Mapping Dialog Box and select columns to include into comparison and map them in this column.

note Note

The Caution icon informs you about mapping warnings.

You may select several tables and views and include or exclude them from comparison together. To select several tables click them holding the CTRL key. To select all tables and views press CTRL+A.

Filter Text Box
Enter filter here to see only objects, containing the filter string in their names.

ExpandedToggleIcon(9x12) Mapping Toolbar

Icon | Name | Description
Filter | Filter | Allows using some predefined filters in addition to filtering by object name
RefreshButton | Refresh | Click to refresh mapping
MapObjects | Map Objects | Click to call the Custom Object Mapping dialog box to customize the object mapping
Unmap | Unmap | Click to unmap the object pairs, selected in the grid
MapSchemas | Map Schemas | Click to call the Custom Schema Mapping dialog box to customize the schema mapping
CustomQueryMapping | Custom Query | Click to call the Custom Queries Mapping dialog box to customize mapping
Reset | Reset | Click to restore automatic mapping
SQLFilter | Filter | Click to open the WHERE Filter dialog box to filter Source/Target rows included into comparison.

Predefined Filters

Name | Description
All | Shows all object pairs
Valid Mappings | Shows object pairs without table level warnings
Invalid Mappings | Shows object pairs with table level warnings
Auto Mapped Objects | Objects, that were mapped automatically by dbForge Data Compare
User Mapped Objects | Objects, that were mapped manually by user
Fully Mapped Objects | Objects that were fully mapped
Partially Mapped Objects | Objects that were fully mapped
Included Objects | Object pairs, included to comparison
Excluded Objects | Object pairs, excluded from comparison

note Note
1. If not all the objects are mapped, an information link that shows the number of unmapped objects is displayed in the bottom right corner of the wizard page. Click this link to go to the Object Mapping dialog box.
2. If the primary key is not set for some object, the icon is displayed in the check boxes column.

ExpandedToggleIcon(9x12) See Also

Data Comparison Wizard

Column Mapping Dialog Box


Column Mapping Dialog Box

This dialog allows you to set custom mapping for columns.

Comparison Keys
Use this field to choose indexes, primary keys, unique keys from the drop-down list to select the key columns automatically depending on the columns that were included into the selected index or key.

Select columns for comparison
This grid allows controlling column mapping.

Check box column
Select check boxes to include column pairs to comparison.

Source column
Contains all source columns.

Target columns
Contains Target columns, mapped to the Source columns. Click to map or unmap a Target column. The icon shows the state of the pair - normal or warning.

Key
Select check boxes to include column pairs to a comparison key.

Column details
This grid displays properties of a Source and Target column from the selected column pair in the Select columns for comparison grid.

Reset
Click to restore the automatic mapping.

Cancel
Click to cancel changes and close the dialog.

OK
Click to apply changes and close the dialog.

ExpandedToggleIcon(9x12) See Also

Data Comparison Wizard

Custom Queries Mapping Dialog Box


Custom Queries Mapping Dialog Box

This dialog allows you to set custom mapping for tables and views.

ExpandedToggleIcon(9x12) Source Object

Table or view
Select this radio button to display the list of tables in the source database. If several schemas are being compared, tables are grouped by these schemas.

Search
To quickly find a required object, enter characters available in the required object's name. Only objects, names of which contain the required characters, will be shown in the list.

Hide mapped objects
Select this option to show only unmapped objects in the list.

Query
Select this radio button to create a custom query to compare custom results.

Name
Type the query name here.

Query text box
Type a query in this box.

ExpandedToggleIcon(9x12) Target Object

Table or view
Select this radio button to display the list of tables in the target database. If several schemas are being compared, tables are grouped by these schemas.

Search
To quickly find a required object, enter characters available in the required object's name. Only objects, names of which contain the required characters, will be shown in the list.

Hide mapped objects
Check this option to show only unmapped objects in the list.

Query
Select this radio button to create a custom query to compare custom results. Specify query name in the field below.

Name
Type the query name here.

Query text box
Type a query in this box.

Use the same query for Source and Target
Select this option to use the same query for source and target.

Buttons

Validate
Click to validate both queries one by one. To validate each query separately, choose the Validate Validate command from the Query text box shortcut menu.

OK
Click to map the selected source and target object and close the dialog.

Cancel
Click to close the dialog.

Map
Click to map the selected source and target object without closing the dialog.

note Note

To start comparing queries, you should specify a key in the Key column of the Column Mapping window.

ExpandedToggleIcon(9x12) See Also

Data Comparison Wizard

WHERE Filter Dialog Box


WHERE Filter Dialog Box

In most cases comparing data in tables is performed on an entire data set. However, there are circumstances when it is necessary to limit the scope of data in a table and perform comparison and synchronization only for a limited data set. The WHERE Filter dialog box is used to enter and enforce row filtering utilizing a WHERE clause. To open it, click the SQLFilter Filter button on the toolbar of the Mapping wizard page.

The WHERE Filter dialog box is divided into Source section (on the left) and Target one (on the right). If you want to filter Source rows, enter the filtering expression in the left section. To filter Target rows, specify the expression in the right section. The dialog contains the following details:

Source object name
It displays the name of the Source object selected in the grid on the Mapping wizard page.

Source expression
Enter a filtering expression to apply to Source rows. Right-click here and select Insert Column and a required column from the shortcut menu. Type the filter expression.

Target object name
It displays the name of the Target object selected in the grid on the Mapping wizard page.

Target expression
Enter a filtering expression to apply to Target rows here.

Use the same expression for source and target
You can enter the expression in one section and select this check box to apply it for both Source or Target. The expression will be copied to the opposite section.

Validate
Click this button to validate the entered expression.

ExpandedToggleIcon(9x12) See Also

Data Comparison Wizard


Data Synchronization Wizard

ExpandedToggleIcon(9x12) Data Synchronization Wizard Description

The Data Synchronization Wizard provides a single access to perform the basic configuration steps to synchronize compared data.

To access the Data Synchronization Wizard, click SynchroniseButton Synchronize on the Comparison toolbar.

ExpandedToggleIcon(9x12) The Main Tabs and Dialog Boxes of the Data Synchronization Wizard

Output, Data Synchronization Wizard
Allows you to select general synchronization options including script execution.

Options, Data Synchronization Wizard
Allows you to select output options to manage synchronization script.

Summary, Data Synchronization Wizard
Allows you to review the synchronization actions and warnings.


Output, Data Synchronization Wizard

ExpandedToggleIcon(9x12) Synchronization Script Output

Specify output options concerning synchronization script.

Open the synchronization script in the internal editor
Select to output the synchronization script to the SQL document.

Save the script to a file
Select to output the synchronization script to file. Click the Browse button to specify the path to save this file.

Open in the internal editor
Select to open the script in dbForge Data Compare after creating.

Execute the script directly against the target database
Select to synchronize the target database immediately.

Refresh comparison results after successful synchronization
Select to refresh comparison results after synchronization if synchronization was executed successfully.

ExpandedToggleIcon(9x12) See Also

Data Synchronization Wizard

Options, Data Synchronization Wizard


Options, Data Synchronization Wizard

ExpandedToggleIcon(9x12) Data Synchronization Options

Exclude Comments
Select to prevent comments generation in a synchronization script.

Rollback changes on synchronization error
In case of error it automatically restores the database to the state preceding the synchronization. This includes rolling back a transaction, enabling disabled indexes and triggers, etc.

Disable foreign keys
Select this option to disable foreign keys before synchronizing tables and to enable them after it.

Disable indexes and check constraints
Select it to disable non-unique indexes and check constraints in the beginning of the synchronization. After the synchronization, it will be enabled. If an index is the comparison key, it can not be disabled.

Disable triggers
Select to disable triggers in the beginning of the synchronization. After the synchronization, it will be enabled. This option applied to tables and views.

note Note

Oracle indexes and triggers can be created in a schema different from the owner schema. I.e. a table is located in schema A, triggers for this table reside in schema B, and index for this table resides in schema C. The Disable indexes and check constraints and Disable triggers options are designed to disable only those triggers and indexes that are located in schemas that take part in the comparison process, otherwise they are not disabled.

Restore session parameters
Restore session parameters (NLS_DATE_FORMAT, NLS_TIMESTAMP_TZ_FORMAT, NLS_TIMESTAMP_FORMAT, NLS_NUMERIC_CHARACTERS, NLS_NCHAR_CONV_EXCP, TIME_ZONE) after script done.

Force data refresh in materialized view
Force data refresh in materialized view after script done.

Generate fully qualified object names
Generates fully qualified object names in the synchronization script. If the option is enabled, names of objects in synchronization script will include a schema name.

Use SQL *Plus commands
Select to use SQL *Plus commands SET SQLBLANKLINES and SET DEFINE in synchronization script.

Include print comments
If selected, comments will be printed into output while executing the script. If print comments are included in the deployment script, it is easier to locate items in output.

Synchronize LOBs via files
For each value with size greater than 1Mb, a separate file will be generated, which will be placed on a server side and loaded using BFILEs. Applicable to the following data types: BLOB, CLOB, NCLOB, and XML.

Directory
Specify an Oracle's directory alias, which will be used for placing temporary files with large data.

Shared Paths
Share the selected directory and grant "write" permission on it for remote users. Then specify its network path in this edit box so to let the application access the directory remotely. If you run the application on the server side, just specify the directory's local path.

Copy BFILEs physically
Allows making a physical copy of BFILEs, which can be useful when synchronizing two different servers. Thus, all the BFILEs will be placed into a single directory, which you must specify.

Directory
Specify an Oracle's directory alias, which will be used for placing copies of BFILEs.

Shared Paths
Share the selected directory and grant "write" permission on it for remote users. Then specify its network path in this edit box so that the application can access it remotely. If you run the application on the server side, just specify the directory's local path.

ExpandedToggleIcon(9x12) See Also

Data Synchronization Wizard

Summary, Data Synchronization Wizard


Summary, Data Synchronization Wizard

ExpandedToggleIcon(9x12) Summary Information

This tab contains summary information about synchronization. It consists of two subtabs:

Action Plan
This tab displays synchronization script plan. Statements in the script will be placed in the same order as actions in the action plan. You can copy the action plan using CTRL+C.

Search
Type filter string here. Use "_" symbol to substitute any character.

Expand All
Click to expand all synchronization actions.

Collapse All
Click to collapse all synchronization actions.

Warnings
This tab displays pairs of compared table which have synchronization warnings. Point to the table pairs to see column pairs which caused the warning and the warning text. You can copy the list of warnings using CTRL+C.

ExpandedToggleIcon(9x12) See Also

Data Comparison Wizard

Comparison and Synchronization Progress Info


Comparison and Synchronization Progress Info

When comparison or synchronization is in progress, the Progress window is shown. In this window, the following information is displayed:

· The action that is being performed. They are Describing objects and Comparing data for the comparison process, and Generating script for the synchronization process.
· The count of processed objects. The total number of objects and the number of objects already processed is displayed.
· Progress bar indicating the process progress.
· The name of the database object that is being processed.
· The count of records being processed.
· Elapsed time indicates the time used during comparison or synchronization.
· The Skip button allows to skip comparison of a table that is being compared and starts to compare the next table. You can use this button if you don't want to compare a large table.
· The Cancel button stops the comparison or synchronization process.

ExpandedToggleIcon(9x12) See Also

Data Compare

Comparison Report


Comparison Report

This section describes the Comparison Report wizard.

ExpandedToggleIcon(9x12) In This Section

Format, Comparison Report
Select the report format and location on this page.

Options, Comparison Report
Set options for your report on this page.

ExpandedToggleIcon(9x12) See Also

Data Compare

Data Comparison Document


Format, Comparison Report

The Generating Comparison Report window will help to generate a comparison report for the comparison performed before.

To access the Comparison Report Window:

On the Comparison menu click Generate Comparison Report.

ExpandedToggleIcon(9x12) Available Options

In this window you can choose the following options for the report:

Format
Specify the format of the report file you want to generate.

HTML
Generate a report in the HTML format.

Excel
Generate a report in the Excel (XLS) format.

CSV
Generate a report in the CSV format.

Name
Specify the name of the report file.

Location
Specify where the report should be created. Click Browse... specify the location.

Create report for

All objects
Check this option to include all objects (except identical ones) into your report.

Identical objects
Check this option to include identical objects into your report.

Objects marked for synchronization
Include only objects marked for synchronization into your report.

View the report on completion
Check this option to view the generated report after it was completed.

ExpandedToggleIcon(9x12) See Also

Comparison Report

Options, Comparison Report


Options, Comparison Report

ExpandedToggleIcon(9x12) Available options

In this window you can choose the additional options for the report:

Show number of differences per column
Check this option to include the list with the number of differences in each column to your report. For each database table, a table with the list of columns and the number of differences in them will be created.

Include comparison settings
Check this option to include comparison options into your report. This option is available only for HTML reports.

Include actual data records for different objects
Check this option to include data records available in your database tables into your report. For HTML report, each tablename in the main part of the report will be turned into a link to the part of the report where all data records are listed. For Excel report, pages containing this information will be added.

Hide unmodified columns
Only data that contains differences will be added to the report.

ExpandedToggleIcon(9x12) See Also

Comparison Report

Data Comparison Document


Data Comparison Document

Use this document to see, analyze data comparison results and set up synchronization. It consists of the following:

note Note

Actual document look may slightly vary from the image above, depending on the product you use.

Comparison Result Grid Shortcut Menu and Comparison Toolbar

The shortcut menu of the Comparison Result Grid of a Data Comparison document provides a number of options to manage the data comparison document:

edit-comparisonDataComparisonDocument Edit Comparison...
Calls Data Comparison Wizard where you can change options for the performed data comparison and perform new data comparison.

RefreshButton Refresh
Refreshes the opened comparison document.

stop-execution Stop Execution
Terminates data comparison or synchronization operation.

FilterDataComparisonDocument Filter
Use it to filter the comparison results by their status. Click the down arrow near the Filter button and select the corresponding option in the appeared menu.

filter-allDataComparisonDocument All
All rows are included into the grid.

filter-differentDataComparisonDocument With Different Rows
Only different rows are included into the grid.

filter-identicalDataComparisonDocument With Identical Rows Only
Only identical rows are included into the grid.

filter-conflictDataComparisonDocumen With Conflict Rows
Only conflict rows are included into the grid.

Included Objects
Only rows with included objects are shown into the grid.

Excluded Objects
Only rows with excluded objects are shown into the grid.

Correctly Mapped Objects
Check this option to show correctly mapped objects.

Incorrectly Mapped Objects
Select show incorrectly mapped objects. Objects are considered as mapped incorrectly if there is no comparison key or source or target object was described with error.

Generate Comparison Report
Opens the Comparison Report wizard. Go through the wizard pages to generate a report.

Synchronize
Opens Data Synchronization Wizard.

Exclude Selected Objects
Excludes selection from the needed row, if available.

Include Selected Objects
Includes selection into the needed row, if available.

Change Synchronization Direction
Changes the synchronization direction, so you can synchronize both databases without re-comparing them.

Document Header

Document header shows:

· The search field that allows you to find an object.
· Source and Target databases with their connections.
· Number of selected objects.

Comparison Data Details Grid

The Comparison Data Details Grid displays all the records of each compared object that is selected in the Comparison Result Grid. The records are automatically grouped by status and displayed on separate tabs, and are easy to navigate.

Column with check boxes
Select a check box to include an object to data synchronization.

Owner
Shows an owner of a source object.

Source Object
The object of the Source database that will be compared with the corresponding object of the Target database.

Only in Source
Displays a quantity of records that exist only in source database.

Different Records
Displays a quantity of records, having the same comparison key value, but differing in other columns.

Only in Target
Displays a quantity of records that exist only in target database.

Identical Records
Displays a quantity of identical records. Note that this column is available only if the Identical records option of Data Comparison Wizard is turned on.

Conflict Records
Appears only if there are conflict records (records, having non-unique values of the custom comparison key). It displays numbers of different key values in the conflict records.

Target Object
The object of the Target database which contents you compare and synchronize with the Source one.

Owner
Shows an owner of a target object.

Comparison Data Details Grid Toolbar

Only in Source
Displays a quantity of records that exist only in source database.

Different Records
Displays a quantity of records, having the same comparison key value, but differing in other columns.

Only in Target
Displays a quantity of records that exist only in target database.

Identical Records
Displays a quantity of identical records. Note that this column is available only if the Identical records option of Data Comparison Wizard is turned on.

Conflict Records
Appears only if there are conflict records (records, having non-unique values of the custom comparison key). It consists of two grids, each containing conflict records from the corresponding database.

GoToNextRight Go to the next difference
Points the next difference.

GoToNextLeft Go to the previous difference
Points the previous difference.

GoToNextDown Go to the next difference for the selected column
Points the next difference in column.

GoToNextUp Go to the previous difference for the selected column
Points the previous difference in column.

findDataComparisonDocument Find
Opens the Find and Replace Window. Use this option to start search in the grid.

visible-columnsDataComparisonDocument Visible Columns
Opens the Visible Columns dialog box. Use it to display only the needed columns in the bottom grid.

LockKeyColumns Lock Key Columns
Allows to keep an area of a worksheet visible while you scroll to another area of the worksheet, you can lock key columns in one area by freezing or splitting panes.

HideUnmodifiedColumns Hide unmodified columns
If this checkbox is checked, only columns that contain differences are displayed in the grid.

detached-window-btn Show comparison results in a detached window
Click to show Comparison Data Details Grid in a detached window.

collapse-btn Collapse Pane
Click to collapse Comparison Data Details Grid.

expand-btn Expand Pane
Click to expand Comparison Data Details Grid. The button appears only if Comparison Data Details Grid was collapsed previously.

Shortcut Menu of the Comparison Data Details Grid

The shortcut menu of the Comparison Data Details Grid of a Data Compare document contains the following options (options identical to the ones available on the toolbar are omitted):

best-fitDataComparisonDocument Best Fit
Fits the size of the selected column to the size of data available in it.

Best Fit (all columns)
Fits the size of each column displayed in the grid to the size of data available in it.

viewDifference View Difference
Opens the Data Viewer and Editor window where differences between records can be viewed. If the Data Viewer and Editor window is already opened, it makes this window active.

The status bar in the bottom of the grid displays the number of differences in each column shown in it.

ExpandedToggleIcon(9x12) See Also

Data Compare


Data Editor

This section provides information on data managing windows and dialogs.

ExpandedToggleIcon(9x12) In This Section

Data Viewer and Editor Window
Describes how to view large field values using the Data Viewer tool window.

Custom AutoFilter Dialog Box
Tells how to build a custom filter for a data column.

Filter Editor Dialog Box
Describes how to build complex filter conditions for table data.

Visible Columns Dialog Box
Tells how to filter data by hiding some columns.

Data Editor Window
Describes user interface elements of the Data Editor window.


Data Viewer and Editor Window

Data Viewer and Editor is a tool which allows simple viewing and editing fields with the following data types: BINARY, NCHAR, NVARCHAR, CHAR, NTEXT, IMAGE, XML, TEXT, VARBINARY, VARCHAR.

The control automatically detects type of the content of the BLOB field and represents it as an image, text, rich text or hex dump. To access Data Viewer and Editor, on the View menu, select Other Windows, and then click Data Viewer and Editor. Then just select the text or BLOB field, and its content appears in the Data Viewer and Editor window.

Load Load Data
Replaces the cell content with the data from the file. It opens the Open File dialog where you can select a required file and specify the encoding which should be applied to open and save the file content.

Save Save Data
Opens the Save File As dialog to save data to a file.

note Note

If you try to save to database more data than can be stored in the selected column type, the data will be truncated.

Save Data at the Left
Saves data displayed in the left part of the window to a file.

Save Data at the Right
Saves data displayed in the right part of the window to a file.

note Note

The Save Data at the Left and Save Data at the Right options are available for comparison results.

null-data-btn Null Data
Sets the cell value to NULL.

Apply Changes
Click to apply changes.

Cancel Changes
Click to cancel changes.

EntireCell Copy Entire Cell Value
Copies the cell data into the clipboard.

Paste Entire Cell Value
Replaces the cell data with the data from the clipboard. The format of the pasted data is automatically detected and the required view is set.

Cut Entire Cell Value
Cut the cell data placing it to the clipboard.

Hexadecimal View
Shows cell data as hex dump.

Text View
Shows cell data as a text.

xml-view XML View
Shows cell data as structured XML.

Rich Text View
Shows cell data as a rich text.

json-icon JSON View
Shows cell data as a JSON string.

Image View
Shows cell data as an image.

FitScale Fit Image
Fits an image to the size of the window.

View White Space
Shows each white space with a green character.

Type | Size
Shows the type and size of the displayed data. If data cannot be displayed in the selected view, the Type will be set to Unknown.

note Note

You can copy all data in the cell by using the CTRL+SHIFT+C shortcut. Format of the copied data will depend on the selected view. For example, if the Hexadecimal view is selected, the data will be copied in hex order; data in the Text view, will be copied in text format, etc.

ExpandedToggleIcon(9x12) See Also

Data Editor

Custom AutoFilter Dialog Box


Custom AutoFilter Dialog Box

Custom AutoFilter dialog is used to create custom filter for data grid column. It is displayed when choosing Custom in the grid drop-down filter list.

Using this dialog, you can build a custom data filter with two conditions for the column. Condition relation can be selected from the drop-down list in the left box and value for relation can be entered in the right box. Select And or Or option and click OK to apply the filter.

ExpandedToggleIcon(9x12) See Also

Data Editor

Filter Editor Dialog Box


Filter Editor Dialog Box

Use the Filter Editor dialog to create complex filter conditions to filter data in the data grid. To open this dialog, right-click a required column and select the [image] Condition item from the Quick Filter sub-menu.

Filter conditions in the Filter Editor dialog box are displayed as a tree with condition and group nodes. A group consists of several conditions or subgroups, united with a logical operator.

Condition Tree

The upper part of the Filter Editor dialog is a condition tree. Its nodes are red-colored condition groups and conditions, started with blue-colored column name.

Condition Group

It is displayed as a red-colored logical operator and a FilterGreyAdd button. Clicking the FilterGreyAdd button adds a new condition to group. Clicking the logical operator displays the following menu:

And
Sets And logical operator for the group. All group conditions must be true.

Or
Sets And logical operator for the group. At least one condition from the group must be true.

Not And
Sets Not And logical operator for the group. At least one condition from the group must be false.

Not Or
Sets Not Or logical operator for the group. All group conditions must be false.

Add Condition
Adds a new condition to the group.

Add Group
Adds a new condition group to the current group.

Clear All
This command is available for the top-level condition group only. Removes all conditions and subgroups, leaving only the top-level group node.

Remove Group
This command is available for the non-top-level condition group only. Removes the condition group.

Condition

It consists of the following parts:

Condition column
Blue-colored name of the grid column, to which condition will be applied. You can set another column for the condition by clicking the column name and choosing the column from the appeared menu.

Criteria operator
Green-colored criteria operator. You can set another operator for the condition by clicking the operator name and choosing the operator from the appeared menu.

Operand value
Click and enter the operand value here. Some operators have no operand values (for example Is blank operator), some may have several values.

FilterGreyAdd
This button appears for operators that can have one or more operand values. Click it to add one more operand value.

FilterGreyDel
Click this button to delete the condition. You can also navigate to the condition and press the DELETE or MINUS SIGN key

To navigate between conditions and groups, use the UP ARROW and DOWN ARROW keys. To navigate between a condition column, a criteria operator and a operand value, use the LEFT ARROW and RIGHT ARROW keys.

Buttons

OK
Apply the filter and close Filter Builder dialog.

Cancel
Close Filter Builder dialog and cancel all filter changes.

Apply
Apply the filter and without closing Filter Builder dialog.

ExpandedToggleIcon(9x12) See Also

Data Editor

Visible Columns Dialog Box


Visible Columns Dialog Box

Use the Visible Columns dialog to simplify data analysis and filter the data by hiding some columns in the grid. To open this dialog, select Visible Columns from the shortcut menu. The Visible Columns dialog contains the following:

List of columns
Clear the check box next to a column to hide the column data in the grid. Select a check box to show the column data again.

Select / Deselect All
Select this check box to show all the columns at once. Clear the check box to manually select required columns.

Sort alphabetically
Select it to show the columns in alphabetical order.

ExpandedToggleIcon(9x12) See Also

Data Editor

Data Editor Window


Data Editor Window

This topic describes the Data Editor window user interface elements.

RefreshButton Refresh Data
Use this option to refresh data.

Stop Refresh Data
Use this option to stop refresh operation.

Cached Updates Mode
Allows you to control data editing within single database object.

Apply Changes
Click to store your changes to the server.

Cancel Changes
Click in case you do not want the changes to be applied.

Paginal Mode
Use the Paginal Mode to simplify data view by dividing it into parts.

Go To First Page
Click the Go To First Page button to open the first part page of data.

Go To Previous Page
Click the Go To Previous Page button to open the previous part page of data.

Go to Next Page
Click the Go to Next Page button to open the next part page of data.

Go To Last Page
Click the Go To Last Page button to open the last part page of data.

Switch To Grid View
Click the Switch To Grid View button on the data view toolbar to switch to the Grid View mode.

Switch To Card View
Click the Switch To Card View button to switch to the Card View mode.

Show Group By Box
Click the Show Group By Box button to group data by column.

Auto-search mode
Click the Auto-search mode button to switch to the Auto-search mode. You can also switch to the Auto-search mode by pressing CTRL+I keys.

Export Data
Click the Export Data button to export data from the grid.

Table
To make data editable, choose the table name from the Table drop-down list on the data view toolbar

Data Editor Grid
Contains editable data. It could be represented as a table in the Grid View mode as well as cards in the Card View mode.

First First
Click the First button to switch to the first record field.

Previous Previous
Click the Previous button to switch to the previous record field.

Next Next
Click the Next button to switch to the next record field.

Last Last
Click the Last button to switch to the last record field.

Append Append
Click the Append button to insert more records.

Delete Delete
Click this button to delete the records.

End Edit
Click this button to confirm the changes.

Cancel Edit
Click the Cancel Edit button to discard the changes.

ExpandedToggleIcon(9x12) See Also

Data Editor


Data Export Wizard

Make your data export quick and convenient using the Data Export wizard. You can access the Data Export wizard by doing either of these actions:

· On the Start Page, click Data Analysis, and then click Export Data.
· In Database Explorer, right click the required table or view (or Ctrl+click several tables and/or views) you want to export data from and select Export Data from the shortcut menu.
· In Data Editor Window, select Export Data from the shortcut menu, or click the DataExport Export Data button on the Data Editor Window toolbar.
· On the Database menu , select Export Data.

See the list of the wizard's pages with their options below.

ExpandedToggleIcon(9x12) In This Section

Source, Data Export wizard
Select a required Oracle server connection, a database, and a table where the data you want to export is located.

Export Format, Data Export wizard
Choose a required data export format on this page.

Options, Data Export wizard
Tells how to set options to customize data export into any of 10 available export formats.

Table columns, Data Export Wizard
Choose columns and specify the key for export.

Table, Data Export wizard
Choose a table for data export. Available only for MS Access and ODBC formats.

Data Formats, Data Export wizard
Choose columns for export, change their name and data type, and customize formats for data representation (if available) on this page.

Output Settings, Data Exprot Wizard
Set output settings for exported data on this page. Available for the JSON, XML, TXT and CSV formats only.

Page Print Settings, Data Export wizard
Choose a page size and orientation, set margins, and enter a text for a table's header and footer on this page. Available only for MS Excel, RTF, and PDF formats.

Exported Rows, Data Export wizard
Specify a range of exported rows on this page.

Errors handling, Data Export wizard
Specify the errors handling behavior.

Export Progress, Data Export wizard
See the export progress on this page.

Finish, Data Export wizard
See the result of export process and select whether to open the exported file after the export on this page.


Export Format, Data Export Wizard

Use this wizard page to select an export format, load a user template, and specify a destination file or table. The page contains the following items:

Categories

All Items
Select it to see both export formats and user templates in the Templates section.

Formats
Select it to see only the list of export formats in the Templates section.

User Templates
Select it to see only the list of user templates in the Templates section.
Templates allow to view and select the items of the selected category. Click an export format or a saved template to use them. To load a user template, double-click the Load Template... icon.

note Note

To export data into MS Access, ensure that Microsoft Data Access Components (MDAC) version 2.6 or later is installed on your PC. If you don't have MDAC, click here to download

Large icons
Click it to see the items marked with large icons in the Templates section.

Small icons
Click it to see the items marked with small icons in the Templates section.

ExpandedToggleIcon(9x12) See Also

Options, Data Export Wizard

Data Export Wizard


Source, Data Export Wizard

Use this wizard page to select a required Oracle server connection, a database, and a table/view where the data you want to export is located. The page contains the following details:

Connection

Click the field to select a required Oracle server connection from the drop-down list. By default the connection highlighted in the Database Explorer is selected. In the drop-down list you can click the <Manage...> link to open the Connection Manager dialog box. It will help you to create, edit, and delete database connections.

Edit
Click to edit the properties of the selected connection. The Database Connection Properties dialog box opens. For more information, go to How To: Manage Database Connections topic.

New
Click to create a new Oracle server connection. The Database Connection Properties dialog box opens. For more information, go to How To: Manage Database Connections topic.

Database

Select a database located on the selected Oracle server. In the drop-down list you can click the <Refresh...> link to refresh the list of databases available on the selected Oracle server, if any changes were made.

Tables and Views
Select a table or view you want to export the data from. The list shows all the tables of the selected database.

Filter
Type the filter criteria in this field, and tables and views answering this criteria will be displayed in the Tables and Views field of this page.

File name
Click the Browse button to specify a name and a path of the destination file (the one where the exported data will be saved.) This field is not available for ODBC and MS Access destination formats.

Folder name
Click the Browse button to specify the path to store the destination files (the one where the exported data will be saved.) This field is available more than one table is selected.

Export selected tables into single file
Check this option to export selected tables into a single file. This option is available for SQL destination format only.

Save Template
Click it to save the settings as a template for future uses. For more information, refer to the Saving and Using Templates topic.

ExpandedToggleIcon(9x12) See Also

Export Format, Data Export Wizard

Data Export Wizard


Options, Data Export Wizard

Find how to set options to customize data export into any available export format in this section.

ExpandedToggleIcon(9x12) In This Section

CSV Document Options, Data Export wizard
Choose values for a column separator and a quoted string. Set Unicode support for the exported data on this page.

dBase, FoxPro Database Options, Data Export wizard
Specify a number of digits after the decimal point on this page.

HTML Format Options, Data Export wizard
Customize a header, borders, and rows for the exported data. Choose colors for a table's text and background, set a font, and preview the results on this pages.

Microsoft Access Database Options, Data Export wizard
Enter a table's name and password on this page.

Microsoft Excel Format Options, Data Export wizard
Customize a header, borders, and rows for the exported data. Choose colors for a table's text and background, set a font, and preview the results on this page.

ODBC Data Providers Options, Data Export wizard
Specify a system data source name or customize a connection string on this page. Provide login information if your data source requires.

Portable Document Format Options, Data Export wizard
Customize a header, borders, and rows for the exported data. Choose colors for a text and a background, set a font, and preview the results on this page.

Rich Text Format Options, Data Export wizard
Customize a header, borders, and rows for the exported data. Choose colors for a table's text and background, set a font, and preview the results on this page.

Text Document Options, Data Export wizard
Choose a text alignment and a column length, include or hide a table's header and a grid, and set Unicode support on this page.

XML Document Options, Data Export wizard
Set Unicode support for the exported data and select whether to export information about a table on this page.

SQL Document Options, Data Export Wizard
Specify a table name and select a statement type for exported data.

ExpandedToggleIcon(9x12) See Also

Data Export Wizard

Table columns, Data Export Wizard


HTML Format Options, Data Export Wizard

Use this wizard page to specify options for data export into HTML format and preview the results in the Preview section. The Options page contains the following details:

Header

Customize a header's text and background choosing a required color from the drop-down lists.

1. Click the arrow button in the field to open the drop-down list.
2. Switch to either the Custom, or Web, or System tab to select a required color. You can see the selected color in the Preview section at the bottom of the page.

Click the Font button to change the font settings. Select a font, a style, a size, and a script; add font effects and click OK. The selected font is shown next to the Font button.

Borders

Choose a width and color of borders and preview the results.

Rows

Choose required colors for the text and background of rows and change font settings as was described in Header section. See any changes in the Preview section.

Preview
Here you can look at the sample data with applied format options before exporting.

Save Template
Click it to save the settings as a template for future uses.

ExpandedToggleIcon(9x12) See Also

Text Document Options, Data Export Wizard

Data Export Wizard


Text Document Options, Data Export Wizard

Use this wizard page to specify options for data export into Text format and preview the results in the Sample section. The Options page contains the following details:

Use Unicode
Select this check box to ensure the exported data will support Unicode.

Tab
Choose either to keep tabs or insert spaces.

Text alignment
Select a text alignment from the drop-down list. Preview your changes in the Sample section.

Column length
Use the arrow buttons in the field to choose a column length.

Show a table header
Clear the check box to hide a table header. See the result in the Sample section.

Show a grid
Clear the check box to hide a table grid. See the result in the Sample section.

Horizontal header
If required, change the default character for horizontal header border. Preview your changes in the Sample section.

Vertical header
If required, change the default character for vertical header cell border. Preview your changes in the Sample section.

Horizontal
If required, change the default character for horizontal cell border. Preview your changes in the Sample section.

Vertical
If required, change the default character for vertical cell border. Preview your changes in the Sample section.

Sample
Here you can look at the sample data with applied format options before exporting.

Save Template
Click it to save the settings as a template for future uses. For more information, go to the Saving and Using Templates topic.

ExpandedToggleIcon(9x12) See Also

Microsoft Excel Format Options, Data Export Wizard

Options, Data Export Wizard


Microsoft Excel Format Options, Data Export Wizard

Use this wizard page to specify options for data export into Microsoft Excel format and preview the results in the Preview section. The Options page contains the following details:

Header

Select to include header to the export file.

Text
Select the text color from the drop-down list. Switch to either Custom, or Web, or System tab to select a required color. You can see the selected color in the Preview section at the bottom of the page.

Background
Select the background color from the drop-down list. Switch to either Custom, or Web, or System tab to select a required color. You can see the selected color in the Preview section at the bottom of the page.

Font
Click the button to to change the font settings. Select a font, a style, a size, and a script; add font effects and click OK. The selected font is shown next to the Font button.

Borders

Choose a width and color of borders and preview the results.

Rows

Choose required colors for a text and a background of rows and change font settings as was described in Header section. See any changes in the Preview section.

Preview

Here you can look at the sample data with applied format options before exporting.

Save Template
Click it to save the settings as a template for future uses.

ExpandedToggleIcon(9x12) See Also

Microsoft Access Database Options, Data Export Wizard

Options, Data Export Wizard


Microsoft Access Database Options, Data Export Wizard

Use this wizard page to specify a file name and a password for a database here. The Options page contains the following details:

Password
Enter a password for a database.

Save Template
Click it to save the settings as a template for future uses. For more information, go to the Saving and Using Templates topic.

ExpandedToggleIcon(9x12) See Also

Rich Text Format Options, Data Export Wizard

Options, Data Export Wizard


Rich Text Format Options, Data Export Wizard

Use this wizard page to specify options for data export into RTF format and preview the results in the Preview section. The Options page contains the following details:

Header

Select to include header to the export file.

Text
Select the text color from the drop-down list. Switch to either Custom, or Web, or System tab to select a required color. You can see the selected color in the Preview section at the bottom of the page.

Background
Select the background color from the drop-down list. Switch to either Custom, or Web, or System tab to select a required color. You can see the selected color in the Preview section at the bottom of the page.

Font
Click the button to to change the font settings. Select a font, a style, a size, and a script; add font effects and click OK. The selected font is shown next to the Font button.

Borders

Choose a width and color of borders and preview the results.

Rows

Choose required colors for a text and a background of rows and change font settings as was described in Header section. See any changes in the Preview section.

Use Unicode
Select this check box to ensure the exported data will support Unicode.

Preview

Here you can look at the sample data with applied format options before exporting.

Save Template
Click it to save the settings as a template for future uses.

ExpandedToggleIcon(9x12) See Also

Portable Document Format Options, Data Export Wizard

Options, Data Export Wizard


Portable Document Format Options, Data Export Wizard

Use this wizard page to specify options for data export into portable document format (PDF) and preview the results in the Preview section. The Options page contains the following details:

Header

Select to include header to the export file.

Text
Select the text color from the drop-down list. Switch to either Custom, or Web, or System tab to select a required color. You can see the selected color in the Preview section at the bottom of the page.

Background
Select the background color from the drop-down list. Switch to either Custom, or Web, or System tab to select a required color. You can see the selected color in the Preview section at the bottom of the page.

Font
Click the button to to change the font settings. Select a font, a style, a size, and a script; add font effects and click OK. The selected font is shown next to the Font button.

Borders

Choose a width and color of borders and preview the results.

Rows

Choose required colors for a text and a background of rows and change font settings as was described in Header section. See any changes in the Preview section.

Preview
Here you can look at the sample data with applied format options before exporting.

Save Template
Click it to save the settings as a template for future uses. For more information, go to the Saving and Using Templates topic.

ExpandedToggleIcon(9x12) See Also

XML Document Options, Data Export Wizard

Options, Data Export Wizard


XML Document Options, Data Export Wizard

Use this wizard page to specify options for data export into XML format here. The Options page contains the following details:

Use Unicode
Select this check box to ensure your data will support Unicode.

Save Template
Click it to save the settings as a template for future uses. For more information, go to the Saving and Using Templates topic.

ExpandedToggleIcon(9x12) See Also

Options, Data Export Wizard

CSV Document Options, Data Export Wizard


CSV Document Options, Data Export Wizard

Use this wizard page to set format options for export data to a CSV file here. The Options page contains the following details:

Use Unicode
Select this check box to ensure your data will support Unicode.

Show a table header
Select or clear this check box to show/hide a table's header.

Quote string
Specify a character to be used for quotation.

Force quote
If selected, all the data will be quoted (not only text).

Field Separator
Select how to separate fields: Tab, Space, Comma, or Custom.

Save Template
Click it to save the settings as a template for future uses. For more information, go to the Saving and Using Templates topic.

ExpandedToggleIcon(9x12) See Also

ODBC Data Providers Options, Data Export Wizard

Options, Data Export Wizard


ODBC Data Providers Options, Data Export Wizard

Use this wizard page to set options for ODBC data source. You can set the following:

Data source specification

Set the ODBC connection first. Select either a system data source name or a user data source name from the drop-down list. Click the Refresh button to refresh the list.

Use system or user data source name
You can choose any data source created in the operation system. Click the Refresh button to refresh the list available data sources.

Use a connection string
Click the Build button to customize a connection string.

Login information

Based on the selected data source name, you should enter a user name and a password.

Test connection
Click this button to ensure your connection is successfully set.

Save Template
Click it to save the settings as a template for future uses.

ExpandedToggleIcon(9x12) See Also

dBase, FoxPro Database Options, Data Export Wizard

Options, Data Export Wizard


dBase, FoxPro Database Options, Data Export Wizard

Use this wizard page to specify the number of digits after the decimal point from 0 to 18. You can see the following:

Decimal scale
Click the arrows to specify the number of digits.

Encoding
Select a required encoding from the drop-down list box. By default, the current Windows encoding is selected.

Save Template
Click it to save the settings as a template for future uses. For more information, go to the Saving and Using Templates topic.

ExpandedToggleIcon(9x12) See Also

SQL Document Options, Data Export Wizard

Options, Data Export Wizard


SQL Document Options, Data Export Wizard

Use this wizard page to specify options for data export into SQL format. The Options page contains the following details:

Destination table name
Specify a table name that will be generated in the SQL file. This field is disabled when more than one table are selected.

Statement type
Choose a type of the statements that will be generated in the SQL file.

INSERT
Select it to export data as INSERT statements. Insert data into the table.

UPDATE
Select it to export data as UPDATE statements. Update data into the table.

DELETE
Select it to export data as MERGE statements. Delete data from the table.

MERGE
Select it to export data as MERGE statements. Merge data with the table.

Include database name in script
Select to include database name into script. The option is available only when exporting multiple tables.

Save Template
Click it to save the settings as a template for future uses. For more information, go to the Saving and Using Templates topic.

note Note

The Include database name in script check box appears instead of a text box, while selecting several objects for export.

ExpandedToggleIcon(9x12) See Also

Table columns, Data Export Wizard

Options, Data Export Wizard


Table columns, Data Export Wizard

Use this wizard page to select columns for export. The tab is available for SQL destination format only.

Column
Select or clear the check boxes next to columns to include them into export or exclude.

Key
Select or clear the check boxes next to columns to include them into the key for export or exclude.

Destination Column
Specify the destination column names that will be generated in the SQL file.

ExpandedToggleIcon(9x12) See Also

Data Formats, Data Export Wizard

Data Export Wizard


Table, Data Export Wizard

This page is available only for MS Access and ODBC formats and if only one object for export is selected. You can choose a destination table for data export here.

Existing table
Choose a table to export data to from the list of existing tables.

New table
Create a new table to export data to.

Filter
Type the filter criteria in this field, and objects answering this criteria will be displayed in the list of existing tables.

Save Template
Click it to save the settings as a template for future uses. For more information, go to the Saving and Using Templates topic.

ExpandedToggleIcon(9x12) See Also

Page print settings, Data Export Wizard

Data Export Wizard


Data Formats, Data Export Wizard

ExpandedToggleIcon(9x12) Columns

On the Columns tab select columns for export. You can see the grid with the following details:

Field
Select or clear the check boxes next to columns to include them into export or exclude.

Alias
To export a column with another name, click the Alias field and enter a new column name.

Data Type
You can select the required type from the drop-down list. (This field is editable only for Text, HTML, PDF, RTF, and CSV formats. For Excel and Excel 2007 formats, the field is editable only for binary columns and includes only two data types (HexString and String) in the drop-down list).

ExpandedToggleIcon(9x12) Formats

This tab is available only for Excel, Excel 2007, HTML, Text, RTF, PDF, CSV and JSON export formats. On the Formats tab specify data representation formats for the exported data.

If necessary, change the default types of data representation. Enter new values into the fields.

For more detailed information about how to customize formats, see the Custom Numeric Strings article.

Save Template
Click it to save the settings as a template for future uses. For more information, go to the Saving and Using Templates topic.

ExpandedToggleIcon(9x12) See Also

Table, Data Export Wizard

Data Export Wizard


Output Settings, Data Exprot Wizard

Use this page to set output settings for exported data. This page is available for the JSON, XML, TXT and CSV formats only.

Folder
Specify a name and a path of the destination file (the one where the exported data will be saved).

Export data into a single file
Select this option to export selected data into a single file.

Export data into separate files
Select this option to export selected tables and views into a separate files.

Append timestamp to the file name
Select it to include a timestamp to the name of the generated file.

Auto delete old files
If the Append timestamp to the file name option is checked, you can choose to delete old output files automatically when generating new files.

Files older than
Set the number of days the files should be older to be deleted.

Quantity more than
Backups are auto deleted if their quantity is more than the number specified.

Use compression (ZIP)
Check this option to compress the exported data to a ZIP file.

Level
Select the level of compression here. You can select one of the following levels of compression: No Compression, Best Speed, Fast, Default, Good, Maximum.

Comment
Add a comment to the created archive.

Exported files preview
Allows to preview the exported files.

Save Template
Click it to save the settings as a template for future uses. For more information, go to the Saving and Using Templates topic.

ExpandedToggleIcon(9x12) See Also

Table, Data Export Wizard

Data Export Wizard


Page Print Settings, Data Export Wizard

Use this wizard page to specify page print options and preview the results in the Preview section. These options are available only for the MS Excel, RTF, and PDF formats. You can see the following details:

Page size
Select a required page size from the drop-down list. Preview the result.

Repeat a table header
Select it to print a table header on each page.

Orientation
Specify a page orientation, either a portrait or landscape one. Preview the result.

Margins
Set margins using the arrow buttons. Preview your changes.

Footer/Header
Enter a text for a table's footer and header. If required, select the check box at the top of the window to repeat a table's header on each page.

Preview
Here you can look at the sample data with applied settings before exporting.

Save Template
Click it to save the settings as a template for future uses. For more information, go to the Saving and Using Templates topic.

ExpandedToggleIcon(9x12) See Also

Exported rows, Data Export Wizard

Data Export Wizard


Exported Rows, Data Export Wizard

Choose options for exported rows here.

Export all rows
Select this option to export all rows. Both selected and not selected rows in the grid will be included into export.

Export selected rows only
If you select several rows in a table and then click Export Data, this option will be selected automatically. All applied filters (if any) will be saved in the output file.

Export a range of rows
Select a range of exported rows.

Start from
Specify the row's number to start exporting from.

Count
Specify the quantity of rows for export. (Note: The specified quantity will include the starting exported row.). If 0 is specified, all rows after the Start from value are exported.

Save Template
Click it to save the settings as a template for future uses. For more information, go to the Saving and Using Templates topic.

ExpandedToggleIcon(9x12) See Also

Errors Handling, Data Export Wizard

Data Export Wizard


Errors Handling, Data Export Wizard

On this page, you can specify the application behaviour when an error is encountered during data export and logging options.

Errors handling

Prompt a user for an action
Select it to be prompted by dbForge Studio for Oracle in case of any errors. You will be able to ignore the errors and continue exporting data or cancel the process.

Ignore all errors
Select it to make dbForge Studio for Oracle ignore all errors during export.

Abort at the first error
Select it to cancel export if any error occurs.

Log settings

Write a report to a log file
Select it to get a log file with details about the export session. This will allow you to see the information about the errors appeared during the export session and their causes.

Log file
Click the Browse button and specify the path to the log file or enter it manually.

ExpandedToggleIcon(9x12) See Also

Export progress, Data Export Wizard

Data Export Wizard


Export Progress, Data Export Wizard

You can see the export progress on this page. To cancel the export, click the Cancel button.

ExpandedToggleIcon(9x12) See Also

Finish, Data Export Wizard

Data Export Wizard


Finish, Data Export Wizard

You can see data export results on this page.

Errors count
Displays the total number of errors.

Rows exported
Displays the total number of exported rows.

Show log file
Click to open the log file. This button appears only if you selected Write a report to a log file on the Errors Handling wizard page.

Open result file
Click to open the result file. The option is disabled if several objects are selected for import.

Open result folder
Click to open the result folder that contains result file. This option is not available when exporting to the ODBC format.

Export more
Click this button to perform export data process once more. When you click this button, you are redirected to the Export Format page of the wizard. To select new tables and/or views to export data from, go to the Source page of the wizard.

If an error occurred during the export process, its text will be displayed in the upper part of the page.

ExpandedToggleIcon(9x12) See Also

Data Export Wizard


Data Import Wizard

Import your data quickly and conveniently using the Data Import wizard. To open it, do either of these actions:

· (to import to a new table) Select Database, and then click Import Data in the top menu.
· (to import to an existing table) Right-click a table in Database Explorer and select Import Data from the menu. The Data Import wizard opens with predefined parameters: a Oracle connection, a database, and a table to import the data to.

See the list of wizard's pages with their options below.

ExpandedToggleIcon(9x12) In This Section

Source File, Data Import Wizard
Specify an import format and a file for the import here.

Destination (for DBF, CSV, Excel, XML, Text formats), Data Import Wizard
Select a Oracle connection, a database, and a table to import the data to here.

Destination (for Access and ODBC formats), Data Import Wizard
Select a Source and a Target table for the import here.

Source query dialog
Use this dialog to create a query for a partial data import.

Options, Data Import Wizard
Set options to customize import of the selected import format here.

Data Formats, Data Import Wizard
Specify data format values and column settings for import here.

Mapping, Data Import Wizard
Set correspondence between a file content and a Target table here.

Mapping for Text data, Data Import Wizard
Set correspondence between a Text file content and a Target table here.

Modes, Data Import Wizard
Define how dbForge Studio for Oracle should import the data.

Output, Data Import Wizard
Select output options to manage the data import script.

Errors Handling, Data Import Wizard
Select how dbForge Studio should handle errors during import and whether to write a log file.

Import Progress, Data Import Wizard
See the import progress on this page.

Finish, Data Import Wizard
See whether the import completed successfully or failed, open a log file on this page.

Open MS Access database Dialog Box
Appears only if selected for import MS Access data is password-protected.


Source File, Data Import Wizard

Use this wizard page to select an import format, load a user template, and specify a location of Source data. The page contains the following elements:

Categories

All Items
Select it to see both import formats and user templates in the Templates section.

Formats
Select it to see only the list of import formats in the Templates section.

Templates
Select it to see only the list of user templates in the Templates section.

Templates

Allows you to view and select the items of the selected category. Click an import format or a saved template in the list to use them. To load a user template, double-click the Load a template icon.

File name
Enter the path to the Source data or click the Browse button to select the path in the Open dialog.

Large icons
Click it to see the items marked with large icons in the Templates section.

Small icons
Click it to see the items marked with small icons in the Templates section.

ExpandedToggleIcon(9x12) See Also

Destination Table, Data Import Wizard

Data Import Wizard


Destination, Data Import Wizard

Use this wizard page to select a required Oracle connection, a database, and a table where you want to import the data. The page contains the following elements:

Target

Connection
Click the field to select a required Oracle connection from the drop-down list. By default, the connection highlighted in Database Explorer is selected. In the drop-down list, you can click the <Manage...> link to open the Connection Manager dialog box. It will help you to create, edit, and delete database connections.

Edit
Click to edit the properties of the selected connection. The Database Connection Properties dialog box opens. For more information, go to the How To: Manage Database Connections topic.

New
Click to create a new Oracle server connection. The Database Connection Properties dialog box opens. For more information, go to the How To: Create Database Connection topic.

Database
Select a database located on the selected Oracle server. In the drop-down list you can click the <Refresh...> link to refresh the list of databases available on the selected Oracle server, if any changes were made.

New table
Enter a name of a new table to import the data to.

Existing table
Select a table to import the data to. The list shows all the tables of the selected database.

Filter
To quickly find a required Target table or view in the list, enter characters of a required name. The list will be filtered to show only those that contain such characters in their names.

ExpandedToggleIcon(9x12) See Also

Destination Table (for Access and ODBC formats), Data Import Wizard

Data Import Wizard


Destination (for Access and ODBC formats), Data Import Wizard

Use this wizard page to select a Source table/view and a Target connection, a database, and a table where you want to import the data. The page contains the following details:

Source

Select a table or a view
Lists all the tables and views of the selected data source. Select a required table or view to import the data from.

Filter
To quickly find a required Source table or view in the list, enter characters of a required name. The list will be filtered to show only those that contain such characters in their names.

Custom Query
You can use a query to import the Source data partially. Click this button and edit a query in the Source query editor. Click OK to save the changes. To discard the changes, click Cancel.

Target

Connection
Click the field to select a required Oracle connection from the drop-down list. By default, the connection highlighted in Database Explorer is selected. In the drop-down list, you can click the <Manage...> link to open the Connection Manager dialog box. It will help you to create, edit, and delete database connections.

Edit
Click to edit the properties of the selected connection. The Database Connection Properties dialog box opens.

New
Click to create a new Oracle connection. The Database Connection Properties dialog box opens.

Database
Select a database located on the selected Oracle. In the drop-down list, you can click the <Refresh...> link to refresh the list of databases available on the selected server, if any changes were made.

Existing table
Select a table to import the data to. The list shows all the tables of the selected database.

Filter
To quickly find a required Target table or view in the list, enter characters of a required name. The list will be filtered to show only those that contain such characters in their names.

New table
Enter a name of a new table to import the data to.

ExpandedToggleIcon(9x12) See Also

Source Query Dialog Box

Data Import Wizard


Source Query Dialog Box

You can use a query for partial data import. Click the Custom Query button and edit the query in the editor. Click OK to save the changes.

ExpandedToggleIcon(9x12) See Also

Options, Data Import Wizard

Data Import Wizard


Options, Data Import Wizard

Use the Options wizard page to customize import of the selected import format.

ExpandedToggleIcon(9x12) In This Section

Text Options
Set options for Text import format on this page

MS Excel Options
Set options for MS Excel import format on this page.

XML Options
Set options for XML import format on this page.

JSON Options, Data Import Wizard
Set options for JSON import format on this page.

CSV Options
Set options for CSV import format on this page.

ODBC Options
Set options for ODBC import format on this page.

DBF Options
Set options for DBF import format on this page.

.

ExpandedToggleIcon(9x12) See Also

Data Import Wizard

Mapping, Data Import Wizard


Text Options, Data Import Wizard

Use this wizard page to customize import of text files. You can set the following options:

Encoding
Shows the automatically-detected encoding of the Source data. If the file encoding cannot be detected, dbForge Studio for Oracle sets the current Windows encoding. You can select a required encoding from the drop-down list.

Quote string
Set a symbol to define quoted data in the Source text file during import. The default value is double quotes. The mechanism of importing quoted data is based on the following rules:

· Data is delimited into fields according to found delimiters.
· Data between quotation marks will be imported and the quotation marks will be ignored. Any single quotation mark will be imported. For example, the data from these two fields "text"1text" "text"2text" will be imported like text"1text text"2text.

Skip lines
Set a quantity of lines to skip during import. For example, if you set 3, dbForge Studio for Oracle will import the data starting from the 4th line. The selected line range will be highlighted with pink in the Preview section.

Header position
Select a line number where the table header is located. The selected line will be highlighted with blue in the Preview section.

Import even lines only
Select it to make dbForge Studio for Oracle import only even lines. It is useful when, for example, each line with data is delimited by a line containing horizontal delimiters and you need only the lines with data.

Splitting

Manual
Select it for manual splitting of Source data into columns. In the Preview section double-click on desired positions to set column bounds. The markers will appear. Read how to manage markers in Preview description.

Fixed width
Select it to split Source data into columns with fixed width. Specify a width value and see how the columns are splitted in the Preview section.

Delimiter
Select it if you want to specify a column delimiter. Specify the delimiter type and see the result in the Preview section. The following options are available:

Tab - will delimit the Source columns by tab.

Space - will delimit the Source columns by space.

Custom - will delimit the Source columns by a custom symbol, which you should enter.

Preview

Highlights the skipped lines and the header position, shows splitting of the Source columns. Allows you to preview how the options change the data display. You can set columns bounds manually by double-clicking on desired positions in the Preview section. The markers will appear. To remove them, double-click them again. You can move the markers forward or backward to change the column length. The changes are displayed in the Length field of the mapped Target column in the top grid.

Save Template
Click it to save the settings as a template for future uses. For more information, go to the Saving and Using Templates topic.

ExpandedToggleIcon(9x12) See Also

Options, Data Import Wizard

XML Options, Data Import Wizard


Excel Options, Data Import Wizard

Use this wizard page to customize import of Excel files. You can set the following options:

Data location

Sheet
Allows you to specify which sheet of the Source to choose for import. Click the field to select a required sheet from the drop-down list.

Start/End cell
Clear the Detect a range automatically check box to activate the fields. Enter the starting and ending cells to specify Source data range you want to import.

- click this button to specify the Source data range by double-clicking the starting and ending cells in the Preview section. The number of the selected cells will appear in the Start cell and End cell fields and the data range will be highlighted with green in the Preview section.

Detect a range automatically
Clear the check box to specify a data range for import manually. Enter the number of the start cell and end cells in the corresponding fields.

Data in

Rows - select it to import the data in rows. See the result in the Preview section on the Mapping wizard page.

Columns - select it to import the data in columns. See the result in the Preview section on the Mapping wizard page.

Header

No header
Select it if the Source has no header.

First row in a range
Select it to indicate that the header is in the first row of the selected data range.

Position
Select it to set the header position manually. Enter the position of the row or cell that contain the header, it will be highlighted with blue in the Preview section. If you don't specify the header position, the imported columns will get default names - column1, column2, etc.

- click it to specify the header position by double-clicking a required field in the Preview section. The number of the selected field will appear in the Position field and the header will be highlighted with blue.

Preview
Highlights the data range for import and the header position in the Source. Allows you to preview how the options change the data display. You can select the data range for import by clicking the [image] buttons and double-clicking a required start or end cell in the grid. Do the same to indicate the header position.

Save Template
Click it to save the settings as a template for future uses.

ExpandedToggleIcon(9x12) See Also

Data Import Wizard

ODBC Options, Data Import Wizard


XML Options, Data Import Wizard

Use this wizard page to customize import of XML files. You can set the following options:

Encoding
Shows the automatically-detected encoding of the imported file. If the file encoding cannot be detected, dbForge Studio for Oracle sets the current Windows encoding. You can select a required encoding from the drop-down list.

Tag that identifies a table row
Select a tag from the drop-down list to consider as a Source table row during import.

Consider tag attributes as table fields
Select it to consider tag attributes in the Source as table fields, otherwise only the values of the tag selected in the prior field will be considered.

Preview
Shows the Source data.

Save Template
Click it to save the settings as a template for future uses. For more information, go to the Saving and Using Templates topic.

ExpandedToggleIcon(9x12) See Also

Options, Data Import Wizard

Mapping, Data Import Wizard


JSON Options, Data Import Wizard

Use this wizard page to customize import of JSON files. You can set the following options:

Encoding
Shows the automatically-detected encoding of the imported file. If the file encoding cannot be detected, dbForge Studio for Oracle sets the current Windows encoding. You can select a required encoding from the drop-down list.

Preview
Shows the Source data.

Save Template
Click it to save the settings as a template for future uses. For more information, go to the Saving and Using Templates topic.

ExpandedToggleIcon(9x12) See Also

Options, Data Import Wizard

Mapping, Data Import Wizard


CSV Options, Data Import Wizard

Use this wizard page to customize import of CSV files. You can set the following options:

Encoding
Shows the automatically-detected encoding of the imported file. If the file encoding cannot be detected, dbForge Studio for Oracle sets the current Windows encoding. You can select a required encoding from the drop-down list.

Quote
Set a symbol to mark quoted data in Source during import. The default value is double quotes.

Skip lines
Set a quantity of lines to skip during import. For example, if you set 3, dbForge Studio for Oracle will import the data starting from the 4th line. The selected line range will be highlighted with pink in the Preview section.

Header position
Select the line number where the table header is located. The selected line will be highlighted with blue in the Preview section.

Delimiter
Select it if you want to specify a column delimiter. Specify the delimiter type and see the result in the Preview section. The following options are available:

· Tab - will delimit the Source columns by a tab.
· Space - will delimit the Source columns by a space.
· Comma - will delimit the Source columns by a comma.
· Custom - will delimit the Source columns by a custom symbol, which you should enter.

Preview
Highlights the skipped lines and the header position, shows splitting of the Source columns. Allows you to preview how the options change the data display.

Save Template
Click it to save the settings as a template for future uses. For more information, go to the Saving and Using Templates topic.

ExpandedToggleIcon(9x12) See Also

Options, Data Import Wizard

DBF Options, Data Import Wizard


ODBC Options, Data Import Wizard

Use this wizard page to set options for ODBC data source. You can set the following:

Data source specification
Set the ODBC connection first. Select either a system data source name or a user data source name from the drop-down list.

Refresh
Click it to refresh the data sources list.

Use a connection string
Click the Build button to customize a connection string.

Login information
Based on the selected data source name, you should enter a user name and a password.

Test connection
Click this button to ensure your connection is successfully set.

Save Template
Click it to save the settings as a template for future uses.

ExpandedToggleIcon(9x12) See Also

Options, Data Import Wizard

Text Options, Data Import Wizard


DBF Options, Data Import Wizard

Use this wizard page to customize import of DBF files. You can set the following options:

Encoding
Allows you to select the encoding of the Source data. Click the field and select a required encoding from the drop-down list. By default, the current Windows encoding is selected.

Read deleted rows
Select it to preview and import rows marked as deleted in Source.

Preview
Allows you to preview first 50 rows of the Source data. When the Read deleted rows check box is selected, the Preview section will display rows marked as deleted in Source.

Save Template
Click it to save the settings as a template for future uses. For more information, go to the Saving and Using Templates topic.

ExpandedToggleIcon(9x12) See Also

Excel Options, Data Import Wizard

Options, Data Import Wizard


Data Formats, Data Import Wizard

Use this wizard page to set required data formats and column settings for Source data. The page contains the following details:

Common Formats
If it is required, enter required values for data representation in Source data.

Null String
Enter a text representing Null values in the Source records.

Thousand Separator
Enter a character representing a thousand separator in the Source data.

Decimal Separator
Enter a character representing a decimal separator in the Source data.

Boolean
Enter a text representing boolean true and false values in the Source data.

Date and Time
If you want to specify a required date and time format for the Source data, clear the Autodetect Date and Time format check box and enter a format or select it from the drop-down list.

Autodetect Date and Time format
Select it to turn on automatic detecting data and time format of the imported data.

Column Settings
Switch to this tab to set required values for data representation in each Source column. In the left part you will see the list of table columns selected for import and those columns where a default value is not specified. For columns without a default value, you must specify a value that will be inserted during import. Note, for NOT NULL columns with string data type, i.e., Char, Varchar, NChar, NVarchar, an empty string will be set by default.

To specify column settings, select a required column in the left part and enter the following values in the right part:

Null String
Enter a text representing Null values in the Source records of the selected column.

Left Quote
Enter a value to use as a left quote mark in the data of the selected Source column.

Right Quote
Enter a value to use as a right quote mark in the data of the selected Source column.

Date and Time
It is active only for columns with DATE, DATETIME, and TIMESTAMP data types. If you want to specify a required date and time format for records in a separate Source column, enter a format or select it from the drop-down list.

note Note

If a format mask is not set, the program itself will try to identify date and time values.

Save Template
Click it to save the settings as a template for future uses. For more information, go to the Saving and Using Templates topic.

ExpandedToggleIcon(9x12) See Also

Data Import Wizard

Modes, Data Import Wizard


Mapping, Data Import Wizard

Use this wizard page to set a correspondence between the Source data and a Target table.

New column
Allows you to create a new column in a Target table. It is active only when you import data to a new table. Click this button and specify the column properties in the Column Properties dialog box. Click OK to save the changes and see the created column in the top grid.

Delete
Allows you to delete columns in a Target table. It is active only when you import the data to a new table. Select a required column in the top grid and click this button. The column will be removed from the top grid.

Edit
Allows you to edit column properties in a Target table. It is active only when you import the data to a new table. Select a required column in the top grid and click this button. Specify the column properties in the Column Properties dialog box. Click OK to save the changes and see the result in the top grid.

View
It appears if you import the data to an existing table. Click it to view the Target column properties.

Use the arrows to change a column order. They are active only when you import the data to a new table. Select a required column in the top grid and click the arrows to move it up or down.

Fill Mapping
By default, dbForge Studio automatically maps Source and Target columns, but if you clicked Clear Mappings to cancel mapping of all the columns and now want to automatically fill the Target table with the Source columns, click Fill Mapping.

Clear Mappings
Click it to cancel mapping. The columns in the top grid will lose bold highlight, and the Source column fields will contain None values. You should click the fields to select a required Source column from the drop-down list.

note Note

For a new table you can delete all the Target columns and click Fill Mapping. In this case dbForge Studio will automatically create and map the columns taking into account specific Source data types.

Top grid (for the Target table)

Key
Select the Key check box next to a required column with a primary key. If you are importing to an existing table, you can select any of existing key columns (they are marked with the [image] icon). You should select at least one column with a primary key, otherwise some of import modes on the Modes wizard page will be disabled.

note Note

This column is not available while importing to a new table.

Column
Shows the names of the Target table columns. Click any column to view and edit its properties.

Type
Shows the types of the Target table columns. Click any column type to view and edit it.

Source column
Shows the Source columns mapped to the Target columns. If you click Clear Mappings to cancel mapping for all columns, the Source column fields will contain None values. To change mapping, click a Source column field and select a required column from the drop-down list.

Default Value
Enter a value to use as a default value in the selected Source column. All null values in the records of the selected Source column will be replaced with the default value if it is specified.

Preview (for the Source table)

Shows the Source data.

Save Template
Click it to save the settings as a template for future uses.

ExpandedToggleIcon(9x12) See Also

Data Import Wizard

Mapping for Text Data, Data Import Wizard


Mapping for Text Data, Data Import Wizard

Use this wizard page to set a correspondence between the Source data in text format and columns of a Target table.

New column
Allows you to create a new column in a Target table. It is active only when you import data to a new table. Click this button and specify the column properties in the Column Properties dialog box. Click OK to save the changes and see the created column in the top grid.

Delete
Allows you to delete columns in a Target table. It is active only when you import the data to a new table. Select a required column in the top grid and click this button. The column will be removed from the top grid.

Edit
Allows you to edit column properties in a Target table. It is active only when you import the data to a new table. Select a required column in the top grid and click this button. Specify the column properties in the Column Properties dialog box. Click OK to save the changes and see the result in the top grid.

View
It appears if you import the data to an existing table. Click it to view properties of Target columns.

They are active only when you import the data to a new table. Use the arrows to change a column order. Select a required column in the top grid and click arrows to move it up or down.

Fill Mapping
By default, dbForge Studio automatically maps Source and Target columns, but if you clicked Clear Mappings to cancel mapping of all the columns and now want to automatically fill the Target table with the Source columns, click Fill Mapping.

Clear Mappings
Click it to cancel mapping. The columns in the top grid will lose bold highlight, and the Source column fields will contain None value. You should click the fields to select a required Source column from the drop-down list.

Top grid (for the Target table)

Key
Select the Key check box next to a required column with a Primary key. If you are importing to an existing table, you can select any of existing key columns (they are marked with the [image] icon). You should select at least one column with a primary key, otherwise some of import modes on the Modes wizard page will be disabled.

Column
Shows the names of the Target table columns. Click any column to view and edit its properties.

Type
Shows the types of the Target table columns. Click any column type to view and edit it.

Position
Indicates the starting position of the Source table column.

Length
Indicates the length of a Source column. If this Source column is mapped to a Target one, you can click the Length field to see the highlighted Source column range in the bottom grid. To change the column length, enter the value manually or move the markers indicating the column range to the right or left.

Default Value
Enter a value to use as a default value in the selected Source column. All null values in the records of the selected Source column will be replaced with the default value if it is specified.

Map
Use this button to change mapping of Source and Target columns. Select a required Target column in the top grid and click the Unmap button. Click a required Source column in the Preview section to map it to the Target column and click the Map button. Now when you select the Target column in the top grid, the mapped Source column will be highlighted in the Preview section.

Unmap
Click it to change mapping of Source and Target columns. Select a required Target column in the top grid and click the Unmap button.

Preview (for the Source table)

Ruler
Shows ranges of the Source columns with the help of markers. To add a marker, double-click on a required place in the Preview section. To delete the marker, double-click it again. You can move them forward or backward to change the column length. The changes are displayed in the Length and Position fields in the top grid. You can select a range between markers to map it to a Target column by clicking any place between these markers. The range will be highlighted with green.

Save Template
Click it to save the settings as a template for future uses.

ExpandedToggleIcon(9x12) See Also

Data Import Wizard

Data Formats, Data Import Wizard


Modes, Data Import Wizard

Use this wizard page to select how dbForge Studio for Oracle should import the data. You can select the following modes:

Append
Select it to insert records from the Source into the Target table.

Update
Select it to replace records in the Target table with ones from the Source.

Delete
Select it to delete existing records in the Target table that match records in the Source.

note Note

Update, Append/Update, Delete are disabled while importing to a new table.

Repopulate
Select it to delete all the records in the Target table and insert all the records from the Source.

Use a single transaction
Select it to import data as a single transaction, i.e., if any error occurs, all the data imported before this error will be rolled back.

note Note

Note, if you are importing to a new table, only Append mode is available, as it's no need to use other import modes with a new table.

If you are importing to an existing table and did not selected any Target column as one containing a Primary key (to do this, select the Key check box for a column on the Mapping wizard page), some of the import modes will be disabled and the wizard will show a warning.

Use bulk insert
Select this option to reduce the quantity of statements and speed up import. Be careful, this can affect error handling mechanism.

Save Template
Click it to save the settings as a template for future uses. For more information, go to the Saving and Using Templates topic.

ExpandedToggleIcon(9x12) See Also

Data Import Wizard

Output, Data Import Wizard


Output, Data Import Wizard

Select output options to manage the data import script on this page.

Open the data export script in the internal editor
Select the check box to open the data export script in an SQL document. The file name is generated automatically.

Save the script to a file
Select the check box to output your script to a file.

Browse
Click the button to specify the path to save a file.

Open in the internal editor
Select the check box to open the script in dbForge Studio for Oracle. The file name is generated by a user. If not selected, the script will not open.

Execute the script directly against the target database
Select the check box to synchronize the target database immediately without generating a synchronization script.

ExpandedToggleIcon(9x12) See Also

Data Import Wizard

Errors Handling, Data Import Wizard


Errors Handling, Data Import Wizard

Use this wizard page to select how dbForge Studio for Oracle should handle errors during import and whether you want to get a log file with details about the import session.

The page contains the following details:

Errors handling

Prompt a user for an action
Select it to be prompted by dbForge Studio for Oracle in case of any errors. You will be able to ignore the errors and continue importing or cancel the process.

Ignore all errors
Select it to make dbForge Studio for Oracle ignore all errors during import.

Abort at the first error
Select it to cancel import if any error occurs.

Log settings

Write a report to a log file
Select it to get a log file with details about the import session. This will allow you to see the information about the errors appeared during the import session and their causes.

Log file
Click the Browse button and specify the path to the log file or enter it manually.

Save Template
Click it to save the settings as a template for future uses. For more information, go to the Saving and Using Templates topic.

ExpandedToggleIcon(9x12) See Also

Data Import Wizard

Import, Data Import Wizard


Import Progress, Data Import Wizard

See the import progress on this page. To cancel the import, click the Cancel button.

Minimize Application
Click this button to minimize the application and start doing other tasks until the import is finished.

ExpandedToggleIcon(9x12) See Also

Data Import Wizard

Finish, Data Import Wizard


Finish, Data Import Wizard

Use this wizard page to see whether the import completed successfully or failed.

Errors count
Displays the total number of errors.

Warnings
Displays the total number of warnings.

Rows imported
Displays the total number of imported rows.

Show log file
Click the Show log file button to open the log file. This button appears only if you selected Write a report to a log file on the Errors Handling wizard page.

Import more
Allows you to select a new source file and continue importing data.

ExpandedToggleIcon(9x12) See Also

Data Import Wizard

Open MS Access Database Dialog Box


Open MS Access Database Dialog Box

When selected for import MS Access data is password-protected, the Open MS Access database dialog box appears prompting you to enter the password.

Enter a password and click Connect to connect to the source data and move to other wizard's pages.

If you don't want to proceed, click Cancel.

ExpandedToggleIcon(9x12) See Also

Data Import Wizard

Open MS Access Database Dialog Box

© 2004-2016 Devart


Data Report

This section contains detailed description of data reports implementation in dbForge Studio. When studying this section, you will learn how to perform the simplest and the most difficult tasks with data reports.

ExpandedToggleIcon(9x12) In This Section

Report Designer
Describes elements of the designer area.

Report Wizard
Describes Data Report Wizard usage.


Report Designer

This section describes the the elements of Report Designer in dbForge Studio for Oracle.

ExpandedToggleIcon(9x12) In This Section

Data Report Document
Describes user interface elements of blank data report document.

Data Report Document Outline Window
Describes the Document Outline window and its usage.

Data Source Window for Data Reports
Describes the Data Source window and its usage.

CalculatedField Collection Editor Dialog Box
Describes the CalculatedField Collection Editor dialog box and its usage.

Parameter Collection Editor Dialog Box
Describes the Parameter Collection Editor dialog box and its usage.

Toolbox Window
Describes the Toolbox window and its usage.

Group and Sort Window
Describes the Group and Sort window and its usage.

Add Table(s)/View(s)
Describes the Add Table(s)/View(s) window and its usage.

Scripts Errors Window
Describes the Scripts Errors window and its usage.

Relations
Describes the Relations window and its usage.

ExpandedToggleIcon(9x12) See Also

Data Report

Report Wizard


Data Report Document

This topic provides a quick overview of the user interface elements that assist you in the process of creating and customizing reports.

Report Editing Surface
The editing surface becomes available after you switch to the Designer tab in a report tray. (This is the default tab shown after you add a report to your application.) Its user interface includes the following principal elements.

Band Headlines
In the Report Designer, each report band carries a headline, the title, icon and color, which depends on the band kind. These headlines are not printed in the resultant report document and are only visible during design time. You can expand or collapse a band's content at design time, by clicking the triangle at the left of the band's headline. To access the properties of a band, select the band by clicking its headline, and then switch to the Properties window or click the band's smart tag.

Smart tag
With smart tag, report controls and bands are enabled to display context-sensitive information and commands.

Rulers
The horizontal and vertical rulers display tickmarks in the measure units specified for your report. Click an element to evaluate its size and location using the rulers. The horizontal ruler also allows you to modify a report's side margins, by moving the left and right sliders on the ruler. The vertical ruler shows resizing rectangles for every report band, which you can move to change the band height.

Report Tray
This tray is located below the report editing surface and provides the following elements.

Report View Tabs
Allow you to quickly switch between design and preview modes, as well as evaluate scripts in a report.

Designer
Loads the Report Designer, which provides an editing surface to customize the report's layout.

Preview
Loads a print preview that displays a generated report document for evaluating its layout at design time. (Runtime customization of a report, such as the customization provided by handling report events, is not reflected in the design-time preview.)

HTML View
Shows a report document converted to HTML and published on a sample webpage. (A runtime customization of a report, like the one provided by handling report events, is not reflected during the design-time preview.)

Scripts
Opens the script editor, where you can manage and validate report scripts.

Report Status Bar
Displays the name of a selected report or its element, and provides information about its current location and size (for report controls) or paper kind (for a report).

Report Zoom Panel
Allows you to change the current zoom factor value applied to a report's design surface.

Shortcut Menu
This menu provides quick access to the most commonly used actions that depend on the element for which it is invoked. To invoke this menu, right-click a report element or the report editing surface.

ExpandedToggleIcon(9x12) See Also

Report Designer

Data Report Document Outline Window


Data Report Document Outline Window

This topic provides a description of the Document Outline window. To learn more about other report designer elements, refer to the Report Designer topic.

If the Document Outline window is not available among the tool windows, go to the View menu Document Outline.

The Document Outline window provides quick and easy navigation through the report elements. It can be used while building a report to access all report's elements and to see the whole report's structure:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

Created report's structure is displayed as a tree in the Document Outline window. The report elements in the tree are displayed in vertical order corresponding to their vertical position in a report. When you choose a report element in the Document Outline tree, the selected element gets focus in the document area, so that you can edit this element and its properties.

Usually a standard report consists of several report bands with report controls on them. In the tree view of the Document Outline window, corresponding parent nodes contain all child nodes. As the Document Outline shows the report structure, note that there are special rules for report building (for instance, Band objects should contain Control objects, not vice versa). These relations are illustrated on the image above.

If you right-click any item of the Document Outline tree, the shortcut menu for this report element will appear (the same one as in the Document area). Use this menu to perform commonly used functions for a report element.

In the Document Outline tree, you can use elements' drag-and-drop operation between different nodes. This means that items representing report controls can be dragged onto band or panel instances. As a result, the corresponding report control will be moved.

If any controls of the report are data-bound, they will be marked with the yellow database icon. If a pointer hovers over such an item, a tooltip displaying the binding information will be shown:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

The Document Outline window can be moved, resized, docked, or auto-hidden like other tool windows in dbForge Studio.

ExpandedToggleIcon(9x12) See Also

Report Designer

Data Source Window for Data Reports


Data Source Window for Data Reports

The Data Source window displays the schema of the data source currently bound to a report. This window is also used to bind report to data, add tables and/or views to a report, create new or add existing queries, add or edit relations, bind existing report controls to data, and create new bound report controls.

Usually it has the following look:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

To bind report to data, simply drag the needed data source from the Database Explorer window to the Data Source window. After binding a report to data, the structure of the data source will be shown in Data Source.

note Note

You can add one table or view to the Data Source window by selecting the needed table or view in Database Explorer and clicking Send to, Data Report option in the shortcut menu. In this case the table or view will be added to the report data source as a query.

The same will happen if you choose Send to, Chart Designer from the shortcut menu of a table or view in Database Explorer, but in this case the Chart control will be added to the report and Chart Wizard will be opened.

You can use the Data Source window for the following purposes:

Add Table(s)/View(s) Add Table(s)/View(s)
Opens the Add Table(s)/View(s) window to add tables and/or views to the report.

Add an Empty Query Add a Query
Use this option to add an empty query to your report. Click this button to create an empty query.

Open Existing Query Open an Existing Query
Use this option to open an existing query. When you click this button, a dialog window to open a file will appear.

Edit Relations Edit Relations
By clicking this button the Relations window will be opened. Using this window, you can add new relations or edit existing ones.

Refresh Data Refresh Data
Use this option to refresh data in the elements of the Data Source tree. Note that Refresh Data does not refresh elements in Data Source, but only data in them.

Calculated Field Add and Edit Calculated Fields
Through the shortcut menu of any element available in the Data Source window you can add and edit Calculated Fields. Right-click any element in the tree and select the Add Calculated Field option. A calculated field will be added (such fields can be distinguished by the Calculated Field icon in the Data Source element tree).

With the help of calculated fields, you can set a logical or arithmetical expression for the elements of Data Source or an output parameter.

To edit calculated fields, select Edit Calculated Fields... from the shortcut menu. The CalculatedField Collection Editor will appear. In the editor, you can add or remove calculated fields, navigate between them, and edit their properties.

ExpandedToggleIcon(9x12) Expression Editor

To edit an expression in a calculated field, right-click the needed calculated field and select the Edit Expression... option from the shortcut menu. The Expression Editor, shown on the image below, will appear:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

In the editor, you will be able to create or edit the expression of your calculated field.

In Expression Editor you can choose functions, operators, fields, constants, and parameters to add to your expression:

· Functions. If you want to add a function to your expression, select this item in Expression Editor. In the second field of the editor the list of available functions will appear. To add a function to your expression, just double-click it.
To find the needed function faster, you can choose the group it belongs to in the drop-down list above the complete list of functions. There are Date-time, Logical, Math, and String groups available.
In the third field of Expression Editor you can see the description of any function you choose. To learn the description of a function, just click it in the list.
· Operators. If you want to add an operator to your expression, select this item in Expression Editor. In the second field of the editor the list of available operators will appear. To add an operator to your expression, just double-click it.
In the third field of Expression Editor you can see the description of any operator you choose. To learn the description of an operator, just click it in the list.
Also some operators are available as icons below the area where expressions are written.
· Fields. If you want to add a field to your expression, select this item in Expression Editor. In the second field of the editor the list of fields available in the table the calculated field belongs to will appear. To add a field to your expression, just double-click it. To add a data field into the expression field manually, type its name in [square brackets].
In the third field of Expression Editor you can see the type of any field you choose. To learn the type of a field, just click it in the list.
· Constants. If you want to add a constant to your expression, select this item in Expression Editor. In the second field of the editor the list of available constants will appear. To add a constant to your expression, just double-click it.
In the third field of Expression Editor you can see the description of any constant you choose. To learn the description of a constant, just click it in the list.
· Parameters. If you want to add a parameter to your expression, select this item in Expression Editor. In the second field of the editor the list of available parameters will appear. To add a parameter to your expression, just double-click it. To add a parameter to the expression text manually, type its name in [square brackets] with the "Parameters." prefix before it.
In the third field of Expression Editor you can see the type of any parameter you choose. To learn the type of a parameter, just click it in the list.

ExpandedToggleIcon(9x12) Working with Parameters

In dbForge Studio data reports, you can add parameters to the Data Source element tree. Parameters can be used, for example, when building expressions for calculated fields (to learn more about their usage in calculated fields, see the previous paragraph) or bound to report controls.

Adding and Editing Parameters

To add a new parameter, right click on the parameter node icon ( Parameters) in the element tree, and select Add Parameter or Edit Parameters... from the shortcut menu:

· Add Parameter
If you select this option, a new parameter will be added automatically to the Data Source element tree. Its default type is string.
· Edit Parameters...
If you select this option, Parameter Collection Editor will open. Using this editor, you can add new or remove existing parameters with the Add and Remove buttons, and also edit parameter properties. To navigate between parameters, use up and down arrow buttons.

Passing Parameters

Passing a parameter implies assigning a particular value to the Value property of an object, contained in a report's Parameters collection. There are different ways of passing parameters, and your selection depends upon the specifics of your application.

note Note

Note that although you can change the parameter value during report generation, this appears to be a bad report design, since parameters can be used to filter a report's data, as well as in calculated fields and data binding. So, changing report parameters upon report generation may lead to unpredictable results in a report.

In Preview, the Parameters dock panel appears. Its visibility is toggled by the Parameters button on the Preview toolbar.

The Parameters UI prompts an end-user to fill in values for all report parameters the Visible property of which is set to Yes. If a parameter already has any value assigned to its Value property, then this value is used as an initial value to display in the parameter's editor. To help an end-user better understand the purpose of a parameter, you can provide an informative description for it via the Description property.

note Note

The Parameters UI collects all the parameters which should be filled in during generation of the current report. So, if a report contains detail report bands, all their parameters will be also embedded to a single Parameters UI. This means that a parameter will use only one value, if a detail report band is printed several times.

If you have any parameters in your report, when you switch to the preview, a window with parameters will be shown and you will have to enter their values and click Submit. Then only data with these values will be shown.

Note that parameter icon is changed when its type is changed.

Using Parameters

After a parameter was created, added to a report's Parameters collection, and its value was assigned, it can be used in different ways during report generation:

· Filtering
Filtering is one of the most common scenarios of using parameters in a report. The easiest way to filter a report's data according to the current parameter value is to build a report's FilterString using FilterString Editor with this parameter:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.
· Data Binding
You can show a parameter value in a report in the same way as you bind report controls to any standard data fields. Just drag and drop a parameter from the Data Source window, and you'll get a label displaying a parameter value.
· Calculated Fields
Parameters can participate in constructing expressions for calculated fields, as well as standard data fields.

Binding Existing Controls to Fields in Data Source

To bind an existing control to any field available in the data source, drag the needed data field from the Data Source window and drop it onto the report control.

Adding a New Report Control Bound to Data

To add a new report control bound to data, you can use one of the following ways:

· Drag the needed data field from the Data Report window and drop it onto any report band. In the result an appropriate control bound to this data field should appear.
· Right-click a Data Source item, and drag and drop it onto the report designer area. Shortcut menu will appear. Choose the item you need from the list, and the selected control bound to the needed data field will be created and added to the report.

ExpandedToggleIcon(9x12) See Also

Report Designer

CalculatedField Collection Editor Dialog Box


CalculatedField Collection Editor Dialog Box

Use this dialog box to add or remove calculated fields, navigate between them, and edit their properties. To open it, select Edit Calculated Fields... from the shortcut menu.

Members
Lists available calculated fields.

Up Arrow
Click to move the calculated field up in the list.

Down Arrow
Clock to move the calculated filed down in the list.

Add
Click to add a new calculated field.

Remove
Click to remove the calculated filed.

Properties
Lists properties for the selected calculated field.

Categorized
Click to view properties of the calculated field grouped by categories.

Alphabetical
Click to view properties of the calculated field in alphabetical order.

Behavior
Lists the behavior properties of the calculated field.

Scripts
Provides access to an object that contains calculated field-specific scripts to handle its events.

Data
Lists the data properties of the calculated field.

Data Member
Specifies the data member of the calculated field.

Data Source
Specifies the data source, associated with the calculated field.

Expression
Specifies the expression of the calculated field.

Filed Type
Specifies the type of the value returned by the calculated field.

Design
Lists the design properties of the calculated field.

(Name)
Gets or sets the name of the calculated field.

ExpandedToggleIcon(9x12) See Also

Report Designer

Parameter Collection Editor Dialog Box


Parameter Collection Editor Dialog Box

Use this dialog box to add or remove parameters, navigate between them, and edit their properties. To open it, select Edit Parameters... from the shortcut menu.

Members
Lists available parameters.

Up Arrow
Click to move the parameter up in the list.

Down Arrow
Clock to move the parameter down in the list.

Add
Click to add a new parameter.

Remove
Click to remove the parameter.

Properties
Lists properties for the selected parameter.

Categorized
Click to view properties of the parameter grouped by categories.

Alphabetical
Click to view properties of the parameter in alphabetical order.

Behavior
Lists the behavior properties of the parameter.

Visible
Indicates, whether the parameter is visibly displayed or it is hidden.

Data
Lists the data properties of the calculated field.

Description
Specifies the description of the parameter.

Look-Up Settings
Specifies the look-up editor settings of the parameter.

Type
Specifies the parameter's type.

Value
Specifies the parameter's value.

Design
Lists the design properties of the calculated field.

(Name)
Gets or sets the name of the parameter.

ExpandedToggleIcon(9x12) See Also

Report Designer

Toolbox Window


Toolbox Window

This topic provides a description of the Toolbox window.

The Toolbox window contains controls available in dbForge Studio for Oracle data reports.

The Toolbox window can be moved, resized, docked, or auto-hidden like other tool windows in dbForge Studio. If the Toolbox window is not available among the tool windows, in the View menu, click Other Windows, and then select Toolbox click its icon on the Data Report toolbar. The Toolbox window has the following look:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

To add a control to the report, simply drag it from the Toolbox window and drop it onto Designer.

ExpandedToggleIcon(9x12) See Also

Report Designer

Group and Sort Window


Group and Sort Window

This topic provides a description of the Group and Sort window. To learn more about other report designer elements, refer to the Report Designer topic.

With the help of the Group and Sort window you can easily apply grouping and sorting to your report. Using this panel, you don't need to manually add group header and footer bands, invoke their Group Fields editor dialog, create grouping fields and define their properties. With the Group and Sort panel you can do it in several clicks.

The Group and Sort window can be moved, resized, docked, or auto-hidden like other tool windows in dbForge Studio for Oracle. If the Group and Sort window is not available among the tool windows, go to the View, Other Windows, Group and Sort item of the main menu or click its icon on the Data Report toolbar. Usually it has the following look:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

ExpandedToggleIcon(9x12) See Also

Report Designer

Add Table(s)/View(s) Window


Add Table(s)/View(s) Window

You can choose tables and/or views to add to the report here.

To call the Add Table(s)/View(s) window, click Add Table in the Data Source window.

To add a table or a view to the report, just check it, or select it and click RightArrow. To add all tables and views available in the database, click right-arrow-all. To remove tables and/or views, click the left-arrow button.

Clear the Show all objects check box to hide unnecessary objects and show only tables and views available in the selected database.

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

ExpandedToggleIcon(9x12) See Also

Report Designer

Scripts Errors Window


Scripts Errors Window

The Scripts Errors window displays errors discovered during script syntax validation, if any.

To call this window, on the View menu, point to Other Windows, and click Script Errors.

ExpandedToggleIcon(9x12) Scripts Error List Columns

Description
Displays error text.

Line
Displays the line in the document, where the problem occurs.

Column
Shows the column on the indicated line where the problem begins.

ExpandedToggleIcon(9x12) Shortcut Menu Commands of the Scripts Errors Window

Sort Ascending
Sorts data in the ascending order.

Sort Descending
Sorts data in the descending order.

Column Chooser
Calls the Customization window designed for column layout customization.

Best Fit
Fits the size of the selected column to the size of data available in it.

Best Fit (all columns)
Fits the size of each column displayed in the grid to the size of data available in it.

ExpandedToggleIcon(9x12) See Also

Report Designer

Relations


Relations

If you have two or more tables bound to your report, you can establish relations between them. For this the Relations window can be used.

To call the Relations window, click its icon Relations in the Data Source window.

The following image demonstrates how the Relations window looks like:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

ExpandedToggleIcon(9x12) Add Relation

To add a relation, follow such steps:

1. Open the Relations window by clicking the Relations button;
2. Click the Add Relation button. In the field in the left part of the window and in the Name: field you will see the default name of the relation. The default name consists of the FK characters and the names of the parent and child table separated by underscores;
3. In the Name: field specify the name of the relation you want to add. If you want, you can leave the default relation name.
4. Specify the Parent and Child tables of your report;
5. Specify Key Columns and Foreign Key Columns;
6. Click OK.

ExpandedToggleIcon(9x12) Remove Relation

To remove a relation, simply open the Relations window, select the relation you want to remove, and click Remove Relation.

To remove all added relations, click Remove All Relations.

ExpandedToggleIcon(9x12) See Also

Report Designer

Report Wizard


Report Wizard

This section describes the essentials of using Data Report Wizard tool.

ExpandedToggleIcon(9x12) In This Section

Welcome to the Data Report Wizard
Choose the type of the report you are going to create.

Standard Report
This section describes steps to create a standard report using a wizard.

Label Report
This section describes steps to create a label report.

With the Data Report Wizard tool, you can create standard, label or blank reports quickly and easily. To access Data Report Wizard perform either of these actions:

· Click File, point to New, and select the Create Data Report Data Report.
· Click Database, and select Create Data Report Report Designer.
· Click the Create Data Report Design in Report Wizard button on the Data Report toolbar.

note Note

This button is active only if a report was created already.
· Invoke the report's smart tag and click the Design in Report Wizard context link, as shown on the image below.

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

Note that in this case new report is not created and the current one is used. The step of assigning the data source for the report is omitted because the available one is used. So, if your report is not a data-aware one yet, you won't be able to use the Standard Report option of the wizard. Also, the current report layout will be lost after finishing the wizard.

If you choose the Blank Report option, the current report will be replaced by a blank one, so be careful not to lose your data.

· Click the Create Data Report Send Query to Report button on the SQL toolbar.
· Point to Send to, and then click Create Data Report Data Report in the shortcut menu of the Data window or in the shortcut menu of the Data tab of any SQL document.


Welcome to the Data Report Wizard

Welcome page of Data Report Wizard lets you choose the type of the report you are going to create.

Standard Report
Data-aware report based on the specified dataset will be created. You can choose different options concerning report data source, layout, style, etc.

Label Report
Report containing labels of the specified type will be created. Data Report Wizard leads you through a set of steps to customize the layout of your report.

Blank Report
Empty data report will be created. You can create a new report from scratch.

ExpandedToggleIcon(9x12) See Also

Report Wizard

Standard Report


Standard Report

This section describes steps to create a standard report using a wizard.

To create a standard report, invoke Data Report Wizard and select the Standard Report option on the Welcome page.

The Standard Report option allows to create a data-aware report based on the specified dataset. Data Report Wizard leads you through a set of steps that allow you to choose different options concerning report data source, layout, style, etc.

Here is the list of steps you are offered to complete while creating Standard Report with Data Report Wizard:

ExpandedToggleIcon(9x12) In This Section

Select Data Connection
Select data connection and data type to use the report.

Create a Custom Query
Write a custom query for your report to be based on.

Select Table or View
Choose data table or data view to use in the report.

Select Columns
Choose columns to display in the report.

Add Grouping Levels
Specify how the report's data should be grouped.

Summary Options
Specify summary options for numeric fields.

Choose Report Layout
Choose the report layout.

Choose Report Style
Choose the report style.

Enter Report Title
Enter the title of the report.

ExpandedToggleIcon(9x12) See Also

Report Wizard

Label Report


Select Data Connection

Select the data connection which specifies the path to the needed data source and specify the data type you want to use for the report construction here.

On this page you can select one of the available connections from the drop-down list. The data connection specifies how to find and log into a specific server and database.

The following image demonstrates how this step of Data Report Wizard looks like:

Standard Report - Choose Connection

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

Also on this page you can choose the data type for your report construction. There are two data types available:

· Simple Table/View - offers a set of steps to create a standard report based on one table.
· Custom Query - offers an option to create a report based on a custom query.

Click Next to proceed to the next step and select a table or view to present in the report if you've chosen the Simple Table/View option or create a custom query if you've chosen the Custom Query option.

ExpandedToggleIcon(9x12) See Also

Standard Report

Select Table or View


Create a Custom Query

Write a custom query that will be used to define the tables, views, and columns in them to add to your report here.

The custom query should be based on the tables and views available in the databases that you can access using the connection selected earlier. Result set of the created query contains columns which will be available in your report.

The following image demonstrates how this step of Data Report Wizard looks like:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

note Note

You can select only one table or view to be bound to the report. It's impossible to create a master-detail report with this wizard.

You can create a custom query in several ways here:

· Load from a *.sql file using the Load button. After you've selected and opened a file to load a SQL statement from, the statement will appear in the Sql: field of the window.
· You can write a query manually in the Sql: field.
· You can design a query in the Query Builder. To do this, click the Design button and the Query Builder window will appear. After you've created a query, click OK. The query you've just written will appear in the Sql: field of the window.

Click Next to proceed to the next step and select columns to display in the report.

ExpandedToggleIcon(9x12) See Also

Standard Report

Select Columns


Select Table or View

Select a data table or a data view fields of which should be presented in the report here.

On this page you should select one of the available tables or views. The table or view you choose determines the columns that will be available in your report.

Add the needed table or view by clicking the RightArrow button:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

note Note

You can select only one table or view to be bound to the report. It's impossible to create a master-detail report with this wizard.

Click Next to proceed to the next step and select columns to display in the report.

ExpandedToggleIcon(9x12) See Also

Standard Report

Create a Custom Query


Select Columns

Select columns to display in your report here.

Choose one or several columns from the list on the left and place them to the right using arrow buttons, as shown on the image below. Note that your report can display any of the columns available in the dataset.

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

note Note

You can select only one table or view to be bound to the report. It's impossible to create a master-detail report with this wizard.

note Note

On this step, you can click Finish to complete report creation and omit the following steps.

Click Next to proceed to the next step and add grouping levels.

ExpandedToggleIcon(9x12) See Also

Standard Report

Add Grouping Levels


Add Grouping Levels

Specify the way the report's data should be grouped here.

You can use this option to group data in your report. For example, on the image below the report's data, based on the EMPLOYEES table of the sample database HR, will be grouped depending on the hire date of each employee.

In this window, you can select some of the available columns from the list on the left, and click ">" to create a new grouping level against the selected data column. Also you can specify several grouping fields at the same level using the "+>" button. To reorder the created grouping levels, use the up and down arrow buttons.

The following image demonstrates how this step of Data Report Wizard looks like:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

note Note

On this step, you can click Finish to complete report creation and omit the following steps.

Click Next to proceed to the next step and choose the report layout.

ExpandedToggleIcon(9x12) See Also

Standard Report

Summary Options


Summary Options

Specify summary options here.

If you have added grouping levels to your report and some data fields in your report are numeric fields, you will be able to apply summary options to such fields. In the Field Name column the numeric fields names are specified. Check the checkboxes near the field names corresponding to the operations you need to perform with your data. Check the Ignore NULL values checkbox to ignore records with NULL values when performing selected operations.

The following image demonstrates how this step of Data Report Wizard looks like:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

Summary options include:

· Sum - the sum of the data in numeric field;
· Avg - counts the average value;
· Min - defines the smallest value in numeric field;
· Max - defines the biggest value in numeric field;
· Count - counts the number of records in numeric field.

ExpandedToggleIcon(9x12) See Also

Standard Report

Choose Report Layout


Choose Report Layout

Choose the layout of your report here.

On this page you can choose one of the report layout templates. Note that the list of suggested templates depends on whether you added grouping levels to your report or not.

The templates specify the way the selected data fields should be arranged in your report. Click the radio buttons for each template to see the suggested layout in the preview part of the wizard window.

Also you can define the page orientation of your report - Portrait or Landscape. Uncheck or check the checkbox in the bottom of the window to disable or enable adjusting the field width so all fields fit on page.

Refer to the following topics to learn more about the available layouts depending on the grouping levels:

· Ungrouped Report Layout
· Grouped Report Layout

ExpandedToggleIcon(9x12) See Also

Standard Report

Choose Report Style


Choose Ungrouped Report Layout

If you have not added any grouping levels to your report, the layout templates stated on the following image will be suggested:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

note Note

On this step, you can click Finish to complete report creation and omit the following steps.

Click Next to proceed to the next step and choose the report style.

ExpandedToggleIcon(9x12) See Also

Choose Report Layout

Choose Grouped Report Layout


Choose Grouped Report Layout

If you've added any grouping levels to your report, the layout templates stated on the following image will be suggested:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

note Note

On this step, you can click Finish to complete report creation and omit the following steps.

Click Next to proceed to the next step and apply summary options to your report or choose the report style.

ExpandedToggleIcon(9x12) See Also

Choose Report Layout

Choose Report Style


Choose Report Style

Choose the style of your report here.

On this page you can choose one of the predefined styles for your report. They define foreground and background text colors, font options, borders style of the report elements.

The following image demonstrates how this step of Data Report Wizard looks like:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

note Note

On this step, you can click Finish to complete report creation and omit the following steps.

Click Next to proceed to the next step and enter a report title.

ExpandedToggleIcon(9x12) See Also

Standard Report

Enter Report Title


Enter Report Title

Type the header of your report here.

Click Finish to complete the report creation process.

ExpandedToggleIcon(9x12) See Also

Standard Report

Label Report


Label Report

This section describes steps to create a label report.

To create a label report, invoke Data Report Wizard and select the Label Report option on the Welcome page.

The Label Report option allows to create reports containing labels of the specified type. Data Report Wizard leads you through a set of steps to customize the layout of your report.

Here is the list of steps you are offered to complete while creating Label Report with Data Report Wizard:

ExpandedToggleIcon(9x12) In This Section

Select Label Type
Select the label type of the report.

Customize Label Options
Set the layout parameters of the label.

ExpandedToggleIcon(9x12) See Also

Report Wizard


Select Label Type

Select a label type for your report from a number of predefined types here.

Here you can select one of the predefined label types by specifying the product from the Label Products list and its ID from the Product Number drop-down list. The selected type defines the label's size and the page type.

The following image demonstrates how this step of Data Report Wizard looks like:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

Click Next to proceed to the next step and customize label options.

ExpandedToggleIcon(9x12) See Also

Label Report

Customize Label Options


Customize Label Options

Customize the label's options here.

If required, you can set the layout parameters of the label and choose the page size from the Page Size drop-down list.

The following image demonstrates how this step of Data Report Wizard looks like:

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

Click Finish to complete the report creation process.

ExpandedToggleIcon(9x12) See Also

Label Report

Data Report


Database Administration Tools

dbForge Studio for Oracle provides you administrative tools, that allow to perform different database administration tasks.

ExpandedToggleIcon(9x12) In This Section

Session Manager
Describes user interface elements of Session Manager.

Export Utility Wizard
Describes Database Export Wizard fields and options.

Import Utility Wizard
Describes Database Import Wizard fields and options.

Event Monitor Window
Explains how to monitor and send alerts and pipe messages.


Session Manager

Use Session Manager to observe and manipulate sessions.

To call Session Manager, on the Database menu, select session-manager Session Manager.

The main part of the Session Manager is the grid displaying the list of current database sessions. For more information about sessions list see Retrieving Information about Current Sessions.

The rest of the Session Manager is the tabbed window with two tabs: Cursors and Statistics. On the Cursors tab, the cursors list and SQL fragment of the selected cursor is shown. For more information see Using Cursor List. On the Statistics tab the session statistics is a box, where query text is displayed.

ExpandedToggleIcon(9x12) Grid

User Name
Name of the user associated with the session.

Sid
Session identifier.

Serial
Session serial number, used to unambiguously determine a session. In combination with the Sessions ID, it is used to specify the correct session to manipulate with.

Status
Shows whether a user session is active, inactive or killed.

OS User
Operating system username.

Machine
Operating system machine through which the user is connected.

Program
Program you are currently running.

Schema Name
Schema name associated with the user.

SQL Address, SQL Hash Value
Used to identify the SQL statement that is currently being executed.

Logon Time
Shows the start date and time of the session.

Clicking the Refresh button refreshes the information in grid.

ExpandedToggleIcon(9x12) Toolbar

refresh-session Refresh Sessions
Refreshes information about sessions.

disconnect-session Disconnect Session
Disconnects session. The session is not actually terminated until the user tries to execute a database operation, ongoing transactions are allowed to complete before the session is disconnected.

kill-session Kill Session
Disconnects session. Currently running operation will be aborted.

enable-sql-trace Enable SQL Trace
Enables SQL trace for selected session.

disable-sql-trace Disable SQL Trace
Disables SQL trace for selected session.

kill-user-session Kill User Sessions
Disconnects all sessions of the user, whose session was selected in the Session Manager.

full-session-information Full Session Information
Displays additional information about sessions.

customize-column-session Customize Session Columns
Displays Visible Columns dialog box, where you can adjust session information column set and their order. Not available when Full Session Information is on. To show/hide the column select/deselect the corresponding check box left of the column name in the window. To change columns order drag the required column to the desired location. Press OK to apply changes.

Refresh Interval
This numeric up/down control allows you to set the autorefresh time.

ExpandedToggleIcon(9x12) See Also

Database Administration Tools

Export Utility Wizard


Export Utility Wizard

Use the Export Utility Wizard to export database objects from your schemas. To access the Export Utility Wizard, on the Database menu, point to Export & Import, and select Export Utility. Alternatively, in Database Explorer, right-click a schema or connection, point to Export & Import, and select Export Utility from the shortcut menu. Wizard's pages are listed below.

Export Mode, Export Utility Wizard
Choose what data to export on this page.

Export Tables, Export Utility Wizard
Choose tables to export on this page. This page is available if you have chosen Table on the Export mode page.

Additional Query, Export Utility Wizard
Input where clause here to select a subset of rows from a set of tables when doing a table mode export.

Export Users, Export Utility Wizard
Choose users to export their data on this page. This page is available if you have chosen User on the Export mode page.

Export Tablespaces, Export Utility Wizard
Choose tablespaces to export on this page. This page is available if you have chosen Tablespace on the Export mode page.

Export Objects and Settings, Export Utility Wizard
Select additional database objects to export and settings on this page.

File Paths, Export Utility Wizard
Choose output files on this page.

Export Process, Export Utility Wizard
This page is displayed during export process.

Export Complete, Export Utility Wizard
You can see export result on this page.


Export Mode, Export Utility Wizard

Choose information to export on this page.

Table
You can choose what tables to export.

User
Export data of selected user or users. You must have the EXP_FULL_DATABASE role enabled to export data from another users.

Full
Export entire database. You must have enough privileges to use this mode.

Tablespace
Export selected tablespaces. You must have enough privileges to use this mode.

ExpandedToggleIcon(9x12) See Also

Export Utility Wizard

Export Tables, Export Utility Wizard


Export Tables, Export Utility Wizard

Select tables to export on this page. This page is available if you have chosen Table on the Export Mode page.

Available tables
Check tables here to export them.

Selected tables
Selected tables to export are listed here. You can remove them from this list by double-clicking them.

DoubleRight
Moves all available tables to the Selected tables list.

RightArrow
Moves available tables that are highlighted in the Available tables to the Selected tables list.

LeftArrow
Removes the highlighted item from the Selected tables list.

DoubleLeft
Clears the table selection.

Show all tables
Shows tables of all users if selected. Otherwise shows only tables of current user.

Additional query
You can specify a query to filter the data rows from the exported tables. To do it, click this button and input the query in the Additional query dialog.

ExpandedToggleIcon(9x12) See Also

Export Utility Wizard

Additional Query, Export Utility Wizard


Additional Query, Export Utility Wizard

Input a condition here. This condition allows you to select a subset of rows from a set of tables when doing a table mode export. The condition must be a where clause for SQL statement. The query is applied to all tables, so it must be applicable to all tables. That means, the query "SELECT * FROM <table_name>" must be valid with this WHERE condition added for every exported table. It cannot be specified for tables with inner nested tables.

For example, if you want to export data from the table "emp", containing only salesmen, the condition should be the following: "WHERE JOB = 'SALESMAN'".

If you want to export the data from both emp and dept tables for the SALES department, the following condition may be used: "WHERE DEPTNO = (SELECT DEPTNO FROM DEPT WHERE DNAME = 'SALES')". Both tables have DEPTNO column, so the condition will be applicable to both tables.

ExpandedToggleIcon(9x12) See Also

Export Utility Wizard

Export Users, Export Utility Wizard


Export Users, Export Utility Wizard

Select users to export on this page. This page is available if you have chosen User on the Export Mode page.

Available users
Check users here to export their data.

Selected users
Selected users to export their data are listed here. You can remove them from this list by double-clicking them.

DoubleRight
Moves all available users to the Selected users list.

RightArrow
Moves available users that are highlighted in the Available users to the Selected users list.

LeftArrow
Removes the highlighted item from the Selected users list.

DoubleLeft
Clears the user selection.

ExpandedToggleIcon(9x12) See Also

Export Utility Wizard

Export Tablespaces, Export Utility Wizard


Export Tablespaces, Export Utility Wizard

Select tablespaces to export on this page. This page is available if you have chosen Tablespace on the Export Mode page.

Available tablespaces
Check tablespaces here to export.

Tablespaces to export
Selected tablespaces to export are listed here. You can remove them from this list by double-clicking them.

DoubleRight
Moves all available tablespaces to the Selected tablespaces list.

RightArrow
Moves available tablespaces that are highlighted in the Available tablespaces to the Tablespaces to export list.

LeftArrow
Removes the highlighted item from the Tablespaces to export list.

DoubleLeft
Clears the tablespace selection.

Make tablespaces online and read only
If selected, the wizard will make exporting tablespaces ONLINE and READ ONLY.

note Note

To be exported, tablespaces must be ONLINE and READ ONLY. Using this check box you can make selected tablespaces online and read only. If you need to restore tablespace status, you should do it manually after copying the .dbf files.

ExpandedToggleIcon(9x12) See Also

Export Utility Wizard

Export Objects and Settings, Export Utility Wizard


Export Objects and Settings, Export Utility Wizard

Select additional database objects to export and settings on this page.

ExpandedToggleIcon(9x12) Additional objects to export

Table rows
Specifies whether to export table rows.

Constraints
Specifies whether to export constraints.

Indexes
Specifies whether to export indexes.

Triggers
Specifies whether to export triggers.

Grants
Specifies whether to export grants.

ExpandedToggleIcon(9x12) Settings

Compress
Specifies how export manage the initial extent for table data. If selected the data will be placed to one initial extent when they would be imported.

Consistent
When selected, SET TRANSACTION READ ONLY statement will be executed to ensure that the data seen by Export is consistent.

Direct
When selected, the data will be extracted directly, bypassing the SQL Command Processing layer (evaluating buffer). Direct export can be much faster.
Direct option cannot be used with using additional query. If you have set additional query on the Export Tables page, this option will be unavailable.
You must have the same language, territory and charset settings on both server and client sides for using Direct option.

ExpandedToggleIcon(9x12) See Also

Export Utility Wizard

File Paths, Export Utility Wizard


File Paths, Export Utility Wizard

Choose locations of output file and configuration file on this page.

Output dump file
Choose result dump file location here.

Parameter file
Choose parameter file location here. A new parameter file will be created. You can use it later for making export with Oracle Export utility from the command line.

ExpandedToggleIcon(9x12) See Also

Export Utility Wizard

Export Process, Export Utility Wizard


Export Process, Export Utility Wizard

This page is displayed during export process. You can see export process in the Output window. To cancel export, click the Cancel button.

ExpandedToggleIcon(9x12) See Also

Export Utility Wizard

Export Complete, Export Utility Wizard


Export Complete, Export Utility Wizard

You can see export result on this page. If you want to view export log, select corresponding check box. If export utility have not started, the log will not be created. You can not view log in that case.

ExpandedToggleIcon(9x12) See Also

Export Utility Wizard

Import Utility Wizard


Import Utility Wizard

Use the Import Utility Wizard to import data. To access the Import Utility Wizard, on the Database menu, point to Export & Import, and select Import Utility. Alternatively, in the Database Explorer, right-click a schema or connection, point to Export & Import, and select Import Utility from the shortcut menu. Wizard's pages are listed below.

File Paths, Import Utility Wizard
Choose export files on this page.

Import Mode, Import Utility Wizard
Choose import mode on this page.

Import Tables, Import Utility Wizard
Choose what tables to import on this page.

Select Tables, Import Utility Wizard
Manually select what to import from list of existing tables on this page. This page is available if you have chosen Table on the Import mode page.

Import Users, Import Utility Wizard
Select owners of the exported tables and schemas to import data to on this page. This page is available if you have chosen User on the Import mode page.

Import Whole File, Import Utility Wizard
Set some options for whole file importing on this page. This page is available if you have chosen Full on the Import mode page.

Import Tablespaces, Import Utility Wizard
Select tablespaces to import and their datafiles on this page. This page is available if you have chosen Tablespace on the Import mode page.

Select Users, Import Utility Wizard
Choose schema for tablespace import on this page. This page is available if you have chosen Tablespace on the Import mode page and selected Select from available on Import tablespaces page.

Import Options, Import Utility Wizard
Set data to import and import options on this page. This page is not available if you have chosen Tablespace on the Import mode page.

Import Process, Import Utility Wizard
This page is displayed during import process.

Import Complete, Import Utility Wizard
You can see import result on this page.


File Paths, Import Utility Wizard

Choose file paths on this page.

Export dump file
Choose result dump file location here.

Parameter file
Choose configuration file location here. A new configuration file will be created. You can use it later for making import with Oracle Import utility from the command line.

Index file
Choose index file location here. This is an optional field. Not used in Tablespace import mode. If you set an index file, index-creation commands for the requested mode will be extracted and written to the specified file, rather than used to create indexes in the database. No database objects will be imported. Tablespace import mode will not be available.

ExpandedToggleIcon(9x12) See Also

Import Utility Wizard

Import Mode, Import Utility Wizard


Import Mode, Import Utility Wizard

Choose information to import on this page.

Table
You can choose what tables to import.

User
Import data of selected user or users.

Full
Import all data in the dump file.

Tablespace
Imports data of selected tablespaces. You must have enough privileges to use this mode.

ExpandedToggleIcon(9x12) See Also

Import Utility Wizard

Import Tables, Import Utility Wizard


Import Tables, Import Utility Wizard

Select what to import from list of existing tables on this page. This page is available only if you have chosen Table on the Import Mode page.

Import method
Choose what tables to import.

All tables
Import all tables from file.

Existing tables
Manually select what to import from list of existing tables.

Manually entered tables
Enter table names manually.

Table list
Enter table names separated by commas manually here.

From user
Only selected owner's data will be imported from file.

To user
Select schema to import tables to. This field is used only with conjunction with From user field. If you leave To user field empty, the data will be imported:

· to the From user schema, if the export file is a full dump or a multischema, user-mode export dump file,
· to the importer's schema (regardless of the From user field) if the export file is a single-schema, user-mode export dump file created by an unprivileged user.

ExpandedToggleIcon(9x12) See Also

Import Utility Wizard

Select Tables, Import Utility Wizard


Select Tables, Import Utility Wizard

Select tables to import on this page.

Available tables
Check tables here to import the tables with the same names from the dump file.

Selected tables
Selected tables to import are listed here. You can remove them from this list by double-clicking them.

DoubleRight
Moves all available tables to the Selected tables list.

RightArrow
Moves available tables that are highlighted in the Available tables to the Selected tables list.

LeftArrow
Removes the highlighted item from the Selected tables list.

DoubleLeft
Clears the table selection.

Show all tables
Shows tables of all users if selected. Otherwise shows only tables of current user.

note Note

This page allows to choose names of the tables that will be imported. Table owner doesn't matter on this page. Source and target schemas should be selected on the previous page of the wizard.

ExpandedToggleIcon(9x12) See Also

Import Utility Wizard

Import Users, Import Utility Wizard


Import Users, Import Utility Wizard

Select owners of the exported tables in the From user fields and schemas to import data to in the To user fields on this page. This page is available only if you have chosen User on the Import Mode page.

ExpandedToggleIcon(9x12) See Also

Import Utility Wizard

Import Whole File, Import Utility Wizard


Import Whole File, Import Utility Wizard

Set some import options for the whole database import on this page. The page is available only if you have chosen Full on the Import Mode page.

ExpandedToggleIcon(9x12) User to import to

Original schema or Current schema
Data will be imported to original schema (current schema for SYSDBA).

Specify
Manually specify schema to import data to.

ExpandedToggleIcon(9x12) Incremental import

None
No incremental import is used.

System
Import the most recent version of system objects. It imports system objects such as foreign function libraries and object type definitions, but does not import user data or objects.

Restore
Imports all user database objects and data contained in the export file, excluding system objects.

ExpandedToggleIcon(9x12) See Also

Import Utility Wizard

Import Tablespaces, Import Utility Wizard


Import Tablespaces, Import Utility Wizard

Select tablespaces to import and their datafiles on this page. The page is available only if you have chosen Tablespace on the Import Mode page.

Tablespace data files
List of datafiles of importing tablespaces.

Add
Add files to list.

Remove
Remove selected files from list.

Clear
Clear the list.

Tablespaces for import
List tablespaces to import, separated by commas, here.

Tablespaces owners
List tablespaces owners, separated by commas, here. Use this parameter to list the users who own the data in the transportable tablespace set.

Select from available
Select owners from owners list manually.

ExpandedToggleIcon(9x12) See Also

Import Utility Wizard

Select Users, Import Utility Wizard


Select Users, Import Utility Wizard

Select tablespaces' owners on this page. This page is available if you have chosen Tablespace on the Import Mode page and selected Select from available check box on the Import Tablespaces page.

Available users
Check users here to move them to Selected users list.

Selected users
The users who own the data in the transportable tablespace set are listed here. You can remove them from this list by double-clicking them.

DoubleRight
Moves all available users to the Selected users list.

RightArrow
Moves available users that are highlighted in the Available users to the Selected users list.

LeftArrow
Removes the highlighted item from the Selected users list.

DoubleLeft
Clears the user selection.

ExpandedToggleIcon(9x12) See Also

Import Utility Wizard

Import Options, Import Utility Wizard


Import Options, Import Utility Wizard

Set additional objects and options for import on this page.

ExpandedToggleIcon(9x12) Additional objects to import

Table data rows
Specifies whether to import table data.

Constraints
Specifies whether to import constraints.

Table indexes
Specifies whether to import table indexes.

Grants
Specifies whether to import grants.

ExpandedToggleIcon(9x12) Settings

Reuse existing data files
Specifies whether or not the existing data files making up the database should be reused.

Commit after each array insert
Specifies whether to commit after each array insert. By default, Import commits only after loading each table

Ignore creation errors
If selected, Import continues without reporting the object creation errors.

Only show the file contents
If selected, content of the export file is listed to the Output window and not imported to database.

ExpandedToggleIcon(9x12) See Also

Import Utility Wizard

Import Process, Import Utility Wizard


Import Process, Import Utility Wizard

This page is displayed during import process. You can see import process in the Output window. To cancel import, click Cancel.

ExpandedToggleIcon(9x12) See Also

Import Utility Wizard

Import Complete, Import Utility Wizard


Import Complete, Import Utility Wizard

You can see import result on this page. If you want to view import log, select corresponding check box. If import utility have not started, the log will not be created. You can not view log in that case.

ExpandedToggleIcon(9x12) See Also

Import Utility Wizard

Event Monitor Window


Event Monitor Window

Use Event Monitor to send and receive alerts and pipe messages.

To call Event Monitor, select Event Monitor from the Database menu.

The main part of the Event Monitor is the window displaying the messages the users exchanged with. The options of these messages can be set in the following fields.

Connection
Select the needed connection from the drop down list.

Event Type
Use this field to select the type of the message to send.

Name
Specify the name of the alert or a pipe in this field.

Message
Input the message to be sent there.

Event monitor has following toolbar buttons.

Send message
Sends alert or pipe message with the text that is in Message box.

Start/Stop listening to alerts
Starts or stops listening to alerts.

Refresh. Get message
Receives alerts you are subscribed for or receives one pipe message you are subscribed for.

Clear report text
Clears report text with received alerts and messages.

ExpandedToggleIcon(9x12) See Also

Database Administration Tools


Database Connection

This section describes Data Connection user interface elements.

note Note

Database Explorer is available only in dbForge Studio for Oracle.

ExpandedToggleIcon(9x12) In This Section

Database Connection Properties Dialog Box
Information about connection parameters.

Connect to Oracle Server Dialog Box
The topic helps you to connect to the server without having specified a password.

Connection Manager Dialog Box
The topic helps you to create, edit, and delete database connections.

Connect to Server Dialog Box
The topic helps you to connect to the server when the Database Explorer window is not activated.


Database Connection Properties Dialog Box

Use this dialog box to setup or change database connection parameters. To access it, do either of the following:

· Click New Connection on the Start Page.
· On the Database menu, select New Connection.
· On the Database Explorer toolbar, click the New Connection button.
· Right-click anywhere on the Database Explorer window, and select New Connection... from the shortcut menu.

note Note

Database Explorer is available only in dbForge Studio for Oracle.

The dialog box includes the following tabs:

General, Database Connection Properties Dialog Box
You can set login information required to connect to the Oracle Server here.

Advanced, Database Connection Properties Dialog Box
You can set additional options to tune and better manage database connections here.

ExpandedToggleIcon(9x12) See Also

Database Connection

Connect to Oracle Server Dialog Box


General, Database Connection Properties Dialog Box

Use the General tab of the Database Connection Properties dialog box to enter the following parameters to establish the connection to the Oracle Server:

Connection Type
Select an appropriate connection type from the drop-down list. Three connection types are available when connecting to an instance of the Database Engine.

TNS (Transparent Network Substrate)
Select to connect the the Oracle server via TNS.

TNS using OS Authentication
Select to connect to the Oracle Server via TNS using OS Authentication.

Direct
Select to connect to the Oracle server by the direct mode.

Host
The name or IP address of the Oracle Server host to which to connect. Direct mode only.

Port
Specify Oracle Server connection port; default value is 1521. Direct mode only.

Server
Set the name of the Oracle database to which to connect. Not available in the direct mode.

Service Name
Specify an alias to an Oracle database instance (or many instances). Direct mode only.

SID
Specify a unique name for an Oracle database instance. Direct mode only.

note Note

The Service Name parameter can be used instead of SID.

User
The name of the user account on the Oracle server. The default Oracle user is 'scott'. Not available for connecting via TNS using OS Authentication.

Password
The password of the user account on the Oracle Server. Not available for connecting via TNS using OS Authentication.

Allow saving password
Select to save the password among the other connection parameters.

Connect as
Specify how you want to connect to the Oracle server. This parameter is set to 'Normal' by default. Alternatively, you can select administrative privileges available in dbForge Studio for Oracle, such as: SYSDBA, SYSOPER, SYSBACKUP, SYSDG, SYSKM.

Home
Select an Oracle client to be used. Not available in the direct mode.

Show All Objects
If checked (by default), you will see in the Database Explorer all databases available on the Oracle Server. The database you select from the list will be considered as default. If this option is unchecked, you will see only the default database.

Connection name
Enter a user-friendly connection name. If you do not specify the name, it is auto-generated as: [user]@[host]:[service name] or [user]@[server].

Document Category
You can assign a category for a document to associate it with a specific connection.

Test connection
Click this button to verify that you have correctly specified all required parameters and a connection can be established.

ExpandedToggleIcon(9x12) See Also

Database Connection Properties Dialog Box

Advanced, Database Connection Properties Dialog Box


Advanced, Database Connection Properties Dialog Box

dbForge Studio for Oracle offers a number of useful features to tune and better manage database connections.

Group objects by schema
Select to view database objects grouped by schema.

Enable DBMS output
If selected DBMS output messages will be shown in the Output window.

Buffer size
Set DBMS output buffer size.

Connection timeout
You can specify the required time period after which dbForge Studio for Oracle stops its attempts to get response from the Oracle Server to open a connection. Zero means to wait infinitively. Direct mode only.

Execute timeout
You can specify the required time period after which dbForge Studio for Oracle stops its attempts to execute a query. Zero means to wait infinitively. Direct mode only.

Show PL/SQL compilation warnings
If selected PL/SQL compilation warnings are displayed in the Error List.

Use unicode
Select to use the UTF16 standard charset.

ExpandedToggleIcon(9x12) See Also

Database Connection Properties Dialog Box

Connect to Oracle Server Dialog Box


Connect to Oracle Server Dialog Box

Opens when you connect to the server without having specified a password.

Host
The host name of the Oracle Server. This option is available if the Direct connection mode is selected.

Home
Location to the Oracle client to be used for the connection. This option is available if the connection is established via Oracle Call Interface or an Instant Client.

Connect as
Specifies how you connect to the Oracle server: usually ('Normal') or with administrative privileges ('SYSDBA' and 'SYSOPER').

Oracle login

User
The Oracle login account.

Password
The password for the Oracle login account.

ExpandedToggleIcon(9x12) See Also

Database Connection Properties Dialog Box

Connection Manager Dialog Box


Connection Manager Dialog Box

Connection Manager dialog box allows you to create, edit, and delete database connections.

ExpandedToggleIcon(9x12) Dialog Box Controls

Dialog box contains the following controls:

Connections
The list of the existing database server connections.

New
Click to open Database Connection Properties dialog box for creating a new connection.

Edit
Click to open Database Connection Properties dialog box for editing a connection.

Delete
Click to delete the connection.

Connection String
Displays connection parameters for the selected connection.

ExpandedToggleIcon(9x12) See Also

Database Connection Properties Dialog Box

Connect to Server Dialog Box


Connect to Server Dialog Box

This dialog allows you to establish a connection to a server. To The dialog displays connections' server, user and name.

ExpandedToggleIcon(9x12) Dialog Box Controls

Dialog box contains the following controls:

Connections
The list of the existing database server connections.

Connect
Click this button to establish a connection to the selected server.

New Connection
Click this button to create a new connection using the Database Connection Properties dialog box.

ExpandedToggleIcon(9x12) See Also

Database Connection Properties Dialog Box

Database Connection


Database Designer

This section contains information on Database Designer user interface elements.

ExpandedToggleIcon(9x12) In This Section

Diagram Document
Describes elements available on diagram document.

Diagram Shapes
Describes interface elements of diagram shapes.

Diagram Overview Window
Describes the Diagram Overview window.

Virtual Relation Properties Dialog Box
Describes properties of the Virtual Relation Properties dialog box.

Virtual Relation Manager Window
Describes how to manage virtual relations using this window.

Create New Unique Index Message
Describes how to answer the prompt to add a unique index to a referencing table.

Hyperlink Properties Dialog Box
Describes properties of added hyperlinks.


Diagram Document

Diagram document is used to manage database diagrams. You can view and add different objects, foreign keys, and call editors to modify them. The saved diagram document has the '*.dbd' extension.

Database diagram document interface elements are listed below.

Diagram toolbar

new-selection New Selection
Enables to manage diagram elements.

New Table
Enables to create a new table on a diagram. Tables are displayed on the diagram as blue rectangular shapes.

view New View
Enables to create a new view on a diagram. Views are displayed on the diagram as green rectangular shapes.

procedure New Procedure
Enables to create a new procedure on a diagram. Procedures are displayed on the diagram as green rectangular shapes.

function New Function
Enables to create a new function on a diagram. Functions are displayed on the diagram as violet rectangular shapes.

new-relation New Relation
Enables to create a new relation between diagram elements.

virtual-relation New Virtual Relation
Enables to create a new virtual relation between diagram elements.

container New Container
Enables to create a new container on a diagram. Containers are displayed on the diagram as orange rectangular shapes. You can place various diagram objects onto the container.

note-shape New Note
Enables to create a new note on a diagram. Notes on the diagram contain additional information.

stamp New Stamp
Enables to create a new stamp on a diagram. On the stamp, you can specify essential information about the diagram (e.g. date, company name, author, etc.)

New Image
Images can be added to the diagram from external sources.

show-comments Show Comments
Shows diagram elements' comments.

vr-manager Virtual Relation Manager
Opens Virtual Relation Manager.

refresh-btn Refresh
Refreshes data of a diagram document.

stop-refresh Stop Refresh
Stops refreshing data.

Diagram shortcut menu

New
Point to New to create any diagram object: table, view, procedure, function, etc.

Zoom
Zoom your diagram in or out.

preserve-routing Preserve Routing
Select it to preserve the routing of relation links on the diagram.

layout-diagram Layout Diagram
The application adjusts diagram layout as it considers best.

Export to Image
Saves your diagram as an image.

Select All
Selects all shapes on the diagram.

Synchronize Document Outline
Synchronizes Document Outline tree with diagram objects.

Options
Calls Options window to specify diagram options.

ExpandedToggleIcon(9x12) See Also

Database Designer


Diagram Shapes

Diagram may contain different kinds of shapes. They are database object shapes, containers, notes, and stamp. Most shapes have caption with shape name and the collapse button, that allows collapsing and restoring shapes. When you select a shapes, the size handles (small squares at the shape edges) are displayed. You may use size handles to change the shape size. Some shapes have eight size handles, allowing you to change both height and width of the shape, and some shapes have only two size handles, allowing you to change only width of the shape.

ExpandedToggleIcon(9x12) In This Section

Table Shapes
The topic describes table shapes.

Relations
The topic describes foreign key relations.

Database Object Shapes

Diagram displays the following database objects as shapes:

· Tables
· Views
· Stored procedures
· Stored functions

View shapes are light green dotted rounded rectangles. They consist of the caption and the list of columns.

note Note

Nullable view columns have grey color, and non-nullable view columns have black color in the column list.

Stored procedures are displayed as pink colored rounded rectangles with caption and parameter list. Stored functions are rectangles with caption and parameter list having light purple color.

View and stored routine shapes have only two size handles. Only their width can be resized.

Note that selected skin affect shape colors.

Containers

Containers are large rounded rectangles with caption. They can contain any other shapes including other containers.

Notes

Notes are just yellow rectangles with text that you can edit. They don't have caption or other user interface elements.

Stamp

Stamp is a rounded rectangle with several changeable fields. You can change any field value by double-clicking the field and entering the needed value.

ExpandedToggleIcon(9x12) See Also

Database Designer

Diagram Shapes

© 2004-2016 Devart


Table Shapes

Table shape represents database table on a diagram. Table shape is rectangular if its primary key does not contain foreign key columns. Otherwise table shape is a rounded rectangle. It consists of the following parts:

Caption
Table name with the collapse button, allowing you to collapse and expand table shape.

Column list
Contains table columns. By default column list consists of two parts, separated with a horizontal line - the first part contains primary key columns, and the second part contains other columns. You can turn this separation off in the Notation Options.

note Note

Nullable table columns have grey color, and non-nullable table columns have black color in the column list.

The icons near the column name have the following meaning:

FK - Foreign key column.

PK - Primary key column.

PKFK - This column belongs to both primary and foreign key.

Compartments
There are some expandable compartments with table indexes, constraints, and triggers (if the table has any) below the column list. You may disable their display in the diagram options. You may expand and collapse these compartments with + and - buttons correspondingly.

ExpandedToggleIcon(9x12) See Also

Table Shapes

Database Designer


Relations

Foreign key relations are displayed as lines connecting tables. Their appearance depends on the selected notation and relation cardinality.

ExpandedToggleIcon(9x12) See Also

Diagram Shapes

Database Designer


Diagram Overview Window

Use this window to get a better overview of large diagrams while working with them. You can quickly zoom in and out the diagram to see where the required diagram items are, move to them, and grasp the whole picture.

To open the Diagram Overview window, click the [image] Diagram Overview icon on the Diagram toolbar, or, in the View menu, click Other Windows, and then click Diagram Overview. Alternatively, you can use the Ctrl+W,V hot key combination to call this window.By default, the window will be docked to the right corner of dbForge Studio, but you can move or dock it the same way as you do with other windows in dbForge Studio.

The Diagram Overview window has a blue selection box that highlights the area currently displayed on the diagram. Use this box to move to a required item on the diagram. To move in a strictly horizontal or vertical direction, move the blue selection box holding down the Shift key. You can re-size the box to change the zooming level on the diagram.

To zoom in and out the diagram, you can hold down the Ctrl key and roll the mouse wheel forward to zoom in the diagram or backward to zoom out.

ExpandedToggleIcon(9x12) See Also

Database Designer


Virtual Relation Properties Dialog Box

The Virtual Relation Properties dialog box contains the same properties as the Foreign Key Properties dialog box does.

The difference between these two dialog boxes is that the Foreign Key Properties dialog box contains properties of a physically existing foreign key and the Virtual Relation Properties dialog box contains properties of a virtual relation that can be converted into a physical foreign key.

ExpandedToggleIcon(9x12) See Also

Database Designer


Virtual Relation Manager Window

Use this window to view, edit, remove virtual relations, generate their DDL, convert to Foreign keys, etc.

To open the Virtual Relation Manager window, click the Virtual Relation Manager icon on the toolbar or point to Other Windows on the View menu, and click Virtual Relation Manager. The window contains the following virtual relation details:

Name
The name of the foreign key.

Table
The name of the referencing table.

Columns
The name of the referencing column(s).

Referenced Table
The name of the referenced table.

Referenced Columns
The name of the referenced column(s).

Delete Rule
The selected action that must happen on a row deletion. It can be Cascade, No Action, Set Null, or Restrict.

Update Rule
The selected action that must happen on a row update. It can be Cascade, No Action, Set Null, or Restrict.

To edit the virtual relation properties, do either of these actions:

· Double-click the required relation in the grid.
· Select the required relation in the grid and click the Edit Virtual Relation icon on the toolbar.

The Virtual Relation Properties dialog box will appear where you can edit the properties. It is the same as Foreign Key Properties dialog box.

To delete the virtual relation, do either of these actions:

· Select the required relation in the grid and click Remove from the Diagram icon on the toolbar.
· Right-click the required relation in the grid and select Remove from Diagram in the menu.

To convert a virtual relation to a foreign key, do either of these actions:

· Select the required relation in the grid and click the Convert to Foreign Key icon on the toolbar.
· Right-click the required relation in the grid and select Convert to Foreign Key in the menu. Click Yes in the appeared dialog box.

Note, to create a foreign key, the referenced table should have a unique index, otherwise dbForge Studio will prompt you to create it. Click Yes in the appeared dialog and the unique index will be added. For more information go to Create New Unique Index Message topic.

To generate schema script for a virtual relation, do either of these actions:

· Select the required relation in the grid and click the Generate Schema Script icon on the toolbar.
· Right-click the required relation in the grid and select Generate Schema Script in the menu.

The SQL document will open with the generated script. You can save it or execute immediately.

To group virtual relations, click the following icons:

GroupByTable - to group by a table

GroupByRefTable - to group by a referenced table

ExpandedToggleIcon(9x12) See Also

Database Designer


Create New Unique Index Message

Yes
Click it to automatically create a unique index in a referencing table. If dbForge Studio fails to create a unique index due to some error, you should change foreign key properties (or properties of a virtual relation if you are converting it into a foreign key) and try again.

No
Click it if you don't need to add a unique index. Note, in this case dbForge Studio will fail to create a foreign key. You should manually create a unique index and try creating again.

Don't show this message again
If you select this check box, next time during creating a foreign key, if a referencing table has no unique index, a new one will be added automatically without any notification.

Help
Click it to see quick information of this topic.

ExpandedToggleIcon(9x12) See Also

Database Designer


Hyperlink Properties Dialog Box

Use this dialog box to edit the hyperlink properties. To open it, right-click a note and select Hyperlink from the menu. In the dialog box you can specify the following details:

Specify the file path or URL
Enter a path or URL to a file location to create a link to it. Click the Browse button to select the path in the Open window. To delete a hyperlink from the note, clear this field.

Specify the link description
By default the link description is created based on the file name, but you can enter a required name. It will be displayed under the note text and you can click on it to open in dbForge Studio.

ExpandedToggleIcon(9x12) See Also

Database Designer


Database Explorer

This section describes Database Explorer user interface elements.

ExpandedToggleIcon(9x12) In This Section

Duplicate Object Dialog Box
This topic describes the Duplicate Object dialog box.

Filter Settings Dialog Box
Describes the Filter Settings dialog box

Enable Triggers Dialog Box
Describes the Enable Triggers dialog box.

Disable Triggers Dialog Box
Describes the Disable Triggers dialog box.

Enable Constraints Dialog Box
Describes Enable Constraints dialog box.

Disable Constraints Dialog Box
Describes Disable Constraints dialog box.

Compile Dialog Box
Describes the Compile dialog box

Object Viewer
Describes the Object Viewer window, which displays information about database object selected in Database Explorer.

Database Explorer Window
Information on Database Explorer window and how to access it.

Node Icons
Lists icons you can see in Database Explorer and explains their meaning.

Database Explorer Shortcut Keys
Describes shortcut keys that can be used when working with Database Explorer.

Database Explorer Nodes' Properties
Describes meaning of properties of the Database Explorer nodes for each type of node.


Duplicate Object Dialog Box

Use the Duplicate Object dialog to make an exact copy of a database object in the same or another database of the same server. To open the dialog, right-click a required object in the Database Explorer and select Duplicate Object from the menu.

Destination database
Select a destination database to create a copy of an object. The drop-down list contains all the schemas available on the server.

New object name
Change the new object's name.

Copy Data
Select this check box to copy data from the source table to a table copy. Enabled only for tables. Note copying large bulks of data can take a lot of time, but dbForge Studio makes this procedure asynchronous. You can hide the Duplicate Object dialog by clicking the Hide button that appears along with the progress

script-changes Script changes

newsql To New SQL Window
Shows script changes in a new SQL document.
to-clipboard To Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Database Explorer

Filter Settings Dialog Box


Filter Settings Dialog Box

Use the Filter Settings dialog to create a filter for database objects in accordance with certain criteria. To open the dialog, right-click a required object category node in the Database Explorer and select Filter from the menu, or select an object category node and click Filter on the Database Explorer toolbar.

Server
Displays the server version.

Database
Displays the database.

Criteria

Property
Specify the statistics name, owner, or schema to be filtered.

Operator
Choose the operator for the filter.

Pattern
Specify the pattern which goes with the corresponding criteria.

All
If checked, the filtered object will comply with all criteria.

Any
If checked, the filtered object will comply with any criteria.

ExpandedToggleIcon(9x12) See Also

Database Explorer

Object Viewer


Enable Triggers Dialog Box

Use this dialog box to enable all triggers in the required database or to specify a trigger as enabled in the required database. To open the Enable Triggers dialog box:

· Right-click the Triggers node in the Database Explorer and select Enable All from the shortcut menu.
· Right-click a required trigger in the Database Explorer, then select Enable from the shortcut menu.

Name
Displays name/names of a trigger/triggers you want to disable.

Enabled
Shows if a trigger/triggers is/are enabled or not.

Status
Shows status/statuses for a selected trigger/triggers.

Filter
Type filter string here, if required.

script-changes Script changes

newsql To New SQL Window
Shows script changes in a new SQL document.
to-clipboard To Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Database Explorer

Disable Triggers Dialog Box


Disable Triggers Dialog Box

Use this dialog box to disable all triggers in the required database or to specify a trigger as disabled in the required database. To open the Disable Triggers dialog box:

· Right-click the Triggers node in the Database Explorer and select Disable All from the shortcut menu.
· Right-click a required trigger in the Database Explorer, then select Disable from the shortcut menu.

Name
Displays name/names of trigger/triggers you want to disable.

Enabled
Shows if a trigger/triggers is/are enabled or not.

Status
Shows status/statuses for the selected trigger/triggers.

Filter
Type filter string here, if required.

script-changes Script changes

newsql To New SQL Window
Shows script changes in a new SQL document.
to-clipboard To Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Database Explorer

Compile Dialog Box


Enable Constraints Dialog Box

Use this dialog box to enable all constraints in the required database or to specify a constraint as enabled in the required database. To open the Enable Constraints dialog box:

· Right-click the Constraints folder in Database Explorer and select Enable All from the shortcut menu.
· Right-click a required constraint in Database Explorer, then select Enable from the shortcut menu.

Object Name
Displays a constraint name you want to enable.

Table
Displays a table name that hosts a constraint.

Enabled
Displays constraint(s) state (either enabled or disabled).

Result
Shows status for a selected constraint(s).

Filter
Type filter string here, if required.

script-changes Script changes

newsql To New SQL Window
Shows script changes in a new SQL document.
to-clipboard To Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Database Explorer

Disable Constraints Dialog Box


Disable Constraints Dialog Box

Use this dialog box to disable all constraints in the required database or to specify a constraint as enabled in the required database. To open the Disable Constraints dialog box:

· Right-click the Constraints folder in Database Explorer and select Disable All from the shortcut menu.
· Right-click a required constraint in Database Explorer, then select Disable from the shortcut menu.

Object Name
Displays a constraint name you want to enable.

Table
Displays a table name that hosts a constraint.

Enabled
Displays constraint(s) state (either enabled or disabled).

Result
Shows status for a selected constraint(s).

Filter
Type filter string here, if required.

script-changes Script changes

newsql To New SQL Window
Shows script changes in a new SQL document.
to-clipboard To Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Database Explorer

Enable Constraints Dialog Box


Compile Dialog Box

Use the Compile dialog to compile database objects. To open the dialog, right-click a required object in the Database Explorer and select Compile from the shortcut menu, or select an object category node and click Compile All from the shortcut menu.

Name
Displays name/names of a database object/objects you want to compile.

Status
Shows status/statuses for the selected database object/objects.

Filter
Type filter string here, if required.

Invalid objects
Click the button to select all invalid objects.

script-changes Script changes

newsql To New SQL Window
Shows script changes in a new SQL document.
to-clipboard To Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Database Explorer

Object Viewer


Object Viewer

Object Viewer displays information about objects selected in the Database Explorer. To open Object Viewer, do either of these actions:

· Click ObjectViewerWindow Object Viewer on the View menu.
· Select the required object in Database Explorer and click ObjectViewerWindow Show Object Viewer on the Database Explorer window toolbar.
· Right-click the required object in Database Explorer and select ObjectViewerWindow Show Details.

Object Viewer

Properties, DDL and Data of Selected Objects

Object Viewer has three views to display properties, DDL (text), and data of the selected object in the Database Explorer. Note that the formatting settings used in the Text view of the window are the same as the ones used in the Text View of object editors. Text formatting settings in the Object Viewer are not used only for procedures, functions, triggers, and events.

In Object Viewer, you can see information on connections, databases, and most database objects (e.g. tables, views, columns, stored routines, etc.). The easiest way to view information about the required item in the Object Viewer is to double click it in the Database Explorer window. In this case the Object Viewer window will be opened automatically. But note that such way is not universal for all items displayed in the Database Explorer, and it's just a tip.

If there is a list of items in the Properties view of Object Viewer, you can obtain details on a particular item by double clicking it in the list or selecting it and pressing ENTER.

Navigation in Object Viewer

Object Viewer provides easy navigation. Use the following buttons on the toolbar:

Back Back to display the summary of the previous object.

Forward Forward - to display the summary of the next object in Database Explorer.

Up Up - to see the summary of the parent object.

Sync-with-DE Synchronize with Database Explorer - to synchronize the information in Object Viewer with Database Explorer.

RefreshButton Refresh - to refresh data in the Object Viewer window.

StopRefresh Stop Refresh - to stop refreshing data in the Object Viewer window.

ExpandedToggleIcon(9x12) See Also

Database Explorer

Database Explorer Window


Database Explorer Window

Database Explorer is a connection management console. Use the Database Explorer window to open data connections and to log on to servers and explore their databases.

To access the Database Explorer window, choose Database Explorer from the View menu.

To make the Database Explorer window close automatically when not in use, select Auto Hide from the Window menu.

Toolbar

You can find the following buttons on the toolbar in the Database Explorer window:

Refresh button Refresh - to synchronize the current view with changes that other users might be applying to the server.

Stop Refresh Stop Refresh - to stop refreshing when it takes too long.

Collapse-all-button Collapse All - to collapse all the expanded tree nodes.

New Connection - to the Database Connection Properties dialog box.

OpenConnectionDatabaseExplorer Open Connection - open a connection selected in Database Explorer.

CloseConnectionDatabaseExplorer Close Connection - close a connection selected in Database Explorer.

Show-AllObjects Show All Objects - to show all the objects of the selected connection, otherwise dbForge Studio shows only the objects of the default database for the selected connection.

Filter Filter - filter the child elements of selected node.

ObjectViewerWindow Object Viewer - show the Object Viewer window.

note Note

The availability of the toolbar options depends on the product you use.

Shortcut menu

The shortcut menu of the Database Explorer window provides quick access to a wide range of options that differs depending on the selected database object. For example, for tables and views available in a database you can choose the Send To... option, and open the selected object in Query Builder, create a new master-detail relationship, create a data report, chart, or pivot table.

From the shortcut menu, you can compile dependants and references. For this, select the needed option from the Compile submenu: Compile References for Debugging, Compile References, Compile Dependants for Debugging, Compile Dependants.

Collections

The Database Explorer window tree includes tables, views, procedures, functions, triggers, events, and user-defined functions. Each of available database objects has dependants Depends On and dependants Used By collections. In these collections you can find object's references and dependants.

ExpandedToggleIcon(9x12) See Also

Database Explorer

Database Explorer Shortcut Keys


Node Icons

This table lists icons you can see in the Database Explorer and explains their meaning.

Icon | Description
Connection | A connection to a server
InvalidConnection | Invalid connection (connection to not supported database server other than Oracle).
Database | A database schema on a server
Table | A table
XMLTable | An XML table
ObjectTable | An object table
ClusteredTable | A clustered table
IOTable | An index-organized table
PartitionedTable | A partitioned table
NonexistentObject | A non-existent object - one that does not exist in the schema or the server any longer
InvalidObject | An invalid object - one that is defined as invalid in the database or the program can't get all its properties
Column | A column that is contained by a table or referenced by an index
ForeignKey | A foreign key
PrimaryIndex | A primary key
UniqueIndex | A unique index
CheckConstraint | A check constraint
CommonIndex | An index (neither primary nor unique)
View | A view
Package | A package
 | A package body
StoredProcedure | A stored procedure
StoredFunction | A stored function
ParameterIn | A stored procedure parameter (IN)
ParameterOut | A stored procedure parameter (OUT)
ParameterResult | A stored function result value
Trigger | A trigger
disabled-trigger | A disabled trigger
array-type | An array type
object-type | An object type
table-type | A table type
 | An object type body
Sequence | A sequence
 | A synonym
 | A materialized view
 | A materialized view log
Cluster | A cluster
DbLink | A database link
XMLSchema | An XML schema
depends-on-icon | Depends On - lists database objects that must be present for an object to function properly
used-by-icon | Used By - lists database objects that depend upon a database object

ExpandedToggleIcon(9x12) See Also

Database Explorer Nodes' Properties

XML Schema Properties


Database Explorer Shortcut Keys

Use following shortcut key combinations when working in Database Explorer to speed up your work.

Shortcut Keys | Action | Where is used
F4 | View properties of currently selected Database Explorer node. | Database Explorer
F2 | Rename currently selected Database Explorer node. | Database Explorer
F5 | Refresh selected node and its child nodes in the Database Explorer | Database Explorer
ENTER | Same as double-click. | Database Explorer

These shortcuts are default shortcuts.

ExpandedToggleIcon(9x12) See Also

Database Explorer Nodes' Properties

Database Explorer


Database Explorer Nodes' Properties

This section describes what properties are owned by Database Explorer's nodes.

ExpandedToggleIcon(9x12) In This Section

Connection Properties
Lists properties of a connection.

Table Properties
Lists properties of a table.

Column Properties
Lists properties of a column.

Index Properties
Lists properties of an index.

Primary Key Properties
Lists properties of a primary key.

Foreign Key Properties
Lists properties of a foreign key.

View Properties
Lists properties of a view.

Stored Procedure and Stored Function Properties
Lists properties of a stored procedure or stored function.

Stored Procedure Parameter Properties
Lists properties of a stored procedure parameter.

Trigger Properties
Lists properties of a trigger.

Schema Properties
Lists properties of a schema.

Object Table Properties
Lists properties of an object table.

XML Table Properties
Lists properties of an XML table.

Unique Key Properties
Lists properties of a unique key.

Check Constraint Properties
Lists properties of a check constraint.

Package Properties
Lists properties of a package.

Package Body Properties
Lists properties of a package body.

Array Type and Table Type Properties
Lists properties of an array or table type.

Object Type Properties
Lists properties of an object type.

Object Type Body Properties
Lists properties of an object type body.

Sequence Properties
Lists properties of a sequence.

Materialized View Properties
Lists properties of a materialized view.

Materialized View Log Properties
Lists properties of a materialized view log.

Synonym Properties
Lists properties of a synonym.

Cluster Properties
Lists properties of a cluster.

Database Link Properties
Lists properties of a database link.

XML Schema Properties
Lists properties of an XML schema.

ExpandedToggleIcon(9x12) See Also

Database Explorer


Connection Properties

This node represents a connection to Oracle and has the following properties:

Client version
Displays version of the Oracle client, that is used by this connection.

Connection String
Represents connection parameters in a single string.

Database
The name of the master database.

Document Category
The name of the document category.

Open
Identifies whether a connection is active or not.

Save Password
Shows whether the password should be saved.

Server Version
Displays version of the server connected.

ExpandedToggleIcon(9x12) See Also

Table Properties


Table Properties

This node represents Oracle table and has the following properties:

(Name)
The name of the table.

Backed Up
Indicates whether the table was backed up.

Cluster Name
Shows name of a cluster if one is used to store table data.

Compression
Shows whether data segments in the table are compressed.

Created
Shows creation date.

Flashback Archive Name
Shows the name of the flashback data archive.

Id Is Primary Key
Indicates that the object identifier (OID) of the object table is based on the primary key of the table.

Index Organized
Shows whether the table is index-organized.

Is Object Based Table
Shows whether the table is object-based.

Is Read Only
Shows whether the table is in read-only mode.

Modified
Shows when the table was modified last.

Object Name
Name of the object, which table is based on.

Object Owner
Owner of the object, which table is based on.

Owner
Shows schema that contains the table.

Partitioned
Shows whether the table is partitioned.

Result Cache
Shows the result cache size.

Row movement
Shows if the row movement mode is enabled in the table.

Status
Indicates whether the table is valid or not.

Temporary
Indicates whether the table is temporary.

Temporary Session
If selected, the rows of the table will be preserved. Applicable only for temporary tables.

ExpandedToggleIcon(9x12) See Also

Column Properties


Column Properties

This node represents table column and has the following properties:

(Name)
The name of the column.

Char Used
Specifies the measurement type for Char. Values are CHAR and BYTE

Cluster Name
Shows name of cluster that holds data for the column.

Compute Expression
Generates totals that appear as additional summary columns at the end of the result set.

Data Type
This is the type of the column.

Data Type Owner
If Data Type is user-defined, this property indicates its owner, otherwise it is empty.

Default On Null
Shows whether the column default value is NULL.

Default Value
Specifies a default value that will be entered in the column.

Is Nested Table
Indicates whether the column is NESTED TABLE column or not.

Is Persistent
Determines whether or not an event persists with its document.

Length
Shows size of the column in bytes.

Nullable
Shows whether the column can be of NULL value.

Owner
Table that contains the column.

Precision
Displays precision for the column if set.

Reference
Indicates whether the column has REF attribute.

Scale
This property shows how many decimals are in the column.

ExpandedToggleIcon(9x12) See Also

Index Properties


Index Properties

These nodes represent Oracle indexes. Unique indexes are marked by blue key icon UniqueIndex, non-unique indexes are rendered with icon CommonIndex. Indexes have the following properties:

(Name)
Name of the index.

Compress
Shows compression volume.

Degree
Specifies the number of parallel slave processes to use on each instance.

Enable
Specifies whether the index is enabled.

Instances
Specifies the number of instances to use.

note Note

INSTANCES property applies only to the Oracle Parallel Server configuration. If not using OPS, the value of INSTANCES should be set to 1; any other value is meaningless.

Is Bitmap
Indicates whether the index was created with a bitmap for each distinct key.

Logging
Indicates if the index logging is enabled

Owner
Database object that contains the index.

Partitioned
Shows whether the index is partitioned.

Reverse
Indicates whether the index was created with Reverse option.

Status
Shows whether the index is valid or not.

Unique
Shows whether the index is unique. UniqueIndex

Visible
Indicates whether the index is visible.

ExpandedToggleIcon(9x12) See Also

Database Explorer Nodes' Properties

Primary Key Properties


Primary Key Properties

This node represents primary key and has the following properties:

(Name)
Name of the constraint.

Bad
A true value indicates that this constraint specifies a century in an ambiguous manner. To avoid errors resulting from this ambiguity, rewrite the constraint using the TO_DATE function with a four-digit year.

Deferrable
Specifies whether the constraint is deferrable.

Deferred
Specifies whether the constraint is deferred.

Enabled
Specifies whether the constraint is enabled.

Generated
Indicates whether it was user (USER NAME) or database (GENERATED NAME) who generated the constraint.

Index Name
Name of the bound index.

Index Owner
Table, that contains the bound index.

Is System Named
Indicates whether the name was assigned by the system but not by the user.

Modified
Shows date and time of the last primary key modification.

Owner
Table that contains the constraint.

Rely
Indicates whether the enabled constraint is enforced or unenforced.

Validated
Specifies whether the constraint is validated.

ExpandedToggleIcon(9x12) See Also

Database Explorer Nodes' Properties

Foreign Key Properties


Foreign Key Properties

Represents a foreign key and has the following properties:

(Name)
Name of the constraint.

Bad
A true value indicates that this constraint specifies a century in an ambiguous manner. To avoid errors resulting from this ambiguity, rewrite the constraint using the TO_DATE function with a four-digit year.

Deferrable
Specifies whether the constraint is deferrable.

Deferred
Specifies whether the constraint is deferred.

Delete Rule
Rule used when a row is deleted. Can be Cascade, No Action, or Set Null.

Enabled
Specifies whether the constraint is enabled.

Full Referenced Name
Name of the table with the schema prefix name that the key references to.

Generated
Indicates whether it was user (USER NAME) or database (GENERATED NAME) who generated the constraint.

Is System Named
Indicates whether the name was assigned by the system but not by the user.

Modified
Shows date and time of the last foreign key modification.

Owner
Table that contains the constraint.

Referenced Constraint
Name of constraint that the key references to.

Referenced Table Database
Name of the database that the key references to.

Referenced Table Name
Name of the table that the key references to.

Reference Owner
Owner of the table that the key references to.

Rely
Indicates whether the enabled constraint is enforced or unenforced.

Validated
Specifies whether the constraint is validated.

ExpandedToggleIcon(9x12) See Also

Database Explorer Nodes' Properties

View Properties


View Properties

This node represents Oracle view and has the following properties:

(Name)
The name of the view.

Container Id
Indicates Id number of container.

Editioning
Indicates whether edition-based redefinition is applied to the view.

Modified
View modification time.

Oid Text
WITH OID clause of the typed view.

Owner
Database that contains the view.

Status
Shows whether the view is valid or not.

Type Text
Type clause of the typed view.

View Type
Type of the view if the view is a typed view.

View Type Owner
Owner of the type of the view if the view is a typed view.

ExpandedToggleIcon(9x12) See Also

Database Explorer Nodes' Properties


Stored Procedure and Stored Function Properties

These nodes represent a stored procedure or stored function and the have following properties:

(Name)
Name of the procedure or function.

Created
Shows date and time of the stored procedure creation.

Is Wrapped
Indicates whether the procedure or function is wrapped.

Modified
Shows date and time of the last procedure modification.

Overload
Indicates the number of the procedure overload if the procedure is overloaded.

No Change Owner Message

Owner
Schema that contains the procedure.

Package
Shows name of the package that contains the procedure. Empty if the procedure does not belong to any package.

Status
Shows whether the procedure is valid or not.

ExpandedToggleIcon(9x12) See Also

Database Explorer Nodes' Properties

Stored Procedure Parameter Properties


Stored Procedure Parameter Properties

These nodes represent parameter of a stored procedure and have the following properties:

Name
The name of the parameter.

Data Type
This parameter's data type.

Direction
Shows parameter's direction (in ParameterIn, out ParameterOut, or return value ParameterResult).

Owner
The stored procedure that contains the parameter.

ExpandedToggleIcon(9x12) See Also

Database Explorer Nodes' Properties

Trigger Properties


Trigger Properties

This node represents Oracle trigger and has the following properties:

(Name)
Name of the trigger.

Created
Shows date and time of the trigger creation.

Enabled
Specifies whether the trigger is enabled.

Event
Event, that fires the trigger.

Modified
Shows date and time of the last trigger modification.

Owner
Schema that contains the trigger.

Referencing Names
Specified correlation names for referring specifically to old and new values of the current row.

Status
Shows whether the procedure is valid or not.

Table Name
Name of the table, the event on which fires the trigger.

Table Owner
Schema that contains the table, the event on which fires the trigger.

Type
Type of the trigger.

When Clause
The trigger condition, which is a SQL condition that must be satisfied for the database to fire the trigger.

ExpandedToggleIcon(9x12) See Also

Database Explorer Nodes' Properties

Schema Properties


Schema Properties

This node represents Oracle schema and has the following properties:

(Name)
The name of the schema.

Owner
Owner of the object, which schema is based on.

ExpandedToggleIcon(9x12) See Also

Database Explorer Nodes' Properties

Object Table Properties


Object Table Properties

This node represents Oracle Object table and has the following properties:

(Name)
Name of the table.

Backed Up
Indicates whether the table was backed up.

Compression
Shows whether data segments in the table are compressed.

Created
Shows creation date.

Flashback Archive Name
Shows the name of the flashback data archive.

Id Is Primary Key
Indicates that the object identifier (OID) of the object table is based on the primary key of the table.

Index Organized
Shows whether the table is index-organized.

Is Object Based Table
Shows whether the table is object-based.

Is Read Only
Shows whether the table is in read-only mode.

Modified
Shows when the table was modified last.

Object Name
Name of the object, which table is based on.

Object Owner
Owner of the object, which table is based on.

Owner
Shows schema that contains the table.

Partitioned
Shows whether the table is partitioned.

Result Cache
Shows the result cache size.

Row movement
Shows if the row movement mode is enabled in the table.

Status
Indicates whether the table is valid or not.

Temporary
Indicates whether the table is temporary.

Temporary Session
If selected, the rows of the temporary table will be preserved after temporary session.

ExpandedToggleIcon(9x12) See Also

Database Explorer Nodes' Properties

XML Table Properties


XML Table Properties

This node represents Oracle XML table and has the following properties:

(Name)
The name of the table.

Backed Up
Indicates whether the table was backed up.

Cluster Name
Shows name of a cluster if one is used to store table data.

Compression
Shows whether data segments in the table are compressed.

Created
Shows the creation date.

Flashback Archive Name
Shows the name of the flashback data archive.

Id Is Primary Key
Indicates that the object identifier (OID) of the object table is based on the primary key of the table.

Index Organized
Shows whether the table is index-organized.

Is Object Based Table
Shows whether the table is object-based.

Is Read Only
Shows whether the table is in read-only mode.

Modified
Shows when the table was modified last.

Object Name
Name of the object, which table is based on.

Object Owner
Owner of the object, which table is based on.

Owner
Shows schema that contains the table.

Partitioned
Shows whether the table is partitioned.

Result Cache
Shows the result cache size.

Row movement
Shows if the row movement mode is enabled in the table.

Status
Indicates whether the table is valid or not.

Temporary
Indicates whether the table is temporary.

Temporary Session
If selected, the rows of the temporary table will be preserved after temporary session.

ExpandedToggleIcon(9x12) See Also

Database Explorer Nodes' Properties

Unique Key Properties


Unique Key Properties

This node represents unique key and has the following properties:

(Name)
Name of the constraint.

Compress
Specifies compression level.

Degree
Specifies the number of parallel slave processes to use on each instance.

Enable
Specifies whether the key is enabled.

Instances
Specifies the number of instances to use.

note Note

INSTANCES property applies only to the Oracle Parallel Server configuration. If not using OPS, the value of INSTANCES should be set to 1; any other value is meaningless.

Is Bitmap
Indicates whether the key was created with a bitmap for each distinct key.

Logging
Indicates if the key logging is enabled

Owner
Database object that contains the key.

Partitioned
Shows whether the key is partitioned.

Reverse
Indicates whether the key was created with Reverse option.

Status
Shows whether the index is valid or not.

Unique
Shows whether the key is unique. UniqueIndex

Visible
Indicates whether the key is visible.

ExpandedToggleIcon(9x12) See Also

Database Explorer Nodes' Properties

Check Constraint Properties


Check Constraint Properties

This node represents check constraint and has the following properties:

(Name)
Name of the constraint.

Bad
A true value indicates that this constraint specifies a century in an ambiguous manner. To avoid errors resulting from this ambiguity, rewrite the constraint using the TO_DATE function with a four-digit year.

Condition
Shows condition that is applied by the constraint.

Deferrable
Specifies whether the constraint is deferrable.

Deferred
Specifies whether the constraint is deferred.

Enabled
Specifies whether the constraint is enabled.

Generated
Indicates whether it was user (USER NAME) or database (GENERATED NAME) who generated the constraint.

Is Not Null
Shows whether the column can be of NULL value.

Is System Named
Indicates whether the name was assigned by the system but not by the user.

Modified
Shows date and time of the last check constraint modification.

Owner
Table that contains the constraint.

Rely
Indicates whether the enabled constraint is enforced or unenforced.

Validated
Specifies whether the constraint is validated.

ExpandedToggleIcon(9x12) See Also

Database Explorer Nodes' Properties

Package Properties


Package Properties

This node represents Oracle package and has the following properties:

(Name)
Name of the package.

Owner
Database that contains the package.

ExpandedToggleIcon(9x12) See Also

Database Explorer Nodes' Properties

Package Body Properties


Package Body Properties

This node represents Oracle package body and has the following properties:

(Name)
Name of the package body.

Owner
Database that contains the package body.

ExpandedToggleIcon(9x12) See Also

Database Explorer Nodes' Properties

Array Type and Table Type Properties


Array Type and Table Type Properties

This node represents Oracle array type or table type and has the following properties:

(Name)
Name of the user type.

Owner
Database that contains the user type.

ExpandedToggleIcon(9x12) See Also

Database Explorer Nodes' Properties

Object Type Properties


Object Type Properties

This node represents Oracle object type and has the following properties:

(Name)
Name of the object type.

Owner
Database that contains the object type.

ExpandedToggleIcon(9x12) See Also

Database Explorer Nodes' Properties

Object Type Body Properties


Object Type Body Properties

This node represents Oracle object type body and has the following properties:

(Name)
Name of the object type body.

Owner
Database that contains the object type body.

ExpandedToggleIcon(9x12) See Also

Database Explorer Nodes' Properties

Sequence Properties


Sequence Properties

This node represents Oracle sequence and has the following properties:

(Name)
Name of the sequence.

Owner
Schema that contains the sequence.

ExpandedToggleIcon(9x12) See Also

Database Explorer Nodes' Properties

Materialized View Properties


Materialized View Properties

This node represents Oracle materialized view and has the following properties:

(Name)
Name of the materialized view.

Build Mode
Shows how the materialized view was populated with data.

Cluster Name
Shows name of a cluster if one is used to store table data.

Compile State
Shows whether the materialized view needs compile.

Compression
Shows whether data segments in the materialized view are compressed.

Created
Shows creation date.

Error
Shows the number of failed automatic refreshes since last successful refresh.

Fast Refreshable
Shows whether fast refresh is supported for the materialized view and what operation is it supported for.

Id is Primary Key
Indicates that the object identifier (OID) of the object table is based on the primary key of the table.

Index Organized
Shows whether the table is index-organized.

Is Read Only
Shows whether the materialized view is in read-only mode.

Key Compression
Shows the number of key compressions.

Last Refresh Date
Shows date of the last materialized view refresh operation.

Last Refresh Type
Shows most recent refresh type - fast or complete.

Local Rollback Segment
Materialized view local rollback segment.

Master Rollback Segment
Rollback segment for the master site or the master materialized view site.

Modified
Shows when the materialized view was modified last.

Next
Shows date function used to compute next refresh dates.

Object Name
Name of the object, which materialized view is based on.

Object Owner
Owner of the object, which materialized view is based on.

Owner
Shows schema that contains the materialized view.

Partitioned
Shows whether the materialized view is partitioned.

Prebuilt
Shows whether the materialized view is created on the existing table.

Refresh Method
Shows default method used to refresh the materialized view.

Refresh Mode
Shows refresh mode of the materialized view.

Refresh Type
Shows type of refresh for all automatic refreshes.

Rewrite Capability
Shows whether the materialized view is eligible for rewrite, and if so, what rules must be followed.

Rewrite Enabled
Shows whether rewrite is enabled.

Row Movement
Shows if the row movement mode is enabled in the materialized view.

Stale Since
Shows time from when the materialized view became stale.

Staleness
Shows relationship between the contents of the materialized view and the contents of the materialized view as masters.

Start With
Shows date function used to compute next refresh dates.

Status
Shows materialized view status.

Temporary
Indicates whether the materialized view is temporary.

Temporary Session
If selected, the materialized view will be preserved. Applicable only for temporary materialized views.

Updatable
Shows whether the materialized view is updatable.

Update Log
Shows filename of the update log for updatable materialized view.

Use Index
Shows whether the materialized view was created with default index.

ExpandedToggleIcon(9x12) See Also

Database Explorer Nodes' Properties

Materialized View Log Properties


Materialized View Log Properties

This node represents Oracle materialized view log and has the following properties:

(Name)
Auto-generated name of the materialized view log.

Owner
Shows schema that contains the materialized view log.

ExpandedToggleIcon(9x12) See Also

Database Explorer Nodes' Properties

Synonym Properties


Synonym Properties

This node represents Oracle synonym and has the following properties:

(Name)
Name of the synonym.

Owner
Schema that contains the synonym.

ExpandedToggleIcon(9x12) See Also

Database Explorer Nodes' Properties

Cluster Properties


Cluster Properties

This node represents Oracle XML table and has the following properties:

(Name)
Name of the cluster.

Backed up
Indicates whether the cluster was backed up.

Compression
Shows whether data segments in the cluster are compressed.

Created
Shows creation date.

Flashback Archive Name
Shows the name of the flashback data archive.

Id Is Primary Key
Indicates that the object identifier (OID) of the object table is based on the primary key of the table.

Index Organized
Shows whether the cluster is index-organized.

Is Object Based Table
Specifies whether the table is object-based.

Is Read Only
Shows whether the cluster is in read-only mode.

Modified
Object type modification time.

Object Name
Name of the object, which cluster is based on.

Object Owner
Owner of the object, which cluster is based on.

Owner
Shows schema that contains the cluster.

Partitioned
Shows whether the cluster is partitioned.

Result Cache
Shows the result cache size.

Row Movement
Shows if the row movement mode is enabled in the cluster.

Status
Shows whether the cluster is valid or not.

Temporary
Indicates whether the cluster is temporary.

Temporary Session
If selected, the temporary cluster will be preserved after the temporary session.

ExpandedToggleIcon(9x12) See Also

Database Explorer Nodes' Properties

Database Link Properties


Database Link Properties

This node represents Oracle XML table and has the following properties:

Name
Name of the database link.

Owner
Shows schema that contains the database link.

ExpandedToggleIcon(9x12) See Also

Database Explorer Nodes' Properties

Node Icons


XML Schema Properties

This node represents Oracle XML schema and has the following properties:

Name
Name of the Xml Schema.

Owner
Shows the schema that contains the Xml Schema.

ExpandedToggleIcon(9x12) See Also

Database Explorer Nodes' Properties


Database Projects

dbForge Studio for Oracle provides you projects feature. Project contains items that represent SQL scripts, query files and database object shortcuts. You can use Project Explorer to manage dbForge Studio project.

ExpandedToggleIcon(9x12) In This Section

New Database Project Wizard
This section describes windows of the New Database Project wizard.

Project Options
This section describes pages on which you can set project options.

Project Management Windows
This section describes user interface elements of the tool windows and dialogs concerned with project management.

ExpandedToggleIcon(9x12) See Also

Reference


New Database Project Wizard

Use New Database Project Wizard to create new database project or to import existing database objects to a new database project. To access New Database Project Wizard, in the File menu, point to New, and select Project. Wizard's pages are listed below.

ExpandedToggleIcon(9x12) In This Section

Name and Location, New Database Project Wizard
Choose project name and location and whether on this page.

Import Options, New Database Project Wizard
Specify connection and database to import database objects from and set additional import options on this page.

Import Objects, New Database Project Wizard
Select database objects to import on this page.

Options, New Database Project Wizard
Set options for DDL generation on this page.

Project Options, New Database Project Wizard
Select a project connection and whether to create virtual project folders for database object types for the project on this page.

Database Import Progress, New Database Project Wizard
You can see a database object import progress on this page.


Name and Location, New Database Project Wizard

Choose project name and location and whether on this page.

Name
Enter or select the name of the project.

Location
Enter or select a directory, in which project file will be stored.

Create a folder for the project
Indicates whether to create a separate folder, having the project name, in the selected location.

Import schema objects from the existing database
Select to import schema objects from existing database. Your project will contain selected schema objects from the selected database in either single script, or in separate files.

ExpandedToggleIcon(9x12) See Also

New Database Project Wizard

Import Options, New Database Project Wizard


Import Options, New Database Project Wizard

Specify connection and database to import database objects from and set additional import options on this page. This page is available only if user selected Import schema objects from existing database on the first wizard page.

Connection
Select a connection to import database objects from.

Database
Select a database to import database objects from.

Include all objects
Select to import all objects from the specified database. If selected, the Import Objects page will not be displayed.

Import all objects into a single file
Indicates whether to import all objects into a single file or create a separate file for each database object.

Create a physical folder on the disk for each object type
Indicates whether to create physical folder on the disk for each object type or store all files together in the project folder.

ExpandedToggleIcon(9x12) See Also

New Database Project Wizard

Import Objects, New Database Project Wizard


Import Objects, New Database Project Wizard

Select database objects to import on this page. This page is available only if user selected Import schema objects from existing database on the first wizard page and if the Include all objects option is not checked on the Import options page.

Database objects tree
Check database objects here to export their structure.

Selected objects list
Selected database objects to export structure are listed here. You can remove them from this list by double-clicking them.

Moves all database objects to the Selected objects list.

Moves database objects that are highlighted in the Database objects tree to the Selected objects list.

Removes the highlighted item from the Selected objects list.

Clears the Selected objects list.

ExpandedToggleIcon(9x12) See Also

New Database Project Wizard

Options, New Database Project Wizard


Options, New Database Project Wizard

Set options for DDL generation on this page.

ExpandedToggleIcon(9x12) General

Contains general settings for DDL generating.

Exclude objects named with '$'
Script will not be generated for schema objects, that have '$' character in their name. '$' character is usually used for distinguishing system objects. Note that when determining whether to generate script for materialized view log, dbForge Studio analyzes its master table name, not the materialized view log name (that begins with 'LOG$').

Format the script
Select to format script of the source objects. Otherwise, source object DDL will have the same formatting as in database, the rest of objects will have default formatting.

Generate comments in the script
Select to insert comments in the script.

Include body for packages and objects
Select to include body of packages and objects in the script.

Include CASCADE CONSTRAINTS option
Select to include CASCADE CONSTRAINTS in the script.

Include CONNECT command
Select to include CONNECT command with current connection settings in the script.

Include DROP statement
Select to include DROP statements in the script.

Include physical attributes clause
Select to include physical attributes clause of schema objects in the script.

Include PURGE option
Select to include PURGE statements in the script. PURGE execution cannot be rolled back!

Include SET CURRENT_SCHEMA
Select to include a statement that changes current schema to the one being exported. ALTER SESSION SET CURRENT_SCHEMA statement will be written in the beginning of the script.

Include storage clause
Select to include storage clause of schema objects in the script.

Include tablespace names in script
Select to include tablespace names of schema objects in script.

Prefix object names with a schema name
Select to add schema name as prefix for object names. If you enable schema prefixes generation, you will not be able to import this script to another schema.

Use CREATE OR REPLACE
Select to use CREATE OR REPLACE statement instead of CREATE statement for objects' script generation.

ExpandedToggleIcon(9x12) Tables/Views

Contains settings for generating DDL of tables and views.

Disable constraints
Determines whether to add ALTER TABLE ... DISABLE statement before INSERT statements.

Exclude column default values
Select to exclude column default values from the script.

Exclude START and NEXT for materialized views
Excludes START and NEXT clauses from the materialized view DDL.

Include constraints
Select to include constraints for tables in the script.

Include indexes
Select to include indexes for tables in the script.

Include object comments
Select to include comments of objects in the script.

Include triggers
Select to include triggers for tables in the script.

ExpandedToggleIcon(9x12) Partitioning

Contains settings for generating script of partitioned database objects.

Exclude partition list for locally partitioned index
Select to exclude partition list for locally partitioned index.

Include partition clause
Select to include PARTITION clause in the script.

Include tablespace name for index partitions
Select to include tablespace name for every index partitions.

Include tablespace name for partitions
Select to include tablespace name for every partition.

List individual hash partitions
Select to list individual hash partitions in the script. Depends on the "Include partition clause" option.

ExpandedToggleIcon(9x12) Users/Roles

Contains settings for generating script of users.

Include an encrypted password
Includes encrypted password into the user script (using the IDENTIFIED BY VALUE statement). It allows generating script that creates users exactly with the same password without knowing it. You should not change user name in the script if you use this option.

Include grants
Includes grants for users in the script.

Include object grants
Includes any object grants for users in the script.

ExpandedToggleIcon(9x12) See Also

Database Explorer Nodes' Properties

Database Explorer


Project Options, New Database Project Wizard

Select a project connection and whether to create virtual project folders for database object types for the project on this page.

Select a connection to use for the project deployment
Select project connection.

Create a virtual folder in the project for each object type
Select whether to create virtual project folders for database object types for the project. If you have selected the Create physical folder on the disk for each object type check box on the Import Options page, virtual project folders will be created and you cannot clear this check box.

ExpandedToggleIcon(9x12) See Also

New Database Project Wizard

Database Import Progress, New Database Project Wizard


Database Import Progress, New Database Project Wizard

You can see a database object import progress on this page. To cancel the import click the Cancel button.

Minimize application
Click to minimize application while the project creation is in progress. The application window will be restored when the wizard finishes working.

ExpandedToggleIcon(9x12) See Also

New Database Project Wizard

Database Projects


Project Options

Use this document to set project options. To open it, right-click the project in the Project Explorer and select Properties from the shortcut menu.

ExpandedToggleIcon(9x12) In This Section

Build, Project Options
Set project build options on this tab.

Build Order, Project Options
Set build order on this tab.


Build, Project Options

Set build project options on this tab.

ExpandedToggleIcon(9x12) Configuration

Select a required configuration from the drop-down list. For a newly created project only Default configuration is available. To create and manage configurations, click the Configuration Manager button.

Configuration Manager
Click this button to open the Configuration Manager dialog where you can add, remove or rename project configurations.

note Note

The configuration you select in the project options relies only to Project Options document. If you build or deploy project, the configuration, selected in the Project toolbar is used.

ExpandedToggleIcon(9x12) Source validation

Check references
If this option is selected, database object references will be checked when building a project. That means, dbForge Studio checks if database objects are created before they are referenced in project scripts.

Ignore errors
Select to ignore all errors when building project.

ExpandedToggleIcon(9x12) Output

Build output path
Specify the output path for the generated script file.

Target file name
Specify the generated script file name.

note Note

Project build will delete all SQL files having the same names as project files in this directory without user confirmation. dbForge Studio asks for confirmation before deleting any other SQL file. Non-SQL files in the build output directory are not affected by build.

Generating single SQL file
Select to build the project into a single SQL script.

Include file contents into region
Select to include file contents into region.

Write full path in comments
Select to write full path in comments.

Generate batch script file
Select to build the project into a batch script file, that calls project script files.

Place all project files into one folder
Select to copy all project files to the Build output path folder.

Generate relative paths and keep project folders
Select to copy project files with subfolders to the Build output path folder.

Only create batch file with absolute paths
Select to generate only batch file with absolute paths to the project scripts.

ExpandedToggleIcon(9x12) See Also

Project Options

Build, Project Options

© 2004-2016 Devart


Build Order, Project Options

Build Order options allows you to specify what files have to be included in the build output script and to determine the include order of the scripts contained in the project to the result build script. It shows the list of files included into the project and the information about these files location.

ExpandedToggleIcon(9x12) Configuration

Select a required configuration from the drop-down list. For a newly created project only Default configuration is available. To create and manage configurations, click the Configuration Manager button.

Configuration Manager
Click this button to open the Configuration Manager dialog box where you can add, remove or rename project configurations.

note Note

The configuration you select in the project options relies only to Project Options document. If you build or deploy project, the configuration, selected in the Project toolbar is used.

ExpandedToggleIcon(9x12) Grid columns

Select All Check Box
Selects all grid rows. To select separate rows, use row selection check boxes.

File name
Shows name of the file.

Project folder
Shows path to a file in the project (virtual project folders).

Disk folder
Shows path to the file.

ExpandedToggleIcon(9x12) Buttons

Move Up
Moves selected file one position up in the list.

Move Down
Moves selected file one position down in the list.

Duplicate
Creates a copy of the selected file entry (entries). You can also copy, cut and paste file entries to create their copies. You can use this button to include files to the build order several times.

Delete
Deletes the selected file entry (or entries) if the entry is not the last entry for a file. If the file is included to the build order only once, it can not be deleted from the build order. Clear its check box to avoid the file execution when deploying the project.

Restore Defaults
Restores default deployment order (all files selected, they have the same order as in project manager).

ExpandedToggleIcon(9x12) See Also

Project Options

Database Projects


Project Management Windows

This section describes user interface elements of the tool windows and dialogs concerned with project management.

ExpandedToggleIcon(9x12) In This Section

Project Explorer Window
This window allows you to manipulate project items.

Schema View Window
This window provides you fast access to project database object DDL queries.

Configuration Manager
This dialog box allows you to add, remove, or rename project configurations.

Save New Project Dialog Box
This dialog box allows you to save a new project.

New Project Configuration Dialog Box
This dialog box is used for creating new project configurations.

Add New File Dialog Box
This dialog box is used for creating new files and adding them to project.

ExpandedToggleIcon(9x12) See Also

Database Projects


Project Explorer Window

Use the Project Explorer window to manipulate project items to organize your project. With the Project Explorer you can access project script files and queries, open selected database objects and find them in Database Explorer, organize project files into folders for convenient access.To access the Project Explorer window, choose Project Explorer from the View menu.

Project Explorer contains a tree with nodes, representing project, its folders and files, the project connection and database object shortcuts. Project Explorer allows you to do the following:

· See and quickly access all SQL and query files of the project, as they are accurately organized as a tree.
· Add new files to the project.
· Add existing SQL and query files to the project.
· Edit or delete files in the project.
· Drag-and-drop files to ensure their best location within the project tree.
· Create and then rename folders and subfolders in the project to neatly distribute multiple files into them.
· Delete folders and subfolders from the project.
· Move folders by drag-and-dropping them to include one into another, creating subfolders and getting the desired folder structure.

Note, you can right-click in Project Explorer and select the required option to manage project's files.

ExpandedToggleIcon(9x12) Shortcut Menu

build-project Build <Project name>
Build the opened project.

deploy-project Deploy <Project name>
Deploy your project.

Build order
Goes to the Build Order tab in project options.

Configuration manager
Opens Configuration Manager window.

add-new-file Add new file
Lets you add a new file to the project.

assign-connection Assign connection
Opens the Connection Manager window and lets you choose a connection fro your project.

add-existing-file Add existing file
Lets you add an existing file to your project.

add-new-folder Add folder
Adds new folder to your project.

save Save <Project name>
Saves the project.

Close project
Closes the project.

Open
Opens the selected file in the editor.

Exclude from project
Removes the selected file from project.

Rename
Renames the selected object.

Delete
Deletes the chosen file permanently.

RefreshButton Refresh
Refreshes the project tree.

properties Properties
Opens the Properties window for the selected element of the tree.

find-in-dbexplorer Find in Database Explorer
Click to locate the connection available in project, in Database Explorer.

ExpandedToggleIcon(9x12) See Also

Project Management Windows

Schema View Window


Schema View Window

Schema View displays database objects created by the scripts available in the project you are developing. When defined in the script explicitly, the target schema is displayed in Schema View with all objects contained in it. If the name of the schema is not mentioned in the script, the database objects are shown in the node <user>. When fulfilling the deploy operation, these objects are created in the schema which was assigned to the project.

You can access Schema View by selecting Schema View from the View menu.

ExpandedToggleIcon(9x12) Toolbar

LeftArrow Back

Move the cursor back.

RightArrow Forward

Move the cursor forward.

Object View Search

Enter search condition in this box.

search Search

Starts search.

clear-search-results Clear Search Results

Clears search results and displays all objects.

ExpandedToggleIcon(9x12) Shortcut Menu

go-to-definition Go to definition

Opens the script containing each object's Create statement. The script opens with the carriage at the beginning of the required line.

View in Project Explorer

Locates the object in the Project Explorer window.

Sort alphabetically

Orders the objects by their names.

Sort by object type

Organizes the objects by their type.

Group by object type

Arranges items in a separate folder according to the object type

Delete

Deletes the selected object.

ExpandedToggleIcon(9x12) See Also

Project Management Windows

Configuration Manager


Configuration Manager

Use the Configuration Manager dialog box to add, remove or rename project configurations. To open Configuration Manager, select Configuration Manager from the Configuration drop-down list on the Project toolbar.

Configuration

List of available configurations.

Add

Create a new configuration.

Remove

Remove selected configuration.

Rename

Renames the selected configuration.

Set Active

Set the selected configuration as active configuration (configuration that will be applied for building or deploying).

ExpandedToggleIcon(9x12) See Also

Project Management Windows

Save New Project Dialog Box


Save New Project Dialog Box

Use the Save New Project dialog box to save a new project. To access this dialog box, create a new project, right-click it in the Project Explorer and select Save Project from the shortcut menu.

Name
Name of the project.

Location
Path to the project.

Create folder for project
Creates a directory with the same name as the project in the project path directory.

ExpandedToggleIcon(9x12) See Also

Project Management Windows

New Project Configuration Dialog Box


New Project Configuration Dialog Box

Use this dialog box to create a new configuration. To view it, click the Add button in Configuration Manager.

Name

Specify the name of a new configuration.

Copy Settings From

Select an existing configuration to copy settings from it to the new configuration.

ExpandedToggleIcon(9x12) See Also

Project Management Windows

Add New File Dialog Box


Add New File Dialog Box

Use the Add New File dialog box to add new file to the project.

At the upper right corner there are two buttons - Large Icons and Small Icons. They change templates appearance in the box below. You can choose file template in the Templates box to create file on predefined template.

A brief template description is provided in the box below when template is selected.

Enter file name into the Name field and click the Add button to create the file and add it to the project or click the Cancel button to close the dialog.

ExpandedToggleIcon(9x12) See Also

Project Management Windows


Execute Script Wizard

Use this wizard for executing large scripts without opening them in the editor. To access the Execute Script Wizard, on the Database menu, click ExecuteLargeScript Execute Large Script. The wizard pages are listed below.

ExpandedToggleIcon(9x12) Script Location, Execute Script Wizard

Use this page to choose a location and connection parameters of a large script to execute it without opening in the text editor. This will significantly save your time while working with large scripts.

Options

Connection
Click the field to select a connection to a required server where you want to execute your script. In the drop-down list of the field you can click the <Manage...> link to open the Connection Manager dialog box. It will help you to create, edit, and delete existing connections.

Database
Click the field to select a required database from the list of all databases available on the selected Oracle.

File Name
Enter the path to a script you want to execute or click the Browse button to select the path in the Open dialog.

SQL file encoding
Select the encoding which should be applied to open and execute the script. The program automatically selects it based on the script, if it fails, the default encoding (the current Windows encoding on the machine where dbForge Studio for Oracle is running) is selected.

Execute
Click it to execute the selected script.

Cancel
Click it to close the wizard and discard the script execution.

ExpandedToggleIcon(9x12) Execution Progress, Execute Script Wizard

See script execution progress on this page. To stop the script execution, click the Cancel button.

ExpandedToggleIcon(9x12) Operation Complete, Execute Script Wizard

See the results of script execution on this page.

ExpandedToggleIcon(9x12) See Also

Reference


Find and Replace Window

You can use the Find and Replace window to search for text, expressions, or entity names within the code of your documents. To access this window, from the Edit menu, click Find and Replace, and then select one of the options listed.

The Find and Replace window contains a toolbar with two drop-downs, one for find operations and one for replace operations. When you select an operation, the corresponding options for the operation are displayed. You can search and replace in one or more files or an entire project for text, SQL code, or symbols.

ExpandedToggleIcon(9x12) In This Section

Find, Find and Replace Window
Used to search the active file for a string or expression. Jumps from match to match within each document.

Find in Files, Find and Replace Window
Used to search for a string or expression in files stored within a set of search folders, or across the active solution. Displays matches in the Find Results windows.

Choose Search Folders Dialog Box
The topic describes Choose Search Folders dialog box that allows you to create your own set of search folders, and to specify the order in which they are searched.

Find Results Window
The topic describes the Find Results window that allows you to navigate text search results


Find, Find and Replace Window

Use Find and Replace dialog box for searching and replacing text in the code editor.

note Note

The dialog boxes and menu commands you see might differ from those described in Help depending on your active settings or edition.

To access the Find and Replace dialog box:

1. In the Edit menu, click Find and Replace.
2. Select required option from the list.

An alternative way to access the Find and Replace window is by pressing CTRL+F shortcut key.

ExpandedToggleIcon(9x12) Menus

Find
Allows to select Find or Find in Files dialog.

Find
The search will be executed in an open document.

Find in Files
The search will be executed in the selected files or a project. If this option is selected, the Find and Replace window provides additional options. You can create a set of selected folders, specify search file types, and set result options.

Replace
Allows to select Replace or Replace in Files dialog.

Replace
The search will be executed in the document. The occurrences will be replaced with the replacement string.

Replace in Files
The search will be executed in the files or a project. The occurrences will be replaced with the replacement string.

ExpandedToggleIcon(9x12) General Options

Find what
To search for a new text string or expression, specify it in the box. To search for any of the strings that you searched for most recently, open the list, and select the string for which you want to search. You can also:

· Reuse the search strings by selecting any from the drop-down list in the field
· Enter a new search string into the field
· Use regular expressions as search strings
· Use wildcards in your search strings

Replace with
Replacement string.

Look in
Select search location here.

Current Document
Search will be executed in current document only.

Current Window
Search will be executed in current tool window. It can be either the Output window or the Data Viewer and Editor window.

All Open Documents
Search will be executed in all open documents.

Selection
Search will be executed in the selected text.

Current Project
Search will be executed in the opened project.

ExpandedToggleIcon(9x12) Find Options

Match case
Case sensitive search.

Match whole word
The string will not be found/replaced if it is not a whole word.

Search up
Search will be performed in reverse direction.

Search hidden text
Search in collapsed text areas (such as regions, definitions and others) will be also performed.

Use
Use regular expressions or wildcards in search.

Regular expressions
A regular expression is a pattern of text that consists of ordinary characters (for example, letters a through z) and special characters, known as metacharacters. The pattern describes one or more strings to match when searching text. If this option is selected, the arrow button next to the Find what field becomes active. You can click the button and select a required regular expression to add to the Find what field.

Wildcards
This is a list of expressions to replace characters or digits in the Find what field.

ExpandedToggleIcon(9x12) Buttons

Find Next
Searches the next occurrence in document.

Bookmark All
Sets bookmarks for the lines, that contain occurrences in the scope. Available for the Find mode.

Replace
Searches the next occurrence in document or replaces the selected one if on replace dialog, shows replace dialog if on search dialog. Available for the Replace mode.

Replace All
Replaces all occurrences in search location. Available for the Replace mode.

ExpandedToggleIcon(9x12) See Also

Find and Replace Window

Find in Files, Find and Replace Window


Find in Files, Find and Replace Window

Use the Find and Replace window to find and replace text in the selected files.

note Note

The dialog boxes and menu commands you see might differ from those described in Help depending on your active settings or edition.

To access the Find in Files, Find and Replace dialog box:

1. In the Edit menu, click Find and Replace.
2. Select required option from the list.

An alternative way to access the Find in Files, Find and Replace window is by pressing CTRL+F shortcut key, and then select Find in Files from the Find menu.

ExpandedToggleIcon(9x12) Menus

Find
Allows to select Find or Find in Files dialog.

Find
The search will be executed in the opened document.

Find in Files
The search will be executed in the selected files or a project. If this option is selected, the Find and Replace window provides additional options. You can create a set of selected folders, specify search file types, and set result options.

Replace
Allows to select Replace or Replace in Files dialog.

Replace
The search will be executed in the document. The occurrences will be replaced with the replacement string.

Replace in Files
The search will be executed in the files or a project. The occurrences will be replaced with the replacement string.

ExpandedToggleIcon(9x12) General Options

Find what
String that will be searched. This field allows you to use a string or a regular expression that will be matched. You can do the following:

· Reuse the search strings by selecting any from the drop-down list in the field
· Enter a new search string into the field
· Use regular expressions as search strings
· Use wildcards in your search strings

Replace with
Replacement string.

Look in
Select a search location here, either selecting options from the drop-down list or creating a new set of folders in the Choose Search Folders window. The drop-down list contains the following options:

Current document
Search will be executed in the current document only.

All open documents
Search will be executed in all open documents.

Current Project
Search will be executed in the opened project.

Button
Click to open the Choose Search Folders dialog box for creating custom named folder list.

Include sub-folders
Select this check-box to include the sub-folders within the selected folder set in the Look in field.

ExpandedToggleIcon(9x12) Find Options

Match case
Case sensitive search.

Match whole word
The string will not be found/replaced if it is not a whole word.

Use
Select this check-box to activate the use of regular expressions or wildcards in search strings.

Regular expressions
A regular expression is a pattern of text that consists of ordinary characters (for example, letters a through z) and special characters, known as metacharacters. The pattern describes one or more strings to match when searching text. If this option is selected, the arrow button next to the Find what field becomes active. You can click the button and select a required regular expression to add to the Find what field.

Wildcards
This is a list of expressions to replace characters or digits in the Find what field.

Look at these file types
Select the required file types from the drop-down list. The search will be executed only in files of the selected type.

ExpandedToggleIcon(9x12) Result Options

Display file names only
Select this check-box to show one entry per a file containing a search match.

Keep modified files open after Replace All
Select this check-box to leave all modified files open after Replace All is performed. It will allow you to undo or save the changes in the files.

ExpandedToggleIcon(9x12) Buttons

Find Next
Searches the next occurrence in document.

Find All
Searches for all occurrences in the scope. Available for the Find in Files mode.

Replace
Searches the next occurrence in document or replaces the selected one if on replace dialog, shows replace dialog if on search dialog. Available for the Replace in Files mode.

Replace All
Replaces all occurrences in search location. Available for the Replace in Files mode.

ExpandedToggleIcon(9x12) See Also

Find and Replace Window

Choose Search Folders Dialog Box


Choose Search Folders Dialog Box

This dialog allows you to create, save, and revise your own set of search folders, and to specify the order in which they are searched. To open this dialog, click the Button button, next to the Look in field.

Folder set
Shows the folders available for search. To create a new folder set, enter a name, add a set of search folders to the Selected folders list, and then click the Apply button.

Apply
Saves the set of search folders in the Selected folders list as a named folder set. This folder set then can be chosen in the Look in field on all tabs of the Find and Replace window. Leaves the Choose Search Folders dialog box open.

Delete
Removes the selected folder set from the Folder set field, and from the Look in field on all tabs of the Find and Replace window.

Available folders
Select a previously selected folder from the drop-down list to populate the Selected folders list.

List of Folders
Shows the drives and folders available within the folder selected in the Available folders drop-down list. Double-click to expand any drive or folder listed. Select a folder, or hold down the SHIFT or CTRL key to select multiple folders. To add a selected folder to the Selected folders list, click the arrowright right-arrow button. To remove a selected folder, click the arrowleft the left-arrow button.

Up
Moves the selection in the Available folders list one level higher in the folder hierarchy.

Selected folders
Lists folders added from the Available folders list. These folders will be included in the named folder set.

Arrow buttons
arrowright - Moves folders to the Selected folders list.

arrowleft - Selects folders from the Selected folders list.

arrowup - Moves the selected folder to one position higher in the Selected folders list so that the folder will be searched earlier.

arrowdown - Shifts the selected folder to one position down in the Selected folders list so that the folder will be searched later.

OK
Saves the set of search folders listed in Selected folders list as a named folder set. This folder set then can be chosen in the Look in field on all tabs of the Find and Replace window. Closes the Choose Search Folders window.

Cancel
Discards all changes and closes the Choose Search Folders window.

ExpandedToggleIcon(9x12) See Also

Find and Replace Window

Find Results Window


Find Results Window

Find Results window allows you to navigate text search results. It provides you following search results: file name, line number and part of the text, containing the match. You may double-click on matches to navigate to them. Find Results window has following toolbar buttons.

Go to the location on the current line
Moves caret to the selected line location of the match found.

Go to the previous location in the list
Moves caret to the selected line location of the previous match found.

Go to the next location In the list
Moves caret to the selected line location of the next match found.

Clear All
Clears Find Results window.

ExpandedToggleIcon(9x12) See Also

Find and Replace Window


Import and Export Settings Wizard

Export, import, or restore dbForge Studio settings using convenient Import and Export Settings wizard.

To access this wizard, in the Tools menu, click Import and Export Settings.

ExpandedToggleIcon(9x12) In This Section

See the list of Wizard's pages with their options below.

Welcome to the Import and Export Settings Wizard, Import and Export Settings Wizard
Choose a required action (export, import, or resetting) to apply to dbForge Studio settings on this page.

Choose Settings to Export, Import and Export Settings Wizard
Select categories of settings that you want to export on this page.

Save Current Settings, Import and Export Settings Wizard
Choose a file name and a location for the file which will contain the current settings on this page.

Export Finish, Import and Export Settings Wizard
See the result message to know whether the export is performed successfully and close the wizard on this page.

Save Current Settings While Importing, Import and Export Settings Wizard
Save your current settings while importing new ones on this page.

Choose Settings To Import, Import and Export Settings Wizard
Select categories of settings that you want to import on this page.

Reset Finish, Import and Export Settings Wizard
See the result message to know whether the resetting is performed successfully and close the wizard on this page.

Import Finish, Import and Export Settings Wizard
See the result message to know whether the import is performed successfully and close the wizard on this page.

Save Current Settings While Resetting, Import and Export Settings Wizard
Save your current settings while restoring default settings on this page.


Welcome to the Import and Export Settings Wizard, Import and Export Settings Wizard

Select the required action to export, or import the settings, or reset all settings to default ones here.

Export selected environment settings
Select this option to save your current settings to a file. Further you can import them at any time.

Import selected environment settings
Select this option to import settings from a file and apply to the environment.

Reset all settings
Select this option to replace your current settings with the default ones.

ExpandedToggleIcon(9x12) See Also

Import and Export Settings Wizard

Welcome to the Import and Export Settings Wizard, Import and Export Settings Wizard

© 2004-2016 Devart


Choose Settings to Export, Import and Export Settings Wizard

Select categories of settings which you want to export here.

Select the check boxes next to the settings you want to export. (To export all settings, select All Settings check box.)

Clear the settings which should not be exported.

note Note

The similarly-named connections are being imported with an index, while importing connections options.

ExpandedToggleIcon(9x12) See Also

Import and Export Settings Wizard

Save Current Settings, Import and Export Settings Wizard


Save Current Settings, Import and Export Settings Wizard

Specify the name and location of the file that will contain exported settings here.

Settings file name
Change the default name of the file with exported settings.

Store my settings in this directory
Click the Browse button to change the default location for the file with exported settings.

ExpandedToggleIcon(9x12) See Also

Import and Export Settings Wizard

Export Finish, Import and Export Settings Wizard


Export Finish, Import and Export Settings Wizard

See the result message on this page to know whether the export is performed successfully. Click the Close button to close the wizard.

ExpandedToggleIcon(9x12) See Also

Import and Export Settings Wizard

Save Current Settings While Importing, Import and Export Settings Wizard


Save Current Settings While Importing, Import and Export Settings Wizard

Save your current settings while importing new ones on this page.

Yes, save my current settings
Select this option to save your current settings before importing the new ones. Enter the name of the file that will contain the exported settings.

Browse
Click the Browse button to change the default location of the file that will contain the exported settings.

No, just import new settings, overwriting my current settings
Select this option to import the new settings without saving the current ones.

ExpandedToggleIcon(9x12) See Also

Import and Export Settings Wizard

Choose Settings To Import, Import and Export Settings Wizard


Choose Settings To Import, Import and Export Settings Wizard

Select the categories of settings that you want to import here.

Browse
Click the Browse button to select the file with imported settings. Select the check boxes next to the settings you want to export. (To export all settings, select All Settings check box.)

Clear the settings which should not be exported.

ExpandedToggleIcon(9x12) See Also

Import and Export Settings Wizard

Reset Finish, Import and Export Settings Wizard


Reset Finish, Import and Export Settings Wizard

See the result message on this page to know whether the resetting is performed successfully. Click the Close button to close the wizard.

ExpandedToggleIcon(9x12) See Also

Import and Export Settings Wizard

Import Finish, Import and Export Settings Wizard


Import Finish, Import and Export Settings Wizard

See the result message on this page to know whether the import is performed successfully. Click the Close button to close the wizard.

ExpandedToggleIcon(9x12) See Also

Import and Export Settings Wizard

Save Current Settings While Resetting to Default Ones, Import and Export Settings Wizard


Save Current Settings While Resetting to Default Ones, Import and Export Settings Wizard

Save your current settings while resetting your settings to the default ones on this page.

Yes, save my current settings
Select this option to save your current settings before before replacing them with the default ones. Enter the name of the file that will contain the exported settings.

Browse
Click the Browse button to change the default location of the file that will contain the exported settings.

No, just import new settings, overwriting my current settings
Select this option to restore the default settings without saving the current ones.

ExpandedToggleIcon(9x12) See Also

Import and Export Settings Wizard


Invalid Object Manager Document

Use the Invalid Object Manager document to analyze and compile invalid objects. To open the document, in the Database menu, select Find Invalid Objects.

Search
Type in the search string here for a quick navigation through the invalid object list.

clear-icon Clear
Click to clear the search string.

Reanalyze
Click to perform the invalid object search over again.

Type
Select the type of invalid objects to search for from the drop-down list.

Database
Select a database from the drop-down list. You can select Check all to add all the available databases. To find a specific database type in its name in the Search field. Click the Refresh button to refresh the list of available databases.

Connection
Select an Oracle server connection from the drop-down list. You can click the <Manage...> link to open the Connection Manager dialog box. It will help you to create, edit, and delete server connection.

Action Required
Lists invalid objects that require maintenance.

Compile
Click to compile the selected objects.

Script Changes
Click to generate a compile script for selected objects.

to New SQL Window
Shows script changes in a new SQL document.

to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

Export to CSV
Click to export the compilation results to a CSV file.

No Action Required

Lists valid objects that do not require maintenance.

Grid

Filter
Click the filter glyph or error icon on a column header to start filtering or sorting data in the grid. You can select the (Custom) option to open the Custom AutoFilter dialog box that will help you to customize filter parameters.

Schema
Shows the schema, in which an object resides.

Name
Shows the name of an object.

Type
Shows the type of an object.

Status
Shows the status of an object, either valid or invalid.

Result
Shows the result of the compilation. The column is only available for the Action Required section.

ExpandedToggleIcon(9x12) See Also

Import and Export Settings Wizard

Master-Detail Browser


Master-Detail Browser

Master-Detail Browser is a utility for viewing data in parent tables or views as well as in related child tables or views, and also in self-referencing tables. This section describes Master-Detail Browser user interface elements.

ExpandedToggleIcon(9x12) In This Section

Design View, Master-Detail Browser
Describes the Design view of the Master-Detail Browser document.

Data View, Master-Detail Browser
Describes the Design view of the Master-Detail Browser document.


Design View, Master-Detail Browser

In this window you can view relations between tables.

Toolbar

browse-data Browse Data
Click to open Data View of the browser.

Set Table as Master
Makes the table selected on the diagram, master table.

Select All Columns
Click to select all columns in the selected table.

Unselect All Columns
Click to cancel all columns selection in the selected table.

sort-ascending Sort Ascending
Apply ascending data sorting in this column.

sort-descending Sort Descending
Apply descending data sorting in this column.

Send to Query
Create new query using tables and settings available in the Master-Detail Browser document.

Diagram shapes

Master table
Master table shape, it's marked pink.

Table
Shape(s) of child table(s).

Relations
Arrows indicate relations between tables.

Diagram shortcut menu

Zoom
Zoom in or zoom out the diagram.

Select All
Select all shapes on the diagram.

Export to Image
Save your diagram as an image.

Layout Diagram
Apply automatic diagram layout.

Send to Query
Create new query using tables and settings available in the Master-Detail Browser document.

Paste
Pastes objects on the diagram.

Options
Opens master-detail options.

Status bar

Message
Specifies name of the table selected on the diagram.

Fetch Limit
Specify the number of rows that should be displayed in the Data view.

Where Condition
Specify an additional condition for performing data selection from tables.

ExpandedToggleIcon(9x12) See Also

Master-Detail Browser

Data View, Master-Detail Browser


Data View, Master-Detail Browser

You can view data from related tables here.

RefreshButton Refresh
Refreshes data. Apply whenever you make changes in the Design view.

StopRefresh Stop Refresh
Stops refreshing data.

show-design Show (Hide) Design
Click to return to the Design view. The Hide option appears if you are using split window layout.

Upper grid
Contains data of the master table.

Lower grid
Contains data of child table(s).

ExpandedToggleIcon(9x12) See Also

Viewing Data in Master-Detail Tables

How To: View Data in Related Tables


Object Editors

This section contains reference information on user interface. Visit following topics for detailed information.

ExpandedToggleIcon(9x12) In This Section

New Object Dialog Box
Information about dialog box where you can create a new Oracle schema object.

Table and View Editors
Contains information on user interface of table, view, materialized view, constraint and index editors.

Cluster Editor
Information on user interface of the Cluster editor.

Trigger Editor
Describes what elements trigger editor has.

User Types Editor
Describes elements of user-defined types editors.

Database Link Editor
Information on user interface of the DbLink editor.

Sequence Editor
Information on constituent parts of the Sequence editor and their functions.

Synonym Editor
Information on constituent parts of the Synonym editor and their functions.

XML Schema Editor
Describes what elements XML schema editor has.

Generate Schema Script Wizard
Describes how to create DDL script for database objects using Generate DDL Wizard.


New Object Dialog Box

Use this dialog box to create a new database object. On the Database menu, click New Database Object. New Object dialog box opens.

Location
Lists available databases on specific Oracle server instance. You may choose specific database to place your object there. If you can not find required database in the list, try to refresh it by pressing F5 or the Refresh button from the connection node shortcut menu.

Type
Lists available object types to create. Select a required object type to create, e.g. table, view etc.

Name
Name of a database object.

Create
Click the button to create an object after you have specified its parameters.

Cancel
Use the button to abort creation of a new object.

ExpandedToggleIcon(9x12) See Also

Object Editors

Table and View Editors


Table and View Editors

This section contains reference information on user interface of table, view, materialized view, constraints and indexes editors.

ExpandedToggleIcon(9x12) In This Section

Table Editor
Describes user interface elements of the table editor.

View Editor
Describes user interface elements of the view editor.

Materialized View Editor
Describes user interface elements of the materialized view editor.

Materialized View Log Editor
Describes user interface elements of the materialized view log editor.

Index Properties (Table)
Describes the Index Properties grid.

Rebuild Indexes Dialog Box
Describes the Rebuild Indexes dialog box

Constraints
Describes constraints editors.

ExpandedToggleIcon(9x12) See Also

Object Editors

Cluster Editor


Table Editor

Use table editor to modify table structure together with indexes.

ExpandedToggleIcon(9x12) In This Section

Columns, Table Editor (Relational Table)
Information on what parameters are provided at the General tab for relational tables.

Constraints, Table Editor
Information on what parameters are provided at the Constraints tab.

Indexes, Table Editor
Information on what parameters are provided at the Indexes tab.

Cluster, Table Editor
Information on what additional parameters are provided for clustered tables.

Partitioning, Table Editor
Information on setting table partition parameters.

Storage, Table Editor
Information on what parameters are provided at the Storage tab.

IOT Properties Tab
Information on what additional parameters are provided for index-organized tables.

Data, Table Editor
Describes the data tab of the Table editor

Edit Values Dialog Box
Describes the Edit Values dialog box.

Column Properties
Describes the Column Properties grid.

ExpandedToggleIcon(9x12) See Also

Working with Tables


Columns, Table Editor

Use this tab to set up a table, its name and columns. To see this tab, double-click a table in Database Explorer.

Name
Name of the table.

Owner
Owner of the table

Comment
Table comment. If it consists of more than one line, only the first line followed with dots is displayed in the field. Click the CBDropDownArrow button to view and edit multiline comment.

Type
Shows how table data rows are stored. Type of the table can be changed only when creating a table.

Initial Object

note Note

The following settings and parameters and available for the object tables only.

Schema
Shows what database the table object type belongs to.

Name
Name of the table object type.

Object identifier is primary key
Specifies that the object identifier (OID) of the object table should be based on the primary key of the table.

Template XML Schema

note Note

The following settings and parameters and available for the XML tables only.

Schema
Shows which database a source XML schema object belongs to.

XML Schema
Specify a source XML Schema.

Element
Specify an element to be stored in a table.

Storing options

note Note

The following settings and parameters and available for the XML tables only.

As defined in XML schema
Specifies if XML data have to be stored as it had been determined in a source XML Schema.

As CLOB
Specifies if XML data have to be stored as CLOBs.

Column List Grid (For Relational and Object Tables)

note Note

The following settings and parameters and available for the relational and object tables only.

The grid lists all the table columns and contains following information about them.

new-primary-key Primary
Indicates whether column is included in primary index.

Name
Column name.

Data Type
Column type.

Not Null
Indicates whether column is nullable or not.

Default
Default column value.

Comment
Column comment. If it consists of more than one line, only the first line followed with dots is displayed in the field. Click the CBDropDownArrow button to view and edit multiline comment.

Column List Grid Shortcut Menu

note Note

The following settings and parameters and available for the relational and object tables only.

New Column
Creates a new column.

Insert Column
Inserts a new column. The column will be added before the currently selected column.

Find Column
To quickly find a column, enter characters available in the required event filter's name. Only columns, names of which contain the required characters, will be shown in the list.

Search Box
Type the search string in this box.

Clear
Click to clear the search string.

Move Column Up
Moves a column up.

Move Column Down
Moves a column down.

Delete Column
Deletes a currently selected column.

Column Properties Grid

note Note

The following settings and parameters and available for the relational and object tables only.

The grid shows detailed properties of the column that is currently selected in the Column List grid. For detailed description of column properties, see Column Properties.

Text editor

Contains SQL code of the table. Changes you make in the visual part of the editor are immediately available in the Text editor.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
newsql to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Table Editor

Constraints, Table Editor


Constraints, Table Editor

On the Constraints tab you can edit constraints of the specific table. The grid lists all table constraints and contains the following information about them.

Name
Name of a constraint.

Columns
Name of a column.

Constraint Type
Constraint type. Can be Check, Unique, Primary or Foreign.

Enabled
Indicates whether a constraint is enabled. Use a double-click or a shortcut menu to edit constraints.

Constraints grid shortcut menu

Constraints tab shortcut menu appears when editing a table in a document and right-clicking anywhere on the Constraints tab. The menu contains the following items.

Add Check Constraint
Opens a dialog box where you can create a new check constraint.

Add Foreign Key
Opens a dialog where you can setup a foreign key and add it.

Add Primary Key
Opens a dialog where you can setup a primary key and add it.

Add Unique Key
Opens a dialog where you can setup a unique key and add it.

Delete Constraint
Deletes a currently selected key.

Constraint Properties

The grid shows detailed properties of the constraint that is currently selected in the Constraint List grid. For detailed description of constraint properties, see Constraint Properties.

Text editor

Contains an SQL code of the created table. Changes you make in the visual part of the editor are immediately available in the Text Editor.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
new-sql-window to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Table Editor

Indexes, Table Editor


Indexes, Table Editor

On the Indexes tab, you can edit indexes of a specific table. The grid lists all table indexes and contains the following information about them.

Index List

Name
Name of an index.

Columns
List of columns that index includes, separated by commas.

Unique
Flag showing whether an index is unique or not. Use a double-click or a shortcut menu to edit a certain index.

Indexes grid shortcut menu

Indexes tab shortcut menu appears when editing table in a document and right-clicking anywhere on Indexes tab. The menu contains the following items.

Edit Index
Opens a dialog where you can setup a currently selected index.

Add Index
Opens a dialog where you can setup an index and add it.

Delete Index
Deletes a currently selected index.

Index Properties

The grid shows detailed properties of the index that is currently selected in the Index List grid. For detailed description of index properties, see Index Properties.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
new-sql-window to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Table Editor

Cluster, Table Editor


Cluster, Table Editor

This tab is available only for clustered tables. Use this tab to set clustered table properties. To open the editor, right click a clustered table, select Edit Table, and then switch to the Cluster tab.

Schema
Select a schema which a cluster belongs to.

Cluster
Select a name of a cluster the table will be part of.

Columns grid

Use the grid to set corresponding table columns for cluster columns.

Table column
Select table columns that correspond to the cluster columns here. Only table columns of required type are available when selecting.

Cluster column
A name and a type of a cluster column are shown here.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
newsql to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Table Editor

Partitioning, Table Editor


Partitioning, Table Editor

Use the tab to set up table partitioning parameters. To see it, double-click a partitioned table at Database Explorer, then switch to the Partitioning tab. This tab is available only for Oracle servers that support partitioning.

Partition type
Set partitioning method here.

Subpartition type
Set subpartitioning method here for composite partitioning. Available only when range partitioning type is set.

Partition columns
Select columns of partitioning key here. Only one column can be selected for list partitioning.

Subpartition columns
Select columns of subpartitioning here. Only one column can be selected for range-list partitioning.

Partitions

Partitions
Shows table partitions, their subpartitions and subpartition template.

Add partition
Click to add a partition or subpartition template.

Remove
Click to remove selected item in the Partitions tree.

Name
Input selected partition or subpartition name here.

Value
Set selected partition or subpartition values here.

Tablespace
Select partition or subpartition tablespace here.

Quantity of subpartitions
Shows quantity of subpartitions for the selected partition or subpartition template, or quantity of partitions when using hash partitioning method.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
newsql to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Table Editor

Storage, Table Editor


Storage, Table Editor

On the Storage tab you can customize storage options. To open the tab, double click the table in Database Explorer, and then switch to the Storage tab.

When creating or editing partitioned table, this tab is called Def. Partition Storage and sets default storage parameters for new partitions.

Tablespace
Select a tablespace to store a table in.

Extents

Initial Size
Defines the size in bytes of the first extent in a segment.

Next Size
Defines the size in bytes of the second and subsequent extents.

Minimum
Specifies the number of extents allocated when a segment is first created in the tablespace.

Maximum
Specifies the maximum number of extents that a segment can have. Can be unlimited.

PCTINCREASE
Specifies the percent by which each extent grows after the second extent.

PCTFREE
Specifies the percentage of space in each data block of the table reserved for future updates to the table's rows. The value of PCTFREE must be a value from 0 to 99. A value of 0 allows the entire block to be filled by inserts of new rows. The default value is 10. This value reserves 10% of each block for updates to existing rows and allows inserts of new rows to fill a maximum of 90% of each block.

PCTUSED
Specifies the minimum percentage of used space that Oracle maintains for each data block of the table. A block becomes a candidate for row insertion when its used space falls below PCTUSED. PCTUSED is specified as a positive integer from 1 to 99 and defaults to 40.

Transactions

Initial Number
Specifies the initial number of transaction entries allocated within each data block allocated to the table. This value can range from 1 to 255 and defaults to 1. In general, you should not change this value from its default.

Maximum Number
Specifies the maximum number of concurrent transactions that can update a data block allocated to the table. This limit does not apply to queries. This value can range from 1 to 255 and the default is a function of the data block size. You should not change this value from its default.

Free Lists
Number of free lists in a group.

Free List Groups
Number of free list groups.

Buffer Pool
Can be any of the following:

· Keep - puts blocks from the segment into the Keep buffer pool. Maintaining an appropriately sized Keep buffer pool lets Oracle retain the schema object in memory to avoid I/O operations.
· Recycle - puts blocks from the segment into the Recycle pool. An appropriately sized Recycle pool reduces the number of objects whose default pool is the Recycle pool from taking up unnecessary cache space.
· Default - the default buffer pool.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
newsql to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Table Editor

IOT Properties, Table Editor


IOT Properties, Table Editor

This tab is available only for index-organized tables. Use this tab to set index-organized table properties. To open the editor, right-click an index-organized table, select Edit Table, and then switch to the IOT Properties tab.

Mapping table
Select the check box to instruct the database to create a mapping of local to physical ROWIDs, and store them in a heap-organized table.

Threshold
Percentage of space reserved in the index block for an index-organized table row. Must be large enough to hold the primary key. All trailing columns of a row, starting with the column that causes the specified threshold to be exceeded, are stored in the overflow segment.

Overflow
If selected, table data rows exceeding the specified threshold are placed in the overflow data segment.

Include column
Specify here a column at which to divide an index-organized table row into index and overflow portions. The primary key columns are always stored in the index. It can be the last primary key column or any non primary key column. All non primary key columns that follow the chosen column are stored in the overflow data segment.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
newsql to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Table Editor

Data, Table Editor


Data, Table Editor

This tab contains data available in the table.

Data Editor
Allows to view and quickly edit table data. For information on user interface elements of the grid, refer to Data Editor Window.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
newsql to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Table Editor

Edit Values Dialog Box


Edit Values Dialog Box

dbForge Studio for Oracle provides you with a handy interface to enumerate column values for table partitioning. The window consists of two parts: currently enumerated values and dialog elements designed to manipulate the list. Every new enumeration element is entered in a single-line text box.

To open the dialog box, right click a partitioned table you want to edit in Database Explorer, select Edit Table, and switch to the Partitioning tab. Specify or edit the partitioning type of the table, then right click in the Partitions field and select Add partition. In the Value box click the [image] button. Edit Values Dialog Box will open.

Replace
Click the button to replace a currently highlighted element in the list with a new item.

Add
Click the button to add a new list element that is entered in the single-line text box. A new item will be the last in the list.

Delete
Click the button to delete a currently highlighted element from the list.

OK
After making changes to the enumeration click OK to apply changes and close the dialog.

Cancel
Click the button to discard all changes made to the enumeration.

ExpandedToggleIcon(9x12) See Also

Table Editor

Column Properties


Column Properties

Use this dialog box to modify column properties. To invoke the dialog, double-click a table in Database Explorer, and then double-click on a column.

Column name
Name of a column. Uniqueness of the name is checked when you click the OK button.

Use ADT
If selected, allows using abstract data types.

Data type
Specify a column type.

Schema
Specify a scheme to derive abstract data types from. Available only if Use ADT option is selected.

Allow nulls
Set a column attribute indicating whether a column is nullable or not.

Unique
Set a column attribute indicating whether a column should have unique values only or not.

Primary
Make this column a primary key.

REF
Indicates whether the column has an REF attribute.

Visible
Allows to make a column disable.

Identity
Specify the corresponding options in the column's properties to generate the values.

Length
Specify the size of the column in bytes, affects YEAR, BINARY, VARBINARY, CHAR and VARCHAR data types only.

Precision
Specify precision, affects numeric data types only.

Scale
Specify the scale, affects numeric data types only.

Default value
Specify a column default value.

Comment
Specify a column comment. If comment consists of more than one line, only the first line followed with dots is displayed in the field. Click the CBDropDownArrow button of this field to view and edit a multiline comment.

note Note

You should enter correct values into the Default value field. dbForge Studio will not check it. String values should be quoted with single quotation marks. For example, if you enter "null" that means NULL value, and if you enter "'null'" that means a string "null". If the string should contain a single quotation mark, you should enter two single quotation marks. Enter "'ab''cd'" string to have "ab'cd" default value. For more details refer to the corresponding Oracle documentation.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script changes

newsql To New SQL Window
Shows script changes in a new SQL document.
to-clipboard To Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Table Editor


View Editor

Use this editor to modify a view. To invoke it, right-click a view in Database Explorer and select Edit View.

ExpandedToggleIcon(9x12) In This Section

Main, View Editor
Use this tab to modify a view name, an owner, a query, and a comment.

Query Design, View Editor
Use this tab to modify query of a view.

SQL, View Editor
Describes the SQL tab of the View editor.

Data, View Editor
Describes the Data tab of the View editor.

ExpandedToggleIcon(9x12) See Also

Table and View Editors

Materialized View Editor


Main, View Editor

Use this tab to modify a view name, an owner and a query.

Name
Name of a view. Read-only after a view had been created.

Owner
Indicates which database the view belongs to. Read-only after the view was created.

Comment
Add a view comment. If a comment consists of more than one line, only the first line followed with dots is displayed in the field. Click the CBDropDownArrow button to view and edit a multiline comment.

Query Text
Place here a query text that must represent the view. You do not have to type "CREATE OR REPLACE VIEW ... AS" because dbForge Studio adds this clause for you.

Columns

Use this grid to modify view column aliases and comments.

Alias
Specify an alias for the selected column.

Name
Specify a name for the selected column.

Comment
Specify a corresponding comment for the selected column.

Options

Force view creation
Forces view creation even if it selects data from non-existent tables, views or columns.

Restrictions

Read only
View data is read only if selected.

With check option
All updated or inserted records must correspond with a condition.

Constraint
Check the condition.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
new-sql-window to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

View Editor

Query Design, View Editor


Query Design, View Editor

Use the Query Design tab of View Editor to edit query of the view with help of query document.

For description of user interface elements of the tab, refer to the Query Builder section.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
new-sql-window to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

View Editor

SQL, View Editor


SQL, View Editor

Use the SQL tab of View Editor to edit SQL script of the view.

For description of user interface elements of the tab, refer to the SQL Editor section.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
new-sql-window to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

View Editor

Data, View Editor


Data, View Editor

This tab contains data available in the view.

Data Editor
Allows to view and quickly edit table data. For information on user interface elements of the grid, refer to Data Editor Window.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
new-sql-window to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

View Editor

Table and View Editors


Materialized View Editor

Use a materialized view editor to modify materialized views.

ExpandedToggleIcon(9x12) In This Section

Main, Materialized View Editor
Use this tab to set general materialized view parameters.

Constraints, Materialized View Editor
Use this tab to set materialized view creation and refresh options.

Indexes, Materialized View Editor
Use this tab to edit materialized view indexes.

Cluster, Materialized View Editor
Use this tab to set clustered materialized view properties.

Partitioning, Materialized View Editor
Use the tab to set materialized view partitioning parameters.

Storage, Materialized View Editor
Use this tab to set materialized view storage parameters.

IOT Properties, Materialized View Editor
Use this tab to set additional parameters for index organized materialized view.

SQL, Matreialized View Edtior
Describes the SQL tab of the Materialized View editor.

Data, Materialized View Editor
Describes the Data tab of the Materialized View editor.

ExpandedToggleIcon(9x12) See Also

Table and View Editors

Materialized View Log Editor


Main, Materialized View Editor

Use the tab to set general materialized view properties. To open the editor, double-click a materialized view in Database Explorer.

Name
Specify a name of a materialized view.

Owner
Shows what schema the materialized view belongs to.

Comment
Add a materialized view comment.

Type
Shows how materialized view data rows are stored. Type of the materialized view can be changed only when creating it.

Materialized View body
Place here the query text that must represent the materialized view.

Refresh method

Select a refresh method for a materialized view here.

Force
If possible, Oracle will use the fast method. Otherwise, it will use a complete method.

Complete
A view will be refreshed by executing the defining query of the materialized view.

Fast
A view will be refreshed incrementally (according to changes that occurred to the master tables).

Never
A view will not be refreshed with any Oracle refresh mechanism or packaged procedure. Refresh options are not available with this method.

Refresh options

Refresh mode
Select the refresh mode for a materialized view here.

On Demand
A materialized view will be refreshed on demand by calling DBMS_MVIEW refresh procedures. It will also be refreshed at start time and next time if they are specified.

On Commit
A materialized view will be refreshed each time whenever the database commits a transaction that operates on a master table of the materialized view. Oracle does not support the On Commit refresh mode for materialized views containing object types.

Refresh type
Select a refresh type for a materialized view here.

Start refresh time
Select a date and time for the first automatic refresh time.

Next refresh time
Enter a datetime expression for calculating an interval between automatic refreshes.

Master rollback segment
Optionally enter a remote rollback segment here to be used at the remote master site for the individual materialized view.

Local rollback segment
Optionally select a local rollback segment for a materialized view here.

Build mode

Select a materialized view build mode here.

Immediate
A materialized view will be populated immediately.

Deferred
A materialized view will be populated by the next refresh operation.

Prebuilt
A materialized view will be based on the existing table. The view must have the same name and the same owner that the table has.

Other creation options

Enable query rewrite
Allows a materialized view to be used for query rewrite.

Enable update
Allows a materialized view to be updated.

Use index
Means that an index that will be used for materialized view fast refresh optimization will be created. Selected by default.

Reduced precision
This option can be used for prebuilt materialized views to authorize the loss of precision that will result if the precision of the table or materialized view columns do not exactly match the precision returned by subquery. Otherwise, if the precision of the table or materialized view columns do not exactly match the precision returned by subquery, materialized view creation will fail.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
newsql to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Materialized View Editor

Constraints, Materialized View Editor


Constraints, Materialized View Editor

On the Constraints tab, you can edit constraints of the specific materialized view. The grid lists all view constraints and contains the following information about them.

Name
Name of a constraint.

Columns
Name of a column.

Constraint Type
Specify a constraint type. Can be Check, Unique,Primary or Foreign.

Enabled
Indicates whether constraint is enabled. Use double-click or shortcut menu to edit constraints.

Constraints grid shortcut menu

Constraints tab shortcut menu appears when editing a view in a document and right-clicking anywhere on the Constraints tab. The menu contains the following items.

Edit Constraint
Opens a dialog where you can setup a currently selected key.

Add Check Constraint
Opens a dialog box where you can create a new check constraint.

Add Foreign Key
Opens a dialog where you can setup a foreign key and add it.

Add Primary Key
Opens a dialog where you can setup a primary key and add it.

Add Unique Key
Opens a dialog where you can setup a unique key and add it.

Delete Constraint
Deletes a currently selected key.

Constraint Properties

The grid shows detailed properties of the constraint that is currently selected in the Constraint List grid. For detailed description of constraint properties, see Constraint Properties.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
newsql to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Materialized View Editor

Indexes, Materialized View Editor


Indexes, Materialized View Editor

On the Indexes tab, you can edit indexes of the specific materialized view. The grid lists all the table indexes and contains the following information about them.

Name
Name of an index.

Columns
List of columns that index includes, separated by commas.

Unique
Flag showing whether index is unique or not. Use double-click or shortcut menu to edit a certain index.

Indexes grid shortcut menu

The Indexes tab shortcut menu appears when editing table in a document and right-clicking anywhere on the Indexes tab. The menu contains the following items.

Edit Index
Opens a dialog where you can setup a currently selected index.

Add Index
Opens a dialog where you can setup an index and add it.

Delete Index
Deletes a currently selected index.

Index Properties

The grid shows detailed properties of the index that is currently selected in the Index List grid. For detailed description of index properties, see Index Properties.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
newsql to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Materialized View Editor

Cluster, Materialized View Editor


Cluster, Materialized View Editor

This tab is available only for clustered materialized views. Use this tab to set clustered materialized view properties. To open the editor, right click a clustered materialized view, select Edit Materialized View, and then switch to the Cluster tab.

Schema
Select a schema which a cluster belongs to.

Cluster
Select a name of a cluster the materialized view will be part of.

Columns grid

Use the grid to set corresponding materialized view columns for cluster columns.

Table column
Select materialized view columns that correspond to the cluster columns here. Only materialized view columns of required type are available when selecting.

Cluster column
A name and a type of a cluster column are shown here.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
newsql to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Materialized View Editor

Partitioning, Materialized View Editor


Partitioning, Materialized View Editor

Use this tab to set up table partitioning parameters. To see it, double-click a partitioned table in Database Explorer, then switch to the Partitioning tab. This tab is available only for Oracle servers, that support partitioning.

Partition type
Set a partitioning method here.

Subpartition type
Set a subpartitioning method here for composite partitioning. Available only when the range partitioning type is set.

Partition columns
Select columns of a partitioning key here. Only one column can be selected for list partitioning.

Subpartition columns
Select columns of subpartitioning here. Only one column can be selected for range-list partitioning.

Partitions

Add
Click to add a partition, subpartitions or subpartition templates.

Remove
Click to remove the selected item in the Partitions tree.

Partitions
Shows table partitions, their subpartitions and subpartition templates.

Name
Input the selected partition or a subpartition name here.

Value
Set the selected partition or subpartition values here.

Tablespace
Select a partition or subpartition tablespace here.

Quantity of subpartitions
Shows quantity of subpartitions for the selected partition or subpartition template, or quantity of partitions when using the hash partitioning method.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
newsql to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Materialized View Editor

Storage, Materialized View Editor


Storage, Materialized View Editor

Use this tab to set up table storage options. To see this dialog, double-click a table in Database Explorer, and then switch to the Storage tab.

When creating or editing a partitioned table, this tab is called Def. Partition Storage and sets default storage parameters for new partitions.

Tablespace
Select a tablespace to store a table in.

Extents

Initial Size
Defines the size in bytes of the first extent in the segment.

Next Size
Defines the size in bytes of the second and subsequent extents.

Minimum
Specifies the number of extents allocated when a segment is first created in the tablespace.

Maximum
Specifies the maximum number of extents that a segment can have. Can be unlimited.

PCTINCREASE
Specifies the percent by which each extent grows after the second extent.

PCTFREE
Specifies the percentage of space in each data block of the table reserved for future updates to the table's rows. The value of PCTFREE must be a value from 0 to 99. A value of 0 allows the entire block to be filled by inserts of new rows. The default value is 10. This value reserves 10% of each block for updates to existing rows and allows inserts of new rows to fill a maximum of 90% of each block.

PCTUSED
Specifies the minimum percentage of used space that Oracle maintains for each data block of the table. A block becomes a candidate for a row insertion when its used space falls below PCTUSED. PCTUSED is specified as a positive integer from 1 to 99 and defaults to 40.

Transactions

Initial Number
Specifies the initial number of transaction entries allocated within each data block allocated to the table. This value can range from 1 to 255 and defaults to 1. In general, you should not change this value from its default.

Maximum Number
Specifies the maximum number of concurrent transactions that can update a data block allocated to the table. This limit does not apply to queries. This value can range from 1 to 255 and the default is a function of the data block size. You should not change this value from its default.

Free Lists
Number of free lists in a group.

Free List Groups
Number of free list groups.

Buffer Pool
Can be any of the following:

· Keep - puts blocks from the segment into the Keep buffer pool. Maintaining an appropriately sized Keep buffer pool lets Oracle retain the schema object in memory to avoid I/O operations.
· Recycle - puts blocks from the segment into the Recycle pool. An appropriately sized Recycle pool reduces the number of objects whose default pool is the Recycle pool from taking up unnecessary cache space.
· Default - the default buffer pool.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
newsql to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Materialized View Editor

IOT Properties, Materialized View Editor


IOT Properties, Materialized View Editor

This tab is available only for index-organized views. Use this tab to set index-organized view properties. To open the editor, double-click an index-organized view, and then switch to the IOT Properties tab.

IOT Properties

Mapping table
Select the check box to instruct the database to create a mapping of local to physical ROWIDs and store them in a heap-organized table.

Threshold
Percentage of space reserved in the index block for an index-organized table row. Must be large enough to hold the primary key. All trailing columns of a row, starting with the column that causes the specified threshold to be exceeded, are stored in the overflow segment.

Overflow
If selected, table data rows exceeding the specified threshold are placed in the overflow data segment.

Include column
Specify here a column at which to divide an index-organized table row into index and overflow portions. The primary key columns are always stored in the index. It can be the last primary key column or any non primary key column. All non primary key columns that follow the chosen column are stored in the overflow data segment.

RefreshButton Refresh Object
Click to refresh the edited object from the database.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
newsql to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Materialized View Editor

SQL, Matreialized View Edtior


SQL, Matreialized View Edtior

Use the SQL tab of View Editor to edit SQL script of the view.

For description of user interface elements of the tab, refer to the SQL Editor section.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
new-sql-window to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Materialized View Editor

Data, Materialized View Editor


Data, Materialized View Editor

This tab contains data available in the table.

Data Editor
Allows to view and quickly edit table data. For information on user interface elements of the grid, refer to Data Editor Window.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
newsql to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Materialized View Editor

Materialized View Log Editor


Materialized View Log Editor

Use the materialized view log editor to modify materialized view logs.

ExpandedToggleIcon(9x12) In This Section

General, Materialized View Log Editor
Use this tab to set general materialized view log parameters.

Storage, Materialized View Log Editor
Use this tab to set materialized view log storage parameters.

Partitioning, Materialized View Log Editor
Use this tab to set materialized view log partitioning parameters. Not available for existing non-partitioned materialized view logs.

ExpandedToggleIcon(9x12) See Also

Table and View Editors

Index Properties


Main, Materialized View Log Editor

Use this tab to set general materialized view properties. To open the editor, double-click a table in Database Explorer.

Schema
Owner of the table which a materialized view log will be created on.

Table
Table which a materialized view log will be created on.

Options

Primary key
Select the check box to specify that the primary key of all rows changed should be recorded in the materialized view log. Selected by default. To clear it, you should select Row ID or Object ID check box first.

Row ID
Select to specify that the row id of all rows changed should be recorded into the materialized view log.

Object ID
Select this option for object table materialized view log only to specify that object identifier of every modified row should be recorded in the materialized view log.

Sequence
Select to indicate that a sequence value providing additional ordering information should be recorded in the materialized view log. Sequence numbers are necessary to support fast refresh after some update scenarios.

Include New Values
Select to save both old and new values for update DML operations in the materialized view log. Check, if there is a single-table materialized aggregate view on this table and you want it to be eligible for fast refresh.

Columns

Select table columns whose values you want to be recorded in the materialized view log for all rows that are changed.

Primary Key
Indicates primary key columns.

With Primary Key
Indicates columns with primary keys.

Name
Name of the table column.

Text editor
Contains SQL code of the created table. Changes you make in the visual part of the editor are immediately available in the Text editor.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
new-sql-window to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Materialized View Log Editor

Storage, Materialized View Log Editor


Storage, Materialized View Log Editor

Use this tab to set up table storage options. To see this dialog, double-click a table in Database Explorer, and then switch to the Storage tab.

When creating or editing a partitioned table, this tab is called Def. Partition Storage and sets default storage parameters for new partitions.

Tablespace
Select a tablespace to store a table in.

Extents

Initial Size
Defines the size in bytes of the first extent in the segment.

Next Size
Defines the size in bytes of the second and subsequent extents.

Minimum
Specifies the number of extents allocated when a segment is first created in the tablespace.

Maximum
Specifies the maximum number of extents that a segment can have. Can be unlimited.

PCTINCREASE
Specifies the percent by which each extent grows after the second extent.

PCTFREE
Specifies the percentage of space in each data block of the table reserved for future updates to the table's rows. The value of PCTFREE must be a value from 0 to 99. A value of 0 allows the entire block to be filled by inserts of new rows. The default value is 10. This value reserves 10% of each block for updates to existing rows and allows inserts of new rows to fill a maximum of 90% of each block.

PCTUSED
Specifies the minimum percentage of used space that Oracle maintains for each data block of the table. A block becomes a candidate for row insertion when its used space falls below PCTUSED. PCTUSED is specified as a positive integer from 1 to 99 and defaults to 40.

Transactions

Initial Number
Specifies the initial number of transaction entries allocated within each data block allocated to the table. This value can range from 1 to 255 and defaults to 1. In general, you should not change this value from its default.

Maximum Number
Specifies the maximum number of concurrent transactions that can update a data block allocated to the table. This limit does not apply to queries. This value can range from 1 to 255 and the default is a function of the data block size. You should not change this value from its default.

Free Lists
Number of free lists in a group.

Free List Groups
Number of free list groups.

Buffer Pool
Can be any of the following:

· Keep - puts blocks from the segment into the Keep buffer pool. Maintaining an appropriately sized Keep buffer pool lets Oracle retain the schema object in memory to avoid I/O operations.
· Recycle - puts blocks from the segment into the Recycle pool. An appropriately sized Recycle pool reduces the number of objects whose default pool is the Recycle pool from taking up unnecessary cache space.
· Default - the default buffer pool.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
new-sql-window to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Materialized View Log Editor

Partitioning, Materialized View Log Editor


Partitioning, Materialized View Log Editor

Use this tab to set up table partitioning parameters. To see it, double-click a partitioned table in Database Explorer, and then switch to the Partitioning tab. This tab is available only for Oracle servers that support partitioning.

Partitioning type
Set partitioning method here.

Subpartitioning type
Set subpartitioning method here for composite partitioning. Available only when the range partitioning type is set.

Partition columns
Select columns of partitioning key here. Only one column can be selected for list partitioning.

Subpartition columns
Select columns of subpartitioning here. Only one column can be selected for range-list partitioning.

Partitions

Partitions
Shows table partitions, their subpartitions and subpartition templates.

Add
Click to add partition, subpartitions or subpartition templates.

Remove
Click to remove the selected item in the Partitions tree.

Name
Input the selected partition or a subpartition name here.

Value
Set the selected partition or subpartition values here.

Tablespace
Select a partition or subpartition tablespace here.

Quantity of subpartitions
Shows quantity of subpartitions for the selected partition or subpartition template, or quantity of partitions when using the hash partitioning method.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
new-sql-window to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Materialized View Log Editor

Table and View Editors


Index Properties (Table)

Use this grid to modify table index properties. To view the grid, double-click an object in Database Explorer, then switch to the Indexes tab and click an index. Note that most of options are unavailable for changes once you have saved the index. Tabs of this grid are listed below.

ExpandedToggleIcon(9x12) In This Section

Use this tab to modify general index properties.

Storage, Index Properties
Use this tab to modify storage index properties.

Partitioning, Index Properties
Use this tab to modify partitioning index properties.

ExpandedToggleIcon(9x12) See Also

Table and View Editors

Constraint Properties


General, Index Properties (Table)

Use this tab to modify general index properties.

Index name
Name of an index. Uniqueness of the name is checked when you press the OK button. Index name cannot be empty.

Partitioning

None
The index is not partitioned.

Local
The index has the same partitioning structure that a table has.

Global
The index has his own partitioning structure. You can set index partitioning parameters on the Partitioning tab.

Options

Unique
Identifies that the index is a unique index.

Bitmap
Identifies that the index is a bitmap index.

Reverse
Identifies that the index is a reverse index.

Unsorted
Identifies that the index is an unsorted index.

Visible
Identifies that the index is an visible index.

Index columns

Lists table columns that are participating in an index. Index must include at least one column.

Name
Specifies the name of a column.

Data Type
Specifies the data type of a column

Allow nulls
Indicates whether the column accepts null values.

Sort order
Indicates whether the data is sorted in ascending (ASC) or in descending (DESC) order.

ExpandedToggleIcon(9x12) See Also

Index Properties

Storage, Index Properties


Storage, Index Properties (Table)

Use this tab to set up index storage options. To see this dialog, double-click an index in Database Explorer, then switch to the Storage tab.

Tablespace
Select a tablespace to store an index in.

Extents

Initial Size
Defines the size in bytes of the first extent in the segment.

Next Size
Defines the size in bytes of the second and subsequent extents.

Minimum
Specifies the number of extents allocated when a segment is first created in the tablespace.

Maximum
Specifies the maximum number of extents that a segment can have. Can be unlimited.

PCTINCREASE
Specifies the percent by which each extent grows after the second extent.

PCTFREE
Specifies the percentage of space in each data block of the index reserved for future updates to the table's rows. The value of PCT Free must be a value from 0 to 99. A value of 0 allows the entire block to be filled by inserts of new rows. The default value is 10. This value reserves 10% of each block for updates to existing rows and allows inserts of new rows to fill a maximum of 90% of each block.

PCTUSED
Specifies the minimum percentage of used space that Oracle maintains for each data block of the index. A block becomes a candidate for row insertion when its used space falls below PCT Used. PCT Used is specified as a positive integer from 1 to 99 and defaults to 40.

Transactions

Initial Number
Specifies the initial number of transaction entries allocated within each data block allocated to the index. This value can range from 1 to 255 and defaults to 1. In general, you should not change this value from its default.

Maximum Number
Specifies the maximum number of concurrent transactions that can update a data block allocated to the index. This limit does not apply to queries. This value can range from 1 to 255 and the default is a function of the data block size. You should not change this value from its default.

Free Lists
Number of free lists in a group.

Free List Groups
Number of free list groups.

Buffer Pool
Can be any of the following:

· Keep - puts blocks from the segment into the Keep buffer pool. Maintaining an appropriately sized Keep buffer pool lets Oracle retain the schema object in memory to avoid I/O operations.
· Recycle - puts blocks from the segment into the Recycle pool. An appropriately sized Recycle pool reduces the number of objects whose default pool is the Recycle pool from taking up unnecessary cache space.
· Default - the default buffer pool.

ExpandedToggleIcon(9x12) See Also

Index Properties

Partitioning, Index Properties


Partitioning, Index Properties Dialog Box

Use this tab to set up index partitioning parameters. To see it double-click on an index in Database Explorer, then switch to Partitioning tab.

Partition type
Set partitioning method here.

Subpartition type
Cannot be set for index because partitions of index cannot be divided to subpartitions.

Partition columns
Select columns of a partitioning key here.

Subpartition columns
Cannot be set for an index because partitions of an index cannot be divided to subpartitions.

Partitions
Shows partitions of an index.

Name
Input the selected partition name here.

Value
Set selected partition values here.

Tablespace
Select a partition tablespace here.

Quantity of subpartitions
Shows quantity of partitions when using the hash partitioning method.

Add
Click to add a partition.

Remove
Click to remove the selected partition in the Partitions tree.

ExpandedToggleIcon(9x12) See Also

Index Properties

Constraint Properties


Constraint Properties

This section contains reference information on constraints editors.

ExpandedToggleIcon(9x12) In This Section

Primary Key Properties Dialog Box
Information on what properties of primary key you can alter in the grid.

Foreign Key Properties Dialog Box
Information on what properties of foreign key you can alter in the grid.

Unique Key Properties Dialog Box
Information on what properties of unique key you can alter in the grid.

Check Constraint Properties Dialog Box
Information on what properties of check constraint you can alter in the grid.

ExpandedToggleIcon(9x12) See Also

Table and View Editors

Cluster Editor


Check Constraint Properties

This grid allows to edit options for check constraints. You can invoke it by double-clicking on a constraint in Database Explorer or in the Constraints tab of the table editor.

Name
Name of the constraint.

Options

Enabled
If selected, adds the ENABLE keyword to SQL statement generated by the editor; otherwise, adds the DISABLE keyword.

Validate
If selected, adds the VALIDATE keyword to SQL statement generated by the editor; otherwise, adds the NOVALIDATE keyword. This option is bound with the previous one. If you alter either of Enabled or Validate options, they will be both included in the SQL query.

Deferrable
Indicates whether or not, in subsequent transactions, constraint checking can be deferred until the end of the transaction using the SET CONSTRAINT(S) statement. This option is available only when creating a key.

Rely
If selected, adds the RELY keyword to SQL statement generated by the editor; otherwise, adds the NORELY keyword. Not available when creating a key.

Deferred
If selected, conditions specified by the deferrable constraint are checked when the transaction is committed; otherwise, they are checked immediately on issuing the DML statement. Not available if the Deferrable option is not selected.

Condition
Contains check condition. This field is available only when the constraint is being created. When altering it, the field is read-only.

ExpandedToggleIcon(9x12) See Also

Constraint Properties

Primary Key Properties


Primary Key Properties

Use this grid to modify the primary key properties. To view the grid, switch to the Constraints tab of the object editor, and click a primary key in the list. Note that most of options are unavailable for changes once you have saved the key.

ExpandedToggleIcon(9x12) In This Section

General, Primary Key Properties Dialog Box
Use this tab to modify general primary key properties.

Storage, Primary Key Properties Dialog Box
Use this tab to modify storage primary key properties.


General, Primary Key Properties

Use this tab to set up the primary key general options. To see this dialog, double-click an primary key in Database Explorer, then switch to the the General tab.

Name
Name of the key. Uniqueness of the name is checked when you click the OK button. The Name text box cannot be empty.

Using Index
Select the index, that will be referenced by the key from the drop-down list box.

Default
Select to use the default index properties.

Custom
Select to use the custom index properties. The option becomes available if any changes were made in the Storage tab.

<Existing Index Name>
Select the existing index to use its settings.

note Note

The Storage tab options cannot be edited if the existing index is selected.

Options

Enabled
Specifies whether the constraint is enabled.

Validate
Specifies whether the constraint is validated.

Deferrable
Specifies whether the constraint is deferrable.

Rely
Indicates whether the enabled constraint is enforced or unenforced.

Deferred
Specifies whether the constraint is deferred.

Constraint columns

List of columns in the table that are included in the key.

Name
Specifies the name of the column participating in the key.

Data type
Specifies the data type of the column.

Not Null
Indicates whether the column accepts the null values.

Constraint columns shortcut menu

Remove
Click the button to delete the selected constraint column from the grid.

Move up
Click the button to move the constraint column up in the grid.

Move down
Click the button to move the constraint column down in the grid.

ExpandedToggleIcon(9x12) See Also

Primary Key Properties

Storage, Primary Key Properties


Storage, Primary Key Properties

Use this tab to set up the primary key storage options. To see this dialog, right-click the Constraints node, select New Primary Key from the shortcut menu, and then switch to the Storage tab of the Primary Key Properties dialog box.

note Note

The Storage tab is only available for new keys.

Tablespace
Select a tablespace to store the key in.

Extents

Initial Size
Shows the size in bytes of the first extent in the segment. The specified value for the option is based on data of the selected index and cannot be edited.

Next Size
Shows the size in bytes of the second and subsequent extents. The specified value for the option is based on data of the selected index and cannot be edited.

Minimum
Shows the number of extents allocated when a segment is first created in the tablespace. The specified value for the option is based on data of the selected index and cannot be edited.

Maximum
Shows the maximum number of extents that a segment can have. Can be unlimited. The specified value for the option is based on data of the selected index and cannot be edited.

PCTINCREASE
Shows the percent by which each extent grows after the second extent. The specified value for the option is based on data of the selected index and cannot be edited.

PCTFREE
Specifies the percentage of space in each data block of the key reserved for future updates to the table's rows. The value of PCT Free must be a value from 0 to 99. A value of 0 allows the entire block to be filled by inserts of new rows. The default value is 10. This value reserves 10% of each block for updates to existing rows and allows inserts of new rows to fill a maximum of 90% of each block.

PCTUSED
Shows the minimum percentage of used space that Oracle maintains for each data block of the key. A block becomes a candidate for row insertion when its used space falls below PCT Used. PCT Used is specified as a positive integer from 1 to 99 and defaults to 40. The specified value for the option is based on data of the selected index and cannot be edited.

Transactions

Initial Number
Specifies the initial number of transaction entries allocated within each data block allocated to the key. This value can range from 1 to 255 and defaults to 1. In general, you should not change this value from its default.

Maximum Number
Specifies the maximum number of concurrent transactions that can update a data block allocated to the key. This limit does not apply to queries. This value can range from 1 to 255 and the default is a function of the data block size. You should not change this value from its default.

Free Lists
Number of free lists in a group.

Free List Groups
Number of free list groups.

Buffer Pool
Can be any of the following:

· Keep - puts blocks from the segment into the Keep buffer pool. Maintaining an appropriately sized Keep buffer pool lets Oracle retain the schema object in memory to avoid I/O operations.
· Recycle - puts blocks from the segment into the Recycle pool. An appropriately sized Recycle pool reduces the number of objects whose default pool is the Recycle pool from taking up unnecessary cache space.
· Default - the default buffer pool.

ExpandedToggleIcon(9x12) See Also

Primary Key Properties

General, Primary Key Properties


Foreign Key Properties

Use this dialog box to modify foreign key properties. To invoke the dialog, double-click a table in Database Explorer, then switch to the Constraints tab and double-click a foreign key. Note, that most of options are unavailable for changes once you have saved a foreign key. Tabs of this dialog box are listed below.

Name
Name of the foreign key. Uniqueness of the name is checked when you click the OK button.

Referenced Schema Name
Schema that contains referenced constraint.

Delete Rule
Specify action that must take place on row deletion. This can be Cascade, No Action, or Set Null. You cannot change this setting after you have created the key.

Referenced Table Name
Name of the table the key references to. Below is the name of the constraint the key references to.

Options

Enabled
If selected, adds the ENABLE keyword to an Oracle statement generated by an editor; otherwise, adds the DISABLE keyword.

Validate
If selected, adds the VALIDATE keyword to an Oracle statement generated by an editor; otherwise, adds the NOVALIDATE keyword. This option is bound with the previous one. If you alter either of ENABLE or VALIDATE options they will be both included in the Oracle query.

Deferrable
Indicates whether or not, in subsequent transactions, constraint checking can be deferred until the end of the transaction using the SET CONSTRAINT(S) statement. This option is available only when creating a key.

Rely
If selected, adds the RELY keyword to an Oracle statement generated by an editor; otherwise, adds the NORELY keyword. Not available when creating a key.

Deferred
If selected, conditions specified by the deferrable constraint are checked when the transaction is committed; otherwise, they are checked immediately on issuing the DML statement. Not available if Deferrable option is not selected.

Constraint Columns
List of columns in the table that are included in the key.

Referenced Columns
List of columns involved in referenced constraint.

ExpandedToggleIcon(9x12) See Also

Constraint Properties

Unique Key Properties


Unique Key Properties

Use this grid to modify the unique key properties. To view the grid, switch to the Constraints tab of the object editor, and click a unique key. Note that most of options are unavailable for changes once you have saved the key.

ExpandedToggleIcon(9x12) In This Section

General, Unique Key Properties Dialog Box
Use this tab to modify general unique key properties.

Storage, Unique Key Properties Dialog Box
Use this tab to modify storage unique key properties.


General, Unique Key Properties

Use this tab to set up the unique key general options. To see this dialog, double-click the unuque key in Database Explorer, then switch to the the General tab.

Name
The name of the key. Uniqueness of the name is checked when you click the OK button. The Name text box cannot be empty.

Using Index
Select the index, that will be referenced by the key from the drop-down list box.

Default
Select to use the default index properties.

Custom
Select to use the custom index properties. The option becomes available if any changes were made in the Storage tab.

<Existing Index Name>
Select an existing index to use its settings.

note Note

The Storage tab options cannot be edited if an existing index is selected.

Options

Enabled
Specifies whether the constraint is enabled.

Validate
Specifies whether the constraint is validated.

Deferrable
Specifies whether the constraint is deferrable.

Rely
Indicates whether the enabled constraint is enforced or unenforced.

Deferred
Specifies whether the constraint is deferred.

Constraint columns

List of columns in the table that are included in the key.

Move column up
Click the button to move the constraint column up in the grid.

Move column down
Click the button to move the constraint column down in the grid.

Delete column
Click the button to delete the selected constraint column from the grid.

Constraint key columns Grid

Name
Specifies the name of the column participating in the key.

Data type
Specifies the data type of the column.

Not Null
Indicates whether the column accepts the null values.

ExpandedToggleIcon(9x12) See Also

Unique Key Properties Dialog Box

Storage, Unique Key Properties Dialog Box


Storage, Unique Key Properties

Use this tab to set up the unique key storage options. To see this dialog, right-click the Constraints node, select New Unique Key from the shortcut menu, and then switch to the Storage tab of the Unique Key Properties dialog box.

note Note

The Storage tab is only available for new keys.

Tablespace
Select a tablespace to store the key in.

Extents

Initial Size
Shows the size in bytes of the first extent in the segment. The specified value for the option is based on data of the selected index and cannot be edited.

Next Size
Shows the size in bytes of the second and subsequent extents. The specified value for the option is based on data of the selected index and cannot be edited.

Minimum
Shows the number of extents allocated when a segment is first created in the tablespace. The specified value for the option is based on data of the selected index and cannot be edited.

Maximum
Shows the maximum number of extents that a segment can have. Can be unlimited. The specified value for the option is based on data of the selected index and cannot be edited.

PCTINCREASE
Shows the percent by which each extent grows after the second extent. The specified value for the option is based on data of the selected index and cannot be edited.

PCTFREE
Specifies the percentage of space in each data block of the key reserved for future updates to the table's rows. The value of PCT Free must be a value from 0 to 99. A value of 0 allows the entire block to be filled by inserts of new rows. The default value is 10. This value reserves 10% of each block for updates to existing rows and allows inserts of new rows to fill a maximum of 90% of each block.

PCTUSED
Shows the minimum percentage of used space that Oracle maintains for each data block of the key. A block becomes a candidate for row insertion when its used space falls below PCT Used. PCT Used is specified as a positive integer from 1 to 99 and defaults to 40. The specified value for the option is based on data of the selected index and cannot be edited.

Transactions

Initial Number
Specifies the initial number of transaction entries allocated within each data block allocated to the key. This value can range from 1 to 255 and defaults to 1. In general, you should not change this value from its default.

Maximum Number
Specifies the maximum number of concurrent transactions that can update a data block allocated to the key. This limit does not apply to queries. This value can range from 1 to 255 and the default is a function of the data block size. You should not change this value from its default.

Free Lists
Number of free lists in a group.

Free List Groups
Number of free list groups.

Buffer Pool
Can be any of the following:

· Keep - puts blocks from the segment into the Keep buffer pool. Maintaining an appropriately sized Keep buffer pool lets Oracle retain the schema object in memory to avoid I/O operations.
· Recycle - puts blocks from the segment into the Recycle pool. An appropriately sized Recycle pool reduces the number of objects whose default pool is the Recycle pool from taking up unnecessary cache space.
· Default - the default buffer pool.

ExpandedToggleIcon(9x12) See Also

Unique Key Properties Dialog Box

General, Unique Key Properties Dialog Box


Cluster Editor

Use cluster editor to modify clusters.

ExpandedToggleIcon(9x12) In This Section

Columns, Cluster Editor
Use this tab to set general cluster parameters.

Options, Cluster Editor
Use this tab to set cluster type and size.

Storage, Cluster Editor
Use this tab to set cluster storage parameters.

Index Properties Dialog Box
Use this dialog to set cluster index parameters for index clusters.

ExpandedToggleIcon(9x12) See Also

Object Editors

Trigger Editor


Columns, Cluster Editor

Use this tab to set general cluster properties and columns.

Name
Name of a cluster.

Owner
Shows the database the cluster belongs to.

General tab of the cluster editor allows you to edit cluster key column collection. Grid lists all the cluster key columns and contains the following information about them.

Name
Column name.

Data Type
Column type.

Length
Specify a length of a column if applicable.

Units
Specify column size measurement units. Available values are: CHAR, BYTE, As Defined.

Precision
Specify a precision, affects numeric data types only.

Scale
Specify a scale, affects numeric data types only.

Text editor

Contains SQL code of the created cluster. Changes you make in the visual part of the editor are immediately available in the Text editor.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
new-sql-window to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Cluster Editor

Options, Cluster Editor


Options, Cluster Editor

Use this tab to set a cluster type and a size.

Cluster Type

Index
Select to enable creating an index cluster.

Create index
Click to create a cluster index.

Hash
Creates a hash cluster.

Number of keys
Specify the number of hash values for a hash cluster here.

Single table
Creates a hash cluster for a single table.

Hash function
Determines a hash function for a hash cluster.

Size
Specify the amount of space in bytes reserved to store all rows with the same cluster key value or the same hash value.

Index Properties

The grid shows detailed properties of the cluster index. For detailed description of index properties, see Index Properties (Cluster).

refresh-object Refresh Object
Click to refresh the edited object from the database.

script-changes Script changes

newsql To New SQL Window
Shows script changes in a new SQL document.
to-clipboard To Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

ExpandedToggleIcon(9x12) See Also

Cluster Editor

Storage, Cluster Editor


Storage, Cluster Editor

Use this tab to set up table storage options. To open the dialog box, double-click a table in Database Explorer, then switch to the Storage tab.

When creating or editing partitioned table, this tab is called Def. Partition Storage and sets default storage parameters for new partitions.

Tablespace
Select a tablespace to store a table in.

Extents

Initial Size
Defines a size in bytes of the first extent in the segment.

Next Size
Defines a size in bytes of the second and subsequent extents.

Minimum
Specifies a number of extents allocated when a segment is first created in the tablespace.

Maximum
Specifies a maximum number of extents that a segment can have. Can be unlimited.

PCTINCREASE
Specifies a percent by which each extent grows after the second extent.

PCTFREE
Specifies a percentage of space in each data block of the table reserved for future updates to the table's rows. The value of PCTFREE must be a value from 0 to 99. A value of 0 allows the entire block to be filled by inserts of new rows. The default value is 10. This value reserves 10% of each block for updates to existing rows and allows inserts of new rows to fill a maximum of 90% of each block.

PCTUSED
Specifies a minimum percentage of used space that Oracle maintains for each data block of the table. A block becomes a candidate for row insertion when its used space falls below PCTUSED. PCTUSED is specified as a positive integer from 1 to 99 and defaults to 40.

Transactions

Initial Number
Specifies the initial number of transaction entries allocated within each data block allocated to the table. This value can range from 1 to 255 and defaults to 1. In general, you should not change this value from its default.

Maximum Number
Specifies a maximum number of concurrent transactions that can update a data block allocated to the table. This limit does not apply to queries. This value can range from 1 to 255 and the default is a function of the data block size. You should not change this value from its default.

Free Lists
Number of free lists in a group.

Free List Groups
Number of free list groups.

Buffer Pool
Can be any of the following:

· Keep - puts blocks from the segment into the Keep buffer pool. Maintaining an appropriately sized Keep buffer pool lets Oracle retain the schema object in memory to avoid I/O operations.
· Recycle - puts blocks from the segment into the Recycle buffer pool. An appropriately sized Recycle pool reduces the number of objects whose default pool is the Recycle pool from taking up unnecessary cache space.
· Default - the default buffer pool.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script changes

newsql To New SQL Window
Shows script changes in a new SQL document.
to-clipboard To Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Cluster Editor

Index Properties (Cluster)


Index Properties (Cluster)

Use this grid to modify cluster index properties. To invoke the dialog, open the cluster editor for the index cluster, switch to the Options tab and click the Edit button. Tabs of this dialog box are listed below.

ExpandedToggleIcon(9x12) In This Section

General, Index Properties Dialog Box
Use this tab to modify general cluster index properties.

Storage, Index Properties Dialog Box
Use this tab to modify cluster index storage properties.


General, Index Properties Dialog Box

General, Index Properties Dialog Box (Cluster)

Use this tab to modify general cluster index properties.

Name
Name of an index. Uniqueness of the name is checked when you click the OK button. The Index name cannot be empty.

Options

Lists some options available for an index. All of them except for Reverse are unavailable after index creation. Options do not available for a cluster index.

Bitmap
Set to indicate that an index is to be created with a bitmap for each distinct key, rather than indexing each row separately. Bitmap indexes store the row ids associated with a key value as a bitmap. Each bit in the bitmap corresponds to a possible row id. If the bit is set, then it means that the row with the corresponding row id contains the key value. The internal representation of bitmaps is the best suited for applications with low levels of concurrent transactions.

Unsorted
You can specify Unsorted option to indicate to the database that the rows are already stored in the database in ascending order, so that Oracle does not have to sort the rows when creating an index. If the rows of an indexed column or columns are not stored in ascending order, then the database returns an error. You cannot specify both Unsorted and Reverse options.

Reverse
Specify the Reverse option to store the bytes of the index block in reverse order, excluding the row id. You cannot specify both Unsorted and Reverse options.

Visible
Allows to make a column disable.

Index columns

Lists table columns that are participating in an index. Index must include at least one column.

Name
Specifies the name of a column.

Data Type
Specifies the data type of a column

Not Null
Indicates whether the column accepts null values.

Sort order
Indicates whether the data is sorted in ascending (ASC) or in descending (DESC) order.

ExpandedToggleIcon(9x12) See Also

Index Properties (Cluster)

Storage, Cluster Editor


Storage, Index Properties Dialog Box

Use this tab to set up cluster index storage options.

Tablespace
Choose a tablespace to store an index in.

Extents

Initial Size
Defines a size in bytes of the first extent in the segment.

Next Size
Defines a size in bytes of the second and subsequent extents.

Minimum
Specifies a number of extents allocated when a segment is first created in the tablespace.

Maximum
Specifies a maximum number of extents that a segment can have. Can be unlimited.

PCT Increase
Specifies a percent by which each extent grows after the second extent.

PCT Free
Specifies a percentage of space in each data block of the index reserved for future updates to the table's rows. The value of PCT Free must be a value from 0 to 99. A value of 0 allows the entire block to be filled by inserts of new rows. The default value is 10. This value reserves 10% of each block for updates to existing rows and allows inserts of new rows to fill a maximum of 90% of each block.

PCT Used
Specifies a minimum percentage of used space that Oracle maintains for each data block of an index. A block becomes a candidate for row insertion when its used space falls below PCT Used. PCT Used is specified as a positive integer from 1 to 99 and defaults to 40.

Transactions

Initial Number
Specifies the initial number of transaction entries allocated within each data block allocated to an index. This value can range from 1 to 255 and defaults to 1. In general, you should not change this value from its default.

Maximum Number
Specifies a maximum number of concurrent transactions that can update a data block allocated to an index. This limit does not apply to queries. This value can range from 1 to 255 and the default is a function of the data block size. You should not change this value from its default.

Free Lists
Number of free lists in a group.

Free List Groups
Number of free list groups.

Buffer Pool
Can be any of the following:

· Keep - puts blocks from the segment into the Keep buffer pool. Maintaining an appropriately sized Keep buffer pool lets Oracle retain the schema object in memory to avoid I/O operations.
· Recycle - puts blocks from the segment into the Recycle buffer pool. An appropriately sized Recycle pool reduces the number of objects whose default pool is the Recycle buffer pool from taking up unnecessary cache space.
· Default - the default buffer pool.

ExpandedToggleIcon(9x12) See Also

Cluster Editor

Trigger Editor


Trigger Editor

Use the Trigger Editor to modify triggers on table, view, schema, or database.

ExpandedToggleIcon(9x12) In This Section

Main, Trigger Editor
Information on what parameters are provided at the General tab.

SQL, Trigger Editor
Describes SQL tab of the Trigger editor.

ExpandedToggleIcon(9x12) See Also

Object Editors

User Types Editor


Main, Trigger Editor

Use this tab to enable and disable the trigger and to setup a trigger name, body and a database object it will be associated with. To see this tab, double-click a trigger in Database Explorer.

Name
Name of a trigger.

Owner
Shows the dbForge Studio the trigger belongs to.

Enable
Switches trigger on or off.

Trigger on

Table
Sets a trigger to be executed by an event from a table.

View
Sets a trigger to be executed by an event from a view.

Schema
Sets a trigger to be executed by an event from a schema.

Database
Sets a trigger to be executed by an event from a database.

Trigger Body
Contains PL/SQL block that represents a trigger body.

Events

Choose events that fire a trigger. The contents of the Events grid depends on the trigger type:

· for a detailed set of optionss available for the table and view events, refer to the Event, Trigger Editor (Table and View) topic.
· for a detailed set of options available for the schema and database events, see the Event, Trigger Editor (Schema and Database) topic.

RefreshButton Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script changes

newsql To New SQL Window
Shows script changes in a new SQL document.
to-clipboard To Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Triggers


Event, Trigger Editor (Table and View)

Use the Event tab to choose events that fire a trigger. To see this grid, double-click a trigger in Database Explorer, make sure the Trigger on option is set to either Table or View.

The contents of the Event grid depends on the trigger type. This topic describes a set of options that are available for table and view triggers. Topic Event, Trigger Editor (Schema and Database) provides information on event options for database and schema triggers.

Timing
Specify the time for trigger to fire. This can be Before an event, After, or Instead of.

After
The trigger will be fired after execution of a statement. Not available for view triggers.

Instead of
The trigger will be fired instead of executing a statement. Not available for table triggers.

Before
The trigger will be fired before a statement that caused it to fire will be executed. Not available for view triggers.

Event
This section defines which events have to fire the trigger.

Insert
The trigger will be fired when a new row is being inserted into a table or a view.

Delete
The trigger will be fired when a row is being deleted from a table or a view.

Update of columns
The trigger will be fired when a row is being updated in a table or a view. By default, such trigger fires when any of available columns is updated. If you want to set this event for particular columns, select them in the list below.

Trigger for each row
Select the check box if you want the trigger to be executed multiple times for the statement that alters several rows. If not selected, the trigger fires once per statement. This option is implicitly activated for Instead of statements.

Referencing
When a trigger is executed for each row, you can use NEW and OLD correlation names to refer to the current row in trigger body and condition clause. If there is a confusion between a correlation name and a table name, you can specify other correlation names.

New as
Specify a new correlation name to be used instead of NEW to reference new values for a row when updating or inserting it.

Old as
Specify a new correlation name to be used instead of OLD to reference old values for row when updating or deleting.

Condition

Type here a condition for firing a trigger.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script changes

newsql To New SQL Window
Shows script changes in a new SQL document.
to-clipboard To Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Triggers


Event, Trigger Editor (Schema and Database)

Use the Event tab to choose events that fire a trigger. To see this tab, double-click a trigger in Database Explorer, make sure the Trigger on option is set to either Schema or Database, and then switch to the Event tab.

The contents of the Event tab depends on the trigger type. This topic describes a set of options that are available for schema and database triggers. Topic Event, Trigger Editor (Table and View) provides information on event options for table and view triggers.

Timing

Before
The trigger will be fired before the statement that caused it to fire will be executed.

After
The trigger will be fired after execution of the statement.

Database Events

This section defines which database events have to fire the trigger. Availability of options depends on trigger timing you have chosen (Before or After).

Server Error
Fires the trigger whenever a server error message is logged. The following errors do not cause a SERVERERROR trigger to fire:

· ORA-01403: no data found
· ORA-01422: exact fetch returns more than requested number of rows
· ORA-01423: error encountered while checking for extra rows in exact fetch
· ORA-01034: ORACLE not available
· ORA-04030: out of process memory when trying to allocate string bytes

Logon
Fires the trigger whenever a client application logs onto the database.

Logoff
Fires the trigger whenever a client application logs off the database.

Startup
Fires the trigger whenever the database is opened. Applies to database triggers only.

Shutdown
Fires the trigger whenever an instance of the database is shut down. Applies to database triggers only.

Suspend
Fires the trigger whenever a server error causes a transaction to be suspended.

DDL events

Specify one or more types of the DDL statements that can cause a trigger to fire.

Alter
Fires the trigger whenever the ALTER statement modifies a database object in the data dictionary. Applies to database triggers only.

Analyze
Fires the trigger whenever the database collects or deletes statistics or validates the structure of a database object.

Associate statistics
Fires the trigger whenever the database associates a statistics type with a database object.

Audit
Fires the trigger whenever the database tracks the occurrence of an SQL statement or tracks operations on a schema object.

Comment
Fires the trigger whenever a comment on a database object is added to the data dictionary.

Create
Fires the trigger whenever the CREATE statement adds a new database object to the data dictionary. The trigger will not be fired by the CREATE DATABASE or CREATE CONTROLFILE statement.

Disassociate statistics
Fires the trigger whenever the database disassociates a statistics type from a database object.

Drop
Fires the trigger whenever the DROP statement removes a database object from the data dictionary.

Grant
Fires the trigger whenever a user grants system privileges or roles or object privileges to another user or to a role.

No audit
Fires the trigger whenever the NOAUDIT statement instructs the database to stop tracking an SQL statement or operations on a schema object.

Rename
Fires the trigger whenever the RENAME statement changes the name of a database object.

Revoke
Fires the trigger whenever the REVOKE statement removes system privileges or roles or object privileges from a user or role.

Truncate
Fires the trigger whenever the TRUNCATE statement removes the rows from a table or a cluster and resets its storage characteristics.

DDL
Fires the trigger whenever any of the preceding DDL statements is issued.

Condition

Type here a condition for firing a trigger.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script changes

newsql To New SQL Window
Shows script changes in a new SQL document.
to-clipboard To Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Triggers


SQL, Trigger Editor

Use the SQL tab of Trigger Editor to edit SQL script of the trigger.

For description of user interface elements of the tab, refer to the SQL Editor section.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
new-sql-window to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Trigger Editor


User Types Editor

This section describes user-defined types editors.

ExpandedToggleIcon(9x12) In This Section

Array Type
Information on what parameters are provided for user-defined array type.

Table Type
Information on what parameters are provided for user-defined table type.

ExpandedToggleIcon(9x12) See Also

Object Editors


Array Type

Use this editor to set properties of the user-defined array type.

Name
Name of a user-defined array type.

Owner
Shows the schema the array type belongs to.

Data type

Specify data type properties here.

Size
Specify a size.

Schema
Specify a schema your type will belong to.

Type
Specify needed data type.

Length
Specify a length. Available for the CHAR, NCHAR, NVARCHAR2, RAW, VARCHAR2, XML types only.

Precision
Specify a precision. Available for the numeric data types only.

Day
Specify a day. Available for the INTERVAL DAY TO SECOND type only.

Second
Specify a second. Available for the INTERVAL DAY TO SECOND type only.

Scale
Specify a scale. Available for the NUMBER type only.

User defined object will be a reference (REF)
If selected, this check box indicates that the object is a REF pointer.

Text editor
Contains SQL code of the object. Changes you make in the visual part of the editor are immediately available in the Text editor.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
new-sql-window to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

User Types Editor

Table Type


Table Type

Use this editor to set properties of the user-defined table type.

Name
Name of a user-defined array type.

Owner
Shows the schema the array type belongs to.

Data type

Specify data type properties here.

Schema
Specify a schema your type will belong to.

Type
Specify needed data type.

Length
Specify a length. Available for the CHAR, NCHAR, NVARCHAR2, RAW, VARCHAR2, XML types only.

Precision
Specify a precision. Available for the numeric data types only.

Day
Specify a day. Available for the INTERVAL DAY TO SECOND type only.

Second
Specify a second. Available for the INTERVAL DAY TO SECOND type only.

Scale
Specify a scale. Available for the NUMBER type only.

User defined object will be a reference (REF)
If selected, this check box indicates that the object is a REF pointer.

Text editor
Contains SQL code of the object. Changes you make in the visual part of the editor are immediately available in the Text editor.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
new-sql-window to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

User Types Editor

Object Editors


Database Link Editor

Use Database Link Editor to create database links and view parameters of existing database links. To open the tab, double click Database Links in Database Explorer, and then double click the corresponding database.

Name
Name of the database link

Owner
Shows owner of the database link. Can not be edited.

Public
Select the check box to make the database link available to all users.

Connection details

Current user
Creates a current user database link. The current user must be a global user with a valid account on the remote database.

Connected user
Users connect as themselves. They must have an account on the remote database with the same username as their account on the local database.

Fixed user
Users connect using a username and a password referenced in the link. Set a name and a password for a fixed user.

Name
Name of the user that will be used for connecting to a remote database.

Password
Password of the user that will be used for connecting to a remote database.

Service name
Specify a service name of a remote database. If you specify only the database name, then Oracle Database implicitly appends the database domain to the connection string to create a complete service name.

Shared

Shared link can be used multiple client processes simultaneously.

Name
Name of a user, that will be used to connect to a remote database through a shared database link.

Password
Password, that will be used to connect to a remote database through a shared database link.

Text editor
Contains SQL code of the object. Changes you make in the visual part of the editor are immediately available in the Text editor.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
new-sql-window to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Object Editors

Sequence Editor


Sequence Editor

Use this editor to modify a sequence. To open it, double-click a sequence in Database Explorer.

Name
Name of a sequence. You can modify it only when creating a sequence.

Owner
Schema that contains a sequence. You can modify it only when creating a sequence.

Values

This group contains parameters related to sequence number generation.

Initial value
Shows a current sequence value. When you create a sequence you can alter this value to set it as initial.

Increment
Specifies an interval between sequence numbers. This integer value can be any positive or negative integer, but it cannot be 0. The absolute of this value must be less than the difference of Minimum and Maximum. If this value is negative, then the sequence descends. If the value is positive, then the sequence ascends. Defaults to 1.

Min value
Specifies a minimum value the sequence can generate. Note that the Minimum field is empty when its value equals its default value (-100000000000000000000000000 for negative increment and 1 for the positive increment).

Max value
Specifies a maximum value the sequence can generate. Note that the Maximum field is empty when its value equals its default value (100000000000000000000000000 for positive increment and -1 for the negative increment).

Cache
Specifies how many values of the sequence the database preallocates and keeps in memory for faster access. For sequences that cycle, this value must be less than the number of values in the cycle.

Default
Sets cache size to default, which is 20.

No Cache
Prevents Oracle from caching values for this sequence.

Size
Sets cache size to the specified value. The minimum value for this parameter is 2.

Options

Shows additional parameters a sequence can have.

Cycle values
Specifies whether the sequence continues to generate values after reaching either its maximum or minimum value. After a cycling ascending sequence reaches its maximum value, it generates its minimum value. After a cycling descending sequence reaches its minimum, it generates its maximum value.

Order values
If true, guarantees that sequence numbers are generated in order of request. This is useful if you are using the sequence numbers as timestamps. Guaranteeing order is usually not important for sequences used to generate primary keys. Order is necessary only to guarantee ordered generation if you are using Oracle Database with Real Application Clusters. If you are using exclusive mode, sequence numbers are always generated in order.

Keep values
Select the check box to save setting values.

Session
Specifies the options to create a sequence with session visibility.

Text editor
Contains SQL code of the object. Changes you make in the visual part of the editor are immediately available in the Text editor.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
new-sql-window to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Object Editors

Synonym Editor


Synonym Editor

Use this editor to modify a synonym. To open it, right-click a synonym in Database Explorer and select Edit Synonym.

Name
Name of a synonym. You can modify it only when creating a synonym.

Owner
Schema that contains a synonym. You can modify it only when creating a synonym.

Public
Select a check box to create a public synonym. Public synonyms are accessible to all users.

Referenced Object

Local database
Select the check box if you create a synonym for the object located in the local database.

Remote database
Select the check box if you create a synonym for the object located in the remote database.

Type
This parameter is available for local database only. It specifies referenced object's type.

Schema
Shows the schema of the referenced object.

Name
Shows the name of the referenced object.

Text editor
Contains SQL code of the object. Changes you make in the visual part of the editor are immediately available in the Text editor.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
new-sql-window to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Object Editors

XML Schema Editor


XML Schema Editor

Use XML Schema Editor to register XML Schema in Oracle database. To invoke it, right-click XML Schemas node in Database Explorer and select New XML Schema from the shortcut menu.

Name
Specify an XML Schema name here. Read-only after an XML Schema had been created.

Owner
Indicates which database an XML schema belongs to. Read-only after an XML Schema had been created.

Load XML text from
Select an XML text source here. This control is not displayed after an XML Schema had been created.

File
XML text will be loaded from a file. Input file name with the path here. This control is not displayed after an XML Schema had been created.

Browse
Click the button to choose a file with XML text.

URL
XML text will be loaded from the specified URL. This control is not displayed after an XML Schema had been created.

Specify text
Manually input the XML text. Read-only after an XML Schema had been created.

Options

Local
Defines if this schema is local or global one. By default, all schemas are registered as local schemas i.e. under the current schema. If a schema is registered as global, it is added under /sys/schemas/PUBLIC/... You need write privileges on the above directory to be able to register a schema as global.

Generate object types based on this XML schema
Check if the schema compiler has to generate object types.

Generate tables based on this XML schema
Check if the schema compiler has to generate default tables.

Generate java beans based on this XML schema
Check if the schema compiler has to generate Java beans.

Register this XML schema regardless of any errors
Specifies if the schema should be created/stored even with errors. Checking this option will register the schema in the hierarchy even if there were compilation errors, but the schema cannot be used until it is made valid.

Text editor
Contains SQL code of the object. Changes you make in the visual part of the editor are immediately available in the Text editor.

refresh-object Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script changes

newsql To New SQL Window
Shows script changes in a new SQL document.
to-clipboard To Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Object Editors

Rebuild Indexes Dialog Box


Rebuild Indexes Dialog Box

Use this dialog box to rebuild indexes using the same columns, index type, uniqueness attribute, and sort order. To open the Rebuild Indexes dialog box:

· Right-click the Indexes node in the Database Explorer and select Rebuild All Indexes from the shortcut menu.
· Right-click a required index in the Database Explorer, then select Rebuild Index from the shortcut menu.

Object Name
Displays the index name.

Table
Displays the name of the table where an index belongs to.

Result
Shows the result of the index rebuilding.

script-changes Script changes

newsql To New SQL Window
Shows script changes in a new SQL document.
to-clipboard To Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Object Editors

Generate Schema Script Wizard


Generate Schema Script Wizard

Use Generate Schema Script Wizard to make DDL statements or scripts of existing database objects. Its pages are listed below.

ExpandedToggleIcon(9x12) In This Section

Database Objects, Generate Schema Script Wizard
Select database objects for DDL statements generation on this page.

Script Generation Options, Generate Schema Script Wizard
Set options for DDL generation on this page.

Script Generation Progress, Generate Schema Script Wizard
You can see DDL generation progress on this page.

ExpandedToggleIcon(9x12) See Also

Object Editors


Database Objects, Generate Schema Script Wizard

Select database objects to generate DDL on this page. Browse connection tree and check objects you want to create DDL for.

Available objects list
Check here database objects to generate DDL statements for.

Selected objects list
Selected database objects to generate DDL statements for are listed here. You can remove them from this list by double-clicking them.

DoubleRight Add all objects
Moves all available database objects to the Selected objects list.

RightArrow Add object(s)
Moves available database objects that are highlighted in the Available objects list to the Selected objects list.

LeftArrow Remove object(s)
Removes the highlighted item from the Selected objects list.

DoubleLeft Remove all objects
Clears the database objects selection.

Show all objects
Shows objects of all databases if selected. Otherwise shows only objects of current database.

ExpandedToggleIcon(9x12) See Also

Generate Schema Script Wizard

Script Generation Options, Generate Schema Script Wizard


Script Generation Options, Generate Schema Script Wizard

Set options for DDL generation on this page.

ExpandedToggleIcon(9x12) General

Contains general settings for DDL generating.

Exclude objects named with '$'
DDL will not be generated for schema objects, that have '$' character in their name. '$' character is usually used for distinguishing system objects. Note that when determining whether to generate DDL for materialized view log, dbForge Studio analyzes its master table name, not the materialized view log name (that begins with 'LOG$').

Format the script
Select to format DDL of the source objects. Otherwise, source object DDL will have the same formatting as in database, the rest objects will have default formatting.

Generate comments in the script
Select to insert comments in the DDL.

Include body for packages and objects
Select to include DDL for both the body and the specification when extracting from packages or objects.

Include CASCADE CONSTRAINTS option
Select to include CASCADE CONSTRAINTS with DROP in the DDL.

Include CONNECT command
Select to include CONNECT SQL*Plus command to the script.

Include DROP statement
Select to include DROP statements in the DDL.

Include physical attributes clause
Select to include storage clause in the DDL.

Include PURGE option
Select to include PURGE statements in the DDL. PURGE execution cannot be rolled back!

Include SET CURRENT_SCHEMA
Check this option to include a statement that changes the current schema to the one being exported. ALTER SESSION SET CURRENT_SCHEMA statement will be written in the beginning of the script.

Include storage clause
Select to include storage clause in the DDL.

Include tablespace names in script
Select to include a tablespace name in the DDL.

Prefix object names with a schema name
Select to prefix object names with schema name in the DDL.

Use CREATE OR REPLACE
Select to use CREATE OR REPLACE statement instead of CREATE statement for objects' script generation.

ExpandedToggleIcon(9x12) Tables/Views

Contains settings for generating DDL of tables and views.

Disable constraints
Select to generate DDL that creates disabled constraints.

Exclude column default values
Select to exclude column default values from the DDL.

Exclude START and NEXT for materialized views
Excludes START and NEXT clauses from the materialized view DDL.

Include constraints
Select to include constraints for the objects in the DDL.

Include indexes
Select to include indexes for the objects in the DDL.

Include object comments
Select to include comments of objects in the script.

Include triggers
Select to include triggers for the objects in the DDL.

ExpandedToggleIcon(9x12) Partitioning

Contains settings for generating DDL of partitioned database objects.

Exclude partition list for locally partitioned index
Select to exclude partitions and subpartitions from the DDL for locally partitioned indexes.

Include partition clause
Select to include partition clause for the objects in the DDL.

Include tablespace name for index partitions
Select to include tablespace name for index partitions in the DDL.

Include tablespace name for partitions
Select to include tablespace name for partitions for the objects in the DDL.

List individual hash partitions
Select to list individual hash partitions for the objects in the DDL. Otherwise, only partition quantity will be specified.

Tables/Views Contains settings for generating DDL of tables and views.

ExpandedToggleIcon(9x12) Users/Roles

Include an encrypted password
Includes encrypted password into the user DDL (using the IDENTIFIED BY VALUE statement). That allows to generate DDL that creates users exactly with the same password without knowing it. You should not change user name in the script if you use this option.

Include grants
Includes grants for users in the DDL.

Include object grants
Includes any object grants for users in the DDL.

ExpandedToggleIcon(9x12) See Also

Generate Schema Script Wizard

Script Generation Progress, Generate Schema Script Wizard


Script Generation Progress, Generate Schema Script Wizard

You can see a DDL generation progress on this page. To cancel DDL generation, click the Cancel button.

ExpandedToggleIcon(9x12) See Also

Generate Schema Script Wizard

Object Editors


Options

The section provides you with the information on user adjustable parameters.

ExpandedToggleIcon(9x12) In This Section

Environment Options
Learn how certain elements of the dbForge Studio display and behave.

Text Editor Options
Learn how to customize the performance and the appearance of the editor.

Data Editor Options
Learn how to customize the performance and the appearance of the editor.

Data Comparison Options
Learn how to change data comparison options.

Database Diagram Options
Learn how to customize a database diagram.

Database Explorer Options
Use this section to set database explorer options.

Debugging Options
Learn how to customize debugging behavior of a stored procedure or an SQL script.

Generate Schema Script Options
Learn how to set DDL generation options properly.

Master-Detail Options
Describes available Master-detail options.

Query Builder Options
Use the section to tune Query Builder's diagram.

Query Profiler Options
Learn how to set code formatting options properly.

Schema Comparison Options
Use the section to tune schema comparison.


Environment Options

You can use the pages in the Environment folder in the Options dialog box to set how certain elements of the dbForge Studio display and behave. You can access the Environment pages by clicking Options on the Tools menu, and then clicking Environment.

ExpandedToggleIcon(9x12) In This Section

General, Environment, Options Dialog Box
Lists general environment preferences and explains them.

Keyboard, Environment, Options Dialog Box
Describes the tab where you can customize shortcut keys.

Output, Environment Options Dialog Box
Describes the tab where you can customize application output.

Documents, Environment, Options Dialog Box
Describes the tab where you can customize the document view layout.

Projects, Environment, Options Dialog Box
Describes the tab where you can specify the default projects location.

SMTP, Environment, Options Dialog Box
Lists options available at the SMTP options tab.

Web Browser, Environment, Options Dialog Box
Describes the tab where you can set dbForge Studio web browser options.

ExpandedToggleIcon(9x12) See Also

Options

Text Editor Options


General, Environment, Options Dialog Box

Use this page of the Options dialog box to change settings for the dbForge Studio. You can access the Options dialog box by clicking Options on the Tools menu and then selecting the General page in the Environment folder.

ExpandedToggleIcon(9x12) Settings

At startup
Select what to do when dbForge Studio starts up.

Show Startup page
A Start Up page will be opened at startup.

Load Last Opened Project
Last opened project will be loaded at startup.

Create New SQL Document
A new empty SQL document will be created at startup.

Show Empty Environment
No documents or projects will be opened or created at startup.

Check updates on startup once a week
Select this option so that dbForge Studio for Oracle will check if any updates are available for the product every week

Show splash screen on startup
Clear to turn off splash screen displaying.

Stop script execution on the first error
If selected, script execution will be stopped when execution encounters the first error.

Show status bar
Determines whether status bar should be visible.

Open object editors in the same window
If selected, all new object editors will be opened "unpinned". That means, when opening a database object with already opened database object of the same type, object editor of already opened object will be replaced with object editor of the opening object. This option doesn't work with stored procedures and functions.

Open source objects in the same window
If selected, all new source object editors will be opened "unpinned". This option works with stored procedures and functions.

Display X items shown in Window menu
Customizes the number of windows that appear in the Windows list of the Window menu. Type a number between 1 and 24. By default, the number is 10.

Display X items shown in recently used lists
Customizes the number of most recently used projects and files that appear on the File menu. Type a number between 1 and 24. By default, the number is 10. This is an easy way to retrieve recently used projects and files.

ExpandedToggleIcon(9x12) See Also

Environment Options

Keyboard, Environment, Options Dialog Box


Keyboard, Environment, Options Dialog Box

The Keyboard page of the Options dialog box allows you to customize the keyboard scheme for the dbForge Studio. Use this option to set shortcut keys for frequently used commands or to establish your favorite binding for a particular command. To access this dialog box, select Options from the Tools menu and choosing the Keyboard page from the Environment folder.

ExpandedToggleIcon(9x12) Options

Keyboard mapping scheme
Lists the set of all available collections of shortcut keys. To load a specific scheme, select it from the list. When you are ready to leave the options dialog box, click OK your selected scheme will be loaded.

Reset
Resets all shortcuts to the defaults of the selected keyboard mapping scheme.

Show commands containing
Specifies which command is selected and shows a list of all commands available in the dbForge Studio that contain the specified characters, or all commands if this edit box is empty. As you type a complete word, the result list displays all entries containing the typed word. For example, you can enter save, locate the command, File.Save, and see that the associated shortcut is CTRL+S.

Shortcut(s) for selected command
Lists mapped shortcuts for the command selected in the Show commands containing list. Some commands have more than one mapped shortcut.

Remove
Removes the selected shortcut key combination.

Use new shortcut in
Specifies the scope of the shortcut key. For example, you can use the shortcut key globally in the dbForge Studio or only within a specific context (or window); Global is the default setting. If you choose a specific context, the shortcut key remains in effect only while the context is active. If you choose Global, the shortcut key works in any active window in the dbForge Studio, unless the same shortcut is mapped in another editor, in which case the editor overrides the shortcut.

Press shortcut key(s)
Allows you to press a key combination to be used for the currently selected command. You must use one or more modifier keys such as CTRL, ALT, or SHIFT. The modifier keys appear in the order in which you press them. For example, pressing CTRL, then SHIFT, and then F2 creates the shortcut key, CTRL+SHIFT+F2. You can enter one or two key combinations that include a modifier key. For example, you can enter CTRL+Y, or enter CTRL+Y, CTRL+W. Use BACKSPACE to delete the whole shortcut key combination at one time.

note Note

The following keys cannot be assigned: ALT, SHIFT, or CTRL without another key; ESC, PRINT SCRN/SYS RQ, SCROLL LOCK, PAUSE/BREAK, TAB, CAPS LOCK, INSERT, HOME, END, PAGE UP, PAGE DOWN, Windows logo keys, Application key, any of the ARROW keys, or ENTER; NUM LOCK, DEL, or CLEAR on the numeric keypad; or CTRL+ALT+DELETE.

Assign
Binds the new key combination to the selected command in the Keyboard mapping scheme displayed. The new assignment is added to the Shortcut(s) for selected command list and you can specify multiple key combinations for one command. This button is active after you type a key combination in the Press shortcut key(s) box. If you attempt to bind a key in the [Default Settings] scheme, you are prompted to make a copy of the scheme and give it a name.

note Note

Changes made using the Assign button are not canceled if you click the Cancel button.

Shortcut currently used by
Displays the command to which the key combination is currently assigned. Appears only when you assign a key or key combination that is already assigned. To replace the shortcut with a custom shortcut key combination you must define a new Keyboard mapping scheme.

ExpandedToggleIcon(9x12) See Also

Environment Options

Output, Environment, Options Dialog Box


Shortcuts Table, Keyboad Options

Use this window to view all shortcuts applied to the commands within the selected keyboard mapping scheme.

Search box
To quickly find a required command or shortcut, enter characters available in the required command or shortcut. Only commands or shortcuts, which names contain the enered characters, will be shown in the list.

Group by context
Click to group commands by context.

Print
Click to print out the shortcuts table.

Command
Lists all available commands.

Shortcut
Lists command shortcuts.

Context
Lists command contexts.

ExpandedToggleIcon(9x12) See Also

Keyboard, Environment, Options Dialog Box

Environment Options


Output, Environment, Options Dialog Box

Use Options window to adjust dbForge Studio behavior to your needs. To access this dialog box, select Options from the Tools menu and choosing the Output page from the Environment folder.

ExpandedToggleIcon(9x12) Settings

Turn on 'Redirect Data to Output Window' by default
Enables displaying of selected data as text in the Output window instead of the Data for every SQL document by default.

Show time for output events
If selected, the time stamp is added at the beginning of every line in the Output window.

ExpandedToggleIcon(9x12) SQL Log

Write queries sent by program to the SQL Log
Allows to log all the queries sent by program to a database.

ExpandedToggleIcon(9x12) Event Tracing

Log application errors
Check this option to write all errors and processes that took place during the application work to a file. This file is placed in the directory with the application executable file.

It can help a user to provide more detailed information on the encountered problem to the developers so that they are able to reproduce and fix the problem faster. If you have encountered an error and are going to send us an error report, this file will be attached to the letter with the error report.

Delete application log after closing
Clear this check box if you want the application log be available after application closing.

ExpandedToggleIcon(9x12) See Also

Environment Options

Documents, Environment, Options Dialog Box


Documents, Environment, Options Dialog Box

Use the Options window to adjust the dbForge Studio behavior to your needs.

ExpandedToggleIcon(9x12) In This Section

SQL Documents Dialog Box
Describes options available for SQL document view.

Object Editors Dialog Box
Describes options available for Object editors view.

Categories
Describes options available for window coloring.

Restore
Describes options available for automatic files saving.

ExpandedToggleIcon(9x12) See Also

Environment Options

Project, Environment Options Dialog Box


SQL Documents Dialog Box

The SQL Documents subsection of Environment Documents of the Options window contains the following options:

ExpandedToggleIcon(9x12) Default SQL Document View Layout

One main document view
All views corresponding to the opened SQL document are visible. You can activate the needed view by clicking the corresponding tabs.

All views tabbed
Only one view corresponding to the document is visible, all others are tabbed. Click the needed tab for the corresponding view to be shown on the screen.

note Note

You can also change the document view layout from the shortcut menu that can be called from the lower part of the document view.

Show Data view for every SQL document
Check this option for the Data view tab to be displayed for every opened or newly created SQL document.

Activate Data editor after query execution
Check this option to focus on the Data editor after a query is executed. If this option is unchecked, focus stays in the Text view.

Redirect data to Data window if Data view is closed
If this option is checked, data returned after query execution is displayed into the Data window if the Data view is closed.

ExpandedToggleIcon(9x12) See Also

Documents, Environment, Options Dialog Box

Object Editors Dialog Box


Object Editors Dialog Box

The Object Editors subsection of Environment Documents of the Options window contains the following options:

ExpandedToggleIcon(9x12) Options

One main document view
All views corresponding to the opened SQL document are visible. You can activate the needed view by clicking the corresponding tabs.

All views tabbed
Only one view corresponding to the document is visible, all others are tabbed. Click the needed tab for the corresponding view to be shown on the screen.

Show Data view for every Table and View editor
Check this option to show or hide the Data tab when editing tables or views.

ExpandedToggleIcon(9x12) See Also

Documents, Environment, Options Dialog Box

Project, Environment Options Dialog Box


Categories

Document categories
Displays the list of available document categories.

Name
Category name.

Shape
Category shape.

Color
Category color.

New Category
Adds a new category to the list.

Delete Category
Deletes a selected category.

Reset to Default
Resets all changes to defaults.

ExpandedToggleIcon(9x12) See Also

Environment Options

Restore


Restore

Use the topic to customize the automatic files saving. It will allow you to return to the documents which you forgot to save during the last session.

Settings

Save restore information every ... min
Set the time after which the data will be saved automatically.

Restorable file types

SQL files (*.sql)
If checked, the *.sql files will be saved automatically.

PL/SQL files (*.pls; *.plb; *.pks; *.pkb; *.pck)
If checked, the PL/SQL files will be saved automatically.

SQL Navigator PL/SQL files
If checked, the SQL Navigator PL/SQL files will be saved automatically.

Toad for Oracle PL/SQL files
If checked, the Toad for PL/SQL files will be saved automatically.

Reports
If checked, the reports files will be saved automatically.

Text files
If checked, the text files will be saved automatically.

XML files
If checked, the XML files will be saved automatically.

Master-Detail files
If checked, the master-detail files will be saved automatically.

Database diagrams
If checked, the database diagrams will be saved automatically.

Data comparison files
If checked, the data comparison files will be saved automatically.

Schema comparison files
If checked, the schema comparison files will be saved automatically.

ExpandedToggleIcon(9x12) See Also

Documents, Environment, Options Dialog Box


Project, Environment Options Dialog Box

Use the Options window to adjust dbForge Studio behavior to your needs. To open it, select Options from the Tools menu.

ExpandedToggleIcon(9x12) Options

Project location
Set default folder for storing your projects here.

ExpandedToggleIcon(9x12) See Also

Environment Options

SMTP, Environment, Options Dialog Box


SMTP, Environment, Options Dialog Box

Use the Options window to adjust dbForge Studio behavior to your needs. To open it, select Options from the Tools menu.

ExpandedToggleIcon(9x12) Options

From address
Specify the sender address in this field.

SMTP server
Specify the SMTP server in this field.

Port
Specify the port here.

Timeout (seconds)
Specify the timeout in seconds.

Enable SSL
Check to enable SSL.

Requires authentication
Check to enable authentication process.

Name
Specify the name for authentication here.

Password
Specify the password here.

ExpandedToggleIcon(9x12) See Also

Environment Options

Web Browser, Environment, Options Dialog Box


Web Browser, Environment, Options Dialog Box

Use the Options window to adjust dbForge Studio behavior to your needs. To access this dialog box, select Options from the Tools menu and choosing the Web Browser page from the Environment folder.

ExpandedToggleIcon(9x12) Settings

Home page
Set here a home page for dbForge Studio web browser. It opens when you call dbForge Studio web browser window or click Home button on Web toolbar.

Use default
Use the product home page.

Search page
Set here a search page for dbForge Studio web browser. It opens when you click the Online Search button on the Web toolbar.

Use default
Use Google as a search page.

ExpandedToggleIcon(9x12) See Also

Environment Options

Options


Text Editor Options

The Text Editor options in the Options dialog box provide a variety of ways to customize the performance and appearance of the editor.

ExpandedToggleIcon(9x12) In This Section

General, Text Editor, Options Dialog Box
This dialog box lets you change global settings for the dbForge Studio.

Tabs, Text Editor, Options Dialog Box
This dialog box allows you to change the default behavior of the Code Editor.

Font & Colors, Text Editor, Options Dialog Box
This dialog box allows you to change the default setting for a custom font and color scheme for various user interface elements.

Printing, Text Editor, Options Dialog Box
This dialog box allows you to change default printing options.

Advanced, Text Editor, Options Dialog Box
This dialog box describes how to set up tabulation and indenting editor preferences.

Code Completion
This section describes statement completion options available in dbForge Studio.

Formatting
This section describes code formatting options available in dbForge Studio.

ExpandedToggleIcon(9x12) See Also

Options

Data Editor Options


General, Text Editor, Options Dialog Box

This dialog box lets you change global settings for the Code and Text. To display this dialog box, click Options on the Tools menu, expand the Text Editor node, and then click General.

ExpandedToggleIcon(9x12) Settings

Virtual whitespace
When selected, it allows you to move the cursor beyond the physical end of a line of text into character spaces that do not exist. If you move your cursor out into this area and begin typing, the void between your current position and the end of the last word is automatically filled with space characters. When this setting is not selected, you cannot move the cursor beyond the last character in a line.

Bracket matching
If selected, dbForge Studio for Oracle finds a corresponding bracket for the one that is currently near the cursor.

ExpandedToggleIcon(9x12) Display

Line numbers
Displays line numbers in the left of Text view of a document.

Indicator margin
Reveals the indicator margin on the left of Text view of a document.

Vertical scroll bar
Shows or hides a vertical scrollbar in Text view of a document.

Horizontal scrollbar
Shows or hides horizontal scrollbar in Text view of a document.

ExpandedToggleIcon(9x12) See Also

Text Editor Options

Tabs, Text Editor, Options Dialog Box


Tabs, Text Editor, Options Dialog Box

This dialog box allows you to change the default behavior of the Code Editor. To display this dialog box, click Options on the Tools menu, expand the Text Editor node, and then click Tabs.

ExpandedToggleIcon(9x12) Indenting

None
When selected, no automatic indenting occurs when you press ENTER to move to a new line of text, and the cursor is placed at the first column of the next line.

Block
When selected and you press ENTER, the new line of text is automatically indented to the same tab stop as the line preceding it.

Smart
When selected, new lines of text are automatically indented taking into account selecting formatting options.

ExpandedToggleIcon(9x12) Tabs

Tab size
Sets the distance in spaces between tab stops. The default is 2 spaces.

Indent size
Sets the size in spaces of an automatic indentation. The default is 2 spaces. Tab characters, space characters, or both will be inserted to fill the specified size.

Insert spaces
When selected, indent operations insert only space characters, not TAB characters. If the Indent size is set to 5, for example, then five space characters are inserted whenever you press the TAB key or the Increase Indent button on the Formatting toolbar.

Keep tabs
When selected, indent operations insert as many TAB characters as possible. Each TAB character fills the number of spaces specified in Tab size. If the Indent size is not an even multiple of the Tab size, space characters are added to fill in the difference.

ExpandedToggleIcon(9x12) See Also

Text Editor Options

Font & Colors, Text Editor, Options Dialog Box


Font & Colors, Text Editor, Options Dialog Box

The Fonts and Colors page of the Options dialog box lets you establish a custom font and color scheme for various user interface elements in the dbForge Studio. To access this dialog box, click Options on the Tools menu, and then select the Font &Colors page in the Text Editor folder.

ExpandedToggleIcon(9x12) Options

Font (bold type indicates fixed-width fonts)
Lists all the fonts installed on your system. Fixed fonts appear in bold.

Size
Specify the size of the font for the selected display item here.

Use Defaults
Resets text editor font and color settings to the default values.

Display items
Select a display item here to change its font and color settings.

Brace Matching
Matching braces, for example ().

Built-in Data Type
Built-in data type, for example, INT or VARCHAR.

Built-in Function
Built-in function, for example, COUNT.

Call Return
Source statement that indicates call return points when context is switched to a non-top stack frame when debugging.

Comment
Code comment.

Current Statement
Current code line when debugging.

Identifier
Identifier, such as database object name, stored procedure parameter, etc.

Keyword
SQL keyword.

Number
Number.

Operator
Operators and separators (, ;: * + = / - . (<>!~&^%\|{})).

Plain Text
Text, when editing a file as text.

Program Block Label
Labels.

Region
Region or endregion command.

Select Marker
Frame around the select statements.

Selected Line
Line, selected in the Find Results window.

String
SQL string constant.

Visible Whitespace
White space characters when View White Space is turned on.

XML Attribute Name
Tag attribute in XML editor.

XML Comment
Comment in XML editor.

XML Indent
Indent in XML editor.

XML Number
Number in XML editor.

XML Special Tag
Special XML tag.

XML String
String constant in XML editor.

XML Tag Name
XML attribute name.

Bold
Select it to display the text of selected display items in bold.

Italic
Select it to display the text of selected display items in italic.

Item foreground
Font color of a selected display item.

Item background
Background color of a selected display item.

Sample
Sample of a display item appearance.

ExpandedToggleIcon(9x12) See Also

Text Editor Options

Printing, Text Editor, Options Dialog Box


Printing, Text Editor, Options Dialog Box

This dialog box allows you to change default printing options. To access this dialog box, click Options on the Tools menu, and then select the Printing page in the Text Editor folder.

ExpandedToggleIcon(9x12) Settings

Print header
Check it to print the document name.

Print line numbers
Check it to print line numbers in the document.

Print white space
Check it to print white space symbols, tabulation symbols, and symbols of line breaks.

ExpandedToggleIcon(9x12) See Also

Text Editor Options

Advanced, Text Editor Options Dialog Box


Advanced, Text Editor, Options Dialog Box

Use the Options window to adjust dbForge Studio behavior to your needs. To open it, select Options from the Tools menu.

The Advanced section of the Text Editor options allows you to set up outlining and SELECT statement highlighting. You can use the following options:

ExpandedToggleIcon(9x12) Outlining

Enter outlining mode when files open
If selected, outlining is enabled when you open a file.

Collapse --region blocks when files open
If selected, --region blocks in an opened file will be collapsed.

ExpandedToggleIcon(9x12) Syntax highlighting

Highlight SELECT statements
If selected, a frame will be drawn around SELECT statements.

Underline errors in the editor
If selected, syntax errors will be underlined with a red curved line.

ExpandedToggleIcon(9x12) Editor performance

Enable syntax highlight
Clear a check box to disable syntax highlight.

Max script size
Specify max script size for syntax highlight support.

Max script size
Specify max script size for code completion, navigation and refactoring support.

ExpandedToggleIcon(9x12) See Also

Text Editor Options

Code Completion Options


Code Completion Options

Code Completion

This section explains statement completion options provided in the Options window.

The Code Completion section of the Text Editor options contains the following subsections:

ExpandedToggleIcon(9x12) In This Section

General, Code Completion Text Editor Options Dialog Box
Lists general code completion preferences and explains them.

Advanced, Code Completion Text Editor Options Dialog Box
Describes advanced code completion options.

List Members, Code Completion Text Editor Options Dialog Box
Describes options for list members.

Alias, Code Completion Text Editor Options Dialog Box
Describes options for aliases.

ExpandedToggleIcon(9x12) See Also

Formatting


General, Code Completion Text Editor Options Dialog Box

Use the Options window to adjust dbForge Studio behavior to your needs. To open it, select Options from the Tools menu.

The General subsection of the Code Completion section of the Text Editor options allows you to setup options for automatic code formatting when typing code.

Settings

Enable Code Completion
Select to toggle automatic code completion. Selected by default.

Auto-list members
Toggles the display of valid databases, tables, columns, and other database objects in the suggestion box when you are typing. Selected by default.

Auto Parameter Info
Toggles the display of the Parameter Info hint when the left bracket is typed after the procedure or object method name. Selected by default.

Highlight Occurrences
Toggles identifier occurrence highlighting.

Automatically trigger after ... millisec
Defines a delay used by dbForge Studio to show the suggestion box after you stop typing. To change the default value, use the arrow buttons in the field or enter the value.

Refresh

Automatically refresh suggestion cache every ... minute(s)
Select this checkbox to enable automatic refresh within specified interval.

Detect changes on a server before refreshing suggestion cache
If the option is enabled, the suggestion cache will be refreshed in case of any changes on a server. If the option is disabled, the suggestion cache will be refreshed when a user selects the respective command (irrespective of changes on the server).

ExpandedToggleIcon(9x12) See Also

Code Completion Options

Advanced, Code Completion Text Editor Options


Advanced, Code Completion Text Editor Options

Use the Options window to adjust dbForge Studio behavior to your needs. To open it, select Options from the Tools menu.

The Advanced subsection of the Code Completion section of the Text Editor options allows you to setup options for automatic code completion when typing code.

Settings

Qualify column name with table alias
Defines that column names should be committed with table alias.

Qualify column name (no table alias)
Defines how column names should be committed.

With table name
The name of the table the column belongs to is specified before the column name: TableName.ColumnName.
With schema name and table name
The name of the table the column belongs to and the schema name are specified before the column name: SchemaName.TableName.ColumnName.

Reverse order in 'JOIN'-condition
Applies reverse order in JOIN conditions.

Add parentheses when inserting functions
If the option is checked, parentheses are added when you insert functions.

Quote identifiers

Always
If the option is selected, all the identifiers, aliases, and database objects will be enclosed in parentheses.

If an identifier concurs with a keyword
If the option is selected, all the identifiers, aliases, and database objects will be enclosed in parentheses, in case their names concur with reserved keywords or system objects.

If quotes are required
If the option is selected, all the identifiers, aliases, and database objects will be enclosed in parentheses, if required. For instance, if a column name is declared with white spaces.

ExpandedToggleIcon(9x12) See Also

Code Completion Options

List Members, Code Completion Text Editor Options


List Members, Code Completion Text Editor Options

Use the Options window to adjust dbForge Studio behavior to your needs. To open it, select Options from the Tools menu.

The List Members subsection of the Code Completion section of the Text Editor options allows you to setup options for automatic code completion when typing code. The following options are available:

Settings

Sort keywords by relevance
When selected, keywords in the suggestion box will be sorted to display the most relevant at the top of the list. It is selected by default.

Cyclic movement through the suggestion list
Check the option to scroll data through the suggestion list.

Filtering Rule

These options define how to filter the list of suggestions in the suggestion box. If neither of them is selected, dbForge Studio will display only suggestions that start with the typed character(s).

By Matching
When selected, dbForge Studio filters the list of suggestions to display those that start with the typed character(s) or contain it in the top of the list.

Camel Case
When selected, dbForge Studio filters the list of suggestions to display those that are compound word which elements are joined without spaces and start with the typed characters.

Commit selection in completion list by typing

When you type any of the symbols specified below, dbForge Studio will insert a highlighted suggestion from the suggestion box into code.

Tab
The highlighted suggestion will be inserted when you press the Tab key.

Whitespace
The highlighted suggestion will be inserted when you press the Spacebar key.

Following characters
Enter characters here, and the highlighted suggestion will be inserted when you type any of the specified characters.

Add new line on enter at end of fully typed word
Cursor will be moved to the new line if you type a word completely and press Enter.

Select items in the list even if a user input is expected
Select the option to select items from the suggestion list.

ExpandedToggleIcon(9x12) See Also

Code Completion Options

Alias, Code Completion Text Editor Options Dialog Box


Alias, Code Completion Text Editor Options Dialog Box

Use the Options window to adjust dbForge Studio behavior to your needs. To open it, select Options from the Tools menu.

The Alias subsection of the Code Completion section of the Text Editor options allows you to setup options for automatic code completion when typing code.

note Note

The functionality is available in dbForge Studio for Oracle only.

You can adjust the following settings:

Generate alias on commit
Alias is generated when a table object name is committed. If this option is unchecked, all other options are disabled.

Generate aliases in UPPER case
Alias is generated using upper case characters.

Condition
Define an identifier using a corresponding condition mask to which a custom alias specified in the Action column will be assigned. You can remove the identifier by selecting it in the list and clicking del-alias.

Action
Define an alias name using a corresponding mask. The alias will be assigned to the identifiers meeting the condition specified in the Condition column. You can remove the alias by selecting it in the list and clicking del-alias.

Condition masks
The box shows example condition masks to assist you in creating aliases.

Buttons

move-rule-up Move rule up
Alias masks specified in the grid have top-down priority. Use this button to move the alias up the priority list.

move-rule-down Move rule down
Alias masks specified in the grid have top-down priority. Use this button to move the alias down the priority list.

del-alias Delete rule
Click to delete the selected alias rule.

ExpandedToggleIcon(9x12) See Also

Code Completion Options

Formatting


Formatting

This section explains code formatting options provided in the Options window. The Formatting section of the Text Editor options contains the following subsections:

ExpandedToggleIcon(9x12) In This Section

General, Formatting, Text Editor Options Dialog Box
Lists general code formatting preferences and explains them.

Profiles, Formatting, Text Editor Options Dialog Box
Describes options to customize case formatting profiles.

ExpandedToggleIcon(9x12) See Also

Text Editor Options

Data Editor Options


General, Formatting, Text Editor Options Dialog Box

Use the Options window to adjust dbForge Studio behavior to your needs. To open it, select Options from the Tools menu, expand the Text Editor node, and in the Formatting node click General.

ExpandedToggleIcon(9x12) Settings

The General subsection of the Text Editor Formatting section allows you to setup options for automatic code formatting when typing code. You can use the following options:

Automatically format on paste
If checked, pasted code will be automatically formatted. Selected by default.

Automatically format completed statement on delimiter
If checked, code will be automatically formatted when the delimiter is entered (semicolon or backslash). Selected by default.

Automatically format while typing
If the option is checked, code formatting while typing statement elements in SQL editor is supported. Start typing first letters for the required statement, and press TAB or a space to see the result. All objects and keywords are formatted in correspondence with formatting active profile settings. By default, the option is selected.

Right Margin
Line breaks will be inserted automatically after the Right Margin number of characters on a line. 80 is by default.

Put syntax errors to Output window
Select it if you want syntax errors to be redirected to the Output window.

Show syntax error notification window
Select it if you want the syntax error notification window to appear upon formatting a document.

Dictionary file
Specify file with dictionary to adjust formatting to your needs. You can use default dictionary or create a new one. Also you can modify the existing dictionary. This dictionary is used to format identifiers when the Identifier Case option is set to Initial Caps each word.

Available prefixes
Specify prefixes here. If one of the prefixes is used in a word, the application looks in the dictionary for the word that is used after the prefix. If the word is found, its first letter is written in uppercase. These prefixes can be used to format identifiers when the Identifier Case option is set to Initial Caps each word.

Reset Page Defaults
Resets all options on this page to their default values.

ExpandedToggleIcon(9x12) See Also

Formatting

Profiles, Formatting, Text Editor Options Dialog Box


Profiles, Formatting, Text Editor Options Dialog Box

Use the Profiles option to customize code formatting provided by dbForge Studio. To access it, go to Tools menu, select Options, and then click Text Editor. Navigating to Formatting, click Profiles.

ExpandedToggleIcon(9x12) Formatting Profiles

Select a profile from the table.

Name
Profile name.

File
Profile file name.

Edit Profile
Opens the Edit Profile Options window that allows editing options available in the profile.

New Profile
Opens the New Profile window to create a new formatting profile.

Activate
Click to activate the selected profile.

Show in Folder
Opens folder containing the selected profile.

ExpandedToggleIcon(9x12) Shortcut Menu

Edit Profile
Click to open the Edit Profile window.

Reset To Defaults
Click to reset settings to the default values.

Activate
Activates the selected profile.

Rename
Click to change the profile name.

Show In Folder
Opens folder containing the file in Windows Explorer.

Copy File Path
Copies file path to the clipboard.

Delete
Click to delete selected formatting profile.

ExpandedToggleIcon(9x12) See Also

Formatting

Data Editor Options


Edit Profile, Formatting Options

Use this window to edit formatting options in the selected formatting profile.

ExpandedToggleIcon(9x12) Edit Profile Window

Filter
Allows to quick search the needed options/option groups.

collapse-all Collapse/Expand all option groups
Click to expand/collapse the option groups tree.

Show white spaces button
Click to toggle white spaces in the formatting profile editor.

Show Original Sample
Click to restore the code sample to its original state.

Format Text
Formats code according to the selected options.

Options tree
Includes various code formatting options. Allows customizing default text formatting options the way user likes.

Code field
Shows how the code looks like after choosing the corresponding text formatting options.

ExpandedToggleIcon(9x12) Edit Profile Shortcut Menu

Format Selection
Formats selected code according to the chosen options.

Format Current Statement
Formats a current statement.

Cut
Cuts selected text and places it to the clipboard.

Copy
Copies selected text to the clipboard.

Paste
Pastes the clipboard content into the cursor position.

ExpandedToggleIcon(9x12) See Also

Profiles, Formatting, Text Editor Options Dialog Box

New Profile, Formatting Options


New Profile, Formatting Options

Use this window to create and add new formatting profile to the list of profiles.

ExpandedToggleIcon(9x12) New Profile Window

Name
Specify the new profile name here.

Copy settings from
Select an existing profile to copy settings from.

File Path
Set the path to save your new formatting profile.

Set Active
Activate this profile in the Profiles, Options Dialog Box.

ExpandedToggleIcon(9x12) See Also

Profiles, Formatting, Text Editor Options Dialog Box

Data Editor Options


Data Editor Options

The Data Editor options in the Options dialog box provide a variety of ways to customize the performance and appearance of the editor.

ExpandedToggleIcon(9x12) In This Section

General, Data Editor, Options Dialog Box
Use the Options window to adjust the products behavior to your needs.

Font & Colors, Data Editor, Options Dialog Box
The Fonts and Colors page of the Options dialog box lets you establish a custom font and color scheme for Data Editor.

Printing, Data Editor, Options Dialog Box
This dialog box allows you to change default printing options.

Formatting, Data Editor, Options Dialog Box
Use the Options window to adjust the products behavior to your needs.

ExpandedToggleIcon(9x12) See Also

Options

Data Comparison Options


General, Data Editor, Options Dialog Box

Use the Options window to adjust the products behavior to your needs. To access this dialog box, select Options from the Tools menu and choosing the General page from the Data Editor folder.

The Data Editor General section of the Options window contains the following options:

ExpandedToggleIcon(9x12) Settings

Automatically adjust column width
Automatically adjusts column width for every data grid.

Use cached updates mode by default
If selected, cached updates mode will be enabled by default in data view of every SQL document created.

Use paginal mode by default
If selected, paginal mode will be enabled by default in data view of every SQL document created.

Initial page size
Default page record count for paginal mode for data view.

Use auto-search mode by default
Activates auto-search in Data view by default.

Show row numbers
Adds a column with row numbers (#) to the data editor grid.

ExpandedToggleIcon(9x12) Data Editing

Open Data Editor in the editing mode
Select to open the Data Editor is opened in the editing mode by default.

Open Data Editor in the read-only mode
Select to open the Data Editor is opened in the read-only mode by default.

Show a dialog window to choose a mode
Select to invoke a dialog window asking to choose the mode in which Data Editor should be opened (editing or read-only).

ExpandedToggleIcon(9x12) See Also

Data Editor Options

Font & Colors, Data Editor, Options Dialog Box


Font & Colors, Data Editor, Options Dialog Box

The Fonts and Colors page of the Options dialog box lets you establish a custom font and color scheme for Data Editor. You can access this dialog box by clicking Options on the Tools menu, and then selecting the Font &Colors page in the Data Editor folder.

ExpandedToggleIcon(9x12) Options

Data Editor Font & Colors section of the Options window contains the following options:

Font
Select a font for the selected display item here.

Size
Specify a font size for the selected display item here.

Use Defaults
Click this button to reset specified font and color settings to the default values.

Display item
Select a display item here to change its background and foreground color settings.

Item foreground
Select a font color for the selected display item.

Item background
Select a background color for the selected display item.

Sample
Preview the display item appearance here.

ExpandedToggleIcon(9x12) See Also

Data Editor Options

Printing, Data Editor, Options Dialog Box


Printing, Data Editor, Options Dialog Box

This dialog box allows you to change default printing options. You can access this dialog box by clicking Options on the Tools menu, and then selecting the Printing page in the Data Editor folder.

ExpandedToggleIcon(9x12) General

Auto width
Select to fit the printed data to the page width.

ExpandedToggleIcon(9x12) Grid

Print horizontal lines
Select to print grid horizontal lines.

Print vertical lines
Select to print grid vertical lines.

ExpandedToggleIcon(9x12) Card

Print card captions
Select to prints card captions.

Print empty fields
Select to prints card empty fields.

ExpandedToggleIcon(9x12) See Also

Data Editor Options

Formatting, Data Editor, Options Dialog Box


Formatting, Data Editor, Options Dialog Box

Use the Options window to adjust the products behavior to your needs. You can access this dialog box by clicking Options on the Tools menu, and then selecting the Formatting page in the Data Editor folder.

ExpandedToggleIcon(9x12) DateTime Format

Data type
Select either Date or DateTime format here.

Edit format
Set the datetime format here. It can be one of the predefined formats or custom format. Predefined formats are described below. The following table contains all available format specifiers and their description.

Format Specifier

Description

d

A placeholder for the day of the month. If the day is a single digit only (1-9), then it's displayed as a single digit.

Note that if the 'd' specifier is used alone, without other custom specifiers, it's interpreted as the standard mask (short date pattern). If the 'd' specifier is passed with other custom specifiers or the '%' character, it's interpreted as a custom mask specifier.

dd

A placeholder for the day of the month. If the day is a single digit only (1-9), it is formatted with a preceding 0 (01-09).

ddd

Displays the abbreviated name of the current day.

The value represented by this specifier cannot be edited.

dddd (plus any number of additional "d" characters)

Displays the full name of the current day.

The value represented by this specifier cannot be edited.

f

A placeholder for seconds fractions represented in one digit.

Note that if the 'f' specifier is used alone without other custom specifiers, it's interpreted as the standard mask (full date/time pattern ). If the 'f' specifier is passed with other custom specifiers or the '%' character, it's interpreted as a custom mask specifier.

ff

A placeholder for seconds fractions represented in two digits.

fff

A placeholder for seconds fractions represented in three digits.

ffff

Displays seconds fractions represented in four digits.

The value represented by this specifier cannot be edited.

fffff

Displays seconds fractions represented in five digits.

The value represented by this specifier cannot be edited.

ffffff

Displays seconds fractions represented in six digits.

The value represented by this specifier cannot be edited.

fffffff

Displays seconds fractions represented in seven digits.

The value represented by this specifier cannot be edited.

g

Displays the era (A.D. for example) for the current date/time value.

The value represented by this specifier cannot be edited.

h

A placeholder for the hour part of the date/time value in the range 1-12.

hh

A placeholder for the hour part of the date/time value in the range 1-12. This pattern inserts two placeholders to enter a value. If a single digit is entered it is preceded with a '0'.

H

A placeholder for the hour part of the date/time value in the range 0-23.

HH

A placeholder for the hour part of the date/time value in the range 0-23. This pattern inserts two placeholders to enter a value. If a single digit is entered it is preceded with a '0'.

m

A placeholder for the minutes of the date/time value in the range 0-59.

mm

A placeholder for the minutes of the date/time value in the range 0-59. This pattern inserts two placeholders to enter a value. If a single digit is entered it is preceded with a '0'.

M

A placeholder for the month in this position, measured as a number in the range 1-12.

MM

A placeholder for the month in this position, measured as a number in the range 1-12. This pattern inserts two placeholders to enter a value. If a single digit is entered it is preceded with a '0'.

MMM

A placeholder for the abbreviated name of the month.

MMMM

A placeholder for the full name of the month.

s

A placeholder for the seconds part of the date/time value in the range 0-59.

Note that if the 's' specifier is used alone without other custom specifiers it's interpreted as the standard mask (sortable date/time pattern). If the 's' specifier is passed with other custom specifiers or the '%' character, it's interpreted as a custom mask specifier.

ss

A placeholder for the seconds part of the date/time value in the range 0-59. This pattern inserts two placeholders to enter a value. If a single digit is entered it's preceded with a '0'.

t

A placeholder for the first character of the A.M./P.M. designator of the date/time value.

Note that if the 't' specifier is used alone without other custom specifiers it's interpreted as the standard mask (short time pattern). If the 't' specifier is passed with other custom specifiers or the '%' character, it's interpreted as a custom mask specifier.

tt

A placeholder for the A.M./P.M. designator of the date/time value.

y

A placeholder for entering the last two digits of the year of the date/time value.

Note that if the 'y' specifier is used alone without other custom specifiers, it's interpreted as the standard mask (year month pattern). If the 'y' specifier is passed with other custom specifiers or the '%' character it's interpreted as a custom mask specifier.

yy

A placeholder for entering the last two digits of the year of the date/time value. This pattern inserts two placeholders to enter a value. If a single digit is entered it is preceded with a '0'.

yyyy

A placeholder for entering the year part of the date/time value including the century.

z

Displays the time zone offset for the system's current time zone in whole hours only. The offset is always displayed with a leading sign (zero is displayed as "+0"), indicating how many hours ahead of Greenwich mean time (+) or hours behind Greenwich mean time (-) the current time zone is. The range of values is -12 to +13. If the offset is a single digit (0-9), it's displayed as a single digit with an appropriate leading sign.

The value represented by this specifier cannot be edited.

zz

Displays the time zone offset for the system's current time zone in whole hours only. The offset is always displayed with a leading or trailing sign (zero is displayed as "+00"), indicating how many hours ahead of Greenwich mean time (+) or hours behind Greenwich mean time (-) the current time zone is. The range of values is -12 to +13. If the offset is a single digit (0-9), it's formatted with a preceding 0 (01-09) with an appropriate leading sign.

The value represented by this specifier cannot be edited.

zzz

Displays the time zone offset for the system's current time zone in hours and minutes. The offset is always displayed with a leading or trailing sign (zero is displayed as "+00:00"), indicating how many hours ahead of Greenwich mean time (+) or hours behind Greenwich mean time (-) the current time zone is. The range of values is -12:00 to +13:00. If the offset is a single digit (0-9), it's formatted with a preceding 0 (01-09) with an appropriate leading sign.

The value represented by this specifier cannot be edited.

:

Time separator.

/

Date separator. The actual date separator is determined by the DateTimeFormatInfo.DateSeparator property of the current culture.

"abc" or 'abc'

Quoted string. Inserts the string enclosed with single or double quotes literally to the edit box. The string cannot be edited.

%c

Where c is one of the standard mask specifiers, makes the specifier be interpreted as a custom mask specifier.

Note that if a mask specifier is used alone as a single character, it's interpreted as a standard mask specifier. Only mask specifiers consisting of two or more characters are interpreted as custom specifiers. In order to use a custom specifier on its own which matches one of the standard specifiers it should be preceded with the % character.

\c

The backslash is used as the escape character. It inserts the following character literally to the edit box.

Any other characters.

The other characters are inserted to the edit box literally.

ExpandedToggleIcon(9x12) Predefined Formats

You can choose one of the predefined datetime formats here. The following table contains their descriptions and samples.

Standard Mask | Name | Sample. Culture: English (USA)
d | Short date | 8/20/2007
D | Long date | Monday, August 20, 2007
t | Short time | 10:23 AM
T | Long time | 10:23:35 AM
f | Full date/time (short time) | Monday, August 20, 2007 10:23 AM
F | Full date/time (long time) | Monday, August 20, 2007 10:23:35 AM
g | General date/time (short time) | 8/20/2007 10:23 AM
G | General date/time (long time) | 8/20/2007 10:23:35 AM
M or m | Month day | August 20
R or r | RFC1123 | Mon, 20 Aug 2007 10:23:35 GMT
s | Sortable date/time | 2007-08-20T10:23:35
u | Universal sortable date/time | 2007-08-20 10:23:35Z
Y or y | Year month | August, 2007

ExpandedToggleIcon(9x12) See Also

Data Editor Options

Data Comparison Options


Data Comparison Options

ExpandedToggleIcon(9x12) In This Section

General, Data Comparison, Options Dialog Box
This dialog box allows you to change the default behavior of the Data Comparison.

ExpandedToggleIcon(9x12) See Also

Options

Database Diagram Options


General, Data Comparison, Options Dialog Box

This dialog box lets you change global settings for the Data Comparison. To display this dialog box, click Options on the Tools menu, expand the Data Comparison node, and then click General.

ExpandedToggleIcon(9x12) Settings

The Data Comparison General section of the Options window contains the following options:

Cache Folder
Allows selecting a directory to store temporary data needed during the comparison process.

Windows Temporary Folder
Select to store temporary files to the windows temporary folder.

Custom Folder
Select this option to store temporary files in a custom folder. To choose a folder, click the Browse... button.

ExpandedToggleIcon(9x12) See Also

Data Comparison Options

Database Diagram Options


Database Diagram Options

This section describes options that help to customize a database diagram. Options can be set either globally for all the diagram documents or separately for a particular one.

To set default options for new diagram documents, in the Tools menu, click Options. Then go to the Database Diagram node. To set options for the current diagram, right-click the diagram and then select Options from the shortcut menu.

This dialog allows you to customize options for a diagram. It contains the same options as the Options dialog box, but options in this dialog are applied only to the current diagram document.

Diagram Options tabs have the Default button instead of the Reset button on the corresponding pages of the Options dialog box. This button resets settings for the current diagram to the values currently set in the Options dialog box.

ExpandedToggleIcon(9x12) In This Section

General, Database Diagram, Options Dialog Box
Describes general diagram options.

Notation, Database Diagram, Options Dialog Box
Describes options for adjusting default settings for new diagram documents.

Page, Database Diagram, Options Dialog Box
Describes how to set page settings for diagram printing.

Print, Database Diagram, Options Dialog Box
Describes how to set options for diagram printing.

ExpandedToggleIcon(9x12) See Also

Options

Database Explorer Options


General, Database Diagram, Options Dialog Box

Use the Options window to adjust database diagram behavior to your needs. To open it, select Options from the Tools menu.

Options can be set either globally for all the diagram documents or separately for a particular one.

The General section of the Database Diagram node contains the following options:

ExpandedToggleIcon(9x12) General

Background Color
Choose the background color for the diagram.

Auto Scale on Drop
Select to scale diagram automatically to fit all its shapes when dropping database objects to the diagram.

Preserve routing
Select to preserve routing of relation links on the diagram.

Wheel Scale
Select it to zoom the diagram in and out with the scroll wheel. When the option is selected, hold the Ctrl button and use the wheel to scroll; when the option is cleared, use Ctrl+scroll to zoom the diagram in/out.

ExpandedToggleIcon(9x12) Grid

Show Grid
Select to enable grid on the diagram.

Enable Grid Snap
Select to enable snapping shapes to grid when dragging them.

Grid Step
Set size for the grid cells in pixels.

ExpandedToggleIcon(9x12) Shadow

Enable Shadows
Select to enable shadows for diagram shapes.

X Offset
Set horizontal offset for the shape shadow.

Y Offset
Set vertical offset for the shape shadow.

ExpandedToggleIcon(9x12) Reset

Resets all options on this page to their default values.

note Note

You can access the aforementioned options (except the Reset button) if you right-click a diagram and select Options from the menu. Instead of the Reset button in the options, you will see Default. The difference between these buttons is the following:

Reset restores all the options to the Devart predefined values. The Default button restores options to those specified in the Database Diagram General section of the Options window.

ExpandedToggleIcon(9x12) See Also

Database Diagram Options

Notation, Database Diagram, Options Dialog Box


Notation, Database Diagram, Options Dialog Box

Use the Options window to adjust database diagram behavior to your needs. To open it, select Options from the Tools menu.

Options can be set either globally for all the diagram documents or separately for a particular one.

The Notation section of the Database Diagram node allows you to customize notations. It contains the following options:

ExpandedToggleIcon(9x12) Skin

Skin Type
Choose the diagram skin type.

ExpandedToggleIcon(9x12) Relations

Relation Notation
Allows you to choose relation notation, that determines its look on the diagram. IE and IDEF1X notation.

Show Relation Comments
Select to display foreign key names near the relation child ends.

ExpandedToggleIcon(9x12) Tables

Table Compartments
Select table compartments to display.

Separate Primary Keys
Select to separate primary key columns with horizontal line.

Field Details Level
Select detail level for displaying table and view columns. You may choose to display only their names, names and data type, or names and detailed datatype with size (or precision and scale).

ExpandedToggleIcon(9x12) Reset

Resets all options on this page to their default values.

note Note

You can access the aforementioned options (except the Reset button) if you right-click a diagram and select Options from the menu. Instead of the Reset button in the options, you will see Default. The difference between these buttons is the following:

Reset restores all the options to the Devart predefined values. The Default button restores options to those specified in the Database Diagram General section of the Options window.

ExpandedToggleIcon(9x12) See Also

Database Diagram Options

Page, Database Diagram, Options Dialog Box


Page, Database Diagram, Options Dialog Box

Use the Options window to adjust database diagram behavior to your needs. To open it, select Options from the Tools menu.

Options can be set either globally for all the diagram documents or separately for a particular one.

The Page section of the Database Diagram node allows you to customize page settings for diagram printing. It contains the following options:

ExpandedToggleIcon(9x12) Paper

Size
Set the size of paper for printing.

Source
Specify where the paper you want to use is located in the printer.

ExpandedToggleIcon(9x12) Orientation

Specify how the document is positioned on the page.

ExpandedToggleIcon(9x12) Margins

Specify margins to set the printing area of the page.

ExpandedToggleIcon(9x12) Overlap

Set the percentage of the printing area which will be overlapped on the adjacent pages.

ExpandedToggleIcon(9x12) Header and Footer

Header text
Specify the text to print at the top of each page. Use the following letter and character combinations to print specific information in the page header.

· &f - Insert the file name.
· &d - Insert the current date.
· &t - Insert the current time.
· &p - Insert page numbers.
· &P - Insert the page count

Footer text
Specify the text to print at the bottom of each page. Use the following letter and character combinations to print specific information in the page header.

· &f - Insert the file name.
· &d - Insert the current date.
· &t - Insert the current time.
· &p - Insert page numbers.
· &P - Insert the page count

ExpandedToggleIcon(9x12) Reset

Resets all options on this page to their default values.

note Note

You can access the aforementioned options (except the Reset button) if you right-click a diagram and select Options from the menu. Instead of the Reset button in the options, you will see Default. The difference between these buttons is the following:

Reset restores all the options to the Devart predefined values. The Default button restores options to those specified in the Database Diagram General section of the Options window.

ExpandedToggleIcon(9x12) See Also

Database Diagram Options

Print, Database Diagram, Options Dialog Box


Print, Database Diagram, Options Dialog Box

Use the Options window to adjust database diagram behavior to your needs. To open it, select Options from the Tools menu.

Options can be set either globally for all the diagram documents or separately for a particular one.

The Print section of the Database Diagram node allows you to customize diagram printing settings. It contains the following options:

ExpandedToggleIcon(9x12) Printer

note Note

This section is available only if you open the Options window by right-clicking the diagram and selecting Options in the menu.

Name
Select a required printer from the list.

Properties
Click to set up a printer in the Printer Properties dialog box.

ExpandedToggleIcon(9x12) Scaling

Center Image
Select to center the image on the page.

Scale
Specify scale for printing.

Fit to Pages
Select to use automatic scaling to fit to the specific number of pages.

Pages Across
Specify the number of pages to fit the diagram width to.

Pages Down
Specify the number of pages to fit the diagram height to.

ExpandedToggleIcon(9x12) Print Elements

Print Grid
Select to print the diagram grid.

Print Markup Mode
Specify whether to print the markup which helps to cut and glue together the diagram that is printed several sheets.

None
No markup is printed.

Page Margins
Page margin borders are printed as a dotted line. Only borders of margins, that should be cut off are printed. For example, for top left page only right and bottom borders are printed.

Full Markup
Overlapping borders markup is printed where needed to help you to glue diagram pages together.

ExpandedToggleIcon(9x12) Reset

Resets all options on this page to their default values.

note Note

You can access the aforementioned options (except the Reset button) if you right-click a diagram and select Options from the menu. Instead of the Reset button in the options, you will see Default. The difference between these buttons is the following:

Reset restores all the options to the Devart predefined values. The Default button restores options to those specified in the Database Diagram General section of the Options window.

ExpandedToggleIcon(9x12) See Also

Database Diagram Options

Database Explorer Options


Database Explorer Options

This section describes Database Explorer options.

ExpandedToggleIcon(9x12) In This Section

General, Database Explorer Options Dialog Box
Describes the tab, where you can customize Database Explorer behavior.

ExpandedToggleIcon(9x12) See Also

Options

Debugging Options


General, Database Explorer Options Dialog Box

Use the Options window to adjust dbForge Studio behavior to your needs. To open it, select Options from the Tools menu. Then go to the Database Explorer node.

The General section of the Database Explorer node contains following options.

ExpandedToggleIcon(9x12) Settings

Show detailed column name in tree
Shows column type, and whether it is not null in the tree.

ExpandedToggleIcon(9x12) Table and View

Customize dbForge Studio default behavior when double-clicking on table or view node in Database Explorer.

Open object editor
Opens object editor for the table or view.

Retrieve data
Opens document with data of the table or view.

ExpandedToggleIcon(9x12) Procedure and Function

Customize dbForge Studio default behavior when double-clicking on procedure or function node in Database Explorer.

Open object editor
Opens object editor for the procedure or function.

Execute
Executes the procedure or function.

ExpandedToggleIcon(9x12) See Also

Database Explorer Options

Debugging Options


Debugging Options

This section describes debugging options.

ExpandedToggleIcon(9x12) In This Section

General, Debugger, Options Dialog Box
Describes the tab where you can setup debugging behavior when you debug a stored procedure or SQL script, make changes to it and then try to continue or step execution.

ExpandedToggleIcon(9x12) See Also

Options

Generate Schema Script Options


General, Debugging, Options Dialog Box

Use the Options window to adjust dbForge Studio behavior to your needs. To open it, select Options from the Tools menu. Then go to the Debugging node.

The General section of the Debugging node contains the following options:

Warn me if I make changes
Select to invoke the Unable to Apply Code Changes dialog box each time you debug a stored procedure or SQL script, make changes to it and then try to continue or step execution.

Always restart the debugging after I make changes
When selected, disables the Unable to Apply Code Changes dialog box. Instead, the debugger will automatically save changes and restart the stored procedure or SQL script.

Always ignore changes and continue debugging
When selected, disables the Unable to Apply Code Changes dialog box. Instead, the debugger will automatically continue, without applying the changes, when you try to step or continue.

Timeout
Specify the timeout here.

ExpandedToggleIcon(9x12) See Also

Debugging Options

Generate Schema Script Options


Generate Schema Script Options

This section describes DDL generation options.

ExpandedToggleIcon(9x12) In This Section

General, Generate Schema Script Options Dialog Box
Describes general options for DDL generating.

Objects, Generate Schema Script Options Dialog Box
Describes more specific options for DDL generating.

ExpandedToggleIcon(9x12) See Also

Options

Master-Detail Options


General, Generate Schema Script Options Dialog Box

Use the Options window to adjust dbForge Studio behavior to your needs. To open it, select Options from the Tools menu. Then go to the Generate Schema Script node.

The General subsection of the Generate Schema Script node contains the following options:

Append script to active SQL document
Select to append generated DDL statements to the active SQL documents.

Show script options in Generate Schema Script Wizard
Select to show DDL Options page in the Generate Schema Script Wizard. Otherwise these default options will be displayed.

ExpandedToggleIcon(9x12) See Also

Generate Schema Script Options

Objects, Generate Schema Script, Options Dialog Box


Objects, Generate Schema Script, Options Dialog Box

Use the Options window to adjust dbForge Studio behavior to your needs. To open it, select Options from the Tools menu. Then go to the Generate Schema Script node.

The Objects section of the Generate Schema Script node contains following options:

ExpandedToggleIcon(9x12) Settings

Schema Export Wizard
Select to set options for Schema Export wizard.

New Project Wizard
Select to set options for New Project wizard.

Search
Enter a filter string. Use "_" symbol to substitute any character.

ExpandedToggleIcon(9x12) General

Contains general settings for DDL generating.

Exclude objects named with '$'
Select to exclude objects that contain '$' symbol in their names from the script.

Format the script
Select to format any DDL text. Otherwise, DDL text will have the same formatting as in database.

Generate comments in the script
Select to insert comments in the DDL.

Include body for packages and objects
Select to include body for packages and objects in the script.

Include CASCADE CONSTRAINTS option
Select to include the CASCADE CONSTRAINTS option in the script.

Include CONNECT command
Select to include the CONNECT command with current connection settings in the script.

Include DROP statement
Select to include DROP statements in the DDL.

Include physical attributes clause
Select to include a physical attributes clause of schema in the script.

Include PURGE option
Select to include the PURGE option in the script.

Include SET CURRENT_SCHEMA
Select to include a statement that changes current schema to the one being exported. ALTER SESSION CURRENT_SCHEMA statement will be written in the beginning of the script.

Include storage clause
Select to include the STORAGE clause of schema objects in the script.

Include tablespace names in script
Select to include tablespace names of schema objects in the script.

Prefix object names with a database name
Select to add schema name as a prefix for object names. If you enable schema prefixes generation, you will not be able to import this script to another schema.

Use CREATE OR REPLACE
Select to use CREATE OR REPLACE statement instead of CREATE statement for objects' script generation.

ExpandedToggleIcon(9x12) Tables/Views

Contains settings for generating DDL of tables and views.

Disable constraints
Determines whether to add ALTER TABLE ... DISABLE KEYS statement before INSERT statements.

Exclude column default values
Select to exclude column default values from the DDL.

Exclude START and NEXT for materialized views
Select to exclude START and NEXT clauses for materialized views.

Include constraints
Select to include constraints for the tables in the DDL.

Include indexes
Select to include indexes for the tables in the DDL.

Include object comments
Select to include comments for objects in the script.

Include triggers
Select to include triggers for the tables in the DDL.

ExpandedToggleIcon(9x12) Partitioning

Contains settings for generating DDL of partitioned database objects.

Exclude partition list for locally partitioned index
Select to exclude partition list for locally partitioned index from DDL.

Include partition clause
Select to include PARTITION clause in DDL.

Include tablespace name for index partitions
Select to include tablespace name for every index partition in DDL.

Include tablespace name for partitions
Select to include tablespace name for every partition in DDL.

List individual hash partitions
Select to list individual hash partitions in DDL. Depends on "Include partition clause" option.

ExpandedToggleIcon(9x12) Users/Roles

Contains settings for generating DDL of users.

Include an encrypted password
Select to include an encrypted password in the script.

Include grants
Select to include grants for users in the DDL.

Include object grants
Select to include any object grants for users in the DDL.

Include user information
Select to include CREATE USER statements in the script.

ExpandedToggleIcon(9x12) Data

Contains settings for manipulating generation of DML statements.

Include column names into INSERT statements
Select to include column names into INSERT statement.

Insert COMMIT after every N statements
Select to insert COMMIT statement after each defined number of INSERT statements.

Edit Value
Select the number of statements before the COMMIT statement.

ExpandedToggleIcon(9x12) See Also

Generate Schema Script Options

Master-Detail Options


Master-Detail Options

This section describes the available Master-detail options.

ExpandedToggleIcon(9x12) In This Section

Page, Master-detail, Options Dialog Box
Describes options available for Master-detail page setup.

Print, Master-detail, Options Dialog Box
Describes how to set options for Master-detail printing.

ExpandedToggleIcon(9x12) See Also

Options

Query Builder Options


Page, Master-Detail, Options Dialog Box

Use the Options window to adjust database diagram behavior to your needs. To open it, select Options from the Tools menu. Then go to the Master-Detail node.

The Page section of the Master-Detail node allows you to customize page settings for diagram printing. It contains the following options:

ExpandedToggleIcon(9x12) Paper

Size
Set the size of paper for printing.

Source
Specify where the paper you want to use is located in the printer.

ExpandedToggleIcon(9x12) Orientation

Specify the way the document is positioned on the page.

ExpandedToggleIcon(9x12) Margins

Specify margins to set the printing area of the page.

ExpandedToggleIcon(9x12) Overlap

Set the percentage of the printing area which will be overlapped on the adjacent pages.

ExpandedToggleIcon(9x12) Header and Footer

Header text
Specify the text to print at the top of each page. Use the following letter and character combinations to print specific information in the page header.

· &f - Insert the file name.
· &d - Insert the current date.
· &t - Insert the current time.
· &p - Insert page numbers.
· &P - Insert the page count

Footer text
Specify the text to print at the bottom of each page. Use the following letter and character combinations to print specific information in the page header.

· &f - Insert the file name.
· &d - Insert the current date.
· &t - Insert the current time.
· &p - Insert page numbers.
· &P - Insert the page count

ExpandedToggleIcon(9x12) Reset

Resets all options on this page to their default values.

note Note

You can access the aforementioned options (except the Reset button) if you right-click a diagram and select Options from the menu. Instead of the Reset button in the options, you will see Default. The difference between these buttons is the following:

Reset restores all the options to the Devart predefined values. The Default button restores options to those specified in the Database Diagram General section of the Options window.

ExpandedToggleIcon(9x12) See Also

Master-Detail Options

Print, Master-Detail, Options Dialog Box


Print, Master-Detail, Options Dialog Box

Use the Options window to adjust database diagram behavior to your needs. To open it, select Options from the Tools menu. Then go to the Master-Detail node.

The Print section of the Master-Detail node allows you to customize diagram printing settings. It contains the following options:

ExpandedToggleIcon(9x12) Scaling

Center Image
Select to center the image on the page.

Scale
Specify scale for printing.

Fit to Pages
Select to use automatic scaling to fit to the specific number of pages.

Pages Across
Specify the number of pages to fit the diagram width to.

Pages Down
Specify the number of pages to fit the diagram height to.

ExpandedToggleIcon(9x12) Print Elements

Print Grid
Select to print the diagram grid.

Print Markup Mode
Specify whether to print the markup which helps to cut and glue together the diagram that is printed several sheets.

None
No markup is printed.

Page Margins
Page margin borders are printed as a dotted line. Only borders of margins, that should be cut off are printed. For example, for top left page only right and bottom borders are printed.

Full Markup
Overlapping borders markup is printed where needed to help you to glue diagram pages together.

ExpandedToggleIcon(9x12) Reset

Resets all options on this page to their default values.

note Note

You can access the aforementioned options (except the Reset button) if you right-click a diagram and select Options from the menu. Instead of the Reset button in the options, you will see Default. The difference between these buttons is the following:

Reset restores all the options to the Devart predefined values. The Default button restores options to those specified in the Database Diagram General section of the Options window.

ExpandedToggleIcon(9x12) See Also

Master-Detail Options

Query Builder Options


Query Builder Options

This section describes options for Query Builder's diagram.

ExpandedToggleIcon(9x12) In This Section

General, Query Builder Options Dialog Box
Describes options to tune Query Builder's diagram.

ExpandedToggleIcon(9x12) See Also

Options

Query Profiler Options


General, Query Builder Options Dialog Box

Use the Options window to adjust dbForge Studio behavior to your needs. To open it, select Options from the Tools menu. Then go to the Query Builder node.

The General section of the Query Builder node allows you to customize diagram appearance and diagram grid options. You can use the following options:

Enable shadows
Select to enable shadows for diagram table shapes.

Enable grid
Select to enable grid on the diagram.

Grid size
Set grid size in pixels.

Snap to grid
Select to enable snapping shapes to grid when dragging them.

Background color
Set the diagram background color.

Skin type
Choose Default or Classic skin type to adjust the diagram appearance to your needs.

Use Defaults
Click to reset options on this page to their default values.

ExpandedToggleIcon(9x12) See Also

Query Builder Options

Query Profiler Options


Query Profiler Options

This section explains code formatting options provided in the Options window.

ExpandedToggleIcon(9x12) In This Section

General, Query Profiler Options Dialog Box
Describes the options to customize Query Profiler behavior.

ExpandedToggleIcon(9x12) See Also

Options

Schema Comparison Options


General, Query Profiler Options Dialog Box

Use the Options window to adjust the dbForge Studio behavior to your needs. To open it, select Options from the Tools menu. Then go to the Query Profiler node.

The General section of the Query Profiler node contains the following options:

Maximum history size
Set the number of query profiling results that can be stored on the Profiler tab.

Do not highlight differences less than X.xxx s. during comparison
Set the difference in time between performing actions when they should be highlighted.

Display SQL query while printing SQL results
Select it to print the SQL query text with the query profiling results.

ExpandedToggleIcon(9x12) See Also

Schema Comparison Options

Query Profiler Options


Schema Comparison Options

This section describes schema comparison options.

ExpandedToggleIcon(9x12) In This Section

General, Schema Comparison Options Dialog Box
Describes the tab where you can customize text comparer settings for schema comparison.

ExpandedToggleIcon(9x12) See Also

Options


General, Schema Comparison Options Dialog Box

Use the Options window to adjust dbForge Studio behavior to your needs. To open it, select Options from the Tools menu. Then go to the Schema Comparison node.

The General section of the Schema Comparison node contains the following options:

Text Comparer

Internal
Use internal dbForge Studio comparer. Text comparer will be displayed at the bottom of the Schema Comparison document.

Araxis Merge
Use Araxis Merge. This option is available only if Araxis Merge 2001 or higher is installed.

Custom
Use a custom comparer. You should set Comparer Location and Command Line Parameters to use this option.

Comparer Location
Specify the comparer executable file here.

Command Line Parameters
Specify command line parameters for the comparer call. You may use the following predefined parameters:

· %file1% - full name with path of the first file to compare.
· %file2% - full name with path of the second file to compare.
· %title1% - title for the first comparison pane.
· %title2% - title for the second comparison pane.

ExpandedToggleIcon(9x12) See Also

Schema Comparison Options


Pivot Table

This section contains detailed information on all the windows and dialog boxes related to PivotGrid functionality.

ExpandedToggleIcon(9x12) In This Section

Pivot Table View
Describes how to create and manage pivot tables using the Pivot Grid view of the SQL document.

PivotGrid Prefilter Dialog Box
Shows how to apply various filter criteria using the PivotGrid Prefilter dialog box.

Conditional Styles Dialog Box
Teaches how to customize a pivot table appearance with the help of the Conditional Styles dialog box.

Collection Editor Dialog Box
Shows how to create a custom group mode using the Collection Editor dialog box.

Data Source View
Tells how to use the Data Source view to create pivot tables.

Chart View
Describes the Chart view of the Pivot Table document.


Pivot Table View

Use this document view to convert your data into compact and informative summaries - pivot tables. To open an empty Pivot Table document view, do either of the following:

· On the File menu, click New and then click PivotGrid Pivot Table in the top menu.
· On the Database menu click PivotGrid Pivot Table
· Open an SQL document or a query document, right-click its bottom part and select PivotGrid Pivot Table from the shortcut menu.

To create a pivot table, drag-and-drop fields from the Data Source view to required areas in the Pivot Table view. You can rearrange (or pivot) your fields by a simple drag of a mouse until you get the layout best for understanding the data relations and dependencies.

Pivot Table Toolbar

The Pivot Table view contains the following toolbar buttons:

Refresh
Use this option to refresh data.

Edit SQL Text
Contains SQL code of the created pivot table. Changes you make in the visual part of the editor are immediately available in the SQL Text editor

Show Data Source
Opens Data Source View.

Prefilter
Opens Prefilter Dialog Box.

Conditional Styles
Opens Collection Editor Dialog Box.

Show Chart
Opens Chart View.

Pivot Table Visual UI Elements

The Pivot Table view contains the following areas:

Filter area
Place the data source field(s) here to filter all the data in a pivot table by applying custom filtering criteria.

Data area
Place the data source field here to get custom totals and grand totals.

Row area
Place the data source field(s) here to display the data in rows in a pivot table. The field(s) will consist of a row header and values. The header will display a row name and will allow you to sort and filter the row data, move the field to any area in the PivotGrid window to rearrange the data.

Column area
Place the data source field(s) here to display the data in columns in a pivot table. The field(s) will consist of a column header and values. The header will display a column name and will allow you to sort and filter the column data, move the field to any area in the PivotGrid window to rearrange the data.

Grand Total
When you add any data fields to the Row Field, Column Field, and Data areas in the PivotGrid window, grand total values are automatically calculated and displayed in the Data area highlighted with the light yellow color.

Custom Total
Total values are calculated based on selected summary functions. The default function calculates the sum of all values in rows and columns. You can cancel the default function or apply other functions besides the default one using the Summary drop-down list in the Properties window.

For more information about the Pivot Table document view, go to the Pivot Table Components topic.

ExpandedToggleIcon(9x12) See Also

Pivot Table

PivotGrid Prefilter Dialog Box


Prefilter Dialog Box

Use this dialog box to apply advanced filtering conditions to filter data in a pivot table. To open the dialog box, click the [image] Prefilter icon on the toolbar or right-clock the pivot table header and select Prefilter from the menu. The Prefilter dialog box contains the following details:

ExpandedToggleIcon(9x12) Condition group

It is displayed as a red-colored logical operator and the FilterGreyAdd button to add a new condition to a group. Clicking the logical operator displays the following menu:

And
Sets And logical operator for the group. All group conditions must be true.

Or
Sets Or logical operator for the current group. At least one condition from the group must be true.

Not And
Sets Not And logical operator for the current group. At least one condition from the group must be false.

Not Or
Sets Not Or logical operator for the current group. All group conditions must be false.

Add Condition
Adds a new condition to the current group.

Add Group
Adds a new condition group to the current group.

Clear All
Removes all conditions and sub-groups, leaving only the top-level group node. This command is available for the top-level condition group only.

Remove Group
Removes the condition group. This command is available for all the condition groups except a top-level one.

ExpandedToggleIcon(9x12) Condition

A condition consists of the following details:

Operand
An editable field containing the list of data source fields. Click the operand and select a required field from the drop-down list.

Criteria operator
A green-colored criteria operator, e.g., [image]. To set another operator for a condition, click the operator and choose another from the appeared menu.

Click it to add a new condition.

Click it to remove a condition.

ExpandedToggleIcon(9x12) See Also

Pivot Table

Conditional Styles Dialog Box


Conditional Styles Dialog Box

Use this dialog box to change the pivot table appearance based on specific conditions. To open this dialog box, click the [image] Conditional Styles icon on the toolbar or right-click the pivot table header and select Conditional Styles from the menu. The dialog box contains the following:

Add Condition
Click it to create a new condition for customizing a pivot table.

Up and Down
Click these arrows to change the order of conditional styles in the Conditions list.

Remove
Click it to remove the selected conditional style from the Conditions list and the pivot table.

Clear All
Click it to remove all the conditional styles from the Conditions list and the pivot table at once.

Conditions list

Contains the list of created conditions. Select a required condition in the list and see its properties displayed on the right part of the Conditional Styles dialog box. You can change the order of conditions or remove them by using the corresponding buttons on the toolbar.

Condition properties

Set properties of a condition here. For example, you want to highlight values from some field that are in 100-1000 range. You need to select a required field from the drop-down list and go to the Condition field to select Between value. Then enter 100 and 1000 into Value1 and Value2 fields to specify the required range. In the Apply To section you should clear all the check boxes except the Cell one, as you don't need to apply this condition for all the cell types in the pivot table. The last thing is to select a required background color in the Appearance section. The style is ready and will be applied when you click OK in the dialog box.

Field
Contains the list of data source fields, which you can select for applying the conditional styles.

Condition
Contains the list of logical operators (e.g., Equal, Less, Greater, etc) to apply to the values of the selected data source field.

Value1 and Value2
Enter values for the specified condition. Value2 field is required when you specify the range of values.

Apply To
Allows you to select the cell types to apply the created style. You can select the following types:

Cell - to apply for all the cells in the pivot table.

Total Cell - to apply for cells containing automatically calculated sum of row or column field values. By default such sells are highlighted with the grey color in the pivot table.

Grand Total Cell - to apply for cells containing automatically calculated sum of row or column field totals. By default such sells are highlighted with the light yellow color in the pivot table.

Custom Total Cell - to apply for cells containing values calculated based on selected summary functions. By default such sells are highlighted with the grey color in the pivot table.

Appearance
In this section you can set the following properties to change the pivot table appearance:

BackColor
Select a required background color to apply for the selected cells.

BackColor2
The color selected in this field is applied only if some color is selected in the BackColor field. Both colors will be displayed as gradient.

Font
Expand the node and select a font and its properties to use in the selected cell(s).

ForeColor
Select a font color to use in the selected cell(s).

GradientMode
Select a required gradient mode from the field. The selected mode will be applied only if BackColor and BackColor2 values are set.

Image
Click this field and select a required image in the Open dialog box to set as a background in the pivot table cells.

ExpandedToggleIcon(9x12) See Also

Pivot Table

Collection Editor Dialog Box


Collection Editor Dialog Box

Use this dialog box to specify a range to group numeric values in a pivot table. To open the dialog box, right-click a required field in the Data Source view and select Custom from the menu. Collection Editor contains the following details:

Add Value
Click it to add a value to set a range for a created custom group mode.

Remove
Click it to remove the custom group mode from the Collection Editor window and a pivot table.

Clear All
Click it to remove all the custom group modes from the Collection Editor window and a pivot table at once.

Value
Enter value to set a range for a created custom group mode.

ExpandedToggleIcon(9x12) See Also

Pivot Table

Data Source View


Data Source View

When you are creating a pivot table in the Pivot Table view of the SQL or query document, use the Data Source view to see and manage a list of data source fields bound to a pivot table.

To bound some fields to the pivot table, place required fields to the Data Source view. Use either of these ways:

· Compose the query on the Query Builder diagram and switch to the PivotGrid mode.
· Drag-and-drop a required table from Database Explorer either to the Data Source view or the PivotGrid window.

Using the Data Source view you can manage the fields in the following ways:

· Add them to required pivot table areas or remove with a single drag of a mouse.
· Apply predefined group modes and create custom ones using the shortcut menu.
· Switch to the Properties window to apply summary functions to calculated custom totals for the field values.

note Note

You can add one table or view to the Data Source view. To do this, select the needed table or view in Database Explorer and clicking Send to Pivot Table option from the shortcut menu or click the same option in the Data view of Object Viewer or the Data window shortcut menu.

If you click Send to and select Pivot Table on the Data tab of any SQL document, the Pivot Table tab will be opened for this document

The Data Source view contains the following details:

Top root of the data fields tree
It contains a name of the opened SQL document for which you are creating a pivot table.

Data fields
The tree of data fields specified in the opened SQL document which is a data source for a pivot table. You can select any field and drag it to a required pivot table area in the Pivot Table view to add to a pivot table. If you double-click a field it will be added to the pivot table area that is currently selected in the Destination area. If any field is already added to the area, the newly added field will be placed to the left of it.

You can right-click a field in the tree and select a predefined group mode or create a custom one to group the field values in a pivot table.

Add To
Use this button to place data source fields to required pivot table areas in the Pivot Table view. Do the following:

1. Select a field in the tree.
2. Select a required pivot table area from the Destination area drop-down list at the bottom of the Data Source view.
3. Click the Add To button. Also instead of clicking the button you can just press ENTER.

Tip: As dealing with a composite field (one that consists of a group of fields), you can add the group of fileds to a required pivot table area at once if you select the top field.

Destination area
It contains the list of pivot table areas which you can select to add data source fields. The list includes the following areas: Filter, Row, Column, and Data.

ExpandedToggleIcon(9x12) See Also

Pivot Table

Chart View


Chart View

dbForge Studio provides possibility to create 3D and 2D charts for pivot data easier than ever before. So, you can build a chart basing on data of a pivot table. With a wide feature set it takes really a little effort to design a smart professional-looking chart.

ExpandedToggleIcon(9x12) What is a chart?

A chart is simply a graphical representation of a series of numeric values.

Displaying data in a well-conceived chart can make your numbers more understandable. Because a chart presents a picture, charts are particularly useful for summarizing a series of numbers and their interrelationships. Making a chart can often help you spot trends and patterns that may otherwise go unnoticed.

ExpandedToggleIcon(9x12) Chart Wizard

The Chart Wizard is a powerful tool for quickly building charts of any complexity from scratch, and customizing existing charts. To open the wizard, right-click the required table in the Database Explorer window, select Send To, and click Chart Designer from the shortcut menu. The Chart Wizard opens.

ExpandedToggleIcon(9x12) Chart View Usage

Use the Chart document view to present data displayed in the pivot table view as a chart.

To open the Chart view, click the ShowChart-PivotTable Show Chart button on the Pivot Table View of the document.

To create a chart, simply select the data you want to be presented as a chart, on the Pivot Table View. To learn the exact steps to create a chart, refer to the How To: Create a Chart in Pivot Table topic.

ExpandedToggleIcon(9x12) Chart View Options

Use the Chart view options to optimize the appearance of the created chart.

Type
Choose the type of your chart from the drop-down list.

ChartDesigner Open Chart Designer
Open Chart Designer to adjust the chart to your needs. You can choose chart type here, adjust the appearance of the whole chart, of its diagram, add such elements as strips, constant lines, scale breaks, chart titles, etc.

ShowAllData Show All Data
Click this button to show all data available in the table as a chart. If this button is on, all data available in the pivot table is shown in the chart independently of any selections made in the grid. If the button if off, only selected data is shown in the chart.

Chart Options
Click this button to view the list of available options that may help you to adjust chart appearance.

Point Labels
Check to show point labels that are used to identify particular series points within a series.

Generate Series From Columns
Check this option to generate series from the columns of the resulting pivot table.

Show Column Totals
Show column totals on the chart.

Show Row Totals
Show row totals on the chart.

Show Column Grand Totals
Check to show grand total of each column on the chart.

Show Row Grand Totals
Check to show grand total of each row on the chart.

Rotated
Check this option to rotate the chart relatively the X-axis.

Chart Layout
Check to specify the chart layout.

Vertical
Check to display the Chart view vertically in relation to the Pivot Table view.

Horizontal
Check to display the Chart view horizontally in relation to the Pivot Table view.

ExpandedToggleIcon(9x12) Chart Elements

· Data point is the most fundamental element of a chart. A group of data points makes a single series. Each data point must have one argument and at least one value specified. Argument and its value are generally represented on a diagram's axes as their X and Y coordinates respectively.
· A group of data points represents a series, which isn't displayed until it has at least one point specified. The view type of the first visible series determines the diagram type of the chart, that means all other series should have a compatible view type. A series point represents data point's argument and value in a diagram as the X and Y coordinates respectively.
· A diagram is a main area of chart where most of the chart's data and graphical elements are displayed. A chart diagram can be zoomed, scrolled, and rotated.
· Axes provide coordinates for the series points' arguments and values. Most charts use axis of arguments (X-axis) and axis of values (Y-axis). Besides primary axes, secondary axes may be added to the chart for its usability.
· A strip is a highlighted area on a chart diagram within the defined range of values of an axis to which it belongs. Generally strips are used to represent a range of values behind series.
· A constant line visually represents an axis value as a line perpendicular to the axis to which it belongs.
· A scale break is an area across an axis shown instead of a section of the axis' range. Usually it's used if a chart has useless space, for example, if the chart's series represent data with great leaps in range.
· A pane is a rectangular area on the diagram where series and their associate axes are displayed.
· The legend is a component that accompanies a chart's diagram and has an explanatory meaning. The legend identifies the most important visual elements of the diagram such as series, series points, constant lines, and strips.

note Note

Only one legend can be created in a diagram.
· Chart titles can accompany charts with text headers and explanations.

ExpandedToggleIcon(9x12) See Also

Pivot Table


Query Builder

This section contains information about main components of the query document - the diagram and the tabbed editor.

ExpandedToggleIcon(9x12) In This Section

Query diagram
Describes what you can see on the query diagram.

Selection Tab
Explains the details of the Selection tab of the tabbed editor.

Joins Tab
Explains the details of the Joins tab of the tabbed editor.

Where And Having Tabs
Explains the details of the Where and Having tabs of the tabbed editor.

Group By Tab
Explains the details of the Group By tab of the tabbed editor.

Order By Tab
Explains the details of the Order By tab of the tabbed editor.

Select To Tab
Explains the details of the Select To tab of the tabbed editor.

Insert Tab
Explains the details of the Insert tab of the tabbed editor.

Update Tab
Explains the details of the Update tab of the tabbed editor.

Operand Editor, Query Builder
Explains how to specify operand parameters using the operand editor.

Choose Target Table
Describes the Choose Target Table window.


Query Diagram, Query Builder

Query diagram is the main part of Query Builder that introduces visual query representation. The query diagram contains tables, views, and subqueries participating in a query and connections between them.

The Select icon in the diagram shows what type of a query is executing now.

To add a table or a view to the query, just drag-and-drop a required one from the Database Explorer.

You can see two kinds of controls on the diagram:

ExpandedToggleIcon(9x12) Table Shape

Represents a database table, view, or subquery that is included to FROM clause. It contains the list of fields that you can include to SELECT clause as well as grouping and sorting marks, and marks of the constraints. You can drag a table shape anywhere on the query diagram.

A table shape caption contains an object type icon, a name (alias), an object type, and a button that allows you to minimize table shape and restore it back.

For more information on working with table shapes, visit the Adding Tables to Diagram and the Removing Tables from Diagram topics.

ExpandedToggleIcon(9x12) Connector

Represents a join relation between two tables. To establish a connection, drag a column from one table shape to another. To make it any kind of OUTER JOIN, right-click on a connector and setup the relation. Visit the Making Joins Between Tables topic for details.

ExpandedToggleIcon(9x12) See Also

Query Builder

Selection, Query Builder


Selection, Query Builder

Use this tab to edit the select list of the query. The Selection tab contains the following details:

Unique records

Defines whether records in a result set are unique, same as DISTINCT modifier.

Column

Represents a column (columns) in the select list. This can be either column from a table or an arbitrary expression. You can choose it from the Operand Editor or enter manually.

Alias

Specify an alias for the selected column.

Table

Represents a table or a subquery from which the column is selected. Not applicable for arbitrary expressions in the select list.

Aggregate

Specifies grouping function to apply to the selected column in the select list.

Sort

Defines whether a column is sorted and specifies sorting direction.

Filter

Allows adding a simple condition on the column to the WHERE clause. Filter should have the following form: <operator> <value>. Operator can be the following: >, <, =, <>, >=, <=, IS NULL , IS NOT NULL. Value must be a constant value with the same type as the column.

Icon | Description
MoveUp | Moves the selected column up in the select list and changes accordingly the order of columns' names in the query.
MoveDown | Moves the selected column down in the select list and changes accordingly the order of columns' names in the query.
RemoveButton | Removes the selected column both from the select list and the query.

ExpandedToggleIcon(9x12) See Also

Query Builder

Joins, Query Builder


Joins, Query Builder

ExpandedToggleIcon(9x12) Joins Tab

Use this tab to establish, edit or remove joins between tables. Joins tab contains a tree with FilterGreyAdd button root node, joins as second level nodes and conditions and condition groups as further level nodes.

These buttons are in a root node. Use the FilterGreyAdd button to add joins. The template will be inserted to help you create your join. To remove the join, click the FilterGreyDel button.

Join

Joins are the second level nodes. They consist of the following parts:

Table name

Black colored names of the joined tables, views, or subqueries, located on both sides of the join kind.

Condition kind

Red-colored condition kind, for example, Join-type. You can set another condition kind for the condition by clicking the operator name and choosing the condition kind from the appeared menu. The following kinds are available: Left Outer, Right Outer, Inner, Cross, Full Outer.

Icon | Description
FilterGreyAdd | Click this button to add a condition to the join.
FilterGreyDel | Click this button to remove the join.

ExpandedToggleIcon(9x12) Condition Group

You may add a condition group if you need to add several conditions.

A condition group is displayed as a red-colored logical operator, for example, Condition-Group- and a FilterGreyAdd button. To add a group, click the red-colored condition and select Add Group from the menu. Besides, the menu offers the following options: clicking the FilterGreyAdd button adds a new condition to the group. Clicking the logical operator displays the following menu:

And

Sets the And logical operator for the group. All group conditions must be true.

Or

Sets the Or logical operator for the group. At least one condition from the group must be true.

Not And

Sets the Not And logical operator for the group. At least one condition from the group must be false.

Not Or

Sets the Not Or logical operator for the group. All group conditions must be false.

Add Condition

Adds a new condition to the group.

Add Group

Adds a new condition group to the current group.

Clear All

This command is available for the top-level condition group only. Removes all conditions and subgroups, leaving only the top-level group node.

Remove Group

This command is available for the non-top-level condition group only. Removes the condition group.

ExpandedToggleIcon(9x12) Condition

Condition consists of the following parts:

Operand

Click the operand and enter a column name as the value or select it from the drop-down list. To edit the operand values, move to the required operand and press F2.

fx (function)

Click and select function for operand from the appeared menu. If function is already selected, it is marked with blue. To change function, click the function and select the function you need again.

Criteria operator

Green-colored criteria operator, for example CriteriaOperator. To select another operator for the condition, click the operator name and choose the operator from the appeared menu.

Icon | Description
FilterGreyAdd | This button appears for operators that can have a variable number of operands. Click it to add one more operand value.
FilterGreyDel | If this button is located at the end of the condition, clicking this button deletes the condition. If this is an operator that can have variable number of operands and the button is after the operand value, clicking this button deletes this operand value.

ExpandedToggleIcon(9x12) See Also

Query Builder

Where, Having, Query Builder


Where, Having, Query Builder

Where and Having tabs contain the same controls. The only difference between them is that they edit criteria in WHERE and HAVING clauses appropriately. You may use Where and Having tabs to build very complex conditions almost without typing.

ExpandedToggleIcon(9x12) Condition group

Condition group is displayed as a red-colored logical operator and the FilterGreyAdd button. Clicking the FilterGreyAdd button adds a new condition to a group. Clicking the logical operator displays the following menu:

And
Sets And logical operator for the group. All group conditions must be true.

Or
Sets Or logical operator for the group. At least one condition from the group must be true.

Xor
Sets Xor logical operator for the group. At least one condition from the group must be true, and at least one condition must be false.

Not And
Sets Not And logical operator for the group. At least one condition from the group must be false.

Not Or
Sets Not Or logical operator for the group. All group conditions must be false.

Add Condition
Adds a new condition to the group.

Add Group
Adds a new condition group to the current group.

Clear All
This command is available for the top-level condition group only. Removes all conditions and subgroups, leaving only the top-level group node.

ExpandedToggleIcon(9x12) Condition

Condition consists of the following parts:

Operand
Click the operand and enter a column name as the value or select it from the drop-down list. To edit the operand values, move to the required operand and press F2.

fx (function)
Click and select function for operand from the appeared menu. If function is already selected, it is marked with blue. To change function, click the function and select the function you need again.

Criteria operator
Green-colored criteria operator, for example CriteriaOperator. To select another operator for the condition, click the operator name and choose the operator from the appeared menu.

Icon | Description
FilterGreyAdd | This button appears for operators that can have a variable number of operands. Click it to add one more operand value.
FilterGreyDel | If this button is located at the end of the condition, clicking this button deletes the condition. If this is an operator that can have variable number of operands and the button is after the operand value, clicking this button deletes this operand value.

ExpandedToggleIcon(9x12) See Also

Query Builder

Group By, Query Builder


Group By, Query Builder

Use this tab to edit GROUP BY clause.

Columns
Lists all columns that are not grouped.

Grouped By
Lists all grouped columns and grouping expressions.

Expression
Type grouping expression and click the button near the edit box to add expression to GROUP BY clause.

Add Expression
Click to add the expression to GROUP BY clause.

RightArrow
Adds a column to GROUP BY clause.

LeftArrow
Removes a column or grouping expression from the list.

UpArrow
Moves grouping expression up in the list.

DownArrow
Moves grouping expression down in the list.

ExpandedToggleIcon(9x12) See Also

Query Builder

Order By, Query Builder


Order By, Query Builder

Use this tab to edit ORDER BY clause.

Columns
Lists all columns that do not participate in sorting.

Grouped By
Lists all columns and expressions that participate in sorting.

Expression
Type expression and click the button near the edit box to add expression to ORDER BY clause.

Add Expression
Click to add the expression to ORDER BY clause.

Button RightArrow
Adds column to ORDER BY clause.

Button LeftArrow
Removes column or expression from ORDER BY clause.

Button UpArrow
Moves ordering expression up in the list.

Button DownArrow
Moves ordering expression down in the list.

Sorting direction button
Toggles sorting direction of the ORDER BY item.

ExpandedToggleIcon(9x12) See Also

Query Builder

Select to, Query Builder


Select to, Query Builder

Use this tab to edit the insert into list of the query. The Select to tab contains the following details:

Insert to
Represents a list of columns into which results should be inserted.

Column
Represents a column (columns) in the select list. This can be either column from a table or an arbitrary expression. You can choose it from the Operand Editor or enter manually.

Alias
Specify an alias for the selected column.

Table
Represents a table or a subquery from which the column is selected. Not applicable for arbitrary expressions in the select list.

Aggregate
Specifies grouping function to apply to the selected column in the select list.

Sort
Defines whether a column is sorted and specifies sorting direction.

Filter
Allows adding a simple condition on the column to the WHERE clause. Filter should have the following form: <operator> <value>. Operator can be the following: >, <, =, <>, >=, <=, IS NULL , IS NOT NULL. Value must be a constant value with the same type as the column.

MoveUp Button
Moves the selected column up in the select list and changes accordingly the order of columns' names in the query.

MoveDown Button
Moves the selected column down in the select list and changes accordingly the order of columns' names in the query.

RemoveButton Button
Removes the selected column both from the select list and the query.

ExpandedToggleIcon(9x12) See Also

Query Builder

Insert, Query Builder


Insert, Query Builder

Use this tab to edit the insert into statement in the query. The Insert tab contains the following details:

Name
Represents a list of columns to insert values into.

Value
Represents values to be inserted.

Default
Indicates that the value that is being inserted is default.

ExpandedToggleIcon(9x12) See Also

Query Builder

Update, Query Builder


Update, Query Builder

Use this tab to edit the update statement in the query. The Update tab contains the following details:

Name
Represents a list of columns to insert values into.

Value
Represents values to be inserted.

Default
Indicates that the value that is being inserted is default.

Filter
Allows adding a simple condition on the column to the WHERE clause. Filter should have the following form: <operator> <value>. Operator can be the following: >, <, =, <>, >=, <=, IS NULL , IS NOT NULL. Value must be a constant value with the same type as the column.

ExpandedToggleIcon(9x12) See Also

Query Builder

Operand Editor, Query Builder


Operand Editor, Query Builder

Use this operand editor to add the operands to your query. To open the editor, go to the Joins, Where or Having tabs of the tabbed editor and click the operands fields in the template. The operand editor contains the following elements:

close-editor
Hides/Collapses the operand editor.

Add-Subquery
Creates a subquery and opens the subquery tab of the query document.

ExpandedToggleIcon(9x12) Table

<All Tables>
The list of tables added to the diagram. Click the button and select a required table from the drop-down list. See the columns of the selected table under the field.

Columns
Columns of tables added to the diagram. To select a column, double-click it in the list.

ExpandedToggleIcon(9x12) Function

<All Functions>
The list of function categories to add to your query. Click the button and select a required category from the drop-down list. See the functions related to the selected category under the field.

Functions
Functions related to the selected category. To add a function to your query, double-click it in the list.

ExpandedToggleIcon(9x12) Operators

The list of operators such as (), +, -, to add to your query. Double-click a required operator in the list to add to your query.

note Note

The appearance of the Operand Editor may slightly vary depending on a product you use.

ExpandedToggleIcon(9x12) See Also

Query Builder

Choose Target Table, Query Builder


Choose Target Table, Query Builder

This window appears when you are selecting different query types and you need to select a table to insert results, values, update or delete records.

Database
Choose the database to select a table from.

Tables and Views
Choose the needed table from the list.

Filter
Specify a filter for tables, if needed.

Click OK if you selected the table or Cancel to cancel the operation.

ExpandedToggleIcon(9x12) See Also

Query Builder


Query Profiling

This section gives description of Query Profiling interface elements.

ExpandedToggleIcon(9x12) In This Section

Profiler View
Explains the details of the Profiler document view.

Assign Plan Table Dialog Box
Describes the Assign Plan Table window.


Profiler View

Use the Profiler document view to see the results of EXPLAIN command along with Session statistics related to the executed query. Each time you get profiling results for the executed query, they appear in the tree view as a new node with time and date of query execution. You can easily distinguish and navigate to them. Besides execution date and time, they contain the connection properties, duration of execution in seconds and the server version used.

The query profiling results are displayed on two tabs:

ExpandedToggleIcon(9x12) Plan

Shows the EXPLAIN results returned by the executed query. Use the Plan tab to learn how Oracle executes a SELECT statement. It shows when you need to add an index to a table to increase SELECT performance, optimize joining between tables, etc.

ExpandedToggleIcon(9x12) Session statistics

Shows statistics for each query execution.

ExpandedToggleIcon(9x12) See Also

Query Profiling

Assign Plan Table Dialog Box


Assign Plan Table Dialog Box

This dialog appears when you are about to generate a query execution plan but there's no table assigned to store plan data. This is the case when plan is being generated for the first time or if the table which was assigned previously had been deleted. After a table has been chosen for this purpose it will be used for all consequent plans generated in given schema.

Plan table name
This field contains name of table to be used for plan generation. By default the name is PLAN_TABLE.

Create a new table
Choose this option to create new table in the current schema with name specified in Plan table name field.

Assign an existing table
If you select this option Plan table name will become a drop-down list containing list of suitable tables in the current schema. You can choose one of them to be used when a plan is generated.

ExpandedToggleIcon(9x12) See Also

Query Profiling


Schema Compare

This section describes all the wizards, documents, windows and other UI elements related to schema comparison and synchronization processes.

ExpandedToggleIcon(9x12) In This Section

New Schema Comparison Wizard
Explains the elements of the Schema Comparison wizard and how to use them.

Schema Comparison Document
Describes how to manage object and DDL differences in the Schema Comparison document.

Schema Update Script Window
Describes how to preview synchronization script excerpts for any compared objects.

Generate Comparison Report Dialog Box
Describes how to generate comparison reports.

Schema Synchronization Wizard
Describes features of the Schema Synchronization wizard.

Source Control
Describes user interface elements related to the source control functionality.


New Schema Comparison Wizard

This section describes the pages of the Schema Comparison wizard and how to use them.

To open the Schema Comparison wizard:

· On the Start page, click DatabaseDesign Database Design and then click NewSchemaComparison New Schema Comparison

or

· In the Database Explorer right click required database, and then click New Schema Comparison from the shortcut menu.

ExpandedToggleIcon(9x12) In This Section

Source and Target, Schema Comparison Wizard
Tells how to select source and target schemas for comparison.

Options, Schema Comparison Wizard
Explains the options available to tune schema comparison.

Object Filter, Schema Comparison Wizard
Use this tab to specify the types of objects you want to compare.

ExpandedToggleIcon(9x12) See Also

Schema Compare

Schema Comparison Document


Source and Target, Schema Comparison Wizard

Use the Source and Target wizard page to select source and target connections and databases for comparison. The page contains the following details:

Type
Select the type of comparison you want to implement: database, snapshot of versioned snapshot.

ExpandedToggleIcon(9x12) Database

Connection
Select a Source Oracle server connection in the left part of the wizard and a Target Oracle server connection in the right part. In the drop-down lists of the fields you can click the <Manage...> link to open the Connection Manager dialog box. It will help you to create, edit, and delete database connections.

Edit
Click to edit the selected connection.

New
Click to create a new connection for Oracle server.

Server version
Indicates the version of the selected server.

ExpandedToggleIcon(9x12) Snapshot

Snapshot
Select a snapshot file for comparison. You can open an existing snapshot file clicking the <Browse..> link.

Browse
Click the button to open an existing snapshot file.

New
Click the button to open the Create Schema Snapshot dialog box and create a snapshot for a required database.

Server
The server connection name is specified.

Server Version
Shows a version of the snapshot database server used in the connection.

Schema
Shows a schema of the used snapshot.

Created
Shows a snapshot creation date.

Category
Shows a category of the used snapshot.

ExpandedToggleIcon(9x12) Versioned Snapshot

Repository
Select a required repository from the drop-down list. Select <Manage...> to create, edit, or delete repositories with help of the Repository Manager Dialog Box. Click "+" to configure Source Control Repository Properties. Click "..." to modify Source Control Repository Properties.

Snapshot
Select a required snapshot from the drop-down list. Select <Refresh...> to refresh the snapshot list.

Revision
Select a required revision from the drop-down list.

Search
To quickly find a required revision, enter characters available in the required revision name. Only revisions, names of which contain the required characters, will be shown in the list.

Revision
Shows the revision identifier.

Date
Displays the revision date.

Author
Displays name of the user who committed changes.

Comment
Displays comment related to the revision.

Refresh
Click to refresh the revisions list.

Select
Click to use the selected revision

Select head
Click to use the head (latest) revision.

note Note

The Versioned Snapshot functionality is now available only for TFS and SVN. Though other version control systems are available for selection, you will be notified that the "Specified Version Control System is not supported".

Schema Mapping
Use this grid to manage schema mapping.

Hide System Schemas
Select to hide system schemas in the Schema Mapping grid.

Filter
Use the Filter box to locate the required objects.

Swaps the Source and Target settings.

Click to copy the Source settings to the Target.

Click to copy the Target settings to the Source.

ExpandedToggleIcon(9x12) See Also

Schema Comparison Wizard

Options, Schema Comparison Wizard


Options, Schema Comparison Wizard

Use the Options wizard page to tune schema comparison.

Common Options for Schema Comparison

You can select options to ignore the following schema properties during comparison:

Ignore column order in indexes
Ignores the column order for the included columns in indexes during comparison and synchronization.

Ignore COMMENT objects
Ignores COMMENT objects during comparison. During synchronization, an attempt to save existing comments for different objects is made.

Ignore LOGGING/NOLOGGING clause
Ignores LOGGING AND NOLOGGING clause during databases comparison and synchronization.

Ignore permissions
Ignores security permissions during comparison and synchronization. Target database permissions will be preserved if possible.

Ignore schema name during comparison
Ignores schema name during comparison in foreign keys.

Quote object names with double quotes
Always quote object names with double quotes during script generation.

Set 'None' operation for invalid objects from source
Set the 'None' operation for all objects from the source schema that have INVALID status in the comparison results grid.

Tables Options

Force column order
When selected, adding a column to a table will cause its re-creation. As a result, the column order will be preserved. Otherwise difference in columns order will be ignored and objects will be equal.

Ignore column default values
When selected, default values in table columns will be ignored when comparing and synchronizing databases.

Ignore constraints' clause ENABLE/DISABLE
When selected, the ENABLE and DISABLE clause of constraints in tables will be ignored when comparing and synchronizing databases.

Ignore constraints' clause VALIDATE/NOVALIDATE
When selected, the VALIDATE and NOVALIDATE clause of constraints in tables will be ignored when comparing and synchronizing databases.

Ignore constraints' names
When selected, constraints' names are ignored during comparison and synchronization. They will be preserved in the Target.

Ignore foreign keys
When selected, foreign keys are ignored during comparison and synchronization. Foreign keys will not be restored after synchronization, for example, if a referenced column has no primary key.

Ignore Not Null constraints
When selected, not null constraints in tables will be ignored when comparing and synchronizing databases.

Script Objects Options

Compare wrapped and unwrapped PL/SQL objects
Select this option to compare wrapped and unwrapped PL/SQL objects. It will let you define equal and non-equal objects. If this option is on, the comparison process will become slower. This option requires Oracle 10g or higher.

Ignore case
When selected, any case differences are ignored during comparison. For example, objects with case differences will have Equal status in the comparison results. Case differences in a script object's body are preserved during synchronization.

Ignore comments
Ignores comments when comparing views, stored procedures, functions, etc. Comments in a script object's body are preserved during synchronization.

Ignore white spaces
When selected, any differences in white spaces (new lines, tabs, spaces, etc.) are ignored during comparison and synchronization. Original white spaces in a script object's body are preserved during synchronization.

Storage Options

Ignore compressions
Ignores difference in the compressions for the tables when comparing and synchronizing databases.

Ignore partitions
Ignores partitions while comparing. During synchronization existing partitions might be saved.

Ignore physical attributes
Ignores physical storage settings for tables when comparing and synchronizing databases.

Ignore storage clause
Ignores STORAGE settings for tables when comparing and synchronizing databases.

Ignore tablespaces
Ignores tablespaces during comparison. During synchronization it will make an attempt to save existing tablespaces for different tables or set default tablespaces for new tables.

Buttons

Save As My Defaults
Click this button to save current settings as your default settings.

Devart Defaults
Click this button to restore the application default comparison settings.

My Defaults
Click this button to restore your default comparison settings, previously saved with the Save As My Defaults button.

Other Elements

Save settings to a command line arguments file
Click to save settings of options to use them in an arguments file when comparing databases through the command line or scheduling a task.

ExpandedToggleIcon(9x12) See Also

Schema Comparison Wizard

Object Filter, Schema Comparison Wizard


Object Filter, Schema Comparison Wizard

Use this tab to specify the types of objects you want to compare.

Types field
Displays all available object types you can take into account when compare.

Select All
Click the check box to select or discard all the object types for comparison.

Compare
Click the button to start schema comparison process.

ExpandedToggleIcon(9x12) See Also

Schema Comparison Wizard

Schema Compare


Schema Comparison Document

Use this document to see, analyze schema comparison results, and set up synchronization. It contains the following:

Comparison toolbar

The Comparison toolbar appears automatically when the Schema Comparison document opens. The toolbar contains the following buttons to help you manage comparison results:

ChangeCompProperties Edit Comparison
Click it to change the Source and Target connections and databases. The Change Schema Comparison Properties wizard opens. Click the down arrow near the Group by field and select the corresponding option in the appeared menu.

RefreshButton Refresh
Click it to restart the comparison and refresh the comparison results.

Stop Execution
Click it to stop the comparison.

Group-by-field
Use it to filter the comparison results by their status, operation, object type, or cancel grouping.

Filter
Use it to filter the comparison results by their status. Click the down arrow near the Filter button and select the corresponding option in the appeared menu, e.g., to show only in Source objects.

View Schema Update Script
Click it to preview the synchronization script, generated by dbForge Studio, for any compared object. The Schema Update Script window opens.

GenerateComparisonReport Generate Comparison Report
Click it to preview the comparison report, generated by dbForge Studio. The Generate Comparison Report window opens.

Synch-btn Show Synchronization Wizard
Click it when you have reviewed the comparison results and want to synchronize them. The Schema Synchronization wizard opens.

Document Header
Document header shows:

1. The search field that allows you to find an object.
2. Source and Target databases with their connections.
3. Number of selected objects.

Grid
The grid shows the following details:

Type
Shows objects type that is being compared.

Owner
Shows an owner of a source object

Source Object
The object of the Source database that will be compared with the corresponding object of the Target database.

Check box
Select the check boxes to include compared objects into synchronization. If you don't want to synchronize some objects, clear the check boxes for them.

Operation
The operation related to a compared object that will be executed during synchronization. You can click the Operation field and select other operation from the drop-down list. To avoid changing of the Target object during synchronization, you can select the None operation.

Target Object
The object of the Target database which contents you compare and synchronize with the Source one.

Owner
Shows an owner of a target object.

Text Comparer

Text comparer displays DDL differences of Source and Target objects. You can use the following buttons to customize the view of Text Comparer:

detached-window-btn - click to show Text Comparer in a detached window.

collapse-btn - click to collapse Text Comparer

expand-btn - click to expand Text Comparer. The button appears only if Text Comparer was collapsed previously.

- click it to turn on/off word wrap.

- click it to show or hide line numbers.

AZ - click it to sort columns and constraints in alphabetical order.

Tip: To better understand comparison results, you can filter them by their status or name and group by their status, operation, and object type.

ExpandedToggleIcon(9x12) See Also

Schema Update Script Window


Schema Update Script Window

Use the Schema Update Script window to preview a synchronization script for any compared object. To open the window, select any object (or several ones) in the grid and do either of these actions:

· Right-click the grid with comparison results and select View Schema Update Script from the shortcut menu
· Click the [image] View Schema Update Script button on the toolbar
· Click the View Schema Update Script button from the Comparison menu.

Also you can copy the synchronization script in the Schema Update Script window and paste into the SQL editor or other file for further editing or saving.

ExpandedToggleIcon(9x12) See Also

Generate Comparison Report Dialog Box


Generate Comparison Report Dialog Box

Use this dialog box to generate a report after schema comparison is completed. Select Generate Comparison Report from the Comparison menu to open the Generate Comparison Report dialog box. It contains the following details:

Format
Select what format you need for a comparison report. HTML, Excel, XML and XML for Excel are available.

Name
Change the default name for the comparison report file. Enter a required one.

Location
Change the default location to store the comparison report file. You can specify the location either manually or click the [image] button to select a required folder in the Browse for Folder dialog box.

Include
Select what objects to include into the comparison report, either objects with differences or all the objects selected for comparison. Besides you can include or exclude identical objects and comparison options.

Group objects by
Select how to group objects to display in the comparison report.

View a report on completion
Select this check box if you want to see a generated comparison report opened.

ExpandedToggleIcon(9x12) See Also

Schema Synchronization Wizard


Schema Synchronization Wizard

Use Schema Synchronization Wizard to synchronize database differences. To access the wizard, click the Synchronize button on the Comparison toolbar. The wizard pages are listed below.

To switch between the wizard pages, either use the Next and the Back buttons or click page names on the left side of the wizard.

ExpandedToggleIcon(9x12) In This Section

Output, Schema Synchronization Wizard
Learn how to manage the synchronization script.

Options, Schema Synchronization Wizard
Use the topic to specify general synchronization options.

Dependencies, Schema Synchronization Wizard
Use the topic to specify additional objects to synchronize.

Issues, Schema Synchronization Wizard
Learn how to resolve issues for synchronization actions.

Summary, Schema Synchronization Wizard
Use the topic to review the synchronization actions and warnings.

ExpandedToggleIcon(9x12) See Also

Schema Compare

Create Schema Snapshot Dialog Box (Schema Compare)


Output, Schema Synchronization Wizard

Select output options to manage a synchronization script.

Open the synchronization script in the internal editor
Select the check box to open the synchronization script in an SQL document. The file name is generated automatically.

Save the script to a file
Select the check box to output your script to a file.

Browse
Click the button to specify the path to save a file.
Open in the internal editor
Select the check box to open the synchronization script in dbForge Studio for Oracle. The file name is generated by a user. If not selected, the synchronization script will not open.

Execute the script directly against the target database
Select the check box to synchronize the target database immediately without generating a synchronization script.

Refresh comparison results after synchronization
Select the check box to refresh comparison results after synchronization if synchronization was executed successfully.

ExpandedToggleIcon(9x12) See Also

Schema Synchronization Wizard

Options, Schema Synchronization Wizard


Options, Schema Synchronization Wizard

Select general synchronization options including script execution.

Use ENABLE NOVALIDATE
Means that the constraint is checked, but it does not have to be true for all the rows. This lets the existing rows violate the constraint, and ensures that all new or modified rows are valid.

Enable table lock in target before synchronization
Enable table locks during synchronization, thereby allowing DDL operations on tables.

Compile dependant objects after synchronization
Adds a script for recompiling invalid dependant objects to the end of the synchronization script.

Create views forcedly
Forces the creation of views even if they will be invalid.

Generate fully qualified object names
Generates fully qualified object names in the synchronization script. If the option is enabled, names of objects in synchronization script will include a schema name.

Rebuild sequences
Forcedly rebuild sequences. Current values will be lost.

Purge Recycle Bin
Select to empty a recycle bin when objects are being dropped (for Oracle servers of version 10 or higher).

Restore session parameters
Restore session parameters (NLS_DATE_FORMAT, NLS_TIMESTAMP_TZ_FORMAT, NLS_TIMESTAMP_FORMAT, NLS_NUMERIC_CHARACTERS, NLS_NCHAR_CONV_EXCP, TIME_ZONE) after the script is done.

Exclude comments
Select to prevent comments generation in a synchronization script.

Use SQL *Plus commands
Select to use SQL *Plus commands SET SQLBLANKLINES and SET DEFINE in synchronization script.

Description
Hover a cursor over a wizard option, and see a corresponding brief description.

Save As My Defaults
Click this button to save current settings as your default settings.

Devart Defaults
Click this button to restore the application default comparison settings.

My Defaults
Click this button to restore your default comparison settings, previously saved with the Save As My Defaults button.

ExpandedToggleIcon(9x12) See Also

Schema Synchronization Wizard

Dependencies, Schema Synchronization Wizard


Dependencies, Schema Synchronization Wizard

Select additional objects to synchronize.

Synchronize the following objects, which have not been explicitly selected for synchronization, but which are used by one or more objects that you have included in the synchronization.

Affected Object
Specify the objects you want to include into the synchronization. All the objects are selected by default.

Referencing or Referenced by
Objects that are referencing to the affected objects.

ExpandedToggleIcon(9x12) See Also

Schema Synchronization Wizard

Issues, Schema Synchronization Wizard


Issues, Schema Synchronization Wizard

Resolve issues for synchronization actions.

Column
A column that has a conflict with the specified constraint.

Action
To make the synchronization successful, specify the action to do with a conflict column.

Value
Specify a new column value.

Warning
Learn the messages of conflicts that can occur while synchronization.

ExpandedToggleIcon(9x12) See Also

Schema Synchronization Wizard

Summary, Schema Synchronization Wizard


Summary, Schema Synchronization Wizard

Review the synchronization actions and warnings.

Action Plan
Displays synchronization actions in the order in which they occur.

Warnings
Displays conflict messages.

Find
Use the Find option to search for an object to synchronize.

Shortcut menu

Expand All
Click the option to expand all the actions to see which objects will be synchronized.

Collapse All
Click the option to hide all the objects for synchronization.

ExpandedToggleIcon(9x12) See Also

Schema Synchronization Wizard

Schema Compare


Source Control

This section provides detailed information on all the windows and dialog boxes related to the source control functionality.

ExpandedToggleIcon(9x12) In This Section

Repository Manager Dialog Box
Describes fields and options of the Repository Manager dialog box.

Create Folder Dialog Box
Describes fields and options of the Create Folder dialog box.

Select Database Scripts Folder Dialog Box
Describes Select Database Scripts Folder dialog box.

Source Control Repository Properties Dialog Box
Describes fields and options of the Source Control Repository dialog box.


Repository Manager Dialog Box

Repository Manager dialog box allows you to create, edit, and delete source control repositories.

Dialog Box Controls

Repositories
The list of the existing repositories.

New
Click to open Source Control Repository Properties Dialog Box for setting a new source control repository.

Edit
Click to open Source Control Repository Properties Dialog Box for editing a source control repository.

Delete
Click to delete the source control repository.

Repository Info
Displays a string, containing the properties for the selected source control repository.

ExpandedToggleIcon(9x12) See Also

Source Control Repository Properties Dialog Box


Create Folder Dialog Box

Use this dialog box to create a new folder to store database scripts. To open this dialog box, click Create Folder in the Select Database Scripts Folder dialog box. If you specified a nonexistent folder in the Source Control Repository Properties Dialog Box, this box appears automatically during the attempt to link a database to a selected source control system.

Folder name
Type the folder name here.

Comment
Specify the comment for the folder to be created.

Buttons

OK
Click to apply changes.

Cancel
Click to cancel changes and close the dialog box.

ExpandedToggleIcon(9x12) See Also

Select Database Scripts Folder Dialog Box


Select Database Scripts Folder Dialog Box

Use this dialog box to select the folder to store database scripts.

Select or create folder to link to database
Select the required folder from the list or create a new folder by clicking the Create Folder button.

Selected path
Shows the path to the selected folder.

Buttons

Create Folder
Click to open the Create Folder dialog box to create a new folder.

OK
Click to apply changes.

Cancel
Click to cancel changes and close the dialog box.

ExpandedToggleIcon(9x12) See Also

Source Control Repository Properties Dialog Box


Source Control Repository Properties Dialog Box

Use this dialog box to modify or set up properties of the source control repository.

Source control system
Select source control system from the drop-down list box.

Source control settings
Specify source control settings for the selected source control system.

ExpandedToggleIcon(9x12) For Team Foundation Server (TFS)

Server URL
Specify the URL for the TFS Server.

Username
Specify the username for the TFS Server.

Password
Specify the password for the TFS Server.

Use Windows authentication
Select to use Windows authentication when logging in to the repository.

Database folder
Specify the path to the repository folder containing versioned snapshot.

Repository name
Specify repository name here.
ExpandedToggleIcon(9x12) For Subversion (SVN)

Server URL
Specify the URL of your SVN server.

Username
Specify the username for the SVN server.

Password
Specify the password for the SVN server.

Database folder
Specify the path to the repository folder containing versioned snapshot.

Repository name
Specify repository name here.
ExpandedToggleIcon(9x12) For SourceGear Vault

note Note

This option is not currently supported by dbForge Studio for Oracle.

Server
Specify the SourceGear Vault server address in this box.

Use SSL
Select the check-box to use SSL connection.

Username
Specify the username for the SourceGear Vault server.

Password
Specify the password for the SourceGear Vault server.

Repository
Specify the SourceGear Vault repository name.

Database folder
Specify the path to the repository folder containing SQL scripts that represent the database.

Repository name
Specify repository name here.
ExpandedToggleIcon(9x12) For Perforce (P4)

note Note

This option is not currently supported by dbForge Studio for Oracle.

P4PORT
Specify the protocol, host and port number for the Perforce server.

Username
Specify the username for the Perforce server.

Password
Specify the password for the Perforce server.

Workspace
Select the workspace from the drop-down list box.

New
Click to create a new workspace .

Mapping
Select mapping from the drop-down list box, if required. Mapping specifies the depot and the remote folder, that will be used by dbForge Studio for Oracle.

Repository name
Specify repository name here.
ExpandedToggleIcon(9x12) For Git

note Note

This option is not currently supported by dbForge Studio for Oracle.

Remote repository
Specify URL for the remote repository in this box.

Security settings: HTTP

Login
Specify login for the remote repository.

Password
Specify password for the remote repository. .

Client Certificate
If the server is set up for authentication using the client certificate, select client certificate from the drop-down list box.

Security settings: SSH

Password
Select to use password authentication.

Password:
Type your password in this box.

Key
Select to use key authentication.

Key file
Specify path to the key in this box.

Passphrase
Type the passphrase in this box.

Use existing local clone
Select to use a ready local clone instead of the technical clone created by dbForge Studio for Oracle. In this case, all settings (including address of the remote repository) will be taken from the selected local clone. Specify the path to the local clone in the box.

Branch
Select required branch of the remote repository from the drop-down list box.

User name
Specify your Git user name in this box.

E-mail
Specify your Git e-mail address in this box.

Repository name
Specify repository name in this box.
ExpandedToggleIcon(9x12) For Mercurial

note Note

This option is not currently supported by dbForge Studio for Oracle.

Server URL:
Specify the URL of the Mercurial server in this box.

Use existing local repository
Select to use existing local repository instead of the remote repository. Specify the path to the local repository in the box.

Repository name
Specify repository name in this box.
ExpandedToggleIcon(9x12) For Working Folder

note Note

This option is not currently supported by dbForge Studio for Oracle.

Database folder
Specify the path to the database folder.

Repository name
Specify repository name here.
ExpandedToggleIcon(9x12) For Command Line Interaction

Database folder
Specify the path to the database folder.

Command line configuration preset
Select the required command line configuration preset from the drop-down list box. The following presets are available: Template, Plastic SCM.

Command line configuration
Shows config file with command line hooks according to the selected command line configuration preset.

Repository name
Specify repository name here.

Buttons

OK
Click to apply changes.

Test
Click to test the connection to the source control repository.

Cancel
Click to cancel changes.

ExpandedToggleIcon(9x12) See Also

Source Control


Schema Export Wizard

Use Schema Export Wizard to export your schemas or single tables. To access Schema Export Wizard, on the Database menu, point to Export & Import. Alternatively, right-click a schema in Database Explorer, point to Export & Import, and then click Schema Export. Wizard's pages are listed below.

General, Schema Export Wizard
Choose a connection and a database to export and a filename for the export script on this page.

Export Content, Schema Export Wizard
Choose information to export on this page.

Options, Schema Export Wizard
Set some export options on this page.

Errors Handling, Schema Export Wizard
You can specify errors processing behavior and logging options on this page.

Export Progress, Schema Export Wizard
You can see database export progress on this page.

Finish, Schema Export Wizard
You can see results of export operation on this page.


General, Schema Export Wizard

Choose general schema export options on this page.

Load a previously saved schema export project:
Use these options to load an existing schema export project.

Open
Calls the Open dialog. Use this button to open an existing backup project.

Opened
Click this button to choose one of the previously opened backup projects.

If you load an existing project its name is displayed in a field near these buttons.

Connection
Choose a connection from the drop-down list.

Schema
Choose a schema from the drop-down list.

Path
Defines the path where output file will be saved. Click the [image] button to select another folder to store backup.

Output file name
Enter output file name here. The default name is the name of the database.

Append timestamp to the file name
Select it to include a timestamp to the name of the generated file. For example, if the file with the structure of demobase database is ready for generation on the 1st of November, 2009 at 12:30 a.m, the file name with the timestamp will be the following - demobase 20091101 1230.sql.

Auto delete old files
If the Append timestamp to the file name option is checked, you can choose to delete old output files automatically when generating new files.

Files older than
Set the number of days the files should be older to be deleted.

Quantity more than
Backups are auto deleted if their quantity is more than the number specified.

Use compression (ZIP)
Check this option to compress a database script to a ZIP file.

note Note

If the size of the SQL file you want to compress is more than 4GB, the ZIP64 format will be used for compression. Otherwise the old format will be used.

Level
Select the level of compression here. You can select one of the following levels of compression: No Compression, Best Speed, Fast, Default, Good, Maximum.

Comment
Add a comment to the created archive.

ExpandedToggleIcon(9x12) See Also

Schema Export Wizard

Export Content, Schema Export Wizard


Export Content, Schema Export Wizard

Choose information to export on this page.

Structure
Export only objects' structure into DDL statements.

Data
Export only tables' data into INSERT statements.

Include all objects
Check this to export all objects and to skip next pages, where you should choose exported objects.

ExpandedToggleIcon(9x12) See Also

Schema Export Wizard

Options, Schema Export Wizard


Options, Schema Export Wizard

Set options for schema export on this page.

ExpandedToggleIcon(9x12) General

Contains general settings for DDL generating.

Exclude objects named with '$'
DDL will not be generated for schema objects, that have '$' character in their name. '$' character is usually used for distinguishing system objects. Note that when determining whether to generate DDL for materialized view log, dbForge Studio for Oracle analyzes its master table name, not the materialized view log name (that begins with 'LOG$').

Format the script
Select to format DDL of the source objects. Otherwise, source object DDL will have the same formatting as in database, the rest objects will have default formatting.

Generate comments in the script
Select to insert comments in the DDL.

Include body for packages and objects
Select to include DDL for both the body and the specification when extracting from packages or objects.

Include CASCADE CONSTRAINTS option
Select to include CASCADE CONSTRAINTS with DROP in the DDL.

Include CONNECT command
Select to include CONNECT SQL*Plus command to the script.

Include DROP statement
Select to include DROP statements in the DDL.

Include physical attributes clause
Select to include storage clause in the DDL.

Include PURGE option
Select to include PURGE statements in the DDL. PURGE execution cannot be rolled back!

Include SET CURRENT_SCHEMA
Select to include SET CURRENT_SCHEMA statements in the DDL.

Include storage clause
Select to include storage clause in the DDL.

Include tablespace names in script
Select to include a tablespace name in the DDL.

Prefix object names with a schema name
Select to prefix object names with schema name in the DDL.

ExpandedToggleIcon(9x12) Tables/Views

Contains settings for generating DDL of tables and views.

Disable constraints
Select to generate DDL that creates disabled constraints.

Exclude column default values
Select to exclude column default values from the DDL.

Exclude START and NEXT for materialized views
Excludes START and NEXT clauses from the materialized view DDL.

Include constraints
Select to include constraints for the objects in the DDL.

Include indexes
Select to include indexes for the objects in the DDL.

Include triggers
Select to include triggers for the objects in the DDL.

note Note

If this option is selected, triggers are included in the DDL even if the Triggers check box was not selected on the Export content page of the wizard.

If the Triggers check box was selected on the Export content page, triggers will be included in the DDL even if you clear the Include triggers check box on the Options page.

ExpandedToggleIcon(9x12) Partitioning

Contains settings for generating DDL of partitioned database objects.

Exclude partition list for locally partitioned index
Select to exclude partitions and subpartitions from the DDL for locally partitioned indexes.

Include partition clause
Select to include partition clause for the objects in the DDL.

Include tablespace name for index partitions
Select to include tablespace name for index partitions in the DDL.

Include tablespace name for partitions
Select to include tablespace name for partitions for the objects in the DDL.

List individual hash partitions
Select to list individual hash partitions for the objects in the DDL. Otherwise, only partition quantity will be specified.

ExpandedToggleIcon(9x12) Users/Roles

Contains options to control script generation for users.

Include encrypted password
Includes encrypted password into the user DDL (using the IDENTIFIED BY VALUE statement). That allows to generate DDL that creates users exactly with the same password without knowing it. You should not change user name in the script if you use this option.

Include grants
Includes grants for users in the DDL.

Include object grants
Includes any object grants for users in the DDL.

Include user information
Includes CREATE USER statement in the DDL.

ExpandedToggleIcon(9x12) Data

Include column names into INSERT statements
Includes column names into INSERT statement.

Insert Commit after every <x> statements
Inserts the COMMIT statement after each defined number of INSERT statements. You can set this number by clicking button button and entering the number.

Place data just after table definition
Places INSERT statements for the table data after CREATE statement for this table. Otherwise, all INSERT statements will be placed after all DDL statements.

ExpandedToggleIcon(9x12) See Also

Schema Export Wizard

Errors Handling, Schema Export Wizard


Errors Handling, Schema Export Wizard

Specify errors processing behavior and logging options on this page.

ExpandedToggleIcon(9x12) Errors handling

Prompt a user for an action
If an error occurred, the application will show a message with the description of an error, its possible reason and possible actions to take:

Yes
The error is ignored and the process continues.

No
The error is not ignored and the process is aborted.

Retry
The application tries to perform an action that resulted in an error once more.

Ignore All
Ignores this error and all errors that may occur during this backup operation.

Ignore all errors
All errors that may occur during the process are written to the error list, and the process will be finished.

Abort at the first error
If an error occurs, the backup process is aborted.

ExpandedToggleIcon(9x12) Log settings

Write a report to a log file
Check this option to write an export report to a log file.

Log file
Choose the destination folder where the log file will be located.

ExpandedToggleIcon(9x12) See Also

Schema Export Wizard

Export Progress, Schema Export Wizard


Export Progress, Schema Export Wizard

You can see an export progress on this page. To cancel the export, click Cancel.

ExpandedToggleIcon(9x12) See Also

Schema Export Wizard

Finish, Schema Export Wizard


Finish, Schema Export Wizard

You can see results of schema export operation on this page.

If the process was completed successfully, the complete icon indicates this status.

If the process failed, this status is indicated by the failed icon.

In the results of schema export process the number of errors, warnings and objects is stated.

Show log file...
Click this button to open the log file. This button appears only if you selected Write a report to a log file on the Errors Handling, Schema Export Wizard.

Open script
Check this option to open the result file when the wizard is closed.

Save an export project
Check this option to save an export project for future use. After the wizard is closed the Save As dialog window is opened.

ExpandedToggleIcon(9x12) See Also

Schema Export Wizard


Schema Import Wizard

Use Schema Import Wizard to import your schemas or single tables from script. To access Schema Import Wizard, on the Database menu, point to Export & Import. Alternatively, right-click a schema in Database Explorer, point to Export & Import, and then click Schema Import.

To import schema from script you should select appropriate connection and schema script in wizard window and click the Import button. Schema Import Wizard pages are described below.

Schema Script File, Schema Import Wizard
Choose connection and schema script file on this page.

Import Progress, Schema Import Wizard
You can see schema import progress on this page.

Operation Complete, Schema Import Wizard
You can see results of schema import operation on this page.


Schema Script File, Schema Import Wizard

Choose connection and schema script file on this page.

Connection
Choose connection from the connection list.

Schema
Select the Target schema from the list. If the export file was generated with Include SET CURRENT SCHEMA option then in case you set the Schema field to other than <As in script>, the previously set Include SET CURRENT SCHEMA option will be ignored. If the export file was generated with Prefix object names with a schema name option, you will not be able to execute it in another schema.

File name
Type a file name with the path here or use the Browse button to choose a file.

SQL file encoding
The encoding which is applied to open and execute the script with the imported schema. The program automatically selects it based on the imported file, if it fails, the default encoding (the current Windows encoding on the machine where dbForge Studio for Oracle is running) is selected. You can always select a required encoding from the drop-down list.

ExpandedToggleIcon(9x12) See Also

Schema Import Wizard

Import Progress, Schema Import Wizard


Import Progress, Schema Import Wizard

You can see a schema import progress on this page. To cancel import click Cancel button.

ExpandedToggleIcon(9x12) See Also

Schema Import Wizard

Operation Complete, Schema Import Wizard


Operation Complete, Schema Import Wizard

You can see results of schema import operation on this page. If operation failed, choose whether to open a source file after the wizard is closed.

ExpandedToggleIcon(9x12) See Also

Schema Import Wizard


Object and Data Search

This section describes the windows that allow you to process database object search.

ExpandedToggleIcon(9x12) In This Section

dbForge Search Window
This topic describes the elements of the Search window.

Custom AutoFilter Window
This topic describes the elements of the AutoFilter window.

Filter Editor Window
This topic describes the elements of the Filter Editor window..


Search Window

Use the Search window to search for database objects and data.

Window Elements

Search objects by name and DDL
Click to start searching for database objects by name and DDL.

Search table and view data
Click to start searching for table and view data.

Search
Enter a search string in this box.

Find Options
Click to select an additional find option from the drop-down list box. The available options are Match Case, Match Whole Word and Use WildCards. By default, the Use WildCards option is selected.

Group results by object type
Click to group search results by type.

Object types/Objects
Select required object types/objects, in which the search will be performed.

Schemas for search
Select a schema to search in.

Connection for search
Select a connection for the search.

Search Results Grid

Name
Contains found objects.

Schema
Contains schemas with found objects.

Database
Contains databases with found objects.

Object type
Contains types of the found objects.

Found In
Contains either Name or Body values meaning that the object is searched either in object names or object DDL. The column is only available during the Search objects by name and DDL mode.

Matches Count
Contains the number of the search string matches in the table or view. The column is only available during the Search table and view data mode.

Buttons

Start Search
Click to initiate the search.

Stop Search
Click to stop the search.

Find in Object Explorer
Click to find a selected object in the Object Explorer.

Word Wrap
Click to set or clear the Word Wrap option for the object DDL in the Preview window. When the option is enabled, all the text shall fit the current width of the Preview window. The button is only available during the Search objects by name and DDL mode.

Show line numbers
Click to set or clear numbers for lines of the object DDL in the Preview window. The button is only available during the Search objects by name and DDL mode.

Edit Filter
Click to open the Filter Editor window, where you can fine tune filters for the search results.

Collapse Pane
Click to minimize the Preview window.

ExpandedToggleIcon(9x12) See Also

Custom AutoFilter Window

Object and Data Search


Custom AutoFilter Window

This topic describes the options of the Custom AutoFilter window.

Window Elements

Select an operator (1)
Select a first operator for the filter from the drop-down list.

Enter a value (1)
Enter a first value associated with the first operator.

And
Select to add a second operator to the filter.

Or
Select to add an alternative second operator to the filter.

Select an operator (2)
Select a second operator for the filter from the drop-down list.

Enter a value (2)
Enter a second value associated with the second operator.

OK
Click to apply the filter and quit the window.

Cancel
Click to quit the window without applying the filter.

ExpandedToggleIcon(9x12) See Also

Filter Editor Window

Object and Data Search


Filter Editor Window

This topic describes the options of the Filter Editor window. The window displays current filter conditions, which may be fine tuned with help of drop-down context menus and text boxed that appear when you click a parameter of the condition.

Buttons

Add
Click to add a condition

Delete
Click to remove the condition

OK
Click to apply changes and quit the window.

Cancel
Click to quit the window without changes.

Apply
Click to apply the filter conditions.

ExpandedToggleIcon(9x12) See Also

Object and Data Search

Custom AutoFilter Window


Security Manager

Use Security Manager to add, edit or delete user accounts, roles and profiles, grant and revoke roles and privileges. To call Security Manager, select Security Manager from Database menu.

Left part of Security Manager is a tree, containing users, roles and profiles in database. Right part content depends on the tree node.

ExpandedToggleIcon(9x12) In This Section

Security Manager Window
Describes the Security Manager toolbar options.

Users/Roles/Profiles Summary Information
Describes summary information girds for users, roles, and profiles.

User Editor
Allows editing user account information. Appears when user node is selected.

Role Editor
Allows editing roles. Appears when role node is selected.

Profile Editor
Allows editing profiles. Appears when profile node is selected.


Security Manager Window

The topic describes the options available in the Security Manager window.

Connection
Select the needed connection from the drop down list.

RefreshButton Refresh
Refreshes user information.

enough Stop Refresh
Stops the refresh operation.

Save Save
Saves changes made to the user account that is being edited.

Undo Undo
Cancels changes made to the user account that is being edited.

script-changes View Changes
Generates SQL statements that will be executed to apply changes to the user account that is being edited.

Create User/Role/Profile
Creates a new user, role or profile.

Delete
Deletes a user, role or profile.

User/Role/Profile Shortcut Menu

New User/Role/Profile
Opens the editor for a new object.

Duplicate Object
Creates a copy of an object.

Generate Schema Script
Opens the Generate Schema Script Wizard to make DDL statements or scripts of selected object(s).

Generate Script As

CREATE
A script to create the selected object will be generated.
DROP
A script to drop the selected object will be generated.
DROP and CREATE
A script to drop and create the selected object will be generated.

Delete
Deletes a selected object.

Refresh
Refreshes object information.

Properties
Shows the object properties in the Properties window.

ExpandedToggleIcon(9x12) See Also

Security Manager

Users/Roles/Profiles Summary Information


Users/Roles/Profiles Summary Information

When you navigate to a certain object folder, you can view the summary information for objects within it. The summary information differs depending on the object type.

ExpandedToggleIcon(9x12) Summary information for users

To view grid with summary information for users, select Users node in the tree. Users grid has following columns:

Name
Name of the user.

Account Status
Status of user account. Shows whether account is locked, expired, or unlocked.

Default Tablespace
Contains default tablespace of the user.

Temporary Tablespace
Contains temporary tablespace of the user.

Profile
Contains profile assigned to the user.

Password Expired
Shows whether the password is expired.

Account Locked
Shows whether the user account is locked.

Created
Contains the date when the user account was created.

ExpandedToggleIcon(9x12) Summary information for roles

To view grid with summary information for roles, select Roles node in the tree. Roles grid has following columns:

Name
Contains the owner of the role.

Authentication
Shows a way of authentication, required for the role.

ExpandedToggleIcon(9x12) Summary information for profiles

To view grid with summary information for profiles, select Profiles node in the tree. Profiles grid has following columns:

Name
Contains profile name.

Login Attempts
Contains the number of login attempts.

Password Life Time
Number of days after which a password expires.

Password Lock Time
Controls the number of days an account will remain locked as a result of the Failed Login Attempts limit being reached before the account is automatically unlocked.

Connect Time
Maximum elapsed time allowed for a session in minutes.

Idle Time
Maximum period of inactive time allowed in a session in minutes.

Sessions Per User
Maximum number of concurrent sessions allowed for a user.

ExpandedToggleIcon(9x12) See Also

Security Manager

User Editor, Security Manager


User

Use User Editor to edit user account, to grant and revoke privileges and roles to or from it. User Editor has the following tabs:

ExpandedToggleIcon(9x12) In This Section

General, User Editor, Security Manager
Set general user account parameters on this tab.

Role, User, Security Manager
Grant roles to user account on this tab.

System, User, Security Manager
Grant system privileges to user account on this tab.

Object, User, Security Manager
Grant object privileges to user account on this tab.

Quota, User, Security Manager
Grant tablespace quotas to user account on this tab.


General, User Editor, Security Manager

Use this tab to input user name and password, to select authentication method, default and temporary tablespaces, user profile, to lock and unlock user account.

Name
User name.

Authentication
Indicates how Oracle authenticates the user.

External Name
X.509 name at the enterprise directory service that identifies this user. Available only for Global authentication method.

Password
Input account password here. Available only for Database authentication method.

Confirm Password
Input account password here to be sure it is correct. Available only for Database authentication method.

Default Tablespace
Select default tablespace for objects that the user creates here.

Temporary Tablespace
Select the tablespace for the user's temporary segments here.

Profile
Select resource profile for user here.

Password Expired
Indicates whether the password is expired.

Account Locked
Indicates whether account is locked.

ExpandedToggleIcon(9x12) See Also

User

Role, User, Security Manager


Role, User, Security Manager

Use this tab to grant roles to user account.

Grid with available roles contains the following columns.

Name
Role name.

Granted
Check to grant the role to user.

Admin option
Check to grant role with admin option. It means that user can grant and revoke this role to or from any user or other role with or without admin option. The user can also alter or drop the role.

Default
Check to grant role as default role to user. Default option means that this role will be enabled after user connects to Oracle server.

ExpandedToggleIcon(9x12) See Also

User

System, User, Security Manager


System, User, Security Manager

Use this tab to grant system privileges to user account.

Grid with available privileges contains the following columns.

Name
Privilege name.

Granted
Check to grant the privilege to user.

Admin option
Check to grant privilege with admin option. It means that user can grant and revoke this privilege to or from any user or role with or without admin option.

ExpandedToggleIcon(9x12) See Also

User

Object, User, Security Manager


Object, User, Security Manager

Use this tab to grant object privileges to user.

Show All
Show all schemas' objects of the current server.

Objects
Tree that contains database objects.

Available Privileges
List of available privileges for the selected database object.

Granted Privileges Grid
Grid, where the privileges granted to the selected user are listed.

ExpandedToggleIcon(9x12) See Also

User

Quota, User, Security Manager


Quota, User, Security Manager

Use this tab to set tablespace quotas for user.

Tablespaces grid
Shows quotas for tablespaces. Select tablespace here to set quota for it.

Name
Tablespace name to set quota for.

Quota
Select quota type here.

Value
Set value of tablespace quota here if selected quota type is Value.

Unit
Select measurement units here if selected quota type is Value.

ExpandedToggleIcon(9x12) See Also

User

Security Manager


Role

Use Role Editor to edit roles and grant privileges and another roles to them. Role Editor consists of following tabs.

ExpandedToggleIcon(9x12) In This Section

General, Role, Security Manager
Set general role parameters on this tab.

Role, Role, Security Manager
Grant other roles to the selected role on this tab.

System, Role, Security Manager
Grant system privileges to role on this tab.

Object, Role, Security Manager
Grant object privileges to role on this tab.


General, Role, Security Manager

Use this tab to input role name and password and select authentication method.

Name
Role name.

Authentication
Indicates how Oracle authenticates the role.

Password
Input role password here. Available only for Database authentication method.

Confirm Password
Input role password here to be sure it is correct. Available only for Database authentication method.

ExpandedToggleIcon(9x12) See Also

Role

Role, Role, Security Manager


Role, Role, Security Manager

Use this tab to grant roles to the current role.

Grid with available roles contains the following columns.

Name
Role name.

Granted
Check to grant role to the current role.

Admin option
Check to grant role with admin option. It means that user can grant and revoke this role to or from any user or other role with or without admin option. The user can also alter or drop the role.

ExpandedToggleIcon(9x12) See Also

Role

System, Role, Security Manager


System, Role, Security Manager

Use this tab to grant system privileges to the role.

Grid with available privileges contains the following columns.

Name
Privilege name.

Granted
Check to grant the privilege to role.

Admin option
Check to grant privilege with admin option. It means that user can grant and revoke this privilege to or from any user or role with or without admin option.

ExpandedToggleIcon(9x12) See Also

Role

Object, Role, Security Manager


Object, Role, Security Manager

Use this tab to grant object privileges to role.

Show All
Show all schemas' objects of the current server.

Objects
Tree that contains database objects.

Available Privileges
List of available privileges for the selected database object.

Granted Privileges Grid
Grid, where the privileges granted to the selected role are listed.

ExpandedToggleIcon(9x12) See Also

Role

Security Manager


Profile

Use Profile Editor to edit profiles. Profile editor consists of following tabs.

ExpandedToggleIcon(9x12) In This Section

General, Profile Editor, User Manager
Set general resource limits on this tab.

Password Limits, Profile Editor, Security Manager
Set password limits on this tab.


General, Profile, User Manager

Use this tab to edit general profile properties.

Name
Profile name.

CPU/Session
Total amount of CPU time allowed in a session.

CPU/Call
Maximum amount of CPU time allowed for a call.

Connect Time
Maximum elapsed time allowed for a session.

Idle Time
Maximum period of inactive time allowed in a session.

Sessions/User
Maximum number of concurrent sessions allowed for a user.

Reads/Session
Total number of data block reads allowed in a session.

Reads/Call
Maximum number of data block reads allowed for a call.

Private SGA
Maximum amount of private space a session can allocate in the shared pool of the System Global Area (SGA).

Composite Limit
Total resource cost for a session (weighted sum of the CPU time used in the session, the connect time, the number of reads made in the session, and the amount of private SGA space allocated).

ExpandedToggleIcon(9x12) See Also

Profile

Password, Profile, Security Manager


Password, Profile, Security Manager

Use this tab to set password limits for the profile.

Life Time (Days)
Limits time after which a password expires.

Grace Time (Days)
Limits time during which a password can be changed following the first successful login after password expiration.

Reuse Max
Specifies the number of times a password must be changed before it can be reused.

Reuse Time (Days)
Specifies the number of days before a password can be reused after it expires.

Verify Function
Specifies PL/SQL routine that is used for password verification for users who are assigned this profile. It must be locally available for execution on the database to which this profile applies.

Failed Login Attempts
Limits the number of failed login attempts allowed before a user is locked out from the account.

Lock Time (Days)
Specifies time the account is locked after failing the specified number of login attempts.

ExpandedToggleIcon(9x12) See Also

Profile

Security Manager


Service Windows

This section describes user interface elements of service windows and dialogs.

ExpandedToggleIcon(9x12) In This Section

New File Dialog Box
The topic describes the New File dialog box.

Error List
The topic describes the Error List that helps you speed application development.

Output Window
The topic describes the Output window that displays status messages for various features.

Properties Window
The topic describes the Properties window.

Edit Value Dialog Box
The topic describes the Edit Value dialog box.

Save of Read-Only File Dialog Box
The topic describes the Save Prompt dialog box.

Save Prompt Dialog Box
The topic describes the Save of Read-Only File dialog box.

Windows Dialog Box
This topic describes the dialog box that allows you to display, close, and arrange documents that are open in editors and designers.

Product Update Manager
This topic describes the dialog box that allows you to see the update information of dbForge Studio for Oracle.

Document Outline Window
Use the topic to navigate through an opened SQL document outline.


New File Dialog Box

Use this dialog box to add an item to the currently selected project. When you select an item from the Categories list, the appropriate files and references are added to your project.

To access this dialog box, choose New on the File menu, and then click File.

Categories
Lists the project item hierarchy.

Large Icons
Displays large icons for items in the templates pane.

Small Icons
Displays small icons for items in the templates pane.

Name
Enter the name of the file you want to create.

Create
Use this button to add the item to the current project.

Cancel
Click this button to close the New File dialog box.

Help
Click this button to invoke help.

ExpandedToggleIcon(9x12) See Also

Service Windows

Error List


Error List

The Error List contains errors, warnings, and messages with their location. To display the Error List, click the Error List button in the View menu. You can double-click error messages to locate errors quickly in multiple files.

The Error List window allows you to:

· Display the Errors, Warnings, and Messages produced as you edit and compile code.
· Find syntax errors
· Double-click any error message entry to open the file where the problem occurs, and move to the error location.
· Filter which entries are displayed, and which columns of information appear for each entry.

ExpandedToggleIcon(9x12) Error List Columns

Icon
Displays error or warning icon for the message.

Description
Display text of error or warning.

Location
Contains name of the document where the error occurred.

Line
Displays the line in the document, where the problem occurs.

Column
Shows the column on the indicated line where the problem begins.

ExpandedToggleIcon(9x12) Error List Shortcut Menu Commands

Goto Error
Opens the document on the place, where the error have occurred.

Copy
Copies the message to the clipboard.

Word Wrap
Enables or disables word wrap in the Description column of Error List.

Clear All
Clears Error List.

ExpandedToggleIcon(9x12) Error List Toolbar

Use the Errors, Warnings, and Messages buttons to select which entries to display.

Errors
Indicates the number of errors in the list. Click to toggle whether errors are displayed.

Warnings
Indicates the number of warnings in the list. Click to toggle whether warnings are displayed.

Messages
Indicates the number of messages in the list. Click to toggle whether messages are displayed.

In Active Document
Allows to review the errors, warnings, and messages either in the current document or in other opened documents.

ExpandedToggleIcon(9x12) See Also

Service Windows

Output Window


Output Window

This window can display status messages for various features. To display the Output window, select Output from the View menu.

Output messages can be divided into several categories. To view messages of the certain category click on its name on the Output window toolbar. If there is no such a name on the toolbar, right-click on the toolbar and select a required name from the shortcut menu.

General
Displays message statuses on general operations.

SQL Log
Displays all SQL queries executed by the application during the current session.

database-tab-output DBMS Output
Displays the DBMS_OUTPUT package messages. The messages are displayed if the Enable DBMS output option is selected in Advanced, Database Connection Properties Dialog Box.

Debug
Displays output messages on debugging.

ExpandedToggleIcon(9x12) See Also

Service Windows

Properties Window


Properties Window

Properties window reflects properties of currently selected item in Database Explorer or Table Editor. Its content changes while you navigate through Database Explorer, switch between Table Editor views, alter objects.

To open it, click Properties on the View menu or press F4.

All properties in the grid are read-only. To modify a property of a database object, double-click it in Database Explorer. The changes are applied and rendered in the Properties window once you save the modified document.

ExpandedToggleIcon(9x12) See Also

Service Windows

Edit Value Dialog Box


Edit Value Dialog Box

Use this dialog box to enter the option value. This dialog can be opened by clicking the button button for corresponding option.

ExpandedToggleIcon(9x12) See Also

Service Windows

Save of Read-Only File Dialog Box


Save of Read-Only File Dialog Box

When an attempt is made to save a read-only file, Save of Read-Only File dialog box appears. It contains following buttons.

Save As
Click to save the file to a different location.

Overwrite
Click to remove file's read-only attribute and replace original file with the changed one.

Cancel
Click to cancel save operation.

ExpandedToggleIcon(9x12) See Also

Service Windows

Save Prompt Dialog Box


Save Prompt Dialog Box

When an attempt is made to close a document or project that is modified and not saved, Save Prompt dialog box appears. It comprises of list, containing modified project and documents, and buttons you can use to proceed. Documents are grouped by project and miscellaneous files.

Yes
Click Yes button to save selected documents and project. If a document is not implicitly named, a Save dialog will appear where you can give a name to the document.

No
Click No to discard all changes made to the documents you are closing.

Cancel
Click Cancel button to return to IDE without closing any of the documents.

ExpandedToggleIcon(9x12) See Also

Service Windows

Windows Dialog Box


Windows Dialog Box

Use this dialog box to activate, save, and close documents. To access this dialog box, in the Window menu, click Windows. Note that you must have at least one document open for this option to be available.

The Windows dialog box allows you to manipulate several documents at single click. The dialog is not closed when you apply any actions, so it is extremely useful when you have many documents currently open.

Windows list
All documents currently open are enumerated in the list. Click on a document's line to select or deselect it. Use Ctrl and Shift keys to perform group operations.

Activate
Click this button to view the selected document without closing the dialog. Available only when single document is selected in the list.

Save
Save selected documents.

Close Window(s)
Close selected documents. If some are not saved, a dialog appears where you can save them if you need.

Close
Close the current dialog.

ExpandedToggleIcon(9x12) See Also

Service Windows

Product Update Manager


Product Update Manager

Use this dialog to see the update information of dbForge Studio for Oracle.

To open the Product Update Manager dialog window, click the Check for Updates button in the Help menu.

To make dbForge Studio check for updates automatically:

1. In the Tools menu, click Options.
2. Expand the Environment folder in the Options window.
3. Check the Check updates on startup once a week check box.

The Product Update Manager window contains the following details:

Product information
This section shows the product's name, version, and file size.

Refresh
Click it to update the product information.

View revision history
Click it to view the history file of dbForge Studio for Oracle.

Devart authentication
Contains the Login, and the Password text boxes. Allows registered users to pre-save the login credentials.

Save downloaded installation
Check it if you want to save an installation file. Then you should specify the file location in the File name field.

File name
Enter the location of the installation file or click the Browse button to select it in the Browse for Folder dialog.

Browse
Click it to select the installation file location in the Browse for Folder dialog.

Just download a file (do not start installation)
Select it to download the installation file without starting it.

Update
Click it to start downloading the installation file.

Cancel
Click it to close the dialog. Note, this won't stop installation download. To stop downloading, close dbForge Studio for Oracle.

ExpandedToggleIcon(9x12) See Also

Service Windows

Reference


Document Outline Window

The Document Outline window shows a logical structure of an opened SQL document. To open the window, select Document Outline from the View menu.

You can use the Document Outline window to view and navigate through the following items:

· statements in SQL documents.
· queries in Query Builder.
· table shapes and their connections on a database diagram.
· elements of data reports.

ExpandedToggleIcon(9x12) See Also

Service Windows


Shortcut Keys

Several pre-defined keyboard shortcut collections are included in dbForge Studio. All shortcuts can be customized.

ExpandedToggleIcon(9x12) Global Shortcut Keys

The following shortcut key combinations can be used in any dbForge Studio document or tool window.

Icon | Command Name | Shortcut Keys | Description | Where is used
 | Database Explorer | CTRL+W, L | Reveal Database Explorer window | Global
 | Data Window | CTRL+W, D | Reveal Data window | Global
 | Properties Window | CTRL+W, P | Reveal Properties window | Global
 | Project Explorer | CTRL+W, S | Reveal Project Explorer window | Global
 | Output | CTRL+W, O | Reveal the Output window | Global
 | Error List | CTRL+W, E | Reveal Error List window | Global
 | Document Outline | CTRL+W, U | Reveal Document Outline window | Global
 | Schema View | CTRL+W, C | Reveal Schema View window | Global
 | Code Templates | CTRL+W, T | Reveal Code Templates window | Global
 | Data Viewer and Editor | CTRL+W, R | Reveal Data Viewer window | Global
 | Generate DDL | CTRL+D, D | Call Generate DDL wizard | Global
 | Find Object | CTRL+D, F | Reveal Find Object window | Global
 | Session Manager | CTRL+D, S | Reveal Session Manager window | Global
security-manager | Security Manager | CTRL+D, Q | Reveal Security Manager window | Global
 | Web Browser | CTRL+W, W | Reveal Web Browser | Global
 | New Connection | CTRL+D, N | Show Database Connection Properties dialog box for a new connection | Global
 | Diagram Overview | CTRL+W, V | Reveal Diagram Overview window | Global

ExpandedToggleIcon(9x12) Document Management Shortcut Keys

These are default shortcuts. All shortcuts can be customized.

Icon | Command Name | Shortcut Keys | Action | Where is used
 |  | CTRL+TAB | Switch to last used document | Global
 |  | CTRL+SHIFT+TAB | Cycle through all open documents | Global
 |  | F7 | Cycle through document views | Global
 |  | SHIFT+F7 | Cycle through document views backwards | Global
Save | Save | CTRL+S | Save current document | Global
SaveAll | Save All | CTRL+SHIFT+S | Save all documents | Global
 | Open | CTRL+O | Open document | Global
 | Close Document | CTRL+F4 | Close current document | Global
 | SQL | CTRL+N | New SQL document | Global
Pin | Pin Document/ Unpin Document | CTRL+ALT+P | Pin/unpin document | SQL document or database object editor
Print | Print | CTRL+P | Print | Text or data view of a document Data window

ExpandedToggleIcon(9x12) Project Management Shortcut Keys

These are default shortcuts. All shortcuts can be customized.

Icon | Command Name | Shortcut Keys | Action | Where is used
NewProject | Project | CTRL+SHIFT+N | Create a new project | Global
OpenProject | Open Project | CTRL+SHIFT+O | Open a project | Global
 |  | F2 | Rename a project (refactoring) | Global

ExpandedToggleIcon(9x12) See Also

Reference

SQL Document


SQL Document

This section describes SQL Document user interface elements.

ExpandedToggleIcon(9x12) In This Section

SQL Editor
This topic holds information on what is SQL Editor and how to open it.

Edit Parameters Dialog Box
This topic describes content of dialog box where you can edit query parameters.

SQL History Dialog Box
This topic describes what elements are available in the SQL history dialog box.


SQL Editor

The SQL editor is a word processing utility where you enter and edit SQL statements. The statements are colorized so you can easily read them.

You can open multiple SQL editors to view SQL code and copy and paste among them. A list of all open SQL editors is available in the Windows menu.

Every dbForge Studio document has Text View that is shown in SQL editor. You can use autocompletion and SQL History to speed up your work.

You can launch SQL editor in several ways. For example:

1. On the File menu, select New, then click NewSQL New SQL.
2. Click NewSQL New SQL on the Standard toolbar.
3. Switch to the Text View in the Query Builder.

You can always save a SQL document for future use.

Names of SQL Documents

When you open SQL documents, dbForge Studio for Oracle automatically assigns them default names: SQL, SQL1, SQL2, etc. To distinguish between various SQL documents, hover over an SQL document tab to see a hint specifying the name of the SQL document. The name corresponds to the connection name specified during connection to a database.

SQL Editor Interface Elements

Code Pane
An area where SQL code is displayed and edited.

Margin Indicator Bar
A grey area at the left of the editor. Margin indicators, such as breakpoints, bookmarks, current location of the execution point and others, are displayed there. You can show or hide it by setting the corresponding option on the General tab of the Text Editor Options dialog box.

Selection Margin
White area between the margin bar and code. Click here to select the line.

Horizontal and Vertical Scroll Bars
Allows scrolling the code.

Navigation Bar
A bar with two boxes at the top of the editor. Allows navigating through DDL statements. Select database objects in the left box and subobjects of the selected object in the left box to navigate through DDL statements.

If you are editing a database object in SQL tab, the following additional controls are available:

RefreshButton Refresh Object
Updates current view in case an object was updated in a database by someone else.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
new-sql-window to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

SQL Document

Edit Parameters Dialog Box


Edit Parameters Dialog Box

This window allows you to add, delete, or modify existing parameters in the query. Click edit-parameters Edit Parameters button on the SQL toolbar to invoke this window.

Name
Displays the list of parameters that are currently used. Click on a parameter to select it and fill the fields to the right of the list with values that correspond to the selected parameter. Click it again to rename the parameter.

The following fields are specific for every parameter. Their content depends on what parameter is currently selected.

Type
Lets you choose the data type of the parameter.

Direction
Indicates whether the parameter is input, output, or bidirectional.

Null value
Specifies whether the value of this parameter is NULL. Checking this option clears the Value field.

Size
Maximum size (in bytes) of the data within the column.

Value
Value of the parameter. Note that character or date and time values should not be quoted. If you want to set value sample text you should just enter sample text without quotes.

ExpandedToggleIcon(9x12) See Also

SQL Document

SQL History Dialog Box


SQL History Dialog Box

SQL statement history is designed to ease recalling and re-executing statements you have previously executed. Choose View SQL history from the SQL menu to bring up a dialog where you can choose which SQL statement must be inserted into the editor instead of the current one.

In SQL history dialog box every grid row represents a query. An icon to the left of the text shows, was the execution successful or not. If a query is too long too be seen, point to it with mouse to make a hint containing query text appear.

ExpandedToggleIcon(9x12) SQL History Dialog Box Buttons

Replace
Select the query you want to recall and click this button. Another way to reload it is to double-click it.

Append
Appends selected query to the document.

Close
Click on this button to close the dialog without making any changes to query text.

ExpandedToggleIcon(9x12) SQL History Grid Shortcut Menu

Edit
Replaces the document content with the selected item from the history.

Copy
Copies the selected item from the history to the clipboard.

Delete
Removes the selected item from the history.

Clear History
Removes all items from the SQL history.

ExpandedToggleIcon(9x12) SQL History Grid

Execution status
Displays execution status of the statement. The sqlhistory-success icon identifies successful statement execution, the sqlhistory-failed icon identifies that execution failed.

SQL Statement Text
Contains the text of the SQL statement that was executed.

Timestamp
Holds date and time when the statement was executed.

Execution times
Specifies how many times the statement was executed.

ExpandedToggleIcon(9x12) See Also

SQL History

SQL Document


SQL Formatter Wizard

Use SQL Formatting wizard to format SQL code in multiple files or folders. To access SQL Formatter wizard, on the Tools menu, click SQL Formatter. Wizard pages are listed below.

ExpandedToggleIcon(9x12) In This Section

Formatting Mode, SQL Formatter Wizard
Select formatting mode on this page.

File List, SQL Formatter Wizard
Specify files to format on this page.

Folder List, SQL Formatter Wizard
Specify folders to format files in on this page.

Formatting Progress, SQL Formatter Wizard
You can see formatting progress on this page.


Formatting Mode, SQL Formatter Wizard

Select formatting mode on this page.

Files
Select to format the specified files.

Directories
Select to format the specified directories.

ExpandedToggleIcon(9x12) See Also

SQL Formatter Wizard

File List, SQL Formatter Wizard


File List, SQL Formatter Wizard

Specify files to format on this page. This page is available if you have selected Files on the previous page.

Selected folders
Files to format.

Add
Click to add files to format.

Remove
Click to remove the selected files from the Selected files list.

Keep modified files open after format
Select to open modified files before formatting. If selected, you may undo formatting changes in the opened documents.

ExpandedToggleIcon(9x12) See Also

Formatting Mode, SQL Formatter Wizard

Folder List, SQL Formatter Wizard


Folder List, SQL Formatter Wizard

Specify folders to format files in on this page. This page is available if you have selected folders on the previous page.

Selected folders
Folders to format SQL files in.

Add
Click to add folders to format files in.

Remove
Click to remove the selected folders from the Selected folders list.

Look at these file types
Specify the type of files for formatting to look for in the folder.

Keep modified files open after format
Select to open modified files before formatting. If selected, you may undo formatting changes in the opened documents.

Include sub-folders
Select to format files in sub-folders of the specified folders.

ExpandedToggleIcon(9x12) See Also

File List, SQL Formatter Wizard

Formatting Progress, SQL Formatter Wizard


Formatting Progress, SQL Formatter Wizard

You can see a formatting progress on this page. To cancel formatting, click the Cancel button.

ExpandedToggleIcon(9x12) See Also

Folder List, SQL Formatter Wizard


Create Snapshot Dialog Box

Use this dialog box to generate a snapshot file of your schema structure.

Source

Type
Displays the source type, for which a snapshot is created.

Connection
Select an Oracle connection you want to connect to. Click <Manage...> to open the Connection Manager dialog box. It will help you create, edit, and delete database connections.

Edit
Click to edit the selected connection. The Database Connection Properties dialog box opens.

New
Click to create a new Oracle connection. The Database Connection Properties dialog box opens.

Server Version
Displays the server version.

Schema
Specify the required schema. Click <Refresh...> to refresh the list of available schemas, if any changes were made.

Destination

Type
Displays the object type (snapshot) that is created.

Path
Click the [...] button, select the folder to save the snapshot to and specify the name of the snapshot file.

Compress
Select this check box if you want dbForge Studio for Oracle to archive the snapshot file. This option is useful when you save large snapshots.

Create
Click to finish the snapshot file creation.

Cancel
Click to abort the snapshot file creation.

ExpandedToggleIcon(9x12) See Also

Reference


Include Columns in Query

To use a column in a query, you must add it to the query. You may add a column to display it in query output, to use it for sorting, to search the contents of the column, or to summarize its contents.

To add an individual column

· In the Diagram Pane, select the check box next to the column that you want to include.

Alternatively

· In the Tabbed Editor, move to the first blank grid row, click the field in the Column column, and select a table and a column name from the drop-down list.

To add all columns for one table or table-valued object

· In the Diagram Pane, select the check box next to *(All Columns).

To add all columns for all tables and table-structured objects

1. In the Design Pane, select all tables.
2. Make sure no join lines in the Design Pane are selected.
3. Right-click any table and select Select all columns from the shortcut menu.

ExpandedToggleIcon(9x12) See Also

Building Queries with Query Builder

How To: Make Joins Between Tables


Join Tables Automatically

When you add two or more tables to a query, the Query Builder attempts to determine whether they are related. If they are, the Query Builder automatically adds join lines between the rectangles representing the tables or table-structured objects.

The Query Builder recognizes tables as joined in the following cases:

1. The database contains information that specifies that the tables are related.
2. If two columns, one in each table, have the same name and data type. The column must be a primary key in at least one of the tables. For example, if you add person and password tables, if the password_id column is the primary key in the password table, and if each table has a column called password_id with the same data type, the Query Builder will automatically join the tables.
3. The Query Builder detects that a search condition (e.g. the WHERE clause) is actually a join condition. For example, you might add the tables person and password, then create a search condition that searches for the same value in the password_id column of both tables. When you do, the Query Builder detects that the search condition results in a join, and then creates a join condition based on the search condition.

If the Query Builder has created a join that is not suitable to your query, you can modify the join or remove it. If the tool does not automatically join the tables in your query, you can create a join yourself.

note Note

The Query Builder will create only one join based on columns with the same name and data type. If more than one join is possible, the Query Builder stops after creating a join based on the first set of matching columns that it finds.

ExpandedToggleIcon(9x12) See Also

Query with Joins

Join Tables Automatically

© 2004-2016 Devart


Join Tables Manually

When you add two (or more) tables to a query, the Query Builder attempts to join them based on common data or on information stored in the database about how tables are related. However, if the Query Builder has not joined the tables automatically, or if you want to create additional join conditions between tables, you can join tables manually.

You can create joins based on comparisons between any two columns, not just columns that contain the same information.

note Note

Joins work fastest if the columns in the join condition have been indexed. In some cases, joining on unindexed columns can result in a slow query. it finds.

To manually join tables or table-structured objects:

1. Add to the Design Pane the objects you want to join.
2. Drag the name of the join column in the first table or table-structured object and drop it onto the related column in the second table or table-structured object. You cannot base a join on text, ntext, or image columns.

note Note

The join columns must be of the same (or compatible) data types. For example, if the join column in the first table is a date, you must relate it to a date column in the second table. On the other hand, if the first join column is an integer, the related join column must also be of an integer data type, but it can be a different size. The Query and View Designer will not check the data types of the columns you use to create a join, but when you execute the query, the database will display an error if the data types are not compatible.


JSON Import

This topic describes how to import data from an JSON file.

note Note

Data Import Wizard pages can slightly differ due to the product you have been using.

1. Decide what table to import the data to:

For a new table:

· On the Database menu, click Import Data. The Data Import wizard opens.

For an existing table:

· Right-click a table in Database Explorer and select Import Data from the shortcut menu. The Data Import wizard opens with predefined parameters: a Oracle connection, a database, and a table to import the data to.
· Alternatively, on the Database menu click Import Data, and select a required table on the Destination table wizard page.
2. Select JSON import format and specify a location of Source data. Click Next.
3. Specify a Oracle connection, a database, a schema and a table to import the data to. If you selected a table in Database Explorer before opening the Data Import wizard, the wizard will open with the predefined connection parameters of the selected table. To create or edit Oracleconnections, click the corresponding buttons. Click Next.
4. Preview the Source data and specify additional options to customize the import:
· Check that the Source encoding is set correctly.

Click Next.

json-import

5. Specify data formats for the Source data and click Next.
6. Map the Source columns to the Target ones. If you are importing the data into a new table, dbForge Studio will automatically create and map all the columns. If you are importing into an existing table, only columns with the same names will be mapped, the rest should be mapped manually. (If no columns with the same name are found, they are mapped in succession - the 1st column in Source with the 1st column in Target, etc.)

See the Target columns in the top and the Source columns at the bottom of the wizard page. Click Source column fields and select required columns from the drop-down list.

note Note

To cancel mapping of all the columns, click Clear Mappings on the toolbar. To restore it, click Fill Mapping.
7. If you are importing to a new table, you can edit the Target column properties by double-clicking them in the top grid. Select the Key check box for a column with a primary key and click Next. Note you should select at least one column with a primary key, otherwise some of import modes on the Modes wizard page will be disabled.
8. Select an import mode to define how dbForge Studio should import the data. Click Next.
9. Select output options to manager the data import script. Click Next.
10. Select how dbForge Studio should handle errors during import and whether you want to get a log file with details about the import session.
11. Click Import and see the import progress. dbForge Studio will notify you whether the import completed successfully or failed. Click the Show log file button to open the log file.
12. Click Finish to finish the import and close the wizard.

note Note

You can save the import settings as a template for future uses. Click the Save Template button on any wizard page to save the selected settings. Next time you should only select a template and specify a location of the Source data - all the settings will be already set. For more information, go to Saving and Using Templates topic.

ExpandedToggleIcon(9x12) See Also

Data Import

XML Import


Options, Materialized View Editor

Use this tab to set materialized view creation and refresh options.

Refresh method

Select a refresh method for a materialized view here.

Force
If possible, Oracle will use the fast method. Otherwise, it will use a complete method.

Complete
A view will be refreshed by executing the defining query of the materialized view.

Fast
A view will be refreshed incrementally (according to changes that occurred to the master tables).

Never
A view will not be refreshed with any Oracle refresh mechanism or packaged procedure. Refresh options are not available with this method.

Refresh options

Refresh mode
Select the refresh mode for a materialized view here.

On Demand
A materialized view will be refreshed on demand by calling DBMS_MVIEW refresh procedures. It will also be refreshed at start time and next time if they are specified.

On Commit
A materialized view will be refreshed each time whenever the database commits a transaction that operates on a master table of the materialized view. Oracle does not support the On Commit refresh mode for materialized views containing object types.

Refresh type
Select a refresh type for a materialized view here.

Start refresh time
Select a date and time for the first automatic refresh time.

Next refresh time
Enter a datetime expression for calculating an interval between automatic refreshes.

Master rollback segment
Optionally enter a remote rollback segment here to be used at the remote master site for the individual materialized view.

Local rollback segment
Optionally select a local rollback segment for a materialized view here.

Build mode

Select a materialized view build mode here.

Immediate
A materialized view will be populated immediately.

Deferred
A materialized view will be populated by the next refresh operation.

Prebuilt
A materialized view will be based on the existing table. The view must have the same name and the same owner that the table has.

Other creation options

Enable query rewrite
Allows a materialized view to be used for query rewrite.

Enable update
Allows a materialized view to be updated.

Use index
Means that an index that will be used for materialized view fast refresh optimization will be created. Selected by default.

Reduced precision
This option can be used for prebuilt materialized views to authorize the loss of precision that will result if the precision of the table or materialized view columns do not exactly match the precision returned by subquery. Otherwise, if the precision of the table or materialized view columns do not exactly match the precision returned by subquery, materialized view creation will fail.

RefreshButton Refresh Object
Click to refresh the edited object from the database.

update-database Update Database
Saves changes to the database. Clicking this button equal to clicking the Save button.

script-changes Script Changes
new-sql-window to New SQL Window
Show script changes in the new SQL document.
to-clipboard to Clipboard
Copies SQL code to the clipboard. You can insert it anywhere you need.

ExpandedToggleIcon(9x12) See Also

Materialized Views


Query with Joins

A query result can include data from multiple tables or table-valued objects. To combine data from multiple table-valued objects, you use the JOIN operation from SQL.

ExpandedToggleIcon(9x12) In This Section

Join Tables Automatically
Describes automatic table join.

Join Tables Manually
Describes how to join tables manually.


Remove Tables from Query

You can remove a table or any table-valued object from the query.

To remove a table or table-structured object

· In the Diagram Pane, select a table, view, user-defined function, synonym, or query, and then press DELETE, or right-click the object and then click Remove from the diagram. You can select and remove multiple objects at one time.

Alternatively

· Remove all references to the object in the SQL editor.

When you remove a table or table-valued object, the Query Builder automatically removes joins that involve that table or table-valued object and removes references to the object's columns in the SQL editor and.

note Note

Removing a table or table-valued object does not delete anything from the database, it only removes it from the current query.

ExpandedToggleIcon(9x12) See Also

Building Queries with Query Builder

How To: Include Columns in Query


Welcome to dbForge Studio for Oracle

oracle-doc-header

Thank you for choosing dbForge Studio for Oracle!

ExpandedToggleIcon(9x12) dbForge Studio for Oracle Overview

dbForge Studio is a powerful and comprehensive Oracle GUI tool that provides a complete set of instruments for server management and administration. It offers tools for database development, administration tools, and SQL query tools. Combination of the very best features of existing Oracle front ends and Oracle GUI tools makes dbForge Studio the perfect choice for a database developer and administrator as well as for a novice user.

ExpandedToggleIcon(9x12) Where to Start

To start using dbForge Studio for Oracle, see Getting Started section. The guide helps you get started quickly by describing how to setup a new database connection, and provides an explanation of the key steps for basic database operations.

ExpandedToggleIcon(9x12) See Also

Getting Started